/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/platform","vs/base/common/network","vs/base/node/pfs","vs/base/common/errors","vs/base/common/types","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/strings","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","os","child_process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetryUtils","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/telemetry/common/telemetryService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],te=function(_){for(var t=[],T=0,P=_.length;T<P;T++)t[T]=ee[_[T]];return t};define(ee[57],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function T(P,S){if(!P)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=T}),define(ee[45],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function T(D){return(R,l,g)=>{let m=null,b=null;if(typeof g.value=="function"?(m="value",b=g.value):typeof g.get=="function"&&(m="get",b=g.get),!b)throw new Error("not supported");g[m]=D(b,l)}}t.createDecorator=T;function P(D,R,l){let g=null,m=null;if(typeof l.value=="function"?(g="value",m=l.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(g="get",m=l.get),!m)throw new Error("not supported");const b=`$memoize$${R}`;l[g]=function(...d){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,d)}),this[b]}}t.memoize=P;function S(D,R,l){return T((g,m)=>{const b=`$debounce$${m}`,d=`$debounce$result$${m}`;return function(...y){this[d]||(this[d]=l?l():void 0),clearTimeout(this[b]),R&&(this[d]=R(this[d],...y),y=[this[d]]),this[b]=setTimeout(()=>{g.apply(this,y),this[d]=l?l():void 0},D)}})}t.debounce=S;function C(D,R,l){return T((g,m)=>{const b=`$throttle$timer$${m}`,d=`$throttle$result$${m}`,y=`$throttle$lastRun$${m}`,c=`$throttle$pending$${m}`;return function(...u){if(this[d]||(this[d]=l?l():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),R&&(this[d]=R(this[d],...u)),this[c])return;const v=this[y]+D;v<=Date.now()?(this[y]=Date.now(),g.apply(this,[this[d]]),this[d]=l?l():void 0):(this[c]=!0,this[b]=setTimeout(()=>{this[c]=!1,this[y]=Date.now(),g.apply(this,[this[d]]),this[d]=l?l():void 0},v-Date.now()))}})}t.throttle=C}),define(ee[58],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var T;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(T=t.ScanError||(t.ScanError={}));var P;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(P=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var C;(function(e){e.DEFAULT={allowTrailingComma:!0}})(C=t.ParseOptions||(t.ParseOptions={}));function D(e,n=!1){let i=0,r=e.length,a="",E=0,I=16,F=0;function w(Z){let K=0,J=0;for(;K<Z;){const Y=e.charCodeAt(i);if(Y>=48&&Y<=57)J=J*16+Y-48;else if(Y>=65&&Y<=70)J=J*16+Y-65+10;else if(Y>=97&&Y<=102)J=J*16+Y-97+10;else break;i++,K++}return K<Z&&(J=-1),J}function L(Z){i=Z,a="",E=0,I=16,F=0}function M(){const Z=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&g(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&g(e.charCodeAt(i)))for(i++;i<e.length&&g(e.charCodeAt(i));)i++;else return F=3,e.substring(Z,i);let K=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&g(e.charCodeAt(i))){for(i++;i<e.length&&g(e.charCodeAt(i));)i++;K=i}else F=3;return e.substring(Z,K)}function $(){let Z="",K=i;for(;;){if(i>=r){Z+=e.substring(K,i),F=2;break}const J=e.charCodeAt(i);if(J===34){Z+=e.substring(K,i),i++;break}if(J===92){if(Z+=e.substring(K,i),i++,i>=r){F=2;break}switch(e.charCodeAt(i++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const se=w(4);se>=0?Z+=String.fromCharCode(se):F=4;break;default:F=5}K=i;continue}if(J>=0&&J<=31)if(l(J)){Z+=e.substring(K,i),F=2;break}else F=6;i++}return Z}function Q(){if(a="",F=0,E=i,i>=r)return E=r,I=17;let Z=e.charCodeAt(i);if(R(Z)){do i++,a+=String.fromCharCode(Z),Z=e.charCodeAt(i);while(R(Z));return I=15}if(l(Z))return i++,a+=String.fromCharCode(Z),Z===13&&e.charCodeAt(i)===10&&(i++,a+=`
`),I=14;switch(Z){case 123:return i++,I=1;case 125:return i++,I=2;case 91:return i++,I=3;case 93:return i++,I=4;case 58:return i++,I=6;case 44:return i++,I=5;case 34:return i++,a=$(),I=10;case 47:const K=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<r&&!l(e.charCodeAt(i));)i++;return a=e.substring(K,i),I=12}if(e.charCodeAt(i+1)===42){i+=2;const J=r-1;let Y=!1;for(;i<J;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,Y=!0;break}i++}return Y||(i++,F=1),a=e.substring(K,i),I=13}return a+=String.fromCharCode(Z),i++,I=16;case 45:if(a+=String.fromCharCode(Z),i++,i===r||!g(e.charCodeAt(i)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=M(),I=11;default:for(;i<r&&ie(Z);)i++,Z=e.charCodeAt(i);if(E!==i){switch(a=e.substring(E,i),a){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return a+=String.fromCharCode(Z),i++,I=16}}function ie(Z){if(R(Z)||l(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let Z;do Z=Q();while(Z>=12&&Z<=15);return Z}return{setPosition:L,getPosition:()=>i,scan:n?oe:Q,getToken:()=>I,getTokenValue:()=>a,getTokenOffset:()=>E,getTokenLength:()=>i-E,getTokenError:()=>F}}t.createScanner=D;function R(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var m;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(m||(m={}));function b(e,n){const i=[],r=new Object;let a;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function F(w,L,M,$){E.value=w,E.offset=L,E.length=M,E.type=$,E.colonOffset=void 0,a=E}try{h(e,{onObjectBegin:(w,L)=>{if(n<=w)throw r;a=void 0,I=n>w,i.push("")},onObjectProperty:(w,L,M)=>{if(n<L||(F(w,L,M,"property"),i[i.length-1]=w,n<=L+M))throw r},onObjectEnd:(w,L)=>{if(n<=w)throw r;a=void 0,i.pop()},onArrayBegin:(w,L)=>{if(n<=w)throw r;a=void 0,i.push(0)},onArrayEnd:(w,L)=>{if(n<=w)throw r;a=void 0,i.pop()},onLiteralValue:(w,L,M)=>{if(n<L||(F(w,L,M,s(w)),n<=L+M))throw r},onSeparator:(w,L,M)=>{if(n<=L)throw r;if(w===":"&&a&&a.type==="property")a.colonOffset=L,I=!1,a=void 0;else if(w===","){const $=i[i.length-1];typeof $=="number"?i[i.length-1]=$+1:(I=!0,i[i.length-1]=""),a=void 0}}})}catch(w){if(w!==r)throw w}return{path:i,previousNode:a,isAtPropertyKey:I,matches:w=>{let L=0;for(let M=0;L<w.length&&M<i.length;M++)if(w[L]===i[M]||w[L]==="*")L++;else if(w[L]!=="**")return!1;return L===w.length}}}t.getLocation=b;function d(e,n=[],i=C.DEFAULT){let r=null,a=[];const E=[];function I(w){Array.isArray(a)?a.push(w):r!==null&&(a[r]=w)}return h(e,{onObjectBegin:()=>{const w={};I(w),E.push(a),a=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{a=E.pop()},onArrayBegin:()=>{const w=[];I(w),E.push(a),a=w,r=null},onArrayEnd:()=>{a=E.pop()},onLiteralValue:I,onError:(w,L,M)=>{n.push({error:w,offset:L,length:M})}},i),a[0]}t.parse=d;function y(e,n=[],i=C.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(w){r.type==="property"&&(r.length=w-r.offset,r=r.parent)}function E(w){return r.children.push(w),w}h(e,{onObjectBegin:w=>{r=E({type:"object",offset:w,length:-1,parent:r,children:[]})},onObjectProperty:(w,L,M)=>{r=E({type:"property",offset:L,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:w,offset:L,length:M,parent:r})},onObjectEnd:(w,L)=>{r.length=w+L-r.offset,r=r.parent,a(w+L)},onArrayBegin:(w,L)=>{r=E({type:"array",offset:w,length:-1,parent:r,children:[]})},onArrayEnd:(w,L)=>{r.length=w+L-r.offset,r=r.parent,a(w+L)},onLiteralValue:(w,L,M)=>{E({type:s(w),offset:L,length:M,parent:r,value:w}),a(L+M)},onSeparator:(w,L,M)=>{r.type==="property"&&(w===":"?r.colonOffset=L:w===","&&a(L))},onError:(w,L,M)=>{n.push({error:w,offset:L,length:M})}},i);const F=r.children[0];return F&&delete F.parent,F}t.parseTree=y;function c(e,n){if(!e)return;let i=e;for(let r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const E of i.children)if(Array.isArray(E.children)&&E.children[0].value===r){i=E.children[1],a=!0;break}if(!a)return}else{const a=r;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}t.findNodeAtLocation=c;function u(e){if(!e.parent||!e.parent.children)return[];const n=u(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;n.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&n.push(i)}return n}t.getNodePath=u;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":const n=Object.create(null);for(let i of e.children){const r=i.children[1];r&&(n[i.children[0].value]=v(r))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=v;function f(e,n,i=!1){return n>=e.offset&&n<e.offset+e.length||i&&n===e.offset+e.length}t.contains=f;function p(e,n,i=!1){if(f(e,n,i)){const r=e.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=n;a++){const E=p(r[a],n,i);if(E)return E}return e}}t.findNodeAtOffset=p;function h(e,n,i=C.DEFAULT){const r=D(e,!1);function a(j){return j?()=>j(r.getTokenOffset(),r.getTokenLength()):()=>!0}function E(j){return j?k=>j(k,r.getTokenOffset(),r.getTokenLength()):()=>!0}const I=a(n.onObjectBegin),F=E(n.onObjectProperty),w=a(n.onObjectEnd),L=a(n.onArrayBegin),M=a(n.onArrayEnd),$=E(n.onLiteralValue),Q=E(n.onSeparator),ie=a(n.onComment),oe=E(n.onError),Z=i&&i.disallowComments,K=i&&i.allowTrailingComma;function J(){for(;;){const j=r.scan();switch(r.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:Z||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(j){case 12:case 13:Z?Y(10):ie();break;case 16:Y(1);break;case 15:case 14:break;default:return j}}}function Y(j,k=[],A=[]){if(oe(j),k.length+A.length>0){let U=r.getToken();for(;U!==17;){if(k.indexOf(U)!==-1){J();break}else if(A.indexOf(U)!==-1)break;U=J()}}}function se(j){const k=r.getTokenValue();return j?$(k):F(k),J(),!0}function B(){switch(r.getToken()){case 11:let j=0;try{j=JSON.parse(r.getTokenValue()),typeof j!="number"&&(Y(2),j=0)}catch(k){Y(2)}$(j);break;case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return J(),!0}function O(){return r.getToken()!==10?(Y(3,[],[2,5]),!1):(se(!1),r.getToken()===6?(Q(":"),J(),W()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function x(){I(),J();let j=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(j||Y(4,[],[]),Q(","),J(),r.getToken()===2&&K)break}else j&&Y(6,[],[]);O()||Y(4,[],[2,5]),j=!0}return w(),r.getToken()!==2?Y(7,[2],[]):J(),!0}function z(){L(),J();let j=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(j||Y(4,[],[]),Q(","),J(),r.getToken()===4&&K)break}else j&&Y(6,[],[]);W()||Y(4,[],[4,5]),j=!0}return M(),r.getToken()!==4?Y(8,[4],[]):J(),!0}function W(){switch(r.getToken()){case 3:return z();case 1:return x();case 10:return se(!0);default:return B()}}return J(),r.getToken()===17?i.allowEmptyContent?!0:(Y(4,[],[]),!1):W()?(r.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}t.visit=h;function o(e,n){let i=D(e),r=[],a,E=0,I;do switch(I=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:E!==I&&r.push(e.substring(E,I)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),E=i.getPosition();break}while(a!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function _(S){const C=[];typeof S=="number"&&C.push("code/timeOrigin",S);function D(l){C.push(l,Date.now())}function R(){const l=[];for(let g=0;g<C.length;g+=2)l.push({name:C[g],startTime:C[g+1]});return l}return{mark:D,getMarks:R}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const D of performance.getEntriesByType("mark"))C.push({name:D.name,startTime:Math.round(S+D.startTime)});return C}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function T(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=T(P))}(),function(_,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var T=t();for(var P in T)(typeof exports=="object"?exports:_)[P]=T[P]}}(typeof self!="undefined"?self:this,function(){return function(_){var t={};function T(P){if(t[P])return t[P].exports;var S=t[P]={i:P,l:!1,exports:{}};return _[P].call(S.exports,S,S.exports,T),S.l=!0,S.exports}return T.m=_,T.c=t,T.d=function(P,S,C){T.o(P,S)||Object.defineProperty(P,S,{enumerable:!0,get:C})},T.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},T.t=function(P,S){if(1&S&&(P=T(P)),8&S||4&S&&typeof P=="object"&&P&&P.__esModule)return P;var C=Object.create(null);if(T.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:P}),2&S&&typeof P!="string")for(var D in P)T.d(C,D,function(R){return P[R]}.bind(null,D));return C},T.n=function(P){var S=P&&P.__esModule?function(){return P.default}:function(){return P};return T.d(S,"a",S),S},T.o=function(P,S){return Object.prototype.hasOwnProperty.call(P,S)},T.p="",T(T.s=0)}([function(_,t,T){(function(P){var S;t=_.exports=A,S=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var N=Array.prototype.slice.call(arguments,0);N.unshift("SEMVER"),console.log.apply(console,N)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var C=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,R=t.re=[],l=t.src=[],g=0,m=g++;l[m]="0|[1-9]\\d*";var b=g++;l[b]="[0-9]+";var d=g++;l[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=g++;l[y]="("+l[m]+")\\.("+l[m]+")\\.("+l[m]+")";var c=g++;l[c]="("+l[b]+")\\.("+l[b]+")\\.("+l[b]+")";var u=g++;l[u]="(?:"+l[m]+"|"+l[d]+")";var v=g++;l[v]="(?:"+l[b]+"|"+l[d]+")";var f=g++;l[f]="(?:-("+l[u]+"(?:\\."+l[u]+")*))";var p=g++;l[p]="(?:-?("+l[v]+"(?:\\."+l[v]+")*))";var h=g++;l[h]="[0-9A-Za-z-]+";var o=g++;l[o]="(?:\\+("+l[h]+"(?:\\."+l[h]+")*))";var s=g++,e="v?"+l[y]+l[f]+"?"+l[o]+"?";l[s]="^"+e+"$";var n="[v=\\s]*"+l[c]+l[p]+"?"+l[o]+"?",i=g++;l[i]="^"+n+"$";var r=g++;l[r]="((?:<|>)?=?)";var a=g++;l[a]=l[b]+"|x|X|\\*";var E=g++;l[E]=l[m]+"|x|X|\\*";var I=g++;l[I]="[v=\\s]*("+l[E]+")(?:\\.("+l[E]+")(?:\\.("+l[E]+")(?:"+l[f]+")?"+l[o]+"?)?)?";var F=g++;l[F]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[p]+")?"+l[o]+"?)?)?";var w=g++;l[w]="^"+l[r]+"\\s*"+l[I]+"$";var L=g++;l[L]="^"+l[r]+"\\s*"+l[F]+"$";var M=g++;l[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=g++;l[$]="(?:~>?)";var Q=g++;l[Q]="(\\s*)"+l[$]+"\\s+",R[Q]=new RegExp(l[Q],"g");var ie=g++;l[ie]="^"+l[$]+l[I]+"$";var oe=g++;l[oe]="^"+l[$]+l[F]+"$";var Z=g++;l[Z]="(?:\\^)";var K=g++;l[K]="(\\s*)"+l[Z]+"\\s+",R[K]=new RegExp(l[K],"g");var J=g++;l[J]="^"+l[Z]+l[I]+"$";var Y=g++;l[Y]="^"+l[Z]+l[F]+"$";var se=g++;l[se]="^"+l[r]+"\\s*("+n+")$|^$";var B=g++;l[B]="^"+l[r]+"\\s*("+e+")$|^$";var O=g++;l[O]="(\\s*)"+l[r]+"\\s*("+n+"|"+l[I]+")",R[O]=new RegExp(l[O],"g");var x=g++;l[x]="^\\s*("+l[I]+")\\s+-\\s+("+l[I]+")\\s*$";var z=g++;l[z]="^\\s*("+l[F]+")\\s+-\\s+("+l[F]+")\\s*$";var W=g++;l[W]="(<|>)?=?\\s*\\*";for(var j=0;j<35;j++)S(j,l[j]),R[j]||(R[j]=new RegExp(l[j]));function k(N,q){if(N instanceof A)return N;if(typeof N!="string"||N.length>C||!(q?R[i]:R[s]).test(N))return null;try{return new A(N,q)}catch(H){return null}}function A(N,q){if(N instanceof A){if(N.loose===q)return N;N=N.version}else if(typeof N!="string")throw new TypeError("Invalid Version: "+N);if(N.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof A))return new A(N,q);S("SemVer",N,q),this.loose=q;var H=N.trim().match(q?R[i]:R[s]);if(!H)throw new TypeError("Invalid Version: "+N);if(this.raw=N,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var le=+ae;if(le>=0&&le<D)return le}return ae}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}t.parse=k,t.valid=function(N,q){var H=k(N,q);return H?H.version:null},t.clean=function(N,q){var H=k(N.trim().replace(/^[=v]+/,""),q);return H?H.version:null},t.SemVer=A,A.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},A.prototype.toString=function(){return this.version},A.prototype.compare=function(N){return S("SemVer.compare",this.version,this.loose,N),N instanceof A||(N=new A(N,this.loose)),this.compareMain(N)||this.comparePre(N)},A.prototype.compareMain=function(N){return N instanceof A||(N=new A(N,this.loose)),V(this.major,N.major)||V(this.minor,N.minor)||V(this.patch,N.patch)},A.prototype.comparePre=function(N){if(N instanceof A||(N=new A(N,this.loose)),this.prerelease.length&&!N.prerelease.length)return-1;if(!this.prerelease.length&&N.prerelease.length)return 1;if(!this.prerelease.length&&!N.prerelease.length)return 0;var q=0;do{var H=this.prerelease[q],ae=N.prerelease[q];if(S("prerelease compare",q,H,ae),H===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if(H===void 0)return-1;if(H!==ae)return V(H,ae)}while(++q)},A.prototype.inc=function(N,q){switch(N){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+N)}return this.format(),this.raw=this.version,this},t.inc=function(N,q,H,ae){typeof H=="string"&&(ae=H,H=void 0);try{return new A(N,H).inc(q,ae).version}catch(le){return null}},t.diff=function(N,q){if(ne(N,q))return null;var H=k(N),ae=k(q);if(H.prerelease.length||ae.prerelease.length){for(var le in H)if((le==="major"||le==="minor"||le==="patch")&&H[le]!==ae[le])return"pre"+le;return"prerelease"}for(var le in H)if((le==="major"||le==="minor"||le==="patch")&&H[le]!==ae[le])return le},t.compareIdentifiers=V;var U=/^[0-9]+$/;function V(N,q){var H=U.test(N),ae=U.test(q);return H&&ae&&(N=+N,q=+q),H&&!ae?-1:ae&&!H?1:N<q?-1:N>q?1:0}function G(N,q,H){return new A(N,H).compare(new A(q,H))}function X(N,q,H){return G(N,q,H)>0}function re(N,q,H){return G(N,q,H)<0}function ne(N,q,H){return G(N,q,H)===0}function ue(N,q,H){return G(N,q,H)!==0}function de(N,q,H){return G(N,q,H)>=0}function ge(N,q,H){return G(N,q,H)<=0}function Ee(N,q,H,ae){var le;switch(q){case"===":typeof N=="object"&&(N=N.version),typeof H=="object"&&(H=H.version),le=N===H;break;case"!==":typeof N=="object"&&(N=N.version),typeof H=="object"&&(H=H.version),le=N!==H;break;case"":case"=":case"==":le=ne(N,H,ae);break;case"!=":le=ue(N,H,ae);break;case">":le=X(N,H,ae);break;case">=":le=de(N,H,ae);break;case"<":le=re(N,H,ae);break;case"<=":le=ge(N,H,ae);break;default:throw new TypeError("Invalid operator: "+q)}return le}function ye(N,q){if(N instanceof ye){if(N.loose===q)return N;N=N.value}if(!(this instanceof ye))return new ye(N,q);S("comparator",N,q),this.loose=q,this.parse(N),this.semver===be?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(N,q){return V(q,N)},t.major=function(N,q){return new A(N,q).major},t.minor=function(N,q){return new A(N,q).minor},t.patch=function(N,q){return new A(N,q).patch},t.compare=G,t.compareLoose=function(N,q){return G(N,q,!0)},t.rcompare=function(N,q,H){return G(q,N,H)},t.sort=function(N,q){return N.sort(function(H,ae){return t.compare(H,ae,q)})},t.rsort=function(N,q){return N.sort(function(H,ae){return t.rcompare(H,ae,q)})},t.gt=X,t.lt=re,t.eq=ne,t.neq=ue,t.gte=de,t.lte=ge,t.cmp=Ee,t.Comparator=ye;var be={};function pe(N,q){if(N instanceof pe)return N.loose===q?N:new pe(N.raw,q);if(N instanceof ye)return new pe(N.value,q);if(!(this instanceof pe))return new pe(N,q);if(this.loose=q,this.raw=N,this.set=N.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+N);this.format()}function De(N){return!N||N.toLowerCase()==="x"||N==="*"}function ze(N,q,H,ae,le,Re,ve,Oe,Pe,Te,ke,Ie,Le){return((q=De(H)?"":De(ae)?">="+H+".0.0":De(le)?">="+H+"."+ae+".0":">="+q)+" "+(Oe=De(Pe)?"":De(Te)?"<"+(+Pe+1)+".0.0":De(ke)?"<"+Pe+"."+(+Te+1)+".0":Ie?"<="+Pe+"."+Te+"."+ke+"-"+Ie:"<="+Oe)).trim()}function Ve(N,q){for(var H=0;H<N.length;H++)if(!N[H].test(q))return!1;if(q.prerelease.length){for(H=0;H<N.length;H++)if(S(N[H].semver),N[H].semver!==be&&N[H].semver.prerelease.length>0){var ae=N[H].semver;if(ae.major===q.major&&ae.minor===q.minor&&ae.patch===q.patch)return!0}return!1}return!0}function Ue(N,q,H){try{q=new pe(q,H)}catch(ae){return!1}return q.test(N)}function je(N,q,H,ae){var le,Re,ve,Oe,Pe;switch(N=new A(N,ae),q=new pe(q,ae),H){case">":le=X,Re=ge,ve=re,Oe=">",Pe=">=";break;case"<":le=re,Re=de,ve=X,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(N,q,ae))return!1;for(var Te=0;Te<q.set.length;++Te){var ke=q.set[Te],Ie=null,Le=null;if(ke.forEach(function(Fe){Fe.semver===be&&(Fe=new ye(">=0.0.0")),Ie=Ie||Fe,Le=Le||Fe,le(Fe.semver,Ie.semver,ae)?Ie=Fe:ve(Fe.semver,Le.semver,ae)&&(Le=Fe)}),Ie.operator===Oe||Ie.operator===Pe||(!Le.operator||Le.operator===Oe)&&Re(N,Le.semver)||Le.operator===Pe&&ve(N,Le.semver))return!1}return!0}ye.prototype.parse=function(N){var q=this.loose?R[se]:R[B],H=N.match(q);if(!H)throw new TypeError("Invalid comparator: "+N);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new A(H[2],this.loose):this.semver=be},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(N){return S("Comparator.test",N,this.loose),this.semver===be||(typeof N=="string"&&(N=new A(N,this.loose)),Ee(N,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(N,q){if(!(N instanceof ye))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new pe(N.value,q),Ue(this.value,H,q);if(N.operator==="")return H=new pe(this.value,q),Ue(N.semver,H,q);var ae=!(this.operator!==">="&&this.operator!==">"||N.operator!==">="&&N.operator!==">"),le=!(this.operator!=="<="&&this.operator!=="<"||N.operator!=="<="&&N.operator!=="<"),Re=this.semver.version===N.semver.version,ve=!(this.operator!==">="&&this.operator!=="<="||N.operator!==">="&&N.operator!=="<="),Oe=Ee(this.semver,"<",N.semver,q)&&(this.operator===">="||this.operator===">")&&(N.operator==="<="||N.operator==="<"),Pe=Ee(this.semver,">",N.semver,q)&&(this.operator==="<="||this.operator==="<")&&(N.operator===">="||N.operator===">");return ae||le||Re&&ve||Oe||Pe},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(N){return N.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(N){var q=this.loose;N=N.trim(),S("range",N,q);var H=q?R[z]:R[x];N=N.replace(H,ze),S("hyphen replace",N),N=N.replace(R[O],"$1$2$3"),S("comparator trim",N,R[O]),N=(N=(N=N.replace(R[Q],"$1~")).replace(R[K],"$1^")).split(/\s+/).join(" ");var ae=q?R[se]:R[B],le=N.split(" ").map(function(Re){return function(ve,Oe){return S("comp",ve),ve=function(Pe,Te){return Pe.trim().split(/\s+/).map(function(ke){return function(Ie,Le){S("caret",Ie,Le);var Fe=Le?R[Y]:R[J];return Ie.replace(Fe,function(Ae,ce,me,we,Se){var Ce;return S("caret",Ie,Ae,ce,me,we,Se),De(ce)?Ce="":De(me)?Ce=">="+ce+".0.0 <"+(+ce+1)+".0.0":De(we)?Ce=ce==="0"?">="+ce+"."+me+".0 <"+ce+"."+(+me+1)+".0":">="+ce+"."+me+".0 <"+(+ce+1)+".0.0":Se?(S("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Ce=ce==="0"?me==="0"?">="+ce+"."+me+"."+we+Se+" <"+ce+"."+me+"."+(+we+1):">="+ce+"."+me+"."+we+Se+" <"+ce+"."+(+me+1)+".0":">="+ce+"."+me+"."+we+Se+" <"+(+ce+1)+".0.0"):(S("no pr"),Ce=ce==="0"?me==="0"?">="+ce+"."+me+"."+we+" <"+ce+"."+me+"."+(+we+1):">="+ce+"."+me+"."+we+" <"+ce+"."+(+me+1)+".0":">="+ce+"."+me+"."+we+" <"+(+ce+1)+".0.0"),S("caret return",Ce),Ce})}(ke,Te)}).join(" ")}(ve,Oe),S("caret",ve),ve=function(Pe,Te){return Pe.trim().split(/\s+/).map(function(ke){return function(Ie,Le){var Fe=Le?R[oe]:R[ie];return Ie.replace(Fe,function(Ae,ce,me,we,Se){var Ce;return S("tilde",Ie,Ae,ce,me,we,Se),De(ce)?Ce="":De(me)?Ce=">="+ce+".0.0 <"+(+ce+1)+".0.0":De(we)?Ce=">="+ce+"."+me+".0 <"+ce+"."+(+me+1)+".0":Se?(S("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Ce=">="+ce+"."+me+"."+we+Se+" <"+ce+"."+(+me+1)+".0"):Ce=">="+ce+"."+me+"."+we+" <"+ce+"."+(+me+1)+".0",S("tilde return",Ce),Ce})}(ke,Te)}).join(" ")}(ve,Oe),S("tildes",ve),ve=function(Pe,Te){return S("replaceXRanges",Pe,Te),Pe.split(/\s+/).map(function(ke){return function(Ie,Le){Ie=Ie.trim();var Fe=Le?R[L]:R[w];return Ie.replace(Fe,function(Ae,ce,me,we,Se,Ce){S("xRange",Ie,Ae,ce,me,we,Se,Ce);var We=De(me),Me=We||De(we),xe=Me||De(Se);return ce==="="&&xe&&(ce=""),We?Ae=ce===">"||ce==="<"?"<0.0.0":"*":ce&&xe?(Me&&(we=0),xe&&(Se=0),ce===">"?(ce=">=",Me?(me=+me+1,we=0,Se=0):xe&&(we=+we+1,Se=0)):ce==="<="&&(ce="<",Me?me=+me+1:we=+we+1),Ae=ce+me+"."+we+"."+Se):Me?Ae=">="+me+".0.0 <"+(+me+1)+".0.0":xe&&(Ae=">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0"),S("xRange return",Ae),Ae})}(ke,Te)}).join(" ")}(ve,Oe),S("xrange",ve),ve=function(Pe,Te){return S("replaceStars",Pe,Te),Pe.trim().replace(R[W],"")}(ve,Oe),S("stars",ve),ve}(Re,q)}).join(" ").split(/\s+/);return this.loose&&(le=le.filter(function(Re){return!!Re.match(ae)})),le=le.map(function(Re){return new ye(Re,q)})},pe.prototype.intersects=function(N,q){if(!(N instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ae){return N.set.some(function(le){return le.every(function(Re){return ae.intersects(Re,q)})})})})},t.toComparators=function(N,q){return new pe(N,q).set.map(function(H){return H.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(N){if(!N)return!1;typeof N=="string"&&(N=new A(N,this.loose));for(var q=0;q<this.set.length;q++)if(Ve(this.set[q],N))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(N,q,H){var ae=null,le=null;try{var Re=new pe(q,H)}catch(ve){return null}return N.forEach(function(ve){Re.test(ve)&&(ae&&le.compare(ve)!==-1||(le=new A(ae=ve,H)))}),ae},t.minSatisfying=function(N,q,H){var ae=null,le=null;try{var Re=new pe(q,H)}catch(ve){return null}return N.forEach(function(ve){Re.test(ve)&&(ae&&le.compare(ve)!==1||(le=new A(ae=ve,H)))}),ae},t.validRange=function(N,q){try{return new pe(N,q).range||"*"}catch(H){return null}},t.ltr=function(N,q,H){return je(N,q,"<",H)},t.gtr=function(N,q,H){return je(N,q,">",H)},t.outside=je,t.prerelease=function(N,q){var H=k(N,q);return H&&H.prerelease.length?H.prerelease:null},t.intersects=function(N,q,H){return N=new pe(N,H),q=new pe(q,H),N.intersects(q)},t.coerce=function(N){if(N instanceof A)return N;if(typeof N!="string")return null;var q=N.match(R[M]);return q==null?null:k((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,T(1))},function(_,t){var T,P,S=_.exports={};function C(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function R(v){if(T===setTimeout)return setTimeout(v,0);if((T===C||!T)&&setTimeout)return T=setTimeout,setTimeout(v,0);try{return T(v,0)}catch(f){try{return T.call(null,v,0)}catch(p){return T.call(this,v,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:C}catch(v){T=C}try{P=typeof clearTimeout=="function"?clearTimeout:D}catch(v){P=D}})();var l,g=[],m=!1,b=-1;function d(){m&&l&&(m=!1,l.length?g=l.concat(g):b=-1,g.length&&y())}function y(){if(!m){var v=R(d);m=!0;for(var f=g.length;f;){for(l=g,g=[];++b<f;)l&&l[b].run();b=-1,f=g.length}l=null,m=!1,function(p){if(P===clearTimeout)return clearTimeout(p);if((P===D||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(p);try{P(p)}catch(h){try{return P.call(null,p)}catch(o){return P.call(this,p)}}}(v)}}function c(v,f){this.fun=v,this.array=f}function u(){}S.nextTick=function(v){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];g.push(new c(v,f)),g.length!==1||m||R(y)},c.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=u,S.addListener=u,S.once=u,S.off=u,S.removeListener=u,S.removeAllListeners=u,S.emit=u,S.prependListener=u,S.prependOnceListener=u,S.listeners=function(v){return[]},S.binding=function(v){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(v){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(ee[37],te([0,1,11,2]),function(_,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=S;function C(h){const o=h;return o?S(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=C;function D(h,o){return new R(h,o)}t.newWriteableStream=D;class R{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,T.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const n=e.indexOf(s);n>=0&&e.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(h,o){const s=[];let e;for(;(e=h.read())!==null;)s.push(e);return o(s)}t.consumeReadable=l;function g(h,o,s){const e=[];let n;for(;(n=h.read())!==null&&e.length<s;)e.push(n);return n===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return h.read()}}}t.peekReadable=g;function m(h,o){return new Promise((s,e)=>{const n=[];b(h,{onData:i=>{o&&n.push(i)},onError:i=>{o?e(i):s(void 0)},onEnd:()=>{s(o?o(n):void 0)}})})}t.consumeStream=m;function b(h,o){h.on("error",s=>o.onError(s)),h.on("end",()=>o.onEnd()),h.on("data",s=>o.onData(s))}t.listenStream=b;function d(h,o){return new Promise((s,e)=>{const n=new P.DisposableStore,i=[],r=I=>{if(i.push(I),i.length>o)return n.dispose(),h.pause(),s({stream:h,buffer:i,ended:!1})},a=I=>e(I),E=()=>s({stream:h,buffer:i,ended:!0});n.add((0,P.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),n.add((0,P.toDisposable)(()=>h.removeListener("end",E))),h.on("end",E),n.add((0,P.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}t.peekStream=d;function y(h,o){const s=D(o);return s.end(h),s}t.toStream=y;function c(){const h=D(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=c;function u(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}t.toReadable=u;function v(h,o,s){const e=D(s);return b(h,{onData:n=>e.write(o.data(n)),onError:n=>e.error(o.error?o.error(n):n),onEnd:()=>e.end()}),e}t.transform=v;function f(h,o,s){let e=!1;return{read:()=>{const n=o.read();return e?n:(e=!0,n!==null?s([h,n]):h)}}}t.prefixedReadable=f;function p(h,o,s){let e=!1;const n=D(s);return b(o,{onData:i=>e?n.write(i):(e=!0,n.write(s([h,i]))),onError:i=>n.error(i),onEnd:()=>{e||(e=!0,n.write(h)),n.end()}}),n}t.prefixedStream=p}),define(ee[16],te([0,1,37]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const P=typeof Buffer!="undefined";let S,C;class D{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return P?new D(Buffer.allocUnsafe(r)):new D(new Uint8Array(r))}static wrap(r){return P&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new D(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(r)):(S||(S=new TextEncoder),new D(S.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let F=0,w=r.length;F<w;F++)a+=r[F].byteLength}const E=D.alloc(a);let I=0;for(let F=0,w=r.length;F<w;F++){const L=r[F];E.set(L,I),I+=L.byteLength}return E}toString(){return P?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(r,a){return new D(this.buffer.subarray(r,a))}set(r,a){r instanceof D?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return g(this.buffer,r)}writeUInt32BE(r,a){m(this.buffer,r,a)}readUInt32LE(r){return b(this.buffer,r)}writeUInt32LE(r,a){d(this.buffer,r,a)}readUInt8(r){return y(this.buffer,r)}writeUInt8(r,a){c(this.buffer,r,a)}}t.VSBuffer=D;function R(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0}t.readUInt16LE=R;function l(i,r,a){i[a+0]=r&255,r=r>>>8,i[a+1]=r&255}t.writeUInt16LE=l;function g(i,r){return i[r]*2**24+i[r+1]*2**16+i[r+2]*2**8+i[r+3]}t.readUInt32BE=g;function m(i,r,a){i[a+3]=r,r=r>>>8,i[a+2]=r,r=r>>>8,i[a+1]=r,r=r>>>8,i[a]=r}t.writeUInt32BE=m;function b(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0|i[r+2]<<16>>>0|i[r+3]<<24>>>0}t.readUInt32LE=b;function d(i,r,a){i[a+0]=r&255,r=r>>>8,i[a+1]=r&255,r=r>>>8,i[a+2]=r&255,r=r>>>8,i[a+3]=r&255}t.writeUInt32LE=d;function y(i,r){return i[r]}t.readUInt8=y;function c(i,r,a){i[a]=r}t.writeUInt8=c;function u(i){return T.consumeReadable(i,r=>D.concat(r))}t.readableToBuffer=u;function v(i){return T.toReadable(i)}t.bufferToReadable=v;function f(i){return T.consumeStream(i,r=>D.concat(r))}t.streamToBuffer=f;async function p(i){return i.ended?D.concat(i.buffer):D.concat([...i.buffer,await f(i.stream)])}t.bufferedStreamToBuffer=p;function h(i){return T.toStream(i,r=>D.concat(r))}t.bufferToStream=h;function o(i){return T.transform(i,{data:r=>typeof r=="string"?D.fromString(r):D.wrap(r)},r=>D.concat(r))}t.streamToBufferReadableStream=o;function s(i){return T.newWriteableStream(r=>D.concat(r),i)}t.newWriteableBufferStream=s;function e(i,r){return T.prefixedReadable(i,r,a=>D.concat(a))}t.prefixedBufferReadable=e;function n(i,r){return T.prefixedStream(i,r,a=>D.concat(a))}t.prefixedBufferStream=n}),define(ee[18],te([0,1,12]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function P(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const v=Array.isArray(u)?[]:{};return Object.keys(u).forEach(f=>{u[f]&&typeof u[f]=="object"?v[f]=P(u[f]):v[f]=u[f]}),v}t.deepClone=P;function S(u){if(!u||typeof u!="object")return u;const v=[u];for(;v.length>0;){const f=v.shift();Object.freeze(f);for(const p in f)if(C.call(f,p)){const h=f[p];typeof h=="object"&&!Object.isFrozen(h)&&v.push(h)}}return u}t.deepFreeze=S;const C=Object.prototype.hasOwnProperty;function D(u,v){return R(u,v,new Set)}t.cloneAndChange=D;function R(u,v,f){if((0,T.isUndefinedOrNull)(u))return u;const p=v(u);if(typeof p!="undefined")return p;if((0,T.isArray)(u)){const h=[];for(const o of u)h.push(R(o,v,f));return h}if((0,T.isObject)(u)){if(f.has(u))throw new Error("Cannot clone recursive data-structure");f.add(u);const h={};for(let o in u)C.call(u,o)&&(h[o]=R(u[o],v,f));return f.delete(u),h}return u}function l(u,v,f=!0){return(0,T.isObject)(u)?((0,T.isObject)(v)&&Object.keys(v).forEach(p=>{p in u?f&&((0,T.isObject)(u[p])&&(0,T.isObject)(v[p])?l(u[p],v[p],f):u[p]=v[p]):u[p]=v[p]}),u):v}t.mixin=l;function g(u,v){if(u===v)return!0;if(u==null||v===null||v===void 0||typeof u!=typeof v||typeof u!="object"||Array.isArray(u)!==Array.isArray(v))return!1;let f,p;if(Array.isArray(u)){if(u.length!==v.length)return!1;for(f=0;f<u.length;f++)if(!g(u[f],v[f]))return!1}else{const h=[];for(p in u)h.push(p);h.sort();const o=[];for(p in v)o.push(p);if(o.sort(),!g(h,o))return!1;for(f=0;f<h.length;f++)if(!g(u[h[f]],v[h[f]]))return!1}return!0}t.equals=g;function m(u){const v=new Set;return JSON.stringify(u,(f,p)=>{if((0,T.isObject)(p)||Array.isArray(p)){if(v.has(p))return"[Circular]";v.add(p)}return p})}t.safeStringify=m;function b(u,v,f){const p=v(u);return typeof p=="undefined"?f:p}t.getOrDefault=b;function d(u,v){const f=Object.create(null);return!u||!v||Object.keys(v).forEach(h=>{const o=u[h],s=v[h];g(o,s)||(f[h]=s)}),f}t.distinct=d;function y(u,v){const f=v.toLowerCase(),p=Object.keys(u).find(h=>h.toLowerCase()===f);return p?u[p]:u[v]}t.getCaseInsensitive=y;function c(u,v){const f=Object.create(null);for(const p of Object.keys(u))v(p,u[p])&&(f[p]=u[p]);return f}t.filter=c}),define(ee[59],te([0,1,7]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function P(g){const m=g;return m&&typeof m.type=="string"&&typeof m.severity=="string"}t.isRemoteConsoleLog=P;function S(g){const m=[];let b;try{const d=JSON.parse(g.arguments),y=d[d.length-1];y&&y.__$stack&&(d.pop(),b=y.__$stack),m.push(...d)}catch(d){m.push("Unable to log remote console arguments",g.arguments)}return{args:m,stack:b}}t.parse=S;function C(g){if(typeof g!="string")return C(S(g).stack);const m=g;if(m){const b=D(m),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(d&&d.length===4)return{uri:T.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}t.getFirstFrame=C;function D(g){if(!g)return g;const m=g.indexOf(`
`);return m===-1?g:g.substring(0,m)}function R(g,m){const{args:b,stack:d}=S(g),y=typeof b[0]=="string"&&b.length===1;let c=D(d);c&&(c=`(${c.trim()})`);let u=[];if(typeof b[0]=="string"?c&&y?u=[`%c[${m}] %c${b[0]} %c${c}`,l("blue"),l(""),l("grey")]:u=[`%c[${m}] %c${b[0]}`,l("blue"),l(""),...b.slice(1)]:u=[`%c[${m}]%`,l("blue"),...b],c&&!y&&u.push(c),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,u)}t.log=R;function l(g){return`color: ${g}`}}),define(ee[60],te([0,1,16,21,7]),function(_,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function C(m){return JSON.stringify(m,l)}t.stringify=C;function D(m){let b=JSON.parse(m);return b=g(b),b}t.parse=D;var R;(function(m){m[m.Uri=1]="Uri",m[m.Regexp=2]="Regexp",m[m.ScmResource=3]="ScmResource",m[m.ScmResourceGroup=4]="ScmResourceGroup",m[m.ScmProvider=5]="ScmProvider",m[m.CommentController=6]="CommentController",m[m.CommentThread=7]="CommentThread",m[m.CommentThreadReply=8]="CommentThreadReply",m[m.CommentNode=9]="CommentNode",m[m.CommentThreadNode=10]="CommentThreadNode",m[m.TimelineActionContext=11]="TimelineActionContext",m[m.NotebookCellActionContext=12]="NotebookCellActionContext",m[m.TestItemContext=13]="TestItemContext"})(R=t.MarshalledId||(t.MarshalledId={}));function l(m,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,P.regExpFlags)(b)}:b}function g(m,b=0){if(!m||b>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return S.URI.revive(m);case 2:return new RegExp(m.source,m.flags)}if(m instanceof T.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let d=0;d<m.length;++d)m[d]=g(m[d],b+1);else for(const d in m)Object.hasOwnProperty.call(m,d)&&(m[d]=g(m[d],b+1))}return m}t.revive=g}),define(ee[61],te([0,1,3,32,46,4,21]),function(_,t,T,P,S,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function R(){return Object.create(null)}t.getEmptyExpression=R;const l="**",g="/",m="[/\\\\]",b="[^/\\\\]",d=/\//g;function y(O){switch(O){case 0:return"";case 1:return`${b}*?`;default:return`(?:${m}|${b}+${m}|${m}${b}+)*?`}}function c(O,x){if(!O)return[];const z=[];let W=!1,j=!1,k="";for(const A of O){switch(A){case x:if(!W&&!j){z.push(k),k="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":j=!0;break;case"]":j=!1;break}k+=A}return k&&z.push(k),z}t.splitGlobAware=c;function u(O){if(!O)return"";let x="";const z=c(O,g);if(z.every(W=>W===l))x=".*";else{let W=!1;z.forEach((j,k)=>{if(j===l){W||(x+=y(2),W=!0);return}let A=!1,U="",V=!1,G="";for(const X of j){if(X!=="}"&&A){U+=X;continue}if(V&&(X!=="]"||!G)){let re;X==="-"?re=X:(X==="^"||X==="!")&&!G?re="^":X===g?re="":re=D.escapeRegExpCharacters(X),G+=re;continue}switch(X){case"{":A=!0;continue;case"[":V=!0;continue;case"}":x+=`(?:${c(U,",").map(ue=>u(ue)).join("|")})`,A=!1,U="";break;case"]":x+="["+G+"]",V=!1,G="";break;case"?":x+=b;continue;case"*":x+=y(1);continue;default:x+=D.escapeRegExpCharacters(X)}}k<z.length-1&&(z[k+1]!==l||k+2<z.length)&&(x+=m),W=!1})}return x}const v=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new S.LRUCache(1e4),n=function(){return!1},i=function(){return null};function r(O,x){if(!O)return i;let z;typeof O!="string"?z=O.pattern:z=O,z=z.trim();const W=`${z}_${!!x.trimForExclusions}`;let j=e.get(W);if(j)return a(j,O);let k;if(v.test(z)){const A=z.substr(4);j=function(U,V){return typeof U=="string"&&U.endsWith(A)?z:null}}else(k=f.exec(E(z,x)))?j=I(k[1],z):(x.trimForExclusions?h:p).test(z)?j=F(z,x):(k=o.exec(E(z,x)))?j=w(k[1].substr(1),z,!0):(k=s.exec(E(z,x)))?j=w(k[1],z,!1):j=L(z);return e.set(W,j),a(j,O)}function a(O,x){return typeof x=="string"?O:function(z,W){return P.isEqualOrParent(z,x.base)?O(C.relative(x.base,z),W):null}}function E(O,x){return x.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function I(O,x){const z=`/${O}`,W=`\\${O}`,j=function(A,U){return typeof A!="string"?null:U?U===O?x:null:A===O||A.endsWith(z)||A.endsWith(W)?x:null},k=[O];return j.basenames=k,j.patterns=[x],j.allBasenames=k,j}function F(O,x){const z=B(O.slice(1,-1).split(",").map(U=>r(U,x)).filter(U=>U!==i),O),W=z.length;if(!W)return i;if(W===1)return z[0];const j=function(U,V){for(let G=0,X=z.length;G<X;G++)if(z[G](U,V))return O;return null},k=z.find(U=>!!U.allBasenames);k&&(j.allBasenames=k.allBasenames);const A=z.reduce((U,V)=>V.allPaths?U.concat(V.allPaths):U,[]);return A.length&&(j.allPaths=A),j}function w(O,x,z){const W=C.sep===C.posix.sep,j=W?O:O.replace(d,C.sep),k=C.sep+j,A=C.posix.sep+O,U=z?function(V,G){return typeof V=="string"&&(V===j||V.endsWith(k)||!W&&(V===O||V.endsWith(A)))?x:null}:function(V,G){return typeof V=="string"&&(V===j||!W&&V===O)?x:null};return U.allPaths=[(z?"*/":"./")+O],U}function L(O){try{const x=new RegExp(`^${u(O)}$`);return function(z){return x.lastIndex=0,typeof z=="string"&&x.test(z)?O:null}}catch(x){return i}}function M(O,x,z){return!O||typeof x!="string"?!1:$(O)(x,void 0,z)}t.match=M;function $(O,x={}){if(!O)return n;if(typeof O=="string"||Z(O)){const z=r(O,x);if(z===i)return n;const W=function(j,k){return!!z(j,k)};return z.allBasenames&&(W.allBasenames=z.allBasenames),z.allPaths&&(W.allPaths=z.allPaths),W}return Y(O,x)}t.parse=$;function Q(O){if(!O)return;let x;return z=>(x||(x=(O()||Promise.resolve([])).then(W=>W?oe(W):{})),x.then(W=>!!W[z]))}t.hasSiblingPromiseFn=Q;function ie(O){if(!O)return;let x;return z=>{if(!x){const W=O();x=W?oe(W):{}}return!!x[z]}}t.hasSiblingFn=ie;function oe(O){const x={};for(const z of O)x[z]=!0;return x}function Z(O){const x=O;return x&&typeof x.base=="string"&&typeof x.pattern=="string"}t.isRelativePattern=Z;function K(O){return O.allBasenames||[]}t.getBasenameTerms=K;function J(O){return O.allPaths||[]}t.getPathTerms=J;function Y(O,x){const z=B(Object.getOwnPropertyNames(O).map(U=>se(U,O[U],x)).filter(U=>U!==i)),W=z.length;if(!W)return i;if(!z.some(U=>!!U.requiresSiblings)){if(W===1)return z[0];const U=function(X,re){for(let ne=0,ue=z.length;ne<ue;ne++){const de=z[ne](X,re);if(de)return de}return null},V=z.find(X=>!!X.allBasenames);V&&(U.allBasenames=V.allBasenames);const G=z.reduce((X,re)=>re.allPaths?X.concat(re.allPaths):X,[]);return G.length&&(U.allPaths=G),U}const j=function(U,V,G){let X;for(let re=0,ne=z.length;re<ne;re++){const ue=z[re];ue.requiresSiblings&&G&&(V||(V=C.basename(U)),X||(X=V.substr(0,V.length-C.extname(U).length)));const de=ue(U,V,X,G);if(de)return de}return null},k=z.find(U=>!!U.allBasenames);k&&(j.allBasenames=k.allBasenames);const A=z.reduce((U,V)=>V.allPaths?U.concat(V.allPaths):U,[]);return A.length&&(j.allPaths=A),j}function se(O,x,z){if(x===!1)return i;const W=r(O,z);if(W===i)return i;if(typeof x=="boolean")return W;if(x){const j=x.when;if(typeof j=="string"){const k=(A,U,V,G)=>{if(!G||!W(A,U))return null;const X=j.replace("$(basename)",V),re=G(X);return(0,T.isThenable)(re)?re.then(ne=>ne?O:null):re?O:null};return k.requiresSiblings=!0,k}}return W}function B(O,x){const z=O.filter(U=>!!U.basenames);if(z.length<2)return O;const W=z.reduce((U,V)=>{const G=V.basenames;return G?U.concat(G):U},[]);let j;if(x){j=[];for(let U=0,V=W.length;U<V;U++)j.push(x)}else j=z.reduce((U,V)=>{const G=V.patterns;return G?U.concat(G):U},[]);const k=function(U,V){if(typeof U!="string")return null;if(!V){let X;for(X=U.length;X>0;X--){const re=U.charCodeAt(X-1);if(re===47||re===92)break}V=U.substr(X)}const G=W.indexOf(V);return G!==-1?j[G]:null};k.basenames=W,k.patterns=j,k.allBasenames=W;const A=O.filter(U=>!U.basenames);return A.push(k),A}}),define(ee[62],te([0,1,32,9,4,8,19,21,7]),function(_,t,T,P,S,C,D,R,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(r,a,E){if(typeof r=="string"&&(r=l.URI.file(r)),E){const F=E.getWorkspaceFolder(r);if(F){const w=E.getWorkspace().folders.length>1;let L;if((0,D.isEqual)(F.uri,r)?L="":L=(0,D.relativePath)(F.uri,r),w){const M=F.name?F.name:(0,D.basename)(F.uri);L=L?M+" \u2022 "+L:M}return L}}if(r.scheme!==P.Schemas.file&&r.scheme!==P.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(r.fsPath))return(0,S.normalize)(b(r.fsPath));let I=(0,S.normalize)(r.fsPath);return!C.isWindows&&a?.userHome&&(I=y(I,a.userHome.fsPath)),I}t.getPathLabel=g;function m(r){if(!r)return;typeof r=="string"&&(r=l.URI.file(r));const a=(0,D.basename)(r)||(r.scheme===P.Schemas.file?r.fsPath:r.path);return C.isWindows&&(0,T.isRootOrDriveLetter)(a)?b(a):a}t.getBaseLabel=m;function b(r){return(0,T.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=b;let d=Object.create(null);function y(r,a){if(C.isWindows||!r||!a)return r;let E=d.original===a?d.normalized:void 0;return E||(E=`${(0,R.rtrim)(a,S.posix.sep)}${S.posix.sep}`,d={original:a,normalized:E}),(C.isLinux?r.startsWith(E):(0,R.startsWithIgnoreCase)(r,E))&&(r=`~/${r.substr(E.length)}`),r}t.tildify=y;function c(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=c;const u="\u2026",v="\\\\",f="~";function p(r,a=S.sep){const E=new Array(r.length);let I=!1;for(let F=0;F<r.length;F++){let w=r[F];if(w===""){E[F]=`.${a}`;continue}if(!w){E[F]=w;continue}I=!0;let L="";w.indexOf(v)===0?(L=w.substr(0,w.indexOf(v)+v.length),w=w.substr(w.indexOf(v)+v.length)):w.indexOf(a)===0?(L=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length)):w.indexOf(f)===0&&(L=w.substr(0,w.indexOf(f)+f.length),w=w.substr(w.indexOf(f)+f.length));const M=w.split(a);for(let $=1;I&&$<=M.length;$++)for(let Q=M.length-$;I&&Q>=0;Q--){I=!1;let ie=M.slice(Q,Q+$).join(a);for(let oe=0;!I&&oe<r.length;oe++)if(oe!==F&&r[oe]&&r[oe].indexOf(ie)>-1){const Z=Q+$===M.length,K=Q>0&&r[oe].indexOf(a)>-1?a+ie:ie,J=r[oe].endsWith(K);I=!Z||J}if(!I){let oe="";(M[0].endsWith(":")||L!=="")&&(Q===1&&(Q=0,$++,ie=M[0]+a+ie),Q>0&&(oe=M[0]+a),oe=L+oe),Q>0&&(oe=oe+u+a),oe=oe+ie,Q+$<M.length&&(oe=oe+a+u),E[F]=oe}}I&&(E[F]=w)}return E}t.shorten=p;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(r,a=Object.create(null)){const E=[];let I=!1,F="";for(const w of r)if(w==="$"||I&&w==="{")F&&E.push({value:F,type:h.TEXT}),F="",I=!0;else if(w==="}"&&I){const L=a[F];if(typeof L=="string")L.length&&E.push({value:L,type:h.VARIABLE});else if(L){const M=E[E.length-1];(!M||M.type!==h.SEPARATOR)&&E.push({value:L.label,type:h.SEPARATOR})}F="",I=!1}else F+=w;return F&&!I&&E.push({value:F,type:h.TEXT}),E.filter((w,L)=>{if(w.type===h.SEPARATOR){const M=E[L-1],$=E[L+1];return[M,$].every(Q=>Q&&(Q.type===h.VARIABLE||Q.type===h.TEXT)&&Q.value.length>0)}return!0}).map(w=>w.value).join("")}t.template=o;function s(r,a){return C.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):r.replace(/&&|&/g,E=>E==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,a){return C.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):C.isWindows?r.replace(/&&|&/g,E=>E==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function n(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=n;function i(r){const a=r.indexOf("/")!==-1?S.posix:S.win32,E=a.basename(r),I=a.dirname(r);return E.length?{name:E,parentPath:I}:{name:I,parentPath:""}}t.splitName=i}),define(ee[47],te([0,1,126]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class P{constructor(C="utf8"){this.stringDecoder=new T.StringDecoder(C),this.remaining=null}write(C){const D=[],R=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(R.length<1)return D;let l=0,g,m=l;for(;m<R.length;)if(g=R.charCodeAt(m),g===13||g===10){if(D.push(R.substring(l,m)),m++,m<R.length){const b=g;g=R.charCodeAt(m),(b===13&&g===10||b===10&&g===13)&&m++}l=m}else m++;return this.remaining=l<R.length?R.substr(l):null,D}end(){return this.remaining}}t.LineDecoder=P}),define(ee[63],te([0,1,38,4,21,10]),function(_,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function D(m){const b=(0,P.dirname)(m);if(m===b)return m;const d=((0,P.basename)(m)||m).toLowerCase();try{const c=(0,C.readdirSync)(b).filter(u=>u.toLowerCase()===d);if(c.length===1){const u=D(b);if(u)return(0,P.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(d);if(u>=0){const v=D(b);if(v)return(0,P.join)(v,c[u])}}}catch(y){}return null}t.realcaseSync=D;async function R(m){try{return await C.Promises.realpath(m)}catch(b){const d=g(m);return await C.Promises.access(d,T.constants.R_OK),d}}t.realpath=R;function l(m){try{return T.realpathSync(m)}catch(b){const d=g(m);return T.accessSync(d,T.constants.R_OK),d}}t.realpathSync=l;function g(m){return(0,S.rtrim)((0,P.normalize)(m),P.sep)}}),define(ee[64],te([0,1,33,4,10]),function(_,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,D=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var l;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(l||(l={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class b{constructor(s,e,n){this.exePath=s,this.displayName=e,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:o=!1}={}){return o?g===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=d({useAlternateBitness:o});if(!e)return null;const n=P.join(e,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(n))return null;let i=-1,r=null;for(const I of await S.Promises.readdir(n)){let F=-1;if(s){const L=I.indexOf("-");if(L<0)continue;const M=I.substring(0,L);if(!C.test(M)||I.substring(L+1)!=="preview")continue;F=parseInt(M,10)}else{if(!C.test(I))continue;F=parseInt(I,10)}if(F<=i)continue;const w=P.join(n,I,"pwsh.exe");!await S.SymlinkSupport.existsFile(w)||(r=w,i=F)}if(!r)return null;const a=e.includes("x86")?" (x86)":"",E=s?" Preview":"";return new b(r,`PowerShell${E}${a}`,!0)}async function c({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:n}=o?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await S.Promises.readdir(s))if(e.test(i)){const r=P.join(s,i,"pwsh.exe");return new b(r,n)}return null}function u(){const o=P.join(T.homedir(),".dotnet","tools","pwsh.exe");return new b(o,".NET Core PowerShell Global Tool")}function v(){const o=P.join(process.env.windir,g===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(o,"Windows PowerShell",!0)}async function*f(){let o=await y();o&&(yield o),o=await y({useAlternateBitness:!0}),o&&(yield o),o=await c(),o&&(yield o),o=u(),o&&(yield o),o=await y({findPreview:!0}),o&&(yield o),o=await c({findPreview:!0}),o&&(yield o),o=await y({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=v(),o&&(yield o)}async function*p(){for await(const o of f())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=p;async function h(){for await(const o of p())return o;return null}t.getFirstAvailablePowerShellInstallation=h}),define(ee[65],te([0,1,38,32,2,127,4,8,10]),function(_,t,T,P,S,C,D,R,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function g(d,y,c){return b({path:d,isDirectory:!1},y,c)}t.watchFile=g;function m(d,y,c){return b({path:d,isDirectory:!0},y,c)}t.watchFolder=m,t.CHANGE_BUFFER_DELAY=100;function b(d,y,c){if(R.isMacintosh&&(0,P.isEqualOrParent)(d.path,"/Volumes/"))return c(`Refusing to watch ${d.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.Disposable.None;const u=(0,D.basename)(d.path),v=new Map;let f=!1,p=[(0,S.toDisposable)(()=>{v.forEach(h=>(0,S.dispose)(h)),v.clear()})];try{const h=(0,T.watch)(d.path);p.push((0,S.toDisposable)(()=>{h.removeAllListeners(),h.close()}));const o=new Set;d.isDirectory&&l.Promises.readdir(d.path).then(s=>s.forEach(e=>o.add(e))),h.on("error",(s,e)=>{f||c(`Failed to watch ${d.path} for changes using fs.watch() (${s}, ${e})`)}),h.on("change",(s,e)=>{if(f)return;let n="";if(e&&(n=e.toString(),R.isMacintosh&&(n=(0,C.normalizeNFC)(n))),!n||s!=="change"&&s!=="rename")return;const i=d.isDirectory?(0,D.join)(d.path,n):d.path;if(d.isDirectory)if(s==="rename"){const r=v.get(i);r&&(0,S.dispose)(r);const a=setTimeout(async()=>{v.delete(i);const E=await l.Promises.exists(i);if(f)return;let I;E?o.has(n)?I="changed":(I="added",o.add(n)):(o.delete(n),I="deleted"),y(I,i)},t.CHANGE_BUFFER_DELAY);v.set(i,(0,S.toDisposable)(()=>clearTimeout(a)))}else{let r;o.has(n)?r="changed":(r="added",o.add(n)),y(r,i)}else if(s==="rename"||n!==u){const r=setTimeout(async()=>{const a=await l.Promises.exists(i);f||(a?(y("changed",i),p=[b(d,y,c)]):y("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,S.dispose)(p),p=[(0,S.toDisposable)(()=>clearTimeout(r))]}else y("changed",i)})}catch(h){l.Promises.exists(d.path).then(o=>{o&&!f&&c(`Failed to watch ${d.path} for changes using fs.watch() (${h.toString()})`)})}return(0,S.toDisposable)(()=>{f=!0,p=(0,S.dispose)(p)})}});var fe=this&&this.__decorate||function(_,t,T,P){var S=arguments.length,C=S<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,T):P,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(_,t,T,P);else for(var R=_.length-1;R>=0;R--)(D=_[R])&&(C=(S<3?D(C):S>3?D(t,T,C):D(t,T))||C);return S>3&&C&&Object.defineProperty(t,T,C),C};define(ee[39],te([0,1,22,3,16,27,45,11,13,2,60,21,12]),function(_,t,T,P,S,C,D,R,l,g,m,b,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var y;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(y=t.RequestType||(t.RequestType={}));function c(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(u=t.ResponseType||(t.ResponseType={}));function v(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(f||(f={}));class p{constructor(O){this.buffer=O,this.pos=0}read(O){const x=this.buffer.slice(this.pos,this.pos+O);return this.pos+=x.byteLength,x}}class h{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(o||(o={}));function s(B){const O=S.VSBuffer.alloc(4);return O.writeUInt32BE(B,0),O}function e(B){return B.read(4).readUInt32BE(0)}function n(B){const O=S.VSBuffer.alloc(1);return O.writeUInt8(B,0),O}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object)},r=typeof Buffer!="undefined";function a(B,O){if(typeof O=="undefined")B.write(i.Undefined);else if(typeof O=="string"){const x=S.VSBuffer.fromString(O);B.write(i.String),B.write(s(x.byteLength)),B.write(x)}else if(r&&Buffer.isBuffer(O)){const x=S.VSBuffer.wrap(O);B.write(i.Buffer),B.write(s(x.byteLength)),B.write(x)}else if(O instanceof S.VSBuffer)B.write(i.VSBuffer),B.write(s(O.byteLength)),B.write(O);else if(Array.isArray(O)){B.write(i.Array),B.write(s(O.length));for(const x of O)a(B,x)}else{const x=S.VSBuffer.fromString(JSON.stringify(O));B.write(i.Object),B.write(s(x.byteLength)),B.write(x)}}function E(B){switch(B.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return B.read(e(B)).toString();case o.Buffer:return B.read(e(B)).buffer;case o.VSBuffer:return B.read(e(B));case o.Array:{const x=e(B),z=[];for(let W=0;W<x;W++)z.push(E(B));return z}case o.Object:return JSON.parse(B.read(e(B)).toString())}}class I{constructor(O,x,z=null,W=1e3){this.protocol=O,this.ctx=x,this.logger=z,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(j=>this.onRawMessage(j)),this.sendResponse({type:200})}registerChannel(O,x){this.channels.set(O,x),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const x=this.send([O.type]);this.logger&&this.logger.logOutgoing(x,0,1,v(O.type));return}case 201:case 202:case 204:case 203:{const x=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(x,O.id,1,v(O.type),O.data);return}}}send(O,x=void 0){const z=new h;return a(z,O),a(z,x),this.sendBuffer(z.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(x){return 0}}onRawMessage(O){const x=new p(O),z=E(x),W=E(x),j=z[0];switch(j){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${c(j)}: ${z[2]}.${z[3]}`,W),this.onPromise({type:j,id:z[1],channelName:z[2],name:z[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${c(j)}: ${z[2]}.${z[3]}`,W),this.onEventListen({type:j,id:z[1],channelName:z[2],name:z[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${c(j)}`),this.disposeActiveRequest({type:j,id:z[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${c(j)}`),this.disposeActiveRequest({type:j,id:z[1]})}}onPromise(O){const x=this.channels.get(O.channelName);if(!x){this.collectPendingRequest(O);return}const z=new C.CancellationTokenSource;let W;try{W=x.call(this.ctx,O.name,O.arg,z.token)}catch(A){W=Promise.reject(A)}const j=O.id;W.then(A=>{this.sendResponse({id:j,data:A,type:201}),this.activeRequests.delete(O.id)},A=>{A instanceof Error?this.sendResponse({id:j,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:j,data:A,type:203}),this.activeRequests.delete(O.id)});const k=(0,g.toDisposable)(()=>z.cancel());this.activeRequests.set(O.id,k)}onEventListen(O){const x=this.channels.get(O.channelName);if(!x){this.collectPendingRequest(O);return}const z=O.id,j=x.listen(this.ctx,O.name,O.arg)(k=>this.sendResponse({id:z,data:k,type:204}));this.activeRequests.set(O.id,j)}disposeActiveRequest(O){const x=this.activeRequests.get(O.id);x&&(x.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let x=this.pendingRequests.get(O.channelName);x||(x=[],this.pendingRequests.set(O.channelName,x));const z=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:O,timeoutTimer:z})}flushPendingRequests(O){const x=this.pendingRequests.get(O);if(x){for(const z of x)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}t.ChannelServer=I;var F;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(F=t.RequestInitiator||(t.RequestInitiator={}));class w{constructor(O,x=null){this.protocol=O,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=x}getChannel(O){const x=this;return{call(z,W,j){return x.isDisposed?Promise.reject(R.canceled()):x.requestPromise(O,z,W,j)},listen(z,W){return x.isDisposed?Promise.reject(R.canceled()):x.requestEvent(O,z,W)}}}requestPromise(O,x,z,W=C.CancellationToken.None){const j=this.lastRequestId++,A={id:j,type:100,channelName:O,name:x,arg:z};if(W.isCancellationRequested)return Promise.reject(R.canceled());let U;return new Promise((G,X)=>{if(W.isCancellationRequested)return X(R.canceled());const re=()=>{const ge=Ee=>{switch(Ee.type){case 201:this.handlers.delete(j),G(Ee.data);break;case 202:this.handlers.delete(j);const ye=new Error(Ee.data.message);ye.stack=Ee.data.stack,ye.name=Ee.data.name,X(ye);break;case 203:this.handlers.delete(j),X(Ee.data);break}};this.handlers.set(j,ge),this.sendRequest(A)};let ne=null;this.state===f.Idle?re():(ne=(0,P.createCancelablePromise)(ge=>this.whenInitialized()),ne.then(()=>{ne=null,re()}));const ue=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:j,type:101}),X(R.canceled())},de=W.onCancellationRequested(ue);U=(0,g.combinedDisposable)((0,g.toDisposable)(ue),de),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(O,x,z){const W=this.lastRequestId++,k={id:W,type:102,channelName:O,name:x,arg:z};let A=null;const U=new l.Emitter({onFirstListenerAdd:()=>{A=(0,P.createCancelablePromise)(G=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(U),this.sendRequest(k)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(U),this.sendRequest({id:W,type:103}))}}),V=G=>U.fire(G.data);return this.handlers.set(W,V),U.event}sendRequest(O){switch(O.type){case 100:case 102:{const x=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(x,O.id,0,`${c(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const x=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(x,O.id,0,c(O.type));return}}}send(O,x=void 0){const z=new h;return a(z,O),a(z,x),this.sendBuffer(z.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(x){return 0}}onBuffer(O){const x=new p(O),z=E(x),W=E(x),j=z[0];switch(j){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,v(j)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],0,v(j),W),this.onResponse({type:z[0],id:z[1],data:W})}}onResponse(O){if(O.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}const x=this.handlers.get(O.id);x&&x(O)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}fe([D.memoize],w.prototype,"onDidInitializePromise",null),t.ChannelClient=w;class L{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:x,onDidClientDisconnect:z})=>{l.Event.once(x.onMessage)(j=>{const k=new p(j),A=E(k),U=new I(x,A),V=new w(x);this.channels.forEach((X,re)=>U.registerChannel(re,X));const G={channelServer:U,channelClient:V,ctx:A};this._connections.add(G),this._onDidAddConnection.fire(G),z(()=>{U.dispose(),V.dispose(),this._connections.delete(G),this._onDidRemoveConnection.fire(G)})})})}get connections(){const O=[];return this._connections.forEach(x=>O.push(x)),O}getChannel(O,x){const z=this;return{call(W,j,k){let A;if((0,d.isFunction)(x)){let V=(0,T.getRandomElement)(z.connections.filter(x));A=V?Promise.resolve(V):l.Event.toPromise(l.Event.filter(z.onDidAddConnection,x))}else A=x.routeCall(z,W,j);const U=A.then(V=>V.channelClient.getChannel(O));return $(U).call(W,j,k)},listen(W,j){if((0,d.isFunction)(x))return z.getMulticastEvent(O,x,W,j);const k=x.routeEvent(z,W,j).then(A=>A.channelClient.getChannel(O));return $(k).listen(W,j)}}}getMulticastEvent(O,x,z,W){const j=this;let k=new g.DisposableStore;const A=new l.Emitter({onFirstListenerAdd:()=>{k=new g.DisposableStore;const U=new l.EventMultiplexer,V=new Map,G=re=>{const ue=re.channelClient.getChannel(O).listen(z,W),de=U.add(ue);V.set(re,de)},X=re=>{const ne=V.get(re);!ne||(ne.dispose(),V.delete(re))};j.connections.filter(x).forEach(G),l.Event.filter(j.onDidAddConnection,x)(G,void 0,k),j.onDidRemoveConnection(X,void 0,k),U.event(A.fire,A,k),k.add(U)},onLastListenerRemove:()=>{k.dispose()}});return A.event}registerChannel(O,x){this.channels.set(O,x),this._connections.forEach(z=>{z.channelServer.registerChannel(O,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=L;class M{constructor(O,x,z=null){const W=new h;a(W,x),O.send(W.buffer),this.channelClient=new w(O,z),this.channelServer=new I(O,x,z)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,x){this.channelServer.registerChannel(O,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=M;function $(B){return{call(O,x,z){return B.then(W=>W.call(O,x,z))},listen(O,x){const z=new l.Relay;return B.then(W=>z.input=W.listen(O,x)),z.event}}}t.getDelayedChannel=$;function Q(B){let O=!1;return{call(x,z,W){return O?B.call(x,z,W):(0,P.timeout)(0).then(()=>O=!0).then(()=>B.call(x,z,W))},listen(x,z){if(O)return B.listen(x,z);const W=new l.Relay;return(0,P.timeout)(0).then(()=>O=!0).then(()=>W.input=B.listen(x,z)),W.event}}}t.getNextTickChannel=Q;class ie{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const x of O.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await l.Event.toPromise(O.onDidAddConnection),await this.route(O)}}t.StaticRouter=ie;var oe;(function(B){function O(W,j){const k=W,A=j&&j.disableMarshalling,U=new Map;for(const V in k)z(V)&&U.set(V,l.Event.buffer(k[V],!0));return new class{listen(V,G){const X=U.get(G);if(X)return X;throw new Error(`Event not found: ${G}`)}call(V,G,X){const re=k[G];if(typeof re=="function"){if(!A&&Array.isArray(X))for(let ne=0;ne<X.length;ne++)X[ne]=(0,m.revive)(X[ne]);return re.apply(k,X)}throw new Error(`Method not found: ${G}`)}}}B.fromService=O;function x(W,j){const k=j&&j.disableMarshalling;return new Proxy({},{get(A,U){if(typeof U=="string")return j?.properties?.has(U)?j.properties.get(U):z(U)?W.listen(U):async function(...V){let G;j&&!(0,d.isUndefinedOrNull)(j.context)?G=[j.context,...V]:G=V;const X=await W.call(U,G);return k?X:(0,m.revive)(X)};throw new Error(`Property not found: ${String(U)}`)}})}B.toService=x;function z(W){return W[0]==="o"&&W[1]==="n"&&b.isUpperAsciiLetter(W.charCodeAt(2))}})(oe=t.ProxyChannel||(t.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let O=B.toString();if(O!=="[object Object]")return O}return B}function J(B){return Array.isArray(B)?B.map(K):K(B)}function Y(B,O,x,z,W,j,k){k=J(k);const A=Z[W],U=A[z%A.length];let V=[`%c[${B}]%c[${String(O).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(j)?(V=V.concat(k),V.push(")")):V.push(k),console.log.apply(console,V)}t.logWithColors=Y;class se{constructor(O,x){this._outgoingPrefix=O,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,x,z,W,j){this._totalOutgoing+=O,Y(this._outgoingPrefix,this._totalOutgoing,O,x,z,W,j)}logIncoming(O,x,z,W,j){this._totalIncoming+=O,Y(this._incomingPrefix,this._totalIncoming,O,x,z,W,j)}}t.IPCLogger=se}),define(ee[66],te([0,1,3,13,2,12]),function(_,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var D;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=t.StorageHint||(t.StorageHint={}));var R;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(R||(R={}));class l extends S.Disposable{constructor(b,d=Object.create(null)){super();this.database=b,this.options=d,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(l.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((d,y)=>this.accept(y,d)),b.deleted?.forEach(d=>this.accept(d,void 0))}accept(b,d){if(this.state===R.Closed)return;let y=!1;(0,C.isUndefinedOrNull)(d)?y=this.cache.delete(b):this.cache.get(b)!==d&&(this.cache.set(b,d),y=!0),y&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,d){const y=this.cache.get(b);return(0,C.isUndefinedOrNull)(y)?d:y}getBoolean(b,d){const y=this.get(b);return(0,C.isUndefinedOrNull)(y)?d:y==="true"}getNumber(b,d){const y=this.get(b);return(0,C.isUndefinedOrNull)(y)?d:parseInt(y,10)}async set(b,d){if(this.state===R.Closed)return;if((0,C.isUndefinedOrNull)(d))return this.delete(b);const y=String(d);if(this.cache.get(b)!==y)return this.cache.set(b,y),this.pendingInserts.set(b,y),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===R.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=l,l.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((d,y)=>this.items.set(y,d)),b.delete&&b.delete.forEach(d=>this.items.delete(d))}async close(){}}t.InMemoryStorageDatabase=g}),define(ee[67],te([5,6]),function(_,t){return _.create("vs/base/common/date",t)}),define(ee[68],te([0,1,67]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const P=60,S=P*60,C=S*24,D=C*7,R=C*30,l=C*365;function g(b,d){typeof b!="number"&&(b=b.getTime());const y=Math.round((new Date().getTime()-b)/1e3);if(y<-30)return(0,T.localize)(0,null,g(new Date().getTime()+y*1e3,!1));if(y<30)return(0,T.localize)(1,null);let c;return y<P?(c=y,d?c===1?(0,T.localize)(2,null,c):(0,T.localize)(3,null,c):c===1?(0,T.localize)(4,null,c):(0,T.localize)(5,null,c)):y<S?(c=Math.floor(y/P),d?c===1?(0,T.localize)(6,null,c):(0,T.localize)(7,null,c):c===1?(0,T.localize)(8,null,c):(0,T.localize)(9,null,c)):y<C?(c=Math.floor(y/S),d?c===1?(0,T.localize)(10,null,c):(0,T.localize)(11,null,c):c===1?(0,T.localize)(12,null,c):(0,T.localize)(13,null,c)):y<D?(c=Math.floor(y/C),d?c===1?(0,T.localize)(14,null,c):(0,T.localize)(15,null,c):c===1?(0,T.localize)(16,null,c):(0,T.localize)(17,null,c)):y<R?(c=Math.floor(y/D),d?c===1?(0,T.localize)(18,null,c):(0,T.localize)(19,null,c):c===1?(0,T.localize)(20,null,c):(0,T.localize)(21,null,c)):y<l?(c=Math.floor(y/R),d?c===1?(0,T.localize)(22,null,c):(0,T.localize)(23,null,c):c===1?(0,T.localize)(24,null,c):(0,T.localize)(25,null,c)):(c=Math.floor(y/l),d?c===1?(0,T.localize)(26,null,c):(0,T.localize)(27,null,c):c===1?(0,T.localize)(28,null,c):(0,T.localize)(29,null,c))}t.fromNow=g;function m(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=m}),define(ee[69],te([5,6]),function(_,t){return _.create("vs/base/common/errorMessage",t)}),define(ee[28],te([0,1,22,12,69]),function(_,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function C(g,m){return m&&(g.stack||g.stacktrace)?S.localize(0,null,R(g),D(g.stack)||D(g.stacktrace)):R(g)}function D(g){return Array.isArray(g)?g.join(`
`):g}function R(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?S.localize(1,null,g.message):g.message||S.localize(2,null)}function l(g=null,m=!1){if(!g)return S.localize(3,null);if(Array.isArray(g)){const b=T.coalesce(g),d=l(b[0],m);return b.length>1?S.localize(4,null,d,b.length):d}if(P.isString(g))return g;if(g.detail){const b=g.detail;if(b.error)return C(b.error,m);if(b.exception)return C(b.exception,m)}return g.stack?C(g,m):g.message?g.message:S.localize(5,null)}t.toErrorMessage=l}),define(ee[70],te([5,6]),function(_,t){return _.create("vs/base/node/processes",t)}),define(ee[48],te([0,1,34,32,9,18,4,8,29,12,47,10,70]),function(_,t,T,P,S,C,D,R,l,g,m,b,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function y(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(o,s){if(R.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const n=T.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(i=>{n.once("error",r=>{i({success:!1,error:r})}),n.once("exit",(r,a)=>{i(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?y(e.status):1})}else if(R.isLinux||R.isMacintosh)try{const e=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",_).fsPath;return new Promise(n=>{T.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(i,r,a)=>{n(i?{success:!1,error:i}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function u(o=l.env){return o.comspec||"cmd.exe"}t.getWindowsShell=u;class v{constructor(s,e,n,i){if(e!==void 0&&n!==void 0&&i!==void 0)this.cmd=s,this.args=e,this.shell=n,this.options=i;else{const r=s;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(l.env).forEach(a=>{r[a]=l.env[a]}),Object.keys(this.options.env).forEach(a=>{r[a]=this.options.env[a]}),this.options.env=r}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(D.sep);return e!==-1&&(s=s.substring(e+1)),v.WellKnowCommands[s]?s:"other"}start(s){return R.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(l.cwd()))?Promise.reject(new Error(d.localize(0,null))):this.useExec().then(e=>{let n,i;const r=new Promise((a,E)=>{n=a,i=E});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=T.exec(a,this.options,(E,I,F)=>{this.childProcess=null;const w=E;w&&w.killed?i({killed:this.terminateRequested,stdout:I.toString(),stderr:F.toString()}):this.handleExec(n,s,E,I,F)})}else{let a=null;const E=I=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(I,n,s,i);const F={terminated:this.terminateRequested};g.isNumber(I)&&(F.cmdCode=I),n(F)};if(this.shell&&R.isWindows){const I=C.deepClone(this.options);I.windowsVerbatimArguments=!0,I.detached=!1;let F=!1,w=!1;const L=[];let M=this.ensureQuotes(this.cmd);L.push(M.value),F=M.quoted,this.args&&this.args.forEach(Q=>{M=this.ensureQuotes(Q),L.push(M.value),w=w&&M.quoted});const $=["/s","/c"];F?w?$.push('"'+L.join(" ")+'"'):L.length>1?$.push('"'+L[0]+'" '+L.slice(1).join(" ")):$.push('"'+L[0]+'"'):$.push(L.join(" ")),a=T.spawn(u(),$,I)}else this.cmd&&(a=T.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(g.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",I=>{this.childProcess=null,i({terminated:this.terminateRequested,error:I})}),a.pid&&(this.childProcess.on("close",E),this.handleSpawn(a,n,s,i,!0)))}return r})}handleClose(s,e,n,i){}ensureQuotes(s){return v.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,c(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!R.isWindows)return s(!1);const e=T.spawn(u(),["/s","/c"]);e.on("error",n=>s(!0)),e.on("exit",n=>s(!1))})}}t.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class f extends v{constructor(s,e,n,i){super(s,e,n,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,n,i,r){[i,r].forEach((a,E)=>{const I=new m.LineDecoder;I.write(a).forEach(L=>{e({line:L,source:E===0?0:1})});const w=I.end();w&&e({line:w,source:E===0?0:1})}),s({terminated:this.terminateRequested,error:n})}handleSpawn(s,e,n,i,r){const a=new m.LineDecoder,E=new m.LineDecoder;s.stdout.on("data",I=>{a.write(I).forEach(w=>n({line:w,source:0}))}),s.stderr.on("data",I=>{E.write(I).forEach(w=>n({line:w,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=E}handleClose(s,e,n,i){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&n({line:a,source:1})}}t.LineProcess=f;function p(o){let s=[],e=!1;const n=function(i){if(e){s.push(i);return}(!o.send(i,a=>{if(a&&console.error(a),e=!1,s.length>0){const E=s.slice(0);s=[],E.forEach(I=>n(I))}})||R.isWindows)&&(e=!0)};return{send:n}}t.createQueuedSender=p;var h;(function(o){async function s(e,n,i){if(D.isAbsolute(e))return e;if(n===void 0&&(n=l.cwd()),D.dirname(e)!=="."||(i===void 0&&g.isString(l.env.PATH)&&(i=l.env.PATH.split(D.delimiter)),i===void 0||i.length===0))return D.join(n,e);async function a(E){if(await b.Promises.exists(E)){let I;try{I=await b.Promises.stat(E)}catch(F){F.message.startsWith("EACCES")&&(I=await b.Promises.lstat(E))}return I?!I.isDirectory():!1}return!1}for(let E of i){let I;if(D.isAbsolute(E)?I=D.join(E,e):I=D.join(n,E,e),await a(I))return I;let F=I+".com";if(await a(F)||(F=I+".exe",await a(F)))return F}return D.join(n,e)}o.findExecutable=s})(h=t.win32||(t.win32={}))}),define(ee[71],te([0,1,33,8,64,48]),function(_,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function D(y,c){return y===1?P.isWindows?b():C.getWindowsShell(c):g(y,c)}t.getSystemShell=D;function R(y,c){return y===1?P.isWindows?d(c):C.getWindowsShell(c):g(y,c)}t.getSystemShellSync=R;let l=null;function g(y,c){if(P.isLinux&&y===2||P.isMacintosh&&y===3)return"/bin/bash";if(!l){let u;if(P.isWindows)u="/bin/bash";else{if(u=c.SHELL,!u)try{u=(0,T.userInfo)().shell}catch(v){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}l=u}return l}let m=null;async function b(){return m||(m=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),m}function d(y){if(m)return m;const c=P.isWindows&&parseFloat((0,T.release)())>=10,u=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${y.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?v:C.getWindowsShell(y)}}),define(ee[49],te([0,1,34,3,16,27,59,11,13,2,18,8,48,39]),function(_,t,T,P,S,C,D,R,l,g,m,b,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class c extends y.ChannelServer{constructor(f){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch(h){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",p=>S.VSBuffer.wrap(Buffer.from(p,"base64")))},f);process.once("disconnect",()=>this.dispose())}}t.Server=c;class u{constructor(f,p){this.modulePath=f,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new P.Delayer(h),this.child=null,this._client=null}getChannel(f){const p=this;return{call(h,o,s){return p.requestPromise(f,h,o,s)},listen(h,o){return p.requestEvent(f,h,o)}}}requestPromise(f,p,h,o=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(f),e=(0,P.createCancelablePromise)(r=>s.call(p,h,r)),n=o.onCancellationRequested(()=>e.cancel()),i=(0,g.toDisposable)(()=>e.cancel());return this.activeRequests.add(i),e.finally(()=>{n.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(f,p,h){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let o;const s=new l.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(f).listen(p,h)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),b.isMacintosh&&p.env&&delete p.env.DYLD_LIBRARY_PATH,this.child=(0,T.fork)(this.modulePath,f,p);const h=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,D.isRemoteConsoleLog)(a)){(0,D.log)(a,`IPC Library: ${this.options.serverName}`);return}h.fire(S.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,d.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),n=h.event,i={send:e,onMessage:n};this._client=new y.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,E)=>{process.removeListener("exit",r),this.activeRequests.forEach(I=>(0,g.dispose)(I)),this.activeRequests.clear(),a!==0&&E!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+E),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:E})})}return this._client}getCachedChannel(f){let p=this.channels.get(f);return p||(p=this.client.getChannel(f),this.channels.set(f,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(ee[72],te([5,6]),function(_,t){return _.create("vs/base/node/zip",t)}),define(ee[73],te([5,6]),function(_,t){return _.create("vs/platform/configuration/common/configurationRegistry",t)}),define(ee[74],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(ee[75],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(ee[76],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(ee[77],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(ee[78],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(ee[79],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(ee[80],te([5,6]),function(_,t){return _.create("vs/platform/extensions/common/extensionValidator",t)}),define(ee[81],te([5,6]),function(_,t){return _.create("vs/platform/files/common/fileService",t)}),define(ee[82],te([5,6]),function(_,t){return _.create("vs/platform/files/common/io",t)}),define(ee[83],te([5,6]),function(_,t){return _.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(ee[84],te([5,6]),function(_,t){return _.create("vs/platform/request/common/request",t)}),define(ee[85],te([5,6]),function(_,t){return _.create("vs/platform/telemetry/common/telemetryService",t)}),define(ee[86],te([0,1,68,45,9,4,29,19,7]),function(_,t,T,P,S,C,D,R,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(c,u,v){this._args=c,this.paths=u,this.productService=v}get appRoot(){return(0,C.dirname)(S.FileAccess.asFileUri("",_).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(l.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=D.env.VSCODE_PORTABLE;return c?l.URI.file((0,C.join)(c,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,C.resolve)(c):(0,C.normalize)((0,C.join)(S.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,C.resolve)(c):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,C.resolve)(c);const u=D.env.VSCODE_EXTENSIONS;if(u)return u;const v=D.env.VSCODE_PORTABLE;return v?(0,C.join)(v,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(u=>/^[^:/?#]+?:\/\//.test(u)?l.URI.parse(u):l.URI.file((0,C.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?l.URI.parse(c):l.URI.file((0,C.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([P.memoize],g.prototype,"appRoot",null),fe([P.memoize],g.prototype,"userHome",null),fe([P.memoize],g.prototype,"userDataPath",null),fe([P.memoize],g.prototype,"appSettingsHome",null),fe([P.memoize],g.prototype,"tmpDir",null),fe([P.memoize],g.prototype,"userRoamingDataHome",null),fe([P.memoize],g.prototype,"settingsResource",null),fe([P.memoize],g.prototype,"userDataSyncHome",null),fe([P.memoize],g.prototype,"userDataSyncLogResource",null),fe([P.memoize],g.prototype,"sync",null),fe([P.memoize],g.prototype,"machineSettingsResource",null),fe([P.memoize],g.prototype,"globalStorageHome",null),fe([P.memoize],g.prototype,"workspaceStorageHome",null),fe([P.memoize],g.prototype,"keybindingsResource",null),fe([P.memoize],g.prototype,"keyboardLayoutResource",null),fe([P.memoize],g.prototype,"argvResource",null),fe([P.memoize],g.prototype,"snippetsHome",null),fe([P.memoize],g.prototype,"isExtensionDevelopment",null),fe([P.memoize],g.prototype,"untitledWorkspacesHome",null),fe([P.memoize],g.prototype,"installSourcePath",null),fe([P.memoize],g.prototype,"builtinExtensionsPath",null),fe([P.memoize],g.prototype,"extensionsPath",null),fe([P.memoize],g.prototype,"extensionDevelopmentLocationURI",null),fe([P.memoize],g.prototype,"extensionDevelopmentKind",null),fe([P.memoize],g.prototype,"extensionTestsLocationURI",null),fe([P.memoize],g.prototype,"debugExtensionHost",null),fe([P.memoize],g.prototype,"serviceMachineIdResource",null),fe([P.memoize],g.prototype,"telemetryLogResource",null),fe([P.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function m(y,c){return d(y["inspect-extensions"],y["inspect-brk-extensions"],5870,c,y.debugId)}t.parseExtensionHostPort=m;function b(y,c){return d(y["inspect-search"],y["inspect-brk-search"],5876,c)}t.parseSearchPort=b;function d(y,c,u,v,f){const h=Number(c||y)||(v?null:u),o=h?Boolean(!!c):!1;return{port:h,break:o,debugId:f}}}),function(){"use strict";function _(t,T,P,S){function C(R){const l=D(R),g=[l];return t.isAbsolute(l)||g.unshift(S),t.resolve(...g)}function D(R){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return t.join(g,P);const m=R["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=t.join(b,"AppData","Roaming")}break;case"darwin":g=t.join(T.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||t.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(g,P)}return{getUserDataPath:C}}if(typeof define=="function")define(ee[87],te([0,88,33,9,19,29]),function(t,T,P,S,C,D){const R=C.dirname(S.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(C.joinPath(R,"package.json").fsPath);return _(T,P,l.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),T=require("path"),P=require("os");module.exports=_(T,P,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[89],te([0,1,33,86,87]),function(_,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class C extends P.AbstractNativeEnvironmentService{constructor(R,l){super(R,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,S.getUserDataPath)(R)},l)}}t.NativeEnvironmentService=C}),define(ee[90],te([0,1,18]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function S(C,D){const R=l=>{if(typeof l!="string")return;const g=P.exec(l);if(!g)return;const m=D[g[1]]??l;return typeof m=="string"?m:typeof m.message=="string"?m.message:l};return(0,T.cloneAndChange)(C,R)}t.localizeManifest=S}),define(ee[50],te([0,1,80]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function C(d){return d=d.trim(),d==="*"||P.test(d)}t.isValidVersionStr=C;function D(d){if(!C(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=d.match(P);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}t.parseVersion=D;function R(d){if(!d)return null;let y=d.majorBase,c=d.majorMustEqual,u=d.minorBase,v=d.minorMustEqual,f=d.patchBase,p=d.patchMustEqual;d.hasCaret&&(y===0||(v=!1),p=!1);let h=0;if(d.preRelease){const o=S.exec(d.preRelease);if(o){const[,s,e,n]=o;h=Date.UTC(Number(s),Number(e)-1,Number(n))}}return{majorBase:y,majorMustEqual:c,minorBase:u,minorMustEqual:v,patchBase:f,patchMustEqual:p,isMinimum:d.hasGreaterEquals,notBefore:h}}t.normalizeVersion=R;function l(d,y,c){let u;typeof d=="string"?u=R(D(d)):u=d;let v;y instanceof Date?v=y.getTime():typeof y=="string"&&(v=new Date(y).getTime());let f;if(typeof c=="string"?f=R(D(c)):f=c,!u||!f)return!1;let p=u.majorBase,h=u.minorBase,o=u.patchBase,s=f.majorBase,e=f.minorBase,n=f.patchBase,i=f.notBefore,r=f.majorMustEqual,a=f.minorMustEqual,E=f.patchMustEqual;return f.isMinimum?p>s?!0:p<s?!1:h>e?!0:h<e||v&&v<i?!1:o>=n:(p===1&&s===0&&(!r||!a||!E)&&(s=1,e=0,n=0,r=!0,a=!1,E=!1),p<s?!1:p>s?!r:h<e?!1:h>e?!a:o<n?!1:o>n?!E:!(v&&v<i))}t.isValidVersion=l;function g(d,y,c,u){return c.isBuiltin||typeof c.main=="undefined"?!0:b(d,y,c.engines.vscode,u)}t.isValidExtensionVersion=g;function m(d,y,c){return d==="*"||b(y,c,d)}t.isEngineValid=m;function b(d,y,c,u=[]){let v=R(D(c));if(!v)return u.push(T.localize(0,null,c)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return u.push(T.localize(1,null,c)),!1}else if(!v.majorMustEqual)return u.push(T.localize(2,null,c)),!1;return l(d,y,v)?!0:(u.push(T.localize(3,null,d,c)),!1)}}),define(ee[91],te([0,1,2,9,39,49]),function(_,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends T.Disposable{constructor(l,g,m,b){super();this.folders=l,this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new C.Client(P.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(l){this.verboseLogging=l,!this.isDisposed&&this.service&&this.service.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}setFolders(l){this.folders=l,this.service&&this.service.setRoots(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(ee[92],te([0,1,2,9,39,49]),function(_,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends T.Disposable{constructor(l,g,m,b,d={}){super();this.folders=l,this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=b,this.watcherOptions=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new C.Client(P.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(l.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${l}`})}setVerboseLogging(l){this.verboseLogging=l,this.service&&this.service.setVerboseLogging(l)}setFolders(l){this.folders=l,this.service&&this.service.setRoots(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(ee[93],te([0,1,34,61,9,47]),function(_,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class D{constructor(l,g,m,b,d){this.watchedFolder=l,this.eventCallback=m,this.logCallback=b,this.verboseLogging=d,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(y=>(0,P.parse)(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${l}, excludes: ${g.join(",")}`),this.startWatcher()}startWatcher(){const l=[this.watchedFolder];this.verboseLogging&&l.push("-verbose"),this.handle=(0,T.spawn)(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",_).fsPath,l);const g=new C.LineDecoder;this.handle.stdout.on("data",m=>{const b=[];for(const d of g.write(m)){const y=d.split("|");if(y.length===2){const c=Number(y[0]),u=y[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(v=>v(u))){this.verboseLogging&&this.log(u);continue}b.push({type:D.changeTypeMap[c],path:u})}else this.log(y[1])}}b.length>0&&this.eventCallback(b)}),this.handle.on("error",m=>this.onError(m)),this.handle.stderr.on("data",m=>this.onError(m)),this.handle.on("exit",(m,b)=>this.onExit(m,b))}onError(l){this.error("process error: "+l.toString())}onExit(l,g){this.handle&&(this.error(`terminated unexpectedly (code: ${l}, signal: ${g})`),this.restartCounter<=D.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(l){this.logCallback({type:"error",message:`[File Watcher (C#)] ${l}`})}log(l){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${l}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=D,D.MAX_RESTARTS=5,D.changeTypeMap=[0,1,2]}),define(ee[94],te([0,1,4,21,93]),function(_,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class C{constructor(R,l,g,m){this.onDidFilesChange=l,this.onLogMessage=g,this.verboseLogging=m,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,P.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=C}),define(ee[51],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class T{constructor(S,C=[],D=!1){this.ctor=S,this.staticArguments=C,this.supportsDelayedInstantiation=D}}t.SyncDescriptor=T}),define(ee[95],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class T{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}t.Node=T;class P{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let D of this._nodes.values())D.outgoing.size===0&&C.push(D);return C}insertEdge(C,D){const R=this.lookupOrInsertNode(C),l=this.lookupOrInsertNode(D);R.outgoing.set(this._hashFn(D),l),l.incoming.set(this._hashFn(C),R)}removeNode(C){const D=this._hashFn(C);this._nodes.delete(D);for(let R of this._nodes.values())R.outgoing.delete(D),R.incoming.delete(D)}lookupOrInsertNode(C){const D=this._hashFn(C);let R=this._nodes.get(D);return R||(R=new T(C),this._nodes.set(D,R)),R}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[D,R]of this._nodes)C.push(`${D}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,D]of this._nodes){const R=new Set([C]),l=this._findCycle(D,R);if(l)return l}}_findCycle(C,D){for(let[R,l]of C.outgoing){if(D.has(R))return[...D,R].join(" -> ");D.add(R);const g=this._findCycle(l,D);if(g)return g;D.delete(R)}}}t.Graph=P}),define(ee[96],te([0,1,14]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,T.createDecorator)("downloadService")}),define(ee[20],te([0,1,14]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,T.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,T.refineServiceDecorator)(t.IEnvironmentService)}),define(ee[23],te([0,1,9,8,29,75,14]),function(_,t,T,P,S,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.CURRENT_TARGET_PLATFORM=t.getTargetPlatform=t.getTargetPlatformFromOS=t.toTargetPlatform=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var R;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(R=t.TargetPlatform||(t.TargetPlatform={}));function l(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=l;function g(f,p){let h;switch(f){case 1:h=3;break;case 3:h=2;break;case 2:h=1;break}return m(h,p)}t.getTargetPlatformFromOS=g;function m(f,p){switch(f){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=m,t.CURRENT_TARGET_PLATFORM=P.isWeb?"web":m(P.platform,S.arch);function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=b;var d;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(d=t.SortBy||(t.SortBy={}));var y;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(y=t.SortOrder||(t.SortOrder={}));var c;(function(f){f.Install="install",f.Uninstall="uninstall"})(c=t.StatisticType||(t.StatisticType={}));var u;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(u=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class v extends Error{constructor(p,h){super(p);this.code=h,this.name=h}}t.ExtensionManagementError=v,t.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",_).toString(!0),t.ExtensionsLabel=(0,C.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,C.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(ee[40],te([0,1,21,14]),function(_,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}t.getWorkspaceSupportTypeMessage=S;function C(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}t.isIExtensionIdentifier=C,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(D=t.ExtensionType||(t.ExtensionType={}));class R{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,d){if(typeof b=="undefined"||b===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof b=="string"||typeof d=="string"){let y=typeof b=="string"?b:b.value,c=typeof d=="string"?d:d.value;return T.equalsIgnoreCase(y,c)}return b._lower===d._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}t.ExtensionIdentifier=R;function l(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}t.isLanguagePackExtension=l;function g(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=g,t.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[24],te([0,1,21,40]),function(_,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(c,u){return c.uuid&&u.uuid?c.uuid===u.uuid:c.id===u.id?!0:(0,T.compareIgnoreCase)(c.id,u.id)===0}t.areSameExtensions=S;class C{constructor(u,v){this.version=v,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof C?S(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=C;function D(c,u){return`${c}.${u}`}t.getExtensionId=D;function R(c){return c.toLocaleLowerCase()}t.adoptToGalleryExtensionId=R;function l(c,u){return R(D(c,u))}t.getGalleryExtensionId=l;function g(c,u){const v=[],f=p=>{for(const h of v)if(h.some(o=>S(u(o),u(p))))return h;return null};for(const p of c){const h=f(p);h?h.push(p):v.push([p])}return v}t.groupByExtension=g;function m(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=m;function b(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}t.getGalleryExtensionTelemetryData=b,t.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function d(c){const u=new Set;for(const v of c)v.malicious&&u.add(v.id.id);return u}t.getMaliciousExtensionsSet=d;function y(c,u){const v=[],f=u.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const p=f.shift();if(p&&v.every(h=>!S(h.identifier,{id:p}))){const h=c.filter(o=>S(o.identifier,{id:p}));h.length===1&&(v.push(h[0]),f.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}t.getExtensionDependencies=y});var he=this&&this.__param||function(_,t){return function(T,P){t(T,P,_)}};define(ee[97],te([0,1,27,11,62,9,41,7,76,23,24,40]),function(_,t,T,P,S,C,D,R,l,g,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const d=p=>(0,l.localize)(0,null,p),y=(0,l.localize)(1,null,"ms-dotnettools.csharp");function c(p,h){return h?`${p.publisher}.${p.name}@${p.version}`:`${p.publisher}.${p.name}`}const u=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function v(p){const h=u.exec(p);return h&&h[1]?[(0,m.adoptToGalleryExtensionId)(h[1]),h[2]]:[(0,m.adoptToGalleryExtensionId)(p),void 0]}t.getIdAndVersion=v;let f=class{constructor(h,o){this.extensionManagementService=h,this.extensionGalleryService=o}get location(){}async listExtensions(h,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const n=b.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(n.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(E=>E.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),n.forEach(r=>{s.log(r)});return}this.location&&s.log((0,l.localize)(2,null,this.location)),e=e.sort((r,a)=>r.identifier.id.localeCompare(a.identifier.id));let i;for(let r of e)i!==r.identifier.id&&(i=r.identifier.id,s.log(c(r.manifest,h)))}async installExtensions(h,o,s,e,n=console){const i=[],r=[];h.length&&n.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),E=(w,L)=>{const M=a.find($=>(0,m.areSameExtensions)($.identifier,{id:w}));if(M){if(!L&&!e)return n.log((0,l.localize)(5,null,w,M.manifest.version,w)),!1;if(L&&M.manifest.version===L)return n.log((0,l.localize)(6,null,`${w}@${L}`)),!1}return!0},I=[],F=[];for(const w of h)if(w instanceof R.URI)I.push(w);else{const[L,M]=v(w);E(L,M)&&F.push({id:L,version:M,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const w of o){const[L,M]=v(w);E(L,M)&&F.push({id:L,version:M,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(I.length&&await Promise.all(I.map(async w=>{try{const L=await this.installVSIX(w,{isBuiltin:!1,isMachineScoped:s},e,n);L&&r.push(L)}catch(L){n.error(L.message||L.stack||L),i.push(w.toString())}})),F.length){const w=await this.getGalleryExtensions(F);await Promise.all(F.map(async L=>{const M=w.get(L.id.toLowerCase());if(M)try{const $=await this.installFromGallery(L,M,a,e,n);$&&r.push($)}catch($){n.error($.message||$.stack||$),i.push(L.id)}else n.error(`${d(L.version?`${L.id}@${L.version}`:L.id)}
${y}`),i.push(L.id)}))}if(i.length)throw new Error((0,l.localize)(7,null,i.join(", ")))}async installVSIX(h,o,s,e){const n=await this.extensionManagementService.getManifest(h);if(!n)throw new Error("Invalid vsix");if(await this.validateVSIX(n,s,e))try{return await this.extensionManagementService.install(h,o),e.log((0,l.localize)(8,null,(0,S.getBaseLabel)(h))),n}catch(r){if((0,P.isPromiseCanceledError)(r))return e.log((0,l.localize)(9,null,(0,S.getBaseLabel)(h))),null;throw r}return null}async getGalleryExtensions(h){const o=new Map,s=await this.extensionGalleryService.getExtensions(h,T.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:h,version:o,installOptions:s},e,n,i,r){const a=await this.extensionGalleryService.getManifest(e,T.CancellationToken.None);if(a&&!this.validateExtensionKind(a,r))return null;const E=n.find(I=>(0,m.areSameExtensions)(I.identifier,e.identifier));if(E){if(e.version===E.manifest.version)return r.log((0,l.localize)(10,null,o?`${h}@${o}`:h)),null;r.log((0,l.localize)(11,null,h,e.version))}try{return s.isBuiltin?r.log(o?(0,l.localize)(12,null,h,o):(0,l.localize)(13,null,h)):r.log(o?(0,l.localize)(14,null,h,o):(0,l.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),r.log((0,l.localize)(16,null,h,e.version)),a}catch(I){if((0,P.isPromiseCanceledError)(I))return r.log((0,l.localize)(17,null,h)),null;throw I}}validateExtensionKind(h,o){return!0}async validateVSIX(h,o,s){const e={id:(0,m.getGalleryExtensionId)(h.publisher,h.name)},i=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,m.areSameExtensions)(e,r.identifier)&&(0,D.gt)(r.manifest.version,h.version));return i&&!o?(s.log((0,l.localize)(18,null,i.identifier.id,i.manifest.version,h.version)),!1):this.validateExtensionKind(h,s)}async uninstallExtensions(h,o,s=console){const e=async i=>{if(i instanceof R.URI){const r=await this.extensionManagementService.getManifest(i);return c(r)}return i},n=[];for(const i of h){const r=await e(i),E=(await this.extensionManagementService.getInstalled()).filter(I=>(0,m.areSameExtensions)(I.identifier,{id:r}));if(!E.length)throw new Error(`${this.notInstalled(r)}
${y}`);if(E.some(I=>I.type===0)){s.log((0,l.localize)(19,null,r));return}if(!o&&E.some(I=>I.isBuiltin)){s.log((0,l.localize)(20,null,r));return}s.log((0,l.localize)(21,null,r));for(const I of E)await this.extensionManagementService.uninstall(I),n.push(I);this.location?s.log((0,l.localize)(22,null,r,this.location)):s.log((0,l.localize)(23,null,r))}}async locateExtension(h,o=console){const s=await this.extensionManagementService.getInstalled();h.forEach(e=>{s.forEach(n=>{if(n.identifier.id===e&&n.location.scheme===C.Schemas.file){o.log(n.location.fsPath);return}})})}notInstalled(h){return this.location?(0,l.localize)(24,null,h,this.location):(0,l.localize)(25,null,h)}};f=fe([he(0,g.IExtensionManagementService),he(1,g.IExtensionGalleryService)],f),t.ExtensionManagementCLIService=f}),define(ee[98],te([0,1,2,4,10,40]),function(_,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class D extends T.Disposable{constructor(l,g){super();this.environmentService=l,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(g.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(l){l.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){S.Promises.rm(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=D}),define(ee[99],te([0,1,34,88,27,28,11,8,30,71,128]),function(_,t,T,P,S,C,D,R,l,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function b(c,u,v){return u["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):R.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,m.isLaunchedFromCli)(v)&&!u["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,m.isLaunchedFromCli)(v)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=new Promise(async f=>{const p=new S.CancellationTokenSource,h=setTimeout(()=>{c.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),p.dispose(!0),f({})},1e4);try{const o=await y(c,p.token);f(o)}catch(o){(0,D.isPromiseCanceledError)(o)||c.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),f({})}finally{clearTimeout(h),p.dispose()}})),d)}t.resolveShellEnv=b;let d;async function y(c,u){const v=new Promise(async(f,p)=>{const h=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",o);const s=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",n);const i=await(0,g.getSystemShell)(R.OS,n);if(c.trace("getUnixShellEnvironment#shell",i),u.isCancellationRequested)return p(D.canceled);const r=P.basename(i);let a,E;/^pwsh(-preview)?$/.test(r)?(a=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,E=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,E=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),a);const I=(0,T.spawn)(i,[...E,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});u.onCancellationRequested(()=>(I.kill(),p(D.canceled))),I.on("error",L=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(L)),f({})});const F=[];I.stdout.on("data",L=>F.push(L));const w=[];I.stderr.on("data",L=>w.push(L)),I.on("close",(L,M)=>{const $=Buffer.concat(F).toString("utf8");c.trace("getUnixShellEnvironment#raw",$);const Q=Buffer.concat(w).toString("utf8");if(Q.trim()&&c.trace("getUnixShellEnvironment#stderr",Q),L||M)return p(new Error(`Failed to get environment (code ${L}, signal ${M})`));const ie=e.exec($),oe=ie?ie[1]:"{}";try{const Z=JSON.parse(oe);h?Z.ELECTRON_RUN_AS_NODE=h:delete Z.ELECTRON_RUN_AS_NODE,o?Z.ELECTRON_NO_ATTACH_CONSOLE=o:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",Z),f(Z)}catch(Z){c.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(Z)),p(Z)}})});try{return await v}catch(f){return c.error("getUnixShellEnvironment#error",(0,C.toErrorMessage)(f)),{}}}}),define(ee[52],te([0,1,8,7,17]),function(_,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function C(l){return l.map(g=>({type:g.type,resource:P.URI.file(g.path)}))}t.toFileChanges=C;function D(l){const g=new R;for(const m of l)g.processEvent(m);return g.normalize()}t.normalizeFileChanges=D;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const m=this.mapPathToChange.get(g.path);if(m){const b=m.type,d=g.type;b===1&&d===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(m),1)):b===2&&d===1?m.type=0:b===1&&d===0||(m.type=d)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],m=[];return this.normalized.filter(b=>b.type!==2?(g.push(b),!1):!0).sort((b,d)=>b.path.length-d.path.length).filter(b=>m.some(d=>(0,S.isParent)(b.path,d,!T.isLinux))?!1:(m.push(b.path),!0)).concat(g)}}}),define(ee[100],te([0,1,3,2,4,63,10,65,52]),function(_,t,T,P,S,C,D,R,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends P.Disposable{constructor(b,d,y,c){super();this.path=b,this.onDidFilesChange=d,this.onLogMessage=y,this.verboseLogging=c,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(R.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:d}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(d)try{y=await(0,C.realpath)(y)}catch(c){if(this.onError(c),d.dangling)return}b.isDirectory()?this._register((0,R.watchFolder)(y,(c,u)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(u))})},c=>this.onError(c))):this._register((0,R.watchFile)(y,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,l.normalizeFileChanges)(d);if(this.verboseLogging)for(const c of y)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(ee[53],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class T{constructor(...S){this._entries=new Map;for(let[C,D]of S)this.set(C,D)}set(S,C){const D=this._entries.get(S);return this._entries.set(S,C),D}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=T}),define(ee[101],te([0,1,3,11,51,95,14,53]),function(_,t,T,P,S,C,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class g extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class m{constructor(c=new R.ServiceCollection,u=!1,v){this._activeInstantiations=new Set,this._services=c,this._strict=u,this._parent=v,this._services.set(D.IInstantiationService,this)}createChild(c){return new m(c,this._strict,this)}invokeFunction(c,...u){let v=d.traceInvocation(c),f=!1;try{return c({get:(h,o)=>{if(f)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(h,v);if(!s&&o!==D.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return s}},...u)}finally{f=!0,v.stop()}}createInstance(c,...u){let v,f;return c instanceof S.SyncDescriptor?(v=d.traceCreation(c.ctor),f=this._createInstance(c.ctor,c.staticArguments.concat(u),v)):(v=d.traceCreation(c),f=this._createInstance(c,u,v)),v.stop(),f}_createInstance(c,u=[],v){let f=D._util.getServiceDependencies(c).sort((o,s)=>o.index-s.index),p=[];for(const o of f){let s=this._getOrCreateServiceInstance(o.id,v);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${o.id}.`);p.push(s)}let h=f.length>0?f[0].index:u.length;if(u.length!==h){console.warn(`[createInstance] First service dependency of ${c.name} at position ${h+1} conflicts with ${u.length} static arguments`);let o=h-u.length;o>0?u=u.concat(new Array(o)):u=u.slice(0,h)}return new c(...[...u,...p])}_setServiceInstance(c,u){if(this._services.get(c)instanceof S.SyncDescriptor)this._services.set(c,u);else if(this._parent)this._parent._setServiceInstance(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let u=this._services.get(c);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):u}_getOrCreateServiceInstance(c,u){let v=this._getServiceInstanceOrDescriptor(c);return v instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,v,u.branch(c,!0)):(u.branch(c,!1),v)}_safeCreateAndCacheServiceInstance(c,u,v){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,u,v)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,u,v){const f=new C.Graph(o=>o.id.toString());let p=0;const h=[{id:c,desc:u,_trace:v}];for(;h.length;){const o=h.pop();if(f.lookupOrInsertNode(o),p++>1e3)throw new g(f);for(let s of D._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${c} depends on ${s.id} which is NOT registered.`),e instanceof S.SyncDescriptor){const n={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};f.insertEdge(o,n),h.push(n)}}}for(;;){const o=f.roots();if(o.length===0){if(!f.isEmpty())throw new g(f);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof S.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}f.removeNode(s)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,u,v=[],f,p){if(this._services.get(c)instanceof S.SyncDescriptor)return this._createServiceInstance(u,v,f,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,u,v,f,p);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(c,u=[],v,f){if(v){const p=new T.IdleValue(()=>this._createInstance(c,u,f));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let s=p.value,e=s[o];return typeof e!="function"||(e=e.bind(s),h[o]=e),e},set(h,o,s){return p.value[o]=s,!0}})}else return this._createInstance(c,u,f)}}t.InstantiationService=m;var b;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(b||(b={}));class d{constructor(c,u){this.type=c,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return l?new d(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(c){return l?new d(0,c.name):d._None}branch(c,u){let v=new d(2,c.toString());return this._dep.push([c,u,v]),v}stop(){let c=Date.now()-this._start;d._totals+=c;let u=!1;function v(p,h){let o=[],s=new Array(p+1).join("	");for(const[e,n,i]of h._dep)if(n&&i){u=!0,o.push(`${s}CREATES -> ${e}`);let r=v(p+1,i);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(c>2||u)&&console.log(f.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(ee[54],te([0,1,14]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,T.createDecorator)("localizationsService");function P(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const C of S.translations)if(typeof C.id!="string"||typeof C.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=P}),define(ee[15],te([0,1,28,13,2,8,14]),function(_,t,T,P,S,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,D.createDecorator)("logService"),t.ILoggerService=(0,D.createDecorator)("loggerService");function R(){return new Date().toISOString()}var l;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;class g extends S.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=g;class m extends g{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,this.format([e,...n]))}debug(e,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,this.format([e,...n]))}info(e,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,this.format([e,...n]))}warn(e,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,this.format([e,...n]))}error(e,...n){if(this.checkLogLevel(l.Error))if(e instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=e.stack,this.log(l.Error,this.format(i))}else this.log(l.Error,this.format([e,...n]))}critical(e,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,this.format([e,...n]))}flush(){}format(e){let n="";for(let i=0;i<e.length;i++){let r=e[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}n+=(i>0?" ":"")+r}return n}}t.AbstractMessageLogger=m;class b extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!C.isWindows}trace(e,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...n):console.log(`[main ${R()}]`,e,...n))}debug(e,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...n):console.log(`[main ${R()}]`,e,...n))}info(e,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...n):console.log(`[main ${R()}]`,e,...n))}warn(e,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,e,...n):console.warn(`[main ${R()}]`,e,...n))}error(e,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,e,...n):console.error(`[main ${R()}]`,e,...n))}critical(e,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,e,...n):console.error(`[main ${R()}]`,e,...n))}dispose(){}flush(){}}t.ConsoleMainLogger=b;class d extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}t.ConsoleLogger=d;class y extends g{constructor(e,n=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=y;class c extends g{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const i of this.logServices)i.trace(e,...n)}debug(e,...n){for(const i of this.logServices)i.debug(e,...n)}info(e,...n){for(const i of this.logServices)i.info(e,...n)}warn(e,...n){for(const i of this.logServices)i.warn(e,...n)}error(e,...n){for(const i of this.logServices)i.error(e,...n)}critical(e,...n){for(const i of this.logServices)i.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=c;class u extends S.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}t.LogService=u;class v extends S.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(i))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let i=this.loggers.get(e.toString());return i||(i=this.doCreateLogger(e,n?.always?l.Trace:this.logLevel,n),this.loggers.set(e.toString(),i),n?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=v;class f{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}t.NullLogService=f;function p(s){if(s.verbose)return l.Trace;if(typeof s.logLevel=="string"){const e=h(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=p;function h(s){switch(s){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=h;function o(s){switch(s){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=o}),define(ee[102],te([0,1,3,11,2,8,19,41,7,30,10,20,23,24,17,15]),function(_,t,T,P,S,C,D,R,l,g,m,b,d,y,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let f=class extends S.Disposable{constructor(h,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=l.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,o){await this.cleanUpPromise;const s=this.getName(h),e=(0,D.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const n=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(h,n,o);try{await this.rename(n,e,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(n)}catch(r){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,n.path),i}}return e}async delete(h){}async rename(h,o,s){try{await m.Promises.rename(h.fsPath,o.fsPath)}catch(e){if(C.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${h} to ${o} with 'EPERM' error. Trying again...`),this.rename(h,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const o=[],s=[];for(const i of h.children){const r=this.parse(i.name);r&&s.push([r,i])}const e=(0,y.groupByExtension)(s,([i])=>i),n=[];for(const i of e)i.sort((r,a)=>R.rcompare(r[0].version,a[0].version)),o.push(...i.slice(1).map(r=>r[1].resource)),n.push(i[0][1]);n.sort((i,r)=>i.mtime-r.mtime),o.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(i=>i.resource)),await T.Promises.settled(o.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?new y.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase():(0,g.generateUuid)()}parse(h){const o=v.exec(h);return o&&o[1]&&o[2]?new y.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};f=fe([he(0,b.INativeEnvironmentService),he(1,c.IFileService),he(2,d.IExtensionGalleryService),he(3,u.ILogService)],f),t.ExtensionsDownloader=f}),define(ee[103],te([0,1,34,3,28,13,2,9,4,10,20,15]),function(_,t,T,P,S,C,D,R,l,g,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let d=class extends D.Disposable{constructor(c,u){super();this.environmentService=c,this.logService=u,this.processesLimiter=new P.Limiter(5)}async postUninstall(c){const u=this.parseScript(c,"uninstall");return u&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(u.script,"uninstall",u.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${v}`)))),g.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(c,u){const v=`vscode:${u}`;if(c.location.scheme===R.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[v]=="string"){const f=c.manifest.scripts[v].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${v} should be a node script`),null):{script:(0,l.join)(c.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(c,u,v,f,p){return new Promise((h,o)=>{const s=this.start(c,u,v,p);let e;const n=i=>{e&&(clearTimeout(e),e=null),i?o(i):h(void 0)};s.on("error",i=>{n((0,S.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,r)=>{n(i?`post-${u} process exited with code ${i}`:void 0)}),f&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(c,u,v,f){const p={silent:!0,execArgv:void 0},h=(0,T.fork)(c,[`--type=extension-post-${u}`,...v],p);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const o=C.Event.fromNodeEventEmitter(h.stdout,"data"),s=C.Event.fromNodeEventEmitter(h.stderr,"data");o(i=>this.logService.info(f.identifier.id,f.manifest.version,`post-${u}`,i)),s(i=>this.logService.error(f.identifier.id,f.manifest.version,`post-${u}`,i));const e=C.Event.any(C.Event.map(o,i=>({data:`%c${i}`,format:[""]})),C.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return C.Event.debounce(e,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),h}getExtensionStoragePath(c){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};d=fe([he(0,m.IEnvironmentService),he(1,b.ILogService)],d),t.ExtensionsLifecycle=d}),define(ee[104],te([0,1,13,2,19,7,20,24,17,15]),function(_,t,T,P,S,C,D,R,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let m=class extends P.Disposable{constructor(d,y,c,u){super();this.extensionsManagementService=d,this.logService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(p=>{this.installedExtensions=p.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(p=>this.onInstallExtension(p))),this._register(d.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(d.onDidUninstallExtension(p=>this.onDidUninstallExtension(p)));const v=C.URI.file(c.extensionsPath),f=new S.ExtUri(p=>!y.hasCapability(p,1024));this._register(y.watch(v)),this._register(T.Event.filter(y.onDidChangeFilesRaw,p=>p.changes.some(h=>this.doesChangeAffects(h,v,f)))(()=>this.onDidChange()))}doesChangeAffects(d,y,c){return c.isEqual(c.dirname(d.resource),y)?c.isEqual(d.resource,c.joinPath(y,".obsolete"))?!0:!(d.type!==1&&d.type!==2||c.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const y of d)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(y=>!(0,R.areSameExtensions)(y,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,R.areSameExtensions)(y,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),y=d.filter(u=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,R.areSameExtensions)(v,u.identifier))?!1:u.installedTimestamp&&u.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",u.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",u.identifier.id),!1)),c=this.installedExtensions.filter(u=>this.installingExtensions.some(v=>(0,R.areSameExtensions)(v,u))?!1:d.every(v=>!(0,R.areSameExtensions)(v.identifier,u))?(this.logService.info("Detected extension removed from another source",u.id),!0):!1);this.installedExtensions=d.map(u=>u.identifier),(y.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:c})}}};m=fe([he(1,l.IFileService),he(2,D.INativeEnvironmentService),he(3,g.ILogService)],m),t.ExtensionsWatcher=m}),define(ee[105],te([0,1,129,22,3,2,9,4,10,20,23,24,54,15]),function(_,t,T,P,S,C,D,R,l,g,m,b,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let c=class extends C.Disposable{constructor(f,p,h){super();this.extensionManagementService=f,this.logService=h,this.cache=this._register(new u(p,h)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const f=await this.cache.getLanguagePacks(),p=["en",...Object.keys(f)];return(0,P.distinct)(p)}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const p=await this.cache.getLanguagePacks();Object.keys(p).some(h=>p[h]&&p[h].extensions.some(o=>(0,b.areSameExtensions)(o.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(p);return!(0,P.equals)(Object.keys(f),Object.keys(h))}};c=fe([he(0,m.IExtensionManagementService),he(1,g.INativeEnvironmentService),he(2,y.ILogService)],c),t.LocalizationsService=c;let u=class extends C.Disposable{constructor(f,p){super();this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(p=>{Object.keys(p).forEach(h=>delete p[h]),this.createLanguagePacksFromExtensions(p,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...p){for(const h of p)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,h);Object.keys(f).forEach(h=>this.updateHash(f[h]))}createLanguagePacksFromExtension(f,p){const h=p.identifier,o=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const s of o)if(p.location.scheme===D.Schemas.file&&(0,d.isValidLocalization)(s)){let e=f[s.languageId];e||(e={hash:"",extensions:[],translations:{}},f[s.languageId]=e);let n=e.extensions.filter(i=>(0,b.areSameExtensions)(i.extensionIdentifier,h))[0];n?n.version=p.manifest.version:e.extensions.push({extensionIdentifier:h,version:p.manifest.version});for(const i of s.translations)e.translations[i.id]=(0,R.join)(p.location.fsPath,i.path)}}updateHash(f){if(f){const p=(0,T.createHash)("md5");for(const h of f.extensions)p.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);f.hash=p.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch(o){return{}}}).then(h=>(p=f(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.languagePacks=h,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),l.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>p,h=>this.logService.error(h))})}};u=fe([he(0,g.INativeEnvironmentService),he(1,y.ILogService)],u)}),define(ee[106],te([0,1,17,15]),function(_,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function S(l,g,m,b){try{const d=await new Promise((y,c)=>{_(["spdlog"],y,c)});return d.setFlushOn(P.LogLevel.Trace),d.createAsyncRotatingLogger(l,g,m,b)}catch(d){console.error(d)}return null}function C(l,g,m,b){const d=_.__$__nodeRequire("spdlog");return d.setFlushOn(P.LogLevel.Trace),d.createRotatingLogger(l,g,m,b)}t.createRotatingLogger=C;function D(l,g,m){switch(g){case P.LogLevel.Trace:l.trace(m);break;case P.LogLevel.Debug:l.debug(m);break;case P.LogLevel.Info:l.info(m);break;case P.LogLevel.Warning:l.warn(m);break;case P.LogLevel.Error:l.error(m);break;case P.LogLevel.Critical:l.critical(m);break;default:throw new Error("Invalid log level")}}class R extends P.AbstractMessageLogger{constructor(g,m,b,d){super();this.name=g,this.filepath=m,this.rotating=b,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const g=this.rotating?6:1,m=30/g*T.ByteSize.MB;return S(this.name,this.filepath,m,g).then(b=>{if(b){this._logger=b,this._logger.setLevel(this.getLevel());for(const{level:d,message:y}of this.buffer)D(this._logger,d,y);this.buffer=[]}})}log(g,m){this._logger?D(this._logger,g,m):this.getLevel()<=g&&this.buffer.push({level:g,message:m})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=R}),define(ee[55],te([0,1,16,11,82,17,35]),function(_,t,T,P,S,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function R(b,d,y,c,u,v){let f;try{await l(b,d,y,c,u,v)}catch(p){f=p}finally{f&&u.errorTransformer&&(f=u.errorTransformer(f)),typeof f!="undefined"&&y.error(f),y.end()}}t.readFileIntoStream=R;async function l(b,d,y,c,u,v){g(v);const f=await b.open(d,{create:!1});try{g(v);let p=0,h=0,o=u&&typeof u.length=="number"?u.length:void 0,s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),e=u&&typeof u.position=="number"?u.position:0,n=0;do h=await b.read(f,e,s.buffer,n,s.byteLength-n),e+=h,n+=h,p+=h,typeof o=="number"&&(o-=h),n===s.byteLength&&(await y.write(c(s)),s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),n=0);while(h>0&&(typeof o!="number"||o>0)&&g(v)&&m(p,u));if(n>0){let i=n;typeof o=="number"&&(i=Math.min(n,o)),y.write(c(s.slice(0,i)))}}catch(p){throw(0,C.ensureFileSystemProviderError)(p)}finally{await b.close(f)}}function g(b){if(b.isCancellationRequested)throw(0,P.canceled)();return!0}function m(b,d){if(d?.limits){if(typeof d.limits.memory=="number"&&b>d.limits.memory)throw(0,C.createFileSystemProviderError)((0,S.localize)(0,null,D.default.nameShort),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&b>d.limits.size)throw(0,C.createFileSystemProviderError)((0,S.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[107],te([0,1,22,3,16,27,13,130,2,46,9,131,19,37,81,17,55,15]),function(_,t,T,P,S,C,D,R,l,g,m,b,d,y,c,u,v,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let p=class Ne extends l.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new D.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new u.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new u.FileChangesEvent(s,!0)))),this.watchedResources=g.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new l.DisposableStore;return e.add(s.onDidChangeFile(n=>this.onDidChangeFile(n,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,l.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await P.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return R.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,d.isAbsolutePath)(o))throw new u.FileOperationError((0,c.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,c.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s)||(0,u.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,u.toFileSystemProviderErrorCode)(e)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,c.localize)(2,null,this.resourceForError(o)),1):(0,u.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),n=this.isPathCaseSensitive(e),i=s?.resolveTo,r=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,E=await e.stat(o);let I;return this.toFileStat(e,o,E,void 0,!!a,(F,w)=>{if(!I&&(I=g.TernarySearchTree.forUris(()=>!n),I.set(o,!0),i))for(const L of i)I.set(L,!0);return I.get(F.resource)||I.findSuperstr(F.resource.with({query:null,fragment:null}))?!0:F.isDirectory&&r?w===1:!1})}async toFileStat(o,s,e,n,i,r){const{providerExtUri:a}=this.getExtUri(o),E={resource:s,name:a.basename(s),isFile:(e.type&u.FileType.File)!=0,isDirectory:(e.type&u.FileType.Directory)!=0,isSymbolicLink:(e.type&u.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&u.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,u.etag)({mtime:e.mtime,size:e.size})};if(E.isDirectory&&r(E,n)){try{const I=await o.readdir(s),F=await P.Promises.settled(I.map(async([w,L])=>{try{const M=a.joinPath(s,w),$=i?await o.stat(M):{type:L};return await this.toFileStat(o,M,$,I.length,i,r)}catch(M){return this.logService.trace(M),null}}));E.children=(0,T.coalesce)(F)}catch(I){this.logService.trace(I),E.children=[]}return E}return E}async resolveAll(o){return P.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new u.FileOperationError((0,c.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=S.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const n=await this.writeFile(o,s);return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,n)),n}async writeFile(o,s,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,o,e)||await this.mkdirp(n,i.dirname(o));let a;if((0,u.hasReadWriteCapability)(n)&&!(s instanceof S.VSBuffer))if((0,y.isReadableStream)(s)){const E=await(0,y.peekStream)(s,3);E.ended?a=S.VSBuffer.concat(E.buffer):a=E}else a=(0,y.peekReadable)(s,E=>S.VSBuffer.concat(E),3);else a=s;!(0,u.hasOpenReadWriteCloseCapability)(n)||(0,u.hasReadWriteCapability)(n)&&a instanceof S.VSBuffer?await this.doWriteUnbuffered(n,o,e,a):await this.doWriteBuffered(n,o,e,a instanceof S.VSBuffer?(0,S.bufferToReadable)(a):a)}catch(r){throw new u.FileOperationError((0,c.localize)(4,null,this.resourceForError(o),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,c.localize)(5,null,this.resourceForError(s)));let i;try{i=await o.stat(s)}catch(r){return}if((i.type&u.FileType.Directory)!=0)throw new u.FileOperationError((0,c.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,i),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==u.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&e.mtime<i.mtime&&e.etag!==(0,u.etag)({mtime:e.mtime,size:i.size}))throw new u.FileOperationError((0,c.localize)(7,null),3,e);return i}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((n,i)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);n(r)}catch(r){i(r)}})})}async doReadFile(o,s,e){const n=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...n,value:await(0,S.streamToBuffer)(n.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const n=new C.CancellationTokenSource,i=this.validateReadFile(s,e).then(a=>a,a=>{throw n.cancel(),a});let r;try{return typeof e?.etag=="string"&&e.etag!==u.ETAG_DISABLED&&await i,!((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasFileReadStreamCapability)(o))||(0,u.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,u.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,n.token,e):r=this.readFileBuffered(o,s,n.token,e),{...await i,value:r}}catch(a){r&&await(0,y.consumeStream)(r);const E=(0,c.localize)(8,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(a).toString());throw a instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(E,a.stat,e):new u.FileOperationError(E,(0,u.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,n=Object.create(null)){const i=o.readFileStream(s,n,e);return(0,y.transform)(i,{data:r=>r instanceof S.VSBuffer?r:S.VSBuffer.wrap(r),error:r=>new u.FileOperationError((0,c.localize)(9,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),n)},r=>S.VSBuffer.concat(r))}readFileBuffered(o,s,e,n=Object.create(null)){const i=(0,S.newWriteableBufferStream)();return(0,v.readFileIntoStream)(o,s,i,r=>r,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new u.FileOperationError((0,c.localize)(10,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),n)},e),i}readFileUnbuffered(o,s,e){const n=(0,y.newWriteableStream)(i=>S.VSBuffer.concat(i));return(async()=>{try{let i=await o.readFile(s);typeof e?.position=="number"&&(i=i.slice(e.position)),typeof e?.length=="number"&&(i=i.slice(0,e.length)),this.validateReadFileLimits(s,i.byteLength,e),n.end(S.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new u.FileOperationError((0,c.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==u.ETAG_DISABLED&&s.etag===e.etag)throw new u.NotModifiedSinceFileOperationError((0,c.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let n;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(n=9),typeof e.limits.size=="number"&&s>e.limits.size&&(n=7),typeof n=="number")throw new u.FileOperationError((0,c.localize)(13,null,this.resourceForError(o)),n)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,n){if(o.toString()!==s.toString())try{const i=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,o,r,s,e,n)}catch(i){return i}return!0}async move(o,s,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(n,o,i,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,s,e){const n=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(n,o,i,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,n,i,r){if(s.toString()===n.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(o,s,e,n,i,r);if(a&&!E&&r&&await this.del(n,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(n)),i==="copy"){if(o===e&&(0,u.hasFileFolderCopyCapability)(o))await o.copy(s,n,{overwrite:r});else{const I=await this.resolve(s);I.isDirectory?await this.doCopyFolder(o,I,e,n):await this.doCopyFile(o,s,e,n)}return i}else return o===e?(await o.rename(s,n,{overwrite:r}),i):(await this.doMoveCopy(o,s,e,n,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,n){if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,n);if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,n);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,n);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,n)}async doCopyFolder(o,s,e,n){await e.mkdir(n),Array.isArray(s.children)&&await P.Promises.settled(s.children.map(async i=>{const r=this.getExtUri(e).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),e,r):this.doCopyFile(o,i.resource,e,r)}))}async doValidateMoveCopy(o,s,e,n,i,r){let a=!1;if(o===e){const{providerExtUri:I,isPathCaseSensitive:F}=this.getExtUri(o);if(F||(a=I.isEqual(s,n)),a&&i==="copy")throw new Error((0,c.localize)(14,null,this.resourceForError(s),this.resourceForError(n)));if(!a&&I.isEqualOrParent(n,s))throw new Error((0,c.localize)(15,null,this.resourceForError(s),this.resourceForError(n)))}const E=await this.exists(n);if(E&&!a){if(!r)throw new u.FileOperationError((0,c.localize)(16,null,this.resourceForError(s),this.resourceForError(n)),4);if(o===e){const{providerExtUri:I}=this.getExtUri(o);if(I.isEqualOrParent(s,n))throw new Error((0,c.localize)(17,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:E,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(s,n.dirname(s));)try{if(((await o.stat(s)).type&u.FileType.Directory)==0)throw new Error((0,c.localize)(18,null,this.resourceForError(s)));break}catch(i){if((0,u.toFileSystemProviderErrorCode)(i)!==u.FileSystemProviderErrorCode.FileNotFound)throw i;e.push(n.basename(s)),s=n.dirname(s)}for(let i=e.length-1;i>=0;i--){s=n.joinPath(s,e[i]);try{await o.mkdir(s)}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,c.localize)(19,null,this.resourceForError(o)));let i;try{i=await e.stat(o)}catch(a){}if(i)this.throwIfFileIsReadonly(o,i);else throw new u.FileOperationError((0,c.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,c.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),n=!!s?.useTrash,i=!!s?.recursive;await e.delete(o,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new u.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,n;{for(const i of o)this.watchedResources.has(i.resource)?(e||(e=[]),e.push(i)):(n||(n=[]),n.push(i));e&&this._onDidFilesChange.fire(new u.FileChangesEvent(e,!s))}if(n){const i=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(n)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${n[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new l.DisposableStore;{let n=!1,i=()=>{n=!0};e.add((0,l.toDisposable)(()=>i())),this.doWatch(o,s).then(r=>{n?(0,l.dispose)(r):i=()=>(0,l.dispose)(r)},r=>this.logService.error(r))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,l.toDisposable)(()=>{const n=this.watchedResources.get(o);typeof n=="number"&&(n<=1?this.watchedResources.delete(o):this.watchedResources.set(o,n-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),n=this.toWatchKey(e,o,s),i=this.activeWatchers.get(n)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,i),i.count+=1,(0,l.toDisposable)(()=>{i.count--,i.count===0&&((0,l.dispose)(i.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,s,e){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const i=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,y.isReadableStream)(n)||(0,y.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,i,n):await this.doWriteReadableBufferedQueued(o,i,n)}catch(r){throw(0,u.ensureFileSystemProviderError)(r)}finally{await o.close(i)}})}async doWriteStreamBufferedQueued(o,s,e){let n=0,i;if((0,y.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=S.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,n,0),n+=r.byteLength}if(e.ended)return;i=e.stream}else i=e;return new Promise(async(r,a)=>{(0,y.listenStream)(i,{onData:async E=>{i.pause();try{await this.doWriteBuffer(o,s,E,E.byteLength,n,0)}catch(I){return a(I)}n+=E.byteLength,setTimeout(()=>i.resume())},onError:E=>a(E),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let n=0,i;for(;(i=e.read())!==null;)await this.doWriteBuffer(o,s,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(o,s,e,n,i,r){let a=0;for(;a<n;)a+=await o.write(s,i+a,e.buffer,r+a,n-a)}async doWriteUnbuffered(o,s,e,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,n))}async doWriteUnbufferedQueued(o,s,e,n){let i;n instanceof S.VSBuffer?i=n:(0,y.isReadableStream)(n)?i=await(0,S.streamToBuffer)(n):(0,y.isReadableBufferedStream)(n)?i=await(0,S.bufferedStreamToBuffer)(n):i=(0,S.readableToBuffer)(n),await o.writeFile(s,i.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,n))}async doPipeBufferedQueued(o,s,e,n){let i,r;try{i=await o.open(s,{create:!1}),r=await e.open(n,{create:!0,unlock:!1});const a=S.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,I=0,F=0;do F=await o.read(i,E,a.buffer,I,a.byteLength-I),await this.doWriteBuffer(e,r,a,F,E,I),E+=F,I+=F,I===a.byteLength&&(I=0);while(F>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await P.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,n))}async doPipeUnbufferedQueued(o,s,e,n){return e.writeFile(n,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,n))}async doPipeUnbufferedToBufferedQueued(o,s,e,n){const i=await e.open(n,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,i,S.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,u.ensureFileSystemProviderError)(r)}finally{await e.close(i)}}async doPipeBufferedToUnbuffered(o,s,e,n){const i=await(0,S.streamToBuffer)(this.readFileBuffered(o,s,C.CancellationToken.None));await this.doWriteUnbuffered(e,n,void 0,i)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new u.FileOperationError((0,c.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,c.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===m.Schemas.file?o.fsPath:o.toString(!0)}};p.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},p=fe([he(0,f.ILogService)],p),t.FileService=p}),define(ee[108],te([0,1,22,3,16,13,32,2,4,8,19,37,10,83,17,55,100,91,92,52,94,15]),function(_,t,T,P,S,C,D,R,l,g,m,b,d,y,c,u,v,f,p,h,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends R.Disposable{constructor(i,r){super();this.logService=i,this.options=r,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=C.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new C.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:a}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,a),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(i){try{const r=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),a=[];return await Promise.all(r.map(async E=>{try{let I;E.isSymbolicLink()?I=(await this.stat((0,m.joinPath)(i,E.name))).type:I=this.toType(E),a.push([E.name,I])}catch(I){this.logService.trace(I)}})),a}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let a;return r?.dangling?a=c.FileType.Unknown:i.isFile()?a=c.FileType.File:i.isDirectory()?a=c.FileType.Directory:a=c.FileType.Unknown,r&&(a|=c.FileType.SymbolicLink),a}async readFile(i){try{const r=this.toFilePath(i);return await d.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(i,r,a){const E=(0,b.newWriteableStream)(I=>S.VSBuffer.concat(I.map(F=>S.VSBuffer.wrap(F))).buffer);return(0,u.readFileIntoStream)(this,i,E,I=>I.buffer,{...r,bufferSize:this.BUFFER_SIZE},a),E}async writeFile(i,r,a){let E;try{const I=this.toFilePath(i);if(!a.create||!a.overwrite){if(await d.Promises.exists(I)){if(!a.overwrite)throw(0,c.createFileSystemProviderError)((0,y.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,c.createFileSystemProviderError)((0,y.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(i,{create:!0,unlock:a.unlock}),await this.write(E,0,r,0,r.byteLength)}catch(I){throw await this.toFileSystemProviderWriteError(i,I)}finally{typeof E=="number"&&await this.close(E)}}async open(i,r){try{const a=this.toFilePath(i);if((0,c.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:F}=await d.SymlinkSupport.stat(a);F.mode&128||await d.Promises.chmod(a,F.mode|128)}catch(F){this.logService.trace(F)}let E;if((0,c.isFileOpenForWriteOptions)(r)){if(g.isWindows)try{await d.Promises.truncate(a,0),E="r+"}catch(F){F.code!=="ENOENT"&&this.logService.trace(F)}E||(E="w")}else E="r";const I=await d.Promises.open(a,E);return this.mapHandleToPos.set(I,0),(0,c.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(I,i),I}catch(a){throw(0,c.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,a):this.toFileSystemProviderError(a)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(r){this.canFlush=!1,this.logService.error(r)}return await d.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}}async read(i,r,a,E,I){const F=this.normalizePos(i,r);let w=null;try{const L=await d.Promises.read(i,a,E,I,F);return typeof L=="number"?w=L:w=L.bytesRead,w}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(i,F,w)}}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,a){const E=this.mapHandleToPos.get(i);typeof E=="number"&&(typeof r=="number"||(typeof a=="number"?this.mapHandleToPos.set(i,E+a):this.mapHandleToPos.delete(i)))}async write(i,r,a,E,I){return(0,P.retry)(()=>this.doWrite(i,r,a,E,I),100,3)}async doWrite(i,r,a,E,I){const F=this.normalizePos(i,r);let w=null;try{const L=await d.Promises.write(i,a,E,I,F);return typeof L=="number"?w=L:w=L.bytesWritten,w}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),L)}finally{this.updatePos(i,F,w)}}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const a=this.toFilePath(i);await this.doDelete(a,r)}catch(a){throw this.toFileSystemProviderError(a)}}async doDelete(i,r){r.recursive?await d.Promises.rm(i,d.RimRafMode.MOVE):await d.Promises.unlink(i)}async rename(i,r,a){const E=this.toFilePath(i),I=this.toFilePath(r);if(E!==I)try{await this.validateTargetDeleted(i,r,"move",a.overwrite),await d.Promises.move(E,I)}catch(F){throw(F.code==="EINVAL"||F.code==="EBUSY"||F.code==="ENAMETOOLONG")&&(F=new Error((0,y.localize)(2,null,(0,l.basename)(E),(0,l.basename)((0,l.dirname)(I)),F.toString()))),this.toFileSystemProviderError(F)}}async copy(i,r,a){const E=this.toFilePath(i),I=this.toFilePath(r);if(E!==I)try{await this.validateTargetDeleted(i,r,"copy",a.overwrite),await d.Promises.copy(E,I,{preserveSymlinks:!0})}catch(F){throw(F.code==="EINVAL"||F.code==="EBUSY"||F.code==="ENAMETOOLONG")&&(F=new Error((0,y.localize)(3,null,(0,l.basename)(E),(0,l.basename)((0,l.dirname)(I)),F.toString()))),this.toFileSystemProviderError(F)}}async validateTargetDeleted(i,r,a,E){const I=this.toFilePath(i),F=this.toFilePath(r);let w=!1;if(!!(this.capabilities&1024)||(w=(0,D.isEqual)(I,F,!0)),w&&a==="copy")throw(0,c.createFileSystemProviderError)((0,y.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!w&&await d.Promises.exists(F)){if(!E)throw(0,c.createFileSystemProviderError)((0,y.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}watch(i,r){return r.recursive?this.watchRecursive(i,r.excludes):this.watchNonRecursive(i)}watchRecursive(i,r){const a={path:this.toFilePath(i),excludes:r},E=(0,T.insert)(this.recursiveFoldersToWatch,a);return this.refreshRecursiveWatchers(),(0,R.toDisposable)(()=>{E(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof f.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,r;this.options?.watcher?.usePolling?(i=p.FileWatcher,r=this.options?.watcher):this.recursiveFoldersToWatch.length===1?g.isWindows?i=o.FileWatcher:i=p.FileWatcher:i=f.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,a=>this._onDidChangeFile.fire((0,h.toFileChanges)(a)),a=>{a.type==="error"&&this._onDidWatchErrorOccur.fire(a.message),this.logService[a.type](a.message)},this.logService.getLevel()===s.LogLevel.Trace,r),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(i){const r=new v.FileWatcher(this.toFilePath(i),E=>this._onDidChangeFile.fire((0,h.toFileChanges)(E)),E=>{E.type==="error"&&this._onDidWatchErrorOccur.fire(E.message),this.logService[E.type](E.message)},this.logService.getLevel()===s.LogLevel.Trace),a=this.logService.onDidChangeLogLevel(()=>{r.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,R.combinedDisposable)(r,a)}toFilePath(i){return(0,l.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof c.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=c.FileSystemProviderErrorCode.NoPermissions;break;default:r=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(i,r){let a=this.toFileSystemProviderError(r);if(i&&a.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:E}=await d.SymlinkSupport.stat(this.toFilePath(i));E.mode&128||(a=(0,c.createFileSystemProviderError)(r,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(E){this.logService.trace(E)}return a}dispose(){super.dispose(),(0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,R.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(ee[42],te([0,1,14]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,T.createDecorator)("productService")}),define(ee[25],te([0,1,57,12]),function(_,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(D,R){T.ok(P.isString(D)),T.ok(P.isObject(R)),T.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,R)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}t.Registry=new S}),define(ee[109],te([0,1,13,25]),function(_,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class C{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,g){this.schemasById[S(l)]=g,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new C;P.Registry.add(t.Extensions.JSONContribution,D)}),define(ee[31],te([0,1,13,12,73,109,25]),function(_,t,T,P,S,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var R;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(R=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var l;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(l=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=D.Registry.as(C.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,h=!0){this.registerConfigurations([p],h)}registerConfigurations(p,h=!0){const o=[];p.forEach(s=>{o.push(...this.validateAndRegisterProperties(s,h,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(p){const h=[],o=s=>{if(s.properties)for(const e in s.properties)h.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,s.properties[e]);s.allOf&&s.allOf.forEach(e=>o(e))};for(const s of p){o(s);const e=this.configurationContributors.indexOf(s);e!==-1&&this.configurationContributors.splice(e,1)}g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}registerDefaultConfigurations(p){const h=[],o=[];for(const s of p)for(const e in s)if(h.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...s[e]};const n={type:"object",default:this.defaultValues[e],description:S.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};o.push(d(e)),this.configurationProperties[e]=n,this.defaultLanguageConfigurationOverridesNode.properties[e]=n}else{this.defaultValues[e]=s[e];const n=this.configurationProperties[e];n&&(this.updatePropertyDefaultValue(e,n),this.updateSchema(e,n))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(p){const h=[];for(const o of p)for(const s in o)if(h.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const e=this.configurationProperties[s];e&&(this.updatePropertyDefaultValue(s,e),this.updateSchema(s,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const h of p)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,h=!0,o,s=3){s=P.isUndefinedOrNull(p.scope)?s:p.scope;let e=[],n=p.properties;if(n)for(let r in n){if(h&&u(r)){delete n[r];continue}const a=n[r];if(this.updatePropertyDefaultValue(r,a),t.OVERRIDE_PROPERTY_PATTERN.test(r)?a.scope=void 0:(a.scope=P.isUndefinedOrNull(a.scope)?s:a.scope,a.restricted=P.isUndefinedOrNull(a.restricted)?!!o?.restrictedConfigurations?.includes(r):a.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),e.push(r)}let i=p.allOf;if(i)for(let r of i)e.push(...this.validateAndRegisterProperties(r,h,o,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const h=o=>{let s=o.properties;if(s)for(const n in s)this.updateSchema(n,s[n]);let e=o.allOf;e&&e.forEach(h)};h(p)}updateSchema(p,h){switch(t.allSettings.properties[p]=h,h.scope){case 1:t.applicationSettings.properties[p]=h;break;case 2:t.machineSettings.properties[p]=h;break;case 6:t.machineOverridableSettings.properties[p]=h;break;case 3:t.windowSettings.properties[p]=h;break;case 4:t.resourceSettings.properties[p]=h;break;case 5:t.resourceSettings.properties[p]=h,this.resourceLanguageSettingsSchema.properties[p]=h;break}}removeFromSchema(p,h){switch(delete t.allSettings.properties[p],h.scope){case 1:delete t.applicationSettings.properties[p];break;case 2:delete t.machineSettings.properties[p];break;case 6:delete t.machineOverridableSettings.properties[p];break;case 3:delete t.windowSettings.properties[p];break;case 4:case 5:delete t.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const h=`[${p}]`,o={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,o),t.allSettings.properties[h]=o,t.applicationSettings.properties[h]=o,t.machineSettings.properties[h]=o,t.machineOverridableSettings.properties[h]=o,t.windowSettings.properties[h]=o,t.resourceSettings.properties[h]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,h){let o=this.defaultValues[p];P.isUndefined(o)&&(o=h.default),P.isUndefined(o)&&(o=y(h.type)),h.default=o}}const b="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(b);function d(f){return f.substring(1,f.length-1)}t.overrideIdentifierFromKey=d;function y(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=y;const c=new m;D.Registry.add(t.Extensions.Configuration,c);function u(f){return f.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(f)?S.localize(5,null,f):c.getConfigurationProperties()[f]!==void 0?S.localize(6,null,f):null:S.localize(4,null)}t.validateProperty=u;function v(){const f=[],p=c.getConfigurationProperties();for(const h of Object.keys(p))f.push([h,p[h].scope]);return f.push(["launch",4]),f.push(["task",4]),f}t.getScopes=v}),define(ee[26],te([0,1,18,12,7,31,14,25]),function(_,t,T,P,S,C,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,D.createDecorator)("configurationService");function l(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof S.URI)}t.isConfigurationOverrides=l;var g;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function m(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=m;function b(n,i){const r=i?n?i.keys.filter(M=>n.keys.indexOf(M)===-1):[...i.keys]:[],a=n?i?n.keys.filter(M=>i.keys.indexOf(M)===-1):[...n.keys]:[],E=[];if(i&&n){for(const M of n.keys)if(i.keys.indexOf(M)!==-1){const $=f(n.contents,M),Q=f(i.contents,M);T.equals($,Q)||E.push(M)}}const I=[],F=M=>{const $={};for(const Q of M)for(const ie of Q.identifiers)$[s(ie)]=Q;return $},w=i?F(i.overrides):{},L=n?F(n.overrides):{};if(Object.keys(w).length)for(const M of r){const $=w[M];$&&I.push([(0,C.overrideIdentifierFromKey)(M),$.keys])}if(Object.keys(L).length)for(const M of a){const $=L[M];$&&I.push([(0,C.overrideIdentifierFromKey)(M),$.keys])}if(Object.keys(w).length&&Object.keys(L).length)for(const M of E){const $=L[M],Q=w[M];if($&&Q){const ie=b({contents:$.contents,keys:$.keys,overrides:[]},{contents:Q.contents,keys:Q.keys,overrides:[]});I.push([(0,C.overrideIdentifierFromKey)(M),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:a,updated:E,overrides:I}}t.compare=b;function d(n,i){const r=[];for(const a of Object.keys(n))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const E={};for(const I in n[a])E[I]=n[a][I];r.push({identifiers:[(0,C.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(E),contents:y(E,i)})}return r}t.toOverrides=d;function y(n,i){const r=Object.create(null);for(let a in n)c(r,a,n[a],i);return r}t.toValuesTree=y;function c(n,i,r,a){const E=i.split("."),I=E.pop();let F=n;for(let w=0;w<E.length;w++){let L=E[w],M=F[L];switch(typeof M){case"undefined":M=F[L]=Object.create(null);break;case"object":break;default:a(`Ignoring ${i} as ${E.slice(0,w+1).join(".")} is ${JSON.stringify(M)}`);return}F=M}if(typeof F=="object"&&F!==null)try{F[I]=r}catch(w){a(`Ignoring ${i} as ${E.join(".")} is ${JSON.stringify(F)}`)}else a(`Ignoring ${i} as ${E.join(".")} is ${JSON.stringify(F)}`)}t.addToValueTree=c;function u(n,i){const r=i.split(".");v(n,r)}t.removeFromValueTree=u;function v(n,i){const r=i.shift();if(i.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const a=n[r];typeof a=="object"&&!Array.isArray(a)&&(v(a,i),Object.keys(a).length===0&&delete n[r])}}function f(n,i,r){function a(F,w){let L=F;for(const M of w){if(typeof L!="object"||L===null)return;L=L[M]}return L}const E=i.split("."),I=a(n,E);return typeof I=="undefined"?r:I}t.getConfigurationValue=f;function p(n,i,r){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in n?P.isObject(n[a])&&P.isObject(i[a])?p(n[a],i[a],r):r&&(n[a]=i[a]):n[a]=i[a])})}t.merge=p;function h(){const n=R.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}t.getConfigurationKeys=h;function o(){const n=Object.create(null),i=R.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let r in i){let a=i[r].default;c(n,r,a,E=>console.error(`Conflict in default settings: ${E}`))}return n}t.getDefaultValues=o;function s(n){return`[${n}]`}t.keyFromOverrideIdentifier=s;function e(n,i,r){const a=n.inspect(i),E=n.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:a.defaultValue}t.getMigratedSettingValue=e}),define(ee[110],te([0,1,22,13,58,2,46,18,12,7,26,31,25]),function(_,t,T,P,S,C,D,R,l,g,m,b,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class y{constructor(e={},n=[],i=[]){this._contents=e,this._keys=n,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,m.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const i=this.getContentsForOverrideIdentifer(n);return i?e?(0,m.getConfigurationValue)(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.keys;return[]}override(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let i={};for(const r of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[r],E=n[r];E&&(typeof a=="object"&&typeof E=="object"?(a=R.deepClone(a),this.mergeContents(a,E)):a=E),i[r]=a}return new y(i,this.keys,this.overrides)}merge(...e){const n=R.deepClone(this.contents),i=R.deepClone(this.overrides),r=[...this.keys];for(const a of e){this.mergeContents(n,a.contents);for(const E of a.overrides){const[I]=i.filter(F=>T.equals(F.identifiers,E.identifiers));I?this.mergeContents(I.contents,E.contents):i.push(R.deepClone(E))}for(const E of a.keys)r.indexOf(E)===-1&&r.push(E)}return new y(n,r,i)}freeze(){return this.isFrozen=!0,this}mergeContents(e,n){for(const i of Object.keys(n)){if(i in e&&l.isObject(e[i])&&l.isObject(n[i])){this.mergeContents(e[i],n[i]);continue}e[i]=R.deepClone(n[i])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?R.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,m.addToValueTree)(this.contents,e,n,i=>{throw new Error(i)})}removeValue(e){this.removeKey(e)&&(0,m.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let i=0;i<n;i++)e.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=y;class c extends y{constructor(){const e=(0,m.getDefaultValues)(),n=(0,m.getConfigurationKeys)(),i=[];for(const r of Object.keys(e))b.OVERRIDE_PROPERTY_PATTERN.test(r)&&i.push({identifiers:[(0,b.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,m.toValuesTree)(e[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,n,i)}}t.DefaultConfigurationModel=c;class u{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!l.isUndefinedOrNull(e)){const i=this.doParseContent(e);this.parseRaw(i,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:i,keys:r,overrides:a,restricted:E}=this.doParseRaw(e,n);this._configurationModel=new y(i,r,a),this._restrictedConfigurations=E||[]}doParseContent(e){let n={},i=null,r=[],a=[],E=[];function I(w){Array.isArray(r)?r.push(w):i!==null&&(r[i]=w)}let F={onObjectBegin:()=>{let w={};I(w),a.push(r),r=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let w=[];I(w),a.push(r),r=w,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:I,onError:(w,L,M)=>{E.push({error:w,offset:L,length:M})}};if(e)try{S.visit(e,F),n=r[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return n}doParseRaw(e,n){const i=d.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,i,!0,n);e=r.raw;const a=(0,m.toValuesTree)(e,F=>console.error(`Conflict in settings file ${this._name}: ${F}`)),E=Object.keys(e),I=(0,m.toOverrides)(e,F=>console.error(`Conflict in settings file ${this._name}: ${F}`));return{contents:a,keys:E,overrides:I,restricted:r.restricted}}filter(e,n,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const a={},E=[];for(let I in e)if(b.OVERRIDE_PROPERTY_PATTERN.test(I)&&i){const F=this.filter(e[I],n,!1,r);a[I]=F.raw,E.push(...F.restricted)}else{const F=n[I],w=F?typeof F.scope!="undefined"?F.scope:3:void 0;F?.restricted&&E.push(I),(w===void 0||r.scopes===void 0||r.scopes.includes(w))&&(r.skipRestricted&&F?.restricted||(a[I]=e[I]))}return{raw:a,restricted:E}}}t.ConfigurationModelParser=u;class v extends C.Disposable{constructor(e,n,i,r){super();this.userSettingsResource=e,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=v;class f{constructor(e,n,i=new y,r=new y,a=new D.ResourceMap,E=new y,I=new D.ResourceMap,F=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=E,this._memoryConfigurationByResource=I,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(e,n,i){return this.getConsolidateConfigurationModel(n,i).getValue(e)}updateValue(e,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new y,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(e):r.setValue(e,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,i){const r=this.getConsolidateConfigurationModel(n,i),a=this.getFolderConfigurationModelForResource(n.resource,i),E=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,I=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),F=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),w=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),L=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),M=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,$=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,Q=n.overrideIdentifier?E.override(n.overrideIdentifier).getValue(e):E.getValue(e),ie=r.getValue(e),oe=T.distinct(T.flatten(r.overrides.map(Z=>Z.identifiers))).filter(Z=>r.getOverrideValue(e,Z)!==void 0);return{defaultValue:I,userValue:F,userLocalValue:w,userRemoteValue:L,workspaceValue:M,workspaceFolderValue:$,memoryValue:Q,value:ie,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:F!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:L!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:a?.freeze().getValue(e),override:n.overrideIdentifier?a?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:Q!==void 0?{value:E.getValue(e),override:n.overrideIdentifier?E.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const i=n.filter(r=>b.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,b.overrideIdentifierFromKey)(r),E=this._defaultConfiguration.getKeysForOverrideIdentifier(a),I=e.getKeysForOverrideIdentifier(a),F=[...I.filter(w=>E.indexOf(w)===-1),...E.filter(w=>I.indexOf(w)===-1),...E.filter(w=>!R.equals(this._defaultConfiguration.override(a).getValue(w),e.override(a).getValue(w)))];return[a,F]});return this.updateDefaultConfiguration(e),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:i,removed:r,overrides:a}=(0,m.compare)(this.localUserConfiguration,e),E=[...n,...i,...r];return E.length&&this.updateLocalUserConfiguration(e),{keys:E,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:i,removed:r,overrides:a}=(0,m.compare)(this.remoteUserConfiguration,e);let E=[...n,...i,...r];return E.length&&this.updateRemoteUserConfiguration(e),{keys:E,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:i,removed:r,overrides:a}=(0,m.compare)(this.workspaceConfiguration,e);let E=[...n,...i,...r];return E.length&&this.updateWorkspaceConfiguration(e),{keys:E,overrides:a}}compareAndUpdateFolderConfiguration(e,n){const i=this.folderConfigurations.get(e),{added:r,updated:a,removed:E,overrides:I}=(0,m.compare)(i,n);let F=[...r,...a,...E];return(F.length||!i)&&this.updateFolderConfiguration(e,n),{keys:F,overrides:I}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:r,removed:a,overrides:E}=(0,m.compare)(n,void 0);return{keys:[...i,...r,...a],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let i=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const r=n.getFolder(e);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const a=this._memoryConfigurationByResource.get(e);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=i}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const i=n.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:i,overrides:r,keys:a}=this._folderConfigurations.get(n);return e.push([n,{contents:i,overrides:r,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>e.add(i))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((E,I)=>(E.set(g.URI.revive(I[0]),this.parseConfigurationModel(I[1])),E),new D.ResourceMap);return new f(n,i,new y,r,a,new y,new D.ResourceMap,!1)}static parseConfigurationModel(e){return new y(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=f;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,n=new Map;for(const r of s)r.keys.forEach(a=>e.add(a)),r.overrides.forEach(([a,E])=>{const I=(0,D.getOrSet)(n,a,new Set);E.forEach(F=>I.add(F))});const i=[];return n.forEach((r,a)=>i.push([a,[...r.values()]])),{keys:[...e.values()],overrides:i}}t.mergeChanges=p;class h{constructor(e,n,i,r){this.change=e,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(I=>a.add(I)),e.overrides.forEach(([,I])=>I.forEach(F=>a.add(F))),this.affectedKeys=[...a.values()];const E=new y;this.affectedKeys.forEach(I=>E.setValue(I,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!R.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let i=(0,m.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(e=e[r],!e)return!1;i=i[r]}return!0}}t.ConfigurationChangeEvent=h;class o extends h{constructor(e,n,i,r){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=i,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(ee[111],te([0,1,3,13,2,19,26,110,31,25]),function(_,t,T,P,S,C,D,R,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class m extends S.Disposable{constructor(d,y){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,y)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,y){const c=typeof d=="string"?d:void 0,u=(0,D.isConfigurationOverrides)(d)?d:(0,D.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(c,u,void 0)}updateValue(d,y,c,u){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const y=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(c,y,1)}onDidDefaultConfigurationChange(d){const y=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,d);this.trigger(c,y,6)}trigger(d,y,c){const u=new R.ConfigurationChangeEvent(d,{data:y},this.configuration);u.source=c,u.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(u)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=m}),define(ee[56],te([0,1,16,84,31,14,25]),function(_,t,T,P,S,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,C.createDecorator)("requestService");function R(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}t.isSuccess=R;function l(c){return c.res.statusCode===204}async function g(c){if(!R(c))throw new Error("Server returned "+c.res.statusCode);return l(c)?null:(await(0,T.streamToBuffer)(c.stream)).toString()}t.asText=g;async function m(c){if(!R(c))throw new Error("Server returned "+c.res.statusCode);if(l(c))return null;const v=(await(0,T.streamToBuffer)(c.stream)).toString();try{return JSON.parse(v)}catch(f){throw f.message+=`:
`+v,f}}t.asJson=m;function b(c){y(c)}t.updateProxyConfigurationsScope=b;let d;function y(c){const u=D.Registry.as(S.Extensions.Configuration);d&&u.deregisterConfigurations([d]),d={id:"http",order:15,title:(0,P.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(4,null),(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],default:"override",description:(0,P.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(9,null),restricted:!0}}},u.registerConfiguration(d)}y(2)}),define(ee[112],te([0,1,113,12]),function(_,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(D,R){return D.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:D.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function C(D,R,l={}){const g=(0,T.parse)(D),m=l.proxyUrl||S(g,R);if(!m)return null;const b=(0,T.parse)(m);if(!/^https?:$/.test(b.protocol||""))return null;const d={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,P.isBoolean)(l.strictSSL)?l.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((y,c)=>{_(["http-proxy-agent"],y,c)}))(d):new(await new Promise((y,c)=>{_(["https-proxy-agent"],y,c)}))(d)}t.getProxyAgent=C}),define(ee[114],te([0,1,16,30]),function(_,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(C,D,R){let l=R&&R.get("storage.serviceMachineId",0)||null;if(l)return l;try{const m=(await D.readFile(C.serviceMachineIdResource)).value.toString();l=(0,P.isUUID)(m)?m:null}catch(g){l=null}if(!l){l=(0,P.generateUuid)();try{await D.writeFile(C.serviceMachineIdResource,T.VSBuffer.fromString(l))}catch(g){}}return R&&R.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=S}),define(ee[115],te([0,1,3,13,2,12,66,14]),function(_,t,T,P,S,C,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const l="__$__targetStorageMarker";t.IStorageService=(0,R.createDecorator)("storageService");var g;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(g=t.WillSaveStateReason||(t.WillSaveStateReason={}));var m;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(m=t.StorageScope||(t.StorageScope={}));var b;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(b=t.StorageTarget||(t.StorageTarget={}));class d extends S.Disposable{constructor(v={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,f){f===l?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:f,target:this.getKeyTargets(v)[f]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,f,p){return this.getStorage(f)?.get(v,p)}getBoolean(v,f,p){return this.getStorage(f)?.getBoolean(v,p)}getNumber(v,f,p){return this.getStorage(f)?.getNumber(v,p)}store(v,f,p,h){if((0,C.isUndefinedOrNull)(f)){this.remove(v,p);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,p,h),this.getStorage(p)?.set(v,f)})}remove(v,f){this.withPausedEmitters(()=>{this.updateKeyTarget(v,f,void 0),this.getStorage(f)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,f){const p=[],h=this.getKeyTargets(v);for(const o of Object.keys(h))h[o]===f&&p.push(o);return p}updateKeyTarget(v,f,p){const h=this.getKeyTargets(f);typeof p=="number"?h[v]!==p&&(h[v]=p,this.getStorage(f)?.set(l,JSON.stringify(h))):typeof h[v]=="number"&&(delete h[v],this.getStorage(f)?.set(l,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const f=this.get(l,v);if(f)try{return JSON.parse(f)}catch(p){}return Object.create(null)}isNew(v){return this.getBoolean(t.IS_NEW_KEY,v)===!0}async flush(v=g.NONE){this._onWillSaveState.fire({reason:v}),await T.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const v=this.getStorage(0)?.items??new Map,f=this.getStorage(1)?.items??new Map;return c(v,f,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends d{constructor(){super();this.globalStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}t.InMemoryStorageService=y;async function c(u,v,f,p){const h=a=>{try{return JSON.parse(a)}catch(E){return a}},o=new Map,s=new Map;u.forEach((a,E)=>{o.set(E,a),s.set(E,h(a))});const e=new Map,n=new Map;v.forEach((a,E)=>{e.set(E,a),n.set(E,h(a))}),console.group(`Storage: Global (path: ${f})`);let i=[];o.forEach((a,E)=>{i.push({key:E,value:a})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${p})`);let r=[];e.forEach((a,E)=>{r.push({key:E,value:a})}),console.table(r),console.groupEnd(),console.log(n)}t.logStorage=c}),define(ee[116],te([0,1,8,29,7,30]),function(_,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function D(g){if(T.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function R(g,m,b,d,y,c,u,v,f,p){const h=Object.create(null);h["common.machineId"]=u,h.sessionID=(0,C.generateUuid)()+Date.now(),h.commitHash=y,h.version=c,h["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,T.PlatformToString)(T.platform),h["common.nodePlatform"]=P.platform,h["common.nodeArch"]=d,h["common.product"]=p||"desktop";const o=l(v||[]);o&&(h["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),T.isLinuxSnap&&(h["common.snap"]="true");const n=D(b);n&&(h["common.platformDetail"]=n);try{const i=await g.readFile(S.URI.file(f));h["common.source"]=i.value.toString().slice(0,30)}catch(i){}return h}t.resolveCommonProperties=R;function l(g){const m=P.env.USERDNSDOMAIN;if(!m)return!1;const b=m.toLowerCase();return g.some(d=>b===d)}t.verifyMicrosoftInternalDomain=l}),define(ee[36],te([0,1,14]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,T.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(ee[117],te([0,1,22,3,27,11,13,2,8,7,74,23,24,15,35,36]),function(_,t,T,P,S,C,D,R,l,g,m,b,d,y,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let v=class extends R.Disposable{constructor(s,e,n){super();this.galleryService=s,this.telemetryService=e,this.logService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(m.localize(0,null));try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(i){throw this.logService.error((0,C.getErrorMessage)(i)),p(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,i),i}if(!await this.canInstall(s)){const i=new b.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension as it is not supported.",s.identifier.id,i.message),p(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,i),i}const n=await this.galleryService.getManifest(s,S.CancellationToken.None);if(n===null){const i=new b.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,i.message),p(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,i),i}if(n.version!==s.version){const i=new b.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(i.message),p(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,i),i}return this.installExtension(n,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(m.localize(1,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(m.localize(2,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,n){if(!g.URI.isUri(e)){let I=this.installingExtensions.get(new d.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(I)return this.logService.info("Extensions is already requested to install",e.identifier.id),I.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],r=[],a=this.createInstallExtensionTask(s,e,n);g.URI.isUri(e)||this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),i.push({task:a,manifest:s});let E=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const F=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!n.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:w,manifest:L}of F)if(E=E||!!L.extensionDependencies?.some(M=>(0,d.areSameExtensions)({id:M},a.identifier)),this.installingExtensions.has(new d.ExtensionIdentifierWithVersion(w.identifier,w.version).key()))this.logService.info("Extension is already requested to install",w.identifier.id);else{const M=this.createInstallExtensionTask(L,w,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(M.identifier,L.version).key(),M),this._onInstallExtension.fire({identifier:M.identifier,source:w}),this.logService.info("Installing extension:",M.identifier.id),i.push({task:M,manifest:L})}}catch(F){if(g.URI.isUri(a.source))(0,T.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,F.message),(0,T.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,F.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(F),F}const I=i.reduce((F,{task:w,manifest:L})=>(F.set(w.identifier.id.toLowerCase(),{task:w,manifest:L}),F),new Map);for(;I.size;){let F;const w=[...I.values()].filter(({manifest:L})=>!L.extensionDependencies?.some(M=>I.has(M.toLowerCase())));w.length?F=I.size===1?w:w.filter(({task:L})=>!(L===a&&!E)):(this.logService.info("Found extensions with circular dependencies",w.map(({task:L})=>L.identifier.id)),F=[...I.values()]),await this.joinAllSettled(F.map(async({task:L})=>{const M=new Date().getTime();try{const $=await L.run();if(await this.joinAllSettled(this.participants.map(Q=>Q.postInstall($,L.source,n,S.CancellationToken.None))),!g.URI.isUri(L.source)&&(p(this.telemetryService,L.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(L.source),new Date().getTime()-M,void 0),l.isWeb&&L.operation===1))try{await this.galleryService.reportStatistic($.manifest.publisher,$.manifest.name,$.manifest.version,"install")}catch(Q){}r.push({local:$,identifier:L.identifier,operation:L.operation,source:L.source})}catch($){throw g.URI.isUri(L.source)||p(this.telemetryService,L.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(L.source),new Date().getTime()-M,$),this.logService.error("Error while installing the extension:",L.identifier.id),this.logService.error($),$}finally{I.delete(L.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:F})=>this.logService.info("Extension installed successfully:",F.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:F})=>(0,d.areSameExtensions)(F,a.identifier))[0].local}catch(I){if(i.forEach(({task:F})=>F.cancel()),r.length)try{const F=await Promise.allSettled(r.map(({local:w})=>this.createUninstallExtensionTask(w,{versionOnly:!0}).run()));for(let w=0;w<F.length;w++){const L=F[w],{identifier:M}=r[w];L.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",M.id):this.logService.warn("Rollback: Error while uninstalling extension",M.id,(0,C.getErrorMessage)(L.reason))}}catch(F){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(F),r.map(({identifier:w})=>w.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,C.getErrorMessage)(I)),this._onDidInstallExtensions.fire(i.map(({task:F})=>({identifier:F.identifier,operation:1,source:F.source}))),I instanceof Error&&(I.name=I&&I.code?I.code:t.ERROR_UNKNOWN),I}finally{for(const{task:I,manifest:F}of i)if(!g.URI.isUri(I.source)){const w=new d.ExtensionIdentifierWithVersion(I.identifier,F.version).key();this.installingExtensions.delete(w)||this.logService.warn("Installation task is not found in the cache",w)}}}async joinAllSettled(s){const e=[],n=[],i=await Promise.allSettled(s);for(const r of i)r.status==="fulfilled"?e.push(r.value):n.push(r.reason);if(n.length)throw f(n);return e}async getAllDepsAndPackExtensionsToInstall(s,e,n){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const r=[s,...i.map(I=>I.identifier)],a=[],E=async(I,F)=>{const w=F.extensionDependencies||[],L=[...w];if(F.extensionPack){const M=n?i.find($=>(0,d.areSameExtensions)($.identifier,I)):void 0;for(const $ of F.extensionPack)M&&M.manifest.extensionPack&&M.manifest.extensionPack.some(Q=>(0,d.areSameExtensions)({id:Q},{id:$}))||L.every(Q=>!(0,d.areSameExtensions)({id:Q},{id:$}))&&L.push($)}if(L.length){const M=[...r,...a.map(Q=>Q.gallery.identifier)],$=L.filter(Q=>M.every(ie=>!(0,d.areSameExtensions)(ie,{id:Q})));if($.length){const Q=await this.galleryService.query({names:$,pageSize:L.length},S.CancellationToken.None);for(const ie of Q.firstPage){if(M.find(J=>(0,d.areSameExtensions)(J,ie.identifier)))continue;if(!w.some(J=>(0,d.areSameExtensions)({id:J},ie.identifier))&&!await this.canInstall(ie)){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}const Z=await this.checkAndGetCompatibleVersion(ie,!0),K=await this.galleryService.getManifest(Z,S.CancellationToken.None);if(K===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${Z.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:Z,manifest:K}),await E(Z.identifier,K)}}}};return await E(s,e),i=await this.getInstalled(),a.filter(I=>!i.some(F=>(0,d.areSameExtensions)(F.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new b.ExtensionManagementError(m.localize(3,null,s.identifier.id),b.INSTALL_ERROR_MALICIOUS);let n=null;if(await this.galleryService.isExtensionCompatible(s,b.CURRENT_TARGET_PLATFORM)&&(n=s),!n&&e&&(n=await this.galleryService.getCompatibleExtension(s,b.CURRENT_TARGET_PLATFORM)),!n)throw new b.ExtensionManagementError(m.localize(4,null,s.identifier.id,c.default.version),b.INSTALL_ERROR_INCOMPATIBLE);return n}async isMalicious(s){const e=await this.getExtensionsReport();return(0,d.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const n=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),n.waitUntilTaskIsFinished();const i=(I,F)=>{const w=this.createUninstallExtensionTask(I,F);return this.uninstallingExtensions.set(w.extension.identifier.id.toLowerCase(),w),this.logService.info("Uninstalling extension:",I.identifier.id),this._onUninstallExtension.fire(I.identifier),w},r=(I,F)=>{F?this.logService.error("Failed to uninstall extension:",I.identifier.id,F.message):this.logService.info("Successfully uninstalled extension:",I.identifier.id),p(this.telemetryService,"extensionGallery:uninstall",(0,d.getLocalExtensionTelemetryData)(I),void 0,F),this._onDidUninstallExtension.fire({identifier:I.identifier,error:F?.code})},a=[],E=[];try{a.push(i(s,{}));const I=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const F=this.getAllPackExtensionsToUninstall(s,I);for(const w of F)this.uninstallingExtensions.has(w.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",w.identifier.id):a.push(i(w,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(F=>F.extension),I,s),await this.joinAllSettled(a.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(w=>w.postUninstall(F.extension,e,S.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch(w){}r(F.extension)}catch(w){const L=w instanceof b.ExtensionManagementError?w:new b.ExtensionManagementError((0,C.getErrorMessage)(w),t.ERROR_UNKNOWN);throw r(F.extension,L),L}finally{E.push(F)}}))}catch(I){const F=I instanceof b.ExtensionManagementError?I:new b.ExtensionManagementError((0,C.getErrorMessage)(I),t.ERROR_UNKNOWN);for(const w of a){try{w.cancel()}catch(L){}E.includes(w)||r(w.extension,F)}throw F}finally{for(const I of a)this.uninstallingExtensions.delete(I.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",I.extension.identifier.id)}}checkForDependents(s,e,n){for(const i of s){const r=this.getDependents(i,e);if(r.length){const a=r.filter(E=>!s.some(I=>(0,d.areSameExtensions)(I.identifier,E.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(i,a,n))}}}getDependentsErrorMessage(s,e,n){return n===s?e.length===1?m.localize(5,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?m.localize(6,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):m.localize(7,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?m.localize(8,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?m.localize(9,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):m.localize(10,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,n=[]){if(n.indexOf(s)!==-1)return[];n.push(s);const i=s.manifest.extensionPack?s.manifest.extensionPack:[];if(i.length){const r=e.filter(E=>!E.isBuiltin&&i.some(I=>(0,d.areSameExtensions)({id:I},E.identifier))),a=[];for(const E of r)a.push(...this.getAllPackExtensionsToUninstall(E,e,n));return[...r,...a]}return[]}getDependents(s,e){return e.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(i=>(0,d.areSameExtensions)({id:i},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};v=fe([he(0,b.IExtensionGalleryService),he(1,u.ITelemetryService),he(2,y.ILogService)],v),t.AbstractExtensionManagementService=v;function f(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,n)=>new Error(`${e.message}${e.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}t.joinErrors=f;function p(o,s,e,n,i){const r=i?i instanceof b.ExtensionManagementError?i.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!i,duration:n,errorcode:r})}t.reportTelemetry=p;class h{constructor(){this.barrier=new P.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(s=>new Promise((e,n)=>{const i=s.onCancellationRequested(()=>{i.dispose(),n((0,C.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=h}),define(ee[118],te([0,1,2,18,21,85,26,31,35,25]),function(_,t,T,P,S,C,D,R,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let m=class{constructor(y,c){this._configurationService=c,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appender=y.appender,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,S.escapeRegExpCharacters)(u),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(u=>{const v=/^[a-f0-9]+$/i.test(u["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!v})})}setExperimentProperty(y,c){this._experimentProperties[y]=c}setEnabled(y){this._enabled=y}_updateUserOptIn(){const y=this._configurationService?.getValue(b);this._userOptIn=y?y.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const y=await this._commonProperties;let c=y.sessionID,u=y["common.instanceId"],v=y["common.machineId"],f=y["common.firstSessionDate"],p=y["common.msftInternal"];return{sessionId:c,instanceId:u,machineId:v,firstSessionDate:f,msftInternal:p}}dispose(){this._disposables.dispose()}publicLog(y,c,u){return this.isOptedIn?this._commonProperties.then(v=>{c=(0,P.mixin)(c,v),c=(0,P.mixin)(c,this._experimentProperties),c=(0,P.cloneAndChange)(c,f=>{if(typeof f=="string")return this._cleanupInfo(f,u)}),this._appender.log(y,c)},v=>{console.error(v)}):Promise.resolve(void 0)}publicLog2(y,c,u){return this.publicLog(y,c,u)}publicLogError(y,c){return this.sendErrorTelemetry?this.publicLog(y,c,!0):Promise.resolve(void 0)}publicLogError2(y,c){return this.publicLogError(y,c)}_cleanupInfo(y,c){let u=y;if(c){const v=[];for(let o of this._cleanupPatterns)for(;;){const s=o.exec(y);if(!s)break;v.push([s.index,o.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(u="";;){const o=p.exec(y);if(!o)break;!f.test(o[0])&&v.every(([s,e])=>o.index<s||o.index>=e)&&(u+=y.substring(h,o.index)+"<REDACTED: user-file-path>",h=p.lastIndex)}h<y.length&&(u+=y.substr(h))}for(let v of this._cleanupPatterns)u=u.replace(v,"");return u}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=fe([he(1,D.IConfigurationService)],m),t.TelemetryService=m;const b="telemetry";g.Registry.as(R.Extensions.Configuration).registerConfiguration({id:b,order:110,type:"object",title:(0,C.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,C.localize)(2,null,l.default.nameLong,l.default.privacyStatementUrl):(0,C.localize)(1,null,l.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[43],te([0,1,3,18,12,26]),function(_,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.TelemetryLevel=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(v,f){return Promise.resolve(void 0)}publicLog2(v,f){return this.publicLog(v,f)}publicLogError(v,f){return Promise.resolve(void 0)}publicLogError2(v,f){return this.publicLogError(v,f)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class D{async publicLog(f,p,h){}async publicLogError(f,p,h){}}t.NullEndpointTelemetryService=D;function R(...v){return{log:(f,p)=>v.forEach(h=>h.log(f,p)),flush:()=>T.Promises.settled(v.map(f=>f.flush()))}}t.combinedAppender=R,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(v,f){return f.onDidChangeConfiguration(p=>{p.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(p.source),configurationKeys:c(p.sourceConfig)})})}t.configurationTelemetry=l;var g;(function(v){v[v.NONE=0]="NONE",v[v.LOG=1]="LOG",v[v.USER=2]="USER"})(g=t.TelemetryLevel||(t.TelemetryLevel={}));function m(v,f){return f.disableTelemetry||!v.enableTelemetry?0:f.isBuilt?2:1}t.getTelemetryLevel=m;function b(v){const f=Object.create(null),p=Object.create(null),h=Object.create(null);y(v,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const s=h[o];typeof s=="number"?p[o]=s:typeof s=="boolean"?p[o]=s?1:0:typeof s=="string"?f[o]=s.substring(0,1023):typeof s!="undefined"&&s!==null&&(f[o]=s)}return{properties:f,measurements:p}}t.validateTelemetryData=b;function d(v){if(!v)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{v.indexOf(`${h}+`)===0&&(f=h)}),f}t.cleanRemoteAuthority=d;function y(v,f,p=0,h){if(!!v)for(let o of Object.getOwnPropertyNames(v)){const s=v[o],e=h?h+o:o;Array.isArray(s)?f[e]=(0,P.safeStringify)(s):s instanceof Date?f[e]=s.toISOString():(0,S.isObject)(s)?p<2?y(s,f,p+1,e+"."):f[e]=(0,P.safeStringify)(s):f[e]=s}}function c(v){if(!v)return[];const f=[];return u(f,"",v),f}function u(v,f,p){p&&typeof p=="object"&&!Array.isArray(p)?Object.keys(p).forEach(h=>u(v,f?`${f}.${h}`:h,p[h])):v.push(f)}}),define(ee[119],te([0,1,22,27,11,18,8,7,26,20,23,24,50,17,14,15,42,56,114,115,36,43]),function(_,t,T,P,S,C,D,R,l,g,m,b,d,y,c,u,v,f,p,h,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var e;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished"})(e||(e={}));function n(...k){return String(k.reduce((A,U)=>A|U,0))}var i;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class F{constructor(A=I){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,U=this.state.pageSize){return new F({...this.state,pageNumber:A,pageSize:U})}withFilter(A,...U){const V=[...this.state.criteria,...U.length?U.map(G=>({filterType:A,value:G})):[{filterType:A}]];return new F({...this.state,criteria:V})}withSortBy(A){return new F({...this.state,sortBy:A})}withSortOrder(A){return new F({...this.state,sortOrder:A})}withFlags(...A){return new F({...this.state,flags:A.reduce((U,V)=>U|V,0)})}withAssetTypes(...A){return new F({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:U,pageSize:V,sortBy:G,sortOrder:X,flags:re,assetTypes:ne}=this.state;return{filters:[{criteria:A,pageNumber:U,pageSize:V,sortBy:G,sortOrder:X}],assetTypes:ne,flags:re}}get searchText(){const A=this.state.criteria.filter(U=>U.filterType===i.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function w(k,A){const U=(k||[]).filter(V=>V.statisticName===A)[0];return U?U.value:0}function L(k){const A="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(V=>V.assetType.indexOf(A)===0).reduce((V,G)=>{const X=ie(k,G.assetType);return X&&V.push([G.assetType.substring(A.length),X]),V},[])}function M(k){if(k.properties){const A=k.properties.filter(G=>G.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=A.filter(G=>U.test(G.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return ie(k,r.Repository)}function $(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function Q(k){const A=ie(k,r.Icon);if(A)return A;const U=m.DefaultIconPath;return{uri:U,fallbackUri:U}}function ie(k,A){return k.files.filter(V=>V.assetType===A)[0]?{uri:`${k.assetUri}/${A}`,fallbackUri:`${k.fallbackAssetUri}/${A}`}:null}function oe(k,A){const U=k.properties?k.properties.filter(G=>G.key===A):[],V=U.length>0&&U[0].value;return V?V.split(",").map(G=>(0,b.adoptToGalleryExtensionId)(G)):[]}function Z(k){const A=k.properties?k.properties.filter(U=>U.key===a.Engine):[];return A.length>0&&A[0].value||""}function K(k){const A=k.properties?k.properties.filter(V=>V.key===a.LocalizedLanguages):[],U=A.length>0&&A[0].value||"";return U?U.split(","):[]}function J(k){return k.indexOf("preview")!==-1}function Y(k){return k.targetPlatform?(0,m.toTargetPlatform)(k.targetPlatform):"undefined"}function se(k){const A=(0,T.distinct)(k.versions.map(Y)),U=!!k.tags?.includes(m.WEB_EXTENSION_TAG),V=A.indexOf("web");return U?V===-1&&A.push("web"):V!==-1&&A.splice(V,1),A}function B(k,A){return A==="web"&&!k.includes("web")}function O(k,A,U){if(B(A,U))return!1;if(k==="undefined"||k==="universal")return!0;if(k==="unknown")return!1;if(k===U)return!0;switch(U){case"win32-x64":return k==="win32-ia32";case"win32-arm64":return k==="win32-ia32";default:return!1}}function x(k,A,U,V){const G=se(k);let X=k.versions[0];return X=k.versions.find(re=>re.version===X.version&&O(Y(re),G,m.CURRENT_TARGET_PLATFORM))||X,z(k,X,G,A,U,V)}function z(k,A,U,V,G,X){const re={manifest:ie(A,r.Manifest),readme:ie(A,r.Details),changelog:ie(A,r.Changelog),license:ie(A,r.License),repository:M(A),download:$(A),icon:Q(A),coreTranslations:L(A)};return{identifier:{id:(0,b.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:A.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,description:k.shortDescription||"",installCount:w(k.statistics,"install"),rating:w(k.statistics,"averagerating"),ratingCount:w(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:U,assets:re,properties:{dependencies:oe(A,a.Dependency),extensionPack:oe(A,a.ExtensionPack),engine:Z(A),localizedLanguages:K(A),targetPlatform:Y(A)},preview:J(k.flags),telemetryData:{index:(G.pageNumber-1)*G.pageSize+V,querySource:X}}}let W=class{constructor(A,U,V,G,X,re,ne,ue){this.requestService=A,this.logService=U,this.environmentService=V,this.telemetryService=G,this.fileService=X,this.productService=re,this.configurationService=ne;const de=re.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=j(re.version,re,this.environmentService,this.configurationService,this.fileService,ue)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,U){const V=[];let G=new F().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,A.length).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExtensionName,...A.map(({id:re})=>re.toLowerCase()));A.every(re=>!re.version)&&(G=G.withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly));const{galleryExtensions:X}=await this.queryGallery(G,P.CancellationToken.None);for(let re=0;re<X.length;re++){const ne=X[re];if(!ne.versions.length)continue;const ue=(0,b.getGalleryExtensionId)(ne.publisher.publisherName,ne.extensionName),de=A.find(ge=>(0,b.areSameExtensions)(ge,{id:ue}))?.version;if(de){const ge=ne.versions.find(Ee=>Ee.version===de);ge&&V.push(z(ne,ge,se(ne),re,G))}else V.push(x(ne,re,G))}return V}async getCompatibleExtension(A,U){const V=(0,m.isIExtensionIdentifier)(A)?null:A;if(V){if(B(V.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(V,U))return V}const{id:G,uuid:X}=V?V.identifier:A;let re=new F().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");X?re=re.withFilter(i.ExtensionId,X):re=re.withFilter(i.ExtensionName,G);const{galleryExtensions:ne}=await this.queryGallery(re,P.CancellationToken.None),[ue]=ne;if(!ue||!ue.versions.length)return null;const de=se(ue);if(B(de,U))return null;for(let ge of ue.versions){if(!Z(ge)){const Ee=await this.getEngine(ge);ge={...ge,properties:[...ge.properties||[],{key:a.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(ge,de,U))return z(ue,ge,de,0,re)}return null}async isExtensionCompatible(A,U){if(!O(A.properties.targetPlatform,A.allTargetPlatforms,U))return!1;let V=A.properties.engine;if(!V){const G=await this.getManifest(A,P.CancellationToken.None);if(!G)throw new Error("Manifest was not found");V=G.engines.vscode}return(0,d.isEngineValid)(V,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,U,V){if(!O(Y(A),U,V))return!1;const G=await this.getEngine(A);return(0,d.isEngineValid)(G,this.productService.version,this.productService.date)}async query(A,U){const V=P.CancellationToken.isCancellationToken(A)?{}:A,G=P.CancellationToken.isCancellationToken(A)?A:U;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let X=V.text||"";const re=(0,C.getOrDefault)(V,ye=>ye.pageSize,50);let ne=new F().withFlags(e.IncludeLatestVersionOnly,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,re).withFilter(i.Target,"Microsoft.VisualStudio.Code");X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,be,pe)=>(ne=ne.withFilter(i.Category,pe||be),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,be,pe)=>(ne=ne.withFilter(i.Tag,pe||be),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(i.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),ne=ne.withFilter(i.SearchText,X)),ne=ne.withSortBy(0)):V.ids?ne=ne.withFilter(i.ExtensionId,...V.ids):V.names?ne=ne.withFilter(i.ExtensionName,...V.names):ne=ne.withSortBy(4),typeof V.sortBy=="number"&&(ne=ne.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(ne=ne.withSortOrder(V.sortOrder));const{galleryExtensions:ue,total:de}=await this.queryGallery(ne,G),ge=ue.map((ye,be)=>x(ye,be,ne,V.source)),Ee=async(ye,be)=>{if(be.isCancellationRequested)throw(0,S.canceled)();const pe=ne.withPage(ye+1),{galleryExtensions:De}=await this.queryGallery(pe,be);return De.map((ze,Ve)=>x(ze,Ve,pe,V.source))};return{firstPage:ge,total:de,pageSize:ne.pageSize,getPage:Ee}}async queryGallery(A,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,e.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,n(e.Unpublished));const V=await this.commonHeadersPromise,G=JSON.stringify(A.raw),X={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},re=new Date().getTime();let ne,ue,de=0;try{if(ne=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:G,headers:X},U),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,f.asJson)(ne);if(ge){const Ee=ge.results[0],ye=Ee.extensions,be=Ee.resultMetadata&&Ee.resultMetadata.filter(pe=>pe.metadataType==="ResultCount")[0];return de=be&&be.metadataItems.filter(pe=>pe.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:de}}return{galleryExtensions:[],total:de}}catch(ge){throw ue=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-re,success:!!ne&&(0,f.isSuccess)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ue?(0,S.isPromiseCanceledError)(ue)?"canceled":(0,S.getErrorMessage)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(A,U,V,G){if(!this.isEnabled())return;const X=D.isWeb?this.api(`/itemName/${A}.${U}/version/${V}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${U}/${V}/stats?statType=${G}`),re=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:re};try{await this.requestService.request({type:"POST",url:X,headers:ue},P.CancellationToken.None)}catch(de){}}async download(A,U,V){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const G=(0,b.getGalleryExtensionTelemetryData)(A),X=new Date().getTime(),re=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...G,duration:ge}),ne=V===1?"install":V===2?"update":"",ue=ne?{uri:`${A.assets.download.uri}${R.URI.parse(A.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${A.assets.download.fallbackUri}${R.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:A.assets.download,de=await this.getAsset(ue);await this.fileService.writeFile(U,de.stream),re(new Date().getTime()-X)}async getReadme(A,U){if(A.assets.readme){const V=await this.getAsset(A.assets.readme,{},U);return await(0,f.asText)(V)||""}return""}async getManifest(A,U){if(A.assets.manifest){const V=await this.getAsset(A.assets.manifest,{},U),G=await(0,f.asText)(V);return G?JSON.parse(G):null}return null}async getManifestFromRawExtensionVersion(A,U){const V=ie(A,r.Manifest);if(!V)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},X=await this.getAsset(V,{headers:G});return await(0,f.asJson)(X)}async getCoreTranslation(A,U){const V=A.assets.coreTranslations.filter(G=>G[0]===U.toUpperCase())[0];if(V){const G=await this.getAsset(V[1]),X=await(0,f.asText)(G);return X?JSON.parse(X):null}return null}async getChangelog(A,U){if(A.assets.changelog){const V=await this.getAsset(A.assets.changelog,{},U);return await(0,f.asText)(V)||""}return""}async getAllCompatibleVersions(A,U){let V=new F().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?V=V.withFilter(i.ExtensionId,A.identifier.uuid):V=V.withFilter(i.ExtensionName,A.identifier.id);const{galleryExtensions:G}=await this.queryGallery(V,P.CancellationToken.None);if(!G.length)return[];const X=se(G[0]);if(B(X,U))return[];const re=[];for(const ne of G[0].versions)try{await this.isRawExtensionVersionCompatible(ne,X,U)&&re.push({version:ne.version,date:ne.lastUpdated})}catch(ue){}return re}async getAsset(A,U={},V=P.CancellationToken.None){const G=await this.commonHeadersPromise,X={type:"GET"},re={...G,...U.headers||{}};U={...U,...X,headers:re};const ne=A.uri,ue=A.fallbackUri,de={...U,url:ne};try{const ge=await this.requestService.request(de,V);if(ge.res.statusCode===200)return ge;const Ee=await(0,f.asText)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${Ee}`)}catch(ge){if((0,S.isPromiseCanceledError)(ge))throw ge;const Ee=(0,S.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ne,message:Ee});const ye={...U,url:ue};return this.requestService.request(ye,V)}}async getEngine(A){let U=Z(A);if(!U){const V=await this.getManifestFromRawExtensionVersion(A,P.CancellationToken.None);if(!V)throw new Error("Manifest was not found");U=V.engines.vscode}return U}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},P.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,f.asJson)(A),V=new Map;if(U)for(const G of U.malicious){const X=V.get(G)||{id:{id:G},malicious:!0,slow:!1};X.malicious=!0,V.set(G,X)}return[...V.values()]}};W=fe([he(0,f.IRequestService),he(1,u.ILogService),he(2,g.IEnvironmentService),he(3,o.ITelemetryService),he(4,y.IFileService),he(5,v.IProductService),he(6,l.IConfigurationService),he(7,(0,c.optional)(h.IStorageService))],W),t.ExtensionGalleryService=W;async function j(k,A,U,V,G,X){const re={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k}`},ne=await(0,p.getServiceMachineId)(U,G,X);return(0,s.getTelemetryLevel)(A,U)>=2&&V.getValue("telemetry.enableTelemetry")===!0&&(re["X-Market-User-Id"]=ne),re}t.resolveMarketplaceHeaders=j}),define(ee[120],te([0,1,11,18,43]),function(_,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function C(R){const l=await new Promise((m,b)=>{_(["applicationinsights"],m,b)});let g;return l.defaultClient?(g=new l.TelemetryClient(R),g.channel.setUseDiskRetryCaching(!0)):(l.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=l.defaultClient),R.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class D{constructor(l,g,m){this._eventPrefix=l,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof m=="function"?this._aiClient=m():this._aiClient=m,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=C(this._aiClient)),this._asyncAIClient.then(g=>{l(g)},g=>{(0,T.onUnexpectedError)(g),console.error(g)})}}log(l,g){!this._aiClient||(g=(0,P.mixin)(g,this._defaultData),g=(0,S.validateTelemetryData)(g),this._withAIClient(m=>m.trackEvent({name:this._eventPrefix+"/"+l,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=D}),define(ee[121],te([0,1,4,10]),function(_,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(C,D){const R=Object.create(null),l=(m,b)=>{const d=JSON.parse(m);R[b]=d};if(D){const m=[],b=await P.Promises.readdir(D);for(const y of b)try{(await P.Promises.stat((0,T.join)(D,y))).isDirectory()&&m.push(y)}catch{}const d=[];for(const y of m)(await P.Promises.readdir((0,T.join)(D,y))).filter(u=>u==="telemetry.json").length===1&&d.push(y);for(const y of d){const c=(await P.Promises.readFile((0,T.join)(D,y,"telemetry.json"))).toString();l(c,y)}}let g=(await P.Promises.readFile((0,T.join)(C,"telemetry-core.json"))).toString();return l(g,"vscode-core"),g=(await P.Promises.readFile((0,T.join)(C,"telemetry-extensions.json"))).toString(),l(g,"vscode-extensions"),JSON.stringify(R,null,4)}t.buildTelemetryMessage=S}),define(ee[44],te([0,1,38,3,4,12,10,72,132,133]),function(_,t,T,P,S,C,D,R,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class m extends Error{constructor(e,n){let i=n.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=e,this.cause=n}}t.ExtractError=m;function b(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,i)=>n+i,e&61440)}function d(s){if(s instanceof m)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new m(e,s)}function y(s,e,n,i,r,a){const E=S.dirname(e),I=S.join(i,E);if(!I.startsWith(i))return Promise.reject(new Error(R.localize(0,null,e)));const F=S.join(i,e);let w;return a.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(D.Promises.mkdir(I,{recursive:!0})).then(()=>new Promise((L,M)=>{if(!a.isCancellationRequested)try{w=(0,T.createWriteStream)(F,{mode:n}),w.once("close",()=>L()),w.once("error",M),s.once("error",M),s.pipe(w)}catch($){M($)}}))}function c(s,e,n,i){let r=(0,P.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((E,I)=>{const F=new P.Sequencer,w=L=>{L.isCancellationRequested||(a++,s.readEntry())};s.once("error",I),s.once("close",()=>r.then(()=>{i.isCancellationRequested||s.entryCount===a?E():I(new m("Incomplete",new Error(R.localize(1,null,a,s.entryCount))))},I)),s.readEntry(),s.on("entry",L=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(L.fileName)){w(i);return}const M=L.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(M)){const ie=S.join(e,M);r=(0,P.createCancelablePromise)(oe=>D.Promises.mkdir(ie,{recursive:!0}).then(()=>w(oe)).then(void 0,I));return}const $=v(s,L),Q=b(L);r=(0,P.createCancelablePromise)(ie=>F.queue(()=>$.then(oe=>y(oe,M,Q,e,n,ie).then(()=>w(ie)))).then(null,I))})})}function u(s,e=!1){return new Promise((n,i)=>{(0,l.open)(s,e?{lazyEntries:!0}:void 0,(r,a)=>{r?i(d(r)):n((0,C.assertIsDefined)(a))})})}function v(s,e){return new Promise((n,i)=>{s.openReadStream(e,(r,a)=>{r?i(d(r)):n((0,C.assertIsDefined)(a))})})}function f(s,e){return new Promise((n,i)=>{const r=new g.ZipFile;e.forEach(E=>{E.contents?r.addBuffer(typeof E.contents=="string"?Buffer.from(E.contents,"utf8"):E.contents,E.path):E.localPath&&r.addFile(E.localPath,E.path)}),r.end();const a=(0,T.createWriteStream)(s);r.outputStream.pipe(a),r.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>n(s))})}t.zip=f;function p(s,e,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let a=u(s,!0);return n.overwrite&&(a=a.then(E=>D.Promises.rm(e).then(()=>E))),a.then(E=>c(E,e,{sourcePathRegex:r},i))}t.extract=p;function h(s,e){return u(s).then(n=>new Promise((i,r)=>{n.on("entry",a=>{a.fileName===e&&v(n,a).then(E=>i(E),E=>r(E))}),n.once("close",()=>r(new Error(R.localize(2,null,e))))}))}function o(s,e){return h(s,e).then(n=>new Promise((i,r)=>{const a=[];n.once("error",r),n.on("data",E=>a.push(E)),n.on("end",()=>i(Buffer.concat(a)))}))}t.buffer=o}),define(ee[122],te([0,1,44,78]),function(_,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(C){return(0,T.buffer)(C,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch(R){throw new Error((0,P.localize)(0,null))}})}t.getManifest=S}),define(ee[123],te([0,1,22,3,11,2,9,4,8,19,41,7,30,10,44,79,20,23,24,90,17,15,42]),function(_,t,T,P,S,C,D,R,l,g,m,b,d,y,c,u,v,f,p,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const n="scanningSystem",i="scanningUser",r="extracting",a="deleting",E="renaming";let I=class extends C.Disposable{constructor(w,L,M,$,Q){super();this.beforeRemovingExtension=w,this.fileService=L,this.logService=M,this.environmentService=$,this.productService=Q,this._devSystemExtensionsPath=null,this.systemExtensionsPath=$.builtinExtensionsPath,this.extensionsPath=$.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new P.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(w){const L=[];(w===null||w===0)&&L.push(this.scanSystemExtensions().then(null,M=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(M).message,n)))),(w===null||w===1)&&L.push(this.scanUserExtensions(!0).then(null,M=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(M).message,i))));try{const M=await Promise.all(L);return(0,T.flatten)(M)}catch(M){throw this.joinErrors(M)}}async scanUserExtensions(w){this.logService.trace("Started scanning user extensions");let[L,M]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return M=M.filter($=>!L[new p.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]),w&&(M=(0,p.groupByExtension)(M,Q=>Q.identifier).map(Q=>Q.sort((ie,oe)=>m.rcompare(ie.manifest.version,oe.manifest.version))[0])),this.logService.trace("Scanned user extensions:",M.length),M}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(w,L,M,$){const Q=w.key(),ie=R.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),oe=R.join(this.extensionsPath,Q);try{await y.Promises.rm(oe)}catch(K){try{await y.Promises.rm(oe)}catch(J){}throw new f.ExtensionManagementError((0,u.localize)(0,null,oe,w.id),a)}await this.extractAtLocation(w,L,ie,$);let Z=await this.scanExtension(b.URI.file(ie),1);if(!Z)throw new Error((0,u.localize)(1,null,ie));await this.storeMetadata(Z,{...M,installedTimestamp:Date.now()});try{await this.rename(w,ie,oe,Date.now()+2*60*1e3),this.logService.info("Renamed to",oe)}catch(K){try{await y.Promises.rm(ie)}catch(J){}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",w.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(K)}. Deleted from extracted location`,ie),K}try{Z=await this.scanExtension(b.URI.file(oe),1)}catch(K){}if(Z)return Z;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(w,L){return this.setMetadata(w,L),await this.storeMetadata(w,{...L,installedTimestamp:w.installedTimestamp}),w}async storeMetadata(w,L){L.isMachineScoped=L.isMachineScoped||void 0,L.isBuiltin=L.isBuiltin||void 0,L.installedTimestamp=L.installedTimestamp||void 0;const M=R.join(w.location.fsPath,"package.json"),$=await y.Promises.readFile(M,"utf8"),{manifest:Q}=await this.parseManifest($);return Q.__metadata=L,await y.Promises.writeFile(M,JSON.stringify(Q,null,"	")),w}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...w){const L=w.map(M=>new p.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version));await this.withUninstalledExtensions(M=>{L.forEach($=>M[$.key()]=!0)})}async setInstalled(w){await this.withUninstalledExtensions($=>delete $[w.key()]);const M=(await this.scanExtensions(1)).find($=>new p.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).equals(w))||null;return M?(await this.storeMetadata(M,{installedTimestamp:Date.now()}),this.scanExtension(M.location,1)):null}async withUninstalledExtensions(w){return this.uninstalledFileLimiter.queue(async()=>{let L;try{L=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch($){if($.code!=="ENOENT")throw $}let M={};if(L)try{M=JSON.parse(L)}catch($){}return w&&(w(M),Object.keys(M).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(M)):await y.Promises.rm(this.uninstalledPath)),M})}async removeExtension(w,L){this.logService.trace(`Deleting ${L} extension from disk`,w.identifier.id,w.location.fsPath),await y.Promises.rm(w.location.fsPath),this.logService.info("Deleted from disk",w.identifier.id,w.location.fsPath)}async removeUninstalledExtension(w){await this.removeExtension(w,"uninstalled"),await this.withUninstalledExtensions(L=>delete L[new p.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()])}async extractAtLocation(w,L,M,$){this.logService.trace(`Started extracting the extension from ${L} to ${M}`);try{await y.Promises.rm(M)}catch(Q){throw new f.ExtensionManagementError(this.joinErrors(Q).message,a)}try{await(0,c.extract)(L,M,{sourcePath:"extension",overwrite:!0},$),this.logService.info(`Extracted extension to ${M}:`,w.id)}catch(Q){try{await y.Promises.rm(M)}catch(ie){}throw new f.ExtensionManagementError(Q.message,Q instanceof c.ExtractError&&Q.type?Q.type:r)}}async rename(w,L,M,$){try{await y.Promises.rename(L,M)}catch(Q){if(l.isWindows&&Q&&Q.code==="EPERM"&&Date.now()<$)return this.logService.info(`Failed renaming ${L} to ${M} with 'EPERM' error. Trying again...`,w.id),this.rename(w,L,M,$);throw new f.ExtensionManagementError(Q.message||(0,u.localize)(3,null,L,M),Q.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const w=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return w;const L=this.scanDevSystemExtensions(),[M,$]=await Promise.all([w,L]);return[...M,...$]}async scanExtensionsInDir(w,L){const M=new P.Limiter(10),$=await this.fileService.resolve(b.URI.file(w));return $.children?(await Promise.all($.children.filter(ie=>ie.isDirectory).map(ie=>M.queue(async()=>L===1&&(0,g.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,L))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(w,L){try{const M=await this.fileService.resolve(w);if(M.children){const{manifest:$,metadata:Q}=await this.readManifest(w.fsPath),ie=M.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,oe=M.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource,Z={id:(0,p.getGalleryExtensionId)($.publisher,$.name)},K={type:L,identifier:Z,manifest:$,location:w,readmeUrl:ie,changelogUrl:oe,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:L===0};return Q&&(this.setMetadata(K,Q),K.installedTimestamp=Q.installedTimestamp),K}}catch(M){L!==0&&this.logService.trace(M)}return null}async scanDefaultSystemExtensions(){const w=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",w.length),w}async scanDevSystemExtensions(){const w=this.getDevSystemExtensionsList();if(w.length){const L=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",L.length),L.filter(M=>w.some($=>(0,p.areSameExtensions)(M.identifier,{id:$})))}else return[]}setMetadata(w,L){w.publisherDisplayName=L.publisherDisplayName||null,w.publisherId=L.publisherId||null,w.identifier.uuid=L.id,w.isMachineScoped=!!L.isMachineScoped,w.isBuiltin=w.type===0||!!L.isBuiltin}async removeUninstalledExtensions(){const w=await this.getUninstalledExtensions(),L=await this.scanAllUserExtensions(),M=new Set;for(const ie of L)w[new p.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||M.add(ie.identifier.id.toLowerCase());const $=(0,p.groupByExtension)(L,ie=>ie.identifier);await P.Promises.settled($.map(async ie=>{const oe=ie.sort((Z,K)=>m.rcompare(Z.manifest.version,K.manifest.version))[0];M.has(oe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(oe)}));const Q=L.filter(ie=>w[new p.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await P.Promises.settled(Q.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const w=await this.scanAllUserExtensions(),L=[],M=(0,p.groupByExtension)(w,$=>$.identifier);L.push(...(0,T.flatten)(M.map($=>$.sort((Q,ie)=>m.rcompare(Q.manifest.version,ie.manifest.version)).slice(1)))),await P.Promises.settled(L.map($=>this.removeExtension($,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(w=>w.name)}joinErrors(w){const L=Array.isArray(w)?w:[w];return L.length===1?L[0]instanceof Error?L[0]:new Error(L[0]):L.reduce((M,$)=>new Error(`${M.message}${M.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(D.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(w){const L=[y.Promises.readFile(R.join(w,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),y.Promises.readFile(R.join(w,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:M,metadata:$},Q]=await Promise.all(L);return{manifest:(0,h.localizeManifest)(M,Q),metadata:$}}parseManifest(w){return new Promise((L,M)=>{try{const $=JSON.parse(w),Q=$.__metadata||null;L({manifest:$,metadata:Q})}catch($){M(new Error((0,u.localize)(4,null)))}})}};I=fe([he(1,o.IFileService),he(2,s.ILogService),he(3,v.INativeEnvironmentService),he(4,e.IProductService)],I),t.ExtensionsScanner=I}),define(ee[124],te([0,1,28,9,4,8,19,41,7,30,10,44,77,96,20,117,23,24,102,103,122,98,123,104,50,17,14,15,35,36]),function(_,t,T,P,S,C,D,R,l,g,m,b,d,y,c,u,v,f,p,h,o,s,e,n,i,r,a,E,I,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const w="unsetUninstalled",L="downloading";let M=class extends u.AbstractExtensionManagementService{constructor(K,J,Y,se,B,O,x){super(K,J,Y);this.environmentService=se,this.downloadService=B;const z=this._register(O.createInstance(h.ExtensionsLifecycle));this.extensionsScanner=this._register(O.createInstance(e.ExtensionsScanner,j=>z.postUninstall(j))),this.manifestCache=this._register(new s.ExtensionsManifestCache(se,this)),this.extensionsDownloader=this._register(O.createInstance(p.ExtensionsDownloader));const W=this._register(new n.ExtensionsWatcher(this,x,se,Y));this._register(W.onDidChangeExtensionsByAnotherSource(({added:j,removed:k})=>{j.length&&this._onDidInstallExtensions.fire(j.map(A=>({identifier:A.identifier,operation:0,local:A}))),k.forEach(A=>this._onDidUninstallExtension.fire({identifier:A}))}))}async zip(K){this.logService.trace("ExtensionManagementService#zip",K.identifier.id);const J=await this.collectFiles(K),Y=await(0,b.zip)((0,D.joinPath)(this.environmentService.tmpDir,(0,g.generateUuid)()).fsPath,J);return l.URI.file(Y)}async unzip(K){return this.logService.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const J=await this.downloadVsix(K),Y=S.resolve(J.fsPath);return(0,o.getManifest)(Y)}getInstalled(K=null){return this.extensionsScanner.scanExtensions(K)}async canInstall(K){return!0}async install(K,J={}){this.logService.trace("ExtensionManagementService#install",K.toString());const Y=await this.downloadVsix(K),se=await(0,o.getManifest)(S.resolve(Y.fsPath));if(se.engines&&se.engines.vscode&&!(0,i.isEngineValid)(se.engines.vscode,I.default.version,I.default.date))throw new Error(d.localize(0,null,(0,f.getGalleryExtensionId)(se.publisher,se.name),I.default.version));return this.installExtension(se,Y,J)}async updateMetadata(K,J){return this.logService.trace("ExtensionManagementService#updateMetadata",K.identifier.id),K=await this.extensionsScanner.saveMetadataForLocalExtension(K,{...K.manifest.__metadata||{},...J}),this.manifestCache.invalidate(),K}async updateExtensionScope(K,J){return this.logService.trace("ExtensionManagementService#updateExtensionScope",K.identifier.id),K=await this.extensionsScanner.saveMetadataForLocalExtension(K,{...K.manifest.__metadata||{},isMachineScoped:J}),this.manifestCache.invalidate(),K}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(K){if(K.scheme===P.Schemas.file)return K;if(!this.downloadService)throw new Error("Download service is not available");const J=(0,D.joinPath)(this.environmentService.tmpDir,(0,g.generateUuid)());return await this.downloadService.download(K,J),J}createInstallExtensionTask(K,J,Y){return l.URI.isUri(J)?new ie(K,J,Y,this.galleryService,this.extensionsScanner,this.logService):new Q(J,Y,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(K,J){return new oe(K,J,this.extensionsScanner)}async collectFiles(K){const J=async se=>{let B=await m.Promises.readdir(se);B=B.map(z=>S.join(se,z));const O=await Promise.all(B.map(z=>m.Promises.stat(z)));let x=Promise.resolve([]);return O.forEach((z,W)=>{const j=B[W];z.isFile()&&(x=x.then(k=>[...k,j])),z.isDirectory()&&(x=x.then(k=>J(j).then(A=>[...k,...A])))}),x};return(await J(K.location.fsPath)).map(se=>({path:`extension/${S.relative(K.location.fsPath,se)}`,localPath:se}))}};M=fe([he(0,v.IExtensionGalleryService),he(1,F.ITelemetryService),he(2,E.ILogService),he(3,c.INativeEnvironmentService),he(4,(0,a.optional)(y.IDownloadService)),he(5,a.IInstantiationService),he(6,r.IFileService)],M),t.ExtensionManagementService=M;class $ extends u.AbstractExtensionTask{constructor(K,J,Y,se){super();this.identifier=K,this.source=J,this.extensionsScanner=Y,this.logService=se,this._operation=1}get operation(){return this._operation}async installExtension(K,J){try{const Y=await this.unsetUninstalledAndGetLocal(K.identifierWithVersion);if(Y)return K.metadata?this.extensionsScanner.saveMetadataForLocalExtension(Y,K.metadata):Y}catch(Y){throw C.isMacintosh?new v.ExtensionManagementError(d.localize(1,null),w):new v.ExtensionManagementError(d.localize(2,null),w)}return this.extract(K,J)}async unsetUninstalledAndGetLocal(K){if(!await this.isUninstalled(K))return null;this.logService.trace("Removing the extension from uninstalled list:",K.id);const Y=await this.extensionsScanner.setInstalled(K);return this.logService.info("Removed the extension from uninstalled list:",K.id),Y}async isUninstalled(K){return!!(await this.extensionsScanner.getUninstalledExtensions())[K.key()]}async extract({zipPath:K,identifierWithVersion:J,metadata:Y},se){let B=await this.extensionsScanner.extractUserExtension(J,K,Y,se);return this.logService.info("Extracting completed.",J.id),B}}class Q extends ${constructor(K,J,Y,se,B){super(K.identifier,K,se,B);this.gallery=K,this.options=J,this.extensionsDownloader=Y}async doRun(K){const Y=(await this.extensionsScanner.scanExtensions(null)).find(O=>(0,f.areSameExtensions)(O.identifier,this.gallery.identifier));Y&&(this._operation=2);const se=await this.downloadInstallableExtension(this.gallery,this._operation);se.metadata.isMachineScoped=this.options.isMachineScoped||Y?.isMachineScoped,se.metadata.isBuiltin=this.options.isBuiltin||Y?.isBuiltin;const B=await this.installExtension(se,K);Y&&R.neq(Y.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(Y);try{await this.extensionsDownloader.delete(l.URI.file(se.zipPath))}catch(O){}return B}async downloadInstallableExtension(K,J){const Y={id:K.identifier.uuid,publisherId:K.publisherId,publisherDisplayName:K.publisherDisplayName};let se;try{this.logService.trace("Started downloading extension:",K.identifier.id),se=(await this.extensionsDownloader.downloadExtension(K,J)).fsPath,this.logService.info("Downloaded extension:",K.identifier.id,se)}catch(B){throw new v.ExtensionManagementError((0,u.joinErrors)(B).message,L)}try{const B=await(0,o.getManifest)(se);return{zipPath:se,identifierWithVersion:new f.ExtensionIdentifierWithVersion(K.identifier,B.version),metadata:Y}}catch(B){throw new v.ExtensionManagementError((0,u.joinErrors)(B).message,u.INSTALL_ERROR_VALIDATING)}}}class ie extends ${constructor(K,J,Y,se,B,O){super({id:(0,f.getGalleryExtensionId)(K.publisher,K.name)},J,B,O);this.manifest=K,this.location=J,this.options=Y,this.galleryService=se}async doRun(K){const J=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),se=(await this.extensionsScanner.scanExtensions(1)).find(O=>(0,f.areSameExtensions)(this.identifier,O.identifier)),B=await this.getMetadata(this.identifier.id,K);if(B.isMachineScoped=this.options.isMachineScoped||se?.isMachineScoped,B.isBuiltin=this.options.isBuiltin||se?.isBuiltin,se)if(this._operation=2,J.equals(new f.ExtensionIdentifierWithVersion(se.identifier,se.manifest.version)))try{await this.extensionsScanner.removeExtension(se,"existing")}catch(O){throw new Error(d.localize(3,null,this.manifest.displayName||this.manifest.name))}else R.gt(se.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(se);else{const O=await this.unsetUninstalledAndGetLocal(J);if(O)try{await this.extensionsScanner.removeExtension(O,"existing")}catch(x){throw new Error(d.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:S.resolve(this.location.fsPath),identifierWithVersion:J,metadata:B},K)}async getMetadata(K,J){try{const Y=(await this.galleryService.query({names:[K],pageSize:1},J)).firstPage[0];if(Y)return{id:Y.identifier.uuid,publisherDisplayName:Y.publisherDisplayName,publisherId:Y.publisherId}}catch(Y){}return{}}}class oe extends u.AbstractExtensionTask{constructor(K,J,Y){super();this.extension=K,this.options=J,this.extensionsScanner=Y}async doRun(K){const J=[],Y=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const se=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);J.push(...Y.filter(B=>se.equals(new f.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version))))}else J.push(...Y.filter(se=>(0,f.areSameExtensions)(se.identifier,this.extension.identifier)));if(!J.length)throw new Error(d.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...J),this.options.remove)for(const se of J)try{K.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(se)}catch(B){throw new Error(d.localize(6,null,(0,T.toErrorMessage)(B)))}}}}),define(ee[125],te([0,1,113,16,11,2,12,26,20,99,15,112,134]),function(_,t,T,P,S,C,D,R,l,g,m,b,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let y=class extends C.Disposable{constructor(u,v,f){super();this.environmentService=v,this.logService=f,this.configure(u.getValue()),this._register(u.onDidChangeConfiguration(()=>this.configure(u.getValue()),this))}configure(u){this.proxyUrl=u.http&&u.http.proxy,this.strictSSL=!!(u.http&&u.http.proxyStrictSSL),this.authorization=u.http&&u.http.proxyAuthorization}async request(u,v){this.logService.trace("RequestService#request",u.url);const{proxyUrl:f,strictSSL:p}=this,h={...process.env,...await(0,g.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=u.agent?u.agent:await(0,b.getProxyAgent)(u.url||"",h,{proxyUrl:f,strictSSL:p});return u.agent=o,u.strictSSL=p,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this._request(u,v)}async getNodeRequest(u){return((0,T.parse)(u.url).protocol==="https:"?await new Promise((p,h)=>{_(["https"],p,h)}):await new Promise((p,h)=>{_(["http"],p,h)})).request}_request(u,v){return new Promise(async(f,p)=>{let h;const o=(0,T.parse)(u.url),s=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,D.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(e.auth=u.user+":"+u.password),h=s(e,n=>{const i=(0,D.isNumber)(u.followRedirects)?u.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...u,url:n.headers.location,followRedirects:i-1},v).then(f,p);else{let r=n;n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,d.createGunzip)())),f({res:n,stream:(0,P.streamToBufferReadableStream)(r)})}}),h.on("error",p),u.timeout&&h.setTimeout(u.timeout),u.data&&typeof u.data=="string"&&h.write(u.data),h.end(),v.onCancellationRequested(()=>{h.abort(),p((0,S.canceled)())})})}async resolveProxy(u){}};y=fe([he(0,R.IConfigurationService),he(1,l.INativeEnvironmentService),he(2,m.ILogService)],y),t.RequestService=y}),define(ee[135],te([0,1,38,136,33,3,16,28,11,2,9,4,29,7,10,26,111,20,89,119,23,97,124,17,107,108,51,101,53,54,105,15,106,35,42,56,125,116,36,118,43,120,121]),function(_,t,T,P,S,C,D,R,l,g,m,b,d,y,c,u,v,f,p,h,o,s,e,n,i,r,a,E,I,F,w,L,M,$,Q,ie,oe,Z,K,J,Y,se,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class O extends g.Disposable{constructor(W){super();this.argv=W,(0,P.gracefulify)(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[W,j]=await this.initServices();return W.invokeFunction(async k=>{const A=k.get(L.ILogService),U=k.get(n.IFileService),V=k.get(f.INativeEnvironmentService),G=k.get(o.IExtensionManagementCLIService);return A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(V,G,U),(0,C.raceTimeout)((0,Y.combinedAppender)(...j).flush(),1e3)})}async initServices(){const W=new I.ServiceCollection,j={_serviceBrand:void 0,...$.default};W.set(Q.IProductService,j);const k=new p.NativeEnvironmentService(this.argv,j);W.set(f.INativeEnvironmentService,k),await Promise.all([k.appSettingsHome.fsPath,k.extensionsPath].map(ue=>ue?c.Promises.mkdir(ue,{recursive:!0}):void 0));const A=(0,L.getLogLevel)(k),U=[];U.push(new M.SpdLogLogger("cli",(0,b.join)(k.logsPath,"cli.log"),!0,A)),A===L.LogLevel.Trace&&U.push(new L.ConsoleLogger(A));const V=this._register(new L.MultiplexLogService(U));W.set(L.ILogService,V);const G=this._register(new i.FileService(V));W.set(n.IFileService,G);const X=this._register(new r.DiskFileSystemProvider(V));G.registerProvider(m.Schemas.file,X);const re=this._register(new v.ConfigurationService(k.settingsResource,G));W.set(u.IConfigurationService,re),await re.initialize(),W.set(ie.IRequestService,new a.SyncDescriptor(oe.RequestService)),W.set(o.IExtensionManagementService,new a.SyncDescriptor(e.ExtensionManagementService)),W.set(o.IExtensionGalleryService,new a.SyncDescriptor(h.ExtensionGalleryService)),W.set(o.IExtensionManagementCLIService,new a.SyncDescriptor(s.ExtensionManagementCLIService)),W.set(F.ILocalizationsService,new a.SyncDescriptor(w.LocalizationsService));const ne=[];if((0,Y.getTelemetryLevel)(j,k)>=2){j.aiConfig&&j.aiConfig.asimovKey&&ne.push(new se.AppInsightsAppender("monacoworkbench",null,j.aiConfig.asimovKey));const{appRoot:ue,extensionsPath:de,installSourcePath:ge}=k,Ee={appender:(0,Y.combinedAppender)(...ne),sendErrorTelemetry:!1,commonProperties:(async()=>{let ye;try{const be=await c.Promises.readFile((0,b.join)(k.userDataPath,"storage.json"));ye=JSON.parse(be.toString())[K.machineIdKey]}catch(be){be.code!=="ENOENT"&&V.error(be)}return(0,Z.resolveCommonProperties)(G,(0,S.release)(),(0,S.hostname)(),process.arch,j.commit,j.version,ye,j.msftInternalDomains,ge)})(),piiPaths:[ue,de]};W.set(K.ITelemetryService,new a.SyncDescriptor(J.TelemetryService,[Ee]))}else W.set(K.ITelemetryService,Y.NullTelemetryService);return[new E.InstantiationService(W),ne]}registerErrorHandler(W){(0,l.setUnexpectedErrorHandler)(j=>{const k=(0,R.toErrorMessage)(j,!0);!k||W.error(`[uncaught exception in CLI]: ${k}`)}),process.on("uncaughtException",j=>(0,l.onUnexpectedError)(j)),process.on("unhandledRejection",j=>(0,l.onUnexpectedError)(j))}async doRun(W,j,k){if(this.argv["install-source"])return this.setInstallSource(W,k,this.argv["install-source"]);if(this.argv["list-extensions"])return j.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return j.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return j.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return j.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,B.buildTelemetryMessage)(W.appRoot,W.extensionsPath))}asExtensionIdOrVSIX(W){return W.map(j=>/\.vsix$/i.test(j)?y.URI.file((0,b.isAbsolute)(j)?j:(0,b.join)((0,d.cwd)(),j)):j)}async setInstallSource(W,j,k){await j.writeFile(y.URI.file(W.installSourcePath),D.VSBuffer.fromString(k.slice(0,30)))}}async function x(z){const W=new O(z);try{await W.run()}finally{W.dispose()}}t.main=x})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/87260247dc7b912db6e6a21a366e6f50dca759ba/core/vs/code/node/cliProcessMain.js.map
