/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/base/common/process","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(J){for(var e=[],m=0,L=J.length;m<L;m++)e[m]=me[J[m]];return e};define(me[56],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,I){if(!L)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=m}),define(me[57],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function L(n){const A=[];for(let u in n)m.call(n,u)&&A.push(n[u]);return A}e.values=L;function I(n,A){for(let u in n)if(m.call(n,u)&&A({key:u,value:n[u]},function(){delete n[u]})===!1)return}e.forEach=I;function k(n,A){const u=Object.create(null);for(const f of n){const o=A(f);let v=u[o];v||(v=u[o]=[]),v.push(f)}return u}e.groupBy=k;function R(n){const A=Object.create(null);return n&&n.forEach((u,f)=>{A[f]=u}),A}e.fromMap=R;function C(n,A){const u=[],f=[];for(let o of n)A.has(o)||u.push(o);for(let o of A)n.has(o)||f.push(o);return{removed:u,added:f}}e.diffSets=C;function D(n,A){const u=[],f=[];for(let[o,v]of n)A.has(o)||u.push(v);for(let[o,v]of A)n.has(o)||f.push(v);return{removed:u,added:f}}e.diffMaps=D;class T{constructor(){this.map=new Map}add(A,u){let f=this.map.get(A);f||(f=new Set,this.map.set(A,f)),f.add(u)}delete(A,u){const f=this.map.get(A);!f||(f.delete(u),f.size===0&&this.map.delete(A))}forEach(A,u){const f=this.map.get(A);!f||f.forEach(u)}}e.SetMap=T}),define(me[58],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(R){return(C,D,T)=>{let n=null,A=null;if(typeof T.value=="function"?(n="value",A=T.value):typeof T.get=="function"&&(n="get",A=T.get),!A)throw new Error("not supported");T[n]=R(A,D)}}e.createDecorator=m;function L(R,C,D){let T=null,n=null;if(typeof D.value=="function"?(T="value",n=D.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(T="get",n=D.get),!n)throw new Error("not supported");const A=`$memoize$${C}`;D[T]=function(...u){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,u)}),this[A]}}e.memoize=L;function I(R,C,D){return m((T,n)=>{const A=`$debounce$${n}`,u=`$debounce$result$${n}`;return function(...f){this[u]||(this[u]=D?D():void 0),clearTimeout(this[A]),C&&(this[u]=C(this[u],...f),f=[this[u]]),this[A]=setTimeout(()=>{T.apply(this,f),this[u]=D?D():void 0},R)}})}e.debounce=I;function k(R,C,D){return m((T,n)=>{const A=`$throttle$timer$${n}`,u=`$throttle$result$${n}`,f=`$throttle$lastRun$${n}`,o=`$throttle$pending$${n}`;return function(...v){if(this[u]||(this[u]=D?D():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[u]=C(this[u],...v)),this[o])return;const S=this[f]+R;S<=Date.now()?(this[f]=Date.now(),T.apply(this,[this[u]]),this[u]=D?D():void 0):(this[o]=!0,this[A]=setTimeout(()=>{this[o]=!1,this[f]=Date.now(),T.apply(this,[this[u]]),this[u]=D?D():void 0},S-Date.now()))}})}e.throttle=k}),define(me[16],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function L(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=L;function I(p){D(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=I;function k(p){D(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=k;function R(p){if(p instanceof Error){let{name:t,message:s}=p;const r=p.stacktrace||p.stack;return{$isError:!0,name:t,message:s,stack:r}}return p}e.transformErrorForSerialization=R;const C="Canceled";function D(p){return p instanceof Error&&p.name===C&&p.message===C}e.isPromiseCanceledError=D;class T extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=T;function n(){const p=new Error(C);return p.name=p.message,p}e.canceled=n;function A(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=A;function u(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=u;function f(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function o(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function v(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=v;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class P extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=P;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function a(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=a;function l(p,t=Object.create(null)){const s=new Error(p);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=l}),define(me[17],ge([0,1,16]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(H,Q=0){return H[H.length-(1+Q)]}e.tail=L;function I(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=I;function k(H,Q,X=(fe,_e)=>fe===_e){if(H===Q)return!0;if(!H||!Q||H.length!==Q.length)return!1;for(let fe=0,_e=H.length;fe<_e;fe++)if(!X(H[fe],Q[fe]))return!1;return!0}e.equals=k;function R(H,Q,X){let fe=0,_e=H.length-1;for(;fe<=_e;){const ye=(fe+_e)/2|0,Re=X(H[ye],Q);if(Re<0)fe=ye+1;else if(Re>0)_e=ye-1;else return ye}return-(fe+1)}e.binarySearch=R;function C(H,Q){let X=0,fe=H.length;if(fe===0)return 0;for(;X<fe;){const _e=Math.floor((X+fe)/2);Q(H[_e])?fe=_e:X=_e+1}return X}e.findFirstInSorted=C;function D(H,Q,X){if(H=H|0,H>=Q.length)throw new TypeError("invalid index");let fe=Q[Math.floor(Q.length*Math.random())],_e=[],ye=[],Re=[];for(let $e of Q){const Be=X($e,fe);Be<0?_e.push($e):Be>0?ye.push($e):Re.push($e)}return H<_e.length?D(H,_e,X):H<_e.length+Re.length?Re[0]:D(H-(_e.length+Re.length),ye,X)}e.quickSelect=D;function T(H,Q){const X=[];let fe;for(const _e of H.slice(0).sort(Q))!fe||Q(fe[0],_e)!==0?(fe=[_e],X.push(fe)):fe.push(_e);return X}e.groupBy=T;function n(H,Q,X){const fe=[];function _e($e,Be,je){if(Be===0&&je.length===0)return;const V=fe[fe.length-1];V&&V.start+V.deleteCount===$e?(V.deleteCount+=Be,V.toInsert.push(...je)):fe.push({start:$e,deleteCount:Be,toInsert:je})}let ye=0,Re=0;for(;;){if(ye===H.length){_e(ye,0,Q.slice(Re));break}if(Re===Q.length){_e(ye,H.length-ye,[]);break}const $e=H[ye],Be=Q[Re],je=X($e,Be);je===0?(ye+=1,Re+=1):je<0?(_e(ye,1,[]),ye+=1):je>0&&(_e(ye,0,[Be]),Re+=1)}return fe}e.sortedDiff=n;function A(H,Q,X){const fe=n(H,Q,X),_e=[],ye=[];for(const Re of fe)_e.push(...H.slice(Re.start,Re.start+Re.deleteCount)),ye.push(...Re.toInsert);return{removed:_e,added:ye}}e.delta=A;function u(H,Q,X){if(X===0)return[];const fe=H.slice(0,X).sort(Q);return o(H,Q,fe,X,H.length),fe}e.top=u;function f(H,Q,X,fe,_e){return X===0?Promise.resolve([]):new Promise((ye,Re)=>{(async()=>{const $e=H.length,Be=H.slice(0,X).sort(Q);for(let je=X,V=Math.min(X+fe,$e);je<$e;je=V,V=Math.min(V+fe,$e)){if(je>X&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,m.canceled)();o(H,Q,Be,je,V)}return Be})().then(ye,Re)})}e.topAsync=f;function o(H,Q,X,fe,_e){for(const ye=X.length;fe<_e;fe++){const Re=H[fe];if(Q(Re,X[ye-1])<0){X.pop();const $e=C(X,Be=>Q(Re,Be)<0);X.splice($e,0,Re)}}}function v(H){return H.filter(Q=>!!Q)}e.coalesce=v;function S(H){let Q=0;for(let X=0;X<H.length;X++)H[X]&&(H[Q]=H[X],Q+=1);H.length=Q}e.coalesceInPlace=S;function P(H,Q,X){H.splice(X,0,H.splice(Q,1)[0])}e.move=P;function E(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=E;function a(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=a;function l(H,Q){if(!Q)return H.filter((fe,_e)=>H.indexOf(fe)===_e);const X=Object.create(null);return H.filter(fe=>{const _e=Q(fe);return X[_e]?!1:(X[_e]=!0,!0)})}e.distinct=l;function p(H){const Q=new Set;return H.filter(X=>Q.has(X)?!1:(Q.add(X),!0))}e.distinctES6=p;function t(H){const Q=Object.create(null);return X=>{const fe=H(X);return Q[fe]?!1:(Q[fe]=!0,!0)}}e.uniqueFilter=t;function s(H,Q){for(let X=H.length-1;X>=0;X--){const fe=H[X];if(Q(fe))return X}return-1}e.lastIndex=s;function r(H,Q){return H.length>0?H[0]:Q}e.firstOrDefault=r;function i(H,Q,X=(fe,_e)=>fe===_e){let fe=0;for(let _e=0,ye=Math.min(H.length,Q.length);_e<ye&&X(H[_e],Q[_e]);_e++)fe++;return fe}e.commonPrefixLength=i;function h(H){return[].concat(...H)}e.flatten=h;function c(H,Q){let X=typeof Q=="number"?H:0;typeof Q=="number"?X=H:(X=0,Q=H);const fe=[];if(X<=Q)for(let _e=X;_e<Q;_e++)fe.push(_e);else for(let _e=X;_e>Q;_e--)fe.push(_e);return fe}e.range=c;function d(H,Q,X){return H.reduce((fe,_e)=>(fe[Q(_e)]=X?X(_e):_e,fe),Object.create(null))}e.index=d;function b(H,Q){return H.push(Q),()=>y(H,Q)}e.insert=b;function y(H,Q){const X=H.indexOf(Q);if(X>-1)return H.splice(X,1),Q}e.remove=y;function g(H,Q,X){const fe=H.slice(0,Q),_e=H.slice(Q);return fe.concat(X,_e)}e.arrayInsert=g;function _(H,Q){let X;if(typeof Q=="number"){let fe=Q;X=()=>{const _e=Math.sin(fe++)*179426549;return _e-Math.floor(_e)}}else X=Math.random;for(let fe=H.length-1;fe>0;fe-=1){const _e=Math.floor(X()*(fe+1)),ye=H[fe];H[fe]=H[_e],H[_e]=ye}}e.shuffle=_;function w(H,Q){const X=H.indexOf(Q);X>-1&&(H.splice(X,1),H.unshift(Q))}e.pushToStart=w;function F(H,Q){const X=H.indexOf(Q);X>-1&&(H.splice(X,1),H.push(Q))}e.pushToEnd=F;function O(H,Q){return Array.isArray(H)?H.map(Q):Q(H)}e.mapArrayOrNot=O;function G(H){return Array.isArray(H)?H:[H]}e.asArray=G;function K(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=K;function U(H,Q){for(const X of H){const fe=Q(X);if(fe!==void 0)return fe}}e.mapFind=U;function W(H,Q,X){const fe=x(H,Q),_e=H.length,ye=X.length;H.length=_e+ye;for(let Re=_e-1;Re>=fe;Re--)H[Re+ye]=H[Re];for(let Re=0;Re<ye;Re++)H[Re+fe]=X[Re]}e.insertInto=W;function M(H,Q,X,fe){const _e=x(H,Q),ye=H.splice(_e,X);return W(H,_e,fe),ye}e.splice=M;function x(H,Q){return Q<0?Math.max(Q+H.length,0):Math.min(Q,H.length)}function B(H,Q){let X=Number.MAX_SAFE_INTEGER,fe=0;return H.forEach((_e,ye)=>{const Re=Q(_e);Re<X&&(X=Re,fe=ye)}),fe}e.minIndex=B;function N(H,Q){let X=Number.MIN_SAFE_INTEGER,fe=0;return H.forEach((_e,ye)=>{const Re=Q(_e);Re>X&&(X=Re,fe=ye)}),fe}e.maxIndex=N;class z{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let X=this.firstIdx;for(;X<this.items.length&&Q(this.items[X]);)X++;const fe=X===this.firstIdx?null:this.items.slice(this.firstIdx,X);return this.firstIdx=X,fe}takeFromEndWhile(Q){let X=this.lastIdx;for(;X>=0&&Q(this.items[X]);)X--;const fe=X===this.lastIdx?null:this.items.slice(X+1,this.lastIdx+1);return this.lastIdx=X,fe}}e.ArrayQueue=z}),define(me[75],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const I=this;let k=!1,R;return function(){return k||(k=!0,R=L.apply(I,arguments)),R}}e.once=m}),define(me[76],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(me[94],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function I(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}L.is=I;const k=Object.freeze([]);function R(){return k}L.empty=R;function*C(p){yield p}L.single=C;function D(p){return p||k}L.from=D;function T(p){return!p||p[Symbol.iterator]().next().done===!0}L.isEmpty=T;function n(p){return p[Symbol.iterator]().next().value}L.first=n;function A(p,t){for(const s of p)if(t(s))return!0;return!1}L.some=A;function u(p,t){for(const s of p)if(t(s))return s}L.find=u;function*f(p,t){for(const s of p)t(s)&&(yield s)}L.filter=f;function*o(p,t){let s=0;for(const r of p)yield t(r,s++)}L.map=o;function*v(...p){for(const t of p)for(const s of t)yield s}L.concat=v;function*S(p){for(const t of p)for(const s of t)yield s}L.concatNested=S;function P(p,t,s){let r=s;for(const i of p)r=t(r,i);return r}L.reduce=P;function*E(p,t,s=p.length){for(t<0&&(t+=p.length),s<0?s+=p.length:s>p.length&&(s=p.length);t<s;t++)yield p[t]}L.slice=E;function a(p,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,p];const r=p[Symbol.iterator]();for(let i=0;i<t;i++){const h=r.next();if(h.done)return[s,L.empty()];s.push(h.value)}return[s,{[Symbol.iterator](){return r}}]}L.consume=a;function l(p,t,s=(r,i)=>r===i){const r=p[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const h=r.next(),c=i.next();if(h.done!==c.done)return!1;if(h.done)return!0;if(!s(h.value,c.value))return!1}}L.equals=l})(m=e.Iterable||(e.Iterable={}))}),define(me[59],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function R(t,s=!1){let r=0,i=t.length,h="",c=0,d=16,b=0;function y(K){let U=0,W=0;for(;U<K;){const M=t.charCodeAt(r);if(M>=48&&M<=57)W=W*16+M-48;else if(M>=65&&M<=70)W=W*16+M-65+10;else if(M>=97&&M<=102)W=W*16+M-97+10;else break;r++,U++}return U<K&&(W=-1),W}function g(K){r=K,h="",c=0,d=16,b=0}function _(){const K=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&T(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&T(t.charCodeAt(r)))for(r++;r<t.length&&T(t.charCodeAt(r));)r++;else return b=3,t.substring(K,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&T(t.charCodeAt(r))){for(r++;r<t.length&&T(t.charCodeAt(r));)r++;U=r}else b=3;return t.substring(K,U)}function w(){let K="",U=r;for(;;){if(r>=i){K+=t.substring(U,r),b=2;break}const W=t.charCodeAt(r);if(W===34){K+=t.substring(U,r),r++;break}if(W===92){if(K+=t.substring(U,r),r++,r>=i){b=2;break}switch(t.charCodeAt(r++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const x=y(4);x>=0?K+=String.fromCharCode(x):b=4;break;default:b=5}U=r;continue}if(W>=0&&W<=31)if(D(W)){K+=t.substring(U,r),b=2;break}else b=6;r++}return K}function F(){if(h="",b=0,c=r,r>=i)return c=i,d=17;let K=t.charCodeAt(r);if(C(K)){do r++,h+=String.fromCharCode(K),K=t.charCodeAt(r);while(C(K));return d=15}if(D(K))return r++,h+=String.fromCharCode(K),K===13&&t.charCodeAt(r)===10&&(r++,h+=`
`),d=14;switch(K){case 123:return r++,d=1;case 125:return r++,d=2;case 91:return r++,d=3;case 93:return r++,d=4;case 58:return r++,d=6;case 44:return r++,d=5;case 34:return r++,h=w(),d=10;case 47:const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!D(t.charCodeAt(r));)r++;return h=t.substring(U,r),d=12}if(t.charCodeAt(r+1)===42){r+=2;const W=i-1;let M=!1;for(;r<W;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,M=!0;break}r++}return M||(r++,b=1),h=t.substring(U,r),d=13}return h+=String.fromCharCode(K),r++,d=16;case 45:if(h+=String.fromCharCode(K),r++,r===i||!T(t.charCodeAt(r)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=_(),d=11;default:for(;r<i&&O(K);)r++,K=t.charCodeAt(r);if(c!==r){switch(h=t.substring(c,r),h){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return h+=String.fromCharCode(K),r++,d=16}}function O(K){if(C(K)||D(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let K;do K=F();while(K>=12&&K<=15);return K}return{setPosition:g,getPosition:()=>r,scan:s?G:F,getToken:()=>d,getTokenValue:()=>h,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>b}}e.createScanner=R;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function T(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function A(t,s){const r=[],i=new Object;let h;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function b(y,g,_,w){c.value=y,c.offset=g,c.length=_,c.type=w,c.colonOffset=void 0,h=c}try{a(t,{onObjectBegin:(y,g)=>{if(s<=y)throw i;h=void 0,d=s>y,r.push("")},onObjectProperty:(y,g,_)=>{if(s<g||(b(y,g,_,"property"),r[r.length-1]=y,s<=g+_))throw i},onObjectEnd:(y,g)=>{if(s<=y)throw i;h=void 0,r.pop()},onArrayBegin:(y,g)=>{if(s<=y)throw i;h=void 0,r.push(0)},onArrayEnd:(y,g)=>{if(s<=y)throw i;h=void 0,r.pop()},onLiteralValue:(y,g,_)=>{if(s<g||(b(y,g,_,p(y)),s<=g+_))throw i},onSeparator:(y,g,_)=>{if(s<=g)throw i;if(y===":"&&h&&h.type==="property")h.colonOffset=g,d=!1,h=void 0;else if(y===","){const w=r[r.length-1];typeof w=="number"?r[r.length-1]=w+1:(d=!0,r[r.length-1]=""),h=void 0}}})}catch(y){if(y!==i)throw y}return{path:r,previousNode:h,isAtPropertyKey:d,matches:y=>{let g=0;for(let _=0;g<y.length&&_<r.length;_++)if(y[g]===r[_]||y[g]==="*")g++;else if(y[g]!=="**")return!1;return g===y.length}}}e.getLocation=A;function u(t,s=[],r=k.DEFAULT){let i=null,h=[];const c=[];function d(y){Array.isArray(h)?h.push(y):i!==null&&(h[i]=y)}return a(t,{onObjectBegin:()=>{const y={};d(y),c.push(h),h=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{h=c.pop()},onArrayBegin:()=>{const y=[];d(y),c.push(h),h=y,i=null},onArrayEnd:()=>{h=c.pop()},onLiteralValue:d,onError:(y,g,_)=>{s.push({error:y,offset:g,length:_})}},r),h[0]}e.parse=u;function f(t,s=[],r=k.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function c(y){return i.children.push(y),y}a(t,{onObjectBegin:y=>{i=c({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,g,_)=>{i=c({type:"property",offset:g,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:g,length:_,parent:i})},onObjectEnd:(y,g)=>{i.length=y+g-i.offset,i=i.parent,h(y+g)},onArrayBegin:(y,g)=>{i=c({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,g)=>{i.length=y+g-i.offset,i=i.parent,h(y+g)},onLiteralValue:(y,g,_)=>{c({type:p(y),offset:g,length:_,parent:i,value:y}),h(g+_)},onSeparator:(y,g,_)=>{i.type==="property"&&(y===":"?i.colonOffset=g:y===","&&h(g))},onError:(y,g,_)=>{s.push({error:y,offset:g,length:_})}},r);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=f;function o(t,s){if(!t)return;let r=t;for(let i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let h=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===i){r=c.children[1],h=!0;break}if(!h)return}else{const h=i;if(r.type!=="array"||h<0||!Array.isArray(r.children)||h>=r.children.length)return;r=r.children[h]}return r}e.findNodeAtLocation=o;function v(t){if(!t.parent||!t.parent.children)return[];const s=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=v;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const s=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=S(i))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function P(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=P;function E(t,s,r=!1){if(P(t,s,r)){const i=t.children;if(Array.isArray(i))for(let h=0;h<i.length&&i[h].offset<=s;h++){const c=E(i[h],s,r);if(c)return c}return t}}e.findNodeAtOffset=E;function a(t,s,r=k.DEFAULT){const i=R(t,!1);function h(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(X){return X?fe=>X(fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const d=h(s.onObjectBegin),b=c(s.onObjectProperty),y=h(s.onObjectEnd),g=h(s.onArrayBegin),_=h(s.onArrayEnd),w=c(s.onLiteralValue),F=c(s.onSeparator),O=h(s.onComment),G=c(s.onError),K=r&&r.disallowComments,U=r&&r.allowTrailingComma;function W(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:K||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(X){case 12:case 13:K?M(10):O();break;case 16:M(1);break;case 15:case 14:break;default:return X}}}function M(X,fe=[],_e=[]){if(G(X),fe.length+_e.length>0){let ye=i.getToken();for(;ye!==17;){if(fe.indexOf(ye)!==-1){W();break}else if(_e.indexOf(ye)!==-1)break;ye=W()}}}function x(X){const fe=i.getTokenValue();return X?w(fe):b(fe),W(),!0}function B(){switch(i.getToken()){case 11:let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(M(2),X=0)}catch(fe){M(2)}w(X);break;case 7:w(null);break;case 8:w(!0);break;case 9:w(!1);break;default:return!1}return W(),!0}function N(){return i.getToken()!==10?(M(3,[],[2,5]),!1):(x(!1),i.getToken()===6?(F(":"),W(),Q()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function z(){d(),W();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||M(4,[],[]),F(","),W(),i.getToken()===2&&U)break}else X&&M(6,[],[]);N()||M(4,[],[2,5]),X=!0}return y(),i.getToken()!==2?M(7,[2],[]):W(),!0}function H(){g(),W();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||M(4,[],[]),F(","),W(),i.getToken()===4&&U)break}else X&&M(6,[],[]);Q()||M(4,[],[4,5]),X=!0}return _(),i.getToken()!==4?M(8,[4],[]):W(),!0}function Q(){switch(i.getToken()){case 3:return H();case 1:return z();case 10:return x(!0);default:return B()}}return W(),i.getToken()===17?r.allowEmptyContent?!0:(M(4,[],[]),!1):Q()?(i.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=a;function l(t,s){let r=R(t),i=[],h,c=0,d;do switch(d=r.getPosition(),h=r.scan(),h){case 12:case 13:case 17:c!==d&&i.push(t.substring(c,d)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),c=r.getPosition();break}while(h!==17);return i.join("")}e.stripComments=l;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(me[137],ge([0,1,59]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(D,T,n){let A,u,f,o,v;if(T){for(o=T.offset,v=o+T.length,f=o;f>0&&!C(D,f-1);)f--;let c=v;for(;c<D.length&&!C(D,c);)c++;u=D.substring(f,c),A=k(u,n)}else u=D,A=0,f=0,o=0,v=D.length;const S=R(n,D);let P=!1,E=0,a;n.insertSpaces?a=I(" ",n.tabSize||4):a="	";const l=(0,m.createScanner)(u,!1);let p=!1;function t(){return S+I(a,A+E)}function s(){let c=l.scan();for(P=!1;c===15||c===14;)P=P||c===14,c=l.scan();return p=c===16||l.getTokenError()!==0,c}const r=[];function i(c,d,b){!p&&d<v&&b>o&&D.substring(d,b)!==c&&r.push({offset:d,length:b-d,content:c})}let h=s();if(h!==17){const c=l.getTokenOffset()+f,d=I(a,A);i(d,f,c)}for(;h!==17;){let c=l.getTokenOffset()+l.getTokenLength()+f,d=s(),b="";for(;!P&&(d===12||d===13);){const g=l.getTokenOffset()+f;i(" ",c,g),c=l.getTokenOffset()+l.getTokenLength()+f,b=d===12?t():"",d=s()}if(d===2)h!==1&&(E--,b=t());else if(d===4)h!==3&&(E--,b=t());else{switch(h){case 3:case 1:E++,b=t();break;case 5:case 12:b=t();break;case 13:P?b=t():b=" ";break;case 6:b=" ";break;case 10:if(d===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?b=" ":d!==5&&d!==17&&(p=!0);break;case 16:p=!0;break}P&&(d===12||d===13)&&(b=t())}const y=l.getTokenOffset()+f;i(b,c,y),h=d}return r}e.format=L;function I(D,T){let n="";for(let A=0;A<T;A++)n+=D;return n}function k(D,T){let n=0,A=0;const u=T.tabSize||4;for(;n<D.length;){const f=D.charAt(n);if(f===" ")A++;else if(f==="	")A+=u;else break;n++}return Math.floor(A/u)}function R(D,T){for(let n=0;n<T.length;n++){const A=T.charAt(n);if(A==="\r")return n+1<T.length&&T.charAt(n+1)===`
`?`\r
`:"\r";if(A===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=R;function C(D,T){return`\r
`.indexOf(D.charAt(T))!==-1}e.isEOL=C}),define(me[138],ge([0,1,59,137]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(T,n,A){return k(T,n,void 0,A)}e.removeProperty=I;function k(T,n,A,u,f){const o=n.slice(),v=[],S=(0,m.parseTree)(T,v);let P,E;for(;o.length>0&&(E=o.pop(),P=(0,m.findNodeAtLocation)(S,o),P===void 0&&A!==void 0);)typeof E=="string"?A={[E]:A}:A=[A];if(P)if(P.type==="object"&&typeof E=="string"&&Array.isArray(P.children)){const a=(0,m.findNodeAtLocation)(P,[E]);if(a!==void 0)if(A===void 0){if(!a.parent)throw new Error("Malformed AST");const l=P.children.indexOf(a.parent);let p,t=a.parent.offset+a.parent.length;if(l>0){const s=P.children[l-1];p=s.offset+s.length}else p=P.offset+1,P.children.length>1&&(t=P.children[1].offset);return R(T,{offset:p,length:t-p,content:""},u)}else return R(T,{offset:a.offset,length:a.length,content:JSON.stringify(A)},u);else{if(A===void 0)return[];const l=`${JSON.stringify(E)}: ${JSON.stringify(A)}`,p=f?f(P.children.map(s=>s.children[0].value)):P.children.length;let t;if(p>0){const s=P.children[p-1];t={offset:s.offset+s.length,length:0,content:","+l}}else P.children.length===0?t={offset:P.offset+1,length:0,content:l}:t={offset:P.offset+1,length:0,content:l+","};return R(T,t,u)}}else if(P.type==="array"&&typeof E=="number"&&Array.isArray(P.children))if(A!==void 0){const a=`${JSON.stringify(A)}`;let l;if(P.children.length===0||E===0)l={offset:P.offset+1,length:0,content:P.children.length===0?a:a+","};else{const p=E===-1||E>P.children.length?P.children.length:E,t=P.children[p-1];l={offset:t.offset+t.length,length:0,content:","+a}}return R(T,l,u)}else{const a=E,l=P.children[a];let p;if(P.children.length===1)p={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===a){const t=P.children[a-1],s=t.offset+t.length,r=P.offset+P.length;p={offset:s,length:r-2-s,content:""}}else p={offset:l.offset,length:P.children[a+1].offset-l.offset,content:""};return R(T,p,u)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${P.type}`);else{if(A===void 0)throw new Error("Can not delete in empty document");return R(T,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(A)},u)}}e.setProperty=k;function R(T,n,A){let u=C(T,n),f=n.offset,o=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;f>0&&!(0,L.isEOL)(u,f-1);)f--;for(;o<u.length&&!(0,L.isEOL)(u,o);)o++}const v=(0,L.format)(u,{offset:f,length:o-f},A);for(let P=v.length-1;P>=0;P--){const E=v[P];u=C(u,E),f=Math.min(f,E.offset),o=Math.max(o,E.offset+E.length),o+=E.content.length-E.length}const S=T.length-(u.length-o)-f;return[{offset:f,length:S,content:u.substring(f,o)}]}e.withFormatting=R;function C(T,n){return T.substring(0,n.offset)+n.content+T.substring(n.offset+n.length)}e.applyEdit=C;function D(T,n){let A=n.slice(0).sort((f,o)=>{const v=f.offset-o.offset;return v===0?f.length-o.length:v}),u=T.length;for(let f=A.length-1;f>=0;f--){let o=A[f];if(o.offset+o.length<=u)T=C(T,o);else throw new Error("Overlapping edit");u=o.offset}return T}e.applyEdits=D}),define(me[139],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new m(()=>I(this.getValue()))}}e.Lazy=m}),define(me[6],ge([0,1,75,94]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let k=null;function R(r){k=r}if(e.setDisposableTracker=R,I){const r="__is_disposable_tracked__";R(new class{trackDisposable(i){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(h)},3e3)}setParent(i,h){if(i&&i!==E.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==E.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function C(r){return k?.trackDisposable(r),r}function D(r){k?.markAsDisposed(r)}function T(r,i){k?.setParent(r,i)}function n(r,i){if(!!k)for(const h of r)k.setParent(h,i)}function A(r){return k?.markAsSingleton(r),r}e.markAsSingleton=A;class u extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=u;function f(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=f;function o(r){if(L.Iterable.is(r)){let i=[];for(const h of r)if(h)try{h.dispose()}catch(c){i.push(c)}if(i.length===1)throw i[0];if(i.length>1)throw new u(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=o;function v(...r){const i=S(()=>o(r));return n(r,i),i}e.combinedDisposable=v;function S(r){const i=C({dispose:(0,m.once)(()=>{D(i),r()})});return i}e.toDisposable=S;class P{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{o(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return T(i,this),this._isDisposed?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=P,P.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new P,C(this),T(this._store,this)}dispose(){D(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&T(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,D(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&T(i,null),i}}e.MutableDisposable=a;class l{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class p{constructor(){this.references=new Map}acquire(i,...h){let c=this.references.get(i);c||(c={counter:0,object:this.createReferencedObject(i,...h)},this.references.set(i,c));const{object:d}=c,b=(0,m.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(i,c.object),this.references.delete(i))});return c.counter++,{object:d,dispose:b}}}e.ReferenceCollection=p;class t{constructor(i){this.referenceCollection=i}async acquire(i,...h){const c=this.referenceCollection.acquire(i,...h);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(d){throw c.dispose(),d}}}e.AsyncReferenceCollection=t;class s{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=s}),define(me[95],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(k){this.element=k,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let k=this._first;for(;k!==m.Undefined;){const R=k.next;k.prev=m.Undefined,k.next=m.Undefined,k=R}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,R){const C=new m(k);if(this._first===m.Undefined)this._first=C,this._last=C;else if(R){const T=this._last;this._last=C,C.prev=T,T.next=C}else{const T=this._first;this._first=C,C.next=T,T.prev=C}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(C))}}shift(){if(this._first!==m.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==m.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==m.Undefined&&k.next!==m.Undefined){const R=k.prev;R.next=k.next,k.next.prev=R}else k.prev===m.Undefined&&k.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):k.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):k.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==m.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Le,De){for(var ke=0;ke<De.length;ke++){var ne=De[ke];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Le,ne.key,ne)}}function e(Le,De,ke){return De&&J(Le.prototype,De),ke&&J(Le,ke),Le}function m(Le,De){if(!!Le){if(typeof Le=="string")return L(Le,De);var ke=Object.prototype.toString.call(Le).slice(8,-1);if(ke==="Object"&&Le.constructor&&(ke=Le.constructor.name),ke==="Map"||ke==="Set")return Array.from(Le);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return L(Le,De)}}function L(Le,De){(De==null||De>Le.length)&&(De=Le.length);for(var ke=0,ne=new Array(De);ke<De;ke++)ne[ke]=Le[ke];return ne}function I(Le,De){var ke=typeof Symbol!="undefined"&&Le[Symbol.iterator]||Le["@@iterator"];if(ke)return(ke=ke.call(Le)).next.bind(ke);if(Array.isArray(Le)||(ke=m(Le))||De&&Le&&typeof Le.length=="number"){ke&&(Le=ke);var ne=0;return function(){return ne>=Le.length?{done:!0}:{done:!1,value:Le[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var k={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Le){k.exports.defaults=Le}k.exports={defaults:R(),getDefaults:R,changeDefaults:C};var D=/[&<>"']/,T=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(De){return u[De]};function o(Le,De){if(De){if(D.test(Le))return Le.replace(T,f)}else if(n.test(Le))return Le.replace(A,f);return Le}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function S(Le){return Le.replace(v,function(De,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var P=/(^|[^\[])\^/g;function E(Le,De){Le=Le.source||Le,De=De||"";var ke={replace:function(de,be){return be=be.source||be,be=be.replace(P,"$1"),Le=Le.replace(de,be),ke},getRegex:function(){return new RegExp(Le,De)}};return ke}var a=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Le,De,ke){if(Le){var ne;try{ne=decodeURIComponent(S(ke)).replace(a,"").toLowerCase()}catch(de){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}De&&!l.test(ke)&&(ke=h(De,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(de){return null}return ke}var t={},s=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(Le,De){t[" "+Le]||(s.test(Le)?t[" "+Le]=Le+"/":t[" "+Le]=y(Le,"/",!0)),Le=t[" "+Le];var ke=Le.indexOf(":")===-1;return De.substring(0,2)==="//"?ke?De:Le.replace(r,"$1")+De:De.charAt(0)==="/"?ke?De:Le.replace(i,"$1")+De:Le+De}var c={exec:function(){}};function d(Le){for(var De=1,ke,ne;De<arguments.length;De++){ke=arguments[De];for(ne in ke)Object.prototype.hasOwnProperty.call(ke,ne)&&(Le[ne]=ke[ne])}return Le}function b(Le,De){var ke=Le.replace(/\|/g,function(be,we,Fe){for(var Ge=!1,He=we;--He>=0&&Fe[He]==="\\";)Ge=!Ge;return Ge?"|":" |"}),ne=ke.split(/ \|/),de=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>De)ne.splice(De);else for(;ne.length<De;)ne.push("");for(;de<ne.length;de++)ne[de]=ne[de].trim().replace(/\\\|/g,"|");return ne}function y(Le,De,ke){var ne=Le.length;if(ne===0)return"";for(var de=0;de<ne;){var be=Le.charAt(ne-de-1);if(be===De&&!ke)de++;else if(be!==De&&ke)de++;else break}return Le.substr(0,ne-de)}function g(Le,De){if(Le.indexOf(De[1])===-1)return-1;for(var ke=Le.length,ne=0,de=0;de<ke;de++)if(Le[de]==="\\")de++;else if(Le[de]===De[0])ne++;else if(Le[de]===De[1]&&(ne--,ne<0))return de;return-1}function _(Le){Le&&Le.sanitize&&!Le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(Le,De){if(De<1)return"";for(var ke="";De>1;)De&1&&(ke+=Le),De>>=1,Le+=Le;return ke+Le}var F={escape:o,unescape:S,edit:E,cleanUrl:p,resolveUrl:h,noopTest:c,merge:d,splitCells:b,rtrim:y,findClosingBracket:g,checkSanitizeDeprecation:_,repeatString:w},O=k.exports.defaults,G=F.rtrim,K=F.splitCells,U=F.escape,W=F.findClosingBracket;function M(Le,De,ke,ne){var de=De.href,be=De.title?U(De.title):null,we=Le[1].replace(/\\([\[\]])/g,"$1");return Le[0].charAt(0)!=="!"?(ne.state.inLink=!0,{type:"link",raw:ke,href:de,title:be,text:we,tokens:ne.inlineTokens(we,[])}):{type:"image",raw:ke,href:de,title:be,text:U(we)}}function x(Le,De){var ke=Le.match(/^(\s+)(?:```)/);if(ke===null)return De;var ne=ke[1];return De.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var we=be[0];return we.length>=ne.length?de.slice(ne.length):de}).join(`
`)}var B=function(){function Le(ke){this.options=ke||O}var De=Le.prototype;return De.space=function(ne){var de=this.rules.block.newline.exec(ne);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},De.code=function(ne){var de=this.rules.block.code.exec(ne);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:G(be,`
`)}}},De.fences=function(ne){var de=this.rules.block.fences.exec(ne);if(de){var be=de[0],we=x(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:we}}},De.heading=function(ne){var de=this.rules.block.heading.exec(ne);if(de){var be=de[2].trim();if(/#$/.test(be)){var we=G(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},De.hr=function(ne){var de=this.rules.block.hr.exec(ne);if(de)return{type:"hr",raw:de[0]}},De.blockquote=function(ne){var de=this.rules.block.blockquote.exec(ne);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},De.list=function(ne){var de=this.rules.block.list.exec(ne);if(de){var be,we,Fe,Ge,He,Ye,it,le,Ee,ce,q=de[1].trim(),Ae=q.length>1,Pe={type:"list",raw:"",ordered:Ae,start:Ae?+q.slice(0,-1):"",loose:!1,items:[]};q=Ae?"\\d{1,9}\\"+q.slice(-1):"\\"+q,this.options.pedantic&&(q=Ae?q:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+q+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(de=Ze.exec(ne)));){Ee=de[2].split(`
`),this.options.pedantic?(Ge=2,ce=Ee[0].trimLeft()):(Ge=de[2].search(/[^ ]/),Ge=de[1].length+(Ge>4?1:Ge),ce=Ee[0].slice(Ge-de[1].length)),Ye=!1,be=de[0],!Ee[0]&&/^ *$/.test(Ee[1])&&(be=de[1]+Ee.slice(0,2).join(`
`)+`
`,Pe.loose=!0,Ee=[]);var Xe=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(He=1;He<Ee.length;He++){if(le=Ee[He],this.options.pedantic&&(le=le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(le)){be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}if(!Ye){le.trim()||(Ye=!0),le.search(/[^ ]/)>=Ge?ce+=`
`+le.slice(Ge):ce+=`
`+le;continue}if(le.search(/[^ ]/)>=Ge||!le.trim()){ce+=`
`+le.slice(Ge);continue}else{be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}}Pe.loose||(it?Pe.loose=!0:/\n *\n *$/.test(be)&&(it=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(ce),we&&(Fe=we[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:ce}),Pe.raw+=be,ne=ne.slice(be.length)}Pe.items[Pe.items.length-1].raw=be.trimRight(),Pe.items[Pe.items.length-1].text=ce.trimRight(),Pe.raw=Pe.raw.trimRight();var ot=Pe.items.length;for(He=0;He<ot;He++)this.lexer.state.top=!1,Pe.items[He].tokens=this.lexer.blockTokens(Pe.items[He].text,[]),Pe.items[He].tokens.some(function(vt){return vt.type==="space"})&&(Pe.loose=!0,Pe.items[He].loose=!0);return Pe}},De.html=function(ne){var de=this.rules.block.html.exec(ne);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):U(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},De.def=function(ne){var de=this.rules.block.def.exec(ne);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},De.table=function(ne){var de=this.rules.block.table.exec(ne);if(de){var be={type:"table",header:K(de[1]).map(function(it){return{text:it}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var we=be.align.length,Fe,Ge,He,Ye;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=K(be.rows[Fe],be.header.length).map(function(it){return{text:it}});for(we=be.header.length,Ge=0;Ge<we;Ge++)be.header[Ge].tokens=[],this.lexer.inlineTokens(be.header[Ge].text,be.header[Ge].tokens);for(we=be.rows.length,Ge=0;Ge<we;Ge++)for(Ye=be.rows[Ge],He=0;He<Ye.length;He++)Ye[He].tokens=[],this.lexer.inlineTokens(Ye[He].text,Ye[He].tokens);return be}}},De.lheading=function(ne){var de=this.rules.block.lheading.exec(ne);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.paragraph=function(ne){var de=this.rules.block.paragraph.exec(ne);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.text=function(ne){var de=this.rules.block.text.exec(ne);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.escape=function(ne){var de=this.rules.inline.escape.exec(ne);if(de)return{type:"escape",raw:de[0],text:U(de[1])}},De.tag=function(ne){var de=this.rules.inline.tag.exec(ne);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):U(de[0]):de[0]}},De.link=function(ne){var de=this.rules.inline.link.exec(ne);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=G(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=W(de[2],"()");if(Fe>-1){var Ge=de[0].indexOf("!")===0?5:4,He=Ge+de[1].length+Fe;de[2]=de[2].substring(0,Fe),de[0]=de[0].substring(0,He).trim(),de[3]=""}}var Ye=de[2],it="";if(this.options.pedantic){var le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);le&&(Ye=le[1],it=le[3])}else it=de[3]?de[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(be)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),M(de,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},De.reflink=function(ne,de){var be;if((be=this.rules.inline.reflink.exec(ne))||(be=this.rules.inline.nolink.exec(ne))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=de[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return M(be,we,be[0],this.lexer)}},De.emStrong=function(ne,de,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(ne);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var Ge=we[0].length-1,He,Ye,it=Ge,le=0,Ee=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ee.lastIndex=0,de=de.slice(-1*ne.length+Ge);(we=Ee.exec(de))!=null;)if(He=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!He){if(Ye=He.length,we[3]||we[4]){it+=Ye;continue}else if((we[5]||we[6])&&Ge%3&&!((Ge+Ye)%3)){le+=Ye;continue}if(it-=Ye,!(it>0)){if(Ye=Math.min(Ye,Ye+it+le),Math.min(Ge,Ye)%2){var ce=ne.slice(1,Ge+we.index+Ye);return{type:"em",raw:ne.slice(0,Ge+we.index+Ye+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var q=ne.slice(2,Ge+we.index+Ye-1);return{type:"strong",raw:ne.slice(0,Ge+we.index+Ye+1),text:q,tokens:this.lexer.inlineTokens(q,[])}}}}}},De.codespan=function(ne){var de=this.rules.inline.code.exec(ne);if(de){var be=de[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=U(be,!0),{type:"codespan",raw:de[0],text:be}}},De.br=function(ne){var de=this.rules.inline.br.exec(ne);if(de)return{type:"br",raw:de[0]}},De.del=function(ne){var de=this.rules.inline.del.exec(ne);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},De.autolink=function(ne,de){var be=this.rules.inline.autolink.exec(ne);if(be){var we,Fe;return be[2]==="@"?(we=U(this.options.mangle?de(be[1]):be[1]),Fe="mailto:"+we):(we=U(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},De.url=function(ne,de){var be;if(be=this.rules.inline.url.exec(ne)){var we,Fe;if(be[2]==="@")we=U(this.options.mangle?de(be[0]):be[0]),Fe="mailto:"+we;else{var Ge;do Ge=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Ge!==be[0]);we=U(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},De.inlineText=function(ne,de){var be=this.rules.inline.text.exec(ne);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):U(be[0]):be[0]:we=U(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Le}(),N=F.noopTest,z=F.edit,H=F.merge,Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=z(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=z(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=z(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=z(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=z(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=z(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=H({},Q),Q.gfm=H({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=z(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=H({},Q.normal,{html:z(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:z(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=z(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=z(Q._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=z(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=z(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=z(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=z(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=z(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=z(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=z(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=z(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=H({},X),X.pedantic=H({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:z(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:z(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=H({},X.normal,{escape:z(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),X.gfm.url=z(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=H({},X.gfm,{br:z(X.br).replace("{2,}","*").getRegex(),text:z(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:Q,inline:X},_e=B,ye=k.exports.defaults,Re=fe.block,$e=fe.inline,Be=F.repeatString;function je(Le){return Le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Le){var De="",ke,ne,de=Le.length;for(ke=0;ke<de;ke++)ne=Le.charCodeAt(ke),Math.random()>.5&&(ne="x"+ne.toString(16)),De+="&#"+ne+";";return De}var ee=function(){function Le(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ye,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Re.normal,inline:$e.normal};this.options.pedantic?(ne.block=Re.pedantic,ne.inline=$e.pedantic):this.options.gfm&&(ne.block=Re.gfm,this.options.breaks?ne.inline=$e.breaks:ne.inline=$e.gfm),this.tokenizer.rules=ne}Le.lex=function(ne,de){var be=new Le(de);return be.lex(ne)},Le.lexInline=function(ne,de){var be=new Le(de);return be.inlineTokens(ne)};var De=Le.prototype;return De.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},De.blockTokens=function(ne,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var we,Fe,Ge,He;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(we=it.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.space(ne)){ne=ne.substring(we.raw.length),we.type&&de.push(we);continue}if(we=this.tokenizer.code(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(we=this.tokenizer.fences(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.heading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.hr(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.blockquote(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.list(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.html(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.def(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.lheading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,le=ne.slice(1),Ee=void 0;be.options.extensions.startBlock.forEach(function(ce){Ee=ce.call({lexer:this},le),typeof Ee=="number"&&Ee>=0&&(it=Math.min(it,Ee))}),it<Infinity&&it>=0&&(Ge=ne.substring(0,it+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Ge))){Fe=de[de.length-1],He&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we),He=Ge.length!==ne.length,ne=ne.substring(we.raw.length);continue}if(we=this.tokenizer.text(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(ne){var Ye="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,de},De.inline=function(ne,de){this.inlineQueue.push({src:ne,tokens:de})},De.inlineTokens=function(ne,de){var be=this;de===void 0&&(de=[]);var we,Fe,Ge,He=ne,Ye,it,le;if(this.tokens.links){var Ee=Object.keys(this.tokens.links);if(Ee.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)Ee.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,Ye.index)+"["+Be("a",Ye[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,Ye.index)+"["+Be("a",Ye[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,Ye.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(it||(le=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(q){return(we=q.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.escape(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.tag(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.link(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.emStrong(ne,He,le)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.codespan(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.br(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.del(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.autolink(ne,V)){ne=ne.substring(we.raw.length),de.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(ne,V))){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var q=Infinity,Ae=ne.slice(1),Pe=void 0;be.options.extensions.startInline.forEach(function(Ze){Pe=Ze.call({lexer:this},Ae),typeof Pe=="number"&&Pe>=0&&(q=Math.min(q,Pe))}),q<Infinity&&q>=0&&(Ge=ne.substring(0,q+1))}(),we=this.tokenizer.inlineText(Ge,je)){ne=ne.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(le=we.raw.slice(-1)),it=!0,Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(ne){var ce="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return de},e(Le,null,[{key:"rules",get:function(){return{block:Re,inline:$e}}}]),Le}(),re=k.exports.defaults,ae=F.cleanUrl,Y=F.escape,oe=function(){function Le(ke){this.options=ke||re}var De=Le.prototype;return De.code=function(ne,de,be){var we=(de||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ne,we);Fe!=null&&Fe!==ne&&(be=!0,ne=Fe)}return ne=ne.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Y(we,!0)+'">'+(be?ne:Y(ne,!0))+`</code></pre>
`:"<pre><code>"+(be?ne:Y(ne,!0))+`</code></pre>
`},De.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},De.html=function(ne){return ne},De.heading=function(ne,de,be,we){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+we.slug(be)+'">'+ne+"</h"+de+`>
`:"<h"+de+">"+ne+"</h"+de+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ne,de,be){var we=de?"ol":"ul",Fe=de&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+ne+"</"+we+`>
`},De.listitem=function(ne){return"<li>"+ne+`</li>
`},De.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ne){return"<p>"+ne+`</p>
`},De.table=function(ne,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+de+`</table>
`},De.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},De.tablecell=function(ne,de){var be=de.header?"th":"td",we=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return we+ne+"</"+be+`>
`},De.strong=function(ne){return"<strong>"+ne+"</strong>"},De.em=function(ne){return"<em>"+ne+"</em>"},De.codespan=function(ne){return"<code>"+ne+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ne){return"<del>"+ne+"</del>"},De.link=function(ne,de,be){if(ne=ae(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<a href="'+Y(ne)+'"';return de&&(we+=' title="'+de+'"'),we+=">"+be+"</a>",we},De.image=function(ne,de,be){if(ne=ae(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<img src="'+ne+'" alt="'+be+'"';return de&&(we+=' title="'+de+'"'),we+=this.options.xhtml?"/>":">",we},De.text=function(ne){return ne},Le}(),ve=function(){function Le(){}var De=Le.prototype;return De.strong=function(ne){return ne},De.em=function(ne){return ne},De.codespan=function(ne){return ne},De.del=function(ne){return ne},De.html=function(ne){return ne},De.text=function(ne){return ne},De.link=function(ne,de,be){return""+be},De.image=function(ne,de,be){return""+be},De.br=function(){return""},Le}(),Me=function(){function Le(){this.seen={}}var De=Le.prototype;return De.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ne,de){var be=ne,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[ne];do we++,be=ne+"-"+we;while(this.seen.hasOwnProperty(be))}return de||(this.seen[ne]=we,this.seen[be]=0),be},De.slug=function(ne,de){de===void 0&&(de={});var be=this.serialize(ne);return this.getNextSafeSlug(be,de.dryrun)},Le}(),qe=oe,Ke=ve,Se=Me,tt=k.exports.defaults,Z=F.unescape,te=function(){function Le(ke){this.options=ke||tt,this.options.renderer=this.options.renderer||new qe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Se}Le.parse=function(ne,de){var be=new Le(de);return be.parse(ne)},Le.parseInline=function(ne,de){var be=new Le(de);return be.parseInline(ne)};var De=Le.prototype;return De.parse=function(ne,de){de===void 0&&(de=!0);var be="",we,Fe,Ge,He,Ye,it,le,Ee,ce,q,Ae,Pe,Ze,Xe,ot,vt,Et,lt,dt,mt=ne.length;for(we=0;we<mt;we++){if(q=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(dt=this.options.extensions.renderers[q.type].call({parser:this},q),dt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(q.type))){be+=dt||"";continue}switch(q.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(q.tokens),q.depth,Z(this.parseInline(q.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(q.text,q.lang,q.escaped);continue}case"table":{for(Ee="",le="",He=q.header.length,Fe=0;Fe<He;Fe++)le+=this.renderer.tablecell(this.parseInline(q.header[Fe].tokens),{header:!0,align:q.align[Fe]});for(Ee+=this.renderer.tablerow(le),ce="",He=q.rows.length,Fe=0;Fe<He;Fe++){for(it=q.rows[Fe],le="",Ye=it.length,Ge=0;Ge<Ye;Ge++)le+=this.renderer.tablecell(this.parseInline(it[Ge].tokens),{header:!1,align:q.align[Ge]});ce+=this.renderer.tablerow(le)}be+=this.renderer.table(Ee,ce);continue}case"blockquote":{ce=this.parse(q.tokens),be+=this.renderer.blockquote(ce);continue}case"list":{for(Ae=q.ordered,Pe=q.start,Ze=q.loose,He=q.items.length,ce="",Fe=0;Fe<He;Fe++)ot=q.items[Fe],vt=ot.checked,Et=ot.task,Xe="",ot.task&&(lt=this.renderer.checkbox(vt),Ze?ot.tokens.length>0&&ot.tokens[0].type==="paragraph"?(ot.tokens[0].text=lt+" "+ot.tokens[0].text,ot.tokens[0].tokens&&ot.tokens[0].tokens.length>0&&ot.tokens[0].tokens[0].type==="text"&&(ot.tokens[0].tokens[0].text=lt+" "+ot.tokens[0].tokens[0].text)):ot.tokens.unshift({type:"text",text:lt}):Xe+=lt),Xe+=this.parse(ot.tokens,Ze),ce+=this.renderer.listitem(Xe,Et,vt);be+=this.renderer.list(ce,Ae,Pe);continue}case"html":{be+=this.renderer.html(q.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(q.tokens));continue}case"text":{for(ce=q.tokens?this.parseInline(q.tokens):q.text;we+1<mt&&ne[we+1].type==="text";)q=ne[++we],ce+=`
`+(q.tokens?this.parseInline(q.tokens):q.text);be+=de?this.renderer.paragraph(ce):ce;continue}default:{var Rt='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(Rt);return}else throw new Error(Rt)}}}return be},De.parseInline=function(ne,de){de=de||this.renderer;var be="",we,Fe,Ge,He=ne.length;for(we=0;we<He;we++){if(Fe=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ge=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=Ge||"";continue}switch(Fe.type){case"escape":{be+=de.text(Fe.text);break}case"html":{be+=de.html(Fe.text);break}case"link":{be+=de.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,de));break}case"image":{be+=de.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=de.strong(this.parseInline(Fe.tokens,de));break}case"em":{be+=de.em(this.parseInline(Fe.tokens,de));break}case"codespan":{be+=de.codespan(Fe.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Fe.tokens,de));break}case"text":{be+=de.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return be},Le}(),pe=ee,xe=te,Je=B,rt=oe,ft=ve,pt=Me,St=F.merge,Ct=F.checkSanitizeDeprecation,ue=F.escape,Ie=k.exports.getDefaults,Ue=k.exports.changeDefaults,Qe=k.exports.defaults;function ze(Le,De,ke){if(typeof Le=="undefined"||Le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");if(typeof De=="function"&&(ke=De,De=null),De=St({},ze.defaults,De||{}),Ct(De),ke){var ne=De.highlight,de;try{de=pe.lex(Le,De)}catch(Ge){return ke(Ge)}var be=function(He){var Ye;if(!He)try{De.walkTokens&&ze.walkTokens(de,De.walkTokens),Ye=xe.parse(de,De)}catch(it){He=it}return De.highlight=ne,He?ke(He):ke(null,Ye)};if(!ne||ne.length<3||(delete De.highlight,!de.length))return be();var we=0;ze.walkTokens(de,function(Ge){Ge.type==="code"&&(we++,setTimeout(function(){ne(Ge.text,Ge.lang,function(He,Ye){if(He)return be(He);Ye!=null&&Ye!==Ge.text&&(Ge.text=Ye,Ge.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=pe.lex(Le,De);return De.walkTokens&&ze.walkTokens(Fe,De.walkTokens),xe.parse(Fe,De)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ue(Ge.message+"",!0)+"</pre>";throw Ge}}ze.options=ze.setOptions=function(Le){return St(ze.defaults,Le),Ue(ze.defaults),ze},ze.getDefaults=Ie,ze.defaults=Qe,ze.use=function(){for(var Le=this,De=arguments.length,ke=new Array(De),ne=0;ne<De;ne++)ke[ne]=arguments[ne];var de=St.apply(void 0,[{}].concat(ke)),be=ze.defaults.extensions||{renderers:{},childTokens:{}},we;ke.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(He){if(!He.name)throw new Error("extension name required");if(He.renderer){var Ye=be.renderers?be.renderers[He.name]:null;Ye?be.renderers[He.name]=function(){for(var it=arguments.length,le=new Array(it),Ee=0;Ee<it;Ee++)le[Ee]=arguments[Ee];var ce=He.renderer.apply(this,le);return ce===!1&&(ce=Ye.apply(this,le)),ce}:be.renderers[He.name]=He.renderer}if(He.tokenizer){if(!He.level||He.level!=="block"&&He.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[He.level]?be[He.level].unshift(He.tokenizer):be[He.level]=[He.tokenizer],He.start&&(He.level==="block"?be.startBlock?be.startBlock.push(He.start):be.startBlock=[He.start]:He.level==="inline"&&(be.startInline?be.startInline.push(He.start):be.startInline=[He.start]))}He.childTokens&&(be.childTokens[He.name]=He.childTokens)})),Fe.renderer&&function(){var He=ze.defaults.renderer||new rt,Ye=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Ae=new Array(q),Pe=0;Pe<q;Pe++)Ae[Pe]=arguments[Pe];var Ze=Fe.renderer[Ee].apply(He,Ae);return Ze===!1&&(Ze=ce.apply(He,Ae)),Ze}};for(var it in Fe.renderer)Ye(it);de.renderer=He}(),Fe.tokenizer&&function(){var He=ze.defaults.tokenizer||new Je,Ye=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Ae=new Array(q),Pe=0;Pe<q;Pe++)Ae[Pe]=arguments[Pe];var Ze=Fe.tokenizer[Ee].apply(He,Ae);return Ze===!1&&(Ze=ce.apply(He,Ae)),Ze}};for(var it in Fe.tokenizer)Ye(it);de.tokenizer=He}(),Fe.walkTokens){var Ge=ze.defaults.walkTokens;de.walkTokens=function(He){Fe.walkTokens.call(Le,He),Ge&&Ge(He)}}we&&(de.extensions=be),ze.setOptions(de)})},ze.walkTokens=function(Le,De){for(var ke=function(){var we=de.value;switch(De(we),we.type){case"table":{for(var Fe=I(we.header),Ge;!(Ge=Fe()).done;){var He=Ge.value;ze.walkTokens(He.tokens,De)}for(var Ye=I(we.rows),it;!(it=Ye()).done;)for(var le=it.value,Ee=I(le),ce;!(ce=Ee()).done;){var q=ce.value;ze.walkTokens(q.tokens,De)}break}case"list":{ze.walkTokens(we.items,De);break}default:ze.defaults.extensions&&ze.defaults.extensions.childTokens&&ze.defaults.extensions.childTokens[we.type]?ze.defaults.extensions.childTokens[we.type].forEach(function(Ae){ze.walkTokens(we[Ae],De)}):we.tokens&&ze.walkTokens(we.tokens,De)}},ne=I(Le),de;!(de=ne()).done;)ke()},ze.parseInline=function(Le,De){if(typeof Le=="undefined"||Le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");De=St({},ze.defaults,De||{}),Ct(De);try{var ke=pe.lexInline(Le,De);return De.walkTokens&&ze.walkTokens(ke,De.walkTokens),xe.parseInline(ke,De)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ue(ne.message+"",!0)+"</pre>";throw ne}},ze.Parser=xe,ze.parser=xe.parse,ze.Renderer=rt,ze.TextRenderer=ft,ze.Lexer=pe,ze.lexer=pe.lex,ze.Tokenizer=Je,ze.Slugger=pt,ze.parse=ze;var at=ze;return at}),define(me[77],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(R,C,D){return Math.min(Math.max(R,C),D)}e.clamp=m;function L(R,C){return(C+R%C)%C}e.rot=L;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class k{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=k}),function(){function J(I){const k=[];typeof I=="number"&&k.push("code/timeOrigin",I);function R(D){k.push(D,Date.now())}function C(){const D=[];for(let T=0;T<k.length;T+=2)D.push({name:k[T],startTime:k[T+1]});return D}return{mark:R,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))k.push({name:R.name,startTime:Math.round(I+R.startTime)});return k}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function m(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(me[11],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let L=!1,I=!1,k=!1,R=!1,C=!1,D=!1,T=!1,n,A=m,u,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?o=e.globals.vscode.process:typeof process!="undefined"&&(o=process);const v=typeof o?.versions?.electron=="string"&&o.type==="renderer";if(e.isElectronSandboxed=v&&o?.sandboxed,typeof navigator=="object"&&!v)f=navigator.userAgent,L=f.indexOf("Windows")>=0,I=f.indexOf("Macintosh")>=0,T=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=f.indexOf("Linux")>=0,D=!0,n=navigator.language,A=n;else if(typeof o=="object"){L=o.platform==="win32",I=o.platform==="darwin",k=o.platform==="linux",R=k&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,n=m,A=m;const r=o.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),h=i.availableLanguages["*"];n=i.locale,A=h||m,u=i._translationsConfigFile}catch(i){}C=!0}else console.error("Unable to resolve platform.");var S;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function P(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=P;let E=0;I?E=1:L?E=3:k&&(E=2),e.isWindows=L,e.isMacintosh=I,e.isLinux=k,e.isLinuxSnap=R,e.isNative=C,e.isWeb=D,e.isIOS=T,e.platform=E,e.userAgent=f,e.language=A;var a;(function(r){function i(){return e.language}r.value=i;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function c(){return e.language==="en"}r.isDefault=c})(a=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=u,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let b=0,y=h.length;b<y;b++){const g=h[b];if(g.id===d.data.vscodeSetImmediateId){h.splice(b,1),g.callback();return}}});let c=0;return d=>{const b=++c;h.push({id:b,callback:d}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof o?.nextTick=="function")return o.nextTick.bind(o);const i=Promise.resolve();return h=>i.then(h)}();var l;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||T?2:L?1:3;let p=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,p=new Uint16Array(r.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=s}),define(me[34],ge([0,1,11]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const I=m.globals.vscode.process;L={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()},nextTick(k){return(0,m.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(I){return process.nextTick(I)}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},nextTick(I){return(0,m.setImmediate)(I)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(me[8],ge([0,1,34]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,I=97,k=90,R=122,C=46,D=47,T=92,n=58,A=63;class u extends Error{constructor(l,p,t){let s;typeof p=="string"&&p.indexOf("not ")===0?(s="must not be",p=p.replace(/^not /,"")):s="must be";const r=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${r} ${s} of type ${p}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function f(a,l){if(typeof a!="string")throw new u(l,"string",a)}function o(a){return a===D||a===T}function v(a){return a===D}function S(a){return a>=L&&a<=k||a>=I&&a<=R}function P(a,l,p,t){let s="",r=0,i=-1,h=0,c=0;for(let d=0;d<=a.length;++d){if(d<a.length)c=a.charCodeAt(d);else{if(t(c))break;c=D}if(t(c)){if(!(i===d-1||h===1))if(h===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==C||s.charCodeAt(s.length-2)!==C){if(s.length>2){const b=s.lastIndexOf(p);b===-1?(s="",r=0):(s=s.slice(0,b),r=s.length-1-s.lastIndexOf(p)),i=d,h=0;continue}else if(s.length!==0){s="",r=0,i=d,h=0;continue}}l&&(s+=s.length>0?`${p}..`:"..",r=2)}else s.length>0?s+=`${p}${a.slice(i+1,d)}`:s=a.slice(i+1,d),r=d-i-1;i=d,h=0}else c===C&&h!==-1?++h:h=-1}return s}function E(a,l){if(l===null||typeof l!="object")throw new u("pathObject","Object",l);const p=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return p?p===l.root?`${p}${t}`:`${p}${a}${t}`:t}e.win32={resolve(...a){let l="",p="",t=!1;for(let s=a.length-1;s>=-1;s--){let r;if(s>=0){if(r=a[s],f(r,"path"),r.length===0)continue}else l.length===0?r=m.cwd():(r=m.env[`=${l}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==l.toLowerCase()&&r.charCodeAt(2)===T)&&(r=`${l}\\`));const i=r.length;let h=0,c="",d=!1;const b=r.charCodeAt(0);if(i===1)o(b)&&(h=1,d=!0);else if(o(b))if(d=!0,o(r.charCodeAt(1))){let y=2,g=y;for(;y<i&&!o(r.charCodeAt(y));)y++;if(y<i&&y!==g){const _=r.slice(g,y);for(g=y;y<i&&o(r.charCodeAt(y));)y++;if(y<i&&y!==g){for(g=y;y<i&&!o(r.charCodeAt(y));)y++;(y===i||y!==g)&&(c=`\\\\${_}\\${r.slice(g,y)}`,h=y)}}}else h=1;else S(b)&&r.charCodeAt(1)===n&&(c=r.slice(0,2),h=2,i>2&&o(r.charCodeAt(2))&&(d=!0,h=3));if(c.length>0)if(l.length>0){if(c.toLowerCase()!==l.toLowerCase())continue}else l=c;if(t){if(l.length>0)break}else if(p=`${r.slice(h)}\\${p}`,t=d,d&&l.length>0)break}return p=P(p,!t,"\\",o),t?`${l}\\${p}`:`${l}${p}`||"."},normalize(a){f(a,"path");const l=a.length;if(l===0)return".";let p=0,t,s=!1;const r=a.charCodeAt(0);if(l===1)return v(r)?"\\":a;if(o(r))if(s=!0,o(a.charCodeAt(1))){let h=2,c=h;for(;h<l&&!o(a.charCodeAt(h));)h++;if(h<l&&h!==c){const d=a.slice(c,h);for(c=h;h<l&&o(a.charCodeAt(h));)h++;if(h<l&&h!==c){for(c=h;h<l&&!o(a.charCodeAt(h));)h++;if(h===l)return`\\\\${d}\\${a.slice(c)}\\`;h!==c&&(t=`\\\\${d}\\${a.slice(c,h)}`,p=h)}}}else p=1;else S(r)&&a.charCodeAt(1)===n&&(t=a.slice(0,2),p=2,l>2&&o(a.charCodeAt(2))&&(s=!0,p=3));let i=p<l?P(a.slice(p),!s,"\\",o):"";return i.length===0&&!s&&(i="."),i.length>0&&o(a.charCodeAt(l-1))&&(i+="\\"),t===void 0?s?`\\${i}`:i:s?`${t}\\${i}`:`${t}${i}`},isAbsolute(a){f(a,"path");const l=a.length;if(l===0)return!1;const p=a.charCodeAt(0);return o(p)||l>2&&S(p)&&a.charCodeAt(1)===n&&o(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let l,p;for(let r=0;r<a.length;++r){const i=a[r];f(i,"path"),i.length>0&&(l===void 0?l=p=i:l+=`\\${i}`)}if(l===void 0)return".";let t=!0,s=0;if(typeof p=="string"&&o(p.charCodeAt(0))){++s;const r=p.length;r>1&&o(p.charCodeAt(1))&&(++s,r>2&&(o(p.charCodeAt(2))?++s:t=!1))}if(t){for(;s<l.length&&o(l.charCodeAt(s));)s++;s>=2&&(l=`\\${l.slice(s)}`)}return e.win32.normalize(l)},relative(a,l){if(f(a,"from"),f(l,"to"),a===l)return"";const p=e.win32.resolve(a),t=e.win32.resolve(l);if(p===t||(a=p.toLowerCase(),l=t.toLowerCase(),a===l))return"";let s=0;for(;s<a.length&&a.charCodeAt(s)===T;)s++;let r=a.length;for(;r-1>s&&a.charCodeAt(r-1)===T;)r--;const i=r-s;let h=0;for(;h<l.length&&l.charCodeAt(h)===T;)h++;let c=l.length;for(;c-1>h&&l.charCodeAt(c-1)===T;)c--;const d=c-h,b=i<d?i:d;let y=-1,g=0;for(;g<b;g++){const w=a.charCodeAt(s+g);if(w!==l.charCodeAt(h+g))break;w===T&&(y=g)}if(g!==b){if(y===-1)return t}else{if(d>b){if(l.charCodeAt(h+g)===T)return t.slice(h+g+1);if(g===2)return t.slice(h+g)}i>b&&(a.charCodeAt(s+g)===T?y=g:g===2&&(y=3)),y===-1&&(y=0)}let _="";for(g=s+y+1;g<=r;++g)(g===r||a.charCodeAt(g)===T)&&(_+=_.length===0?"..":"\\..");return h+=y,_.length>0?`${_}${t.slice(h,c)}`:(t.charCodeAt(h)===T&&++h,t.slice(h,c))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const l=e.win32.resolve(a);if(l.length<=2)return a;if(l.charCodeAt(0)===T){if(l.charCodeAt(1)===T){const p=l.charCodeAt(2);if(p!==A&&p!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(S(l.charCodeAt(0))&&l.charCodeAt(1)===n&&l.charCodeAt(2)===T)return`\\\\?\\${l}`;return a},dirname(a){f(a,"path");const l=a.length;if(l===0)return".";let p=-1,t=0;const s=a.charCodeAt(0);if(l===1)return o(s)?a:".";if(o(s)){if(p=t=1,o(a.charCodeAt(1))){let h=2,c=h;for(;h<l&&!o(a.charCodeAt(h));)h++;if(h<l&&h!==c){for(c=h;h<l&&o(a.charCodeAt(h));)h++;if(h<l&&h!==c){for(c=h;h<l&&!o(a.charCodeAt(h));)h++;if(h===l)return a;h!==c&&(p=t=h+1)}}}}else S(s)&&a.charCodeAt(1)===n&&(p=l>2&&o(a.charCodeAt(2))?3:2,t=p);let r=-1,i=!0;for(let h=l-1;h>=t;--h)if(o(a.charCodeAt(h))){if(!i){r=h;break}}else i=!1;if(r===-1){if(p===-1)return".";r=p}return a.slice(0,r)},basename(a,l){l!==void 0&&f(l,"ext"),f(a,"path");let p=0,t=-1,s=!0,r;if(a.length>=2&&S(a.charCodeAt(0))&&a.charCodeAt(1)===n&&(p=2),l!==void 0&&l.length>0&&l.length<=a.length){if(l===a)return"";let i=l.length-1,h=-1;for(r=a.length-1;r>=p;--r){const c=a.charCodeAt(r);if(o(c)){if(!s){p=r+1;break}}else h===-1&&(s=!1,h=r+1),i>=0&&(c===l.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=h))}return p===t?t=h:t===-1&&(t=a.length),a.slice(p,t)}for(r=a.length-1;r>=p;--r)if(o(a.charCodeAt(r))){if(!s){p=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":a.slice(p,t)},extname(a){f(a,"path");let l=0,p=-1,t=0,s=-1,r=!0,i=0;a.length>=2&&a.charCodeAt(1)===n&&S(a.charCodeAt(0))&&(l=t=2);for(let h=a.length-1;h>=l;--h){const c=a.charCodeAt(h);if(o(c)){if(!r){t=h+1;break}continue}s===-1&&(r=!1,s=h+1),c===C?p===-1?p=h:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||s===-1||i===0||i===1&&p===s-1&&p===t+1?"":a.slice(p,s)},format:E.bind(null,"\\"),parse(a){f(a,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return l;const p=a.length;let t=0,s=a.charCodeAt(0);if(p===1)return o(s)?(l.root=l.dir=a,l):(l.base=l.name=a,l);if(o(s)){if(t=1,o(a.charCodeAt(1))){let y=2,g=y;for(;y<p&&!o(a.charCodeAt(y));)y++;if(y<p&&y!==g){for(g=y;y<p&&o(a.charCodeAt(y));)y++;if(y<p&&y!==g){for(g=y;y<p&&!o(a.charCodeAt(y));)y++;y===p?t=y:y!==g&&(t=y+1)}}}}else if(S(s)&&a.charCodeAt(1)===n){if(p<=2)return l.root=l.dir=a,l;if(t=2,o(a.charCodeAt(2))){if(p===3)return l.root=l.dir=a,l;t=3}}t>0&&(l.root=a.slice(0,t));let r=-1,i=t,h=-1,c=!0,d=a.length-1,b=0;for(;d>=t;--d){if(s=a.charCodeAt(d),o(s)){if(!c){i=d+1;break}continue}h===-1&&(c=!1,h=d+1),s===C?r===-1?r=d:b!==1&&(b=1):r!==-1&&(b=-1)}return h!==-1&&(r===-1||b===0||b===1&&r===h-1&&r===i+1?l.base=l.name=a.slice(i,h):(l.name=a.slice(i,r),l.base=a.slice(i,h),l.ext=a.slice(r,h))),i>0&&i!==t?l.dir=a.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let l="",p=!1;for(let t=a.length-1;t>=-1&&!p;t--){const s=t>=0?a[t]:m.cwd();f(s,"path"),s.length!==0&&(l=`${s}/${l}`,p=s.charCodeAt(0)===D)}return l=P(l,!p,"/",v),p?`/${l}`:l.length>0?l:"."},normalize(a){if(f(a,"path"),a.length===0)return".";const l=a.charCodeAt(0)===D,p=a.charCodeAt(a.length-1)===D;return a=P(a,!l,"/",v),a.length===0?l?"/":p?"./":".":(p&&(a+="/"),l?`/${a}`:a)},isAbsolute(a){return f(a,"path"),a.length>0&&a.charCodeAt(0)===D},join(...a){if(a.length===0)return".";let l;for(let p=0;p<a.length;++p){const t=a[p];f(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(a,l){if(f(a,"from"),f(l,"to"),a===l||(a=e.posix.resolve(a),l=e.posix.resolve(l),a===l))return"";const p=1,t=a.length,s=t-p,r=1,i=l.length-r,h=s<i?s:i;let c=-1,d=0;for(;d<h;d++){const y=a.charCodeAt(p+d);if(y!==l.charCodeAt(r+d))break;y===D&&(c=d)}if(d===h)if(i>h){if(l.charCodeAt(r+d)===D)return l.slice(r+d+1);if(d===0)return l.slice(r+d)}else s>h&&(a.charCodeAt(p+d)===D?c=d:d===0&&(c=0));let b="";for(d=p+c+1;d<=t;++d)(d===t||a.charCodeAt(d)===D)&&(b+=b.length===0?"..":"/..");return`${b}${l.slice(r+c)}`},toNamespacedPath(a){return a},dirname(a){if(f(a,"path"),a.length===0)return".";const l=a.charCodeAt(0)===D;let p=-1,t=!0;for(let s=a.length-1;s>=1;--s)if(a.charCodeAt(s)===D){if(!t){p=s;break}}else t=!1;return p===-1?l?"/":".":l&&p===1?"//":a.slice(0,p)},basename(a,l){l!==void 0&&f(l,"ext"),f(a,"path");let p=0,t=-1,s=!0,r;if(l!==void 0&&l.length>0&&l.length<=a.length){if(l===a)return"";let i=l.length-1,h=-1;for(r=a.length-1;r>=0;--r){const c=a.charCodeAt(r);if(c===D){if(!s){p=r+1;break}}else h===-1&&(s=!1,h=r+1),i>=0&&(c===l.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=h))}return p===t?t=h:t===-1&&(t=a.length),a.slice(p,t)}for(r=a.length-1;r>=0;--r)if(a.charCodeAt(r)===D){if(!s){p=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":a.slice(p,t)},extname(a){f(a,"path");let l=-1,p=0,t=-1,s=!0,r=0;for(let i=a.length-1;i>=0;--i){const h=a.charCodeAt(i);if(h===D){if(!s){p=i+1;break}continue}t===-1&&(s=!1,t=i+1),h===C?l===-1?l=i:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||t===-1||r===0||r===1&&l===t-1&&l===p+1?"":a.slice(l,t)},format:E.bind(null,"/"),parse(a){f(a,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return l;const p=a.charCodeAt(0)===D;let t;p?(l.root="/",t=1):t=0;let s=-1,r=0,i=-1,h=!0,c=a.length-1,d=0;for(;c>=t;--c){const b=a.charCodeAt(c);if(b===D){if(!h){r=c+1;break}continue}i===-1&&(h=!1,i=c+1),b===C?s===-1?s=c:d!==1&&(d=1):s!==-1&&(d=-1)}if(i!==-1){const b=r===0&&p?1:r;s===-1||d===0||d===1&&s===i-1&&s===r+1?l.base=l.name=a.slice(b,i):(l.name=a.slice(b,s),l.base=a.slice(b,i),l.ext=a.slice(s,i))}return r>0?l.dir=a.slice(0,r-1):p&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[140],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(k,...R){const C=R.reduce((n,A)=>(n[A]=!0,n),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(n=>!C[n]).forEach(n=>{for(let A=0;A<D.length;A++)if(n.search(D[A])!==-1){delete k[n];break}})}e.sanitizeProcessEnvironment=I}),define(me[46],ge([0,1,11]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class I{constructor(R){this._highResolution=L&&R,this._startTime=this._now(),this._stopTime=-1}static create(R=!0){return new I(R)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=I}),define(me[3],ge([0,1,16,75,6,95,46]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(a){a.None=()=>I.Disposable.None;function l(K){return(U,W=null,M)=>{let x=!1,B;return B=K(N=>{if(!x)return B?B.dispose():x=!0,U.call(W,N)},null,M),x&&B.dispose(),B}}a.once=l;function p(K,U){return c((W,M=null,x)=>K(B=>W.call(M,U(B)),null,x))}a.map=p;function t(K,U){return c((W,M=null,x)=>K(B=>{U(B),W.call(M,B)},null,x))}a.forEach=t;function s(K,U){return c((W,M=null,x)=>K(B=>U(B)&&W.call(M,B),null,x))}a.filter=s;function r(K){return K}a.signal=r;function i(...K){return(U,W=null,M)=>(0,I.combinedDisposable)(...K.map(x=>x(B=>U.call(W,B),null,M)))}a.any=i;function h(K,U,W){let M=W;return p(K,x=>(M=U(M,x),M))}a.reduce=h;function c(K){let U;const W=new u({onFirstListenerAdd(){U=K(W.fire,W)},onLastListenerRemove(){U.dispose()}});return W.event}function d(K,U,W=100,M=!1,x){let B,N,z,H=0;const Q=new u({leakWarningThreshold:x,onFirstListenerAdd(){B=K(X=>{H++,N=U(N,X),M&&!z&&(Q.fire(N),N=void 0),clearTimeout(z),z=setTimeout(()=>{const fe=N;N=void 0,z=void 0,(!M||H>1)&&Q.fire(fe),H=0},W)})},onLastListenerRemove(){B.dispose()}});return Q.event}a.debounce=d;function b(K,U=(W,M)=>W===M){let W=!0,M;return s(K,x=>{const B=W||!U(x,M);return W=!1,M=x,B})}a.latch=b;function y(K,U){return[a.filter(K,U),a.filter(K,W=>!U(W))]}a.split=y;function g(K,U=!1,W=[]){let M=W.slice(),x=K(z=>{M?M.push(z):N.fire(z)});const B=()=>{M&&M.forEach(z=>N.fire(z)),M=null},N=new u({onFirstListenerAdd(){x||(x=K(z=>N.fire(z)))},onFirstListenerDidAdd(){M&&(U?setTimeout(B):B())},onLastListenerRemove(){x&&x.dispose(),x=null}});return N.event}a.buffer=g;class _{constructor(U){this.event=U}map(U){return new _(p(this.event,U))}forEach(U){return new _(t(this.event,U))}filter(U){return new _(s(this.event,U))}reduce(U,W){return new _(h(this.event,U,W))}latch(){return new _(b(this.event))}debounce(U,W=100,M=!1,x){return new _(d(this.event,U,W,M,x))}on(U,W,M){return this.event(U,W,M)}once(U,W,M){return l(this.event)(U,W,M)}}function w(K){return new _(K)}a.chain=w;function F(K,U,W=M=>M){const M=(...z)=>N.fire(W(...z)),x=()=>K.on(U,M),B=()=>K.removeListener(U,M),N=new u({onFirstListenerAdd:x,onLastListenerRemove:B});return N.event}a.fromNodeEventEmitter=F;function O(K,U,W=M=>M){const M=(...z)=>N.fire(W(...z)),x=()=>K.addEventListener(U,M),B=()=>K.removeEventListener(U,M),N=new u({onFirstListenerAdd:x,onLastListenerRemove:B});return N.event}a.fromDOMEventEmitter=O;function G(K){return new Promise(U=>l(K)(U))}a.toPromise=G})(C=e.Event||(e.Event={}));class D{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${D._idPool++}`}start(l){this._stopWatch=new R.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let T=-1;function n(a){const l=T;return T=a,{dispose(){T=l}}}e.setGlobalLeakWarningThreshold=n;class A{constructor(l,p=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let p=T;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||l<p)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let r,i=0;for(const[h,c]of this._stacks)(!r||i<c)&&(r=h,i=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${i}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class u{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=T>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(l,p,t)=>{this._listeners||(this._listeners=new k.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(p?[l,p]:l);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,p);const i=this._leakageMon?.check(this._listeners.size),h=(0,I.toDisposable)(()=>{i&&i(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof I.DisposableStore?t.add(h):Array.isArray(t)&&t.push(h),h}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(s){(0,m.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=u;class f extends u{async fireAsync(l,p,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,l]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),i=[],h={...r,waitUntil:c=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(c=t(c,typeof s=="function"?s:s[0])),i.push(c)}};try{typeof s=="function"?s.call(void 0,h):s[0].call(s[1],h)}catch(c){(0,m.onUnexpectedError)(c);continue}Object.freeze(i),await Promise.allSettled(i).then(c=>{for(const d of c)d.status==="rejected"&&(0,m.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=f;class o extends u{constructor(l){super(l);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=o;class v extends o{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=v;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const p={event:l,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const t=()=>{this.hasListeners&&this.unhook(p);const s=this.events.indexOf(p);this.events.splice(s,1)};return(0,I.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(p=>this.emitter.fire(p))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class P{constructor(){this.buffers=[]}wrapEvent(l){return(p,t,s)=>l(r=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>p.call(t,r)):p.call(t,r)},void 0,s)}bufferEvents(l){const p=[];this.buffers.push(p);const t=l();return this.buffers.pop(),p.forEach(s=>s()),t}}e.EventBufferer=P;class E{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=I.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,D){const T=setTimeout(C.bind(D),0);return{dispose(){clearTimeout(T)}}});var I;(function(C){function D(T){return T===C.None||T===C.Cancelled||T instanceof k?!0:!T||typeof T!="object"?!1:typeof T.isCancellationRequested=="boolean"&&typeof T.onCancellationRequested=="function"}C.isCancellationToken=D,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(I=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=I.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=R}),define(me[47],ge([0,1,3]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(A){const u=this._icons.get(A.id);u?A.description?u.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const I=new L;e.iconRegistry=I;function k(n,A){return new C(n,A)}e.registerCodicon=k;function R(n){return n?n.replace(/\$\((.*?)\)/g,(A,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=R;class C{constructor(A,u,f){this.id=A,this.definition=u,this.description=f,I.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function D(n,A){const u=["codicon","codicon-"+n];return A&&u.push("codicon-modifier-"+A),u}e.getClassNamesArray=D;var T;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function u(v){if(v instanceof C)return["codicon","codicon-"+v.id];const S=A.exec(v.id);if(!S)return u(C.error);let[,P,E]=S;const a=["codicon","codicon-"+P];return E&&a.push("codicon-modifier-"+E.substr(1)),a}n.asClassNameArray=u;function f(v){return u(v).join(" ")}n.asClassName=f;function o(v){return"."+u(v).join(".")}n.asCSSSelector=o})(T=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,16,6]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(a){const l=a;return l?[l.on,l.pause,l.resume,l.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=I;function k(a){const l=a;return l?I(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=k;function R(a,l){return new C(a,l)}e.newWriteableStream=R;class C{constructor(l,p){this.reducer=l,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(p=>p(l))}emitError(l){this.listeners.error.length===0?(0,m.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(p=>p(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,p){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(l,p){if(this.state.destroyed)return;let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(p);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(a,l){const p=[];let t;for(;(t=a.read())!==null;)p.push(t);return l(p)}e.consumeReadable=D;function T(a,l,p){const t=[];let s;for(;(s=a.read())!==null&&t.length<p;)t.push(s);return s===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return a.read()}}}e.peekReadable=T;function n(a,l){return new Promise((p,t)=>{const s=[];A(a,{onData:r=>{l&&s.push(r)},onError:r=>{l?t(r):p(void 0)},onEnd:()=>{p(l?l(s):void 0)}})})}e.consumeStream=n;function A(a,l){a.on("error",p=>l.onError(p)),a.on("end",()=>l.onEnd()),a.on("data",p=>l.onData(p))}e.listenStream=A;function u(a,l){return new Promise((p,t)=>{const s=new L.DisposableStore,r=[],i=d=>{if(r.push(d),r.length>l)return s.dispose(),a.pause(),p({stream:a,buffer:r,ended:!1})},h=d=>t(d),c=()=>p({stream:a,buffer:r,ended:!0});s.add((0,L.toDisposable)(()=>a.removeListener("error",h))),a.on("error",h),s.add((0,L.toDisposable)(()=>a.removeListener("end",c))),a.on("end",c),s.add((0,L.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=u;function f(a,l){const p=R(l);return p.end(a),p}e.toStream=f;function o(){const a=R(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=o;function v(a){let l=!1;return{read:()=>l?null:(l=!0,a)}}e.toReadable=v;function S(a,l,p){const t=R(p);return A(a,{onData:s=>t.write(l.data(s)),onError:s=>t.error(l.error?l.error(s):s),onEnd:()=>t.end()}),t}e.transform=S;function P(a,l,p){let t=!1;return{read:()=>{const s=l.read();return t?s:(t=!0,s!==null?p([a,s]):a)}}}e.prefixedReadable=P;function E(a,l,p){let t=!1;const s=R(p);return A(l,{onData:r=>t?s.write(r):(t=!0,s.write(p([a,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(a)),s.end()}}),s}e.prefixedStream=E}),define(me[23],ge([0,1,96]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let I,k;class R{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new R(Buffer.allocUnsafe(i)):new R(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new R(i)}static fromString(i,h){return!(h?.dontUseNodeBuffer||!1)&&L?new R(Buffer.from(i)):(I||(I=new TextEncoder),new R(I.encode(i)))}static concat(i,h){if(typeof h=="undefined"){h=0;for(let b=0,y=i.length;b<y;b++)h+=i[b].byteLength}const c=R.alloc(h);let d=0;for(let b=0,y=i.length;b<y;b++){const g=i[b];c.set(g,d),d+=g.byteLength}return c}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(i,h){return new R(this.buffer.subarray(i,h))}set(i,h){i instanceof R?this.buffer.set(i.buffer,h):this.buffer.set(i,h)}readUInt32BE(i){return T(this.buffer,i)}writeUInt32BE(i,h){n(this.buffer,i,h)}readUInt32LE(i){return A(this.buffer,i)}writeUInt32LE(i,h){u(this.buffer,i,h)}readUInt8(i){return f(this.buffer,i)}writeUInt8(i,h){o(this.buffer,i,h)}}e.VSBuffer=R;function C(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=C;function D(r,i,h){r[h+0]=i&255,i=i>>>8,r[h+1]=i&255}e.writeUInt16LE=D;function T(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=T;function n(r,i,h){r[h+3]=i,i=i>>>8,r[h+2]=i,i=i>>>8,r[h+1]=i,i=i>>>8,r[h]=i}e.writeUInt32BE=n;function A(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=A;function u(r,i,h){r[h+0]=i&255,i=i>>>8,r[h+1]=i&255,i=i>>>8,r[h+2]=i&255,i=i>>>8,r[h+3]=i&255}e.writeUInt32LE=u;function f(r,i){return r[i]}e.readUInt8=f;function o(r,i,h){r[h]=i}e.writeUInt8=o;function v(r){return m.consumeReadable(r,i=>R.concat(i))}e.readableToBuffer=v;function S(r){return m.toReadable(r)}e.bufferToReadable=S;function P(r){return m.consumeStream(r,i=>R.concat(i))}e.streamToBuffer=P;async function E(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await P(r.stream)])}e.bufferedStreamToBuffer=E;function a(r){return m.toStream(r,i=>R.concat(i))}e.bufferToStream=a;function l(r){return m.transform(r,{data:i=>typeof i=="string"?R.fromString(i):R.wrap(i)},i=>R.concat(i))}e.streamToBufferReadableStream=l;function p(r){return m.newWriteableStream(i=>R.concat(i),r)}e.newWriteableBufferStream=p;function t(r,i){return m.prefixedReadable(r,i,h=>R.concat(h))}e.prefixedBufferReadable=t;function s(r,i){return m.prefixedStream(r,i,h=>R.concat(h))}e.prefixedBufferStream=s}),define(me[9],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=m;const L=/{(\d+)}/g;function I(ue,...Ie){return Ie.length===0?ue:ue.replace(L,function(Ue,Qe){const ze=parseInt(Qe,10);return isNaN(ze)||ze<0||ze>=Ie.length?Ue:Ie[ze]})}e.format=I;const k=/{([^}]+)}/g;function R(ue,Ie){return ue.replace(k,(Ue,Qe)=>Ie[Qe]??Ue)}e.format2=R;function C(ue){return ue.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=C;function D(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function T(ue,Ie){let Ue=0;const Qe=Ie.charCodeAt(0);for(let ze=ue.length-1;ze>=0;ze--)ue.charCodeAt(ze)===Qe&&Ue++;return Ue}e.count=T;function n(ue,Ie,Ue="\u2026"){return ue.length<=Ie?ue:`${ue.substr(0,Ie)}${Ue}`}e.truncate=n;function A(ue,Ie=" "){const Ue=u(ue,Ie);return f(Ue,Ie)}e.trim=A;function u(ue,Ie){if(!ue||!Ie)return ue;const Ue=Ie.length;if(Ue===0||ue.length===0)return ue;let Qe=0;for(;ue.indexOf(Ie,Qe)===Qe;)Qe=Qe+Ue;return ue.substring(Qe)}e.ltrim=u;function f(ue,Ie){if(!ue||!Ie)return ue;const Ue=Ie.length,Qe=ue.length;if(Ue===0||Qe===0)return ue;let ze=Qe,at=-1;for(;at=ue.lastIndexOf(Ie,ze-1),!(at===-1||at+Ue!==ze);){if(at===0)return"";ze=at}return ue.substring(0,ze)}e.rtrim=f;function o(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function v(ue){return ue.replace(/\*/g,"")}e.stripWildcards=v;function S(ue,Ie,Ue={}){if(!ue)throw new Error("Cannot create regex from empty string");Ie||(ue=D(ue)),Ue.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Qe="";return Ue.global&&(Qe+="g"),Ue.matchCase||(Qe+="i"),Ue.multiline&&(Qe+="m"),Ue.unicode&&(Qe+="u"),new RegExp(ue,Qe)}e.createRegExp=S;function P(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function E(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function a(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=a;function l(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=l;function p(ue){for(let Ie=0,Ue=ue.length;Ie<Ue;Ie++){const Qe=ue.charCodeAt(Ie);if(Qe!==32&&Qe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=p;function t(ue,Ie=0,Ue=ue.length){for(let Qe=Ie;Qe<Ue;Qe++){const ze=ue.charCodeAt(Qe);if(ze!==32&&ze!==9)return ue.substring(Ie,Qe)}return ue.substring(Ie,Ue)}e.getLeadingWhitespace=t;function s(ue,Ie=ue.length-1){for(let Ue=Ie;Ue>=0;Ue--){const Qe=ue.charCodeAt(Ue);if(Qe!==32&&Qe!==9)return Ue}return-1}e.lastNonWhitespaceIndex=s;function r(ue,Ie){return ue<Ie?-1:ue>Ie?1:0}e.compare=r;function i(ue,Ie,Ue=0,Qe=ue.length,ze=0,at=Ie.length){for(;Ue<Qe&&ze<at;Ue++,ze++){let ke=ue.charCodeAt(Ue),ne=Ie.charCodeAt(ze);if(ke<ne)return-1;if(ke>ne)return 1}const Le=Qe-Ue,De=at-ze;return Le<De?-1:Le>De?1:0}e.compareSubstring=i;function h(ue,Ie){return c(ue,Ie,0,ue.length,0,Ie.length)}e.compareIgnoreCase=h;function c(ue,Ie,Ue=0,Qe=ue.length,ze=0,at=Ie.length){for(;Ue<Qe&&ze<at;Ue++,ze++){let ke=ue.charCodeAt(Ue),ne=Ie.charCodeAt(ze);if(ke===ne)continue;const de=ke-ne;if(!(de===32&&b(ne))&&!(de===-32&&b(ke)))return d(ke)&&d(ne)?de:i(ue.toLowerCase(),Ie.toLowerCase(),Ue,Qe,ze,at)}const Le=Qe-Ue,De=at-ze;return Le<De?-1:Le>De?1:0}e.compareSubstringIgnoreCase=c;function d(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=d;function b(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=b;function y(ue){return d(ue)||b(ue)}function g(ue,Ie){return ue.length===Ie.length&&_(ue,Ie)}e.equalsIgnoreCase=g;function _(ue,Ie,Ue=ue.length){for(let Qe=0;Qe<Ue;Qe++){const ze=ue.charCodeAt(Qe),at=Ie.charCodeAt(Qe);if(ze!==at){if(y(ze)&&y(at)){const Le=Math.abs(ze-at);if(Le!==0&&Le!==32)return!1}else if(String.fromCharCode(ze).toLowerCase()!==String.fromCharCode(at).toLowerCase())return!1}}return!0}function w(ue,Ie){const Ue=Ie.length;return Ie.length>ue.length?!1:_(ue,Ie,Ue)}e.startsWithIgnoreCase=w;function F(ue,Ie){let Ue,Qe=Math.min(ue.length,Ie.length);for(Ue=0;Ue<Qe;Ue++)if(ue.charCodeAt(Ue)!==Ie.charCodeAt(Ue))return Ue;return Qe}e.commonPrefixLength=F;function O(ue,Ie){let Ue,Qe=Math.min(ue.length,Ie.length);const ze=ue.length-1,at=Ie.length-1;for(Ue=0;Ue<Qe;Ue++)if(ue.charCodeAt(ze-Ue)!==Ie.charCodeAt(at-Ue))return Ue;return Qe}e.commonSuffixLength=O;function G(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=G;function K(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=K;function U(ue,Ie){return(ue-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=U;function W(ue,Ie,Ue){const Qe=ue.charCodeAt(Ue);if(G(Qe)&&Ue+1<Ie){const ze=ue.charCodeAt(Ue+1);if(K(ze))return U(Qe,ze)}return Qe}e.getNextCodePoint=W;function M(ue,Ie){const Ue=ue.charCodeAt(Ie-1);if(K(Ue)&&Ie>1){const Qe=ue.charCodeAt(Ie-2);if(G(Qe))return U(Qe,Ue)}return Ue}function x(ue,Ie){const Ue=xe.getInstance(),Qe=Ie,ze=ue.length,at=W(ue,ze,Ie);Ie+=at>=65536?2:1;let Le=Ue.getGraphemeBreakType(at);for(;Ie<ze;){const De=W(ue,ze,Ie),ke=Ue.getGraphemeBreakType(De);if(te(Le,ke))break;Ie+=De>=65536?2:1,Le=ke}return Ie-Qe}e.nextCharLength=x;function B(ue,Ie){const Ue=xe.getInstance(),Qe=Ie,ze=M(ue,Ie);Ie-=ze>=65536?2:1;let at=Ue.getGraphemeBreakType(ze);for(;Ie>0;){const Le=M(ue,Ie),De=Ue.getGraphemeBreakType(Le);if(te(De,at))break;Ie-=Le>=65536?2:1,at=De}return Qe-Ie}e.prevCharLength=B;function N(ue,Ie){const Ue=xe.getInstance(),Qe=ue.length,ze=Ie,at=W(ue,Qe,Ie),Le=Ue.getGraphemeBreakType(at);Ie+=at>=65536?2:1;let De=Le;for(;Ie<Qe;){const ne=W(ue,Qe,Ie),de=Ue.getGraphemeBreakType(ne);if(te(De,de))break;Ie+=ne>=65536?2:1,De=de}const ke=Ie;for(Ie=ze,De=Le;Ie>0;){const ne=M(ue,Ie),de=Ue.getGraphemeBreakType(ne);if(te(de,De))break;Ie-=ne>=65536?2:1,De=de}return[Ie,ke]}function z(ue,Ie){return Ie>0&&K(ue.charCodeAt(Ie))?N(ue,Ie-1):N(ue,Ie)}e.getCharContainingOffset=z;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(ue){return H.test(ue)}e.containsRTL=Q;const X=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function fe(ue){return X.test(ue)}e.containsEmoji=fe;const _e=/^[\t\n\r\x20-\x7E]*$/;function ye(ue){return _e.test(ue)}e.isBasicASCII=ye,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Re(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=Re;function $e(ue){for(let Ie=0,Ue=ue.length;Ie<Ue;Ie++)if(Be(ue.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=$e;function Be(ue){return ue=+ue,ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=Be;function je(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129003||ue>=129280&&ue<=129535||ue>=129648&&ue<=129750}e.isEmojiImprecise=je;function V(ue,Ie){if(ue.length<Ie)return ue;const Ue=/\b/g;let Qe=0;for(;Ue.test(ue)&&!(ue.length-Ue.lastIndex<Ie);)Qe=Ue.lastIndex,Ue.lastIndex+=1;return ue.substring(Qe).replace(/^\s/,"")}e.lcut=V;const ee=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function Y(ue){return ue&&(ue=ue.replace(ee,""),ue=ue.replace(re,""),ue=ue.replace(ae,"")),ue}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function ve(ue){return oe(ue)?ue.substr(1):ue}e.stripUTF8BOM=ve;function Me(ue,Ie){if(!ue||!Ie||ue.length<Ie.length)return!1;const Ue=Ie.length,Qe=ue.toLowerCase();let ze=0,at=-1;for(;ze<Ue;){const Le=Qe.indexOf(Ie[ze],at+1);if(Le<0)return!1;at=Le,ze++}return!0}e.fuzzyContains=Me;function qe(ue,Ie=!1){return ue?(Ie&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=qe;function Ke(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Ke;function Se(ue,Ie=1){if(Ie===0)return"";let Ue=-1;do Ue=ue.indexOf(`
`,Ue+1),Ie--;while(Ie>0&&Ue>=0);return Ue===-1?ue:(ue[Ue-1]==="\r"&&Ue--,ue.substr(0,Ue))}e.getNLines=Se;function tt(ue){const Ie=90-65+1;return ue=ue%(2*Ie),ue<Ie?String.fromCharCode(97+ue):String.fromCharCode(65+ue-Ie)}e.singleLetterHash=tt;function Z(ue){return xe.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=Z;function te(ue,Ie){return ue===0?Ie!==5&&Ie!==7:ue===2&&Ie===3?!1:ue===4||ue===2||ue===3||Ie===4||Ie===2||Ie===3?!0:!(ue===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ue===11||ue===9)&&(Ie===9||Ie===10)||(ue===12||ue===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ue===1||ue===13&&Ie===14||ue===6&&Ie===6)}e.breakBetweenGraphemeBreakType=te;var pe;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class xe{constructor(){this._data=Je()}static getInstance(){return xe._INSTANCE||(xe._INSTANCE=new xe),xe._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ue=this._data,Qe=Ue.length/3;let ze=1;for(;ze<=Qe;)if(Ie<Ue[3*ze])ze=2*ze;else if(Ie>Ue[3*ze+1])ze=2*ze+1;else return Ue[3*ze+2];return 0}}xe._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function rt(ue,Ie){if(ue===0)return 0;const Ue=ft(ue,Ie);if(Ue!==void 0)return Ue;const Qe=M(Ie,ue);return ue-=pt(Qe),ue}e.getLeftDeleteOffset=rt;function ft(ue,Ie){let Ue=M(Ie,ue);for(ue-=pt(Ue);St(Ue)||Ue===65039||Ue===8419;){if(ue===0)return;Ue=M(Ie,ue),ue-=pt(Ue)}if(!!je(Ue)){if(ue>=0){const Qe=M(Ie,ue);Qe===8205&&(ue-=pt(Qe))}return ue}}function pt(ue){return ue>=65536?2:1}function St(ue){return 127995<=ue&&ue<=127999}var Ct;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(Ct||(Ct={}))}),define(me[48],ge([0,1,9]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(P){return I(P,0)}e.hash=L;function I(P,E){switch(typeof P){case"object":return P===null?k(349,E):Array.isArray(P)?D(P,E):T(P,E);case"string":return C(P,E);case"boolean":return R(P,E);case"number":return k(P,E);case"undefined":return k(937,E);default:return k(617,E)}}e.doHash=I;function k(P,E){return(E<<5)-E+P|0}function R(P,E){return k(P?433:863,E)}function C(P,E){E=k(149417,E);for(let a=0,l=P.length;a<l;a++)E=k(P.charCodeAt(a),E);return E}e.stringHash=C;function D(P,E){return E=k(104579,E),P.reduce((a,l)=>I(l,a),E)}function T(P,E){return E=k(181387,E),Object.keys(P).sort().reduce((a,l)=>(a=C(l,a),I(P[l],a)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=I(E,this._value),this._value}}e.Hasher=n;var A;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function u(P,E,a=32){const l=a-E,p=~((1<<l)-1);return(P<<E|(p&P)>>>l)>>>0}function f(P,E=0,a=P.byteLength,l=0){for(let p=0;p<a;p++)P[E+p]=l}function o(P,E,a="0"){for(;P.length<E;)P=a+P;return P}function v(P,E=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(a=>a.toString(16).padStart(2,"0")).join(""):o((P>>>0).toString(16),E/4)}e.toHexString=v;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const a=E.length;if(a===0)return;const l=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=E.charCodeAt(0),r=0);;){let i=s;if(m.isHighSurrogate(s))if(r+1<a){const h=E.charCodeAt(r+1);m.isLowSurrogate(h)?(r++,i=m.computeCodePoint(s,h)):i=65533}else{t=s;break}else m.isLowSurrogate(s)&&(i=65533);if(p=this._push(l,p,i),r++,r<a)s=E.charCodeAt(r);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(E,a,l){return l<128?E[a++]=l:l<2048?(E[a++]=192|(l&1984)>>>6,E[a++]=128|(l&63)>>>0):l<65536?(E[a++]=224|(l&61440)>>>12,E[a++]=128|(l&4032)>>>6,E[a++]=128|(l&63)>>>0):(E[a++]=240|(l&1835008)>>>18,E[a++]=128|(l&258048)>>>12,E[a++]=128|(l&4032)>>>6,E[a++]=128|(l&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=S._bigBlock32,a=this._buffDV;for(let d=0;d<64;d+=4)E.setUint32(d,a.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)E.setUint32(d,u(E.getUint32(d-12,!1)^E.getUint32(d-32,!1)^E.getUint32(d-56,!1)^E.getUint32(d-64,!1),1),!1);let l=this._h0,p=this._h1,t=this._h2,s=this._h3,r=this._h4,i,h,c;for(let d=0;d<80;d++)d<20?(i=p&t|~p&s,h=1518500249):d<40?(i=p^t^s,h=1859775393):d<60?(i=p&t|p&s|t&s,h=2400959708):(i=p^t^s,h=3395469782),c=u(l,5)+i+r+h+E.getUint32(d*4,!1)&4294967295,r=s,s=t,t=u(p,30),p=l,l=c;this._h0=this._h0+l&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[49],ge([0,1,9]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(L||(L={})),function(I){const k="error",R="warning",C="warn",D="info",T="ignore";function n(u){return u?m.equalsIgnoreCase(k,u)?I.Error:m.equalsIgnoreCase(R,u)||m.equalsIgnoreCase(C,u)?I.Warning:m.equalsIgnoreCase(D,u)?I.Info:I.Ignore:I.Ignore}I.fromValue=n;function A(u){switch(u){case I.Error:return k;case I.Warning:return R;case I.Info:return D;default:return T}}I.toString=A}(L||(L={})),e.default=L}),define(me[13],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(b){return Array.isArray(b)}e.isArray=m;function L(b){return typeof b=="string"}e.isString=L;function I(b){return Array.isArray(b)&&b.every(y=>L(y))}e.isStringArray=I;function k(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=k;function R(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=R;function C(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=C;function D(b){return b===!0||b===!1}e.isBoolean=D;function T(b){return typeof b=="undefined"}e.isUndefined=T;function n(b){return!A(b)}e.isDefined=n;function A(b){return T(b)||b===null}e.isUndefinedOrNull=A;function u(b,y){if(!b)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}e.assertType=u;function f(b){if(A(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=f;function o(...b){const y=[];for(let g=0;g<b.length;g++){const _=b[g];if(A(_))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);y.push(_)}return y}e.assertAllDefined=o;const v=Object.prototype.hasOwnProperty;function S(b){if(!k(b))return!1;for(let y in b)if(v.call(b,y))return!1;return!0}e.isEmptyObject=S;function P(b){return typeof b=="function"}e.isFunction=P;function E(...b){return b.length>0&&b.every(P)}e.areFunctions=E;function a(b,y){const g=Math.min(b.length,y.length);for(let _=0;_<g;_++)l(b[_],y[_])}e.validateConstraints=a;function l(b,y){if(L(y)){if(typeof b!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(P(y)){try{if(b instanceof y)return}catch{}if(!A(b)&&b.constructor===y||y.length===1&&y.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function p(b){let y=[],g=Object.getPrototypeOf(b);for(;Object.prototype!==g;)y=y.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return y}e.getAllPropertyNames=p;function t(b){const y=[];for(const g of p(b))typeof b[g]=="function"&&y.push(g);return y}e.getAllMethodNames=t;function s(b,y){const g=w=>function(){const F=Array.prototype.slice.call(arguments,0);return y(w,F)};let _={};for(const w of b)_[w]=g(w);return _}e.createProxyObject=s;function r(b){return b===null?void 0:b}e.withNullAsUndefined=r;function i(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=i;function h(b){return class{constructor(){return new Proxy({},{get(y,g){if(y[g])return y[g];throw new Error(`Not Implemented: ${b}->${String(g)}`)}})}}}e.NotImplementedProxy=h;function c(b,y="Unreachable"){throw new Error(y)}e.assertNever=c;function d(b){return!!b&&typeof b.then=="function"&&typeof b.catch=="function"}e.isPromise=d}),define(me[29],ge([0,1,8,11,9,13]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function C(r){return r.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=C;function D(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=D;function T(r,i=m.posix.sep){if(!r)return"";const h=r.length,c=r.charCodeAt(0);if(R(c)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let b=3;const y=b;for(;b<h&&!R(r.charCodeAt(b));b++);if(y!==b&&!R(r.charCodeAt(b+1))){for(b+=1;b<h;b++)if(R(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(P(c)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let d=r.indexOf("://");if(d!==-1){for(d+=3;d<h;d++)if(R(r.charCodeAt(d)))return r.slice(0,d+1)}return""}e.getRoot=T;function n(r){if(!L.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let h=2;const c=h;for(;h<r.length&&(i=r.charCodeAt(h),i!==92);h++);return!(c===h||(i=r.charCodeAt(h+1),isNaN(i)||i===92))}e.isUNC=n;const A=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(r,i=L.isWindows){const h=i?A:u;return!(!r||r.length===0||/^\s+$/.test(r)||(h.lastIndex=0,h.test(r))||i&&f.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=o;function v(r,i,h){const c=r===i;return!h||c?c:!r||!i?!1:(0,I.equalsIgnoreCase)(r,i)}e.isEqual=v;function S(r,i,h,c=m.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(h){if(!(0,I.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let b=i.length;return i.charAt(i.length-1)===c&&b--,r.charAt(b)===c}return i.charAt(i.length-1)!==c&&(i+=c),r.indexOf(i)===0}e.isEqualOrParent=S;function P(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=P;function E(r,i){return L.isWindows&&r.endsWith(":")&&(r+=m.sep),(0,m.isAbsolute)(r)||(r=(0,m.join)(i,r)),r=(0,m.normalize)(r),L.isWindows?(r=(0,I.rtrim)(r,m.sep),r.endsWith(":")&&(r+=m.sep)):(r=(0,I.rtrim)(r,m.sep),r||(r=m.sep)),r}e.sanitizeFilePath=E;function a(r){const i=(0,m.normalize)(r);return L.isWindows?r.length>3?!1:l(i)&&(r.length===2||i.charCodeAt(2)===92):i===m.posix.sep}e.isRootOrDriveLetter=a;function l(r){return L.isWindows?P(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function p(r){return l(r)?r[0]:void 0}e.getDriveLetter=p;function t(r,i,h){return i.length>r.length?-1:r===i?0:(h&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function s(r){const i=r.split(":");let h,c,d;if(i.forEach(b=>{const y=Number(b);(0,k.isNumber)(y)?c===void 0?c=y:d===void 0&&(d=y):h=h?[h,b].join(":"):b}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:c!==void 0?c:void 0,column:d!==void 0?d:c!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(me[25],ge([0,1,13]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const S=Array.isArray(v)?[]:{};return Object.keys(v).forEach(P=>{v[P]&&typeof v[P]=="object"?S[P]=L(v[P]):S[P]=v[P]}),S}e.deepClone=L;function I(v){if(!v||typeof v!="object")return v;const S=[v];for(;S.length>0;){const P=S.shift();Object.freeze(P);for(const E in P)if(k.call(P,E)){const a=P[E];typeof a=="object"&&!Object.isFrozen(a)&&S.push(a)}}return v}e.deepFreeze=I;const k=Object.prototype.hasOwnProperty;function R(v,S){return C(v,S,new Set)}e.cloneAndChange=R;function C(v,S,P){if((0,m.isUndefinedOrNull)(v))return v;const E=S(v);if(typeof E!="undefined")return E;if((0,m.isArray)(v)){const a=[];for(const l of v)a.push(C(l,S,P));return a}if((0,m.isObject)(v)){if(P.has(v))throw new Error("Cannot clone recursive data-structure");P.add(v);const a={};for(let l in v)k.call(v,l)&&(a[l]=C(v[l],S,P));return P.delete(v),a}return v}function D(v,S,P=!0){return(0,m.isObject)(v)?((0,m.isObject)(S)&&Object.keys(S).forEach(E=>{E in v?P&&((0,m.isObject)(v[E])&&(0,m.isObject)(S[E])?D(v[E],S[E],P):v[E]=S[E]):v[E]=S[E]}),v):S}e.mixin=D;function T(v,S){if(v===S)return!0;if(v==null||S===null||S===void 0||typeof v!=typeof S||typeof v!="object"||Array.isArray(v)!==Array.isArray(S))return!1;let P,E;if(Array.isArray(v)){if(v.length!==S.length)return!1;for(P=0;P<v.length;P++)if(!T(v[P],S[P]))return!1}else{const a=[];for(E in v)a.push(E);a.sort();const l=[];for(E in S)l.push(E);if(l.sort(),!T(a,l))return!1;for(P=0;P<a.length;P++)if(!T(v[a[P]],S[a[P]]))return!1}return!0}e.equals=T;function n(v){const S=new Set;return JSON.stringify(v,(P,E)=>{if((0,m.isObject)(E)||Array.isArray(E)){if(S.has(E))return"[Circular]";S.add(E)}return E})}e.safeStringify=n;function A(v,S,P){const E=S(v);return typeof E=="undefined"?P:E}e.getOrDefault=A;function u(v,S){const P=Object.create(null);return!v||!S||Object.keys(S).forEach(a=>{const l=v[a],p=S[a];T(l,p)||(P[a]=p)}),P}e.distinct=u;function f(v,S){const P=S.toLowerCase(),E=Object.keys(v).find(a=>a.toLowerCase()===P);return E?v[E]:v[S]}e.getCaseInsensitive=f;function o(v,S){const P=Object.create(null);for(const E of Object.keys(v))S(E,v[E])&&(P[E]=v[E]);return P}e.filter=o}),define(me[97],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function L(k){return k<0?0:k>255?255:k|0}e.toUint8=L;function I(k){return k<0?0:k>4294967295?4294967295:k|0}e.toUint32=I}),define(me[2],ge([0,1,8,11]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,k=/^\//,R=/^\/\//;function C(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!I.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!k.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(r,i){return!r&&!i?"file":r}function T(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==A&&(i=A+i):i=A;break}return i}const n="",A="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(i,h,c,d,b,y=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=D(i,y),this.authority=h||n,this.path=T(this.scheme,c||n),this.query=d||n,this.fragment=b||n,C(this,y))}static isUri(i){return i instanceof f?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:h,authority:c,path:d,query:b,fragment:y}=i;return h===void 0?h=this.scheme:h===null&&(h=n),c===void 0?c=this.authority:c===null&&(c=n),d===void 0?d=this.path:d===null&&(d=n),b===void 0?b=this.query:b===null&&(b=n),y===void 0?y=this.fragment:y===null&&(y=n),h===this.scheme&&c===this.authority&&d===this.path&&b===this.query&&y===this.fragment?this:new v(h,c,d,b,y)}static parse(i,h=!1){const c=u.exec(i);return c?new v(c[2]||n,s(c[4]||n),s(c[5]||n),s(c[7]||n),s(c[9]||n),h):new v(n,n,n,n,n)}static file(i){let h=n;if(L.isWindows&&(i=i.replace(/\\/g,A)),i[0]===A&&i[1]===A){const c=i.indexOf(A,2);c===-1?(h=i.substring(2),i=A):(h=i.substring(2,c),i=i.substring(c)||A)}return new v("file",h,i,n,n)}static from(i){const h=new v(i.scheme,i.authority,i.path,i.query,i.fragment);return C(h,!0),h}static joinPath(i,...h){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return L.isWindows&&i.scheme==="file"?c=f.file(m.win32.join(a(i,!0),...h)).path:c=m.posix.join(i.path,...h),i.with({path:c})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof f)return i;{const h=new v(i);return h._formatted=i.external,h._fsPath=i._sep===o?i.fsPath:null,h}}else return i}}e.URI=f;const o=L.isWindows?1:void 0;class v extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=o),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(r,i){let h,c=-1;for(let d=0;d<r.length;d++){const b=r.charCodeAt(d);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47)c!==-1&&(h+=encodeURIComponent(r.substring(c,d)),c=-1),h!==void 0&&(h+=r.charAt(d));else{h===void 0&&(h=r.substr(0,d));const y=S[b];y!==void 0?(c!==-1&&(h+=encodeURIComponent(r.substring(c,d)),c=-1),h+=y):c===-1&&(c=d)}}return c!==-1&&(h+=encodeURIComponent(r.substring(c))),h!==void 0?h:r}function E(r){let i;for(let h=0;h<r.length;h++){const c=r.charCodeAt(h);c===35||c===63?(i===void 0&&(i=r.substr(0,h)),i+=S[c]):i!==void 0&&(i+=r[h])}return i!==void 0?i:r}function a(r,i){let h;return r.authority&&r.path.length>1&&r.scheme==="file"?h=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?h=r.path.substr(1):h=r.path[1].toLowerCase()+r.path.substr(2):h=r.path,L.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=a;function l(r,i){const h=i?E:P;let c="",{scheme:d,authority:b,path:y,query:g,fragment:_}=r;if(d&&(c+=d,c+=":"),(b||d==="file")&&(c+=A,c+=A),b){let w=b.indexOf("@");if(w!==-1){const F=b.substr(0,w);b=b.substr(w+1),w=F.indexOf(":"),w===-1?c+=h(F,!1):(c+=h(F.substr(0,w),!1),c+=":",c+=h(F.substr(w+1),!1)),c+="@"}b=b.toLowerCase(),w=b.indexOf(":"),w===-1?c+=h(b,!1):(c+=h(b.substr(0,w),!1),c+=b.substr(w))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const w=y.charCodeAt(1);w>=65&&w<=90&&(y=`/${String.fromCharCode(w+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const w=y.charCodeAt(0);w>=65&&w<=90&&(y=`${String.fromCharCode(w+32)}:${y.substr(2)}`)}c+=h(y,!0)}return g&&(c+="?",c+=h(g,!1)),_&&(c+="#",c+=i?_:P(_,!1)),c}function p(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,i=>p(i)):r}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[24],ge([0,1,17,9,2]),function(J,e,m,L,I){"use strict";var k,R,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(s,r,i){let h=s.get(r);return h===void 0&&(h=i,s.set(r,h)),h}e.getOrSet=D;function T(s){const r=[];return s.forEach((i,h)=>{r.push(`${h} => ${i}`)}),`Map(${s.size}) {${r.join(", ")}}`}e.mapToString=T;function n(s){const r=[];return s.forEach(i=>{r.push(i)}),`Set(${s.size}) {${r.join(", ")}}`}e.setToString=n;class A{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),h=this._value.charCodeAt(this._pos);return i-h}value(){return this._value[this._pos]}}e.StringIterator=A;class u{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=u;class f{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var o;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(o||(o={}));class v{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=v;class S{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(r){this._iter=r}static forUris(r=()=>!1){return new P(new v(r))}static forPaths(){return new P(new f)}static forStrings(){return new P(new A)}static forConfigKeys(){return new P(new u)}clear(){this._root=void 0}set(r,i){const h=this._iter.reset(r);let c;for(this._root||(this._root=new S,this._root.segment=h.value()),c=this._root;;){const b=h.cmp(c.segment);if(b>0)c.left||(c.left=new S,c.left.segment=h.value()),c=c.left;else if(b<0)c.right||(c.right=new S,c.right.segment=h.value()),c=c.right;else if(h.hasNext())h.next(),c.mid||(c.mid=new S,c.mid.segment=h.value()),c=c.mid;else break}const d=c.value;return c.value=i,c.key=r,d}fill(r,i){const h=i.slice(0);(0,m.shuffle)(h);for(let c of h)this.set(c,r)}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let h=this._root;for(;h;){const c=i.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(i.hasNext())i.next(),h=h.mid;else break}return h}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const h=this._iter.reset(r),c=[];let d=this._root;for(;d;){const b=h.cmp(d.segment);if(b>0)c.push([1,d]),d=d.left;else if(b<0)c.push([-1,d]),d=d.right;else if(h.hasNext())h.next(),c.push([0,d]),d=d.mid;else{for(i?(d.left=void 0,d.mid=void 0,d.right=void 0):d.value=void 0;c.length>0&&d.isEmpty();){let[y,g]=c.pop();switch(y){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}d=g}break}}}findSubstr(r){const i=this._iter.reset(r);let h=this._root,c;for(;h;){const d=i.cmp(h.segment);if(d>0)h=h.left;else if(d<0)h=h.right;else if(i.hasNext())i.next(),c=h.value||c,h=h.mid;else break}return h&&h.value||c}findSuperstr(r){const i=this._iter.reset(r);let h=this._root;for(;h;){const c=i.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(i.hasNext())i.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(r){for(const[i,h]of this)r(h,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const h=i.pop();h&&(h.value&&(yield[h.key,h.value]),h.left&&i.push(h.left),h.mid&&i.push(h.mid),h.right&&i.push(h.right))}}}e.TernarySearchTree=P;class E{constructor(r,i){this[k]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=i??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[h,c]of this.map)r(c,I.URI.parse(h),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield I.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[I.URI.parse(r[0]),r[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[I.URI.parse(r[0]),r[1]]}}e.ResourceMap=E,E.defaultToKey=s=>s.toString();var a;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const h=this._map.get(r);if(!!h)return i!==0&&this.touch(h,i),h.value}set(r,i,h=0){let c=this._map.get(r);if(c)c.value=i,h!==0&&this.touch(c,h);else{switch(c={key:r,value:i,next:void 0,previous:void 0},h){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const h=this._state;let c=this._head;for(;c;){if(i?r.bind(i)(c.value,c.key,this):r(c.value,c.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,i=this._state;let h=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.key,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return c}values(){const r=this,i=this._state;let h=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.value,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return c}entries(){const r=this,i=this._state;let h=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:[h.key,h.value],done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return c}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,h=this.size;for(;i&&h>r;)this._map.delete(i.key),i=i.next,h--;this._head=i,this._size=h,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,h=r.previous;if(!i||!h)throw new Error("Invalid list");i.previous=h,h.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const h=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(h.previous=c,c.next=h),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const h=r.next,c=r.previous;r===this._head?(h.previous=void 0,this._head=h):(h.previous=c,c.next=h),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,h)=>{r.push([h,i])}),r}fromJSON(r){this.clear();for(const[i,h]of r)this.set(i,h)}}e.LinkedMap=l;class p extends l{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p;class t{constructor(r){C.set(this,void 0),nt(this,C,r,"f")}get size(){return Oe(this,C,"f").size}forEach(r,i){Oe(this,C,"f").forEach(r,i)}get(r){return Oe(this,C,"f").get(r)}has(r){return Oe(this,C,"f").has(r)}entries(){return Oe(this,C,"f").entries()}keys(){return Oe(this,C,"f").keys()}values(){return Oe(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Oe(this,C,"f").entries()}}e.ReadonlyMapView=t}),define(me[98],ge([0,1,24,9]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...Y){return function(oe,ve){for(let Me=0,qe=Y.length;Me<qe;Me++){const Ke=Y[Me](oe,ve);if(Ke)return Ke}return null}}e.or=I,e.matchesStrictPrefix=k.bind(void 0,!1),e.matchesPrefix=k.bind(void 0,!0);function k(Y,oe,ve){if(!ve||ve.length<oe.length)return null;let Me;return Y?Me=L.startsWithIgnoreCase(ve,oe):Me=ve.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(Y,oe){const ve=oe.toLowerCase().indexOf(Y.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Y.length}]}e.matchesContiguousSubString=R;function C(Y,oe){return D(Y.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=C;function D(Y,oe,ve,Me){if(ve===Y.length)return[];if(Me===oe.length)return null;if(Y[ve]===oe[Me]){let qe=null;return(qe=D(Y,oe,ve+1,Me+1))?P({start:Me,end:Me+1},qe):null}return D(Y,oe,ve,Me+1)}function T(Y){return 97<=Y&&Y<=122}function n(Y){return 65<=Y&&Y<=90}e.isUpper=n;function A(Y){return 48<=Y&&Y<=57}function u(Y){return Y===32||Y===9||Y===10||Y===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>f.add(Y.charCodeAt(0)));function o(Y){return u(Y)||f.has(Y)}function v(Y,oe){return Y===oe||o(Y)&&o(oe)}function S(Y){return T(Y)||n(Y)||A(Y)}function P(Y,oe){return oe.length===0?oe=[Y]:Y.end===oe[0].start?oe[0].start=Y.start:oe.unshift(Y),oe}function E(Y,oe){for(let ve=oe;ve<Y.length;ve++){const Me=Y.charCodeAt(ve);if(n(Me)||A(Me)||ve>0&&!S(Y.charCodeAt(ve-1)))return ve}return Y.length}function a(Y,oe,ve,Me){if(ve===Y.length)return[];if(Me===oe.length)return null;if(Y[ve]!==oe[Me].toLowerCase())return null;{let qe=null,Ke=Me+1;for(qe=a(Y,oe,ve+1,Me+1);!qe&&(Ke=E(oe,Ke))<oe.length;)qe=a(Y,oe,ve+1,Ke),Ke++;return qe===null?null:P({start:Me,end:Me+1},qe)}}function l(Y){let oe=0,ve=0,Me=0,qe=0,Ke=0;for(let pe=0;pe<Y.length;pe++)Ke=Y.charCodeAt(pe),n(Ke)&&oe++,T(Ke)&&ve++,S(Ke)&&Me++,A(Ke)&&qe++;const Se=oe/Y.length,tt=ve/Y.length,Z=Me/Y.length,te=qe/Y.length;return{upperPercent:Se,lowerPercent:tt,alphaPercent:Z,numericPercent:te}}function p(Y){const{upperPercent:oe,lowerPercent:ve}=Y;return ve===0&&oe>.6}function t(Y){const{upperPercent:oe,lowerPercent:ve,alphaPercent:Me,numericPercent:qe}=Y;return ve>.2&&oe<.8&&Me>.6&&qe<.2}function s(Y){let oe=0,ve=0,Me=0,qe=0;for(let Ke=0;Ke<Y.length;Ke++)Me=Y.charCodeAt(Ke),n(Me)&&oe++,T(Me)&&ve++,u(Me)&&qe++;return(oe===0||ve===0)&&qe===0?Y.length<=30:oe<=5}function r(Y,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(Y)||oe.length>60)return null;const ve=l(oe);if(!t(ve)){if(!p(ve))return null;oe=oe.toLowerCase()}let Me=null,qe=0;for(Y=Y.toLowerCase();qe<oe.length&&(Me=a(Y,oe,0,qe))===null;)qe=E(oe,qe+1);return Me}e.matchesCamelCase=r;function i(Y,oe,ve=!1){if(!oe||oe.length===0)return null;let Me=null,qe=0;for(Y=Y.toLowerCase(),oe=oe.toLowerCase();qe<oe.length&&(Me=h(Y,oe,0,qe,ve))===null;)qe=c(oe,qe+1);return Me}e.matchesWords=i;function h(Y,oe,ve,Me,qe){if(ve===Y.length)return[];if(Me===oe.length)return null;if(v(Y.charCodeAt(ve),oe.charCodeAt(Me))){let Ke=null,Se=Me+1;if(Ke=h(Y,oe,ve+1,Me+1,qe),!qe)for(;!Ke&&(Se=c(oe,Se))<oe.length;)Ke=h(Y,oe,ve+1,Se,qe),Se++;return Ke===null?null:P({start:Me,end:Me+1},Ke)}else return null}function c(Y,oe){for(let ve=oe;ve<Y.length;ve++)if(o(Y.charCodeAt(ve))||ve>0&&o(Y.charCodeAt(ve-1)))return ve;return Y.length}const d=I(e.matchesPrefix,r,R),b=I(e.matchesPrefix,r,C),y=new m.LRUCache(1e4);function g(Y,oe,ve=!1){if(typeof Y!="string"||typeof oe!="string")return null;let Me=y.get(Y);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Y),"i"),y.set(Y,Me));const qe=Me.exec(oe);return qe?[{start:qe.index,end:qe.index+qe[0].length}]:ve?b(Y,oe):d(Y,oe)}e.matchesFuzzy=g;function _(Y,oe){const ve=$e(Y,Y.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return ve?F(ve):null}e.matchesFuzzy2=_;function w(Y,oe,ve,Me,qe,Ke){const Se=Math.min(13,Y.length);for(;ve<Se;ve++){const tt=$e(Y,oe,ve,Me,qe,Ke,!1);if(tt)return tt}return[0,Ke]}e.anyScore=w;function F(Y){if(typeof Y=="undefined")return[];const oe=[],ve=Y[1];for(let Me=Y.length-1;Me>1;Me--){const qe=Y[Me]+ve,Ke=oe[oe.length-1];Ke&&Ke.end===qe?Ke.end=qe+1:oe.push({start:qe,end:qe+1})}return oe}e.createMatches=F;const O=128;function G(){const Y=[],oe=[];for(let ve=0;ve<=O;ve++)oe[ve]=0;for(let ve=0;ve<=O;ve++)Y.push(oe.slice(0));return Y}function K(Y){const oe=[];for(let ve=0;ve<=Y;ve++)oe[ve]=0;return oe}const U=K(2*O),W=K(2*O),M=G(),x=G(),B=G(),N=!1;function z(Y,oe,ve,Me,qe){function Ke(tt,Z,te=" "){for(;tt.length<Z;)tt=te+tt;return tt}let Se=` |   |${Me.split("").map(tt=>Ke(tt,3)).join("|")}
`;for(let tt=0;tt<=ve;tt++)tt===0?Se+=" |":Se+=`${oe[tt-1]}|`,Se+=Y[tt].slice(0,qe+1).map(Z=>Ke(Z.toString(),3)).join("|")+`
`;return Se}function H(Y,oe,ve,Me){Y=Y.substr(oe),ve=ve.substr(Me),console.log(z(x,Y,Y.length,ve,ve.length)),console.log(z(B,Y,Y.length,ve,ve.length)),console.log(z(M,Y,Y.length,ve,ve.length))}function Q(Y,oe){if(oe<0||oe>=Y.length)return!1;const ve=Y.codePointAt(oe);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function X(Y,oe){if(oe<0||oe>=Y.length)return!1;switch(Y.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function fe(Y,oe,ve){return oe[Y]!==ve[Y]}function _e(Y,oe,ve,Me,qe,Ke,Se=!1){for(;oe<ve&&qe<Ke;)Y[oe]===Me[qe]&&(Se&&(U[oe]=qe),oe+=1),qe+=1;return oe===ve}e.isPatternInWord=_e;var ye;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var Re;(function(Y){Y.Default=[-100,0];function oe(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Y.isDefault=oe})(Re=e.FuzzyScore||(e.FuzzyScore={}));function $e(Y,oe,ve,Me,qe,Ke,Se){const tt=Y.length>O?O:Y.length,Z=Me.length>O?O:Me.length;if(ve>=tt||Ke>=Z||tt-ve>Z-Ke||!_e(oe,ve,tt,qe,Ke,Z,!0))return;Be(tt,Z,ve,Ke,oe,qe);let te=1,pe=1,xe=ve,Je=Ke;const rt=[!1];for(te=1,xe=ve;xe<tt;te++,xe++){const ue=U[xe],Ie=W[xe],Ue=xe+1<tt?W[xe+1]:Z;for(pe=ue-Ke+1,Je=ue;Je<Ue;pe++,Je++){let Qe=Number.MIN_SAFE_INTEGER,ze=!1;Je<=Ie&&(Qe=je(Y,oe,xe,ve,Me,qe,Je,Z,Ke,M[te-1][pe-1]===0,rt));let at=0;Qe!==Number.MAX_SAFE_INTEGER&&(ze=!0,at=Qe+x[te-1][pe-1]);const Le=Je>ue,De=Le?x[te][pe-1]+(M[te][pe-1]>0?-5:0):0,ke=Je>ue+1&&M[te][pe-1]>0,ne=ke?x[te][pe-2]+(M[te][pe-2]>0?-5:0):0;if(ke&&(!Le||ne>=De)&&(!ze||ne>=at))x[te][pe]=ne,B[te][pe]=3,M[te][pe]=0;else if(Le&&(!ze||De>=at))x[te][pe]=De,B[te][pe]=2,M[te][pe]=0;else if(ze)x[te][pe]=at,B[te][pe]=1,M[te][pe]=M[te-1][pe-1]+1;else throw new Error("not possible")}}if(N&&H(Y,ve,Me,Ke),!rt[0]&&!Se)return;te--,pe--;const ft=[x[te][pe],Ke];let pt=0,St=0;for(;te>=1;){let ue=pe;do{const Ie=B[te][ue];if(Ie===3)ue=ue-2;else if(Ie===2)ue=ue-1;else break}while(ue>=1);pt>1&&oe[ve+te-1]===qe[Ke+pe-1]&&!fe(ue+Ke-1,Me,qe)&&pt+1>M[te][ue]&&(ue=pe),ue===pe?pt++:pt=1,St||(St=ue),te--,pe=ue-1,ft.push(pe)}Z===tt&&(ft[0]+=2);const Ct=St-tt;return ft[0]-=Ct,ft}e.fuzzyScore=$e;function Be(Y,oe,ve,Me,qe,Ke){let Se=Y-1,tt=oe-1;for(;Se>=ve&&tt>=Me;)qe[Se]===Ke[tt]&&(W[Se]=tt,Se--),tt--}function je(Y,oe,ve,Me,qe,Ke,Se,tt,Z,te,pe){if(oe[ve]!==Ke[Se])return Number.MIN_SAFE_INTEGER;let xe=1,Je=!1;return Se===ve-Me?xe=Y[ve]===qe[Se]?7:5:fe(Se,qe,Ke)&&(Se===0||!fe(Se-1,qe,Ke))?(xe=Y[ve]===qe[Se]?7:5,Je=!0):Q(Ke,Se)&&(Se===0||!Q(Ke,Se-1))?xe=5:(Q(Ke,Se-1)||X(Ke,Se-1))&&(xe=5,Je=!0),xe>1&&ve===Me&&(pe[0]=!0),Je||(Je=fe(Se,qe,Ke)||Q(Ke,Se-1)||X(Ke,Se-1)),ve===Me?Se>Z&&(xe-=Je?3:5):te?xe+=Je?2:0:xe+=Je?0:1,Se+1===tt&&(xe-=Je?3:5),xe}function V(Y,oe,ve,Me,qe,Ke,Se){return re(Y,oe,ve,Me,qe,Ke,!0,Se)}e.fuzzyScoreGracefulAggressive=V;function ee(Y,oe,ve,Me,qe,Ke,Se){return re(Y,oe,ve,Me,qe,Ke,!1,Se)}e.fuzzyScoreGraceful=ee;function re(Y,oe,ve,Me,qe,Ke,Se,tt){let Z=$e(Y,oe,ve,Me,qe,Ke,tt);if(Z&&!Se)return Z;if(Y.length>=3){const te=Math.min(7,Y.length-1);for(let pe=ve+1;pe<te;pe++){const xe=ae(Y,pe);if(xe){const Je=$e(xe,xe.toLowerCase(),ve,Me,qe,Ke,tt);Je&&(Je[0]-=3,(!Z||Je[0]>Z[0])&&(Z=Je))}}}return Z}function ae(Y,oe){if(oe+1>=Y.length)return;const ve=Y[oe],Me=Y[oe+1];if(ve!==Me)return Y.slice(0,oe)+Me+ve+Y.slice(oe+2)}}),define(me[141],ge([0,1,47,98,9]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const k=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${k.source}`,"g");function C(v){return v.replace(R,(S,P)=>P?S:`\\${S}`)}e.escapeIcons=C;const D=new RegExp(`\\\\${k.source}`,"g");function T(v){return v.replace(D,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=T;const n=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function A(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(n,(S,P,E,a)=>E?S:P||a||"")}e.stripIcons=A;function u(v){const S=v.indexOf(e.iconStartMarker);return S===-1?{text:v}:f(v,S)}e.parseLabelWithIcons=u;function f(v,S){const P=[];let E="";function a(c){if(c){E+=c;for(const d of c)P.push(t)}}let l=-1,p="",t=0,s,r,i=S;const h=v.length;for(a(v.substr(0,S));i<h;)s=v[i],r=v[i+1],s===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(l=i,a(p),p=e.iconStartMarker,i++):s===")"&&l!==-1?(t+=i-l+1,l=-1,p=""):l!==-1?/^[a-z0-9\-]$/i.test(s)?p+=s:(a(p),l=-1,p=""):a(s),i++;return a(p),{text:E,iconOffsets:P}}function o(v,S,P=!1){const{text:E,iconOffsets:a}=S;if(!a||a.length===0)return(0,L.matchesFuzzy)(v,E,P);const l=(0,I.ltrim)(E," "),p=E.length-l.length,t=(0,L.matchesFuzzy)(v,l,P);if(t)for(const s of t){const r=a[s.start+p]+p;s.start+=r,s.end+=r}return t}e.matchesFuzzyIconAware=o}),define(me[99],ge([0,1,16,141]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class k{constructor(f="",o=!1){if(this.value=f,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(f,o=0){return this.value+=T(this.supportThemeIcons?(0,L.escapeIcons)(f):f).replace(/([ \t]+)/g,(v,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,o){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=k;function R(u){return C(u)?!u.value:Array.isArray(u)?u.every(R):!0}e.isEmptyMarkdownString=R;function C(u){return u instanceof k?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function D(u,f){return u===f?!0:!u||!f?!1:u.value===f.value&&u.isTrusted===f.isTrusted&&u.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=D;function T(u){return u.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function n(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function A(u){const f=[],o=u.split("|").map(S=>S.trim());u=o[0];const v=o[1];if(v){const S=/height=(\d+)/.exec(v),P=/width=(\d+)/.exec(v),E=S?S[1]:"",a=P?P[1]:"",l=isFinite(parseInt(a)),p=isFinite(parseInt(E));l&&f.push(`width="${a}"`),p&&f.push(`height="${E}"`)}return{href:u,dimensions:f}}e.parseHrefAndDimensions=A}),define(me[60],ge([0,1,23,9,2]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(n){return JSON.stringify(n,D)}e.stringify=k;function R(n){let A=JSON.parse(n);return A=T(A),A}e.parse=R;var C;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function D(n,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,L.regExpFlags)(A)}:A}function T(n,A=0){if(!n||A>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return I.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof m.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let u=0;u<n.length;++u)n[u]=T(n[u],A+1);else for(const u in n)Object.hasOwnProperty.call(n,u)&&(n[u]=T(n[u],A+1))}return n}e.revive=T}),define(me[10],ge([0,1,11,2]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(I=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,T,n){this._hosts[D]=T,this._ports[D]=n}setConnectionToken(D,T){this._connectionTokens[D]=T}rewrite(D){if(this._delegate)return this._delegate(D);const T=D.authority;let n=this._hosts[T];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const A=this._ports[T],u=this._connectionTokens[T];let f=`path=${encodeURIComponent(D.path)}`;return typeof u=="string"&&(f+=`&tkn=${encodeURIComponent(u)}`),L.URI.from({scheme:m.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${n}:${A}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new k;class R{asBrowserUri(D,T){const n=this.toUri(D,T);return n.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===I.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${I.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?n.with({scheme:I.vscodeFileResource,authority:n.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(D,T){const n=this.toUri(D,T);return n.scheme===I.vscodeFileResource?n.with({scheme:I.file,authority:n.authority!==R.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(D,T){return L.URI.isUri(D)?D:L.URI.parse(T.toUrl(D))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(me[78],ge([0,1,24]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new m.LRUCache(1e4);function I(T){return D(T,"NFC",L)}e.normalizeNFC=I;const k=new m.LRUCache(1e4);function R(T){return D(T,"NFD",k)}e.normalizeNFD=R;const C=/[^\u0000-\u0080]/;function D(T,n,A){if(!T)return T;const u=A.get(T);if(u)return u;let f;return C.test(T)?f=T.normalize(n):f=T,A.set(T,f),f}e.removeAccents=function(){const T=/[\u0300-\u036f]/g;return function(n){return R(n).replace(T,"")}}()}),define(me[22],ge([0,1,29,10,8,11,9,2]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(f){return(0,C.uriToFsPath)(f,!0)}e.originalFSPath=D;class T{constructor(o){this._ignorePathCasing=o}compare(o,v,S=!1){return o===v?0:(0,R.compare)(this.getComparisonKey(o,S),this.getComparisonKey(v,S))}isEqual(o,v,S=!1){return o===v?!0:!o||!v?!1:this.getComparisonKey(o,S)===this.getComparisonKey(v,S)}getComparisonKey(o,v=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,v,S=!1){if(o.scheme===v.scheme){if(o.scheme===L.Schemas.file)return m.isEqualOrParent(D(o),D(v),this._ignorePathCasing(o))&&o.query===v.query&&(S||o.fragment===v.fragment);if((0,e.isEqualAuthority)(o.authority,v.authority))return m.isEqualOrParent(o.path,v.path,this._ignorePathCasing(o),"/")&&o.query===v.query&&(S||o.fragment===v.fragment)}return!1}joinPath(o,...v){return C.URI.joinPath(o,...v)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return I.posix.basename(o.path)}extname(o){return I.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let v;return o.scheme===L.Schemas.file?v=C.URI.file(I.dirname(D(o))).path:(v=I.posix.dirname(o.path),o.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),v="/")),o.with({path:v})}normalizePath(o){if(!o.path.length)return o;let v;return o.scheme===L.Schemas.file?v=C.URI.file(I.normalize(D(o))).path:v=I.posix.normalize(o.path),o.with({path:v})}relativePath(o,v){if(o.scheme!==v.scheme||!(0,e.isEqualAuthority)(o.authority,v.authority))return;if(o.scheme===L.Schemas.file){const E=I.relative(D(o),D(v));return k.isWindows?m.toSlashes(E):E}let S=o.path||"/",P=v.path||"/";if(this._ignorePathCasing(o)){let E=0;for(const a=Math.min(S.length,P.length);E<a&&!(S.charCodeAt(E)!==P.charCodeAt(E)&&S.charAt(E).toLowerCase()!==P.charAt(E).toLowerCase());E++);S=P.substr(0,E)+S.substr(E)}return I.posix.relative(S,P)}resolvePath(o,v){if(o.scheme===L.Schemas.file){const S=C.URI.file(I.resolve(D(o),v));return o.with({authority:S.authority,path:S.path})}return v=m.toPosixPath(v),o.with({path:I.posix.resolve(o.path,v)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,v){return o===v||(0,R.equalsIgnoreCase)(o,v)}hasTrailingPathSeparator(o,v=I.sep){if(o.scheme===L.Schemas.file){const S=D(o);return S.length>m.getRoot(S).length&&S[S.length-1]===v}else{const S=o.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,v=I.sep){return(0,e.hasTrailingPathSeparator)(o,v)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,v=I.sep){let S=!1;if(o.scheme===L.Schemas.file){const P=D(o);S=P!==void 0&&P.length===m.getRoot(P).length&&P[P.length-1]===v}else{v="/";const P=o.path;S=P.length===1&&P.charCodeAt(P.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(o,v)?o.with({path:o.path+"/"}):o}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(f=>f.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new T(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(f,o){const v=[];for(let S=0;S<f.length;S++){const P=o(f[S]);f.some((E,a)=>a===S?!1:(0,e.isEqualOrParent)(P,o(E)))||v.push(f[S])}return v}e.distinctParents=n;var A;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function o(v){const S=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(a=>{const[l,p]=a.split(":");l&&p&&S.set(l,p)});const E=v.path.substring(0,v.path.indexOf(";"));return E&&S.set(f.META_DATA_MIME,E),S}f.parseMetaData=o})(A=e.DataUri||(e.DataUri={}));function u(f,o,v){if(o){let S=f.path;return S&&S[0]!==I.posix.sep&&(S=I.posix.sep+S),f.with({scheme:v,authority:o,path:S})}return f.with({scheme:v})}e.toLocalResource=u}),define(me[18],ge([0,1,21,16,3,6,22]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(W){return!!W&&typeof W.then=="function"}e.isThenable=C;function D(W){const M=new m.CancellationTokenSource,x=W(M.token),B=new Promise((N,z)=>{const H=M.token.onCancellationRequested(()=>{H.dispose(),M.dispose(),z((0,L.canceled)())});Promise.resolve(x).then(Q=>{H.dispose(),M.dispose(),N(Q)},Q=>{H.dispose(),M.dispose(),z(Q)})});return new class{cancel(){M.cancel()}then(N,z){return B.then(N,z)}catch(N){return this.then(void 0,N)}finally(N){return B.finally(N)}}}e.createCancelablePromise=D;function T(W,M,x){return Promise.race([W,new Promise(B=>M.onCancellationRequested(()=>B(x)))])}e.raceCancellation=T;async function n(W){let M=-1;const x=W.map((N,z)=>N.then(H=>(M=z,H))),B=await Promise.race(x);return W.forEach((N,z)=>{z!==M&&N.cancel()}),B}e.raceCancellablePromises=n;function A(W,M,x){let B;const N=setTimeout(()=>{B?.(void 0),x?.()},M);return Promise.race([W.finally(()=>clearTimeout(N)),new Promise(z=>B=z)])}e.raceTimeout=A;function u(W){return new Promise((M,x)=>{const B=W();C(B)?B.then(M,x):M(B)})}e.asPromise=u;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(x,x).then(B)})}return new Promise((x,B)=>{this.queuedPromise.then(x,B)})}return this.activePromise=M(),new Promise((x,B)=>{this.activePromise.then(N=>{this.activePromise=null,x(N)},N=>{this.activePromise=null,B(N)})})}}e.Throttler=f;class o{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=o;class v{constructor(){this.promiseMap=new Map}queue(M,x){const N=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(M)===N&&this.promiseMap.delete(M)});return this.promiseMap.set(M,N),N}}e.SequencerByKey=v;class S{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,x=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,N)=>{this.doResolve=B,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class P{constructor(M){this.delayer=new S(M),this.throttler=new f}trigger(M,x){return this.delayer.trigger(()=>this.throttler.queue(M),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class E{constructor(){this._isOpen=!1,this._promise=new Promise((M,x)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class a extends E{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(W,M){return M?new Promise((x,B)=>{const N=setTimeout(()=>{z.dispose(),x()},W),z=M.onCancellationRequested(()=>{clearTimeout(N),z.dispose(),B((0,L.canceled)())})}):D(x=>l(W,x))}e.timeout=l;function p(W,M=0){const x=setTimeout(W,M);return(0,k.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=p;function t(W){const M=[];let x=0;const B=W.length;function N(){return x<B?W[x++]():null}function z(H){H!=null&&M.push(H);const Q=N();return Q?Q.then(z):Promise.resolve(M)}return Promise.resolve(null).then(z)}e.sequence=t;function s(W,M=B=>!!B,x=null){let B=0;const N=W.length,z=()=>{if(B>=N)return Promise.resolve(x);const H=W[B++];return Promise.resolve(H()).then(X=>M(X)?Promise.resolve(X):z())};return z()}e.first=s;function r(W,M=B=>!!B,x=null){if(W.length===0)return Promise.resolve(x);let B=W.length;const N=()=>{B=-1;for(const z of W)z.cancel?.()};return new Promise((z,H)=>{for(const Q of W)Q.then(X=>{--B>=0&&M(X)?(N(),z(X)):B===0&&z(x)}).catch(X=>{--B>=0&&(N(),H(X))})})}e.firstParallel=r;class i{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((x,B)=>{this.outstandingPromises.push({factory:M,c:x,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const x=M.factory();x.then(M.c,M.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class h extends i{constructor(){super(1)}}e.Queue=h;class c{constructor(){this.queues=new Map}queueFor(M,x=R.extUri){const B=x.getComparisonKey(M);let N=this.queues.get(B);return N||(N=new h,I.Event.once(N.onFinished)(()=>{N?.dispose(),this.queues.delete(B)}),this.queues.set(B,N)),N}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=c;class d{constructor(M,x){this._token=-1,typeof M=="function"&&typeof x=="number"&&this.setIfNotSet(M,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},x)}setIfNotSet(M,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},x))}}e.TimeoutTimer=d;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,x){this.cancel(),this._token=setInterval(()=>{M()},x)}}e.IntervalTimer=b;class y{constructor(M,x){this.timeoutToken=-1,this.runner=M,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=y;class g extends y{constructor(M,x){super(M,x);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=g;class _ extends k.Disposable{constructor(M,x,B,N){super();this.maxWorkChunkSize=M,this.maxPendingWork=x,this.throttleDelay=B,this.handler=N,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.maxPendingWork)return!1}else if(this.pending+M.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...M),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new y(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const x=setTimeout(()=>M(W));let B=!1;return{dispose(){B||(B=!0,clearTimeout(x))}}}}else e.runWhenIdle=(W,M)=>{const x=requestIdleCallback(W,typeof M=="number"?{timeout:M}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(x))}}}}();class w{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=w;async function F(W,M,x){let B;for(let N=0;N<x;N++)try{return await W()}catch(z){B=z,await l(M)}throw B}e.retry=F;class O{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(M,x,B){return this._pending={taskId:M,cancel:()=>B?.(),promise:x},x.then(()=>this.donePending(M),()=>this.donePending(M)),x}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let x,B;const N=new Promise((z,H)=>{x=z,B=H});this._next={run:M,promise:N,promiseResolve:x,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=O;class G{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,x)=>{this.completeCallback=M,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(x=>{this.completeCallback(M),this.resolved=!0,x()})}error(M){return new Promise(x=>{this.errorCallback(M),this.rejected=!0,x()})}cancel(){new Promise(M=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=K;var U;(function(W){async function M(x){let B;const N=await Promise.all(x.map(z=>z.then(H=>H,H=>{B||(B=H)})));if(typeof B!="undefined")throw B;return N}W.settled=M})(U=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,18,8]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new m.IdleValue(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),k=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(y,g,_=!1){const w=y||"",F=g||"",O=I.value.collator.compare(w,F);return I.value.collatorIsNumeric&&O===0&&w!==F?w<F?-1:1:O}e.compareFileNames=C;function D(y,g){const _=k.value.collator;return y=y||"",g=g||"",p(_,y,g)}e.compareFileNamesDefault=D;function T(y,g){const _=k.value.collator;return y=y||"",g=g||"",i(y,g)||p(_,y,g)}e.compareFileNamesUpper=T;function n(y,g){const _=k.value.collator;return y=y||"",g=g||"",r(y,g)||p(_,y,g)}e.compareFileNamesLower=n;function A(y,g){return y=y||"",g=g||"",y===g?0:y<g?-1:1}e.compareFileNamesUnicode=A;function u(y,g,_=!1){_||(y=y&&y.toLowerCase(),g=g&&g.toLowerCase());const[w,F]=a(y),[O,G]=a(g);return w!==O?w<O?-1:1:F===G?0:F<G?-1:1}e.noIntlCompareFileNames=u;function f(y,g){const[_,w]=a(y),[F,O]=a(g);let G=I.value.collator.compare(w,O);if(G===0){if(I.value.collatorIsNumeric&&w!==O)return w<O?-1:1;if(G=I.value.collator.compare(_,F),I.value.collatorIsNumeric&&G===0&&_!==F)return _<F?-1:1}return G}e.compareFileExtensions=f;function o(y,g){y=y||"",g=g||"";const _=l(y),w=l(g),F=k.value.collator,O=R.value.collator;return p(O,_,w)||p(F,y,g)}e.compareFileExtensionsDefault=o;function v(y,g){y=y||"",g=g||"";const _=l(y),w=l(g),F=k.value.collator,O=R.value.collator;return p(O,_,w)||i(y,g)||p(F,y,g)}e.compareFileExtensionsUpper=v;function S(y,g){y=y||"",g=g||"";const _=l(y),w=l(g),F=k.value.collator,O=R.value.collator;return p(O,_,w)||r(y,g)||p(F,y,g)}e.compareFileExtensionsLower=S;function P(y,g){y=y||"",g=g||"";const _=l(y).toLowerCase(),w=l(g).toLowerCase();return _!==w?_<w?-1:1:y!==g?y<g?-1:1:0}e.compareFileExtensionsUnicode=P;const E=/^(.*?)(\.([^.]*))?$/;function a(y,g=!1){const _=y?E.exec(y):[];let w=[_&&_[1]||"",_&&_[3]||""];return g&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function l(y){const g=y?E.exec(y):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function p(y,g,_){let w=y.compare(g,_);return w!==0?w:g.length!==_.length?g.length<_.length?-1:1:0}function t(y){const g=y.charAt(0);return g.toLocaleUpperCase()!==g}function s(y){const g=y.charAt(0);return g.toLocaleLowerCase()!==g}function r(y,g){return t(y)&&s(g)?-1:s(y)&&t(g)?1:0}function i(y,g){return s(y)&&t(g)?-1:t(y)&&s(g)?1:0}function h(y,g,_=!1){return _||(y=y&&y.toLowerCase(),g=g&&g.toLowerCase()),y===g?0:y<g?-1:1}function c(y,g,_=!1){const w=y.split(L.sep),F=g.split(L.sep),O=w.length-1,G=F.length-1;let K,U;for(let W=0;;W++){if(K=O===W,U=G===W,K&&U)return C(w[W],F[W],_);if(K)return-1;if(U)return 1;const M=h(w[W],F[W],_);if(M!==0)return M}}e.comparePaths=c;function d(y,g,_){const w=y.toLowerCase(),F=g.toLowerCase(),O=b(y,g,_);if(O)return O;const G=w.endsWith(_),K=F.endsWith(_);if(G!==K)return G?-1:1;const U=C(w,F);return U!==0?U:w.localeCompare(F)}e.compareAnything=d;function b(y,g,_){const w=y.toLowerCase(),F=g.toLowerCase(),O=w.startsWith(_),G=F.startsWith(_);if(O!==G)return O?-1:1;if(O&&G){if(w.length<F.length)return-1;if(w.length>F.length)return 1}return 0}e.compareByPrefix=b}),define(me[101],ge([0,1,100,98,48,8,11,9]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const D=0,T=[D,[]];function n(M,x,B,N){if(!M||!x)return T;const z=M.length,H=x.length;if(z<H)return T;const Q=M.toLowerCase();return A(x,B,H,M,Q,z,N)}e.scoreFuzzy=n;function A(M,x,B,N,z,H,Q){const X=[],fe=[];for(let $e=0;$e<B;$e++){const Be=$e*H,je=Be-H,V=$e>0,ee=M[$e],re=x[$e];for(let ae=0;ae<H;ae++){const Y=ae>0,oe=Be+ae,ve=oe-1,Me=je+ae-1,qe=Y?X[ve]:0,Ke=V&&Y?X[Me]:0,Se=V&&Y?fe[Me]:0;let tt;!Ke&&V?tt=0:tt=u(ee,re,N,z,ae,Se),tt&&Ke+tt>=qe&&(Q||V||z.startsWith(x,ae))?(fe[oe]=Se+1,X[oe]=Ke+tt):(fe[oe]=D,X[oe]=qe)}}const _e=[];let ye=B-1,Re=H-1;for(;ye>=0&&Re>=0;){const $e=ye*H+Re;fe[$e]===D||(_e.push(Re),ye--),Re--}return[X[B*H-1],_e.reverse()]}function u(M,x,B,N,z,H){let Q=0;if(!f(x,N[z]))return Q;if(Q+=1,H>0&&(Q+=H*5),M===B[z]&&(Q+=1),z===0)Q+=8;else{const X=o(B.charCodeAt(z-1));X?Q+=X:(0,L.isUpper)(B.charCodeAt(z))&&(Q+=2)}return Q}function f(M,x){return M===x?!0:M==="/"||M==="\\"?x==="/"||x==="\\":!1}function o(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function S(M,x,B=0,N=0){const z=x;return z.values&&z.values.length>1?P(M,z.values,B,N):E(M,x,B,N)}e.scoreFuzzy2=S;function P(M,x,B,N){let z=0;const H=[];for(const Q of x){const[X,fe]=E(M,Q,B,N);if(typeof X!="number")return v;z+=X,H.push(...fe)}return[z,b(H)]}function E(M,x,B,N){const z=(0,L.fuzzyScore)(x.original,x.originalLowercase,B,M,M.toLowerCase(),N,!0);return z?[z[0],(0,L.createMatches)(z)]:v}const a=Object.freeze({score:0}),l=1<<18,p=1<<17,t=1<<16;function s(M,x,B,N){const z=N.values?N.values:[N];return(0,I.hash)({[N.normalized]:{values:z.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:M,description:x,allowNonContiguousMatches:B}})}function r(M,x,B,N,z){if(!M||!x.normalized)return a;const H=N.getItemLabel(M);if(!H)return a;const Q=N.getItemDescription(M),X=s(H,Q,B,x),fe=z[X];if(fe)return fe;const _e=i(H,Q,N.getItemPath(M),x,B);return z[X]=_e,_e}e.scoreItemFuzzy=r;function i(M,x,B,N,z){const H=!B||!N.containsPathSeparator;return B&&(R.isLinux?N.pathNormalized===B:(0,C.equalsIgnoreCase)(N.pathNormalized,B))?{score:l,labelMatch:[{start:0,end:M.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:N.values&&N.values.length>1?h(M,x,B,N.values,H,z):c(M,x,B,N,H,z)}function h(M,x,B,N,z,H){let Q=0;const X=[],fe=[];for(const _e of N){const{score:ye,labelMatch:Re,descriptionMatch:$e}=c(M,x,B,_e,z,H);if(ye===D)return a;Q+=ye,Re&&X.push(...Re),$e&&fe.push(...$e)}return{score:Q,labelMatch:b(X),descriptionMatch:b(fe)}}function c(M,x,B,N,z,H){if(z||!x){const[Q,X]=n(M,N.normalized,N.normalizedLowercase,H&&!N.expectContiguousMatch);if(Q){const fe=(0,L.matchesPrefix)(N.normalized,M);let _e;return fe?(_e=p,_e+=Math.round(N.normalized.length/M.length*100)):_e=t,{score:_e+Q,labelMatch:fe||d(X)}}}if(x){let Q=x;B&&(Q=`${x}${k.sep}`);const X=Q.length,fe=`${Q}${M}`,[_e,ye]=n(fe,N.normalized,N.normalizedLowercase,H&&!N.expectContiguousMatch);if(_e){const Re=d(ye),$e=[],Be=[];return Re.forEach(je=>{je.start<X&&je.end>X?($e.push({start:0,end:je.end-X}),Be.push({start:je.start,end:X})):je.start>=X?$e.push({start:je.start-X,end:je.end-X}):Be.push(je)}),{score:_e,labelMatch:$e,descriptionMatch:Be}}}return a}function d(M){const x=[];if(!M)return x;let B;for(const N of M)B&&B.end===N?B.end+=1:(B={start:N,end:N+1},x.push(B));return x}function b(M){const x=M.sort((z,H)=>z.start-H.start),B=[];let N;for(const z of x)!N||!y(N,z)?(N=z,B.push(z)):(N.start=Math.min(N.start,z.start),N.end=Math.max(N.end,z.end));return B}function y(M,x){return!(M.end<x.start||x.end<M.start)}function g(M,x,B,N,z,H){const Q=r(M,B,N,z,H),X=r(x,B,N,z,H),fe=Q.score,_e=X.score;if((fe===l||_e===l)&&fe!==_e)return fe===l?-1:1;if(fe>t||_e>t){if(fe!==_e)return fe>_e?-1:1;if(fe<p&&_e<p){const ee=w(Q.labelMatch,X.labelMatch);if(ee!==0)return ee}const je=z.getItemLabel(M)||"",V=z.getItemLabel(x)||"";if(je.length!==V.length)return je.length-V.length}if(fe!==_e)return fe>_e?-1:1;const ye=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,Re=Array.isArray(X.labelMatch)&&X.labelMatch.length>0;if(ye&&!Re)return-1;if(Re&&!ye)return 1;const $e=_(M,Q,z),Be=_(x,X,z);return $e&&Be&&$e!==Be?Be>$e?-1:1:F(M,x,B,z)}e.compareItemsByFuzzyScore=g;function _(M,x,B){let N=-1,z=-1;if(x.descriptionMatch&&x.descriptionMatch.length?N=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(N=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(z=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const H=B.getItemDescription(M);H&&(z+=H.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(z=x.descriptionMatch[x.descriptionMatch.length-1].end);return z-N}function w(M,x){if(!M&&!x||(!M||!M.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!M||!M.length)return 1;const B=M[0].start,z=M[M.length-1].end-B,H=x[0].start,X=x[x.length-1].end-H;return z===X?0:X<z?1:-1}function F(M,x,B,N){const z=N.getItemLabel(M)||"",H=N.getItemLabel(x)||"",Q=N.getItemDescription(M),X=N.getItemDescription(x),fe=z.length+(Q?Q.length:0),_e=H.length+(X?X.length:0);if(fe!==_e)return fe-_e;const ye=N.getItemPath(M),Re=N.getItemPath(x);return ye&&Re&&ye.length!==Re.length?ye.length-Re.length:z!==H?(0,m.compareAnything)(z,H,B.normalized):Q&&X&&Q!==X?(0,m.compareAnything)(Q,X,B.normalized):ye&&Re&&ye!==Re?(0,m.compareAnything)(ye,Re,B.normalized):0}function O(M){return M.startsWith('"')&&M.endsWith('"')}const G=" ";function K(M){typeof M!="string"&&(M="");const x=M.toLowerCase(),{pathNormalized:B,normalized:N,normalizedLowercase:z}=U(M),H=B.indexOf(k.sep)>=0,Q=O(M);let X;const fe=M.split(G);if(fe.length>1)for(const _e of fe){const ye=O(_e),{pathNormalized:Re,normalized:$e,normalizedLowercase:Be}=U(_e);$e&&(X||(X=[]),X.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:Re,normalized:$e,normalizedLowercase:Be,expectContiguousMatch:ye}))}return{original:M,originalLowercase:x,pathNormalized:B,normalized:N,normalizedLowercase:z,values:X,containsPathSeparator:H,expectContiguousMatch:Q}}e.prepareQuery=K;function U(M){let x;R.isWindows?x=M.replace(/\//g,k.sep):x=M.replace(/\\/g,k.sep);const B=(0,C.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:B,normalizedLowercase:B.toLowerCase()}}function W(M){return Array.isArray(M)?K(M.map(x=>x.original).join(G)):K(M.original)}e.pieceToQuery=W}),define(me[30],ge([0,1,18,29,24,8,9]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const D="**",T="/",n="[/\\\\]",A="[^/\\\\]",u=/\//g;function f(N){switch(N){case 0:return"";case 1:return`${A}*?`;default:return`(?:${n}|${A}+${n}|${n}${A}+)*?`}}function o(N,z){if(!N)return[];const H=[];let Q=!1,X=!1,fe="";for(const _e of N){switch(_e){case z:if(!Q&&!X){H.push(fe),fe="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":X=!0;break;case"]":X=!1;break}fe+=_e}return fe&&H.push(fe),H}e.splitGlobAware=o;function v(N){if(!N)return"";let z="";const H=o(N,T);if(H.every(Q=>Q===D))z=".*";else{let Q=!1;H.forEach((X,fe)=>{if(X===D){Q||(z+=f(2),Q=!0);return}let _e=!1,ye="",Re=!1,$e="";for(const Be of X){if(Be!=="}"&&_e){ye+=Be;continue}if(Re&&(Be!=="]"||!$e)){let je;Be==="-"?je=Be:(Be==="^"||Be==="!")&&!$e?je="^":Be===T?je="":je=R.escapeRegExpCharacters(Be),$e+=je;continue}switch(Be){case"{":_e=!0;continue;case"[":Re=!0;continue;case"}":z+=`(?:${o(ye,",").map(ee=>v(ee)).join("|")})`,_e=!1,ye="";break;case"]":z+="["+$e+"]",Re=!1,$e="";break;case"?":z+=A;continue;case"*":z+=f(1);continue;default:z+=R.escapeRegExpCharacters(Be)}}fe<H.length-1&&(H[fe+1]!==D||fe+2<H.length)&&(z+=n),Q=!1})}return z}const S=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),s=function(){return!1},r=function(){return null};function i(N,z){if(!N)return r;let H;typeof N!="string"?H=N.pattern:H=N,H=H.trim();const Q=`${H}_${!!z.trimForExclusions}`;let X=t.get(Q);if(X)return h(X,N);let fe;if(S.test(H)){const _e=H.substr(4);X=function(ye,Re){return typeof ye=="string"&&ye.endsWith(_e)?H:null}}else(fe=P.exec(c(H,z)))?X=d(fe[1],H):(z.trimForExclusions?a:E).test(H)?X=b(H,z):(fe=l.exec(c(H,z)))?X=y(fe[1].substr(1),H,!0):(fe=p.exec(c(H,z)))?X=y(fe[1],H,!1):X=g(H);return t.set(Q,X),h(X,N)}function h(N,z){return typeof z=="string"?N:function(H,Q){return L.isEqualOrParent(H,z.base)?N(k.relative(z.base,H),Q):null}}function c(N,z){return z.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function d(N,z){const H=`/${N}`,Q=`\\${N}`,X=function(_e,ye){return typeof _e!="string"?null:ye?ye===N?z:null:_e===N||_e.endsWith(H)||_e.endsWith(Q)?z:null},fe=[N];return X.basenames=fe,X.patterns=[z],X.allBasenames=fe,X}function b(N,z){const H=B(N.slice(1,-1).split(",").map(ye=>i(ye,z)).filter(ye=>ye!==r),N),Q=H.length;if(!Q)return r;if(Q===1)return H[0];const X=function(ye,Re){for(let $e=0,Be=H.length;$e<Be;$e++)if(H[$e](ye,Re))return N;return null},fe=H.find(ye=>!!ye.allBasenames);fe&&(X.allBasenames=fe.allBasenames);const _e=H.reduce((ye,Re)=>Re.allPaths?ye.concat(Re.allPaths):ye,[]);return _e.length&&(X.allPaths=_e),X}function y(N,z,H){const Q=k.sep===k.posix.sep,X=Q?N:N.replace(u,k.sep),fe=k.sep+X,_e=k.posix.sep+N,ye=H?function(Re,$e){return typeof Re=="string"&&(Re===X||Re.endsWith(fe)||!Q&&(Re===N||Re.endsWith(_e)))?z:null}:function(Re,$e){return typeof Re=="string"&&(Re===X||!Q&&Re===N)?z:null};return ye.allPaths=[(H?"*/":"./")+N],ye}function g(N){try{const z=new RegExp(`^${v(N)}$`);return function(H){return z.lastIndex=0,typeof H=="string"&&z.test(H)?N:null}}catch(z){return r}}function _(N,z,H){return!N||typeof z!="string"?!1:w(N)(z,void 0,H)}e.match=_;function w(N,z={}){if(!N)return s;if(typeof N=="string"||K(N)){const H=i(N,z);if(H===r)return s;const Q=function(X,fe){return!!H(X,fe)};return H.allBasenames&&(Q.allBasenames=H.allBasenames),H.allPaths&&(Q.allPaths=H.allPaths),Q}return M(N,z)}e.parse=w;function F(N){if(!N)return;let z;return H=>(z||(z=(N()||Promise.resolve([])).then(Q=>Q?G(Q):{})),z.then(Q=>!!Q[H]))}e.hasSiblingPromiseFn=F;function O(N){if(!N)return;let z;return H=>{if(!z){const Q=N();z=Q?G(Q):{}}return!!z[H]}}e.hasSiblingFn=O;function G(N){const z={};for(const H of N)z[H]=!0;return z}function K(N){const z=N;return z&&typeof z.base=="string"&&typeof z.pattern=="string"}e.isRelativePattern=K;function U(N){return N.allBasenames||[]}e.getBasenameTerms=U;function W(N){return N.allPaths||[]}e.getPathTerms=W;function M(N,z){const H=B(Object.getOwnPropertyNames(N).map(ye=>x(ye,N[ye],z)).filter(ye=>ye!==r)),Q=H.length;if(!Q)return r;if(!H.some(ye=>!!ye.requiresSiblings)){if(Q===1)return H[0];const ye=function(Be,je){for(let V=0,ee=H.length;V<ee;V++){const re=H[V](Be,je);if(re)return re}return null},Re=H.find(Be=>!!Be.allBasenames);Re&&(ye.allBasenames=Re.allBasenames);const $e=H.reduce((Be,je)=>je.allPaths?Be.concat(je.allPaths):Be,[]);return $e.length&&(ye.allPaths=$e),ye}const X=function(ye,Re,$e){let Be;for(let je=0,V=H.length;je<V;je++){const ee=H[je];ee.requiresSiblings&&$e&&(Re||(Re=k.basename(ye)),Be||(Be=Re.substr(0,Re.length-k.extname(ye).length)));const re=ee(ye,Re,Be,$e);if(re)return re}return null},fe=H.find(ye=>!!ye.allBasenames);fe&&(X.allBasenames=fe.allBasenames);const _e=H.reduce((ye,Re)=>Re.allPaths?ye.concat(Re.allPaths):ye,[]);return _e.length&&(X.allPaths=_e),X}function x(N,z,H){if(z===!1)return r;const Q=i(N,H);if(Q===r)return r;if(typeof z=="boolean")return Q;if(z){const X=z.when;if(typeof X=="string"){const fe=(_e,ye,Re,$e)=>{if(!$e||!Q(_e,ye))return null;const Be=X.replace("$(basename)",Re),je=$e(Be);return(0,m.isThenable)(je)?je.then(V=>V?N:null):je?N:null};return fe.requiresSiblings=!0,fe}}return Q}function B(N,z){const H=N.filter(ye=>!!ye.basenames);if(H.length<2)return N;const Q=H.reduce((ye,Re)=>{const $e=Re.basenames;return $e?ye.concat($e):ye},[]);let X;if(z){X=[];for(let ye=0,Re=Q.length;ye<Re;ye++)X.push(z)}else X=H.reduce((ye,Re)=>{const $e=Re.patterns;return $e?ye.concat($e):ye},[]);const fe=function(ye,Re){if(typeof ye!="string")return null;if(!Re){let Be;for(Be=ye.length;Be>0;Be--){const je=ye.charCodeAt(Be-1);if(je===47||je===92)break}Re=ye.substr(Be)}const $e=Q.indexOf(Re);return $e!==-1?X[$e]:null};fe.basenames=Q,fe.patterns=X,fe.allBasenames=Q;const _e=N.filter(ye=>!ye.basenames);return _e.push(fe),_e}}),define(me[79],ge([0,1,29,10,8,11,22,9,2]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(i,h,c){if(typeof i=="string"&&(i=D.URI.file(i)),c){const b=c.getWorkspaceFolder(i);if(b){const y=c.getWorkspace().folders.length>1;let g;if((0,R.isEqual)(b.uri,i)?g="":g=(0,R.relativePath)(b.uri,i),y){const _=b.name?b.name:(0,R.basename)(b.uri);g=g?_+" \u2022 "+g:_}return g}}if(i.scheme!==L.Schemas.file&&i.scheme!==L.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(i.fsPath))return(0,I.normalize)(A(i.fsPath));let d=(0,I.normalize)(i.fsPath);return!k.isWindows&&h?.userHome&&(d=f(d,h.userHome.fsPath)),d}e.getPathLabel=T;function n(i){if(!i)return;typeof i=="string"&&(i=D.URI.file(i));const h=(0,R.basename)(i)||(i.scheme===L.Schemas.file?i.fsPath:i.path);return k.isWindows&&(0,m.isRootOrDriveLetter)(h)?A(h):h}e.getBaseLabel=n;function A(i){return(0,m.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=A;let u=Object.create(null);function f(i,h){if(k.isWindows||!i||!h)return i;let c=u.original===h?u.normalized:void 0;return c||(c=`${(0,C.rtrim)(h,I.posix.sep)}${I.posix.sep}`,u={original:h,normalized:c}),(k.isLinux?i.startsWith(c):(0,C.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}e.tildify=f;function o(i,h){return i.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=o;const v="\u2026",S="\\\\",P="~";function E(i,h=I.sep){const c=new Array(i.length);let d=!1;for(let b=0;b<i.length;b++){let y=i[b];if(y===""){c[b]=`.${h}`;continue}if(!y){c[b]=y;continue}d=!0;let g="";y.indexOf(S)===0?(g=y.substr(0,y.indexOf(S)+S.length),y=y.substr(y.indexOf(S)+S.length)):y.indexOf(h)===0?(g=y.substr(0,y.indexOf(h)+h.length),y=y.substr(y.indexOf(h)+h.length)):y.indexOf(P)===0&&(g=y.substr(0,y.indexOf(P)+P.length),y=y.substr(y.indexOf(P)+P.length));const _=y.split(h);for(let w=1;d&&w<=_.length;w++)for(let F=_.length-w;d&&F>=0;F--){d=!1;let O=_.slice(F,F+w).join(h);for(let G=0;!d&&G<i.length;G++)if(G!==b&&i[G]&&i[G].indexOf(O)>-1){const K=F+w===_.length,U=F>0&&i[G].indexOf(h)>-1?h+O:O,W=i[G].endsWith(U);d=!K||W}if(!d){let G="";(_[0].endsWith(":")||g!=="")&&(F===1&&(F=0,w++,O=_[0]+h+O),F>0&&(G=_[0]+h),G=g+G),F>0&&(G=G+v+h),G=G+O,F+w<_.length&&(G=G+h+v),c[b]=G}}d&&(c[b]=y)}return c}e.shorten=E;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function l(i,h=Object.create(null)){const c=[];let d=!1,b="";for(const y of i)if(y==="$"||d&&y==="{")b&&c.push({value:b,type:a.TEXT}),b="",d=!0;else if(y==="}"&&d){const g=h[b];if(typeof g=="string")g.length&&c.push({value:g,type:a.VARIABLE});else if(g){const _=c[c.length-1];(!_||_.type!==a.SEPARATOR)&&c.push({value:g.label,type:a.SEPARATOR})}b="",d=!1}else b+=y;return b&&!d&&c.push({value:b,type:a.TEXT}),c.filter((y,g)=>{if(y.type===a.SEPARATOR){const _=c[g-1],w=c[g+1];return[_,w].every(F=>F&&(F.type===a.VARIABLE||F.type===a.TEXT)&&F.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=l;function p(i,h){return k.isMacintosh||h?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(i,h){return k.isMacintosh||h?i.replace(/\(&&\w\)|&&/g,""):k.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(i){const h=i.indexOf("/")!==-1?I.posix:I.win32,c=h.basename(i),d=h.dirname(i);return c.length?{name:c,parentPath:d}:{name:d,parentPath:""}}e.splitName=r}),define(me[102],ge([0,1,30,10,8,22,9]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let D=[],T=[],n=[];function A(i,h=!1){const c=u(i);D.push(c),c.userConfigured?n.push(c):T.push(c),h&&!c.userConfigured&&D.forEach(d=>{d.mime===c.mime||d.userConfigured||(c.extension&&d.extension===c.extension&&console.warn(`Overwriting extension <<${c.extension}>> to now point to mime <<${c.mime}>>`),c.filename&&d.filename===c.filename&&console.warn(`Overwriting filename <<${c.filename}>> to now point to mime <<${c.mime}>>`),c.filepattern&&d.filepattern===c.filepattern&&console.warn(`Overwriting filepattern <<${c.filepattern}>> to now point to mime <<${c.mime}>>`),c.firstline&&d.firstline===c.firstline&&console.warn(`Overwriting firstline <<${c.firstline}>> to now point to mime <<${c.mime}>>`))})}e.registerTextMime=A;function u(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,m.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(I.posix.sep)>=0:!1}}function f(i){i?(D=D.filter(h=>!h.userConfigured),n=[]):(D=[],T=[],n=[])}e.clearTextMimes=f;function o(i,h){let c;if(i)switch(i.scheme){case L.Schemas.file:c=i.fsPath;break;case L.Schemas.data:c=k.DataUri.parseMetaData(i).get(k.DataUri.META_DATA_LABEL);break;default:c=i.path}if(!c)return[C.unknown];c=c.toLowerCase();const d=(0,I.basename)(c),b=v(c,d,n);if(b)return[b,C.text];const y=v(c,d,T);if(y)return[y,C.text];if(h){const g=S(h);if(g)return[g,C.text]}return[C.unknown]}e.guessMimeTypes=o;function v(i,h,c){let d=null,b=null,y=null;for(let g=c.length-1;g>=0;g--){const _=c[g];if(h===_.filenameLowercase){d=_;break}if(_.filepattern&&(!b||_.filepattern.length>b.filepattern.length)){const w=_.filepatternOnPath?i:h;_.filepatternLowercase?.(w)&&(b=_)}_.extension&&(!y||_.extension.length>y.extension.length)&&h.endsWith(_.extensionLowercase)&&(y=_)}return d?d.mime:b?b.mime:y?y.mime:null}function S(i){if((0,R.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let h=D.length-1;h>=0;h--){const c=D[h];if(!c.firstline)continue;const d=i.match(c.firstline);if(d&&d.length>0)return c.mime}return null}function P(i){return i?typeof i=="string"?i===C.binary||i===C.text||i===C.unknown:i.length===1&&P(i[0]):!0}e.isUnspecific=P;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(i){const h=(0,I.extname)(i),c=E[h.toLowerCase()];return c!==void 0?c:p(i)}e.getMediaOrTextMime=l;function p(i){const h=(0,I.extname)(i);return a[h.toLowerCase()]}e.getMediaMime=p;function t(i){for(const h in a)if(a[h]===i)return h}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function r(i,h){const c=s.exec(i);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:h?void 0:i}e.normalizeMimeType=r}),define(me[103],ge([0,1,2]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class I{constructor(A){this._uriTransformer=A}transformIncoming(A){const u=this._uriTransformer.transformIncoming(A);return u===A?A:L(m.URI.from(u))}transformOutgoing(A){const u=this._uriTransformer.transformOutgoing(A);return u===A?A:L(m.URI.from(u))}transformOutgoingURI(A){const u=this._uriTransformer.transformOutgoing(A);return u===A?A:m.URI.from(u)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,A,u){if(!n||u>200)return null;if(typeof n=="object"){if(n instanceof m.URI)return A.transformOutgoing(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const o=k(n[f],A,u+1);o!==null&&(n[f]=o)}}return null}function R(n,A){const u=k(n,A,0);return u===null?n:u}e.transformOutgoingURIs=R;function C(n,A,u,f){if(!n||f>200)return null;if(typeof n=="object"){if(n.$mid===1)return u?m.URI.revive(A.transformIncoming(n)):A.transformIncoming(n);for(let o in n)if(Object.hasOwnProperty.call(n,o)){const v=C(n[o],A,u,f+1);v!==null&&(n[o]=v)}}return null}function D(n,A){const u=C(n,A,!1,0);return u===null?n:u}e.transformIncomingURIs=D;function T(n,A){const u=C(n,A,!0,0);return u===null?n:u}e.transformAndReviveIncomingURIs=T}),define(me[32],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(D){return m.test(D)}e.isUUID=L;const I=new Uint8Array(16),k=[];for(let D=0;D<256;D++)k.push(D.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(D){for(let T=0;T<D.length;T++)D[T]=Math.floor(Math.random()*256);return D};function C(){R(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let D=0,T="";return T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T+="-",T+=k[I[D++]],T+=k[I[D++]],T+="-",T+=k[I[D++]],T+=k[I[D++]],T+="-",T+=k[I[D++]],T+=k[I[D++]],T+="-",T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T}e.generateUuid=C}),define(me[142],ge([0,1,104]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new m.StringDecoder(k),this.remaining=null}write(k){const R=[],C=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(C.length<1)return R;let D=0,T,n=D;for(;n<C.length;)if(T=C.charCodeAt(n),T===13||T===10){if(R.push(C.substring(D,n)),n++,n<C.length){const A=T;T=C.charCodeAt(n),(A===13&&T===10||A===10&&T===13)&&n++}D=n}else n++;return this.remaining=D<C.length?C.substr(D):null,R}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,50,80,291,18,29,78,8,11,22,2,32]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function o(U,W=f.UNLINK){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return W===f.UNLINK?S(U):v(U)}async function v(U){try{const W=(0,D.join)((0,L.tmpdir)(),(0,u.generateUuid)());try{await e.Promises.rename(U,W)}catch(M){return S(U)}S(W).catch(M=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function S(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function P(U){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(U,{recursive:!0})}e.rimrafSync=P;async function E(U,W){return p(await(W?a(U):(0,I.promisify)(m.readdir)(U)))}async function a(U){try{return await(0,I.promisify)(m.readdir)(U,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const W=[],M=await E(U);for(const x of M){let B=!1,N=!1,z=!1;try{const H=await e.Promises.lstat((0,D.join)(U,x));B=H.isFile(),N=H.isDirectory(),z=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}W.push({name:x,isFile:()=>B,isDirectory:()=>N,isSymbolicLink:()=>z})}return W}function l(U){return p(m.readdirSync(U))}e.readdirSync=l;function p(U){return U.map(W=>typeof W=="string"?T.isMacintosh?(0,C.normalizeNFC)(W):W:(W.name=T.isMacintosh?(0,C.normalizeNFC)(W.name):W.name,W))}async function t(U){const W=await E(U),M=[];for(const x of W)await r.existsDirectory((0,D.join)(U,x))&&M.push(x);return M}function s(U,W=1e3){return new Promise(M=>{let x=!1;const B=setInterval(()=>{x||(x=!0,m.access(U,N=>{x=!1,N&&(clearInterval(B),M(void 0))}))},W)})}e.whenDeleted=s;var r;(function(U){async function W(B){let N;try{if(N=await e.Promises.lstat(B),!N.isSymbolicLink())return{stat:N}}catch(z){}try{return{stat:await e.Promises.stat(B),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(T.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw H}throw z}}U.stat=W;async function M(B){try{const{stat:N,symbolicLink:z}=await U.stat(B);return N.isFile()&&z?.dangling!==!0}catch(N){}return!1}U.existsFile=M;async function x(B){try{const{stat:N,symbolicLink:z}=await U.stat(B);return N.isDirectory()&&z?.dangling!==!0}catch(N){}return!1}U.existsDirectory=x})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new k.ResourceQueue;function h(U,W,M){return i.queueFor(A.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const x=y(M);return new Promise((B,N)=>d(U,W,x,z=>z?N(z):B()))})}let c=!0;function d(U,W,M,x){if(!c)return m.writeFile(U,W,{mode:M.mode,flag:M.flag},x);m.open(U,M.flag,M.mode,(B,N)=>{if(B)return x(B);m.writeFile(N,W,z=>{if(z)return m.close(N,()=>x(z));m.fdatasync(N,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),c=!1),m.close(N,Q=>x(Q))))})})}function b(U,W,M){const x=y(M);if(!c)return m.writeFileSync(U,W,{mode:x.mode,flag:x.flag});const B=m.openSync(U,x.flag,x.mode);try{m.writeFileSync(B,W);try{m.fdatasyncSync(B)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),c=!1}}finally{m.closeSync(B)}}e.writeFileSync=b;function y(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function g(U,W){if(U===W)return;async function M(x){try{const B=await e.Promises.lstat(x);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(x,B.atime,new Date)}catch(B){}}try{await e.Promises.rename(U,W),await M(W)}catch(x){if(U.toLowerCase()!==W.toLowerCase()&&x.code==="EXDEV"||U.endsWith("."))await _(U,W,{preserveSymlinks:!1}),await o(U,f.MOVE),await M(W);else throw x}}async function _(U,W,M){return F(U,W,{root:{source:U,target:W},options:M,handledSourcePaths:new Set})}const w=511;async function F(U,W,M){if(M.handledSourcePaths.has(U))return;M.handledSourcePaths.add(U);const{stat:x,symbolicLink:B}=await r.stat(U);if(B){if(M.options.preserveSymlinks)try{return await K(U,W,M)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(B.dangling)return}return x.isDirectory()?O(U,W,x.mode&w,M):G(U,W,x.mode&w)}async function O(U,W,M,x){await e.Promises.mkdir(W,{recursive:!0,mode:M});const B=await E(U);for(const N of B)await F((0,D.join)(U,N),(0,D.join)(W,N),x)}async function G(U,W,M){await e.Promises.copyFile(U,W),await e.Promises.chmod(W,M)}async function K(U,W,M){let x=await e.Promises.readlink(U);(0,R.isEqualOrParent)(x,M.root.source,!T.isLinux)&&(x=(0,D.join)(M.root.target,x.substr(M.root.source.length+1))),await e.Promises.symlink(x,W)}e.Promises=new class{get access(){return(0,I.promisify)(m.access)}get stat(){return(0,I.promisify)(m.stat)}get lstat(){return(0,I.promisify)(m.lstat)}get utimes(){return(0,I.promisify)(m.utimes)}get read(){return(0,I.promisify)(m.read)}get readFile(){return(0,I.promisify)(m.readFile)}get write(){return(0,I.promisify)(m.write)}get appendFile(){return(0,I.promisify)(m.appendFile)}get fdatasync(){return(0,I.promisify)(m.fdatasync)}get truncate(){return(0,I.promisify)(m.truncate)}get rename(){return(0,I.promisify)(m.rename)}get copyFile(){return(0,I.promisify)(m.copyFile)}get open(){return(0,I.promisify)(m.open)}get close(){return(0,I.promisify)(m.close)}get symlink(){return(0,I.promisify)(m.symlink)}get readlink(){return(0,I.promisify)(m.readlink)}get chmod(){return(0,I.promisify)(m.chmod)}get mkdir(){return(0,I.promisify)(m.mkdir)}get unlink(){return(0,I.promisify)(m.unlink)}get rmdir(){return(0,I.promisify)(m.rmdir)}get realpath(){return(0,I.promisify)(m.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return t}get writeFile(){return h}get rm(){return o}get move(){return g}get copy(){return _}}}),define(me[105],ge([0,1,50,8,9,28]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function R(n){const A=(0,L.dirname)(n);if(n===A)return n;const u=((0,L.basename)(n)||n).toLowerCase();try{const o=(0,k.readdirSync)(A).filter(v=>v.toLowerCase()===u);if(o.length===1){const v=R(A);if(v)return(0,L.join)(v,o[0])}else if(o.length>1){const v=o.indexOf(u);if(v>=0){const S=R(A);if(S)return(0,L.join)(S,o[v])}}}catch(f){}return null}e.realcaseSync=R;async function C(n){try{return await k.Promises.realpath(n)}catch(A){const u=T(n);return await k.Promises.access(u,m.constants.R_OK),u}}e.realpath=C;function D(n){try{return m.realpathSync(n)}catch(A){const u=T(n);return m.accessSync(u,m.constants.R_OK),u}}e.realpathSync=D;function T(n){return(0,I.rtrim)((0,L.normalize)(n),L.sep)}});var Ve=this&&this.__decorate||function(J,e,m,L){var I=arguments.length,k=I<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(J,e,m,L);else for(var C=J.length-1;C>=0;C--)(R=J[C])&&(k=(I<3?R(k):I>3?R(e,m,k):R(e,m))||k);return I>3&&k&&Object.defineProperty(e,m,k),k};define(me[106],ge([0,1,17,18,23,21,58,16,3,6,60,9,13]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function o(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function S(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(P||(P={}));class E{constructor(N){this.buffer=N,this.pos=0}read(N){const z=this.buffer.slice(this.pos,this.pos+N);return this.pos+=z.byteLength,z}}class a{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var l;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(l||(l={}));function p(B){const N=I.VSBuffer.alloc(4);return N.writeUInt32BE(B,0),N}function t(B){return B.read(4).readUInt32BE(0)}function s(B){const N=I.VSBuffer.alloc(1);return N.writeUInt8(B,0),N}const r={Undefined:s(l.Undefined),String:s(l.String),Buffer:s(l.Buffer),VSBuffer:s(l.VSBuffer),Array:s(l.Array),Object:s(l.Object)},i=typeof Buffer!="undefined";function h(B,N){if(typeof N=="undefined")B.write(r.Undefined);else if(typeof N=="string"){const z=I.VSBuffer.fromString(N);B.write(r.String),B.write(p(z.byteLength)),B.write(z)}else if(i&&Buffer.isBuffer(N)){const z=I.VSBuffer.wrap(N);B.write(r.Buffer),B.write(p(z.byteLength)),B.write(z)}else if(N instanceof I.VSBuffer)B.write(r.VSBuffer),B.write(p(N.byteLength)),B.write(N);else if(Array.isArray(N)){B.write(r.Array),B.write(p(N.length));for(const z of N)h(B,z)}else{const z=I.VSBuffer.fromString(JSON.stringify(N));B.write(r.Object),B.write(p(z.byteLength)),B.write(z)}}function c(B){switch(B.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return B.read(t(B)).toString();case l.Buffer:return B.read(t(B)).buffer;case l.VSBuffer:return B.read(t(B));case l.Array:{const z=t(B),H=[];for(let Q=0;Q<z;Q++)H.push(c(B));return H}case l.Object:return JSON.parse(B.read(t(B)).toString())}}class d{constructor(N,z,H=null,Q=1e3){this.protocol=N,this.ctx=z,this.logger=H,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(N,z){this.channels.set(N,z),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const z=this.send([N.type]);this.logger&&this.logger.logOutgoing(z,0,1,S(N.type));return}case 201:case 202:case 204:case 203:{const z=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(z,N.id,1,S(N.type),N.data);return}}}send(N,z=void 0){const H=new a;return h(H,N),h(H,z),this.sendBuffer(H.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(z){return 0}}onRawMessage(N){const z=new E(N),H=c(z),Q=c(z),X=H[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${o(X)}: ${H[2]}.${H[3]}`,Q),this.onPromise({type:X,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${o(X)}: ${H[2]}.${H[3]}`,Q),this.onEventListen({type:X,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${o(X)}`),this.disposeActiveRequest({type:X,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${o(X)}`),this.disposeActiveRequest({type:X,id:H[1]})}}onPromise(N){const z=this.channels.get(N.channelName);if(!z){this.collectPendingRequest(N);return}const H=new k.CancellationTokenSource;let Q;try{Q=z.call(this.ctx,N.name,N.arg,H.token)}catch(_e){Q=Promise.reject(_e)}const X=N.id;Q.then(_e=>{this.sendResponse({id:X,data:_e,type:201}),this.activeRequests.delete(N.id)},_e=>{_e instanceof Error?this.sendResponse({id:X,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:X,data:_e,type:203}),this.activeRequests.delete(N.id)});const fe=(0,T.toDisposable)(()=>H.cancel());this.activeRequests.set(N.id,fe)}onEventListen(N){const z=this.channels.get(N.channelName);if(!z){this.collectPendingRequest(N);return}const H=N.id,X=z.listen(this.ctx,N.name,N.arg)(fe=>this.sendResponse({id:H,data:fe,type:204}));this.activeRequests.set(N.id,X)}disposeActiveRequest(N){const z=this.activeRequests.get(N.id);z&&(z.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let z=this.pendingRequests.get(N.channelName);z||(z=[],this.pendingRequests.set(N.channelName,z));const H=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:N,timeoutTimer:H})}flushPendingRequests(N){const z=this.pendingRequests.get(N);if(z){for(const H of z)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var b;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(N,z=null){this.protocol=N,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new D.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=z}getChannel(N){const z=this;return{call(H,Q,X){return z.isDisposed?Promise.reject(C.canceled()):z.requestPromise(N,H,Q,X)},listen(H,Q){return z.isDisposed?Promise.reject(C.canceled()):z.requestEvent(N,H,Q)}}}requestPromise(N,z,H,Q=k.CancellationToken.None){const X=this.lastRequestId++,_e={id:X,type:100,channelName:N,name:z,arg:H};if(Q.isCancellationRequested)return Promise.reject(C.canceled());let ye;return new Promise(($e,Be)=>{if(Q.isCancellationRequested)return Be(C.canceled());const je=()=>{const ae=Y=>{switch(Y.type){case 201:this.handlers.delete(X),$e(Y.data);break;case 202:this.handlers.delete(X);const oe=new Error(Y.data.message);oe.stack=Y.data.stack,oe.name=Y.data.name,Be(oe);break;case 203:this.handlers.delete(X),Be(Y.data);break}};this.handlers.set(X,ae),this.sendRequest(_e)};let V=null;this.state===P.Idle?je():(V=(0,L.createCancelablePromise)(ae=>this.whenInitialized()),V.then(()=>{V=null,je()}));const ee=()=>{V?(V.cancel(),V=null):this.sendRequest({id:X,type:101}),Be(C.canceled())},re=Q.onCancellationRequested(ee);ye=(0,T.combinedDisposable)((0,T.toDisposable)(ee),re),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(N,z,H){const Q=this.lastRequestId++,fe={id:Q,type:102,channelName:N,name:z,arg:H};let _e=null;const ye=new D.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)($e=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(ye),this.sendRequest(fe)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(ye),this.sendRequest({id:Q,type:103}))}}),Re=$e=>ye.fire($e.data);return this.handlers.set(Q,Re),ye.event}sendRequest(N){switch(N.type){case 100:case 102:{const z=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(z,N.id,0,`${o(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const z=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(z,N.id,0,o(N.type));return}}}send(N,z=void 0){const H=new a;return h(H,N),h(H,z),this.sendBuffer(H.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(z){return 0}}onBuffer(N){const z=new E(N),H=c(z),Q=c(z),X=H[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,S(X)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],0,S(X),Q),this.onResponse({type:H[0],id:H[1],data:Q})}}onResponse(N){if(N.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(N.id);z&&z(N)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}Ve([R.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class g{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new D.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new D.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:z,onDidClientDisconnect:H})=>{D.Event.once(z.onMessage)(X=>{const fe=new E(X),_e=c(fe),ye=new d(z,_e),Re=new y(z);this.channels.forEach((Be,je)=>ye.registerChannel(je,Be));const $e={channelServer:ye,channelClient:Re,ctx:_e};this._connections.add($e),this._onDidAddConnection.fire($e),H(()=>{ye.dispose(),Re.dispose(),this._connections.delete($e),this._onDidRemoveConnection.fire($e)})})})}get connections(){const N=[];return this._connections.forEach(z=>N.push(z)),N}getChannel(N,z){const H=this;return{call(Q,X,fe){let _e;if((0,u.isFunction)(z)){let Re=(0,m.getRandomElement)(H.connections.filter(z));_e=Re?Promise.resolve(Re):D.Event.toPromise(D.Event.filter(H.onDidAddConnection,z))}else _e=z.routeCall(H,Q,X);const ye=_e.then(Re=>Re.channelClient.getChannel(N));return w(ye).call(Q,X,fe)},listen(Q,X){if((0,u.isFunction)(z))return H.getMulticastEvent(N,z,Q,X);const fe=z.routeEvent(H,Q,X).then(_e=>_e.channelClient.getChannel(N));return w(fe).listen(Q,X)}}}getMulticastEvent(N,z,H,Q){const X=this;let fe=new T.DisposableStore;const _e=new D.Emitter({onFirstListenerAdd:()=>{fe=new T.DisposableStore;const ye=new D.EventMultiplexer,Re=new Map,$e=je=>{const ee=je.channelClient.getChannel(N).listen(H,Q),re=ye.add(ee);Re.set(je,re)},Be=je=>{const V=Re.get(je);!V||(V.dispose(),Re.delete(je))};X.connections.filter(z).forEach($e),D.Event.filter(X.onDidAddConnection,z)($e,void 0,fe),X.onDidRemoveConnection(Be,void 0,fe),ye.event(_e.fire,_e,fe),fe.add(ye)},onLastListenerRemove:()=>{fe.dispose()}});return _e.event}registerChannel(N,z){this.channels.set(N,z),this._connections.forEach(H=>{H.channelServer.registerChannel(N,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=g;class _{constructor(N,z,H=null){const Q=new a;h(Q,z),N.send(Q.buffer),this.channelClient=new y(N,H),this.channelServer=new d(N,z,H)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,z){this.channelServer.registerChannel(N,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function w(B){return{call(N,z,H){return B.then(Q=>Q.call(N,z,H))},listen(N,z){const H=new D.Relay;return B.then(Q=>H.input=Q.listen(N,z)),H.event}}}e.getDelayedChannel=w;function F(B){let N=!1;return{call(z,H,Q){return N?B.call(z,H,Q):(0,L.timeout)(0).then(()=>N=!0).then(()=>B.call(z,H,Q))},listen(z,H){if(N)return B.listen(z,H);const Q=new D.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>Q.input=B.listen(z,H)),Q.event}}}e.getNextTickChannel=F;class O{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const z of N.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await D.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=O;var G;(function(B){function N(Q,X){const fe=Q,_e=X&&X.disableMarshalling,ye=new Map;for(const Re in fe)H(Re)&&ye.set(Re,D.Event.buffer(fe[Re],!0));return new class{listen(Re,$e){const Be=ye.get($e);if(Be)return Be;throw new Error(`Event not found: ${$e}`)}call(Re,$e,Be){const je=fe[$e];if(typeof je=="function"){if(!_e&&Array.isArray(Be))for(let V=0;V<Be.length;V++)Be[V]=(0,n.revive)(Be[V]);return je.apply(fe,Be)}throw new Error(`Method not found: ${$e}`)}}}B.fromService=N;function z(Q,X){const fe=X&&X.disableMarshalling;return new Proxy({},{get(_e,ye){if(typeof ye=="string")return X?.properties?.has(ye)?X.properties.get(ye):H(ye)?Q.listen(ye):async function(...Re){let $e;X&&!(0,u.isUndefinedOrNull)(X.context)?$e=[X.context,...Re]:$e=Re;const Be=await Q.call(ye,$e);return fe?Be:(0,n.revive)(Be)};throw new Error(`Property not found: ${String(ye)}`)}})}B.toService=z;function H(Q){return Q[0]==="o"&&Q[1]==="n"&&A.isUpperAsciiLetter(Q.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let N=B.toString();if(N!=="[object Object]")return N}return B}function W(B){return Array.isArray(B)?B.map(U):U(B)}function M(B,N,z,H,Q,X,fe){fe=W(fe);const _e=K[Q],ye=_e[H%_e.length];let Re=[`%c[${B}]%c[${String(N).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(X)?(Re=Re.concat(fe),Re.push(")")):Re.push(fe),console.log.apply(console,Re)}e.logWithColors=M;class x{constructor(N,z){this._outgoingPrefix=N,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,z,H,Q,X){this._totalOutgoing+=N,M(this._outgoingPrefix,this._totalOutgoing,N,z,H,Q,X)}logIncoming(N,z,H,Q,X){this._totalIncoming+=N,M(this._incomingPrefix,this._totalIncoming,N,z,H,Q,X)}}e.IPCLogger=x}),define(me[107],ge([0,1,23,3,6,11,34,106]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var D;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function n(){return T||(T=m.VSBuffer.alloc(0)),T}class A{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,h){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const y=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=i),y}if(this._chunks[0].byteLength>i){const y=this._chunks[0].slice(0,i);return h&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),y}let c=m.VSBuffer.alloc(i),d=0,b=0;for(;i>0;){const y=this._chunks[b];if(y.byteLength>i){const g=y.slice(0,i);c.set(g,d),d+=i,h&&(this._chunks[b]=y.slice(i),this._totalLength-=i),i-=i}else c.set(y,d),d+=y.byteLength,h?(this._chunks.shift(),this._totalLength-=y.byteLength):b++,i-=y.byteLength}return c}}e.ChunkStream=A;var u;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(u||(u={}));var f;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class o{constructor(i,h,c,d){this.type=i,this.id=h,this.ack=c,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends I.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new A,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5);else{const c=this._state.messageType,d=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new o(c,d,b,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=m.VSBuffer.alloc(13);h.writeUInt8(i.type,0),h.writeUInt32BE(i.id,1),h.writeUInt32BE(i.ack,5),h.writeUInt32BE(i.data.byteLength,9),this._writeSoon(h,i.data)}_bufferAdd(i,h){const c=this._totalLength===0;return this._data.push(i,h),this._totalLength+=i.byteLength+h.byteLength,c}_bufferTake(){const i=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,h){this._bufferAdd(i,h)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends I.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new o(1,0,0,i))}}e.Protocol=P;class E extends C.IPCClient{constructor(i,h,c=null){super(i,h,c);this.protocol=i}static fromSocket(i,h){return new E(new P(i),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=E;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,R.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class l{constructor(i){this.data=i,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],h=0,c=this._first;for(;c;)i[h++]=c.data,c=c.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const h=new l(i);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let h=0;h<t._HISTORY_LENGTH;h++)this.lastRuns[h]=i-1e3*h;setInterval(()=>{for(let h=t._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),h=(1+t._HISTORY_LENGTH)*1e3;let c=0;for(let d=0;d<t._HISTORY_LENGTH;d++)i-this.lastRuns[d]<=h&&c++;return 1-c/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(i,h=null,c=t.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),h&&this._socketReader.acceptChunk(h),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new o(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const h=new o(4,0,0,n());this._socketWriter.write(h),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,h){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let h=0,c=i.length;h<c;h++)this._socketWriter.write(i[h]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new o(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const h=this._outgoingUnackMsg.toArray();for(let c=0,d=h.length;c<d;c++)this._socketWriter.write(h[c]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new o(1,h,this._incomingAckId,i);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(i){const h=new o(2,0,0,i);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),h=Date.now()-i.writtenTime;if(h>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-h,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new o(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=s}),define(me[108],ge([0,1,97]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(C){let D=(0,m.toUint8)(C);this._defaultValue=D,this._asciiMap=L._createAsciiMap(D),this._map=new Map}static _createAsciiMap(C){let D=new Uint8Array(256);for(let T=0;T<256;T++)D[T]=C;return D}set(C,D){let T=(0,m.toUint8)(D);C>=0&&C<256?this._asciiMap[C]=T:this._map.set(C,T)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=L;var I;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(I||(I={}));class k{constructor(){this._actual=new L(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=k}),define(me[143],ge([0,1,108]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends m.CharacterClassifier{constructor(C){super(0);for(let D=0,T=C.length;D<T;D++)this.set(C.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function k(R){let C={};return D=>(C.hasOwnProperty(D)||(C[D]=R(D)),C[D])}e.getMapForWordSeparators=k(R=>new I(R))}),define(me[51],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(I,k){this.lineNumber=I,this.column=k}with(I=this.lineNumber,k=this.column){return I===this.lineNumber&&k===this.column?this:new m(I,k)}delta(I=0,k=0){return this.with(this.lineNumber+I,this.column+k)}equals(I){return m.equals(this,I)}static equals(I,k){return!I&&!k?!0:!!I&&!!k&&I.lineNumber===k.lineNumber&&I.column===k.column}isBefore(I){return m.isBefore(this,I)}static isBefore(I,k){return I.lineNumber<k.lineNumber?!0:k.lineNumber<I.lineNumber?!1:I.column<k.column}isBeforeOrEqual(I){return m.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,k){return I.lineNumber<k.lineNumber?!0:k.lineNumber<I.lineNumber?!1:I.column<=k.column}static compare(I,k){let R=I.lineNumber|0,C=k.lineNumber|0;if(R===C){let D=I.column|0,T=k.column|0;return D-T}return R-C}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new m(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=m}),define(me[41],ge([0,1,51]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(k,R,C,D){k>C||k===C&&R>D?(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=k,this.endColumn=R):(this.startLineNumber=k,this.startColumn=R,this.endLineNumber=C,this.endColumn=D)}isEmpty(){return L.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return L.containsPosition(this,k)}static containsPosition(k,R){return!(R.lineNumber<k.startLineNumber||R.lineNumber>k.endLineNumber||R.lineNumber===k.startLineNumber&&R.column<k.startColumn||R.lineNumber===k.endLineNumber&&R.column>k.endColumn)}containsRange(k){return L.containsRange(this,k)}static containsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>k.endColumn)}strictContainsRange(k){return L.strictContainsRange(this,k)}static strictContainsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<=k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>=k.endColumn)}plusRange(k){return L.plusRange(this,k)}static plusRange(k,R){let C,D,T,n;return R.startLineNumber<k.startLineNumber?(C=R.startLineNumber,D=R.startColumn):R.startLineNumber===k.startLineNumber?(C=R.startLineNumber,D=Math.min(R.startColumn,k.startColumn)):(C=k.startLineNumber,D=k.startColumn),R.endLineNumber>k.endLineNumber?(T=R.endLineNumber,n=R.endColumn):R.endLineNumber===k.endLineNumber?(T=R.endLineNumber,n=Math.max(R.endColumn,k.endColumn)):(T=k.endLineNumber,n=k.endColumn),new L(C,D,T,n)}intersectRanges(k){return L.intersectRanges(this,k)}static intersectRanges(k,R){let C=k.startLineNumber,D=k.startColumn,T=k.endLineNumber,n=k.endColumn,A=R.startLineNumber,u=R.startColumn,f=R.endLineNumber,o=R.endColumn;return C<A?(C=A,D=u):C===A&&(D=Math.max(D,u)),T>f?(T=f,n=o):T===f&&(n=Math.min(n,o)),C>T||C===T&&D>n?null:new L(C,D,T,n)}equalsRange(k){return L.equalsRange(this,k)}static equalsRange(k,R){return!!k&&!!R&&k.startLineNumber===R.startLineNumber&&k.startColumn===R.startColumn&&k.endLineNumber===R.endLineNumber&&k.endColumn===R.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(k){return new m.Position(k.endLineNumber,k.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(k){return new m.Position(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,R){return new L(this.startLineNumber,this.startColumn,k,R)}setStartPosition(k,R){return new L(k,R,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(k){return new L(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}static fromPositions(k,R=k){return new L(k.lineNumber,k.column,R.lineNumber,R.column)}static lift(k){return k?new L(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<k.startColumn)}static areIntersecting(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<=R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,R){if(k&&R){const T=k.startLineNumber|0,n=R.startLineNumber|0;if(T===n){const A=k.startColumn|0,u=R.startColumn|0;if(A===u){const f=k.endLineNumber|0,o=R.endLineNumber|0;if(f===o){const v=k.endColumn|0,S=R.endColumn|0;return v-S}return f-o}return A-u}return T-n}return(k?1:0)-(R?1:0)}static compareRangesUsingEnds(k,R){return k.endLineNumber===R.endLineNumber?k.endColumn===R.endColumn?k.startLineNumber===R.startLineNumber?k.startColumn-R.startColumn:k.startLineNumber-R.startLineNumber:k.endColumn-R.endColumn:k.endLineNumber-R.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}}e.Range=L}),define(me[144],ge([0,1,51,41]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class k extends L.Range{constructor(C,D,T,n){super(C,D,T,n);this.selectionStartLineNumber=C,this.selectionStartColumn=D,this.positionLineNumber=T,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return k.selectionsEqual(this,C)}static selectionsEqual(C,D){return C.selectionStartLineNumber===D.selectionStartLineNumber&&C.selectionStartColumn===D.selectionStartColumn&&C.positionLineNumber===D.positionLineNumber&&C.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,D){return this.getDirection()===0?new k(this.startLineNumber,this.startColumn,C,D):new k(C,D,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,D){return this.getDirection()===0?new k(C,D,this.endLineNumber,this.endColumn):new k(this.endLineNumber,this.endColumn,C,D)}static fromPositions(C,D=C){return new k(C.lineNumber,C.column,D.lineNumber,D.column)}static liftSelection(C){return new k(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,D){if(C&&!D||!C&&D)return!1;if(!C&&!D)return!0;if(C.length!==D.length)return!1;for(let T=0,n=C.length;T<n;T++)if(!this.selectionsEqual(C[T],D[T]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,D,T,n,A){return A===0?new k(C,D,T,n):new k(T,n,C,D)}}e.Selection=k}),define(me[109],ge([0,1,25]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(S){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,S.tabSize|0),this.indentSize=S.tabSize|0,this.insertSpaces=Boolean(S.insertSpaces),this.defaultEOL=S.defaultEOL|0,this.trimAutoWhitespace=Boolean(S.trimAutoWhitespace),this.bracketPairColorizationOptions=S.bracketPairColorizationOptions}equals(S){return this.tabSize===S.tabSize&&this.indentSize===S.indentSize&&this.insertSpaces===S.insertSpaces&&this.defaultEOL===S.defaultEOL&&this.trimAutoWhitespace===S.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,S.bracketPairColorizationOptions)}createChangeEvent(S){return{tabSize:this.tabSize!==S.tabSize,indentSize:this.indentSize!==S.indentSize,insertSpaces:this.insertSpaces!==S.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==S.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class T{constructor(S,P){this._findMatchBrand=void 0,this.range=S,this.matches=P}}e.FindMatch=T;var n;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var A;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None"})(A=e.PositionAffinity||(e.PositionAffinity={}));var u;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u=e.ModelConstants||(e.ModelConstants={}));class f{constructor(S,P,E,a,l,p){this.identifier=S,this.range=P,this.text=E,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=l,this._isTracked=p}}e.ValidAnnotatedEditOperation=f;class o{constructor(S,P,E){this.reverseEdits=S,this.changes=P,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=o}),define(me[145],ge([0,1,9,143,51,41,109]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class D{constructor(a,l,p,t){this.searchString=a,this.isRegex=l,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=T(this.searchString):a=this.searchString.indexOf(`
`)>=0;let l=null;try{l=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let p=!this.isRegex&&!a;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new n(l,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=D;function T(E){if(!E||E.length===0)return!1;for(let a=0,l=E.length;a<l;a++)if(E.charCodeAt(a)===92){if(a++,a>=l)break;const t=E.charCodeAt(a);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=T;class n{constructor(a,l,p){this.regex=a,this.wordSeparators=l,this.simpleSearch=p}}e.SearchData=n;function A(E,a,l){if(!l)return new R.FindMatch(E,null);let p=[];for(let t=0,s=a.length;t<s;t++)p[t]=a[t];return new R.FindMatch(E,p)}e.createFindMatch=A;class u{constructor(a){let l=[],p=0;for(let t=0,s=a.length;t<s;t++)a.charCodeAt(t)===10&&(l[p++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(a){const l=this._lineFeedsOffsets;let p=0,t=l.length-1;if(t===-1||a<=l[0])return 0;for(;p<t;){const s=p+((t-p)/2>>0);l[s]>=a?t=s-1:l[s+1]>=a?(p=s,t=s):p=s+1}return p+1}}class f{static findMatches(a,l,p,t,s){const r=l.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(a,p,new P(r.wordSeparators,r.regex),t,s):this._doFindMatchesLineByLine(a,p,r,t,s):[]}static _getMultilineMatchRange(a,l,p,t,s,r){let i,h=0;t?(h=t.findLineFeedCountBeforeOffset(s),i=l+s+h):i=l+s;let c;if(t){let g=t.findLineFeedCountBeforeOffset(s+r.length)-h;c=i+r.length+g}else c=i+r.length;const d=a.getPositionAt(i),b=a.getPositionAt(c);return new k.Range(d.lineNumber,d.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(a,l,p,t,s){const r=a.getOffsetAt(l.getStartPosition()),i=a.getValueInRange(l,1),h=a.getEOL()===`\r
`?new u(i):null,c=[];let d=0,b;for(p.reset(0);b=p.next(i);)if(c[d++]=A(this._getMultilineMatchRange(a,r,i,h,b.index,b[0]),b,t),d>=s)return c;return c}static _doFindMatchesLineByLine(a,l,p,t,s){const r=[];let i=0;if(l.startLineNumber===l.endLineNumber){const c=a.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return i=this._findMatchesInLine(p,c,l.startLineNumber,l.startColumn-1,i,r,t,s),r}const h=a.getLineContent(l.startLineNumber).substring(l.startColumn-1);i=this._findMatchesInLine(p,h,l.startLineNumber,l.startColumn-1,i,r,t,s);for(let c=l.startLineNumber+1;c<l.endLineNumber&&i<s;c++)i=this._findMatchesInLine(p,a.getLineContent(c),c,0,i,r,t,s);if(i<s){const c=a.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);i=this._findMatchesInLine(p,c,l.endLineNumber,0,i,r,t,s)}return r}static _findMatchesInLine(a,l,p,t,s,r,i,h){const c=a.wordSeparators;if(!i&&a.simpleSearch){const y=a.simpleSearch,g=y.length,_=l.length;let w=-g;for(;(w=l.indexOf(y,w+g))!==-1;)if((!c||S(c,l,_,w,g))&&(r[s++]=new R.FindMatch(new k.Range(p,w+1+t,p,w+1+g+t),null),s>=h))return s;return s}const d=new P(a.wordSeparators,a.regex);let b;d.reset(0);do if(b=d.next(l),b&&(r[s++]=A(new k.Range(p,b.index+1+t,p,b.index+1+b[0].length+t),b,i),s>=h))return s;while(b);return s}static findNextMatch(a,l,p,t){const s=l.parseSearchRequest();if(!s)return null;const r=new P(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(a,p,r,t):this._doFindNextMatchLineByLine(a,p,r,t)}static _doFindNextMatchMultiline(a,l,p,t){const s=new I.Position(l.lineNumber,1),r=a.getOffsetAt(s),i=a.getLineCount(),h=a.getValueInRange(new k.Range(s.lineNumber,s.column,i,a.getLineMaxColumn(i)),1),c=a.getEOL()===`\r
`?new u(h):null;p.reset(l.column-1);let d=p.next(h);return d?A(this._getMultilineMatchRange(a,r,h,c,d.index,d[0]),d,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(a,new I.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(a,l,p,t){const s=a.getLineCount(),r=l.lineNumber,i=a.getLineContent(r),h=this._findFirstMatchInLine(p,i,r,l.column,t);if(h)return h;for(let c=1;c<=s;c++){const d=(r+c-1)%s,b=a.getLineContent(d+1),y=this._findFirstMatchInLine(p,b,d+1,1,t);if(y)return y}return null}static _findFirstMatchInLine(a,l,p,t,s){a.reset(t-1);const r=a.next(l);return r?A(new k.Range(p,r.index+1,p,r.index+1+r[0].length),r,s):null}static findPreviousMatch(a,l,p,t){const s=l.parseSearchRequest();if(!s)return null;const r=new P(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(a,p,r,t):this._doFindPreviousMatchLineByLine(a,p,r,t)}static _doFindPreviousMatchMultiline(a,l,p,t){const s=this._doFindMatchesMultiline(a,new k.Range(1,1,l.lineNumber,l.column),p,t,10*C);if(s.length>0)return s[s.length-1];const r=a.getLineCount();return l.lineNumber!==r||l.column!==a.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(a,new I.Position(r,a.getLineMaxColumn(r)),p,t):null}static _doFindPreviousMatchLineByLine(a,l,p,t){const s=a.getLineCount(),r=l.lineNumber,i=a.getLineContent(r).substring(0,l.column-1),h=this._findLastMatchInLine(p,i,r,t);if(h)return h;for(let c=1;c<=s;c++){const d=(s+r-c-1)%s,b=a.getLineContent(d+1),y=this._findLastMatchInLine(p,b,d+1,t);if(y)return y}return null}static _findLastMatchInLine(a,l,p,t){let s=null,r;for(a.reset(0);r=a.next(l);)s=A(new k.Range(p,r.index+1,p,r.index+1+r[0].length),r,t);return s}}e.TextModelSearch=f;function o(E,a,l,p,t){if(p===0)return!0;const s=a.charCodeAt(p-1);if(E.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=a.charCodeAt(p);if(E.get(r)!==0)return!0}return!1}function v(E,a,l,p,t){if(p+t===l)return!0;const s=a.charCodeAt(p+t);if(E.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=a.charCodeAt(p+t-1);if(E.get(r)!==0)return!0}return!1}function S(E,a,l,p,t){return o(E,a,l,p,t)&&v(E,a,l,p,t)}e.isValidMatch=S;class P{constructor(a,l){this._wordSeparators=a,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const l=a.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(p=this._searchRegex.exec(a),!p))return null;const t=p.index,s=p[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){m.getNextCodePoint(a,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||S(this._wordSeparators,a,l,t,s))return p}while(p);return null}}e.Searcher=P}),define(me[110],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(C=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)C.indexOf(T)>=0||(D+="\\"+T);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=m();function L(C){let D=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)D=C;else{let T="g";C.ignoreCase&&(T+="i"),C.multiline&&(T+="m"),C.unicode&&(T+="u"),D=new RegExp(C.source,T)}return D.lastIndex=0,D}e.ensureValidWordDefinition=L;const I={maxLen:1e3,windowSize:15,timeBudget:150};function k(C,D,T,n,A=I){if(T.length>A.maxLen){let S=C-A.maxLen/2;return S<0?S=0:n+=S,T=T.substring(S,C+A.maxLen/2),k(C,D,T,n,A)}const u=Date.now(),f=C-1-n;let o=-1,v=null;for(let S=1;!(Date.now()-u>=A.timeBudget);S++){const P=f-A.windowSize*S;D.lastIndex=Math.max(0,P);const E=R(D,T,f,o);if(!E&&v||(v=E,P<=0))break;o=P}if(v){let S={word:v[0],startColumn:n+1+v.index,endColumn:n+1+v.index+v[0].length};return D.lastIndex=0,S}return null}e.getWordAtText=k;function R(C,D,T,n){let A;for(;A=C.exec(D);){const u=A.index||0;if(u<=T&&C.lastIndex>=T)return A;if(n>0&&u>n)return null}return null}}),define(me[146],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class L{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let D=0,T=C.notIn.length;D<T;D++)switch(C.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=L;class I{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of C)k(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),k(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),k(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),k(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&k(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=I;function k(R,C,D){R.has(C)?R.get(C).push(D):R.set(C,[D])}}),define(me[81],ge([0,1,30,8]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(k,R,C,D){if(Array.isArray(k)){let T=0;for(const n of k){const A=I(n,R,C,D);if(A===10)return A;A>T&&(T=A)}return T}else{if(typeof k=="string")return D?k==="*"?5:k===C?10:0:0;if(k){const{language:T,pattern:n,scheme:A,hasAccessToAllModels:u}=k;if(!D&&!u)return 0;let f=0;if(A)if(A===R.scheme)f=10;else if(A==="*")f=5;else return 0;if(T)if(T===C)f=10;else if(T==="*")f=Math.max(f,5);else return 0;if(n){let o;if(typeof n=="string"?o=n:o={...n,base:(0,L.normalize)(n.base)},o===R.fsPath||(0,m.match)(o,R.fsPath))f=10;else return 0}return f}else return 0}}e.score=I}),define(me[147],ge([0,1,108]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class I{constructor(o,v,S){const P=new Uint8Array(o*v);for(let E=0,a=o*v;E<a;E++)P[E]=S;this._data=P,this.rows=o,this.cols=v}get(o,v){return this._data[o*this.cols+v]}set(o,v,S){this._data[o*this.cols+v]=S}}e.Uint8Matrix=I;class k{constructor(o){let v=0,S=0;for(let E=0,a=o.length;E<a;E++){let[l,p,t]=o[E];p>v&&(v=p),l>S&&(S=l),t>S&&(S=t)}v++,S++;let P=new I(S,v,0);for(let E=0,a=o.length;E<a;E++){let[l,p,t]=o[E];P.set(l,p,t)}this._states=P,this._maxCharCode=v}nextState(o,v){return v<0||v>=this._maxCharCode?0:this._states.get(o,v)}}e.StateMachine=k;let R=null;function C(){return R===null&&(R=new k([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var D;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let T=null;function n(){if(T===null){T=new m.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<f.length;v++)T.set(f.charCodeAt(v),1);const o=".,;";for(let v=0;v<o.length;v++)T.set(o.charCodeAt(v),2)}return T}class A{static _createLink(o,v,S,P,E){let a=E-1;do{const l=v.charCodeAt(a);if(o.get(l)!==2)break;a--}while(a>P);if(P>0){const l=v.charCodeAt(P-1),p=v.charCodeAt(a);(l===40&&p===41||l===91&&p===93||l===123&&p===125)&&a--}return{range:{startLineNumber:S,startColumn:P+1,endLineNumber:S,endColumn:a+2},url:v.substring(P,a+1)}}static computeLinks(o,v=C()){const S=n();let P=[];for(let E=1,a=o.getLineCount();E<=a;E++){const l=o.getLineContent(E),p=l.length;let t=0,s=0,r=0,i=1,h=!1,c=!1,d=!1,b=!1;for(;t<p;){let y=!1;const g=l.charCodeAt(t);if(i===13){let _;switch(g){case 40:h=!0,_=0;break;case 41:_=h?0:1;break;case 91:d=!0,c=!0,_=0;break;case 93:d=!1,_=c?0:1;break;case 123:b=!0,_=0;break;case 125:_=b?0:1;break;case 39:_=r===34||r===96?0:1;break;case 34:_=r===39||r===96?0:1;break;case 96:_=r===39||r===34?0:1;break;case 42:_=r===42?1:0;break;case 124:_=r===124?1:0;break;case 32:_=d?0:1;break;default:_=S.get(g)}_===1&&(P.push(A._createLink(S,l,E,s,t)),y=!0)}else if(i===12){let _;g===91?(c=!0,_=0):_=S.get(g),_===1?y=!0:i=13}else i=v.nextState(i,g),i===0&&(y=!0);y&&(i=1,h=!1,c=!1,b=!1,s=t+1,r=g),t++}i===13&&P.push(A._createLink(S,l,E,s,p))}return P}}e.LinkComputer=A;function u(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:A.computeLinks(f)}e.computeLinks=u}),define(me[148],ge([0,1,3,6]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class I{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,C){return this._map.set(R,C),this.fire([R]),(0,L.toDisposable)(()=>{this._map.get(R)===C&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,C){let D=null,T=!1;return this._promises.set(R,C.then(n=>{this._promises.delete(R),!(T||!n)&&(D=this.register(R,n))})),(0,L.toDisposable)(()=>{T=!0,D&&D.dispose()})}getPromise(R){const C=this.get(R);if(C)return Promise.resolve(C);const D=this._promises.get(R);return D?D.then(T=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=I}),define(me[111],ge([0,1,23,11]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(A){A[A.Full=1]="Full",A[A.Delta=2]="Delta"})(I||(I={}));function k(A){for(let u=0,f=A.length;u<f;u+=4){const o=A[u+0],v=A[u+1],S=A[u+2],P=A[u+3];A[u+0]=P,A[u+1]=S,A[u+2]=v,A[u+3]=o}}function R(A){const u=new Uint8Array(A.buffer,A.byteOffset,A.length*4);return L.isLittleEndian()||k(u),m.VSBuffer.wrap(u)}function C(A){const u=A.buffer;if(L.isLittleEndian()||k(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const f=new Uint8Array(u.byteLength);return f.set(u),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function D(A){const u=new Uint32Array(T(A));let f=0;if(u[f++]=A.id,A.type==="full")u[f++]=1,u[f++]=A.data.length,u.set(A.data,f),f+=A.data.length;else{u[f++]=2,u[f++]=A.deltas.length;for(const o of A.deltas)u[f++]=o.start,u[f++]=o.deleteCount,o.data?(u[f++]=o.data.length,u.set(o.data,f),f+=o.data.length):u[f++]=0}return R(u)}e.encodeSemanticTokensDto=D;function T(A){let u=0;if(u+=1+1,A.type==="full")u+=1+A.data.length;else{u+=1,u+=(1+1+1)*A.deltas.length;for(const f of A.deltas)f.data&&(u+=f.data.length)}return u}function n(A){const u=C(A);let f=0;const o=u[f++];if(u[f++]===1){const E=u[f++],a=u.subarray(f,f+E);return f+=E,{id:o,type:"full",data:a}}const S=u[f++];let P=[];for(let E=0;E<S;E++){const a=u[f++],l=u[f++],p=u[f++];let t;p>0&&(t=u.subarray(f,f+p),f+=p),P[E]={start:a,deleteCount:l,data:t}}return{id:o,type:"delta",deltas:P}}e.decodeSemanticTokensDto=n}),define(me[112],ge([0,1,97]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(R,C){this._prefixSumIndexOfResultBrand=void 0,this.index=R,this.remainder=C}}e.PrefixSumIndexOfResult=L;class I{constructor(R){this.values=R,this.prefixSum=new Uint32Array(R.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(R,C){R=(0,m.toUint32)(R);const D=this.values,T=this.prefixSum,n=C.length;return n===0?!1:(this.values=new Uint32Array(D.length+n),this.values.set(D.subarray(0,R),0),this.values.set(D.subarray(R),R+n),this.values.set(C,R),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(R,C){return R=(0,m.toUint32)(R),C=(0,m.toUint32)(C),this.values[R]===C?!1:(this.values[R]=C,R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),!0)}removeValues(R,C){R=(0,m.toUint32)(R),C=(0,m.toUint32)(C);const D=this.values,T=this.prefixSum;if(R>=D.length)return!1;let n=D.length-R;return C>=n&&(C=n),C===0?!1:(this.values=new Uint32Array(D.length-C),this.values.set(D.subarray(0,R),0),this.values.set(D.subarray(R+C),R),this.prefixSum=new Uint32Array(this.values.length),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(R){return R<0?0:(R=(0,m.toUint32)(R),this._getPrefixSum(R))}_getPrefixSum(R){if(R<=this.prefixSumValidIndex[0])return this.prefixSum[R];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),R>=this.values.length&&(R=this.values.length-1);for(let D=C;D<=R;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],R),this.prefixSum[R]}getIndexOf(R){R=Math.floor(R),this.getTotalSum();let C=0,D=this.values.length-1,T=0,n=0,A=0;for(;C<=D;)if(T=C+(D-C)/2|0,n=this.prefixSum[T],A=n-this.values[T],R<A)D=T-1;else if(R>=n)C=T+1;else break;return new L(T,R-A)}}e.PrefixSumComputer=I}),define(me[149],ge([0,1,9,51,112]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class k{constructor(C,D,T,n){this._uri=C,this._lines=D,this._eol=T,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const D=C.changes;for(const T of D)this._acceptDeleteRange(T.range),this._acceptInsertText(new L.Position(T.range.startLineNumber,T.range.startColumn),T.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,D=this._lines.length,T=new Uint32Array(D);for(let n=0;n<D;n++)T[n]=this._lines[n].length+C;this._lineStarts=new I.PrefixSumComputer(T)}}_setLineText(C,D){this._lines[C]=D,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,D){if(D.length===0)return;let T=(0,m.splitLines)(D);if(T.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+T[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}T[T.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+T[0]);let n=new Uint32Array(T.length-1);for(let A=1;A<T.length;A++)this._lines.splice(C.lineNumber+A-1,0,T[A]),n[A-1]=T[A].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,n)}}e.MirrorTextModel=k}),define(me[150],ge([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(me[151],ge([0,1,150]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,I=L*60,k=I*24,R=k*7,C=k*30,D=k*365;function T(A,u){typeof A!="number"&&(A=A.getTime());const f=Math.round((new Date().getTime()-A)/1e3);if(f<-30)return(0,m.localize)(0,null,T(new Date().getTime()+f*1e3,!1));if(f<30)return(0,m.localize)(1,null);let o;return f<L?(o=f,u?o===1?(0,m.localize)(2,null,o):(0,m.localize)(3,null,o):o===1?(0,m.localize)(4,null,o):(0,m.localize)(5,null,o)):f<I?(o=Math.floor(f/L),u?o===1?(0,m.localize)(6,null,o):(0,m.localize)(7,null,o):o===1?(0,m.localize)(8,null,o):(0,m.localize)(9,null,o)):f<k?(o=Math.floor(f/I),u?o===1?(0,m.localize)(10,null,o):(0,m.localize)(11,null,o):o===1?(0,m.localize)(12,null,o):(0,m.localize)(13,null,o)):f<R?(o=Math.floor(f/k),u?o===1?(0,m.localize)(14,null,o):(0,m.localize)(15,null,o):o===1?(0,m.localize)(16,null,o):(0,m.localize)(17,null,o)):f<C?(o=Math.floor(f/R),u?o===1?(0,m.localize)(18,null,o):(0,m.localize)(19,null,o):o===1?(0,m.localize)(20,null,o):(0,m.localize)(21,null,o)):f<D?(o=Math.floor(f/C),u?o===1?(0,m.localize)(22,null,o):(0,m.localize)(23,null,o):o===1?(0,m.localize)(24,null,o):(0,m.localize)(25,null,o)):(o=Math.floor(f/D),u?o===1?(0,m.localize)(26,null,o):(0,m.localize)(27,null,o):o===1?(0,m.localize)(28,null,o):(0,m.localize)(29,null,o))}e.fromNow=T;function n(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(me[152],ge([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(me[61],ge([0,1,17,13,152]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(T,n){return n&&(T.stack||T.stacktrace)?I.localize(0,null,C(T),R(T.stack)||R(T.stacktrace)):C(T)}function R(T){return Array.isArray(T)?T.join(`
`):T}function C(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?I.localize(1,null,T.message):T.message||I.localize(2,null)}function D(T=null,n=!1){if(!T)return I.localize(3,null);if(Array.isArray(T)){const A=m.coalesce(T),u=D(A[0],n);return A.length>1?I.localize(4,null,u,A.length):u}if(L.isString(T))return T;if(T.detail){const A=T.detail;if(A.error)return k(A.error,n);if(A.exception)return k(A.exception,n)}return T.stack?k(T,n):T.message?T.message:I.localize(5,null)}e.toErrorMessage=D}),define(me[153],ge([19,20]),function(J,e){return J.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,39,29,10,25,8,11,34,13,142,28,153]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function o(l,p){if(C.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};p&&(t.cwd=p);const s=m.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],t);return new Promise(r=>{s.once("error",i=>{r({success:!1,error:i})}),s.once("exit",(i,h)=>{r(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(C.isLinux||C.isMacintosh)try{const t=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(s=>{m.execFile(t,[l.pid.toString()],{encoding:"utf8",shell:!0},(r,i,h)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function v(l=D.env){return l.comspec||"cmd.exe"}e.getWindowsShell=v;class S{constructor(p,t,s,r){if(t!==void 0&&s!==void 0&&r!==void 0)this.cmd=p,this.args=t,this.shell=s,this.options=r;else{const i=p;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(D.env).forEach(h=>{i[h]=D.env[h]}),Object.keys(this.options.env).forEach(h=>{i[h]=this.options.env[h]}),this.options.env=i}}getSanitizedCommand(){let p=this.cmd.toLowerCase();const t=p.lastIndexOf(R.sep);return t!==-1&&(p=p.substring(t+1)),S.WellKnowCommands[p]?p:"other"}start(p){return C.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(D.cwd()))?Promise.reject(new Error(u.localize(0,null))):this.useExec().then(t=>{let s,r;const i=new Promise((h,c)=>{s=h,r=c});if(t){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=m.exec(h,this.options,(c,d,b)=>{this.childProcess=null;const y=c;y&&y.killed?r({killed:this.terminateRequested,stdout:d.toString(),stderr:b.toString()}):this.handleExec(s,p,c,d,b)})}else{let h=null;const c=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,s,p,r);const b={terminated:this.terminateRequested};T.isNumber(d)&&(b.cmdCode=d),s(b)};if(this.shell&&C.isWindows){const d=k.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let b=!1,y=!1;const g=[];let _=this.ensureQuotes(this.cmd);g.push(_.value),b=_.quoted,this.args&&this.args.forEach(F=>{_=this.ensureQuotes(F),g.push(_.value),y=y&&_.quoted});const w=["/s","/c"];b?y?w.push('"'+g.join(" ")+'"'):g.length>1?w.push('"'+g[0]+'" '+g.slice(1).join(" ")):w.push('"'+g[0]+'"'):w.push(g.join(" ")),h=m.spawn(v(),w,d)}else this.cmd&&(h=m.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(T.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",d=>{this.childProcess=null,r({terminated:this.terminateRequested,error:d})}),h.pid&&(this.childProcess.on("close",c),this.handleSpawn(h,s,p,r,!0)))}return i})}handleClose(p,t,s,r){}ensureQuotes(p){return S.regexp.test(p)?{value:'"'+p+'"',quoted:!0}:{value:p,quoted:p.length>0&&p[0]==='"'&&p[p.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(p=>p.pid,p=>-1):new Promise(p=>{this.pidResolve=p})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(p=>(this.terminateRequested=!0,o(p,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),p=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(p=>{if(!this.shell||!C.isWindows)return p(!1);const t=m.spawn(v(),["/s","/c"]);t.on("error",s=>p(!0)),t.on("exit",s=>p(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class P extends S{constructor(p,t,s,r){super(p,t,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(p,t,s,r,i){[r,i].forEach((h,c)=>{const d=new n.LineDecoder;d.write(h).forEach(g=>{t({line:g,source:c===0?0:1})});const y=d.end();y&&t({line:y,source:c===0?0:1})}),p({terminated:this.terminateRequested,error:s})}handleSpawn(p,t,s,r,i){const h=new n.LineDecoder,c=new n.LineDecoder;p.stdout.on("data",d=>{h.write(d).forEach(y=>s({line:y,source:0}))}),p.stderr.on("data",d=>{c.write(d).forEach(y=>s({line:y,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=c}handleClose(p,t,s,r){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&s({line:i,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&s({line:h,source:1})}}e.LineProcess=P;function E(l){let p=[],t=!1;const s=function(r){if(t){p.push(r);return}(!l.send(r,h=>{if(h&&console.error(h),t=!1,p.length>0){const c=p.slice(0);p=[],c.forEach(d=>s(d))}})||C.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=E;var a;(function(l){async function p(t,s,r){if(R.isAbsolute(t))return t;if(s===void 0&&(s=D.cwd()),R.dirname(t)!=="."||(r===void 0&&T.isString(D.env.PATH)&&(r=D.env.PATH.split(R.delimiter)),r===void 0||r.length===0))return R.join(s,t);async function h(c){if(await A.Promises.exists(c)){let d;try{d=await A.Promises.stat(c)}catch(b){b.message.startsWith("EACCES")&&(d=await A.Promises.lstat(c))}return d?!d.isDirectory():!1}return!1}for(let c of r){let d;if(R.isAbsolute(c)?d=R.join(c,t):d=R.join(s,c,t),await h(d))return d;let b=d+".com";if(await h(b)||(b=d+".exe",await h(b)))return b}return R.join(s,t)}l.findExecutable=p})(a=e.win32||(e.win32={}))}),define(me[154],ge([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(me[114],ge([0,1,154,11,110]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(k=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=R;class C{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,pe){this._values[te]=pe}}e.ValidatedEditorOptions=C;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class T{constructor(te,pe,xe,Je){this.id=te,this.name=pe,this.defaultValue=xe,this.schema=Je}compute(te,pe,xe){return xe}}class n{constructor(te,pe=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(te){return this.defaultValue}}class A{constructor(te,pe,xe,Je){this.id=te,this.name=pe,this.defaultValue=xe,this.schema=Je}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,pe,xe){return xe}}function u(Z,te){return typeof Z=="undefined"?te:Z==="false"?!1:Boolean(Z)}e.boolean=u;class f extends A{constructor(te,pe,xe,Je=void 0){typeof Je!="undefined"&&(Je.type="boolean",Je.default=xe),super(te,pe,xe,Je)}validate(te){return u(te,this.defaultValue)}}class o extends A{constructor(te,pe,xe,Je,rt,ft=void 0){typeof ft!="undefined"&&(ft.type="integer",ft.default=xe,ft.minimum=Je,ft.maximum=rt),super(te,pe,xe,ft),this.minimum=Je,this.maximum=rt}static clampedInt(te,pe,xe,Je){if(typeof te=="undefined")return pe;let rt=parseInt(te,10);return isNaN(rt)?pe:(rt=Math.max(xe,rt),rt=Math.min(Je,rt),rt|0)}validate(te){return o.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class v extends A{constructor(te,pe,xe,Je,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=xe),super(te,pe,xe,rt),this.validationFn=Je}static clamp(te,pe,xe){return te<pe?pe:te>xe?xe:te}static float(te,pe){if(typeof te=="number")return te;if(typeof te=="undefined")return pe;const xe=parseFloat(te);return isNaN(xe)?pe:xe}validate(te){return this.validationFn(v.float(te,this.defaultValue))}}class S extends A{static string(te,pe){return typeof te!="string"?pe:te}constructor(te,pe,xe,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.default=xe),super(te,pe,xe,Je)}validate(te){return S.string(te,this.defaultValue)}}function P(Z,te,pe){return typeof Z!="string"||pe.indexOf(Z)===-1?te:Z}e.stringSet=P;class E extends A{constructor(te,pe,xe,Je,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Je,rt.default=xe),super(te,pe,xe,rt),this._allowedValues=Je}validate(te){return P(te,this.defaultValue,this._allowedValues)}}class a extends T{constructor(te,pe,xe,Je,rt,ft,pt=void 0){typeof pt!="undefined"&&(pt.type="string",pt.enum=rt,pt.default=Je),super(te,pe,xe,pt),this._allowedValues=rt,this._convert=ft}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function l(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,pe,xe){return xe===0?te.accessibilitySupport:xe}}class t extends T{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:m.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertSpace:u(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function h(Z){switch(Z){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function c(Z){switch(Z){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class d extends n{constructor(){super(127,[65,32])}compute(te,pe,xe){const Je=["monaco-editor"];return pe.get(32)&&Je.push(pe.get(32)),te.extraEditorClassName&&Je.push(te.extraEditorClassName),pe.get(65)==="default"?Je.push("mouse-default"):pe.get(65)==="copy"&&Je.push("mouse-copy"),pe.get(100)&&Je.push("showUnused"),pe.get(125)&&Je.push("showDeprecated"),Je.join(" ")}}class b extends f{constructor(){super(31,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(te,pe,xe){return xe&&te.emptySelectionClipboard}}class y extends T{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:m.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:m.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{cursorMoveOnType:u(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":P(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":P(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(pe.loop,this.defaultValue.loop)}}}class g extends T{constructor(){super(43,"fontLigatures",g.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?g.OFF:te==="true"?g.ON:te:Boolean(te)?g.ON:g.OFF}}e.EditorFontLigatures=g,g.OFF='"liga" off, "calt" off',g.ON='"liga" on, "calt" on';class _ extends n{constructor(){super(42)}compute(te,pe,xe){return te.fontInfo}}class w extends A{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(te){let pe=v.float(te,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(pe,6,100)}compute(te,pe,xe){return te.fontInfo.fontSize}}class F extends T{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.MINIMUM_VALUE,maximum:F.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(o.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,F.MINIMUM_VALUE,F.MAXIMUM_VALUE))}}F.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],F.MINIMUM_VALUE=1,F.MAXIMUM_VALUE=1e3;class O extends T{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:xe,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:xe,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:xe,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:xe,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:xe,description:m.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{multiple:P(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??P(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??P(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??P(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??P(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??P(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends T{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:m.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),delay:o.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:u(pe.sticky,this.defaultValue.sticky)}}}var K;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class U extends n{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(te,pe,xe){return U.computeLayout(pe,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const pe=te.height/te.lineHeight,xe=te.scrollBeyondLastLine?pe-1:0,Je=(te.viewLineCount+xe)/(te.pixelRatio*te.height),rt=Math.floor(te.viewLineCount/Je);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:xe,desiredRatio:Je,minimapLineCount:rt}}static _computeMinimapLayout(te,pe){const xe=te.outerWidth,Je=te.outerHeight,rt=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Je};const ft=pe.stableMinimapLayoutInput,pt=ft&&te.outerHeight===ft.outerHeight&&te.lineHeight===ft.lineHeight&&te.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&te.pixelRatio===ft.pixelRatio&&te.scrollBeyondLastLine===ft.scrollBeyondLastLine&&te.minimap.enabled===ft.minimap.enabled&&te.minimap.side===ft.minimap.side&&te.minimap.size===ft.minimap.size&&te.minimap.showSlider===ft.minimap.showSlider&&te.minimap.renderCharacters===ft.minimap.renderCharacters&&te.minimap.maxColumn===ft.minimap.maxColumn&&te.minimap.scale===ft.minimap.scale&&te.verticalScrollbarWidth===ft.verticalScrollbarWidth&&te.isViewportWrapping===ft.isViewportWrapping,St=te.lineHeight,Ct=te.typicalHalfwidthCharacterWidth,ue=te.scrollBeyondLastLine,Ie=te.minimap.renderCharacters;let Ue=rt>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const Qe=te.minimap.maxColumn,ze=te.minimap.size,at=te.minimap.side,Le=te.verticalScrollbarWidth,De=te.viewLineCount,ke=te.remainingWidth,ne=te.isViewportWrapping,de=Ie?2:3;let be=Math.floor(rt*Je);const we=be/rt;let Fe=!1,Ge=!1,He=de*Ue,Ye=Ue/rt,it=1;if(ze==="fill"||ze==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeyondLastLine:Xe,desiredRatio:ot,minimapLineCount:vt}=U.computeContainedMinimapLineCount({viewLineCount:De,scrollBeyondLastLine:ue,height:Je,lineHeight:St,pixelRatio:rt});if(De/vt>1)Fe=!0,Ge=!0,Ue=1,He=1,Ye=Ue/rt;else{let lt=!1,dt=Ue+1;if(ze==="fit"){const mt=Math.ceil((De+Xe)*He);ne&&pt&&ke<=pe.stableFitRemainingWidth?(lt=!0,dt=pe.stableFitMaxMinimapScale):lt=mt>be}if(ze==="fill"||lt){Fe=!0;const mt=Ue;He=Math.min(St*rt,Math.max(1,Math.floor(1/ot))),ne&&pt&&ke<=pe.stableFitRemainingWidth&&(dt=pe.stableFitMaxMinimapScale),Ue=Math.min(dt,Math.max(1,Math.floor(He/de))),Ue>mt&&(it=Math.min(2,Ue/mt)),Ye=Ue/rt/it,be=Math.ceil(Math.max(Ze,De+Xe)*He),ne?(pe.stableMinimapLayoutInput=te,pe.stableFitRemainingWidth=ke,pe.stableFitMaxMinimapScale=Ue):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const le=Math.floor(Qe*Ye),Ee=Math.min(le,Math.max(0,Math.floor((ke-Le-2)*Ye/(Ct+Ye)))+e.MINIMAP_GUTTER_WIDTH);let ce=Math.floor(rt*Ee);const q=ce/rt;ce=Math.floor(ce*it);const Ae=Ie?1:2,Pe=at==="left"?0:xe-Ee-Le;return{renderMinimap:Ae,minimapLeft:Pe,minimapWidth:Ee,minimapHeightIsEditorHeight:Fe,minimapIsSampling:Ge,minimapScale:Ue,minimapLineHeight:He,minimapCanvasInnerWidth:ce,minimapCanvasInnerHeight:be,minimapCanvasOuterWidth:q,minimapCanvasOuterHeight:we}}static computeLayout(te,pe){const xe=pe.outerWidth|0,Je=pe.outerHeight|0,rt=pe.lineHeight|0,ft=pe.lineNumbersDigitCount|0,pt=pe.typicalHalfwidthCharacterWidth,St=pe.maxDigitWidth,Ct=pe.pixelRatio,ue=pe.viewLineCount,Ie=te.get(122),Ue=Ie==="inherit"?te.get(121):Ie,Qe=Ue==="inherit"?te.get(117):Ue,ze=te.get(120),at=te.get(2),Le=pe.isDominatedByLongLines,De=te.get(48),ke=te.get(59).renderType!==0,ne=te.get(60),de=te.get(94),be=te.get(64),we=te.get(92),Fe=we.verticalScrollbarSize,Ge=we.verticalHasArrows,He=we.arrowSize,Ye=we.horizontalScrollbarSize,it=te.get(57),le=te.get(36);let Ee;if(typeof it=="string"&&/^\d+(\.\d+)?ch$/.test(it)){const Ot=parseFloat(it.substr(0,it.length-2));Ee=o.clampedInt(Ot*pt,0,0,1e3)}else Ee=o.clampedInt(it,0,0,1e3);le&&(Ee+=16);let ce=0;if(ke){const Ot=Math.max(ft,ne);ce=Math.round(Ot*St)}let q=0;De&&(q=rt);let Ae=0,Pe=Ae+q,Ze=Pe+ce,Xe=Ze+Ee;const ot=xe-q-ce-Ee;let vt=!1,Et=!1,lt=-1;at!==2&&(Ue==="inherit"&&Le?(vt=!0,Et=!0):Qe==="on"||Qe==="bounded"?Et=!0:Qe==="wordWrapColumn"&&(lt=ze));const dt=U._computeMinimapLayout({outerWidth:xe,outerHeight:Je,lineHeight:rt,typicalHalfwidthCharacterWidth:pt,pixelRatio:Ct,scrollBeyondLastLine:de,minimap:be,verticalScrollbarWidth:Fe,viewLineCount:ue,remainingWidth:ot,isViewportWrapping:Et},pe.memory||new D);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Ae+=dt.minimapWidth,Pe+=dt.minimapWidth,Ze+=dt.minimapWidth,Xe+=dt.minimapWidth);const mt=ot-dt.minimapWidth,Rt=Math.max(1,Math.floor((mt-Fe-2)/pt)),yt=Ge?He:0;return Et&&(lt=Math.max(1,Rt),Qe==="bounded"&&(lt=Math.min(lt,ze))),{width:xe,height:Je,glyphMarginLeft:Ae,glyphMarginWidth:q,lineNumbersLeft:Pe,lineNumbersWidth:ce,decorationsLeft:Ze,decorationsWidth:Ee,contentLeft:Xe,contentWidth:mt,minimap:dt,viewportColumn:Rt,isWordWrapMinified:vt,isViewportWrapping:Et,wrappingColumn:lt,verticalScrollbarWidth:Fe,horizontalScrollbarHeight:Ye,overviewRuler:{top:yt,width:Fe,height:Je-2*yt,right:0}}}}e.EditorLayoutInfoComputer=U;class W extends T{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:m.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:u(te.enabled,this.defaultValue.enabled)}}}class M extends T{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:m.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,markdownDescription:m.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),fontSize:o.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class x extends v{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>v.clamp(te,0,150),{markdownDescription:m.localize(46,null)})}compute(te,pe,xe){return te.fontInfo.lineHeight}}class B extends T{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:m.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(48,null),m.localize(49,null),m.localize(50,null)],default:te.size,description:m.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:m.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:m.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:m.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:m.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),size:P(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:P(pe.side,this.defaultValue.side,["right","left"]),showSlider:P(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(pe.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(pe.scale,1,1,3),maxColumn:o.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function N(Z){return Z==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class z extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{top:o.clampedInt(pe.top,0,0,1e3),bottom:o.clampedInt(pe.bottom,0,0,1e3)}}}class H extends T{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:m.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),cycle:u(pe.cycle,this.defaultValue.cycle)}}}class Q extends n{constructor(){super(128)}compute(te,pe,xe){return te.pixelRatio}}class X extends T{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:m.localize(61,null)},comments:{type:"boolean",default:te.comments,description:m.localize(62,null)},other:{type:"boolean",default:te.other,description:m.localize(63,null)}}}],default:te,description:m.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const pe=te,xe={other:u(pe.other,this.defaultValue.other),comments:u(pe.comments,this.defaultValue.comments),strings:u(pe.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var fe;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class _e extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(65,null),m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:"on",description:m.localize(69,null)})}validate(te){let pe=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(pe=4,xe=te):te==="interval"?pe=3:te==="relative"?pe=2:te==="on"?pe=1:pe=0),{renderType:pe,renderFn:xe}}}function ye(Z){const te=Z.get(87);return te==="editable"?Z.get(80):te!=="on"}e.filterValidationDecorations=ye;class Re extends T{constructor(){const te=[],pe={type:"number",description:m.localize(70,null)};super(91,"rulers",te,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(71,null),format:"color-hex"}}}]},default:te,description:m.localize(72,null)})}validate(te){if(Array.isArray(te)){let pe=[];for(let xe of te)if(typeof xe=="number")pe.push({column:o.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const Je=xe;pe.push({column:o.clampedInt(Je.column,0,0,1e4),color:Je.color})}return pe.sort((xe,Je)=>xe.column-Je.column),pe}return this.defaultValue}}function $e(Z,te){if(typeof Z!="string")return te;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Be extends T{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(73,null),m.localize(74,null),m.localize(75,null)],default:"auto",description:m.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(77,null),m.localize(78,null),m.localize(79,null)],default:"auto",description:m.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:m.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:m.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te,xe=o.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Je=o.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$e(pe.vertical,this.defaultValue.vertical),horizontal:$e(pe.horizontal,this.defaultValue.horizontal),useShadows:u(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:o.clampedInt(pe.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:Je,verticalSliderSize:o.clampedInt(pe.verticalSliderSize,Je,0,1e3),scrollByPage:u(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends T{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:m.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(85,null),m.localize(86,null),m.localize(87,null)],default:te.mode,description:m.localize(88,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),mode:P(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class V extends T{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:m.localize(89,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:u(te.enabled,this.defaultValue.enabled)}}}class ee extends T{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(90,null),m.localize(91,null)],default:te.insertMode,description:m.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:m.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:m.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:m.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:m.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:m.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:m.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:m.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(100,null),m.localize(101,null),m.localize(102,null)],default:te.previewMode,description:m.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:m.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertMode:P(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(pe.showIcons,this.defaultValue.showIcons),showStatusBar:u(pe.showStatusBar,this.defaultValue.showStatusBar),preview:u(pe.preview,this.defaultValue.preview),previewMode:P(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(pe.showMethods,this.defaultValue.showMethods),showFunctions:u(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:u(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:u(pe.showFields,this.defaultValue.showFields),showVariables:u(pe.showVariables,this.defaultValue.showVariables),showClasses:u(pe.showClasses,this.defaultValue.showClasses),showStructs:u(pe.showStructs,this.defaultValue.showStructs),showInterfaces:u(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:u(pe.showModules,this.defaultValue.showModules),showProperties:u(pe.showProperties,this.defaultValue.showProperties),showEvents:u(pe.showEvents,this.defaultValue.showEvents),showOperators:u(pe.showOperators,this.defaultValue.showOperators),showUnits:u(pe.showUnits,this.defaultValue.showUnits),showValues:u(pe.showValues,this.defaultValue.showValues),showConstants:u(pe.showConstants,this.defaultValue.showConstants),showEnums:u(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:u(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(pe.showKeywords,this.defaultValue.showKeywords),showWords:u(pe.showWords,this.defaultValue.showWords),showColors:u(pe.showColors,this.defaultValue.showColors),showFiles:u(pe.showFiles,this.defaultValue.showFiles),showReferences:u(pe.showReferences,this.defaultValue.showReferences),showFolders:u(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:u(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(pe.showSnippets,this.defaultValue.showSnippets),showUsers:u(pe.showUsers,this.defaultValue.showUsers),showIssues:u(pe.showIssues,this.defaultValue.showIssues)}}}class re extends T{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(136,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends n{constructor(){super(129,[80])}compute(te,pe,xe){return pe.get(80)?!0:te.tabFocusMode}}var Y;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Y=e.WrappingIndent||(e.WrappingIndent={}));function oe(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ve extends n{constructor(){super(131,[130])}compute(te,pe,xe){const Je=pe.get(130);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:Je.isWordWrapMinified,isViewportWrapping:Je.isViewportWrapping,wrappingColumn:Je.wrappingColumn}}}const Me="Consolas, 'Courier New', monospace",qe="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?qe:L.isLinux?Ke:Me,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Se(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var tt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.autoClosingBrackets=5]="autoClosingBrackets",Z[Z.autoClosingDelete=6]="autoClosingDelete",Z[Z.autoClosingOvertype=7]="autoClosingOvertype",Z[Z.autoClosingQuotes=8]="autoClosingQuotes",Z[Z.autoIndent=9]="autoIndent",Z[Z.automaticLayout=10]="automaticLayout",Z[Z.autoSurround=11]="autoSurround",Z[Z.bracketPairColorization=12]="bracketPairColorization",Z[Z.codeLens=13]="codeLens",Z[Z.codeLensFontFamily=14]="codeLensFontFamily",Z[Z.codeLensFontSize=15]="codeLensFontSize",Z[Z.colorDecorators=16]="colorDecorators",Z[Z.columnSelection=17]="columnSelection",Z[Z.comments=18]="comments",Z[Z.contextmenu=19]="contextmenu",Z[Z.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=21]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=23]="cursorStyle",Z[Z.cursorSurroundingLines=24]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=26]="cursorWidth",Z[Z.disableLayerHinting=27]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",Z[Z.domReadOnly=29]="domReadOnly",Z[Z.dragAndDrop=30]="dragAndDrop",Z[Z.emptySelectionClipboard=31]="emptySelectionClipboard",Z[Z.extraEditorClassName=32]="extraEditorClassName",Z[Z.fastScrollSensitivity=33]="fastScrollSensitivity",Z[Z.find=34]="find",Z[Z.fixedOverflowWidgets=35]="fixedOverflowWidgets",Z[Z.folding=36]="folding",Z[Z.foldingStrategy=37]="foldingStrategy",Z[Z.foldingHighlight=38]="foldingHighlight",Z[Z.foldingImportsByDefault=39]="foldingImportsByDefault",Z[Z.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=41]="fontFamily",Z[Z.fontInfo=42]="fontInfo",Z[Z.fontLigatures=43]="fontLigatures",Z[Z.fontSize=44]="fontSize",Z[Z.fontWeight=45]="fontWeight",Z[Z.formatOnPaste=46]="formatOnPaste",Z[Z.formatOnType=47]="formatOnType",Z[Z.glyphMargin=48]="glyphMargin",Z[Z.gotoLocation=49]="gotoLocation",Z[Z.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",Z[Z.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",Z[Z.hover=52]="hover",Z[Z.inDiffEditor=53]="inDiffEditor",Z[Z.inlineSuggest=54]="inlineSuggest",Z[Z.letterSpacing=55]="letterSpacing",Z[Z.lightbulb=56]="lightbulb",Z[Z.lineDecorationsWidth=57]="lineDecorationsWidth",Z[Z.lineHeight=58]="lineHeight",Z[Z.lineNumbers=59]="lineNumbers",Z[Z.lineNumbersMinChars=60]="lineNumbersMinChars",Z[Z.linkedEditing=61]="linkedEditing",Z[Z.links=62]="links",Z[Z.matchBrackets=63]="matchBrackets",Z[Z.minimap=64]="minimap",Z[Z.mouseStyle=65]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=67]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=69]="multiCursorModifier",Z[Z.multiCursorPaste=70]="multiCursorPaste",Z[Z.occurrencesHighlight=71]="occurrencesHighlight",Z[Z.overviewRulerBorder=72]="overviewRulerBorder",Z[Z.overviewRulerLanes=73]="overviewRulerLanes",Z[Z.padding=74]="padding",Z[Z.parameterHints=75]="parameterHints",Z[Z.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=78]="quickSuggestions",Z[Z.quickSuggestionsDelay=79]="quickSuggestionsDelay",Z[Z.readOnly=80]="readOnly",Z[Z.renameOnType=81]="renameOnType",Z[Z.renderControlCharacters=82]="renderControlCharacters",Z[Z.renderIndentGuides=83]="renderIndentGuides",Z[Z.renderFinalNewline=84]="renderFinalNewline",Z[Z.renderLineHighlight=85]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=87]="renderValidationDecorations",Z[Z.renderWhitespace=88]="renderWhitespace",Z[Z.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",Z[Z.roundedSelection=90]="roundedSelection",Z[Z.rulers=91]="rulers",Z[Z.scrollbar=92]="scrollbar",Z[Z.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=94]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=95]="scrollPredominantAxis",Z[Z.selectionClipboard=96]="selectionClipboard",Z[Z.selectionHighlight=97]="selectionHighlight",Z[Z.selectOnLineNumbers=98]="selectOnLineNumbers",Z[Z.showFoldingControls=99]="showFoldingControls",Z[Z.showUnused=100]="showUnused",Z[Z.snippetSuggestions=101]="snippetSuggestions",Z[Z.smartSelect=102]="smartSelect",Z[Z.smoothScrolling=103]="smoothScrolling",Z[Z.stickyTabStops=104]="stickyTabStops",Z[Z.stopRenderingLineAfter=105]="stopRenderingLineAfter",Z[Z.suggest=106]="suggest",Z[Z.suggestFontSize=107]="suggestFontSize",Z[Z.suggestLineHeight=108]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",Z[Z.suggestSelection=110]="suggestSelection",Z[Z.tabCompletion=111]="tabCompletion",Z[Z.tabIndex=112]="tabIndex",Z[Z.unusualLineTerminators=113]="unusualLineTerminators",Z[Z.useShadowDOM=114]="useShadowDOM",Z[Z.useTabStops=115]="useTabStops",Z[Z.wordSeparators=116]="wordSeparators",Z[Z.wordWrap=117]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=120]="wordWrapColumn",Z[Z.wordWrapOverride1=121]="wordWrapOverride1",Z[Z.wordWrapOverride2=122]="wordWrapOverride2",Z[Z.wrappingIndent=123]="wrappingIndent",Z[Z.wrappingStrategy=124]="wrappingStrategy",Z[Z.showDeprecated=125]="showDeprecated",Z[Z.inlayHints=126]="inlayHints",Z[Z.editorClassName=127]="editorClassName",Z[Z.pixelRatio=128]="pixelRatio",Z[Z.tabFocusMode=129]="tabFocusMode",Z[Z.layoutInfo=130]="layoutInfo",Z[Z.wrappingInfo=131]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(137,null)})),acceptSuggestionOnEnter:Se(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(138,null),""],markdownDescription:m.localize(139,null)})),accessibilitySupport:Se(new p),accessibilityPageSize:Se(new o(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(140,null)})),ariaLabel:Se(new S(4,"ariaLabel",m.localize(141,null))),autoClosingBrackets:Se(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(142,null),m.localize(143,null),""],description:m.localize(144,null)})),autoClosingDelete:Se(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(145,null),""],description:m.localize(146,null)})),autoClosingOvertype:Se(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(147,null),""],description:m.localize(148,null)})),autoClosingQuotes:Se(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(149,null),m.localize(150,null),""],description:m.localize(151,null)})),autoIndent:Se(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[m.localize(152,null),m.localize(153,null),m.localize(154,null),m.localize(155,null),m.localize(156,null)],description:m.localize(157,null)})),automaticLayout:Se(new f(10,"automaticLayout",!1)),autoSurround:Se(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(158,null),m.localize(159,null),m.localize(160,null),""],description:m.localize(161,null)})),bracketPairColorization:Se(new V),stickyTabStops:Se(new f(104,"stickyTabStops",!1,{description:m.localize(162,null)})),codeLens:Se(new f(13,"codeLens",!0,{description:m.localize(163,null)})),codeLensFontFamily:Se(new S(14,"codeLensFontFamily","",{description:m.localize(164,null)})),codeLensFontSize:Se(new o(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(165,null)})),colorDecorators:Se(new f(16,"colorDecorators",!0,{description:m.localize(166,null)})),columnSelection:Se(new f(17,"columnSelection",!1,{description:m.localize(167,null)})),comments:Se(new t),contextmenu:Se(new f(19,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new f(20,"copyWithSyntaxHighlighting",!0,{description:m.localize(168,null)})),cursorBlinking:Se(new a(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:m.localize(169,null)})),cursorSmoothCaretAnimation:Se(new f(22,"cursorSmoothCaretAnimation",!1,{description:m.localize(170,null)})),cursorStyle:Se(new a(23,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:m.localize(171,null)})),cursorSurroundingLines:Se(new o(24,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(172,null)})),cursorSurroundingLinesStyle:Se(new E(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(173,null),m.localize(174,null)],description:m.localize(175,null)})),cursorWidth:Se(new o(26,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(176,null)})),disableLayerHinting:Se(new f(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new f(28,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new f(29,"domReadOnly",!1)),dragAndDrop:Se(new f(30,"dragAndDrop",!0,{description:m.localize(177,null)})),emptySelectionClipboard:Se(new b),extraEditorClassName:Se(new S(32,"extraEditorClassName","")),fastScrollSensitivity:Se(new v(33,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:m.localize(178,null)})),find:Se(new y),fixedOverflowWidgets:Se(new f(35,"fixedOverflowWidgets",!1)),folding:Se(new f(36,"folding",!0,{description:m.localize(179,null)})),foldingStrategy:Se(new E(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(180,null),m.localize(181,null)],description:m.localize(182,null)})),foldingHighlight:Se(new f(38,"foldingHighlight",!0,{description:m.localize(183,null)})),foldingImportsByDefault:Se(new f(39,"foldingImportsByDefault",!1,{description:m.localize(184,null)})),unfoldOnClickAfterEndOfLine:Se(new f(40,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(185,null)})),fontFamily:Se(new S(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(186,null)})),fontInfo:Se(new _),fontLigatures2:Se(new g),fontSize:Se(new w),fontWeight:Se(new F),formatOnPaste:Se(new f(46,"formatOnPaste",!1,{description:m.localize(187,null)})),formatOnType:Se(new f(47,"formatOnType",!1,{description:m.localize(188,null)})),glyphMargin:Se(new f(48,"glyphMargin",!0,{description:m.localize(189,null)})),gotoLocation:Se(new O),hideCursorInOverviewRuler:Se(new f(50,"hideCursorInOverviewRuler",!1,{description:m.localize(190,null)})),highlightActiveIndentGuide:Se(new f(51,"highlightActiveIndentGuide",!0,{description:m.localize(191,null)})),hover:Se(new G),inDiffEditor:Se(new f(53,"inDiffEditor",!1)),letterSpacing:Se(new v(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>v.clamp(Z,-5,20),{description:m.localize(192,null)})),lightbulb:Se(new W),lineDecorationsWidth:Se(new A(57,"lineDecorationsWidth",10)),lineHeight:Se(new x),lineNumbers:Se(new _e),lineNumbersMinChars:Se(new o(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new f(61,"linkedEditing",!1,{description:m.localize(193,null)})),links:Se(new f(62,"links",!0,{description:m.localize(194,null)})),matchBrackets:Se(new E(63,"matchBrackets","always",["always","near","never"],{description:m.localize(195,null)})),minimap:Se(new B),mouseStyle:Se(new E(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new v(66,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:m.localize(196,null)})),mouseWheelZoom:Se(new f(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(197,null)})),multiCursorMergeOverlapping:Se(new f(68,"multiCursorMergeOverlapping",!0,{description:m.localize(198,null)})),multiCursorModifier:Se(new a(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],N,{markdownEnumDescriptions:[m.localize(199,null),m.localize(200,null)],markdownDescription:m.localize(201,null)})),multiCursorPaste:Se(new E(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(202,null),m.localize(203,null)],markdownDescription:m.localize(204,null)})),occurrencesHighlight:Se(new f(71,"occurrencesHighlight",!0,{description:m.localize(205,null)})),overviewRulerBorder:Se(new f(72,"overviewRulerBorder",!0,{description:m.localize(206,null)})),overviewRulerLanes:Se(new o(73,"overviewRulerLanes",3,0,3)),padding:Se(new z),parameterHints:Se(new H),peekWidgetDefaultFocus:Se(new E(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(207,null),m.localize(208,null)],description:m.localize(209,null)})),definitionLinkOpensInPeek:Se(new f(77,"definitionLinkOpensInPeek",!1,{description:m.localize(210,null)})),quickSuggestions:Se(new X),quickSuggestionsDelay:Se(new o(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(211,null)})),readOnly:Se(new f(80,"readOnly",!1)),renameOnType:Se(new f(81,"renameOnType",!1,{description:m.localize(212,null),markdownDeprecationMessage:m.localize(213,null)})),renderControlCharacters:Se(new f(82,"renderControlCharacters",!1,{description:m.localize(214,null)})),renderIndentGuides:Se(new f(83,"renderIndentGuides",!0,{description:m.localize(215,null)})),renderFinalNewline:Se(new f(84,"renderFinalNewline",!0,{description:m.localize(216,null)})),renderLineHighlight:Se(new E(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(217,null)],description:m.localize(218,null)})),renderLineHighlightOnlyWhenFocus:Se(new f(86,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(219,null)})),renderValidationDecorations:Se(new E(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new E(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(220,null),m.localize(221,null),m.localize(222,null),""],description:m.localize(223,null)})),revealHorizontalRightPadding:Se(new o(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new f(90,"roundedSelection",!0,{description:m.localize(224,null)})),rulers:Se(new Re),scrollbar:Se(new Be),scrollBeyondLastColumn:Se(new o(93,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(225,null)})),scrollBeyondLastLine:Se(new f(94,"scrollBeyondLastLine",!0,{description:m.localize(226,null)})),scrollPredominantAxis:Se(new f(95,"scrollPredominantAxis",!0,{description:m.localize(227,null)})),selectionClipboard:Se(new f(96,"selectionClipboard",!0,{description:m.localize(228,null),included:L.isLinux})),selectionHighlight:Se(new f(97,"selectionHighlight",!0,{description:m.localize(229,null)})),selectOnLineNumbers:Se(new f(98,"selectOnLineNumbers",!0)),showFoldingControls:Se(new E(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(230,null),m.localize(231,null)],description:m.localize(232,null)})),showUnused:Se(new f(100,"showUnused",!0,{description:m.localize(233,null)})),showDeprecated:Se(new f(125,"showDeprecated",!0,{description:m.localize(234,null)})),inlayHints:Se(new M),snippetSuggestions:Se(new E(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(235,null),m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),smartSelect:Se(new re),smoothScrolling:Se(new f(103,"smoothScrolling",!1,{description:m.localize(240,null)})),stopRenderingLineAfter:Se(new o(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new ee),inlineSuggest:Se(new je),suggestFontSize:Se(new o(107,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(241,null)})),suggestLineHeight:Se(new o(108,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(242,null)})),suggestOnTriggerCharacters:Se(new f(109,"suggestOnTriggerCharacters",!0,{description:m.localize(243,null)})),suggestSelection:Se(new E(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),tabCompletion:Se(new E(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(248,null),m.localize(249,null),m.localize(250,null)],description:m.localize(251,null)})),tabIndex:Se(new o(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new E(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(252,null),m.localize(253,null),m.localize(254,null)],description:m.localize(255,null)})),useShadowDOM:Se(new f(114,"useShadowDOM",!0)),useTabStops:Se(new f(115,"useTabStops",!0,{description:m.localize(256,null)})),wordSeparators:Se(new S(116,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:m.localize(257,null)})),wordWrap:Se(new E(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(258,null),m.localize(259,null),m.localize(260,null),m.localize(261,null)],description:m.localize(262,null)})),wordWrapBreakAfterCharacters:Se(new S(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new S(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new o(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(263,null)})),wordWrapOverride1:Se(new E(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new E(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new a(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],oe,{enumDescriptions:[m.localize(264,null),m.localize(265,null),m.localize(266,null),m.localize(267,null)],description:m.localize(268,null)})),wrappingStrategy:Se(new E(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(269,null),m.localize(270,null)],description:m.localize(271,null)})),editorClassName:Se(new d),pixelRatio:Se(new Q),tabFocusMode:Se(new ae),layoutInfo:Se(new U),wrappingInfo:Se(new ve)}}),define(me[155],ge([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[156],ge([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[157],ge([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[158],ge([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[159],ge([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(me[160],ge([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(me[161],ge([19,20]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(me[162],ge([19,20]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(me[163],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[164],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[165],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(me[166],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[167],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[168],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[169],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[170],ge([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[171],ge([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(me[172],ge([19,20]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(me[173],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[174],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[175],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[176],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[177],ge([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[178],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var L;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var I;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var k;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(k=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[179],ge([0,1,157]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function k(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=k;function R(u){if(!k(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=u.match(L);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=R;function C(u){if(!u)return null;let f=u.majorBase,o=u.majorMustEqual,v=u.minorBase,S=u.minorMustEqual,P=u.patchBase,E=u.patchMustEqual;u.hasCaret&&(f===0||(S=!1),E=!1);let a=0;if(u.preRelease){const l=I.exec(u.preRelease);if(l){const[,p,t,s]=l;a=Date.UTC(Number(p),Number(t)-1,Number(s))}}return{majorBase:f,majorMustEqual:o,minorBase:v,minorMustEqual:S,patchBase:P,patchMustEqual:E,isMinimum:u.hasGreaterEquals,notBefore:a}}e.normalizeVersion=C;function D(u,f,o){let v;typeof u=="string"?v=C(R(u)):v=u;let S;f instanceof Date?S=f.getTime():typeof f=="string"&&(S=new Date(f).getTime());let P;if(typeof o=="string"?P=C(R(o)):P=o,!v||!P)return!1;let E=v.majorBase,a=v.minorBase,l=v.patchBase,p=P.majorBase,t=P.minorBase,s=P.patchBase,r=P.notBefore,i=P.majorMustEqual,h=P.minorMustEqual,c=P.patchMustEqual;return P.isMinimum?E>p?!0:E<p?!1:a>t?!0:a<t||S&&S<r?!1:l>=s:(E===1&&p===0&&(!i||!h||!c)&&(p=1,t=0,s=0,i=!0,h=!1,c=!1),E<p?!1:E>p?!i:a<t?!1:a>t?!h:l<s?!1:l>s?!c:!(S&&S<r))}e.isValidVersion=D;function T(u,f,o,v){return o.isBuiltin||typeof o.main=="undefined"?!0:A(u,f,o.engines.vscode,v)}e.isValidExtensionVersion=T;function n(u,f,o){return u==="*"||A(f,o,u)}e.isEngineValid=n;function A(u,f,o,v=[]){let S=C(R(o));if(!S)return v.push(m.localize(0,null,o)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return v.push(m.localize(1,null,o)),!1}else if(!S.majorMustEqual)return v.push(m.localize(2,null,o)),!1;return D(u,f,S)?!0:(v.push(m.localize(3,null,u,o)),!1)}}),define(me[115],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(I,k=[],R=!1){this.ctor=I,this.staticArguments=k,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=m}),define(me[82],ge([0,1,115]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function I(R,C,D){C instanceof m.SyncDescriptor||(C=new m.SyncDescriptor(C,[],D)),L.push([R,C])}e.registerSingleton=I;function k(){return L}e.getSingletonServiceDescriptors=k}),define(me[180],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=m;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let R of this._nodes.values())R.outgoing.size===0&&k.push(R);return k}insertEdge(k,R){const C=this.lookupOrInsertNode(k),D=this.lookupOrInsertNode(R);C.outgoing.set(this._hashFn(R),D),D.incoming.set(this._hashFn(k),C)}removeNode(k){const R=this._hashFn(k);this._nodes.delete(R);for(let C of this._nodes.values())C.outgoing.delete(R),C.incoming.delete(R)}lookupOrInsertNode(k){const R=this._hashFn(k);let C=this._nodes.get(R);return C||(C=new m(k),this._nodes.set(R,C)),C}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[R,C]of this._nodes)k.push(`${R}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,R]of this._nodes){const C=new Set([k]),D=this._findCycle(R,C);if(D)return D}}_findCycle(k,R){for(let[C,D]of k.outgoing){if(R.has(C))return[...R,C].join(" -> ");R.add(C);const T=this._findCycle(D,R);if(T)return T;R.delete(C)}}}e.Graph=L}),define(me[4],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(T){return T[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(m=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function L(C,D,T,n){D[m.DI_TARGET]===D?D[m.DI_DEPENDENCIES].push({id:C,index:T,optional:n}):(D[m.DI_DEPENDENCIES]=[{id:C,index:T,optional:n}],D[m.DI_TARGET]=D)}function I(C){if(m.serviceIds.has(C))return m.serviceIds.get(C);const D=function(T,n,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(D,T,A,!1)};return D.toString=()=>C,m.serviceIds.set(C,D),D}e.createDecorator=I;function k(C){return C}e.refineServiceDecorator=k;function R(C){return function(D,T,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(C,D,n,!0)}}e.optional=R}),define(me[181],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function L(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[182],ge([0,1,3,48,6,24,77,81,181]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(T):!!v.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(S,P){let E={selector:S,provider:P,_score:-1,_time:this._clock++};return this._entries.push(E),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,I.toDisposable)(()=>{if(E){let a=this._entries.indexOf(E);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),E=void 0)}})}has(S){return this.all(S).length>0}all(S){if(!S)return[];this._updateScores(S);const P=[];for(let E of this._entries)E._score>0&&P.push(E.provider);return P}ordered(S){const P=[];return this._orderedForEach(S,E=>P.push(E.provider)),P}orderedGroups(S){const P=[];let E,a;return this._orderedForEach(S,l=>{E&&a===l._score?E.push(l.provider):(a=l._score,E=[l.provider],P.push(E))}),P}_orderedForEach(S,P){if(!!S){this._updateScores(S);for(const E of this._entries)E._score>0&&P(E)}}_updateScores(S){let P={uri:S.uri.toString(),language:S.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===P.language&&this._lastCandidate.uri===P.uri)){this._lastCandidate=P;for(let E of this._entries)if(E._score=(0,C.score)(E.selector,S.uri,S.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(S)),T(E.selector)&&E._score>0){for(let a of this._entries)a._score=0;E._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(S,P){return S._score<P._score?1:S._score>P._score?-1:S._time<P._time?1:S._time>P._time?-1:0}}e.LanguageFeatureRegistry=n;const A=new WeakMap;let u=0;function f(v){let S=A.get(v);return S===void 0&&(S=++u,A.set(v,S)),S}class o{constructor(S,P,E=Number.MAX_SAFE_INTEGER){this._registry=S,this.min=P,this.max=E,this._cache=new k.LRUCache(50,.7)}_key(S){return S.id+this._registry.all(S).reduce((P,E)=>(0,L.doHash)(f(E),P),0)}_clamp(S){return S===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(S*1.3)))}get(S){const P=this._key(S),E=this._cache.get(P);return this._clamp(E?.value)}update(S,P){const E=this._key(S);let a=this._cache.get(E);return a||(a=new R.MovingAverage,this._cache.set(E,a)),a.update(P),this.get(S)}}e.LanguageFeatureRequestDelays=o}),define(me[83],ge([0,1,2,41,182,148,47]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class D{constructor(_,w){this.language=_,this.id=w}}e.LanguageIdentifier=D;var T;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(T=e.FontStyle||(e.FontStyle={}));var n;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var A;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var u;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(u=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let w=this.getForeground(_),F="mtk"+w,O=this.getFontStyle(_);return O&1&&(F+=" mtki"),O&2&&(F+=" mtkb"),O&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(_,w){const F=this.getForeground(_),O=this.getFontStyle(_);let G=`color: ${w[F]};`;return O&1&&(G+="font-style: italic;"),O&2&&(G+="font-weight: bold;"),O&4&&(G+="text-decoration: underline;"),G}}e.TokenMetadata=f;var o;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(_){const w=g[_];let F=w&&R.iconRegistry.get(w);return F||(console.info("No codicon found for CompletionItemKind "+_),F=R.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(_,w){let F=g[_];return typeof F=="undefined"&&!w&&(F=9),F}}();var v;(function(g){g[g.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var P;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(P=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(g){return g&&m.URI.isUri(g.uri)&&L.Range.isIRange(g.range)&&(L.Range.isIRange(g.originSelectionRange)||L.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=t;var s;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var r;(function(g){g[g.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(g){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const w=new Map;w.set(0,"file"),w.set(1,"module"),w.set(2,"namespace"),w.set(3,"package"),w.set(4,"class"),w.set(5,"method"),w.set(6,"property"),w.set(7,"field"),w.set(8,"constructor"),w.set(9,"enum"),w.set(10,"interface"),w.set(11,"function"),w.set(12,"variable"),w.set(13,"constant"),w.set(14,"string"),w.set(15,"number"),w.set(16,"boolean"),w.set(17,"array"),w.set(18,"object"),w.set(19,"key"),w.set(20,"null"),w.set(21,"enum-member"),w.set(22,"struct"),w.set(23,"event"),w.set(24,"operator"),w.set(25,"type-parameter");function F(K){return _.get(K)}g.fromString=F;function O(K){return w.get(K)}g.toString=O;function G(K,U){const W=w.get(K);let M=W&&R.iconRegistry.get("symbol-"+W);return M||(console.info("No codicon found for SymbolKind "+K),M=R.Codicon.symbolProperty),`${U?"inline":"block"} ${M.classNames}`}g.toCssClassName=G})(i=e.SymbolKinds||(e.SymbolKinds={}));class h{constructor(_){this.value=_}}e.FoldingRangeKind=h,h.Comment=new h("comment"),h.Imports=new h("imports"),h.Region=new h("region");var c;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var b;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new k.TokenizationRegistryImpl;var y;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[62],ge([0,1,11,9,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=m.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",m.isMacintosh),R.set("isLinux",m.isLinux),R.set("isWindows",m.isWindows),R.set("isWeb",m.isWeb),R.set("isMacNative",m.isMacintosh&&!m.isWeb),R.set("isEdge",k.indexOf("Edg/")>=0),R.set("isFirefox",k.indexOf("Firefox")>=0),R.set("isChrome",k.indexOf("Chrome")>=0),R.set("isSafari",k.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var D;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return A.INSTANCE}static true(){return u.INSTANCE}static has(w){return f.create(w)}static equals(w,F){return o.create(w,F)}static notEquals(w,F){return P.create(w,F)}static regex(w,F){return s.create(w,F)}static in(w,F){return v.create(w,F)}static not(w){return E.create(w)}static and(...w){return i.create(w,null)}static or(...w){return h.create(w,null,!0)}static greater(w,F){return a.create(w,F)}static less(w,F){return p.create(w,F)}static deserialize(w,F=!1){if(!!w)return this._deserializeOrExpression(w,F)}static _deserializeOrExpression(w,F){let O=w.split("||");return h.create(O.map(G=>this._deserializeAndExpression(G,F)),null,!0)}static _deserializeAndExpression(w,F){let O=w.split("&&");return i.create(O.map(G=>this._deserializeOne(G,F)),null)}static _deserializeOne(w,F){if(w=w.trim(),w.indexOf("!=")>=0){let O=w.split("!=");return P.create(O[0].trim(),this._deserializeValue(O[1],F))}if(w.indexOf("==")>=0){let O=w.split("==");return o.create(O[0].trim(),this._deserializeValue(O[1],F))}if(w.indexOf("=~")>=0){let O=w.split("=~");return s.create(O[0].trim(),this._deserializeRegexValue(O[1],F))}if(w.indexOf(" in ")>=0){let O=w.split(" in ");return v.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const O=w.split(">=");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const O=w.split(">");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const O=w.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const O=w.split("<");return p.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(w)?E.create(w.substr(1).trim()):f.create(w)}static _deserializeValue(w,F){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let O=/^'([^']*)'$/.exec(w);return O?O[1].trim():w}static _deserializeRegexValue(w,F){if((0,L.isFalsyOrWhitespace)(w)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=w.indexOf("/"),G=w.lastIndexOf("/");if(O===G||O<0){if(F)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let K=w.slice(O+1,G),U=w[G+1]==="i"?"i":"";try{return new RegExp(K,U)}catch(W){if(F)throw new Error(`bad regexp-value '${w}', parse error: ${W}`);return console.warn(`bad regexp-value '${w}', parse error: ${W}`),null}}}e.ContextKeyExpr=T;function n(_,w){return _.cmp(w)}class A{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=A,A.INSTANCE=new A;class u{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return A.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class f{constructor(w,F){this.key=w,this.negated=F,this.type=2}static create(w,F=null){const O=R.get(w);return typeof O=="boolean"?O?u.INSTANCE:A.INSTANCE:new f(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class o{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=4}static create(w,F,O=null){if(typeof F=="boolean")return F?f.create(w,O):E.create(w,O);const G=R.get(w);return typeof G=="boolean"?F===(G?"true":"false")?u.INSTANCE:A.INSTANCE:new o(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=o;class v{constructor(w,F){this.key=w,this.valueKey=F,this.type=10,this.negated=null}static create(w,F){return new v(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const F=w.getValue(this.valueKey),O=w.getValue(this.key);return Array.isArray(F)?F.indexOf(O)>=0:typeof O=="string"&&typeof F=="object"&&F!==null?C.call(F,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=S.create(this)),this.negated}}e.ContextKeyInExpr=v;class S{constructor(w){this._actual=w,this.type=11}static create(w){return new S(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new S(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class P{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=5}static create(w,F,O=null){if(typeof F=="boolean")return F?E.create(w,O):f.create(w,O);const G=R.get(w);return typeof G=="boolean"?F===(G?"true":"false")?A.INSTANCE:u.INSTANCE:new P(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=P;class E{constructor(w,F){this.key=w,this.negated=F,this.type=3}static create(w,F=null){const O=R.get(w);return typeof O=="boolean"?O?A.INSTANCE:u.INSTANCE:new E(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=E;class a{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=12}static create(w,F,O=null){return new a(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class l{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=13}static create(w,F,O=null){return new l(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class p{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=14}static create(w,F,O=null){return new p(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=p;class t{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=15}static create(w,F,O=null){return new t(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(w,F){this.key=w,this.regexp=F,this.type=7,this.negated=null}static create(w,F){return new s(w,F)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const F=this.regexp?this.regexp.source:"",O=w.regexp?w.regexp.source:"";return F<O?-1:F>O?1:0}equals(w){if(w.type===this.type){const F=this.regexp?this.regexp.source:"",O=w.regexp?w.regexp.source:"";return this.key===w.key&&F===O}return!1}evaluate(w){let F=w.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class r{constructor(w){this._actual=w,this.type=8}static create(w){return new r(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new r(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class i{constructor(w,F){this.expr=w,this.negated=F,this.type=6}static create(w,F){return i._normalizeArr(w,F)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const G=n(this.expr[F],w.expr[F]);if(G!==0)return G}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(w.expr[F]))return!1;return!0}return!1}evaluate(w){for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].evaluate(w))return!1;return!0}static _normalizeArr(w,F){const O=[];let G=!1;for(const K of w)if(!!K){if(K.type===1){G=!0;continue}if(K.type===0)return A.INSTANCE;if(K.type===6){O.push(...K.expr);continue}O.push(K)}if(O.length===0&&G)return u.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(n);for(let K=1;K<O.length;K++)O[K-1].equals(O[K])&&(O.splice(K,1),K--);if(O.length===1)return O[0];for(;O.length>1;){const K=O[O.length-1];if(K.type!==9)break;O.pop();const U=O.pop(),W=O.length===0,M=h.create(K.expr.map(x=>i.create([x,U],null)),null,W);M&&(O.push(M),O.sort(n))}return O.length===1?O[0]:new i(O,F)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let F of this.expr)w.push(...F.keys());return w}map(w){return new i(this.expr.map(F=>F.map(w)),null)}negate(){if(!this.negated){const w=[];for(let F of this.expr)w.push(F.negate());this.negated=h.create(w,this,!0)}return this.negated}}class h{constructor(w,F){this.expr=w,this.negated=F,this.type=9}static create(w,F,O){return h._normalizeArr(w,F,O)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const G=n(this.expr[F],w.expr[F]);if(G!==0)return G}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(w.expr[F]))return!1;return!0}return!1}evaluate(w){for(let F=0,O=this.expr.length;F<O;F++)if(this.expr[F].evaluate(w))return!0;return!1}static _normalizeArr(w,F,O){let G=[],K=!1;if(w){for(let U=0,W=w.length;U<W;U++){const M=w[U];if(!!M){if(M.type===0){K=!0;continue}if(M.type===1)return u.INSTANCE;if(M.type===9){G=G.concat(M.expr);continue}G.push(M)}}if(G.length===0&&K)return A.INSTANCE;G.sort(n)}if(G.length!==0){if(G.length===1)return G[0];for(let U=1;U<G.length;U++)G[U-1].equals(G[U])&&(G.splice(U,1),U--);if(G.length===1)return G[0];if(O){for(let U=0;U<G.length;U++)for(let W=U+1;W<G.length;W++)y(G[U],G[W])&&(G.splice(W,1),W--);if(G.length===1)return G[0]}return new h(G,F)}}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let F of this.expr)w.push(...F.keys());return w}map(w){return new h(this.expr.map(F=>F.map(w)),null)}negate(){if(!this.negated){let w=[];for(let F of this.expr)w.push(F.negate());for(;w.length>1;){const F=w.shift(),O=w.shift(),G=[];for(const U of g(F))for(const W of g(O))G.push(i.create([U,W],null));const K=w.length===0;w.unshift(h.create(G,null,K))}this.negated=w[0]}return this.negated}}class c extends f{constructor(w,F,O){super(w,null);this._defaultValue=F,typeof O=="object"?c._info.push({...O,key:w}):O!==!0&&c._info.push({key:w,description:O,type:F!=null?typeof F:void 0})}static all(){return c._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(w){return o.create(this.key,w)}notEqualsTo(w){return P.create(this.key,w)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(_,w){return _<w?-1:_>w?1:0}function b(_,w,F,O){return _<F?-1:_>F?1:w<O?-1:w>O?1:0}function y(_,w){if(w.type===6&&_.type!==9&&_.type!==6){for(const G of w.expr)if(_.equals(G))return!0}const F=_.negate(),O=g(F).concat(g(w));O.sort(n);for(let G=0;G<O.length;G++){const U=O[G].negate();for(let W=G+1;W<O.length;W++){const M=O[W];if(U.equals(M))return!0}}return!1}e.implies=y;function g(_){return _.type===9?_.expr:[_]}}),define(me[183],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(me[184],ge([0,1,10,11,34,156,4]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.CURRENT_TARGET_PLATFORM=e.getTargetPlatform=e.getTargetPlatformFromOS=e.toTargetPlatform=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(P){P.WIN32_X64="win32-x64",P.WIN32_IA32="win32-ia32",P.WIN32_ARM64="win32-arm64",P.LINUX_X64="linux-x64",P.LINUX_ARM64="linux-arm64",P.LINUX_ARMHF="linux-armhf",P.DARWIN_X64="darwin-x64",P.DARWIN_ARM64="darwin-arm64",P.WEB="web",P.UNIVERSAL="universal",P.UNKNOWN="unknown",P.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function D(P){switch(P){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function T(P,E){let a;switch(P){case 1:a=3;break;case 3:a=2;break;case 2:a=1;break}return n(a,E)}e.getTargetPlatformFromOS=T;function n(P,E){switch(P){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=n,e.CURRENT_TARGET_PLATFORM=L.isWeb?"web":n(L.platform,I.arch);function A(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=A;var u;(function(P){P[P.NoneOrRelevance=0]="NoneOrRelevance",P[P.LastUpdatedDate=1]="LastUpdatedDate",P[P.Title=2]="Title",P[P.PublisherName=3]="PublisherName",P[P.InstallCount=4]="InstallCount",P[P.PublishedDate=5]="PublishedDate",P[P.AverageRating=6]="AverageRating",P[P.WeightedRating=12]="WeightedRating"})(u=e.SortBy||(e.SortBy={}));var f;(function(P){P[P.Default=0]="Default",P[P.Ascending=1]="Ascending",P[P.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var o;(function(P){P.Install="install",P.Uninstall="uninstall"})(o=e.StatisticType||(e.StatisticType={}));var v;(function(P){P[P.None=0]="None",P[P.Install=1]="Install",P[P.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class S extends Error{constructor(E,a){super(E);this.code=a,this.name=a}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,9,4]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=I;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class C{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,u){if(typeof A=="undefined"||A===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof A=="string"||typeof u=="string"){let f=typeof A=="string"?A:A.value,o=typeof u=="string"?u:u.value;return m.equalsIgnoreCase(f,o)}return A._lower===u._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=C;function D(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function T(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=T,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[185],ge([0,1,9,26]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(o,v){return o.uuid&&v.uuid?o.uuid===v.uuid:o.id===v.id?!0:(0,m.compareIgnoreCase)(o.id,v.id)===0}e.areSameExtensions=I;class k{constructor(v,S){this.version=S,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof k?I(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=k;function R(o,v){return`${o}.${v}`}e.getExtensionId=R;function C(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function D(o,v){return C(R(o,v))}e.getGalleryExtensionId=D;function T(o,v){const S=[],P=E=>{for(const a of S)if(a.some(l=>I(v(l),v(E))))return a;return null};for(const E of o){const a=P(E);a?a.push(E):S.push([E])}return S}e.groupByExtension=T;function n(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function A(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function u(o){const v=new Set;for(const S of o)S.malicious&&v.add(S.id.id);return v}e.getMaliciousExtensionsSet=u;function f(o,v){const S=[],P=v.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const E=P.shift();if(E&&S.every(a=>!I(a.identifier,{id:E}))){const a=o.filter(l=>I(l.identifier,{id:E}));a.length===1&&(S.push(a[0]),P.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=f}),define(me[186],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(me[187],ge([0,1,39,10,8,11,140,28,113,158,186]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const A=T.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends u{openTerminal(l,p){return this.spawnTerminal(m,l,D.getWindowsShell(),p)}spawnTerminal(l,p,t,s){const r=p.windowsExec||f.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const i=I.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return l.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return r.indexOf(" ")>=0&&h.push('""'),h.push(r),(i==="wt"||i==="wt.exe")&&h.push("-d ."),new Promise((c,d)=>{const b=S(process),y=l.spawn(t,h,{cwd:s,env:b});y.on("error",d),y.on("exit",()=>c())})}runInTerminal(l,p,t,s,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((h,c)=>{const d=`"${p} - ${A}"`,b=`""${t.join('" "')}" & pause"`,y=["/c","start",d,"/wait",i,"/c",b],g=Object.assign({},S(process),s);Object.keys(g).filter(F=>g[F]===null).forEach(F=>delete g[F]);const _={cwd:p,env:g,windowsVerbatimArguments:!0};m.spawn(f.CMD,y,_).on("error",F=>{c(P(F))}),h(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const l=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${l?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class o extends u{openTerminal(l,p){return this.spawnTerminal(m,l,p)}runInTerminal(l,p,t,s,r){const i=r.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((h,c)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const d=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",y=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,J).fsPath,"-t",l||A,"-w",p];for(let w of t)y.push("-a"),y.push(w);if(s){const w=Object.assign({},S(process),s);for(let F in w){const O=w[F];O===null?(y.push("-u"),y.push(F)):(y.push("-e"),y.push(`${F}=${O}`))}}let g="";const _=m.spawn(o.OSASCRIPT,y);_.on("error",w=>{c(P(w))}),_.stderr.on("data",w=>{g+=w.toString()}),_.on("exit",w=>{if(w===0)h(void 0);else if(g){const F=g.split(`
`,1);c(new Error(F[0]))}else c(new Error(T.localize(1,null,d,w)))})}else c(new Error(T.localize(2,null,i)))})}spawnTerminal(l,p,t){const s=p.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const h=["-a",s];t&&h.push(t);const c=S(process),d=l.spawn("/usr/bin/open",h,{cwd:t,env:c});d.on("error",i),d.on("exit",()=>r())})}}e.MacExternalTerminalService=o,o.OSASCRIPT="/usr/bin/osascript";class v extends u{openTerminal(l,p){return this.spawnTerminal(m,l,p)}runInTerminal(l,p,t,s,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((h,c)=>{let d=[];i.then(b=>{b.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const y=`${E(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;d.push(`''${y}''`);const g=Object.assign({},S(process),s);Object.keys(g).filter(O=>g[O]===null).forEach(O=>delete g[O]);const _={cwd:p,env:g};let w="";const F=m.spawn(b,d,_);F.on("error",O=>{c(P(O))}),F.stderr.on("data",O=>{w+=O.toString()}),F.on("exit",O=>{if(O===0)h(void 0);else if(w){const G=w.split(`
`,1);c(new Error(G[0]))}else c(new Error(T.localize(4,null,b,O)))})})})}static async getDefaultTerminalLinuxReady(){return v._DEFAULT_TERMINAL_LINUX_READY||(v._DEFAULT_TERMINAL_LINUX_READY=new Promise(async l=>{k.isLinux?await C.Promises.exists("/etc/debian_version")?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm"):l("xterm")})),v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(l,p,t){const s=p.linuxExec?Promise.resolve(p.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{s.then(h=>{const c=S(process),d=l.spawn(h,[],{cwd:t,env:c});d.on("error",i),d.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=T.localize(3,null);function S(a){const l={...a.env};return(0,R.sanitizeProcessEnvironment)(l),l}function P(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(T.localize(5,null,a.path)):a}function E(a){let l="";for(let p of a)p.indexOf(" ")>=0?l+='"'+p+'"':l+=p,l+=" ";return l}}),define(me[42],ge([0,1,24,8,9,13,2,159,4]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function T(U){return U.create===!0}e.isFileOpenForWriteOptions=T;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var A;(function(U){U[U.Readonly=1]="Readonly"})(A=e.FilePermission||(e.FilePermission={}));var u;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(u=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=f;function o(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=o;function v(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function S(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=S;var P;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(W,M){super(W);this.code=M}}e.FileSystemProviderError=E;function a(U,W){const M=new E(U.toString(),W);return p(M,W),M}e.createFileSystemProviderError=a;function l(U){return U||a((0,C.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=l;function p(U,W){return U.name=W?`${W} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=p;function t(U){if(!U)return P.Unknown;if(U instanceof E)return U.code;const W=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!W)return P.Unknown;switch(W[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=t;function s(U){if(U instanceof b)return U.fileOperationResult;switch(t(U)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(W,M,x){this.resource=W,this.operation=M,this.target=x}isOperation(W){return this.operation===W}}e.FileOperationEvent=i;var h;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class c{constructor(W,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const x of W)switch(x.type){case 1:this.added||(this.added=m.TernarySearchTree.forUris(()=>M)),this.added.set(x.resource,x);break;case 0:this.updated||(this.updated=m.TernarySearchTree.forUris(()=>M)),this.updated.set(x.resource,x);break;case 2:this.deleted||(this.deleted=m.TernarySearchTree.forUris(()=>M)),this.deleted.set(x.resource,x);break}}contains(W,...M){return this.doContains(W,{includeChildren:!1},...M)}affects(W,...M){return this.doContains(W,{includeChildren:!0},...M)}doContains(W,M,...x){if(!W)return!1;const B=x.length>0;return!!((!B||x.includes(1))&&(this.added?.get(W)||M.includeChildren&&this.added?.findSuperstr(W))||(!B||x.includes(0))&&(this.updated?.get(W)||M.includeChildren&&this.updated?.findSuperstr(W))||(!B||x.includes(2))&&(this.deleted?.findSubstr(W)||M.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function d(U,W,M){return!U||!W||U===W||W.length>U.length?!1:(W.charAt(W.length-1)!==L.sep&&(W+=L.sep),M?(0,I.startsWithIgnoreCase)(U,W):U.indexOf(W)===0)}e.isParent=d;class b extends Error{constructor(W,M,x){super(W);this.fileOperationResult=M,this.options=x}}e.FileOperationError=b;class y extends b{constructor(W,M,x){super(W,2,x);this.stat=M}}e.NotModifiedSinceFileOperationError=y;var g;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function w(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=w;async function F(U,W){if(!W.canHandleResource(R.URI.from({scheme:U.scheme})))return new Promise(M=>{const x=W.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===U.scheme&&B.added&&(x.dispose(),M())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(W){return(0,k.isNumber)(W)||(W=0),W<O.KB?(0,C.localize)(1,null,W.toFixed(0)):W<O.MB?(0,C.localize)(2,null,(W/O.KB).toFixed(2)):W<O.GB?(0,C.localize)(3,null,(W/O.MB).toFixed(2)):W<O.TB?(0,C.localize)(4,null,(W/O.GB).toFixed(2)):(0,C.localize)(5,null,(W/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var G;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function K(U){return{maxFileSize:U===0?300*O.MB:16*O.GB,maxHeapSize:U===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=K}),define(me[84],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...I){this._entries=new Map;for(let[k,R]of I)this.set(k,R)}set(I,k){const R=this._entries.get(I);return this._entries.set(I,k),R}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=m}),define(me[188],ge([0,1,18,16,115,180,4,84]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class T extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class n{constructor(o=new C.ServiceCollection,v=!1,S){this._activeInstantiations=new Set,this._services=o,this._strict=v,this._parent=S,this._services.set(R.IInstantiationService,this)}createChild(o){return new n(o,this._strict,this)}invokeFunction(o,...v){let S=u.traceInvocation(o),P=!1;try{return o({get:(a,l)=>{if(P)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(a,S);if(!p&&l!==R.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return p}},...v)}finally{P=!0,S.stop()}}createInstance(o,...v){let S,P;return o instanceof I.SyncDescriptor?(S=u.traceCreation(o.ctor),P=this._createInstance(o.ctor,o.staticArguments.concat(v),S)):(S=u.traceCreation(o),P=this._createInstance(o,v,S)),S.stop(),P}_createInstance(o,v=[],S){let P=R._util.getServiceDependencies(o).sort((l,p)=>l.index-p.index),E=[];for(const l of P){let p=this._getOrCreateServiceInstance(l.id,S);if(!p&&this._strict&&!l.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${l.id}.`);E.push(p)}let a=P.length>0?P[0].index:v.length;if(v.length!==a){console.warn(`[createInstance] First service dependency of ${o.name} at position ${a+1} conflicts with ${v.length} static arguments`);let l=a-v.length;l>0?v=v.concat(new Array(l)):v=v.slice(0,a)}return new o(...[...v,...E])}_setServiceInstance(o,v){if(this._services.get(o)instanceof I.SyncDescriptor)this._services.set(o,v);else if(this._parent)this._parent._setServiceInstance(o,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let v=this._services.get(o);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):v}_getOrCreateServiceInstance(o,v){let S=this._getServiceInstanceOrDescriptor(o);return S instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,S,v.branch(o,!0)):(v.branch(o,!1),S)}_safeCreateAndCacheServiceInstance(o,v,S){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,v,S)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,v,S){const P=new k.Graph(l=>l.id.toString());let E=0;const a=[{id:o,desc:v,_trace:S}];for(;a.length;){const l=a.pop();if(P.lookupOrInsertNode(l),E++>1e3)throw new T(P);for(let p of R._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${o} depends on ${p.id} which is NOT registered.`),t instanceof I.SyncDescriptor){const s={id:p.id,desc:t,_trace:l._trace.branch(p.id,!0)};P.insertEdge(l,s),a.push(s)}}}for(;;){const l=P.roots();if(l.length===0){if(!P.isEmpty())throw new T(P);break}for(const{data:p}of l){if(this._getServiceInstanceOrDescriptor(p.id)instanceof I.SyncDescriptor){const s=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,s)}P.removeNode(p)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,v,S=[],P,E){if(this._services.get(o)instanceof I.SyncDescriptor)return this._createServiceInstance(v,S,P,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,v,S,P,E);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(o,v=[],S,P){if(S){const E=new m.IdleValue(()=>this._createInstance(o,v,P));return new Proxy(Object.create(null),{get(a,l){if(l in a)return a[l];let p=E.value,t=p[l];return typeof t!="function"||(t=t.bind(p),a[l]=t),t},set(a,l,p){return E.value[l]=p,!0}})}else return this._createInstance(o,v,P)}}e.InstantiationService=n;var A;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(A||(A={}));class u{constructor(o,v){this.type=o,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return D?new u(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(o){return D?new u(0,o.name):u._None}branch(o,v){let S=new u(2,o.toString());return this._dep.push([o,v,S]),S}stop(){let o=Date.now()-this._start;u._totals+=o;let v=!1;function S(E,a){let l=[],p=new Array(E+1).join("	");for(const[t,s,r]of a._dep)if(s&&r){v=!0,l.push(`${p}CREATES -> ${t}`);let i=S(E+1,r);i&&l.push(i)}else l.push(`${p}uses -> ${t}`);return l.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(o>2||v)&&console.log(P.join(`
`))}}u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(me[12],ge([0,1,61,3,6,11,4]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function C(){return new Date().toISOString()}var D;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class T extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class n extends T{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(D.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(D.Error,this.format(r))}else this.log(D.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(h){}s+=(r>0?" ":"")+i}return s}}e.AbstractMessageLogger=n;class A extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...s){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}debug(t,...s){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}info(t,...s){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}warn(t,...s){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...s):console.warn(`[main ${C()}]`,t,...s))}error(t,...s){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...s):console.error(`[main ${C()}]`,t,...s))}critical(t,...s){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...s):console.error(`[main ${C()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=A;class u extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=u;class f extends T{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,m.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class o extends T{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=o;class v extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=v;class S extends I.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?D.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class P{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=P;function E(p){if(p.verbose)return D.Trace;if(typeof p.logLevel=="string"){const t=a(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function a(p){switch(p){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=a;function l(p){switch(p){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=l}),define(me[116],ge([0,1,42,12]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function I(D,T,n,A){try{const u=await new Promise((f,o)=>{J(["spdlog"],f,o)});return u.setFlushOn(L.LogLevel.Trace),u.createAsyncRotatingLogger(D,T,n,A)}catch(u){console.error(u)}return null}function k(D,T,n,A){const u=J.__$__nodeRequire("spdlog");return u.setFlushOn(L.LogLevel.Trace),u.createRotatingLogger(D,T,n,A)}e.createRotatingLogger=k;function R(D,T,n){switch(T){case L.LogLevel.Trace:D.trace(n);break;case L.LogLevel.Debug:D.debug(n);break;case L.LogLevel.Info:D.info(n);break;case L.LogLevel.Warning:D.warn(n);break;case L.LogLevel.Error:D.error(n);break;case L.LogLevel.Critical:D.critical(n);break;default:throw new Error("Invalid log level")}}class C extends L.AbstractMessageLogger{constructor(T,n,A,u){super();this.name=T,this.filepath=n,this.rotating=A,this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const T=this.rotating?6:1,n=30/T*m.ByteSize.MB;return I(this.name,this.filepath,n,T).then(A=>{if(A){this._logger=A,this._logger.setLevel(this.getLevel());for(const{level:u,message:f}of this.buffer)R(this._logger,u,f);this.buffer=[]}})}log(T,n){this._logger?R(this._logger,T,n):this.getLevel()<=T&&this.buffer.push({level:T,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(me[117],ge([0,1,49,160,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var k;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(k=e.MarkerTag||(e.MarkerTag={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function T(o,v){return v-o}D.compare=T;const n=Object.create(null);n[D.Error]=(0,L.localize)(0,null),n[D.Warning]=(0,L.localize)(1,null),n[D.Info]=(0,L.localize)(2,null);function A(o){return n[o]||""}D.toString=A;function u(o){switch(o){case m.default.Error:return D.Error;case m.default.Warning:return D.Warning;case m.default.Info:return D.Info;case m.default.Ignore:return D.Hint}}D.fromSeverity=u;function f(o){switch(o){case D.Error:return m.default.Error;case D.Warning:return m.default.Warning;case D.Info:return m.default.Info;case D.Hint:return m.default.Ignore}}D.toSeverity=f}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(D){const T="";function n(u){return A(u,!0)}D.makeKey=n;function A(u,f){let o=[T];return u.source?o.push(u.source.replace("\xA6","\\\xA6")):o.push(T),u.code?typeof u.code=="string"?o.push(u.code.replace("\xA6","\\\xA6")):o.push(u.code.value.replace("\xA6","\\\xA6")):o.push(T),u.severity!==void 0&&u.severity!==null?o.push(R.toString(u.severity)):o.push(T),u.message&&f?o.push(u.message.replace("\xA6","\\\xA6")):o.push(T),u.startLineNumber!==void 0&&u.startLineNumber!==null?o.push(u.startLineNumber.toString()):o.push(T),u.startColumn!==void 0&&u.startColumn!==null?o.push(u.startColumn.toString()):o.push(T),u.endLineNumber!==void 0&&u.endLineNumber!==null?o.push(u.endLineNumber.toString()):o.push(T),u.endColumn!==void 0&&u.endColumn!==null?o.push(u.endColumn.toString()):o.push(T),o.push(T),o.join("\xA6")}D.makeKeyOptionalMessage=A})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(me[189],ge([0,1,3,49,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,I.createDecorator)("notificationService");var k;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(k=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new D,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=C;class D{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=D}),define(me[190],ge([0,1,6,9,2,4]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function R(C,D){return I.URI.isUri(C)?(0,L.equalsIgnoreCase)(C.scheme,D):(0,L.startsWithIgnoreCase)(C,D+":")}e.matchesScheme=R}),define(me[191],ge([0,1,10,11,34,22]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const C=L.globals.vscode.context.configuration();if(C)R=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const C=(0,k.dirname)(m.FileAccess.asFileUri("",J));R=J.__$__nodeRequire((0,k.joinPath)(C,"product.json").fsPath);const D=J.__$__nodeRequire((0,k.joinPath)(C,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`}),Object.assign(R,{version:D.version})}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=R});var We=this&&this.__param||function(J,e){return function(m,L){e(m,L,J)}};define(me[118],ge([0,1,18,21,6,4]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,k.createDecorator)("progressService");var R;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(A){this.callback=A}get value(){return this._value}report(A){this._value=A,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let D=class extends I.Disposable{constructor(A,u){super();this.deferred=new m.DeferredPromise,u.withProgress(A,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(A){this.reporter?this.reporter.report(A):this.lastStep=A}};D=Ve([We(1,e.IProgressService)],D),e.UnmanagedProgress=D;class T extends I.Disposable{constructor(A){super();this.progressIndicator=A,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(A){this.stop();const u=++this.currentOperationId,f=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},A),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:f.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(A){this.currentOperationId===A&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,k.createDecorator)("editorProgressService")}),define(me[35],ge([0,1,56,13]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(R,C){m.ok(L.isString(R)),m.ok(L.isObject(C)),m.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,C)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new I}),define(me[119],ge([0,1,3,35]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class k{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,T){this.schemasById[I(D)]=T,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new k;L.Registry.add(e.Extensions.JSONContribution,R)}),define(me[85],ge([0,1,3,13,155,119,35]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const T=R.Registry.as(k.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new m.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new m.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,a=!0){this.registerConfigurations([E],a)}registerConfigurations(E,a=!0){const l=[];E.forEach(p=>{l.push(...this.validateAndRegisterProperties(p,a,p.extensionInfo)),this.configurationContributors.push(p),this.registerJSONConfiguration(p)}),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(E){const a=[],l=p=>{if(p.properties)for(const t in p.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,p.properties[t]);p.allOf&&p.allOf.forEach(t=>l(t))};for(const p of E){l(p);const t=this.configurationContributors.indexOf(p);t!==-1&&this.configurationContributors.splice(t,1)}T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(E){const a=[],l=[];for(const p of E)for(const t in p)if(a.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...p[t]};const s={type:"object",default:this.defaultValues[t],description:I.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};l.push(u(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=p[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(E){const a=[];for(const l of E)for(const p in l)if(a.push(p),delete this.defaultValues[p],e.OVERRIDE_PROPERTY_PATTERN.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const a of E)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,a=!0,l,p=3){p=L.isUndefinedOrNull(E.scope)?p:E.scope;let t=[],s=E.properties;if(s)for(let i in s){if(a&&v(i)){delete s[i];continue}const h=s[i];if(this.updatePropertyDefaultValue(i,h),e.OVERRIDE_PROPERTY_PATTERN.test(i)?h.scope=void 0:(h.scope=L.isUndefinedOrNull(h.scope)?p:h.scope,h.restricted=L.isUndefinedOrNull(h.restricted)?!!l?.restrictedConfigurations?.includes(i):h.restricted),s[i].hasOwnProperty("included")&&!s[i].included){this.excludedConfigurationProperties[i]=s[i],delete s[i];continue}else this.configurationProperties[i]=s[i];!s[i].deprecationMessage&&s[i].markdownDeprecationMessage&&(s[i].deprecationMessage=s[i].markdownDeprecationMessage),t.push(i)}let r=E.allOf;if(r)for(let i of r)t.push(...this.validateAndRegisterProperties(i,a,l,p));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const a=l=>{let p=l.properties;if(p)for(const s in p)this.updateSchema(s,p[s]);let t=l.allOf;t&&t.forEach(a)};a(E)}updateSchema(E,a){switch(e.allSettings.properties[E]=a,a.scope){case 1:e.applicationSettings.properties[E]=a;break;case 2:e.machineSettings.properties[E]=a;break;case 6:e.machineOverridableSettings.properties[E]=a;break;case 3:e.windowSettings.properties[E]=a;break;case 4:e.resourceSettings.properties[E]=a;break;case 5:e.resourceSettings.properties[E]=a,this.resourceLanguageSettingsSchema.properties[E]=a;break}}removeFromSchema(E,a){switch(delete e.allSettings.properties[E],a.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const a=`[${E}]`,l={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,l),e.allSettings.properties[a]=l,e.applicationSettings.properties[a]=l,e.machineSettings.properties[a]=l,e.machineOverridableSettings.properties[a]=l,e.windowSettings.properties[a]=l,e.resourceSettings.properties[a]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,a){let l=this.defaultValues[E];L.isUndefined(l)&&(l=a.default),L.isUndefined(l)&&(l=f(a.type)),a.default=l}}const A="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(A);function u(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=u;function f(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const o=new n;R.Registry.add(e.Extensions.Configuration,o);function v(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?I.localize(5,null,P):o.getConfigurationProperties()[P]!==void 0?I.localize(6,null,P):null:I.localize(4,null)}e.validateProperty=v;function S(){const P=[],E=o.getConfigurationProperties();for(const a of Object.keys(E))P.push([a,E[a].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=S}),define(me[120],ge([0,1,25,13,2,85,4,35]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function D(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof I.URI)}e.isConfigurationOverrides=D;var T;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function A(s,r){const i=r?s?r.keys.filter(_=>s.keys.indexOf(_)===-1):[...r.keys]:[],h=s?r?s.keys.filter(_=>r.keys.indexOf(_)===-1):[...s.keys]:[],c=[];if(r&&s){for(const _ of s.keys)if(r.keys.indexOf(_)!==-1){const w=P(s.contents,_),F=P(r.contents,_);m.equals(w,F)||c.push(_)}}const d=[],b=_=>{const w={};for(const F of _)for(const O of F.identifiers)w[p(O)]=F;return w},y=r?b(r.overrides):{},g=s?b(s.overrides):{};if(Object.keys(y).length)for(const _ of i){const w=y[_];w&&d.push([(0,k.overrideIdentifierFromKey)(_),w.keys])}if(Object.keys(g).length)for(const _ of h){const w=g[_];w&&d.push([(0,k.overrideIdentifierFromKey)(_),w.keys])}if(Object.keys(y).length&&Object.keys(g).length)for(const _ of c){const w=g[_],F=y[_];if(w&&F){const O=A({contents:w.contents,keys:w.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});d.push([(0,k.overrideIdentifierFromKey)(_),[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:h,updated:c,overrides:d}}e.compare=A;function u(s,r){const i=[];for(const h of Object.keys(s))if(k.OVERRIDE_PROPERTY_PATTERN.test(h)){const c={};for(const d in s[h])c[d]=s[h][d];i.push({identifiers:[(0,k.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(c),contents:f(c,r)})}return i}e.toOverrides=u;function f(s,r){const i=Object.create(null);for(let h in s)o(i,h,s[h],r);return i}e.toValuesTree=f;function o(s,r,i,h){const c=r.split("."),d=c.pop();let b=s;for(let y=0;y<c.length;y++){let g=c[y],_=b[g];switch(typeof _){case"undefined":_=b[g]=Object.create(null);break;case"object":break;default:h(`Ignoring ${r} as ${c.slice(0,y+1).join(".")} is ${JSON.stringify(_)}`);return}b=_}if(typeof b=="object"&&b!==null)try{b[d]=i}catch(y){h(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(b)}`)}else h(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=o;function v(s,r){const i=r.split(".");S(s,i)}e.removeFromValueTree=v;function S(s,r){const i=r.shift();if(r.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const h=s[i];typeof h=="object"&&!Array.isArray(h)&&(S(h,r),Object.keys(h).length===0&&delete s[i])}}function P(s,r,i){function h(b,y){let g=b;for(const _ of y){if(typeof g!="object"||g===null)return;g=g[_]}return g}const c=r.split("."),d=h(s,c);return typeof d=="undefined"?i:d}e.getConfigurationValue=P;function E(s,r,i){Object.keys(r).forEach(h=>{h!=="__proto__"&&(h in s?L.isObject(s[h])&&L.isObject(r[h])?E(s[h],r[h],i):i&&(s[h]=r[h]):s[h]=r[h])})}e.merge=E;function a(){const s=C.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=a;function l(){const s=Object.create(null),r=C.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let i in r){let h=r[i].default;o(s,i,h,c=>console.error(`Conflict in default settings: ${c}`))}return s}e.getDefaultValues=l;function p(s){return`[${s}]`}e.keyFromOverrideIdentifier=p;function t(s,r,i){const h=s.inspect(r),c=s.inspect(i);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:h.defaultValue}e.getMigratedSettingValue=t}),define(me[192],ge([0,1,17,3,59,6,24,25,13,2,120,85,35]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,n.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const i of m.distinct([...Object.keys(this.contents),...Object.keys(s)])){let h=this.contents[i],c=s[i];c&&(typeof h=="object"&&typeof c=="object"?(h=C.deepClone(h),this.mergeContents(h,c)):h=c),r[i]=h}return new f(r,this.keys,this.overrides)}merge(...t){const s=C.deepClone(this.contents),r=C.deepClone(this.overrides),i=[...this.keys];for(const h of t){this.mergeContents(s,h.contents);for(const c of h.overrides){const[d]=r.filter(b=>m.equals(b.identifiers,c.identifiers));d?this.mergeContents(d.contents,c.contents):r.push(C.deepClone(c))}for(const c of h.keys)i.indexOf(c)===-1&&i.push(c)}return new f(s,i,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&D.isObject(t[r])&&D.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=C.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,n.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=f;class o extends f{constructor(){const t=(0,n.getDefaultValues)(),s=(0,n.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))A.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,A.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,s,r)}}e.DefaultConfigurationModel=o;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!D.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:i,overrides:h,restricted:c}=this.doParseRaw(t,s);this._configurationModel=new f(r,i,h),this._restrictedConfigurations=c||[]}doParseContent(t){let s={},r=null,i=[],h=[],c=[];function d(y){Array.isArray(i)?i.push(y):r!==null&&(i[r]=y)}let b={onObjectBegin:()=>{let y={};d(y),h.push(i),i=y,r=null},onObjectProperty:y=>{r=y},onObjectEnd:()=>{i=h.pop()},onArrayBegin:()=>{let y=[];d(y),h.push(i),i=y,r=null},onArrayEnd:()=>{i=h.pop()},onLiteralValue:d,onError:(y,g,_)=>{c.push({error:y,offset:g,length:_})}};if(t)try{I.visit(t,b),s=i[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return s}doParseRaw(t,s){const r=u.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,s);t=i.raw;const h=(0,n.toValuesTree)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),c=Object.keys(t),d=(0,n.toOverrides)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:h,keys:c,overrides:d,restricted:i.restricted}}filter(t,s,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const h={},c=[];for(let d in t)if(A.OVERRIDE_PROPERTY_PATTERN.test(d)&&r){const b=this.filter(t[d],s,!1,i);h[d]=b.raw,c.push(...b.restricted)}else{const b=s[d],y=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&c.push(d),(y===void 0||i.scopes===void 0||i.scopes.includes(y))&&(i.skipRestricted&&b?.restricted||(h[d]=t[d]))}return{raw:h,restricted:c}}}e.ConfigurationModelParser=v;class S extends k.Disposable{constructor(t,s,r,i){super();this.userSettingsResource=t,this.scopes=s,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class P{constructor(t,s,r=new f,i=new f,h=new R.ResourceMap,c=new f,d=new R.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=h,this._memoryConfiguration=c,this._memoryConfigurationByResource=d,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new f,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,s===void 0?i.removeValue(t):i.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const i=this.getConsolidateConfigurationModel(s,r),h=this.getFolderConfigurationModelForResource(s.resource,r),c=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,d=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),y=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),g=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),_=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,w=h?s.overrideIdentifier?h.freeze().override(s.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,F=s.overrideIdentifier?c.override(s.overrideIdentifier).getValue(t):c.getValue(t),O=i.getValue(t),G=m.distinct(m.flatten(i.overrides.map(K=>K.identifiers))).filter(K=>i.getOverrideValue(t,K)!==void 0);return{defaultValue:d,userValue:b,userLocalValue:y,userRemoteValue:g,workspaceValue:_,workspaceFolderValue:w,memoryValue:F,value:O,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:y!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:w!==void 0?{value:h?.freeze().getValue(t),override:s.overrideIdentifier?h?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:c.getValue(t),override:s.overrideIdentifier?c.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(i=>A.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const h=(0,A.overrideIdentifierFromKey)(i),c=this._defaultConfiguration.getKeysForOverrideIdentifier(h),d=t.getKeysForOverrideIdentifier(h),b=[...d.filter(y=>c.indexOf(y)===-1),...c.filter(y=>d.indexOf(y)===-1),...c.filter(y=>!C.equals(this._defaultConfiguration.override(h).getValue(y),t.override(h).getValue(y)))];return[h,b]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:h}=(0,n.compare)(this.localUserConfiguration,t),c=[...s,...r,...i];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:h}=(0,n.compare)(this.remoteUserConfiguration,t);let c=[...s,...r,...i];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:i,overrides:h}=(0,n.compare)(this.workspaceConfiguration,t);let c=[...s,...r,...i];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:h}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:i,updated:h,removed:c,overrides:d}=(0,n.compare)(r,s);let b=[...i,...h,...c];return(b.length||!r)&&this.updateFolderConfiguration(t,s),{keys:b,overrides:d}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:h,overrides:c}=(0,n.compare)(s,void 0);return{keys:[...r,...i,...h],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const i=s.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const h=this._memoryConfigurationByResource.get(t);h&&(r=r.merge(h))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(s=r.merge(i),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:i,keys:h}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:i,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((c,d)=>(c.set(T.URI.revive(d[0]),this.parseConfigurationModel(d[1])),c),new R.ResourceMap);return new P(s,r,new f,i,h,new f,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=P;function E(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,s=new Map;for(const i of p)i.keys.forEach(h=>t.add(h)),i.overrides.forEach(([h,c])=>{const d=(0,R.getOrSet)(s,h,new Set);c.forEach(b=>d.add(b))});const r=[];return s.forEach((i,h)=>r.push([h,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=E;class a{constructor(t,s,r,i){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(d=>h.add(d)),t.overrides.forEach(([,d])=>d.forEach(b=>h.add(b))),this.affectedKeys=[...h.values()];const c=new f;this.affectedKeys.forEach(d=>c.setValue(d,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!C.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,n.toValuesTree)({[s]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=a;class l extends a{constructor(t,s,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=l}),define(me[121],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(R,C=L.Unknown,D){super(R);this._message=R,this._code=C,this._detail=D,this.isHandled=C===L.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(R){return R instanceof I&&R._code===L.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof I&&R._code===L.NoResolverFound}static isHandled(R){return R instanceof I&&R.isHandled}}e.RemoteAuthorityResolverError=I}),define(me[86],ge([0,1,10]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(T){return T.scheme===m.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=L;function I(T){if(!T)return;const n=T.indexOf("+");return n<0?T:T.substr(0,n)}e.getRemoteName=I;function k(T){return T.scheme!==m.Schemas.file&&T.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=k;function R(T){if(T.folders.length)return T.folders.every(n=>k(n.uri))?T.folders[0].uri:void 0;if(T.configuration&&k(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=R;function C(T){return R(T)?.scheme}e.getVirtualWorkspaceScheme=C;function D(T){return R(T)!==void 0}e.isVirtualWorkspace=D}),define(me[193],ge([0,1,3,11,4,12]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService");var R;(function(f){f.Http="http",f.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function T(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=T,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=n;function A(f,o){return o?o!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=A;let u=class{constructor(o){this.logService=o,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(o,v){return this._tunnelProvider=o,o?(this._canElevate=v.elevation,this._canMakePublic=v.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async o=>{const v=[],S=Array.from(this._tunnels.values());for(let P of S){const E=Array.from(P.values());for(let a of E){const l=await a.value;l&&v.push(l)}}o(v)})}async dispose(){for(const o of this._tunnels.values()){for(const{value:v}of o.values())await v.then(S=>S?.dispose());o.clear()}this._tunnels.clear()}openTunnel(o,v,S,P,E=!1,a=!1,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${S} on local port ${P}.`),!o)return;v||(v="localhost");const p=this.retainOrCreateTunnel(o,v,S,P,E,a,l);return p?p.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==v||t.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,public:o.public,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const v=this._tunnels.get(o.tunnelRemoteHost);if(v){const S=v.get(o.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,S))}}}}async tryDisposeTunnel(o,v,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${v}.`);const P=S.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(v),P}}async closeTunnel(o,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${v} `);const S=this._tunnels.get(o);if(S&&S.has(v)){const P=S.get(v);P.refcount=0,await this.tryDisposeTunnel(o,v,P)}}addTunnelToMap(o,v,S){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(v,{refcount:1,value:S})}async removeEmptyTunnelFromMap(o,v){const S=this._tunnels.get(o);S&&(await S.get(v)||S.delete(v),S.size===0&&this._tunnels.delete(o))}getTunnelFromMap(o,v){let S=[o];T(o)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):n(o)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const P=S.map(E=>this._tunnels.get(E));for(const E of P){const a=E?.get(v);if(a)return a}}canTunnel(o){return!!D(o)}createWithProvider(o,v,S,P,E,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${S} on local port ${P}.`);const t={elevationRequired:E?A(P===void 0?S:P):!1},s={remoteAddress:{host:v,port:S},localAddressPort:P,public:a,protocol:l},r=o.forwardPort(s,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(v,S,r),r}};u=Ve([We(0,k.ILogService)],u),e.AbstractTunnelService=u}),define(me[194],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((I,k)=>J(["vsda"],I,k))}async sign(I){try{const k=await this.vsda(),R=new k.signer;if(R)return R.sign(I)}catch(k){}return I}}e.SignService=m}),define(me[195],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(o){o.Shell="terminal.integrated.shell.",o.ShellArgs="terminal.integrated.shellArgs.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var I;(function(o){o.ShellLinux="terminal.integrated.shell.linux",o.ShellMacOs="terminal.integrated.shell.osx",o.ShellWindows="terminal.integrated.shell.windows",o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationShellLinux="terminal.integrated.automationShell.linux",o.AutomationShellMacOs="terminal.integrated.automationShell.osx",o.AutomationShellWindows="terminal.integrated.automationShell.windows",o.ShellArgsLinux="terminal.integrated.shellArgs.linux",o.ShellArgsMacOs="terminal.integrated.shellArgs.osx",o.ShellArgsWindows="terminal.integrated.shellArgs.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.TitleMode="terminal.integrated.titleMode",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",o.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",o.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",o.LocalEchoStyle="terminal.integrated.localEchoStyle",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.CustomGlyphs="terminal.integrated.customGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover"})(I=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(o){o.CommandPrompt="cmd",o.PowerShell="pwsh",o.Wsl="wsl",o.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var R;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence"})(R=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.Log="log",o.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,m.createDecorator)("ptyService");var D;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(D=e.HeartbeatConstants||(e.HeartbeatConstants={}));var T;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(T=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(o){o.TerminalView="view",o.Editor="editor"})(n=e.TerminalLocationString||(e.TerminalLocationString={}));var A;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(A=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var f;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(f=e.ProfileSource||(e.ProfileSource={}))}),define(me[196],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,k,R=5){let C;return C=k(D=>{const T=typeof D=="string"?D:D.data;let n=this._terminalBufferMap.get(I);if(n){n.data.push(T);return}const A=setTimeout(()=>this.flushBuffer(I),R);n={data:[T],timeoutId:A,dispose:()=>{clearTimeout(A),this.flushBuffer(I),C.dispose()}},this._terminalBufferMap.set(I,n)}),C}stopBuffering(I){const k=this._terminalBufferMap.get(I);k&&k.dispose()}flushBuffer(I){const k=this._terminalBufferMap.get(I);k&&(this._terminalBufferMap.delete(I),this._callback(I,k.data.join("")))}}e.TerminalDataBufferer=m}),define(me[197],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(me[63],ge([0,1,47,3,6,4,35,197]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var D;(function(S){function P(E){return E&&typeof E=="object"&&typeof E.id=="string"}S.isThemeColor=P})(D=e.ThemeColor||(e.ThemeColor={}));function T(S){return{id:S}}e.themeColorFromId=T;var n;(function(S){function P(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||D.isThemeColor(s.color))}S.isThemeIcon=P;const E=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function a(s){const r=E.exec(s);if(!r)return;let[,i]=r;return{id:i}}S.fromString=a;function l(s,r){let i=s.id;const h=i.lastIndexOf("~");return h!==-1&&(i=i.substring(0,h)),r&&(i=`${i}~${r}`),{id:i}}S.modify=l;function p(s,r){return s.id===r.id&&s.color?.id===r.color?.id}S.isEqual=p;function t(s,r){return{id:s.id,color:r?T(r):void 0}}S.asThemeIcon=t,S.asClassNameArray=m.CSSIcon.asClassNameArray,S.asClassName=m.CSSIcon.asClassName,S.asCSSSelector=m.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function A(S){switch(S){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,I.toDisposable)(()=>{const E=this.themingParticipants.indexOf(P);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new u;R.Registry.add(e.Extensions.ThemingContribution,f);function o(S){return f.onColorThemeChange(S)}e.registerThemingParticipant=o;class v extends I.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,E){let a=this.theme.getColor(P);return a&&E&&(a=E(a,this.theme)),a?a.toString():null}}e.Themable=v}),define(me[198],ge([0,1,18,47,3,161,119,35,63]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(P,E,a,l){const p=this.iconsById[P];if(p){if(a&&!p.description){p.description=a,this.iconSchema.properties[P].markdownDescription=`${a} $(${P})`;const r=this.iconReferenceSchema.enum.indexOf(P);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=a),this._onDidChange.fire()}return p}let t={id:P,description:a,defaults:E,deprecationMessage:l};this.iconsById[P]=t;let s={$ref:"#/definitions/icons"};return l&&(s.deprecationMessage=l),a&&(s.markdownDescription=`${a}: $(${P})`),this.iconSchema.properties[P]=s,this.iconReferenceSchema.enum.push(P),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:P}}deregisterIcon(P){delete this.iconsById[P],delete this.iconSchema.properties[P];const E=this.iconReferenceSchema.enum.indexOf(P);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(P=>this.iconsById[P])}getIcon(P){return this.iconsById[P]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(P,E){const a=this.iconFontsById[P];if(a)return a;let l={id:P,definition:E};return this.iconFontsById[P]=l,this._onDidChange.fire(),l}deregisterIconFont(P){delete this.iconFontsById[P]}getIconFonts(){return Object.keys(this.iconFontsById).map(P=>this.iconFontsById[P])}getIconFont(P){return this.iconFontsById[P]}toString(){const P=(p,t)=>p.id.localeCompare(t.id),E=p=>{for(;D.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of l.filter(t=>!!t.description).sort(P))a.push(`|<i class="${E(p)}"></i>|${p.id}|${D.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const p of l.filter(t=>!D.ThemeIcon.isThemeIcon(t.defaults)).sort(P))a.push(`|<i class="${E(p)}"></i>|${p.id}|`);return a.join(`
`)}}const n=new T;C.Registry.add(e.Extensions.IconContribution,n);function A(S,P,E,a){return n.registerIcon(S,P,E,a)}e.registerIcon=A;function u(){return n}e.getIconRegistry=u;function f(){for(const S of L.iconRegistry.all)n.registerIcon(S.id,S.definition,S.description);L.iconRegistry.onDidRegister(S=>n.registerIcon(S.id,S.definition,S.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let o=C.Registry.as(R.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,n.getIconSchema());const v=new m.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=A("widget-close",L.Codicon.close,(0,k.localize)(2,null)),e.gotoPreviousLocation=A("goto-previous-location",L.Codicon.arrowUp,(0,k.localize)(3,null)),e.gotoNextLocation=A("goto-next-location",L.Codicon.arrowDown,(0,k.localize)(4,null)),e.syncing=D.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(me[43],ge([0,1,24,22,2,4]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var R;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function C(u){const f=u;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=C;function D(u){const f=u;return!!(f&&typeof f=="object"&&I.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=D;class T{constructor(f,o,v,S){this._id=f,this._configuration=v,this._ignorePathCasing=S,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=T;class n{constructor(f,o){this.raw=o,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,L.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function A(u){return new n({uri:u,index:0,name:(0,L.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=A}),define(me[199],ge([0,1,29,59,138,79,10,8,11,22,2,162,4,86,43]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(U){return(typeof U=="string"?(0,C.extname)(U):(0,T.extname)(U))===v}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,u.createDecorator)("workspacesService");function P(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function E(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=E;function a(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=a;function l(U){const W=U;return typeof W?.id=="string"&&n.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=l;function p(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(U){const W=U;return typeof W?.id=="string"&&n.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=t;function s(U){const W=U;if(W?.uri)return{id:W.id,uri:n.URI.revive(W.uri)};const M=U;if(M?.configPath)return{id:M.id,configPath:n.URI.revive(M.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=s;function r(U,W){return T.extUriBiasedIgnorePathCase.isEqualOrParent(U,W.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i(U){return h(U)||c(U)}e.isStoredWorkspaceFolder=i;function h(U){const W=U;return typeof W?.path=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=h;function c(U){const W=U;return typeof W?.uri=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=c;function d(U,W,M,x,B=!D.isWindows,N){if(U.scheme!==x.scheme)return{name:M,uri:U.toString(!0)};let z=W?void 0:N.relativePath(x,U);if(z!==void 0)z.length===0?z=".":D.isWindows&&U.scheme===R.Schemas.file&&!B&&(z=z.replace(/\//g,"\\"));else if(U.scheme===R.Schemas.file)z=U.fsPath,D.isWindows&&(z=(0,k.normalizeDriveLetter)(z),B&&(z=(0,m.toSlashes)(z)));else{if(!N.isEqualAuthority(U.authority,x.authority))return{name:M,uri:U.toString(!0)};z=U.path}return{name:M,path:z}}e.getStoredWorkspaceFolder=d;function b(U,W,M){let x=[],B=new Set;const N=M.dirname(W);for(let z of U){let H;if(h(z))z.path&&(H=M.resolvePath(N,z.path));else if(c(z))try{H=n.URI.parse(z.uri),H.path[0]!=="/"&&(H=H.with({path:"/"+H.path}))}catch(Q){console.warn(Q)}if(H){let Q=M.getComparisonKey(H);if(!B.has(Q)){B.add(Q);const X=z.name||M.basenameOrAuthority(H);x.push(new o.WorkspaceFolder({uri:H,name:X,index:x.length},z))}}}return x}e.toWorkspaceFolders=b;function y(U,W,M,x,B){let N=g(W,U);const z=B.dirname(W),H=B.dirname(x),Q=[],X=_(N.folders);for(const Re of N.folders){const $e=h(Re)?B.resolvePath(z,Re.path):n.URI.parse(Re.uri);let Be;M?Be=!1:Be=!h(Re)||(0,C.isAbsolute)(Re.path),Q.push(d($e,Be,Re.name,H,X,B))}const fe={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},_e=I.setProperty(U,["folders"],Q,fe);let ye=I.applyEdits(U,_e);return N.remoteAuthority===(0,f.getRemoteAuthority)(x)&&(ye=I.applyEdits(ye,I.removeProperty(ye,["remoteAuthority"],fe))),ye}e.rewriteWorkspaceFileForNewLocation=y;function g(U,W){let M=L.parse(W);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(x=>i(x));else throw new Error(`${U} looks like an invalid workspace file.`);return M}function _(U){return D.isWindows?U.some(W=>h(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=_;function w(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function F(U){return typeof U.folderUri=="string"}function O(U){return typeof U.fileUri=="string"}function G(U,W){const M={workspaces:[],files:[]};if(U){const x=function(N,z){for(let H=0;H<N.length;H++)try{z(N[H],H)}catch(Q){W.warn(`Error restoring recent entry ${JSON.stringify(N[H])}: ${Q.toString()}. Skip entry.`)}},B=U;if(Array.isArray(B.entries))x(B.entries,N=>{const z=N.label,H=N.remoteAuthority;w(N)?M.workspaces.push({label:z,remoteAuthority:H,workspace:{id:N.workspace.id,configPath:n.URI.parse(N.workspace.configPath)}}):F(N)?M.workspaces.push({label:z,remoteAuthority:H,folderUri:n.URI.parse(N.folderUri)}):O(N)&&M.files.push({label:z,remoteAuthority:H,fileUri:n.URI.parse(N.fileUri)})});else{const N=U;Array.isArray(N.workspaces3)&&x(N.workspaces3,(z,H)=>{const Q=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[H]||void 0;typeof z=="object"&&typeof z.id=="string"&&typeof z.configURIPath=="string"?M.workspaces.push({label:Q,workspace:{id:z.id,configPath:n.URI.parse(z.configURIPath)}}):typeof z=="string"&&M.workspaces.push({label:Q,folderUri:n.URI.parse(z)})}),Array.isArray(N.files2)&&x(N.files2,(z,H)=>{const Q=Array.isArray(N.fileLabels)&&N.fileLabels[H]||void 0;typeof z=="string"&&M.files.push({label:Q,fileUri:n.URI.parse(z)})})}}return M}e.restoreRecentlyOpened=G;function K(U){const W={entries:[]};for(const M of U.workspaces)E(M)?W.entries.push({folderUri:M.folderUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority}):W.entries.push({workspace:{id:M.workspace.id,configPath:M.workspace.configPath.toString()},label:M.label,remoteAuthority:M.remoteAuthority});for(const M of U.files)W.entries.push({fileUri:M.fileUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority});return W}e.toStoreData=K}),define(me[87],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const k=this._idPool++;return this._data.set(k,I),this.logDebugInfo(),k}get(I,k){return this._data.has(I)?this._data.get(I)[k]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(me[52],ge([0,1,10,22,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(C=>{const D=this._providerInfo.get(C.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(C,D){D===null?this._providerInfo.delete(C):this._providerInfo.set(C,D)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(me[200],ge([0,1,18]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(R,C,D){this._deferredPromises=new Map,this._id=R,this._shared=C,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of T.values())n.complete()}catch(n){for(const A of T.values())A.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,C){let D=this._value[R];return typeof D=="undefined"&&(D=C),D}update(R,C){this._value[R]=C;let D=this._deferredPromises.get(R);if(D!==void 0)return D.p;const T=new m.DeferredPromise;return this._deferredPromises.set(R,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class I extends L{constructor(R,C){super(R.identifier.value,!0,C);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=I}),define(me[201],ge([0,1,3,2,12]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let k=class{constructor(C,D){this._logService=C,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,D,T){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptModelChanged(D.value,T)}$acceptDirtyStateChanged(C,D){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptDirty(D)}$acceptModelSaved(C){const D=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(C,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,D);const T=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));T.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};k=Ve([We(0,I.ILogService)],k),e.ExtHostNotebookDocuments=k}),define(me[14],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class L{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.ExtHostRpcService=L});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[202],ge([0,1,26,3]),function(J,e,m,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class k{constructor(C,D){I.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(C.identifier),nt(this,I,D,"f"),Oe(this,I,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(C){return Oe(this,I,"f").get(this._id,C)}store(C,D){return Oe(this,I,"f").store(this._id,C,D)}delete(C){return Oe(this,I,"f").delete(this._id,C)}}e.ExtensionSecrets=k,I=new WeakMap}),define(me[122],ge([0,1,4,3]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(me[64],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,I=(E,a)=>{const l={controllerId:a};return L.set(E,l),l};e.createPrivateApiFor=I;const k=E=>L.get(E);e.getPrivateApiFor=k;const R=(E,a,l,p)=>{let t=l;return{enumerable:!0,configurable:!1,get(){return t},set(s){if(!p(t,s)){const r=t;t=s,E.listener?.({op:3,key:a,value:s,previous:r})}}}},C=(E,a)=>E===a,D={range:(E,a)=>E===a?!0:!E||!a?!1:E.isEqual(a),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(E,a)=>!(E.length!==a.length||E.some(l=>!a.find(p=>l.id===p.id)))},T=Object.keys(D),n=(E,a)=>({range:R(E,"range",void 0,D.range),label:R(E,"label",a,D.label),description:R(E,"description",void 0,D.description),canResolveChildren:R(E,"canResolveChildren",!1,D.canResolveChildren),busy:R(E,"busy",!1,D.busy),error:R(E,"error",void 0,D.error),tags:R(E,"tags",[],D.tags)}),A=(E,a)=>{const l=new Map;for(const p of T)D[p](E[p],a[p])||l.set(p,a[p]);return l};e.diffTestItems=A;class u extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=u;class f extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class o extends Error{constructor(a,l,p){super(`TestItem with ID "${a}" is from controller "${l}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=o;const v=E=>{const a=(0,e.getPrivateApiFor)(E);let l=new Map;return{get size(){return l.size},forEach(p,t){for(const s of l.values())p.call(t,s,this)},replace(p){const t=new Map,s=new Set(l.keys()),r={op:4,ops:[]};for(const i of p){if(!(i instanceof S))throw new f(i.id);const h=(0,e.getPrivateApiFor)(i).controllerId;if(h!==a.controllerId)throw new o(i.id,h,a.controllerId);if(t.has(i.id))throw new u(i.id);t.set(i.id,i),s.delete(i.id),r.ops.push({op:0,item:i})}for(const i of s.keys())r.ops.push({op:1,id:i});a.listener?.(r),l=t},add(p){if(!(p instanceof S))throw new f(p.id);l.set(p.id,p),a.listener?.({op:0,item:p})},delete(p){l.delete(p)&&a.listener?.({op:1,id:p})},get(p){return l.get(p)},toJSON(){return Array.from(l.values())},[Symbol.iterator](){return l.values()}}};class S{constructor(a,l,p,t){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const s=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof P?void 0:s.parent}},children:{value:v(this),enumerable:!0,writable:!1},...n(s,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=S;class P extends S{constructor(a,l){super(a,a,l,void 0)}}e.TestItemRootImpl=P}),define(me[53],ge([0,1,4,3,14]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var k;(function(C){function D(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}C.fromApiTunnel=D;function T(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}C.fromServiceTunnel=T})(k=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let R=class{constructor(D){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,T){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,T){return{dispose:()=>{}}}async $providePortAttributes(D,T,n,A,u){return[]}async $forwardPort(D,T){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ve([We(0,I.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[7],ge([0,1,17,16,99,24,102,13,2,32,42,121]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";var u,f,o,v,S,P,E,a,l,p,t,s,r,i,h,c,d,b,y,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(j){function $(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf($,j),Object.setPrototypeOf($.prototype,j.prototype),$}let w=S=class{constructor($){u.set(this,void 0),nt(this,u,$,"f")}static from(...$){let se=$;return new S(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}dispose(){typeof Oe(this,u,"f")=="function"&&(Oe(this,u,"f").call(this),nt(this,u,void 0,"f"))}};u=new WeakMap,w=S=Ve([_],w),e.Disposable=w;let F=P=class{constructor($,se){if($<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=$,this._character=se}static Min(...$){if($.length===0)throw new TypeError;let se=$[0];for(let Ce=1;Ce<$.length;Ce++){const et=$[Ce];et.isBefore(se)&&(se=et)}return se}static Max(...$){if($.length===0)throw new TypeError;let se=$[0];for(let Ce=1;Ce<$.length;Ce++){const et=$[Ce];et.isAfter(se)&&(se=et)}return se}static isPosition($){if(!$)return!1;if($ instanceof P)return!0;let{line:se,character:Ce}=$;return typeof se=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,se=0){if($===null||se===null)throw(0,L.illegalArgument)();let Ce;return typeof $=="undefined"?Ce=0:typeof $=="number"?Ce=$:(Ce=typeof $.lineDelta=="number"?$.lineDelta:0,se=typeof $.characterDelta=="number"?$.characterDelta:0),Ce===0&&se===0?this:new P(this.line+Ce,this.character+se)}with($,se=this.character){if($===null||se===null)throw(0,L.illegalArgument)();let Ce;return typeof $=="undefined"?Ce=this.line:typeof $=="number"?Ce=$:(Ce=typeof $.line=="number"?$.line:this.line,se=typeof $.character=="number"?$.character:this.character),Ce===this.line&&se===this.character?this:new P(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};F=P=Ve([_],F),e.Position=F;let O=E=class{constructor($,se,Ce,et){let st,ut;if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"?(st=new F($,se),ut=new F(Ce,et)):$ instanceof F&&se instanceof F&&(st=$,ut=se),!st||!ut)throw new Error("Invalid arguments");st.isBefore(ut)?(this._start=st,this._end=ut):(this._start=ut,this._end=st)}static isRange($){return $ instanceof E?!0:$?F.isPosition($.start)&&F.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof E?this.contains($._start)&&this.contains($._end):$ instanceof F?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const se=F.Max($.start,this._start),Ce=F.Min($.end,this._end);if(!se.isAfter(Ce))return new E(se,Ce)}union($){if(this.contains($))return this;if($.contains(this))return $;const se=F.Min($.start,this._start),Ce=F.Max($.end,this.end);return new E(se,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,se=this.end){if($===null||se===null)throw(0,L.illegalArgument)();let Ce;return $?F.isPosition($)?Ce=$:(Ce=$.start||this.start,se=$.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&se.isEqual(this.end)?this:new E(Ce,se)}toJSON(){return[this.start,this.end]}};O=E=Ve([_],O),e.Range=O;let G=a=class extends O{constructor($,se,Ce,et){let st,ut;if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"?(st=new F($,se),ut=new F(Ce,et)):$ instanceof F&&se instanceof F&&(st=$,ut=se),!st||!ut)throw new Error("Invalid arguments");super(st,ut);this._anchor=st,this._active=ut}static isSelection($){return $ instanceof a?!0:$?O.isRange($)&&F.isPosition($.anchor)&&F.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=a=Ve([_],G),e.Selection=G;class K{constructor($,se,Ce){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,L.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(se),this.connectionToken=Ce}}e.ResolvedAuthority=K;class U extends Error{constructor($,se=A.RemoteAuthorityResolverErrorCode.Unknown,Ce){super($);this._message=$,this._code=se,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable($,se){return new U($,A.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable($){return new U($,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var W;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var M;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(M=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let x=l=class{constructor($,se){this._range=$,this._newText=se}static isTextEdit($){return $ instanceof l?!0:$?O.isRange($)&&typeof $.newText=="string":!1}static replace($,se){return new l($,se)}static insert($,se){return l.replace(new O($,$),se)}static delete($){return l.replace($,"")}static setEndOfLine($){const se=new l(new O(new F(0,0),new F(0,0)),"");return se.newEol=$,se}get range(){return this._range}set range($){if($&&!O.isRange($))throw(0,L.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,L.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,L.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};x=l=Ve([_],x),e.TextEdit=x;var B;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(B=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,se,Ce,et){this._edits.push({_type:1,from:$,to:se,options:Ce,metadata:et})}createFile($,se,Ce){this._edits.push({_type:1,from:void 0,to:$,options:se,metadata:Ce})}deleteFile($,se,Ce){this._edits.push({_type:1,from:$,to:void 0,options:se,metadata:Ce})}replaceNotebookMetadata($,se,Ce){this._edits.push({_type:3,metadata:Ce,uri:$,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells($,se,Ce,et,st){let ut,ht,Dt=[],At;if(zt.isNotebookRange(se)&&Ft.isNotebookCellDataArray(Ce)&&!Ft.isNotebookCellDataArray(et)?(ut=se.start,ht=se.end,Dt=Ce,At=et):typeof se=="number"&&typeof Ce=="number"&&Ft.isNotebookCellDataArray(et)&&(ut=se,ht=Ce,Dt=et,At=st),ut===void 0||ht===void 0)throw new Error("Invalid arguments");(ut!==ht||Dt.length>0)&&this._edits.push({_type:5,uri:$,index:ut,count:ht-ut,cells:Dt,metadata:At})}replaceNotebookCellMetadata($,se,Ce,et){this._edits.push({_type:3,metadata:et,uri:$,edit:{editType:8,index:se,metadata:Ce}})}replace($,se,Ce,et){this._edits.push({_type:2,uri:$,edit:new x(se,Ce),metadata:et})}insert($,se,Ce,et){this.replace($,new O(se,se),Ce,et)}delete($,se,Ce){this.replace($,se,"",Ce)}has($){return this._edits.some(se=>se._type===2&&se.uri.toString()===$.toString())}set($,se){if(se)for(const Ce of se)Ce&&this._edits.push({_type:2,uri:$,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const et=this._edits[Ce];et._type===2&&et.uri.toString()===$.toString()&&(this._edits[Ce]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get($){const se=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===$.toString()&&se.push(Ce.edit);return se}entries(){const $=new k.ResourceMap;for(let se of this._edits)if(se._type===2){let Ce=$.get(se.uri);Ce||(Ce=[se.uri,[]],$.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=Ve([_],N),e.WorkspaceEdit=N;let z=p=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof p?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=p._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,se=this._tabstop++){if(typeof $=="function"){const Ce=new p;Ce._tabstop=this._tabstop,$(Ce),this._tabstop=Ce._tabstop,$=Ce.value}else $=p._escape($);return this.value+="${",this.value+=se,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,se=this._tabstop++){const Ce=$.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable($,se){if(typeof se=="function"){const Ce=new p;Ce._tabstop=this._tabstop,se(Ce),this._tabstop=Ce._tabstop,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,se&&(this.value+=":",this.value+=se),this.value+="}",this}};z=p=Ve([_],z),e.SnippetString=z;var H;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(H=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let X=t=class{constructor($,se){if(this.uri=$,se)if(se instanceof O)this.range=se;else if(se instanceof F)this.range=new O(se,se);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof t?!0:$?O.isRange($.range)&&D.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};X=t=Ve([_],X),e.Location=X;let fe=class{constructor($,se){this.location=$,this.message=se}static is($){return $?typeof $.message=="string"&&$.location&&O.isRange($.location.range)&&D.URI.isUri($.location.uri):!1}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.location.range.isEqual(se.location.range)&&$.location.uri.toString()===se.location.uri.toString()}};fe=Ve([_],fe),e.DiagnosticRelatedInformation=fe;let _e=class{constructor($,se,Ce=Q.Error){if(!O.isRange($))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=$,this.message=se,this.severity=Ce}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.severity===se.severity&&$.code===se.code&&$.severity===se.severity&&$.source===se.source&&$.range.isEqual(se.range)&&(0,m.equals)($.tags,se.tags)&&(0,m.equals)($.relatedInformation,se.relatedInformation,fe.isEqual)}};_e=Ve([_],_e),e.Diagnostic=_e;let ye=class{constructor($,se){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=se}};ye=Ve([_],ye),e.Hover=ye;var Re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Re=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $e=class{constructor($,se=Re.Text){this.range=$,this.kind=se}toJSON(){return{range:this.range,kind:Re[this.kind]}}};$e=Ve([_],$e),e.DocumentHighlight=$e;var Be;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Be=e.SymbolKind||(e.SymbolKind={}));var je;(function(j){j[j.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let V=s=class{constructor($,se,Ce,et,st){this.name=$,this.kind=se,this.containerName=st,typeof Ce=="string"&&(this.containerName=Ce),et instanceof X?this.location=et:Ce instanceof O&&(this.location=new X(et,Ce)),s.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Be[this.kind],location:this.location,containerName:this.containerName}}};V=s=Ve([_],V),e.SymbolInformation=V;let ee=r=class{constructor($,se,Ce,et,st){this.name=$,this.detail=se,this.kind=Ce,this.range=et,this.selectionRange=st,this.children=[],r.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(r.validate)}};ee=r=Ve([_],ee),e.DocumentSymbol=ee;var re;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor($,se){this.title=$,this.kind=se}};ae=Ve([_],ae),e.CodeAction=ae;let Y=i=class{constructor($){this.value=$}append($){return new i(this.value?this.value+i.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+i.sep)}};Y.sep=".",Y=i=Ve([_],Y),e.CodeActionKind=Y,Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll");let oe=class{constructor($,se){if(this.range=$,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=Ve([_],oe),e.SelectionRange=oe;class ve{constructor($,se,Ce,et,st,ut){this.kind=$,this.name=se,this.detail=Ce,this.uri=et,this.range=st,this.selectionRange=ut}}e.CallHierarchyItem=ve;class Me{constructor($,se){this.fromRanges=se,this.from=$}}e.CallHierarchyIncomingCall=Me;class qe{constructor($,se){this.fromRanges=se,this.to=$}}e.CallHierarchyOutgoingCall=qe;var Ke;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ke=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Se=class{constructor($,se){this.range=$,this.command=se}get isResolved(){return!!this.command}};Se=Ve([_],Se),e.CodeLens=Se;let tt=h=class{constructor($,se=!1){f.set(this,void 0),nt(this,f,new I.MarkdownString($,{supportThemeIcons:se}),"f")}static isMarkdownString($){return $ instanceof h?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Oe(this,f,"f").value}set value($){Oe(this,f,"f").value=$}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted($){Oe(this,f,"f").isTrusted=$}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons($){Oe(this,f,"f").supportThemeIcons=$}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml($){Oe(this,f,"f").supportHtml=$}appendText($){return Oe(this,f,"f").appendText($),this}appendMarkdown($){return Oe(this,f,"f").appendMarkdown($),this}appendCodeblock($,se){return Oe(this,f,"f").appendCodeblock(se??"",$),this}};f=new WeakMap,tt=h=Ve([_],tt),e.MarkdownString=tt;let Z=class{constructor($,se){this.label=$,this.documentation=se}};Z=Ve([_],Z),e.ParameterInformation=Z;let te=class{constructor($,se){this.label=$,this.documentation=se,this.parameters=[]}};te=Ve([_],te),e.SignatureInformation=te;let pe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};pe=Ve([_],pe),e.SignatureHelp=pe;var xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Je;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Je=e.InlayHintKind||(e.InlayHintKind={}));let rt=class{constructor($,se,Ce){this.text=$,this.position=se,this.kind=Ce}};rt=Ve([_],rt),e.InlayHint=rt;var ft;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ft=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var pt;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(pt=e.CompletionItemKind||(e.CompletionItemKind={}));var St;(function(j){j[j.Deprecated=1]="Deprecated"})(St=e.CompletionItemTag||(e.CompletionItemTag={}));let Ct=class{constructor($,se){this.label=$,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ct=Ve([_],Ct),e.CompletionItem=Ct;let ue=class{constructor($=[],se=!1){this.items=$,this.isIncomplete=se}};ue=Ve([_],ue),e.CompletionList=ue;let Ie=class{constructor($,se,Ce){this.text=$,this.range=se,this.command=Ce}};Ie=Ve([_],Ie),e.InlineSuggestion=Ie;let Ue=class{constructor($){this.items=$}};Ue=Ve([_],Ue),e.InlineSuggestions=Ue;var Qe;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Qe=e.ViewColumn||(e.ViewColumn={}));var ze;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ze=e.StatusBarAlignment||(e.StatusBarAlignment={}));var at;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Le;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Le=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var De;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(De=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ke;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function $(se){switch(se){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=$}(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor($,se){if(se&&!D.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!O.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.target=se}};be=Ve([_],be),e.DocumentLink=be;let we=class{constructor($,se,Ce,et){this.red=$,this.green=se,this.blue=Ce,this.alpha=et}};we=Ve([_],we),e.Color=we;let Fe=class{constructor($,se){if(se&&!(se instanceof we))throw(0,L.illegalArgument)("color");if(!O.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.color=se}};Fe=Ve([_],Fe),e.ColorInformation=Fe;let Ge=class{constructor($){if(!$||typeof $!="string")throw(0,L.illegalArgument)("label");this.label=$}};Ge=Ve([_],Ge),e.ColorPresentation=Ge;var He;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(He=e.ColorFormat||(e.ColorFormat={}));var Ye;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class it{constructor($,se,Ce){if(this.startIndex=$,this.length=se,this.tooltip=Ce,typeof $!="number"||$<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=it;var le;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(le=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor($){this.options=$,typeof $!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ee;var ce;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var q;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(q=e.TaskPanelKind||(e.TaskPanelKind={}));let Ae=c=class{constructor($,se){if(this.label=se,typeof $!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};Ae.Clean=new c("clean","Clean"),Ae.Build=new c("build","Build"),Ae.Rebuild=new c("rebuild","Rebuild"),Ae.Test=new c("test","Test"),Ae=c=Ve([_],Ae),e.TaskGroup=Ae;function Pe(j){let $="";for(let se=0;se<j.length;se++)$+=j[se].replace(/,/g,",,")+",";return $}let Ze=class{constructor($,se,Ce){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=$,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ce):this._options=se)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let se of this._args)$.push(se);return Pe($)}};Ze=Ve([_],Ze),e.ProcessExecution=Ze;let Xe=class{constructor($,se,Ce){if(this._args=[],Array.isArray(se)){if(!$)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$,this._args=se,this._options=Ce}else{if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$,this._options=se}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)$.push(typeof se=="string"?se:se.value);return Pe($)}};Xe=Ve([_],Xe),e.ShellExecution=Xe;var ot;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ot=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class Et{constructor($){this._callback=$}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=Et;let lt=d=class{constructor($,se,Ce,et,st,ut){this.__deprecated=!1,this._definition=this.definition=$;let ht;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ce,this.execution=et,ht=st,this.__deprecated=!0):se===vt.Global||se===vt.Workspace?(this.target=se,this._name=this.name=Ce,this._source=this.source=et,this.execution=st,ht=ut):(this.target=se,this._name=this.name=Ce,this._source=this.source=et,this.execution=st,ht=ut),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const se=this._definition.type;(d.EmptyType===se||d.ProcessType===se||d.ShellType===se||d.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=d=Ve([_],lt),e.Task=lt;var dt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor($,se=Rt.None){this.collapsibleState=se,D.URI.isUri($)?this.resourceUri=$:this.label=$}};mt=Ve([_],mt),e.TreeItem=mt;var Rt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Rt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor($,se){this.id=$,this.color=se}};yt=Ve([_],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Ot=class{constructor($){this.id=$}};Ot=Ve([_],Ot),e.ThemeColor=Ot;var hn;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(hn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor($,se){if(typeof $!="string"&&(!$||!D.URI.isUri($)&&!D.URI.isUri($.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=D.URI.file($),this.base=$):D.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=se}};It=Ve([_],It),e.RelativePattern=It;let $t=class{constructor($,se,Ce,et){this.enabled=typeof $=="boolean"?$:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};$t=Ve([_],$t),e.Breakpoint=$t;let Zt=class extends $t{constructor($,se,Ce,et,st){super(se,Ce,et,st);if($===null)throw(0,L.illegalArgument)("location");this.location=$}};Zt=Ve([_],Zt),e.SourceBreakpoint=Zt;let wt=class extends $t{constructor($,se,Ce,et,st){super(se,Ce,et,st);this.functionName=$}};wt=Ve([_],wt),e.FunctionBreakpoint=wt;let Kt=class extends $t{constructor($,se,Ce,et,st,ut,ht){super(et,st,ut,ht);if(!se)throw(0,L.illegalArgument)("dataId");this.label=$,this.dataId=se,this.canPersist=Ce}};Kt=Ve([_],Kt),e.DataBreakpoint=Kt;let Vt=class{constructor($,se,Ce){this.command=$,this.args=se||[],this.options=Ce}};Vt=Ve([_],Vt),e.DebugAdapterExecutable=Vt;let en=class{constructor($,se){this.port=$,this.host=se}};en=Ve([_],en),e.DebugAdapterServer=en;let tn=class{constructor($){this.path=$}};tn=Ve([_],tn),e.DebugAdapterNamedPipeServer=tn;let Pt=class{constructor($){this.implementation=$}};Pt=Ve([_],Pt),e.DebugAdapterInlineImplementation=Pt;let Qt=class{constructor($,se){this.range=$,this.expression=se}};Qt=Ve([_],Qt),e.EvaluatableExpression=Qt;var bn;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(bn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor($,se){this.range=$,this.text=se}};Wt=Ve([_],Wt),e.InlineValueText=Wt;let Ht=class{constructor($,se,Ce=!0){this.range=$,this.variableName=se,this.caseSensitiveLookup=Ce}};Ht=Ve([_],Ht),e.InlineValueVariableLookup=Ht;let gt=class{constructor($,se){this.range=$,this.expression=se}};gt=Ve([_],gt),e.InlineValueEvaluatableExpression=gt;let nn=class{constructor($,se){this.frameId=$,this.stoppedLocation=se}};nn=Ve([_],nn),e.InlineValueContext=nn;var Nt;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let Ut=b=class extends Error{constructor($,se=n.FileSystemProviderErrorCode.Unknown,Ce){super(D.URI.isUri($)?$.toString(!0):$);this.code=Ce?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists($){return new b($,n.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound($){return new b($,n.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory($){return new b($,n.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory($){return new b($,n.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions($){return new b($,n.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable($){return new b($,n.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Ut=b=Ve([_],Ut),e.FileSystemError=Ut;let Xt=class{constructor($,se,Ce){this.start=$,this.end=se,this.kind=Ce}};Xt=Ve([_],Xt),e.FoldingRange=Xt;var En;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class mn{constructor($,se=[]){this.tokenTypes=$,this.tokenModifiers=se}}e.SemanticTokensLegend=mn;function rn(j){return typeof j=="undefined"||(0,C.isStringArray)(j)}class sn{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let se=0,Ce=$.tokenTypes.length;se<Ce;se++)this._tokenTypeStrToInt.set($.tokenTypes[se],se);for(let se=0,Ce=$.tokenModifiers.length;se<Ce;se++)this._tokenModifierStrToInt.set($.tokenModifiers[se],se)}}push($,se,Ce,et,st){if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"&&(typeof st=="number"||typeof st=="undefined"))return typeof st=="undefined"&&(st=0),this._pushEncoded($,se,Ce,et,st);if(O.isRange($)&&typeof se=="string"&&rn(Ce))return this._push($,se,Ce);throw(0,L.illegalArgument)()}_push($,se,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const et=$.start.line,st=$.start.character,ut=$.end.character-$.start.character,ht=this._tokenTypeStrToInt.get(se);let Dt=0;if(Ce)for(const At of Ce){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);Dt|=1<<Lt>>>0}this._pushEncoded(et,st,ut,ht,Dt)}_pushEncoded($,se,Ce,et,st){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let At=0,Lt=0;for(let Mt=0;Mt<Dt;Mt++){let Bt=this._data[5*Mt],un=this._data[5*Mt+1];Bt===0?(Bt=At,un+=Lt):Bt+=At,this._data[5*Mt]=Bt,this._data[5*Mt+1]=un,At=Bt,Lt=un}}let ut=$,ht=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=et,this._data[this._dataLen++]=st,this._prevLine=$,this._prevChar=se}static _sortAndDeltaEncode($){let se=[];const Ce=$.length/5|0;for(let ht=0;ht<Ce;ht++)se[ht]=ht;se.sort((ht,Dt)=>{const At=$[5*ht],Lt=$[5*Dt];if(At===Lt){const Mt=$[5*ht+1],Bt=$[5*Dt+1];return Mt-Bt}return At-Lt});const et=new Uint32Array($.length);let st=0,ut=0;for(let ht=0;ht<Ce;ht++){const Dt=5*se[ht],At=$[Dt+0],Lt=$[Dt+1],Mt=$[Dt+2],Bt=$[Dt+3],un=$[Dt+4],Bn=At-st,Gn=Bn===0?Lt-ut:Lt,dn=5*ht;et[dn+0]=Bn,et[dn+1]=Gn,et[dn+2]=Mt,et[dn+3]=Bt,et[dn+4]=un,st=At,ut=Lt}return et}build($){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),$):new jt(sn._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=sn;class jt{constructor($,se){this.resultId=se,this.data=$}}e.SemanticTokens=jt;class on{constructor($,se,Ce){this.start=$,this.deleteCount=se,this.data=Ce}}e.SemanticTokensEdit=on;class Sn{constructor($,se){this.resultId=se,this.edits=$}}e.SemanticTokensEdits=Sn;var yn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var qt;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(qt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new yt("arrow-left")},Jt=Ve([_],Jt),e.QuickInputButtons=Jt;var Dn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor($,se,Ce){this.badge=$,this.tooltip=se,this.color=Ce}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let an=class{constructor($){this.kind=$}};an=Ve([_],an),e.ColorTheme=an;var ln;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(ln=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor($,se){if($<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");$<=se?(this._start=$,this._end=se):(this._start=se,this._end=$)}static isNotebookRange($){return $ instanceof zt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let se=this._start,Ce=this._end;return $.start!==void 0&&(se=$.start),$.end!==void 0&&(Ce=$.end),se===this._start&&Ce===this._end?this:new zt(se,Ce)}}e.NotebookRange=zt;class Ft{constructor($,se,Ce,et,st,ut,ht){this.kind=$,this.value=se,this.languageId=Ce,this.mime=et,this.outputs=st??[],this.metadata=ut,this.executionSummary=ht,Ft.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(se=>Ft.isNotebookCellData(se))}static isNotebookCellData($){return!0}}e.NotebookCellData=Ft;class Ne{constructor($){this.cells=$}}e.NotebookData=Ne;class Tt{constructor($,se){this.data=$,this.mime=se;const Ce=(0,R.normalizeMimeType)(se,!0);if(!Ce)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem($){return $ instanceof Tt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const se={name:$.name,message:$.message,stack:$.stack};return Tt.json(se,"application/vnd.code.notebook.error")}static stdout($){return Tt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Tt.text($,"application/vnd.code.notebook.stderr")}static bytes($,se="application/octet-stream"){return new Tt($,se)}static text($,se=R.Mimes.text){const Ce=Oe(Tt,o,"f",v).encode(String($));return new Tt(Ce,se)}static json($,se="application/json"){const Ce=JSON.stringify($,void 0,"	");return Tt.text(Ce,se)}}e.NotebookCellOutputItem=Tt,o=Tt,v={value:new TextEncoder};class Gt{constructor($,se,Ce){this.items=Gt.ensureUniqueMimeTypes($,!0),typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=(0,T.generateUuid)(),this.metadata=se??Ce)}static isNotebookCellOutput($){return $ instanceof Gt?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,C.isArray)($.items)}static ensureUniqueMimeTypes($,se=!1){const Ce=new Set,et=new Set;for(let st=0;st<$.length;st++){const ut=$[st],ht=(0,R.normalizeMimeType)(ut.mime);if(!Ce.has(ht)){Ce.add(ht);continue}et.add(st),se&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return et.size===0?$:$.filter((st,ut)=>!et.has(ut))}}e.NotebookCellOutput=Gt;var bt;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor($,se){this.text=$,this.alignment=se}}e.NotebookCellStatusBarItem=pn;var Pn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor($,se=[]){this.uri=$,this.provides=(0,m.asArray)(se)}}e.NotebookRendererScript=An;let cn=class{constructor($,se){this.label=$,this.timestamp=se}};cn=Ve([_],cn),e.TimelineItem=cn;var Tn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var vn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(vn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor($,se){this.ranges=$,this.wordPattern=se}}e.LinkedEditingRanges=Ln;class Fn{constructor($,se){this._port=$,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor($,se,Ce){this.include=$,this.exclude=se,this.profile=Ce}};ie=Ve([_],ie),e.TestRunRequest=ie;let he=y=class{constructor($){this.message=$}static diff($,se,Ce){const et=new y($);return et.expectedOutput=se,et.actualOutput=Ce,et}};he=y=Ve([_],he),e.TestMessage=he;let Te=class{constructor($){this.id=$}};Te=Ve([_],Te),e.TestTag=Te;let ct=class{constructor($,se){this.covered=$,this.total=se}};ct=Ve([_],ct),e.CoveredCount=ct;let _t=g=class{constructor($,se,Ce,et){this.uri=$,this.statementCoverage=se,this.branchCoverage=Ce,this.functionCoverage=et}static fromDetails($,se){const Ce=new ct(0,0),et=new ct(0,0),st=new ct(0,0);for(const ht of se)if("branches"in ht){Ce.total+=1,Ce.covered+=ht.executionCount>0?1:0;for(const Dt of ht.branches)et.total+=1,et.covered+=Dt.executionCount>0?1:0}else st.total+=1,st.covered+=ht.executionCount>0?1:0;const ut=new g($,Ce,et.total>0?et:void 0,st.total>0?st:void 0);return ut.detailedCoverage=se,ut}};_t=g=Ve([_],_t),e.FileCoverage=_t;let kt=class{constructor($,se,Ce=[]){this.executionCount=$,this.location=se,this.branches=Ce}};kt=Ve([_],kt),e.StatementCoverage=kt;let Nn=class{constructor($,se){this.executionCount=$,this.location=se}};Nn=Ve([_],Nn),e.BranchCoverage=Nn;let Un=class{constructor($,se){this.executionCount=$,this.location=se}};Un=Ve([_],Un),e.FunctionCoverage=Un;var zn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor($,se,Ce,et,st,ut){this.kind=$,this.name=se,this.detail=Ce,this.uri=et,this.range=st,this.selectionRange=ut}}e.TypeHierarchyItem=qn}),define(me[123],ge([0,1,56,10,9,149,110,7,17]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function n(o,v){v?T.set(o,v):T.delete(o)}e.setWordDefinitionFor=n;function A(o){return T.get(o)}e.getWordDefinitionFor=A;class u extends k.MirrorTextModel{constructor(v,S,P,E,a,l,p,t){super(S,P,E,a);this._proxy=v,this._languageId=l,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,D.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===L.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(S){return S?v._getTextInRange(S):v.getText()},get eol(){return v._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(S){return v._lineAt(S)},offsetAt(S){return v._offsetAt(S)},positionAt(S){return v._positionAt(S)},validateRange(S){return v._validateRange(S)},validatePosition(S){return v._validatePosition(S)},getWordRangeAtPosition(S,P){return v._getWordRangeAtPosition(S,P)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,m.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,m.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const S=this._validateRange(v);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const P=this._eol,E=S.start.line,a=S.end.line,l=[];l.push(this._lines[E].substring(S.start.character));for(let p=E+1;p<a;p++)l.push(this._lines[p]);return l.push(this._lines[a].substring(0,S.end.character)),l.join(P)}_lineAt(v){let S;if(v instanceof C.Position?S=v.line:typeof v=="number"&&(S=v),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new f(S,this._lines[S],S===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(v),P=this._lines[S.index].length;return new C.Position(S.index,Math.min(S.remainder,P))}_validateRange(v){if(!(v instanceof C.Range))throw new Error("Invalid argument");const S=this._validatePosition(v.start),P=this._validatePosition(v.end);return S===v.start&&P===v.end?v:new C.Range(S.line,S.character,P.line,P.character)}_validatePosition(v){if(!(v instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:S,character:P}=v,E=!1;if(S<0)S=0,P=0,E=!0;else if(S>=this._lines.length)S=this._lines.length-1,P=this._lines[S].length,E=!0;else{const a=this._lines[S].length;P<0?(P=0,E=!0):P>a&&(P=a,E=!0)}return E?new C.Position(S,P):v}_getWordRangeAtPosition(v,S){const P=this._validatePosition(v);if(!S)S=A(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const E=(0,R.getWordAtText)(P.character+1,(0,R.ensureValidWordDefinition)(S),this._lines[P.line],0);if(E)return new C.Range(P.line,E.startColumn-1,P.line,E.endColumn-1)}}e.ExtHostDocumentData=u;class f{constructor(v,S,P){this._line=v,this._text=S,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(me[203],ge([0,1,7,3,112,6,81,24,2,32]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(u,f,o,v){this._notebook=o,this._selector=v,this._disposables=new k.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(P=>{const E=this._cellUris.get(P.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(P=>S(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const u=[],f=[];for(const o of this._notebook.getCells())o.kind===m.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),u.push(o.document.getText().length+1),f.push(o.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(u){if(!u){let E="";for(const a of this._cells)E+=a.document.getText()+`
`;return E=E.slice(0,-1),E}if(u.isEmpty)return"";const f=this.locationAt(u.start),o=this.locationAt(u.end),v=this._cellUris.get(f.uri),S=this._cellUris.get(o.uri);if(v===void 0||S===void 0)return"";if(v===S)return this._cells[v].document.getText(new m.Range(f.range.start,o.range.end));const P=[this._cells[v].document.getText(new m.Range(f.range.start,new m.Position(this._cells[v].document.lineCount,0)))];for(let E=v+1;E<S;E++)P.push(this._cells[E].document.getText());return P.push(this._cells[S].document.getText(new m.Range(new m.Position(0,0),o.range.end))),P.join(`
`)}offsetAt(u){const f=this._cellLines.getIndexOf(u.line),o=this._cellLengths.getPrefixSum(f.index-1),v=this._cells[f.index].document.offsetAt(u.with(f.remainder));return o+v}positionAt(u){if(typeof u=="number"){const o=this._cellLengths.getIndexOf(u),v=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(v)}const f=this._cellUris.get(u.uri);if(f!==void 0){const o=this._cellLines.getPrefixSum(f-1);return new m.Position(o+u.range.start.line,u.range.start.character)}return new m.Position(0,0)}locationAt(u){m.Range.isRange(u)||(u=new m.Range(u,u));const f=this._cellLines.getIndexOf(u.start.line);let o=f;u.isEmpty||(o=this._cellLines.getIndexOf(u.end.line));const v=new m.Position(f.remainder,u.start.character),S=new m.Position(o.remainder,u.end.character),P=new m.Range(v,S),E=this._cells[f.index];return new m.Location(E.document.uri,E.document.validateRange(P))}contains(u){return this._cellUris.has(u)}validateRange(u){const f=this.validatePosition(u.start),o=this.validatePosition(u.end);return u.with(f,o)}validatePosition(u){const f=this._cellLines.getIndexOf(u.line),o=new m.Position(f.remainder,u.character),v=this._cells[f.index].document.validatePosition(o),S=this._cellLines.getPrefixSum(f.index-1);return new m.Position(S+v.line,v.character)}}e.ExtHostNotebookConcatDocument=n}),define(me[204],ge([0,1,7,14,3]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let k=class{constructor(C){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let D=C==="light"?m.ColorThemeKind.Light:C==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};k=Ve([We(0,L.IExtHostRpcService)],k),e.ExtHostTheming=k}),define(me[65],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class L{constructor(k){k?(this.transformIncoming=k.transformIncoming.bind(k),this.transformOutgoing=k.transformOutgoing.bind(k),this.transformOutgoingURI=k.transformOutgoingURI.bind(k),this.transformOutgoingScheme=k.transformOutgoingScheme.bind(k)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=L}),define(me[205],ge([0,1,23]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(D){let T=this.buffers.indexOf(D);return T<0&&(T=this.buffers.length,this.buffers.push(D)),T}}function I(C,D){if(D.serializeBuffersForPostMessage){const T=new L,n=(f,o)=>{if(o instanceof ArrayBuffer){const v=T.add(o);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(o)){const v=k(o);if(v){const S=T.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:v,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},A=JSON.stringify(C,n),u=T.buffers.map(f=>{const o=new Uint8Array(f);return m.VSBuffer.wrap(o)});return{message:A,buffers:u}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=I;function k(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(C,D){const T=D.map(u=>{const f=new ArrayBuffer(u.byteLength);return new Uint8Array(f).set(u.buffer),f}),n=D.length?(u,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const o=f,{index:v}=o,S=T[v];if(o.view)switch(o.view.type){case 1:return new Int8Array(S,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return f}:void 0;return{message:JSON.parse(C,n),arrayBuffers:T}}e.deserializeWebviewMessage=R}),define(me[206],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(L){function I(R){const C={items:new Map};return R.types.forEach((D,T)=>{C.items.set(D,{asString:async()=>R.items[T].asString})}),C}L.toITreeDataTransfer=I;async function k(R){const C={types:[],items:[]},D=Array.from(R.items.entries());for(const T of D)C.types.push(T[0]),C.items.push({asString:await T[1].asString()});return C}L.toTreeDataTransferDTO=k})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[88],ge([0,1,10,2]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(C,D){return C.scheme===m.Schemas.http||C.scheme===m.Schemas.https?C:(D&&D.authority&&D.isRemote&&C.scheme===m.Schemas.file&&(C=L.URI.from({scheme:m.Schemas.vscodeRemote,authority:D.authority,path:C.path})),L.URI.from({scheme:m.Schemas.https,authority:`${C.scheme}+${k(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=I;function k(C){return C.replace(/./g,D=>{const T=D.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?D:"-"+T.toString(16).padStart(4,"0")})}function R(C){return C.replace(/-([0-9a-f]{4})/g,(D,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=R}),define(me[207],ge([0,1,3,6,88]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class k{constructor(C,D,T){this._proxy=C,this._editors=D,this._initData=T,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const n=D.getVisibleTextEditors();for(const A of this._insets.values())n.indexOf(A.editor)<0&&A.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,D,T,n,A){let u;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===C){u=a;break}if(!u)throw new Error("not a visible editor");const f=this,o=this._handlePool++,v=new m.Emitter,S=new m.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,I.asWebviewUri)(a,f._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(a){this._options=a,f._proxy.$setOptions(o,a)}get options(){return this._options}set html(a){this._html=a,f._proxy.$setHtml(o,a)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(a){return f._proxy.$postMessage(o,a)}},E=new class{constructor(){this.editor=C,this.line=D,this.height=T,this.webview=P,this.onDidDispose=S.event}dispose(){f._insets.has(o)&&(f._insets.delete(o),f._proxy.$disposeEditorInset(o),S.fire(),S.dispose(),v.dispose())}};return this._proxy.$createEditorInset(o,u.id,u.value.document.uri,D+1,T,n||{},A.identifier,A.extensionLocation),this._insets.set(o,{editor:C,inset:E,onDidReceiveMessage:v}),E}$onDidDispose(C){const D=this._insets.get(C);D&&D.inset.dispose()}$onDidReceiveMessage(C,D){const T=this._insets.get(C);T&&T.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=k}),define(me[208],ge([0,1,171,13,2,6,4,62,35,17,10]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new C.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,m.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(12,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(13,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(14,null)),e.ActiveEditorGroupLockedContext=new C.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(15,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(16,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,m.localize)(17,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,m.localize)(18,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,m.localize)(19,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(20,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,m.localize)(21,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function A(_){if(a(_))return!1;const w=_;return I.URI.isUri(w?.resource)}e.isResourceEditorInput=A;function u(_){if(a(_))return!1;const w=_;return w?.original!==void 0&&w.modified!==void 0}e.isResourceDiffEditorInput=u;function f(_){if(a(_))return!1;const w=_;return w?.primary!==void 0&&w.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function o(_){if(a(_))return!1;const w=_;return w?w.resource===void 0||w.resource.scheme===n.Schemas.untitled||w.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=o;var v;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var S;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var P;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup"})(P=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class E extends k.Disposable{}e.AbstractEditorInput=E;function a(_){return _ instanceof E}e.isEditorInput=a;function l(_){const w=_;return I.URI.isUri(w?.preferredResource)}function p(_){const w=_;return a(w?.primary)&&a(w?.secondary)}e.isSideBySideEditorInput=p;function t(_){const w=_;return a(w?.modified)&&a(w?.original)}e.isDiffEditorInput=t;function s(_){return a(_?.editor)}e.isEditorInputWithOptions=s;function r(_){const w=_;return s(_)&&w?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function i(_){const w=_;return typeof w?.groupId=="number"&&a(w.editor)}e.isEditorIdentifier=i;var h;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(w,F){if(!w)return;if(F?.supportSideBySide){const{primary:G,secondary:K}=this.getSideEditors(w);if(G&&K){if(F?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(G,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:F.filterByScheme})};w=F.supportSideBySide===h.PRIMARY?G:K}}if(u(w)||f(w))return;const O=l(w)?w.preferredResource:w.resource;return!O||!F||!F.filterByScheme?O:this.filterUri(O,F.filterByScheme)}getSideEditors(w){return p(w)||f(w)?{primary:w.primary,secondary:w.secondary}:t(w)||u(w)?{primary:w.modified,secondary:w.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(w,F){if(!w)return;if(F?.supportSideBySide){const{primary:G,secondary:K}=this.getSideEditors(w);if(G&&K){if(F?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(G,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:F.filterByScheme})};w=F.supportSideBySide===h.PRIMARY?G:K}}if(u(w)||f(w))return;const O=w.resource;return!O||!F||!F.filterByScheme?O:this.filterUri(O,F.filterByScheme)}filterUri(w,F){if(Array.isArray(F)){if(F.some(O=>w.scheme===O))return w}else if(F===w.scheme)return w}}e.EditorResourceAccessor=new c;var d;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(d=e.CloseDirection||(e.CloseDirection={}));class b{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(w){const F=this.instantiationService=w.get(R.IInstantiationService);for(const[O,G]of this.editorSerializerConstructors)this.createEditorSerializer(O,G,F);this.editorSerializerConstructors.clear()}createEditorSerializer(w,F,O){const G=O.createInstance(F);this.editorSerializerInstances.set(w,G)}registerFileEditorFactory(w){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=w}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(w,F){if(this.editorSerializerConstructors.has(w)||this.editorSerializerInstances.has(w))throw new Error(`A editor serializer with type ID '${w}' was already registered.`);return this.instantiationService?this.createEditorSerializer(w,F,this.instantiationService):this.editorSerializerConstructors.set(w,F),(0,k.toDisposable)(()=>{this.editorSerializerConstructors.delete(w),this.editorSerializerInstances.delete(w)})}getEditorSerializer(w){return this.editorSerializerInstances.get(typeof w=="string"?w:w.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new b);async function y(_,w){if(!_||!_.length)return[];const F=await Promise.all(_.map(async O=>{const G=I.URI.revive(O.fileUri);if(!G||(await w.activateProvider(G.scheme),!w.canHandleResource(G)))return;const K=typeof O.exists=="boolean"?O.exists:await w.exists(G);if(!K&&O.openOnlyIfExists)return;const U={selection:K?O.selection:void 0,pinned:!0,override:O.editorOverrideId};let W;return K?W={resource:G,options:U}:W={resource:G,options:U,forceUntitled:!0},W}));return(0,T.coalesce)(F)}e.pathsToEditors=y;var g;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(g=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[209],ge([0,1,3,62,172,4,6,24,35,17,57,25,47,198]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",u.Codicon.window,(0,I.localize)(0,null));var o;(function(h){h.ViewContainersRegistry="workbench.registry.view.containers",h.ViewsRegistry="workbench.registry.view"})(o=e.Extensions||(e.Extensions={}));var v;(function(h){h[h.Sidebar=0]="Sidebar",h[h.Panel=1]="Panel"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(h){switch(h){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function P(h){return`viewContainer.${h}.enabled`}e.getEnabledViewContainerContextKey=P;class E extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new m.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new m.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(c,d,b){const y=this.get(c.id);if(y)return y;const g=c;return g.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,C.getOrSet)(this.viewContainers,d,[]).push(g),b?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:d}),g}deregisterViewContainer(c){for(const d of this.viewContainers.keys()){const b=this.viewContainers.get(d),y=b?.indexOf(c);if(y!==-1){b?.splice(y,1),b.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:d});return}}}get(c){return this.all.filter(d=>d.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(b=>b?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===c)}}D.Registry.add(o.ViewContainersRegistry,new E);var a;(function(h){h.Open="2_open",h.Debug="4_debug",h.SCM="5_scm",h.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function l(h,c){const d=h.group??a.More,b=c.group??a.More;return d!==b?d.localeCompare(b):(h.order??5)-(c.order??5)}class p extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new m.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new m.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new m.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new m.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(c,d){this.registerViews2([{views:c,viewContainer:d}])}registerViews2(c){c.forEach(({views:d,viewContainer:b})=>this.addViews(d,b)),this._onViewsRegistered.fire(c)}deregisterViews(c,d){const b=this.removeViews(c,d);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:d})}moveViews(c,d){for(const b of this._views.keys())if(b!==d){const y=this.removeViews(c,b);y.length&&(this.addViews(y,d),this._onDidChangeContainer.fire({views:y,from:b,to:d}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const d of this._viewContainers){const b=(this._views.get(d)||[]).filter(y=>y.id===c)[0];if(b)return b}return null}getViewContainer(c){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(y=>y.id===c)[0])return d;return null}registerViewWelcomeContent(c,d){return this._viewWelcomeContents.add(c,d),this._onDidChangeViewWelcomeContent.fire(c),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(c,d),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,d){const b=new Map;for(const[y,g]of d)this._viewWelcomeContents.add(c,g),b.set(y,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(c,g),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),b}getViewWelcomeContent(c){const d=[];return this._viewWelcomeContents.forEach(c,b=>d.push(b)),d.sort(l)}addViews(c,d){let b=this._views.get(d);b||(b=[],this._views.set(d,b),this._viewContainers.push(d));for(const y of c){if(this.getView(y.id)!==null)throw new Error((0,I.localize)(1,null,y.id));b.push(y)}}removeViews(c,d){const b=this._views.get(d);if(!b)return[];const y=[],g=[];for(const _ of b)c.includes(_)?y.push(_):g.push(_);return y.length&&(g.length?this._views.set(d,g):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),y}}D.Registry.add(o.ViewsRegistry,new p),e.IViewsService=(0,k.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,I.localize)(2,null));function t(h){return`view.${h}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,k.createDecorator)("viewDescriptorService");var s;(function(h){h[h.Default=0]="Default",h[h.Expand=1]="Expand"})(s=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(h){h[h.None=0]="None",h[h.Collapsed=1]="Collapsed",h[h.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,d){this.resolved=!1,this._hasResolve=!1,(0,A.mixin)(this,c),this._hasResolve=!!d,this.resolve=async b=>{if(d&&!this.resolved){const y=await d(b);y&&(this.tooltip=this.tooltip??y.tooltip,this.command=this.command??y.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[124],ge([0,1,3,18,173]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class k{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,D,T,n){const A={command:C};if(D&&Object.keys(D).length>0&&(A.arguments=D),this.internalSend("request",A),typeof n=="number"){const u=setTimeout(()=>{clearTimeout(u);const f=this.pendingRequests.get(A.seq);if(f){this.pendingRequests.delete(A.seq);const o={type:"response",seq:0,request_seq:A.seq,success:!1,command:C,message:(0,I.localize)(0,null,n,C)};f(o)}},n)}return T&&this.pendingRequests.set(A.seq,T),A.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,D){return C.type!=="event"||D.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,L.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const D=C,T=this.pendingRequests.get(D.request_seq);T&&(this.pendingRequests.delete(D.request_seq),T(D));break}}}internalSend(C,D){D.type=C,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((D,T)=>C.set(T,D)),await(0,L.timeout)(500),C.forEach((D,T)=>{D({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=k}),define(me[210],ge([0,1,9,2,8,25,10]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function D(r,i,h){return r.replace(C,function(c,d){return i&&d.length>0&&d[0]!=="_"?c:h&&h.hasOwnProperty(d)?h[d]:c})}e.formatPII=D;function T(r){const i={};for(const h of Object.keys(r))h.startsWith("!")||(i[h]=r[h]);return i}e.filterExceptionsFromTelemetry=T;function n(r){return r.configuration.request==="attach"&&!A(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function A(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(i,"extensionhost")||(0,m.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?A(r.parentSession):void 0}e.getExtensionHostDebugSession=A;function u(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=u;function f(r,i,h){let c,d=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,y=null;for(;y=b.exec(r);){let g=y.index+1,_=g+y[0].length;if(g<=i&&_>=h){c=y[0],d=g;break}}if(c){let g=/\w+/g,_=null;for(;(_=g.exec(c))&&!(_.index+1+d+_[0].length>=h););_&&(c=c.substring(0,g.lastIndex))}return c?{start:d,end:d+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(r){return!!(r&&r.match(o))}e.isUri=v;function S(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(v(r.path))return L.URI.parse(r.path);if((0,I.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function P(r){if(typeof r.path=="object"){const i=L.URI.revive(r.path);if(i)return i.scheme===R.Schemas.file?i.fsPath:i.toString()}return r.path}function E(r,i){const h=i?S:P,c=(0,k.deepClone)(r);return l(c,(d,b)=>{d&&b&&(b.path=h(b))}),c}e.convertToDAPaths=E;function a(r,i){const h=i?S:P,c=(0,k.deepClone)(r);return l(c,(d,b)=>{!d&&b&&(b.path=h(b))}),c}e.convertToVSCPaths=a;function l(r,i){switch(r.type){case"event":const h=r;switch(h.event){case"output":i(!1,h.body.source);break;case"loadedSource":i(!1,h.body.source);break;case"breakpoint":i(!1,h.body.breakpoint.source);break;default:break}break;case"request":const c=r;switch(c.command){case"setBreakpoints":i(!0,c.arguments.source);break;case"breakpointLocations":i(!0,c.arguments.source);break;case"source":i(!0,c.arguments.source);break;case"gotoTargets":i(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(b=>i(!1,b));break;default:break}break;case"response":const d=r;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(b=>i(!1,b.source));break;case"loadedSources":d.body.sources.forEach(b=>i(!1,b));break;case"scopes":d.body.scopes.forEach(b=>i(!1,b.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(b=>i(!1,b.source));break;case"setBreakpoints":d.body.breakpoints.forEach(b=>i(!1,b.source));break;default:break}break}}function p(r){return r.filter(i=>!i.presentation?.hidden).sort((i,h)=>i.presentation?h.presentation?i.presentation.group?h.presentation.group?i.presentation.group!==h.presentation.group?i.presentation.group.localeCompare(h.presentation.group):t(i.presentation.order,h.presentation.order):-1:h.presentation.group?1:t(i.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=p;function t(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function s(r,i){const h=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(h!=="none"&&(await i.saveAll(),h==="allEditorsInActiveGroup")){const c=i.activeEditorPane;c&&await i.save({editor:c.input,groupId:c.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(me[211],ge([0,1,28,39,174,125,8,9,25,11,184,124]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class u extends A.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",l=>this.handleData(l))}sendMessage(E){if(this.outputStream){const a=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${u.TWO_CRLF}${a}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+a))}continue}}else{const a=this.rawData.indexOf(u.TWO_CRLF);if(a!==-1){const p=this.rawData.toString("utf8",0,a).split(u.HEADER_LINESEPARATOR);for(const t of p){const s=t.split(u.HEADER_FIELDSEPARATOR);s[0]==="Content-Length"&&(this.contentLength=Number(s[1]))}this.rawData=this.rawData.slice(a+u.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=u,u.TWO_CRLF=`\r
\r
`,u.HEADER_LINESEPARATOR=/\r?\n/,u.HEADER_FIELDSEPARATOR=/: */;class f extends u{startSession(){return new Promise((E,a)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",p=>{l?this._onError.fire(p):a(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class o extends f{constructor(E){super();this.adapterServer=E}createConnection(E){return k.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=o;class v extends f{constructor(E){super();this.adapterServer=E}createConnection(E){return k.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=v;class S extends u{constructor(E,a,l){super();this.adapterExecutable=E,this.debugType=a,this.outputService=l}async startSession(){const E=this.adapterExecutable.command,a=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(E)if(R.isAbsolute(E)){if(!await m.Promises.exists(E))throw new Error(I.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let p=process.env;if(l.env&&Object.keys(l.env).length>0&&(p=D.mixin(D.deepClone(process.env),l.env)),E==="node")if(Array.isArray(a)&&a.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:p,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(r.cwd=l.cwd);const i=L.fork(a[0],a.slice(1),r);if(!i.pid)throw new Error(I.localize(2,null,a[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const s={env:p};l.cwd&&(s.cwd=l.cwd),this.serverProcess=L.spawn(E,a,s)}this.serverProcess.on("error",s=>{this._onError.fire(s)}),this.serverProcess.on("exit",(s,r)=>{this._onExit.fire(s)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",s=>{this._onError.fire(s)}),this.serverProcess.stdin.on("error",s=>{this._onError.fire(s)});const t=this.outputService;if(t){const s=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(s(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((E,a)=>{const l=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,t,s){if(p)return a(p)});l.on("exit",E),l.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,a){if(!E)return;const l=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?l.runtime=R.join(a,E.runtime):l.runtime=E.runtime),E.runtimeArgs&&(l.runtimeArgs=E.runtimeArgs),E.program&&(R.isAbsolute(E.program)?l.program=E.program:l.program=R.join(a,E.program)),E.args&&(l.args=E.args);const p=E;return p.win&&(l.win=S.extract(p.win,a)),p.winx86&&(l.winx86=S.extract(p.winx86,a)),p.windows&&(l.windows=S.extract(p.windows,a)),p.osx&&(l.osx=S.extract(p.osx,a)),p.linux&&(l.linux=S.extract(p.linux,a)),l}static platformAdapterExecutable(E,a){let l=Object.create(null);a=a.toLowerCase();for(const h of E)if(h.contributes){const c=h.contributes.debuggers;c&&c.length>0&&c.filter(d=>typeof d.type=="string"&&C.equalsIgnoreCase(d.type,a)).forEach(d=>{const b=S.extract(d,h.extensionLocation.fsPath);l=D.mixin(l,b,h.isBuiltin)})}let p;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=l.winx86||l.win||l.windows:T.isWindows?p=l.win||l.windows:T.isMacintosh?p=l.osx:T.isLinux&&(p=l.linux),p=p||l;let t=p.program||l.program;const s=p.args||l.args;let r=p.runtime||l.runtime;const i=p.runtimeArgs||l.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(s||[])};if(t)return{type:"executable",command:t,args:s||[]}}}e.ExecutableDebugAdapter=S}),define(me[212],ge([0,1,39,11,29,187]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function R(u,f){return new Promise((o,v)=>{let S="";const P=m.spawn(u,f);P.pid&&P.stdout.on("data",E=>{S+=E.toString()}),P.on("error",E=>{v(E)}),P.on("close",E=>{o(S)})})}let C;function D(u,f){if(!C)if(L.isWindows)C=new k.WindowsExternalTerminalService;else if(L.isMacintosh)C=new k.MacExternalTerminalService;else if(L.isLinux)C=new k.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const o=f.getConfiguration("terminal");return C.runInTerminal(u.title,u.cwd,u.args,u.env||{},o.external||{})}e.runInExternalTerminal=D;function T(u){return u?L.isWindows?new Promise(async f=>{(await new Promise((v,S)=>{J(["windows-process-tree"],v,S)})).getProcessTree(u,v=>{f(v.children.length>0)})}):R("/usr/bin/pgrep",["-lP",String(u)]).then(f=>{const o=f.trim();return!(o.length===0||o.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=T;var n;(function(u){u[u.cmd=0]="cmd",u[u.powershell=1]="powershell",u[u.bash=2]="bash"})(n||(n={}));function A(u,f,o,v){u=u.trim().toLowerCase();let S;u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0?S=1:u.indexOf("cmd.exe")>=0?S=0:u.indexOf("bash")>=0?S=2:L.isWindows?S=0:S=2;let P,E=" ";switch(S){case 1:if(P=l=>(l=l.replace(/\'/g,"''"),l.length>0&&l.charAt(l.length-1)==="\\"?`'${l}\\'`:`'${l}'`),o){const l=(0,I.getDriveLetter)(o);l&&(E+=`${l}:; `),E+=`cd ${P(o)}; `}if(v)for(let l in v){const p=v[l];p===null?E+=`Remove-Item env:${l}; `:E+=`\${env:${l}}='${p}'; `}if(f.length>0){const l=P(f.shift());E+=l[0]==="'"?`& ${l} `:`${l} `;for(let p of f)E+=`${P(p)} `}break;case 0:if(P=l=>(l=l.replace(/\"/g,'""'),l.indexOf(" ")>=0||l.indexOf('"')>=0||l.length===0?`"${l}"`:l),o){const l=(0,I.getDriveLetter)(o);l&&(E+=`${l}: && `),E+=`cd ${P(o)} && `}if(v){E+='cmd /C "';for(let l in v){let p=v[l];p===null?E+=`set "${l}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${l}=${p}" && `)}}for(let l of f)E+=`${P(l)} `;v&&(E+='"');break;case 2:P=l=>(l=l.replace(/(["'\\\$])/g,"\\$1"),l.indexOf(" ")>=0||l.indexOf(";")>=0||l.length===0?`"${l}"`:l);const a=l=>/[^\w@%\/+=,.:^-]/.test(l)?`'${l.replace(/'/g,"'\\''")}'`:l;if(o&&(E+=`cd ${P(o)} ; `),v){E+="/usr/bin/env";for(let l in v){const p=v[l];p===null?E+=` -u ${a(l)}`:E+=` ${a(`${l}=${p}`)}`}E+=" "}for(let l of f)E+=`${P(l)} `;break}return E}e.prepareCommand=A}),define(me[126],ge([0,1,30,102,10,8,11,62]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(g){g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var A;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(A=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var u;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(u=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeLanguage=5]="ChangeLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var S;(function(g){g.scheme=I.Schemas.vscodeNotebookCell;const _=/^ch(\d{7,})/;function w(U,W){return U.with({scheme:g.scheme,fragment:`ch${W.toString().padStart(7,"0")}${U.scheme!==I.Schemas.file?U.scheme:""}`})}g.generate=w;function F(U){if(U.scheme!==g.scheme)return;const W=_.exec(U.fragment);return W?{handle:Number(W[1]),notebook:U.with({scheme:U.fragment.substr(W[0].length)||I.Schemas.file,fragment:null})}:void 0}g.parse=F;function O(U){if(U.scheme!==I.Schemas.vscodeNotebookCellMetadata)return;const W=_.exec(U.fragment);return W?{handle:Number(W[1]),notebook:U.with({scheme:U.fragment.substr(W[0].length)||I.Schemas.file,fragment:null})}:void 0}g.parseCellMetadataUri=O;function G(U,W,M){return U.with({scheme:M,fragment:`ch${W.toString().padStart(7,"0")}${U.scheme!==I.Schemas.file?U.scheme:""}`})}g.generateCellUri=G;function K(U,W){if(U.scheme!==W)return;const M=_.exec(U.fragment);return M?{handle:Number(M[1]),notebook:U.with({scheme:U.fragment.substr(M[0].length)||I.Schemas.file,fragment:null})}:void 0}g.parseCellUri=K})(S=e.CellUri||(e.CellUri={}));const P=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(g){return P.get(g)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function a(g){return P.get(g)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function l(g){return P.get(g)?.mergeable??!1}e.mimeTypeIsMergeable=l;function p(g,_){return R.isWindows&&(g=g.replace(/\//g,"\\"),_=_.replace(/\//g,"\\")),m.match(g,_)}function t(g,_,w){let F=0;for(let O=0;O<_.length;O++){if(p(_[O],g))return F;F++}for(let O=0;O<w.length;O++){if(p(w[O],g))return F;F++}return F}function s(g,_,w){return g.sort((F,O)=>t(F,_,w)-t(O,_,w))}e.sortMimeTypes=s;function r(g,_,w,F=(O,G)=>O===G){const O=[];function G(W,M,x){if(M===0&&x.length===0)return;const B=O[O.length-1];B&&B.start+B.deleteCount===W?(B.deleteCount+=M,B.toInsert.push(...x)):O.push({start:W,deleteCount:M,toInsert:x})}let K=0,U=0;for(;;){if(K===g.length){G(K,0,_.slice(U));break}if(U===_.length){G(K,g.length-K,[]);break}const W=g[K],M=_[U];if(F(W,M)){K+=1,U+=1;continue}w(M)?(G(K,1,[]),K+=1):(G(K,0,[M]),U+=1)}return O}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(g){g.default="default",g.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(g){const _=g;return!!((typeof _.include=="string"||m.isRelativePattern(_.include))&&(typeof _.exclude=="string"||m.isRelativePattern(_.exclude)))}e.isDocumentExcludePattern=h;function c(g,_,w){if(Array.isArray(g.viewType)&&g.viewType.indexOf(_)>=0||g.viewType===_)return!0;if(g.filenamePattern){let F=h(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,O=h(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(m.match(F,(0,k.basename)(w.fsPath).toLowerCase()))return!(O&&m.match(O,(0,k.basename)(w.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c;class d{constructor(_){this.textModel=_}getElements(){const _=new Int32Array(this.textModel.cells.length);for(let w=0;w<this.textModel.cells.length;w++)_[w]=this.textModel.cells[w].getHashValue();return _}}e.CellSequence=d,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class y{static create(_){return`${y._prefix}${_}`}static parse(_){if(_.startsWith(y._prefix))return _.substr(y._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=y,y._prefix="notebook/"}),define(me[213],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState",I[I.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(me[214],ge([0,1,176,4,62]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[215],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=m;function L(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=L}),define(me[127],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var L;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(A){A[A.Error=0]="Error",A[A.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var k;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(k=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(A,u)=>{u.expand!==void 0&&(A.expand=u.expand),u.item!==void 0&&(A.item=A.item?Object.assign(A.item,u.item):u.item)};e.applyTestItemUpdate=R;var C;(function(A){A[A.Function=0]="Function",A[A.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var D;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.Remove=2]="Remove",A[A.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",A[A.Retire=4]="Retire",A[A.AddTag=5]="AddTag",A[A.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(u){}update(u){}remove(u,f){}complete(){}}e.IncrementalChangeCollector=T;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(u){const f=this.createChangeCollector();for(const o of u)switch(o[0]){case 0:{const v=o[1];if(v.parent){if(this.items.has(v.parent)){const S=this.items.get(v.parent);S.children.add(v.item.extId);const P=this.createItem(v,S);this.items.set(v.item.extId,P),f.add(P)}}else{const S=this.createItem(v);this.roots.add(S),this.items.set(v.item.extId,S),f.add(S)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=o[1],S=this.items.get(v.extId);if(!S)break;v.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,v),f.update(S);break}case 2:{const v=this.items.get(o[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const S=[[o[1]]];for(;S.length;)for(const P of S.pop()){const E=this.items.get(P);E&&(S.push(E.children),this.items.delete(P),f.remove(E,E!==v),E.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}f.complete()}retireTest(u){}updatePendingRoots(u){this.pendingRootCount+=u}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=n}),define(me[89],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(k){k.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class I{constructor(R,C=R.length){if(this.path=R,this.viewEnd=C,R.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,C,D=R.parent){if(R.id===C)return new I([C]);let T=[R.id];for(let n=D;n&&n.id!==C;n=n.parent)T.push(n.id);return T.push(C),new I(T.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new I(R.split("\0"))}static join(R,C){return new I([...R.path,C])}static joinToString(R,C){return R.toString()+"\0"+C}static compare(R,C){return R===C?0:C.startsWith(R+"\0")?2:R.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let C=0;C<R.viewEnd&&C<this.viewEnd;C++)if(R.path[C]!==this.path[C])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=I}),define(me[216],ge([0,1,8,34,13,25,11,79,177]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(A,u,f){this._contributedVariables=new Map,this._context=A,this._labelService=u,f&&(this._envVariablesPromise=f.then(o=>this.prepareEnv(o)))}prepareEnv(A){if(R.isWindows){const u=Object.create(null);return Object.keys(A).forEach(f=>{u[f.toLowerCase()]=A[f]}),u}return A}resolveWithEnvironment(A,u,f){return this.recursiveResolve(this.prepareEnv(A),u?u.uri:void 0,f)}async resolveAsync(A,u){return this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,u)}async resolveAnyBase(A,u,f,o){const v=k.deepClone(u);return R.isWindows&&v.windows?Object.keys(v.windows).forEach(S=>v[S]=v.windows[S]):R.isMacintosh&&v.osx?Object.keys(v.osx).forEach(S=>v[S]=v.osx[S]):R.isLinux&&v.linux&&Object.keys(v.linux).forEach(S=>v[S]=v.linux[S]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,v,f,o)}async resolveAnyAsync(A,u,f){return this.resolveAnyBase(A,u,f)}async resolveAnyMap(A,u,f){const o=new Map;return{newConfig:await this.resolveAnyBase(A,u,f,o),resolvedVariables:o}}resolveWithInteractionReplace(A,u,f,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,u,f,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,u){if(this._contributedVariables.has(A))throw new Error("Variable "+A+" is contributed twice.");this._contributedVariables.set(A,u)}recursiveResolve(A,u,f,o,v){if(I.isString(f))return this.resolveString(A,u,f,o,v);if(I.isArray(f))return f.map(S=>this.recursiveResolve(A,u,S,o,v));if(I.isObject(f)){let S=Object.create(null);return Object.keys(f).forEach(P=>{const E=this.resolveString(A,u,P,o,v);S[E]=this.recursiveResolve(A,u,f[P],o,v)}),S}return f}resolveString(A,u,f,o,v){return f.replace(T.VARIABLE_REGEXP,(P,E)=>{if(E.includes(T.VARIABLE_LHS))return P;let a=this.evaluateSingleVariable(A,P,E,u,o);return v&&v.set(E,a),a!==P&&I.isString(a)&&a.match(T.VARIABLE_REGEXP)&&(a=this.resolveString(A,u,a,o,v)),a})}fsPath(A){return this._labelService?this._labelService.getUriLabel(A,{noPrefix:!0}):A.fsPath}evaluateSingleVariable(A,u,f,o,v){let S;const P=f.split(":");P.length>1&&(f=P[0],S=P[1]);const E=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,D.localize)(0,null,u))},a=()=>{const p=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,u,m.basename(p)))},l=()=>{if(S){const p=this._context.getFolderUri(S);if(p)return p;throw new Error((0,D.localize)(2,null,u,S))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,u)):new Error((0,D.localize)(4,null,u))};switch(f){case"env":if(S){if(A){const p=A[R.isWindows?S.toLowerCase():S];if(I.isString(p))return p}return""}throw new Error((0,D.localize)(5,null,u));case"config":if(S){const p=this._context.getConfigurationValue(o,S);if(I.isUndefinedOrNull(p))throw new Error((0,D.localize)(6,null,u,S));if(I.isObject(p))throw new Error((0,D.localize)(7,null,u,S));return p}throw new Error((0,D.localize)(8,null,u));case"command":return this.resolveFromMap(u,S,v,"command");case"input":return this.resolveFromMap(u,S,v,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return o||S?(0,C.normalizeDriveLetter)(this.fsPath(l())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(l()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,D.localize)(9,null,u));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,u));case"file":return E();case"fileWorkspaceFolder":return a();case"relativeFile":return o||S?m.relative(this.fsPath(l()),E()):E();case"relativeFileDirname":const s=m.dirname(E());if(o||S){const c=m.relative(this.fsPath(l()),s);return c.length===0?".":c}return s;case"fileDirname":return m.dirname(E());case"fileExtname":return m.extname(E());case"fileBasename":return m.basename(E());case"fileBasenameNoExtension":const r=m.basename(E());return r.slice(0,r.length-m.extname(r).length);case"fileDirnameBasename":return m.basename(m.dirname(E()));case"execPath":const i=this._context.getExecPath();return i||u;case"execInstallFolder":const h=this._context.getAppRoot();return h||u;case"pathSeparator":return m.sep;default:try{const c=S?`${f}:${S}`:f;return this.resolveFromMap(u,c,v,void 0)}catch(c){return u}}}}resolveFromMap(A,u,f,o){if(u&&f){const v=o===void 0?f[u]:f[o+":"+u];if(typeof v=="string")return v;throw new Error((0,D.localize)(11,null,A))}return A}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[128],ge([0,1,4,208]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var k;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(k=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var C;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function T(v){const S=v;return(0,L.isEditorInput)(S?.editor)&&(0,L.isEditorInput)(S?.replacement)}e.isEditorReplacement=T;var n;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var A;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.GROUP_LOCKED=2]="GROUP_LOCKED",v[v.EDITOR_OPEN=3]="EDITOR_OPEN",v[v.EDITOR_CLOSE=4]="EDITOR_CLOSE",v[v.EDITOR_MOVE=5]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=7]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=9]="EDITOR_PIN",v[v.EDITOR_STICKY=10]="EDITOR_STICKY",v[v.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(A=e.GroupChangeKind||(e.GroupChangeKind={}));var u;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(u=e.OpenEditorContext||(e.OpenEditorContext={}));function f(v){const S=v;return!!S&&typeof S.id=="number"&&Array.isArray(S.editors)}e.isEditorGroup=f;function o(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=o}),define(me[217],ge([0,1,4,128]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(k){const R=k;return typeof k=="number"||(0,L.isEditorGroup)(R)}e.isPreferredGroup=I}),define(me[15],ge([0,1,17,23,99,292,60,25,13,2,41,83,178,117,64,126,89,217,7]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(le){function Ee(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Pe,positionLineNumber:Ze,positionColumn:Xe}=q,ot=new E.Position(Ae-1,Pe-1),vt=new E.Position(Ze-1,Xe-1);return new E.Selection(ot,vt)}le.to=Ee;function ce(q){const{anchor:Ae,active:Pe}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}le.from=ce})(a=e.Selection||(e.Selection={}));var l;(function(le){function Ee(q){if(!q)return;const{start:Ae,end:Pe}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}le.from=Ee;function ce(q){if(!q)return;const{startLineNumber:Ae,startColumn:Pe,endLineNumber:Ze,endColumn:Xe}=q;return new E.Range(Ae-1,Pe-1,Ze-1,Xe-1)}le.to=ce})(l=e.Range||(e.Range={}));var p;(function(le){function Ee(ce){switch(ce){case 1:return E.StandardTokenType.Comment;case 0:return E.StandardTokenType.Other;case 4:return E.StandardTokenType.RegEx;case 2:return E.StandardTokenType.String}}le.to=Ee})(p=e.TokenType||(e.TokenType={}));var t;(function(le){function Ee(q){return new E.Position(q.lineNumber-1,q.column-1)}le.to=Ee;function ce(q){return{lineNumber:q.line+1,column:q.character+1}}le.from=ce})(t=e.Position||(e.Position={}));var s;(function(le){function Ee(q){switch(q){case E.DiagnosticTag.Unnecessary:return 1;case E.DiagnosticTag.Deprecated:return 2}}le.from=Ee;function ce(q){switch(q){case 1:return E.DiagnosticTag.Unnecessary;case 2:return E.DiagnosticTag.Deprecated;default:return}}le.to=ce})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(le){function Ee(q){let Ae;return q.code&&((0,D.isString)(q.code)||(0,D.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...l.from(q.range),message:q.message,source:q.source,code:Ae,severity:h.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(i.from),tags:Array.isArray(q.tags)?(0,m.coalesce)(q.tags.map(s.from)):void 0}}le.from=Ee;function ce(q){const Ae=new E.Diagnostic(l.to(q),q.message,h.to(q.severity));return Ae.source=q.source,Ae.code=(0,D.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(i.to),Ae.tags=q.tags&&(0,m.coalesce)(q.tags.map(s.to)),Ae}le.to=ce})(r=e.Diagnostic||(e.Diagnostic={}));var i;(function(le){function Ee(q){return{...l.from(q.location.range),message:q.message,resource:q.location.uri}}le.from=Ee;function ce(q){return new E.DiagnosticRelatedInformation(new E.Location(q.resource,l.to(q)),q.message)}le.to=ce})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(le){function Ee(q){switch(q){case E.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}le.from=Ee;function ce(q){switch(q){case f.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}le.to=ce})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(le){function Ee(q){return typeof q=="number"&&q>=E.ViewColumn.One?q-1:q===E.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}le.from=Ee;function ce(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}le.to=ce})(c=e.ViewColumn||(e.ViewColumn={}));function d(le){return typeof le.range!="undefined"}function b(le){return le.length===0?!0:!!d(le[0])}e.isDecorationOptionsArr=b;var y;(function(le){function Ee(Xe){return Xe.map(le.from)}le.fromMany=Ee;function ce(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function q(Xe){let ot;if(ce(Xe)){const{language:dt,value:mt}=Xe;ot={value:"```"+dt+`
`+mt+"\n```\n"}}else E.MarkdownString.isMarkdownString(Xe)?ot={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml}:typeof Xe=="string"?ot={value:Xe}:ot={value:""};const vt=Object.create(null);ot.uris=vt;const Et=dt=>{try{let mt=T.URI.parse(dt,!0);mt=mt.with({query:Ae(mt.query,vt)}),vt[dt]=mt}catch(mt){}return""},lt=new k.Renderer;return lt.link=Et,lt.image=dt=>Et(I.parseHrefAndDimensions(dt).href),k(ot.value,{renderer:lt}),ot}le.from=q;function Ae(Xe,ot){if(!Xe)return Xe;let vt;try{vt=(0,R.parse)(Xe)}catch(lt){}if(!vt)return Xe;let Et=!1;return vt=(0,C.cloneAndChange)(vt,lt=>{if(T.URI.isUri(lt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[dt]=lt,Et=!0,dt}else return}),Et?JSON.stringify(vt):Xe}function Pe(Xe){const ot=new E.MarkdownString(Xe.value,Xe.supportThemeIcons);return ot.isTrusted=Xe.isTrusted,ot.supportHtml=Xe.supportHtml,ot}le.to=Pe;function Ze(Xe){if(!!Xe)return typeof Xe=="string"?Xe:le.from(Xe)}le.fromStrict=Ze})(y=e.MarkdownString||(e.MarkdownString={}));function g(le){return b(le)?le.map(Ee=>({range:l.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?y.fromMany(Ee.hoverMessage):Ee.hoverMessage?y.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):le.map(Ee=>({range:l.from(Ee)}))}e.fromRangeOrRangeWithMessage=g;function _(le){return typeof le=="undefined"?le:typeof le=="string"?T.URI.file(le):le}e.pathOrURIToURI=_;var w;(function(le){function Ee(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?_(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}le.from=Ee})(w=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(le){function Ee(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?_(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?w.from(ce.before):void 0,after:ce.after?w.from(ce.after):void 0}}le.from=Ee})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(le){function Ee(ce){if(typeof ce=="undefined")return ce;switch(ce){case E.DecorationRangeBehavior.OpenOpen:return 0;case E.DecorationRangeBehavior.ClosedClosed:return 1;case E.DecorationRangeBehavior.OpenClosed:return 2;case E.DecorationRangeBehavior.ClosedOpen:return 3}}le.from=Ee})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var G;(function(le){function Ee(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?O.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?F.from(ce.light):void 0,dark:ce.dark?F.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?_(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?w.from(ce.before):void 0,after:ce.after?w.from(ce.after):void 0}}le.from=Ee})(G=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(le){function Ee(q){return{text:q.newText,eol:q.newEol&&pe.from(q.newEol),range:l.from(q.range)}}le.from=Ee;function ce(q){const Ae=new E.TextEdit(l.to(q.range),q.text);return Ae.newEol=typeof q.eol=="undefined"?void 0:pe.to(q.eol),Ae}le.to=ce})(K=e.TextEdit||(e.TextEdit={}));var U;(function(le){function Ee(q,Ae,Pe){const Ze={edits:[]};if(q instanceof E.WorkspaceEdit)for(let Xe of q._allEntries())if(Xe._type===1)Ze.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const ot=Ae?.getDocument(Xe.uri);Ze.edits.push({_type:2,resource:Xe.uri,edit:K.from(Xe.edit),modelVersionId:ot?.version,metadata:Xe.metadata})}else Xe._type===3?Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version}):Xe._type===5&&Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Qe.from)}});return Ze}le.from=Ee;function ce(q){const Ae=new E.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Ae.replace(T.URI.revive(Pe.resource),l.to(Pe.edit.range),Pe.edit.text):Ae.renameFile(T.URI.revive(Pe.oldUri),T.URI.revive(Pe.newUri),Pe.options);return Ae}le.to=ce})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(le){const Ee=Object.create(null);Ee[E.SymbolKind.File]=0,Ee[E.SymbolKind.Module]=1,Ee[E.SymbolKind.Namespace]=2,Ee[E.SymbolKind.Package]=3,Ee[E.SymbolKind.Class]=4,Ee[E.SymbolKind.Method]=5,Ee[E.SymbolKind.Property]=6,Ee[E.SymbolKind.Field]=7,Ee[E.SymbolKind.Constructor]=8,Ee[E.SymbolKind.Enum]=9,Ee[E.SymbolKind.Interface]=10,Ee[E.SymbolKind.Function]=11,Ee[E.SymbolKind.Variable]=12,Ee[E.SymbolKind.Constant]=13,Ee[E.SymbolKind.String]=14,Ee[E.SymbolKind.Number]=15,Ee[E.SymbolKind.Boolean]=16,Ee[E.SymbolKind.Array]=17,Ee[E.SymbolKind.Object]=18,Ee[E.SymbolKind.Key]=19,Ee[E.SymbolKind.Null]=20,Ee[E.SymbolKind.EnumMember]=21,Ee[E.SymbolKind.Struct]=22,Ee[E.SymbolKind.Event]=23,Ee[E.SymbolKind.Operator]=24,Ee[E.SymbolKind.TypeParameter]=25;function ce(Ae){return typeof Ee[Ae]=="number"?Ee[Ae]:6}le.from=ce;function q(Ae){for(const Pe in Ee)if(Ee[Pe]===Ae)return Number(Pe);return E.SymbolKind.Property}le.to=q})(W=e.SymbolKind||(e.SymbolKind={}));var M;(function(le){function Ee(q){switch(q){case E.SymbolTag.Deprecated:return 1}}le.from=Ee;function ce(q){switch(q){case 1:return E.SymbolTag.Deprecated}}le.to=ce})(M=e.SymbolTag||(e.SymbolTag={}));var x;(function(le){function Ee(q){return{name:q.name,kind:W.from(q.kind),tags:q.tags&&q.tags.map(M.from),containerName:q.containerName,location:Q.from(q.location)}}le.from=Ee;function ce(q){const Ae=new E.SymbolInformation(q.name,W.to(q.kind),q.containerName,Q.to(q.location));return Ae.tags=q.tags&&q.tags.map(M.to),Ae}le.to=ce})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var B;(function(le){function Ee(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:l.from(q.range),selectionRange:l.from(q.selectionRange),kind:W.from(q.kind),tags:q.tags?.map(M.from)??[]};return q.children&&(Ae.children=q.children.map(Ee)),Ae}le.from=Ee;function ce(q){const Ae=new E.DocumentSymbol(q.name,q.detail,W.to(q.kind),l.to(q.range),l.to(q.selectionRange));return(0,m.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(M.to)),q.children&&(Ae.children=q.children.map(ce)),Ae}le.to=ce})(B=e.DocumentSymbol||(e.DocumentSymbol={}));var N;(function(le){function Ee(q){const Ae=new E.CallHierarchyItem(W.to(q.kind),q.name,q.detail||"",T.URI.revive(q.uri),l.to(q.range),l.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}le.to=Ee;function ce(q,Ae,Pe){if(Ae=Ae??q._sessionId,Pe=Pe??q._itemId,Ae===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Pe,name:q.name,detail:q.detail,kind:W.from(q.kind),uri:q.uri,range:l.from(q.range),selectionRange:l.from(q.selectionRange),tags:q.tags?.map(M.from)}}le.from=ce})(N=e.CallHierarchyItem||(e.CallHierarchyItem={}));var z;(function(le){function Ee(ce){return new E.CallHierarchyIncomingCall(N.to(ce.from),ce.fromRanges.map(q=>l.to(q)))}le.to=Ee})(z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var H;(function(le){function Ee(ce){return new E.CallHierarchyOutgoingCall(N.to(ce.to),ce.fromRanges.map(q=>l.to(q)))}le.to=Ee})(H=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(le){function Ee(q){return{range:q.range&&l.from(q.range),uri:q.uri}}le.from=Ee;function ce(q){return new E.Location(T.URI.revive(q.uri),l.to(q.range))}le.to=ce})(Q=e.location||(e.location={}));var X;(function(le){function Ee(q){const Ae=q,Pe=q;return{originSelectionRange:Ae.originSelectionRange?l.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Pe.uri,range:l.from(Ae.targetRange?Ae.targetRange:Pe.range),targetSelectionRange:Ae.targetSelectionRange?l.from(Ae.targetSelectionRange):void 0}}le.from=Ee;function ce(q){return{targetUri:T.URI.revive(q.uri),targetRange:l.to(q.range),targetSelectionRange:q.targetSelectionRange?l.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?l.to(q.originSelectionRange):void 0}}le.to=ce})(X=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(le){function Ee(q){return{range:l.from(q.range),contents:y.fromMany(q.contents)}}le.from=Ee;function ce(q){return new E.Hover(q.contents.map(y.to),l.to(q.range))}le.to=ce})(fe=e.Hover||(e.Hover={}));var _e;(function(le){function Ee(q){return{range:l.from(q.range),expression:q.expression}}le.from=Ee;function ce(q){return new E.EvaluatableExpression(l.to(q.range),q.expression)}le.to=ce})(_e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(le){function Ee(q){if(q instanceof E.InlineValueText)return{type:"text",range:l.from(q.range),text:q.text};if(q instanceof E.InlineValueVariableLookup)return{type:"variable",range:l.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}le.from=Ee;function ce(q){switch(q.type){case"text":return{range:l.to(q.range),text:q.text};case"variable":return{range:l.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:l.to(q.range),expression:q.expression}}}le.to=ce})(ye=e.InlineValue||(e.InlineValue={}));var Re;(function(le){function Ee(q){return{frameId:q.frameId,stoppedLocation:l.from(q.stoppedLocation)}}le.from=Ee;function ce(q){return new E.InlineValueContext(q.frameId,l.to(q.stoppedLocation))}le.to=ce})(Re=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(le){function Ee(q){return{range:l.from(q.range),kind:q.kind}}le.from=Ee;function ce(q){return new E.DocumentHighlight(l.to(q.range),q.kind)}le.to=ce})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Be;(function(le){function Ee(ce){switch(ce){case 1:return E.CompletionTriggerKind.TriggerCharacter;case 2:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return E.CompletionTriggerKind.Invoke}}le.to=Ee})(Be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(le){function Ee(ce){return{triggerKind:Be.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}le.to=Ee})(je=e.CompletionContext||(e.CompletionContext={}));var V;(function(le){function Ee(q){switch(q){case E.CompletionItemTag.Deprecated:return 1}}le.from=Ee;function ce(q){switch(q){case 1:return E.CompletionItemTag.Deprecated}}le.to=ce})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(le){const Ee=new Map([[E.CompletionItemKind.Method,0],[E.CompletionItemKind.Function,1],[E.CompletionItemKind.Constructor,2],[E.CompletionItemKind.Field,3],[E.CompletionItemKind.Variable,4],[E.CompletionItemKind.Class,5],[E.CompletionItemKind.Interface,7],[E.CompletionItemKind.Struct,6],[E.CompletionItemKind.Module,8],[E.CompletionItemKind.Property,9],[E.CompletionItemKind.Unit,12],[E.CompletionItemKind.Value,13],[E.CompletionItemKind.Constant,14],[E.CompletionItemKind.Enum,15],[E.CompletionItemKind.EnumMember,16],[E.CompletionItemKind.Keyword,17],[E.CompletionItemKind.Snippet,27],[E.CompletionItemKind.Text,18],[E.CompletionItemKind.Color,19],[E.CompletionItemKind.File,20],[E.CompletionItemKind.Reference,21],[E.CompletionItemKind.Folder,23],[E.CompletionItemKind.Event,10],[E.CompletionItemKind.Operator,11],[E.CompletionItemKind.TypeParameter,24],[E.CompletionItemKind.Issue,26],[E.CompletionItemKind.User,25]]);function ce(Pe){return Ee.get(Pe)??9}le.from=ce;const q=new Map([[0,E.CompletionItemKind.Method],[1,E.CompletionItemKind.Function],[2,E.CompletionItemKind.Constructor],[3,E.CompletionItemKind.Field],[4,E.CompletionItemKind.Variable],[5,E.CompletionItemKind.Class],[7,E.CompletionItemKind.Interface],[6,E.CompletionItemKind.Struct],[8,E.CompletionItemKind.Module],[9,E.CompletionItemKind.Property],[12,E.CompletionItemKind.Unit],[13,E.CompletionItemKind.Value],[14,E.CompletionItemKind.Constant],[15,E.CompletionItemKind.Enum],[16,E.CompletionItemKind.EnumMember],[17,E.CompletionItemKind.Keyword],[27,E.CompletionItemKind.Snippet],[18,E.CompletionItemKind.Text],[19,E.CompletionItemKind.Color],[20,E.CompletionItemKind.File],[21,E.CompletionItemKind.Reference],[23,E.CompletionItemKind.Folder],[10,E.CompletionItemKind.Event],[11,E.CompletionItemKind.Operator],[24,E.CompletionItemKind.TypeParameter],[25,E.CompletionItemKind.User],[26,E.CompletionItemKind.Issue]]);function Ae(Pe){return q.get(Pe)??E.CompletionItemKind.Property}le.to=Ae})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(le){function Ee(ce,q){const Ae=new E.CompletionItem(ce.label);return Ae.insertText=ce.insertText,Ae.kind=ee.to(ce.kind),Ae.tags=ce.tags?.map(V.to),Ae.detail=ce.detail,Ae.documentation=I.isMarkdownString(ce.documentation)?y.to(ce.documentation):ce.documentation,Ae.sortText=ce.sortText,Ae.filterText=ce.filterText,Ae.preselect=ce.preselect,Ae.commitCharacters=ce.commitCharacters,n.Range.isIRange(ce.range)?Ae.range=l.to(ce.range):typeof ce.range=="object"&&(Ae.range={inserting:l.to(ce.range.insert),replacing:l.to(ce.range.replace)}),Ae.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Ae.insertText=new E.SnippetString(ce.insertText):(Ae.insertText=ce.insertText,Ae.textEdit=Ae.range instanceof E.Range?new E.TextEdit(Ae.range,Ae.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ce.additionalTextEdits.map(Pe=>K.to(Pe))),Ae.command=q&&ce.command?q.fromInternal(ce.command):void 0,Ae}le.to=Ee})(re=e.CompletionItem||(e.CompletionItem={}));var ae;(function(le){function Ee(q){return{label:q.label,documentation:q.documentation?y.fromStrict(q.documentation):void 0}}le.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?y.to(q.documentation):q.documentation}}le.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var Y;(function(le){function Ee(q){return{label:q.label,documentation:q.documentation?y.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(ae.from):[],activeParameter:q.activeParameter}}le.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?y.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(ae.to):[],activeParameter:q.activeParameter}}le.to=ce})(Y=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(le){function Ee(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Y.from):[]}}le.from=Ee;function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Y.to):[]}}le.to=ce})(oe=e.SignatureHelp||(e.SignatureHelp={}));var ve;(function(le){function Ee(q){return{text:q.text,position:t.from(q.position),kind:Me.from(q.kind??E.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}le.from=Ee;function ce(q){const Ae=new E.InlayHint(q.text,t.to(q.position),Me.to(q.kind));return Ae.whitespaceAfter=q.whitespaceAfter,Ae.whitespaceBefore=q.whitespaceBefore,Ae}le.to=ce})(ve=e.InlayHint||(e.InlayHint={}));var Me;(function(le){function Ee(q){return q}le.from=Ee;function ce(q){return q}le.to=ce})(Me=e.InlayHintKind||(e.InlayHintKind={}));var qe;(function(le){function Ee(q){return{range:l.from(q.range),url:q.target,tooltip:q.tooltip}}le.from=Ee;function ce(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?T.URI.parse(q.url,!0):T.URI.revive(q.url)}catch(Pe){}return new E.DocumentLink(l.to(q.range),Ae)}le.to=ce})(qe=e.DocumentLink||(e.DocumentLink={}));var Ke;(function(le){function Ee(q){const Ae=new E.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=K.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Pe=>K.to(Pe))),Ae}le.to=Ee;function ce(q){return{label:q.label,textEdit:q.textEdit?K.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>K.from(Ae)):void 0}}le.from=ce})(Ke=e.ColorPresentation||(e.ColorPresentation={}));var Se;(function(le){function Ee(q){return new E.Color(q[0],q[1],q[2],q[3])}le.to=Ee;function ce(q){return[q.red,q.green,q.blue,q.alpha]}le.from=ce})(Se=e.Color||(e.Color={}));var tt;(function(le){function Ee(q){return{range:l.from(q.range)}}le.from=Ee;function ce(q){return new E.SelectionRange(l.to(q.range))}le.to=ce})(tt=e.SelectionRange||(e.SelectionRange={}));var Z;(function(le){function Ee(ce){switch(ce){case 2:return E.TextDocumentSaveReason.AfterDelay;case 1:return E.TextDocumentSaveReason.Manual;case 3:case 4:return E.TextDocumentSaveReason.FocusOut}}le.to=Ee})(Z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var te;(function(le){function Ee(q){switch(q){case E.TextEditorLineNumbersStyle.Off:return 0;case E.TextEditorLineNumbersStyle.Relative:return 2;case E.TextEditorLineNumbersStyle.On:default:return 1}}le.from=Ee;function ce(q){switch(q){case 0:return E.TextEditorLineNumbersStyle.Off;case 2:return E.TextEditorLineNumbersStyle.Relative;case 1:default:return E.TextEditorLineNumbersStyle.On}}le.to=ce})(te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pe;(function(le){function Ee(q){if(q===E.EndOfLine.CRLF)return 1;if(q===E.EndOfLine.LF)return 0}le.from=Ee;function ce(q){if(q===1)return E.EndOfLine.CRLF;if(q===0)return E.EndOfLine.LF}le.to=ce})(pe=e.EndOfLine||(e.EndOfLine={}));var xe;(function(le){function Ee(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case E.ProgressLocation.SourceControl:return 3;case E.ProgressLocation.Window:return 10;case E.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}le.from=Ee})(xe=e.ProgressLocation||(e.ProgressLocation={}));var Je;(function(le){function Ee(ce){const q={start:ce.start+1,end:ce.end+1};return ce.kind&&(q.kind=rt.from(ce.kind)),q}le.from=Ee})(Je=e.FoldingRange||(e.FoldingRange={}));var rt;(function(le){function Ee(ce){if(ce)switch(ce){case E.FoldingRangeKind.Comment:return A.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return A.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return A.FoldingRangeKind.Region}}le.from=Ee})(rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ft;(function(le){function Ee(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?l.from(ce.selection):void 0,override:typeof ce.override=="boolean"?u.EditorResolution.DISABLED:void 0}}le.from=Ee})(ft=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var pt;(function(le){function Ee(q){return q instanceof E.RelativePattern||typeof q=="string"?q:ce(q)?new E.RelativePattern(q.base,q.pattern):q}le.from=Ee;function ce(q){const Ae=q;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(pt=e.GlobPattern||(e.GlobPattern={}));var St;(function(le){function Ee(ce){if(ce){if(Array.isArray(ce))return ce.map(Ee);if(typeof ce=="string")return ce;{const q=ce;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:pt.from(q.pattern),exclusive:q.exclusive}}}else return}le.from=Ee})(St=e.LanguageSelector||(e.LanguageSelector={}));var Ct;(function(le){function Ee(q){return{start:q.start,end:q.end}}le.from=Ee;function ce(q){return new E.NotebookRange(q.start,q.end)}le.to=ce})(Ct=e.NotebookRange||(e.NotebookRange={}));var ue;(function(le){function Ee(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}le.to=Ee;function ce(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}le.from=ce})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ie;(function(le){function Ee(q){switch(q){case E.NotebookCellKind.Markup:return v.CellKind.Markup;case E.NotebookCellKind.Code:default:return v.CellKind.Code}}le.from=Ee;function ce(q){switch(q){case v.CellKind.Markup:return E.NotebookCellKind.Markup;case v.CellKind.Code:default:return E.NotebookCellKind.Code}}le.to=ce})(Ie=e.NotebookCellKind||(e.NotebookCellKind={}));var Ue;(function(le){function Ee(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(let Pe of q.cells)E.NotebookCellData.validate(Pe),Ae.cells.push(Qe.from(Pe));return Ae}le.from=Ee;function ce(q){const Ae=new E.NotebookData(q.cells.map(Qe.to));return(0,D.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}le.to=ce})(Ue=e.NotebookData||(e.NotebookData={}));var Qe;(function(le){function Ee(q){return{cellKind:Ie.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:ue.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(at.from):[]}}le.from=Ee;function ce(q){return new E.NotebookCellData(Ie.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(at.to):void 0,q.metadata,q.internalMetadata?ue.to(q.internalMetadata):void 0)}le.to=ce})(Qe=e.NotebookCellData||(e.NotebookCellData={}));var ze;(function(le){function Ee(q){return{mime:q.mime,valueBytes:L.VSBuffer.wrap(q.data)}}le.from=Ee;function ce(q){return new E.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}le.to=ce})(ze=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(le){function Ee(q){return{outputId:q.id,items:q.items.map(ze.from),metadata:q.metadata}}le.from=Ee;function ce(q){const Ae=q.items.map(ze.to);return new E.NotebookCellOutput(Ae,q.outputId,q.metadata)}le.to=ce})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Le;(function(le){function Ee(Pe){if(Pe!=null){if(Pe instanceof E.RelativePattern||typeof Pe=="string")return Pe;if(Ae(Pe))return new E.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:pt.from(Pe.include)||void 0,exclude:pt.from(Pe.exclude)||void 0}}}le.from=Ee;function ce(Pe){return typeof Pe=="string"?Pe:Ae(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}le.to=ce;function q(Pe){const Ze=Pe,Xe=pt.from(Ze.include);if(!(Xe&&Xe instanceof E.RelativePattern||typeof Xe=="string"))return!1;const ot=pt.from(Ze.exclude);return!!(ot&&ot instanceof E.RelativePattern||typeof ot=="string")}function Ae(Pe){const Ze=Pe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Le=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(le){function Ee(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?w.from(ce.top):void 0}}le.from=Ee})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ke;(function(le){function Ee(ce,q,Ae){const Pe=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===E.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Pe,Ae),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}le.from=Ee})(ke=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ne;(function(le){function Ee(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}le.from=Ee})(ne=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(le){function Ee(q){return{uri:q.uri,provides:q.provides}}le.from=Ee;function ce(q){return new E.NotebookRendererScript(T.URI.revive(q.uri),q.provides)}le.to=ce})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var be;(function(le){function Ee(q){return{message:y.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location?Q.from(q.location):void 0}}le.from=Ee;function ce(q){const Ae=new E.TestMessage(typeof q.message=="string"?q.message:y.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?Q.to(q.location):void 0,Ae}le.to=ce})(be=e.TestMessage||(e.TestMessage={}));var we;(function(le){let Ee;(function(ce){ce.Delimiter="\0"})(Ee||(Ee={})),le.namespace=(ce,q)=>ce+"\0"+q,le.denamespace=ce=>{const q=ce.indexOf("\0");return{ctrlId:ce.slice(0,q),tagId:ce.slice(q+1)}}})(we=e.TestTag||(e.TestTag={}));var Fe;(function(le){function Ee(Pe){const Ze=(0,o.getPrivateApiFor)(Pe).controllerId;return{extId:S.TestId.fromExtHostTestItem(Pe,Ze).toString(),label:Pe.label,uri:Pe.uri,tags:Pe.tags.map(Xe=>we.namespace(Ze,Xe.id)),range:l.from(Pe.range)||null,description:Pe.description||null,error:Pe.error&&y.fromStrict(Pe.error)||null}}le.from=Ee;function ce(Pe){return{id:S.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:T.URI.revive(Pe.uri),tags:(Pe.tags||[]).map(Ze=>{const{tagId:Xe}=we.denamespace(Ze);return new E.TestTag(Xe)}),range:l.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0}}le.toPlain=ce;function q(Pe){const Ze=S.TestId.fromString(Pe.extId),Xe=new o.TestItemImpl(Ze.controllerId,Ze.localId,Pe.label,T.URI.revive(Pe.uri));return Xe.range=l.to(Pe.range||void 0),Xe.description=Pe.description||void 0,Xe}function Ae(Pe){let Ze;for(const Xe of Pe.tests){const ot=q(Xe.item);(0,o.getPrivateApiFor)(ot).parent=Ze,Ze=ot}return Ze}le.toItemFromContext=Ae})(Fe=e.TestItem||(e.TestItem={})),function(le){function Ee(q){return{id:q.id}}le.from=Ee;function ce(q){return new E.TestTag(q.id)}le.to=ce}(we=e.TestTag||(e.TestTag={}));var Ge;(function(le){const Ee=(q,Ae)=>{const Pe={...Fe.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(Xe=>Xe.type===0).map(be.to)})),children:q.children.map(Ze=>Ae.get(Ze)).filter(D.isDefined).map(Ze=>Ee(Ze,Ae))};for(const Ze of Pe.children)Ze.parent=Pe;return Pe};function ce(q){const Ae=[],Pe=new Map;for(const Ze of q.items)Pe.set(Ze.item.extId,Ze),q.request.targets.some(Xe=>Xe.controllerId===Ze.controllerId&&Xe.testIds.includes(Ze.item.extId))&&Ae.push(Ze);return{completedAt:q.completedAt,results:Ae.map(Ze=>Ee(Ze,Pe))}}le.to=ce})(Ge=e.TestResults||(e.TestResults={}));var He;(function(le){function Ee(Pe){return{covered:Pe.covered,total:Pe.covered}}function ce(Pe){return"line"in Pe?t.from(Pe):l.from(Pe)}function q(Pe){return"branches"in Pe?{count:Pe.executionCount,location:ce(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ce(Ze.location)})):void 0}:{type:0,count:Pe.executionCount,location:ce(Pe.location)}}le.fromDetailed=q;function Ae(Pe){return{uri:Pe.uri,statement:Ee(Pe.statementCoverage),branch:Pe.branchCoverage&&Ee(Pe.branchCoverage),function:Pe.functionCoverage&&Ee(Pe.functionCoverage),details:Pe.detailedCoverage?.map(q)}}le.fromFile=Ae})(He=e.TestCoverage||(e.TestCoverage={}));var Ye;(function(le){function Ee(ce){switch(ce){case 1:return E.CodeActionTriggerKind.Invoke;case 2:return E.CodeActionTriggerKind.Automatic}}le.to=Ee})(Ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var it;(function(le){function Ee(q){const Ae=new E.TypeHierarchyItem(W.to(q.kind),q.name,q.detail||"",T.URI.revive(q.uri),l.to(q.range),l.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}le.to=Ee;function ce(q,Ae,Pe){if(Ae=Ae??q._sessionId,Pe=Pe??q._itemId,Ae===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Pe,kind:W.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:l.from(q.range),selectionRange:l.from(q.selectionRange),tags:q.tags?.map(M.from)}}le.from=ce})(it=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[218],ge([0,1,2,16,7,15,95]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(T,n,A,u={timeout:1500,errors:3}){this._logService=T,this._documents=n,this._mainThreadBulkEdits=A,this._thresholds=u,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(n,A,u)=>{const o={dispose:this._callbacks.push([n,A,T])};return Array.isArray(u)&&u.push(o),o}}async $participateInSave(T,n){const A=m.URI.revive(T);let u=!1;const f=setTimeout(()=>u=!0,this._thresholds.timeout),o=[];try{for(let v of[...this._callbacks]){if(u)break;const S=this._documents.getDocument(A),P=await this._deliverEventAsyncAndBlameBadListeners(v,{document:S,reason:k.TextDocumentSaveReason.to(n)});o.push(P)}}finally{clearTimeout(f)}return o}_deliverEventAsyncAndBlameBadListeners([T,n,A],u){const f=this._badListeners.get(T);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(A,T,n,u).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const v=this._badListeners.get(T);this._badListeners.set(T,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,n,A,u){const f=[],o=Date.now(),{document:v,reason:S}=u,{version:P}=v,E=Object.freeze({document:v,reason:S,waitUntil(a){if(Object.isFrozen(f))throw(0,L.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(a))}});try{n.apply(A,[E])}catch(a){return Promise.reject(a)}return Object.freeze(f),new Promise((a,l)=>{const p=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(p),a(t)}).catch(t=>{clearTimeout(p),l(t)})}).then(a=>{const l={edits:[]};for(const p of a)if(Array.isArray(p)&&p.every(t=>t instanceof I.TextEdit))for(const{newText:t,newEol:s,range:r}of p)l.edits.push({_type:2,resource:v.uri,edit:{range:r&&k.Range.from(r),text:t,eol:s&&k.EndOfLine.from(s)}});if(l.edits.length!==0)return P===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(me[54],ge([0,1,15,2,3,4]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class R{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new I.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(D){let T=-1;this._tabs=D.map((A,u)=>{A.isActive&&(T=u);let f;if(A.resource){const o=A.resource;o.primary||o.secondary?f={primary:L.URI.revive(o.primary),secondary:L.URI.revive(o.secondary)}:f=L.URI.revive(A.resource)}return Object.freeze({label:A.label,viewColumn:m.ViewColumn.to(A.viewColumn),resource:f,editorId:A.editorId,isActive:A.isActive})});const n=this._activeTab;this._activeTab=T===-1?void 0:this._tabs[T],this._activeTab!==n&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=R}),define(me[219],ge([0,1,3,30,2,15,7]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(n,A,u,f,o){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,u&&(this._config+=1),f&&(this._config+=2),o&&(this._config+=4);const v=(0,L.parse)(A),S=n(P=>{if(!u)for(let E of P.created){const a=I.URI.revive(E);v(a.fsPath)&&this._onDidCreate.fire(a)}if(!f)for(let E of P.changed){const a=I.URI.revive(E);v(a.fsPath)&&this._onDidChange.fire(a)}if(!o)for(let E of P.deleted){const a=I.URI.revive(E);v(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,S)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(n,A,u){this._logService=A,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,A,u,f){return new C(this._onFileSystemEvent.event,n,A,u,f)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,A){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:A.map(u=>({oldUri:I.URI.revive(u.source),newUri:I.URI.revive(u.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:A.map(u=>I.URI.revive(u.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:A.map(u=>I.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,A){return(u,f,o)=>{const v=function(P){u.call(f,P)};return v.extension=n,A.event(v,void 0,o)}}async $onWillRunFileOperation(n,A,u,f){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:A.map(o=>({oldUri:I.URI.revive(o.source),newUri:I.URI.revive(o.target)}))},u,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:A.map(o=>I.URI.revive(o.target))},u,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:A.map(o=>I.URI.revive(o.target))},u,f)}}async _fireWillEvent(n,A,u,f){const o=new Set,v=[];if(await n.fireAsync(A,f,async(P,E)=>{const a=Date.now(),l=await Promise.resolve(P);l instanceof R.WorkspaceEdit&&(v.push(l),o.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-a>u&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||v.length===0)return;const S={edits:[]};for(let P of v){let{edits:E}=k.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);S.edits=S.edits.concat(E)}return{edit:S,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=D}),define(me[220],ge([0,1,10,25,2,15,7,126]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(u,f,o,v){this.start=u,this.deletedCount=f,this.deletedItems=o,this.items=v}static asApiEvents(u){return u.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(o=>o.apiCell)}))}}class T{constructor(u,f,o){this.notebook=u,this._extHostDocument=f,this._cellData=o,this.handle=o.handle,this.uri=I.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(k.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(u,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:u}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const u=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return u.notebook.getCellIndex(u)},notebook:u.notebook.apiNotebook,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return u._mime},set mime(o){u._mime=o},get outputs(){return u._outputs.slice(0)},get metadata(){return u._metadata},get executionSummary(){return u._previousResult}})}return this._apiCell}setOutputs(u){this._outputs=u.map(k.NotebookCellOutput.to)}setOutputItems(u,f,o){const v=o.map(k.NotebookCellOutputItem.to),S=this._outputs.find(P=>P.id===u);S&&(f||(S.items.length=0),S.items.push(...v))}setMetadata(u){this._metadata=Object.freeze(u)}setInternalMetadata(u){this._internalMetadata=u,this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(u))}setMime(u){}}e.ExtHostCell=T;class n{constructor(u,f,o,v,S,P){this._proxy=u,this._textDocumentsAndEditors=f,this._textDocuments=o,this._emitter=v,this.uri=S,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=P.viewType,this._metadata=Object.freeze(P.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,P.cells]],!0),this._versionId=P.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const u=this;this._notebook={get uri(){return u.uri},get version(){return u._versionId},get notebookType(){return u._notebookType},get isDirty(){return u._isDirty},get isUntitled(){return u.uri.scheme===m.Schemas.untitled},get isClosed(){return u._disposed},get metadata(){return u._metadata},get cellCount(){return u._cells.length},cellAt(f){return f=u._validateIndex(f),u._cells[f].apiCell},getCells(f){return(f?u._getCells(f):u._cells).map(v=>v.apiCell)},save(){return u._save()}}}return this._notebook}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(u){u.metadata&&(this._metadata=Object.freeze({...this._metadata,...u.metadata}))}acceptDirty(u){this._isDirty=u}acceptModelChanged(u,f){this._versionId=u.versionId,this._isDirty=f;for(const o of u.rawEvents)o.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===C.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(u){return u=u|0,u<0?0:u>=this._cells.length?this._cells.length-1:u}_validateRange(u){let f=u.start|0,o=u.end|0;return f<0&&(f=0),o>this._cells.length&&(o=this._cells.length),u.with({start:f,end:o})}_getCells(u){u=this._validateRange(u);const f=[];for(let o=u.start;o<u.end;o++)f.push(this._cells[o]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(u,f){if(this._disposed)return;const o=[],v=[],S=[];u.reverse().forEach(P=>{const a=P[2].map(t=>{const s=new T(this,this._textDocumentsAndEditors,t);return f||v.push(T.asModelAddData(this.apiNotebook,t)),s}),l=new D(P[0],P[1],[],a),p=this._cells.splice(P[0],P[1],...a);for(const t of p)S.push(t.uri),l.deletedItems.push(t.apiCell);o.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:S}),f||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(o)}))}_moveCell(u,f){const o=this._cells.splice(u,1);this._cells.splice(f,0,...o);const v=[new D(u,1,o.map(S=>S.apiCell),[]),new D(f,0,[],o)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(v)}))}_setCellOutputs(u,f){const o=this._cells[u];o.setOutputs(f),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(u,f,o,v){const S=this._cells[u];S.setOutputItems(f,o,v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(u,f){const o=this._cells[u];o.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(o.uri,f)}_changeCellMime(u,f){const o=this._cells[u];o.apiCell.mime=f}_changeCellMetadata(u,f){const o=this._cells[u],v=o.apiCell.metadata;o.setMetadata(f);const S=o.apiCell.metadata;(0,L.equals)(v,S)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(u,f){const o=this._cells[u],v=o.internalMetadata;if(o.setInternalMetadata(f),v.runState!==f.runState){const S=f.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,state:S}))}}getCellFromApiCell(u){return this._cells.find(f=>f.apiCell===u)}getCellFromIndex(u){return this._cells[u]}getCell(u){return this._cells.find(f=>f.handle===u)}getCellIndex(u){return this._cells.indexOf(u)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(me[129],ge([0,1,7,15,16]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class k{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:T})}replaceCells(D,T,n){this._throwIfFinalized(),!(D===T&&n.length===0)&&this._collectedEdits.push({editType:1,index:D,count:T-D,cells:n.map(L.NotebookCellData.from)})}}class R{constructor(D,T,n,A,u,f){this.id=D,this._proxy=T,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=A,this._viewColumn=f}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(T){if(!Array.isArray(T)||!T.every(m.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");D._selections=T,D._trySetSelections(T)},get visibleRanges(){return D._visibleRanges},revealRange(T,n){D._proxy.$tryRevealRange(D.id,L.NotebookRange.from(T),n??m.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(T){const n=new k(this.document.version);return T(n),D._applyEdit(n.finalize())},setDecorations(T,n){return D.setDecorations(T,n)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(L.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const T=[];let n=-1;for(let A=0;A<D.cellEdits.length;A++){if(n<0){T.push(D.cellEdits[A]),n++;continue}const f=T[n],o=D.cellEdits[A];if(f.editType===1&&o.editType===1&&f.index===o.index){f.cells.push(...D.cellEdits[A].cells),f.count+=D.cellEdits[A].count;continue}T.push(D.cellEdits[A]),n++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,T)}setDecorations(D,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return T.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(T),D.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(me[221],ge([0,1,15,118,165,21,58]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(A){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=A}withProgress(A,u,f){const o=this._handles++,{title:v,location:S,cancellable:P}=u,E={label:(0,I.localize)(0,null,A.displayName||A.name),id:A.identifier.value};return this._proxy.$startProgress(o,{location:m.ProgressLocation.from(S),title:v,source:E,cancellable:P},A),this._withProgress(o,f,!!P)}_withProgress(A,u,f){let o;f&&(o=new k.CancellationTokenSource,this._mapHandleToCancellationSource.set(A,o));const v=P=>{this._proxy.$progressEnd(P),this._mapHandleToCancellationSource.delete(P),o&&o.dispose()};let S;try{S=u(new T(this._proxy,A),f&&o?o.token:k.CancellationToken.None)}catch(P){throw v(A),P}return S.then(P=>v(A),P=>v(A)),S}$acceptProgressCanceled(A){const u=this._mapHandleToCancellationSource.get(A);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(A))}}e.ExtHostProgress=C;function D(n,A){return n.message=A.message,typeof A.increment=="number"&&(typeof n.increment=="number"?n.increment+=A.increment:n.increment=A.increment),n}class T extends L.Progress{constructor(A,u){super(f=>this.throttledReport(f));this._proxy=A,this._handle=u}throttledReport(A){this._proxy.$progressReport(this._handle,A)}}Ve([(0,R.throttle)(100,(n,A)=>D(n,A),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(me[130],ge([0,1,56,16,76,15,7]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(u,f,o){const v=C._Keys.nextId();u.$registerTextEditorDecorationType(f.identifier,v,k.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:v,dispose(){u.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=C,C._Keys=new I.IdGenerator("TextEditorDecorationType");class D{constructor(u,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,f){this._throwIfFinalized();let o=null;if(u instanceof R.Position)o=new R.Range(u,u);else if(u instanceof R.Range)o=u;else throw new Error("Unrecognized location");this._pushEdit(o,f,!1)}insert(u,f){this._throwIfFinalized(),this._pushEdit(new R.Range(u,u),f,!0)}delete(u){this._throwIfFinalized();let f=null;if(u instanceof R.Range)f=u;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(u,f,o){const v=this._document.validateRange(u);this._collectedEdits.push({range:v,text:f,forceMoveMarkers:o})}setEndOfLine(u){if(this._throwIfFinalized(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=D;class T{constructor(u,f,o,v){this._proxy=u,this._id=f,this._accept(o),this._logService=v;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(P){S._setTabSize(P)},get insertSpaces(){return S._insertSpaces},set insertSpaces(P){S._setInsertSpaces(P)},get cursorStyle(){return S._cursorStyle},set cursorStyle(P){S._setCursorStyle(P)},get lineNumbers(){return S._lineNumbers},set lineNumbers(P){S._setLineNumbers(P)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=k.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const f=Math.floor(u);return f>0?f:null}if(typeof u=="string"){const f=parseInt(u,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(u){const f=this._validateTabSize(u);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const f=this._validateInsertSpaces(u);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:k.TextEditorLineNumbersStyle.from(u)})))}assign(u){const f={};let o=!1;if(typeof u.tabSize!="undefined"){const v=this._validateTabSize(u.tabSize);v==="auto"?(o=!0,f.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,o=!0,f.tabSize=v)}if(typeof u.insertSpaces!="undefined"){const v=this._validateInsertSpaces(u.insertSpaces);v==="auto"?(o=!0,f.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,o=!0,f.insertSpaces=v)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,o=!0,f.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,o=!0,f.lineNumbers=k.TextEditorLineNumbersStyle.from(u.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(u){u.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=T;class n{constructor(u,f,o,v,S,P,E,a){this.id=u,this._proxy=f,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new T(this._proxy,this.id,P,o),this._visibleRanges=E,this._viewColumn=a;const l=this;this.value=Object.freeze({get document(){return v.getValue()},set document(p){throw(0,L.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(p){if(!(p instanceof R.Selection))throw(0,L.illegalArgument)("selection");l._selections=[p],l._trySetSelection()},get selections(){return l._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof R.Selection)))throw(0,L.illegalArgument)("selections");l._selections=p,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(p){throw(0,L.readonly)("visibleRanges")},get options(){return l._options.value},set options(p){l._disposed||l._options.assign(p)},get viewColumn(){return l._viewColumn},set viewColumn(p){throw(0,L.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(v.getValue(),t);return p(s),l._applyEdit(s)},insertSnippet(p,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=l._selections.map(i=>k.Range.from(i));else if(t instanceof R.Position){const{lineNumber:i,column:h}=k.Position.from(t);r=[{startLineNumber:i,startColumn:h,endLineNumber:i,endColumn:h}]}else if(t instanceof R.Range)r=[k.Range.from(t)];else{r=[];for(const i of t)if(i instanceof R.Range)r.push(k.Range.from(i));else{const{lineNumber:h,column:c}=k.Position.from(i);r.push({startLineNumber:h,startColumn:c,endLineNumber:h,endColumn:c})}}return f.$tryInsertSnippet(u,p.value,r,s)},setDecorations(p,t){const s=t.length===0;s&&!l._hasDecorationsForKey.has(p.key)||(s?l._hasDecorationsForKey.delete(p.key):l._hasDecorationsForKey.add(p.key),l._runOnProxy(()=>{if(k.isDecorationOptionsArr(t))return f.$trySetDecorations(u,p.key,k.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let i=0,h=t.length;i<h;i++){const c=t[i];r[4*i]=c.start.line+1,r[4*i+1]=c.start.character+1,r[4*i+2]=c.end.line+1,r[4*i+3]=c.end.character+1}return f.$trySetDecorationsFast(u,p.key,r)}}))},revealRange(p,t){l._runOnProxy(()=>f.$tryRevealRange(u,k.Range.from(p),t||R.TextEditorRevealType.Default))},show(p){f.$tryShowEditor(u,k.ViewColumn.from(p))},hide(){f.$tryHideEditor(u)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,m.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,m.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,m.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,m.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(k.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const f=u.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const o=f.edits.map(S=>S.range);o.sort((S,P)=>S.end.line===P.end.line?S.end.character===P.end.character?S.start.line===P.start.line?S.start.character-P.start.character:S.start.line-P.start.line:S.end.character-P.end.character:S.end.line-P.end.line);for(let S=0,P=o.length-1;S<P;S++){const E=o[S].end;if(o[S+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=f.edits.map(S=>({range:k.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,v,{setEndOfLine:typeof f.setEndOfLine=="number"?k.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=n}),define(me[222],ge([0,1,168,22,2,3,6,209,18,7,13,17,15,21,206]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(E,a){if((0,n.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let l;return Array.isArray(E.highlights)&&(l=E.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),l=l.length?l:void 0),{label:E.label,highlights:l}}}class S{constructor(a,l,p){this._proxy=a,this.commands=l,this.logService=p,this.treeViews=new Map;function t(s){return s&&s.$treeViewId&&s.$treeItemHandle}l.registerArgumentProcessor({processArgument:s=>t(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(r=>t(r)?this.convertArgument(r):r):s})}registerTreeDataProvider(a,l,p){const t=this.createTreeView(a,{treeDataProvider:l},p);return{dispose:()=>t.dispose()}}createTreeView(a,l,p){if(!l||!l.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=l.dragAndDropController!==void 0,s=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!l.showCollapseAll,canSelectMany:!!l.canSelectMany,canDragAndDrop:t}),r=this.createExtHostTreeView(a,l,p);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(i){r.message=i},get title(){return r.title},set title(i){r.title=i},get description(){return r.description},set description(i){r.description=i},reveal:(i,h)=>r.reveal(i,h),dispose:async()=>{await s,this.treeViews.delete(a),r.dispose()}}}$getChildren(a,l){const p=this.treeViews.get(a);return p?p.getChildren(l):Promise.reject(new Error((0,m.localize)(0,null,a)))}async $onDrop(a,l,p){const t=this.treeViews.get(a);if(!t)return Promise.reject(new Error((0,m.localize)(1,null,a)));const s=o.TreeDataTransferConverter.toITreeDataTransfer(l);if(s.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await s.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(h=>t.getExtensionElement(h)).filter(h=>!!h);i.length>0?s.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):s.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(s,p)}async $hasResolve(a){const l=this.treeViews.get(a);if(!l)throw new Error((0,m.localize)(2,null,a));return l.hasResolve}$resolve(a,l,p){const t=this.treeViews.get(a);if(!t)throw new Error((0,m.localize)(3,null,a));return t.resolveTreeItem(l,p)}$setExpanded(a,l,p){const t=this.treeViews.get(a);if(!t)throw new Error((0,m.localize)(4,null,a));t.setExpanded(l,p)}$setSelection(a,l){const p=this.treeViews.get(a);if(!p)throw new Error((0,m.localize)(5,null,a));p.setSelection(l)}$setVisible(a,l){const p=this.treeViews.get(a);if(!p)throw new Error((0,m.localize)(6,null,a));p.setVisible(l)}createExtHostTreeView(a,l,p){const t=new P(a,l,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(a,t),t}convertArgument(a){const l=this.treeViews.get(a.$treeViewId);return l?l.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=S;class P extends R.Disposable{constructor(a,l,p,t,s,r){super();if(this.viewId=a,this.proxy=p,this.commands=t,this.logService=s,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new k.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new k.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new k.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new k.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new k.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,r.contributes&&r.contributes.views)for(const c in r.contributes.views)for(const d of r.contributes.views[c])d.id===a&&(this._title=d.name);this.dataProvider=l.treeDataProvider,this.dndController=l.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(c=>this._onDidChangeData.fire({message:!1,element:c}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let i,h;this._register(k.Event.debounce(this._onDidChangeData.event,(c,d)=>(c||(c={message:!1,elements:[]}),d.element!==!1&&(i||(i=new Promise(b=>h=b),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(d.element)?c.elements.push(...d.element):c.elements.push(d.element)),d.message&&(c.message=!0),c),200,!0)(({message:c,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=h;return i=null,this.refresh(d).then(()=>b())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,n.isUndefinedOrNull)(a))}async getChildren(a){const l=a?this.getExtensionElement(a):void 0;if(a&&!l)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let p=this.getChildrenNodes(a);return p||(p=await this.fetchChildrenNodes(l)),p?p.map(t=>t.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,l){l=l||{select:!0,focus:!1};const p=(0,n.isUndefinedOrNull)(l.select)?!0:l.select,t=(0,n.isUndefinedOrNull)(l.focus)?!1:l.focus,s=(0,n.isUndefinedOrNull)(l.expand)?!1:l.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(h=>h.item)},{select:p,focus:t,expand:s})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:t,expand:s})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,l){const p=this.getExtensionElement(a);p&&(l?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(a){(0,A.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,l){const p=this.getExtensionElement(l);if(!!p)return(0,D.asPromise)(()=>this.dndController?.onDrop(a,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,l){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(a);if(p){const t=this.nodes.get(p);if(t){const s=await this.dataProvider.resolveTreeItem(t.extensionItem,p,l)??t.extensionItem;return t.item.tooltip=this.getTooltip(s.tooltip),t.item.command=this.getCommand(t.disposableStore,s.command),t.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(l=>l?this.resolveUnknownParentChain(l).then(p=>this.resolveTreeNode(l,p[p.length-1]).then(t=>(p.push(t),p))):Promise.resolve([]))}resolveParent(a){const l=this.nodes.get(a);return l?Promise.resolve(l.parent?this.elements.get(l.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,l){const p=this.nodes.get(a);return p?Promise.resolve(p):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>this.createHandle(a,t,l,!0)).then(t=>this.getChildren(l?l.item.handle:void 0).then(()=>{const s=this.getExtensionElement(t);if(s){const r=this.nodes.get(s);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(a){if(a){let l;if(typeof a=="string"){const p=this.getExtensionElement(a);l=p?this.nodes.get(p):void 0}else l=a;return l&&l.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const l=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=a?this.nodes.get(a):void 0,t=await this.dataProvider.getChildren(a);if(l.token.isCancellationRequested)return;const s=await Promise.all((0,A.coalesce)(t||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!l.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,p):null}));return l.token.isCancellationRequested?void 0:(0,A.coalesce)(s)}finally{l.dispose()}}refresh(a){if(a.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(a);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const l=new Set,p=a.map(s=>this.nodes.get(s));for(const s of p)if(s&&!l.has(s.item.handle)){let r=s;for(;r&&r.parent&&p.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&l.add(s.item.handle)}const t=[];return l.forEach(s=>{const r=this.elements.get(s);if(r){const i=this.nodes.get(r);i&&(!i.parent||!l.has(i.parent.item.handle))&&t.push(s)}}),t}refreshHandles(a){const l={};return Promise.all(a.map(p=>this.refreshNode(p).then(t=>{t&&(l[p]=t.item)}))).then(()=>Object.keys(l).length?this.proxy.$refresh(this.viewId,l):void 0)}refreshNode(a){const l=this.getExtensionElement(a);if(l){const p=this.nodes.get(l);if(p)return this.clearChildren(l),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(t=>{if(t){const s=this.createTreeNode(l,t,p.parent);return this.updateNodeCache(l,s,p,p.parent),p.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,l,p){const t=this.createTreeNode(a,l,p);if(l.id&&this.elements.has(t.item.handle))throw new Error((0,m.localize)(7,null,l.id));return this.addNodeToCache(a,t),this.addNodeToParentCache(t,p),t}getTooltip(a){return T.MarkdownString.isMarkdownString(a)?u.MarkdownString.from(a):a}getCommand(a,l){return l?this.commands.toInternal(l,a):void 0}createTreeNode(a,l,p){const t=new R.DisposableStore,s=this.createHandle(a,l,p),r=this.getLightIconPath(l);return{item:{handle:s,parentHandle:p?p.item.handle:void 0,label:v(l.label,this.extension),description:l.description,resourceUri:l.resourceUri,tooltip:this.getTooltip(l.tooltip),command:this.getCommand(t,l.command),contextValue:l.contextValue,icon:r,iconDark:this.getDarkIconPath(l)||r,themeIcon:this.getThemeIcon(l),collapsibleState:(0,n.isUndefinedOrNull)(l.collapsibleState)?T.TreeItemCollapsibleState.None:l.collapsibleState,accessibilityInformation:l.accessibilityInformation},extensionItem:l,parent:p,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(a){return a.iconPath instanceof T.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:l,label:p,resourceUri:t},s,r){if(l)return`${P.ID_HANDLE_PREFIX}/${l}`;const i=v(p,this.extension),h=s?s.item.handle:P.LABEL_HANDLE_PREFIX;let c=i?i.label:t?(0,L.basename)(t):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const d=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,b=this.getChildrenNodes(s)||[];let y,g=0;do{if(y=`${h}/${g}:${c}`,r||!this.elements.has(y)||d===y)break;g++}while(g<=b.length);return y}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof T.ThemeIcon))return typeof a.iconPath=="string"||I.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof T.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return I.URI.isUri(a)?a:I.URI.file(a)}addNodeToCache(a,l){this.elements.set(l.item.handle,a),this.nodes.set(a,l)}updateNodeCache(a,l,p,t){this.elements.delete(l.item.handle),this.nodes.delete(a),l.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(a,l);const s=this.getChildrenNodes(t)||[],r=s.filter(i=>i.item.handle===p.item.handle)[0];r&&s.splice(s.indexOf(r),1,l)}addNodeToParentCache(a,l){l?(l.children||(l.children=[]),l.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const l=this.nodes.get(a);if(l){if(l.children)for(const p of l.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}l.children=void 0}}else this.clearAll()}clear(a){const l=this.nodes.get(a);if(l){if(l.children)for(const p of l.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}this.nodes.delete(a),this.elements.delete(l.item.handle),l.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}P.LABEL_HANDLE_PREFIX="0",P.ID_HANDLE_PREFIX="1"}),define(me[223],ge([0,1,18,3,6,13,64,15,127,89]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends I.Disposable{constructor(u){super();this.controllerId=u,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(u){this._resolveHandler=u;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const u=this.diff;return this.diff=[],u}pushDiff(u){const f=this.diff[this.diff.length-1];if(f&&u[0]===1){if(f[0]===1&&f[1].extId===u[1].extId){(0,D.applyTestItemUpdate)(f[1],u[1]);return}if(f[0]===0&&f[1].item.extId===u[1].extId){(0,D.applyTestItemUpdate)(f[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,f){const o=this.tree.get(u);if(!!o){if((o.expandLevels===void 0||f>o.expandLevels)&&(o.expandLevels=f),o.expand===1){const v=this.resolveChildren(o);return v.isOpen()?this.expandChildren(o,f-1):v.wait().then(()=>this.expandChildren(o,f-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,f-1)):this.expandChildren(o,f-1)}}dispose(){for(const u of this.tree.values())(0,R.getPrivateApiFor)(u.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(u,f){switch(f.op){case 2:this.pushDiff([4,u.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(u.fullId,f.id));break;case 0:this.upsertItem(f.item,u);break;case 4:for(const E of f.ops)this.onTestItemEvent(u,E);break;case 3:const{key:o,value:v,previous:S}=f,P=u.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(u);break;case"tags":this.diffTagRefs(v,S,P);break;case"range":this.pushDiff([1,{extId:P,item:{range:C.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:P,item:{error:C.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:P,item:{[o]:v??null}}]);break}break;default:(0,k.assertNever)(f)}}upsertItem(u,f){if(!(u instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);const o=T.TestId.fromExtHostTestItem(u,this.root.id,f?.actual),v=(0,R.getPrivateApiFor)(u);v.parent&&v.parent!==f?.actual&&v.parent.children.delete(u.id);let S=this.tree.get(o.toString());if(!S){S={fullId:o,actual:u,parent:f?o.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},u.tags.forEach(this.incrementTagRefs,this),this.tree.set(S.fullId.toString(),S),this.setItemParent(u,f),this.pushDiff([0,{parent:S.parent&&S.parent.toString(),controllerId:this.controllerId,expand:S.expand,item:C.TestItem.from(u)}]),this.connectItemAndChildren(u,S,f);return}if(S.actual===u){this.connectItem(u,S,f);return}const P=S.actual.children,E=S.actual,a=(0,R.diffTestItems)(E,u);(0,R.getPrivateApiFor)(E).listener=void 0,S.actual=u,S.expand=0;for(const[l,p]of a)this.onTestItemEvent(S,{op:3,key:l,value:p,previous:E[l]});this.connectItemAndChildren(u,S,f);for(const l of P)u.children.get(l.id)||this.removeItem(T.TestId.joinToString(o,l.id))}diffTagRefs(u,f,o){const v=new Set(f.map(S=>S.id));for(const S of u)v.delete(S.id)||this.incrementTagRefs(S);this.pushDiff([1,{extId:o,item:{tags:u.map(S=>C.TestTag.namespace(this.controllerId,S.id))}}]),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(u){const f=this.tags.get(u.id);f?f.refCount++:(this.tags.set(u.id,{refCount:1}),this.pushDiff([5,{id:C.TestTag.namespace(this.controllerId,u.id),ctrlLabel:this.root.label}]))}decrementTagRefs(u){const f=this.tags.get(u);f&&!--f.refCount&&(this.tags.delete(u),this.pushDiff([6,C.TestTag.namespace(this.controllerId,u)]))}setItemParent(u,f){(0,R.getPrivateApiFor)(u).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(u,f,o){this.setItemParent(u,o);const v=(0,R.getPrivateApiFor)(u);v.parent=o?.actual,v.listener=S=>this.onTestItemEvent(f,S),this.updateExpandability(f)}connectItemAndChildren(u,f,o){this.connectItem(u,f,o);for(const v of u.children)this.upsertItem(v,f)}updateExpandability(u){let f;this._resolveHandler?u.resolveBarrier?f=u.resolveBarrier.isOpen()?3:2:f=u.actual.canResolveChildren?1:0:f=0,f!==u.expand&&(u.expand=f,this.pushDiff([1,{extId:u.fullId.toString(),expand:f}]),f===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,f){if(f<0)return;const o=[];for(const v of u.actual.children){const S=this.expand(T.TestId.joinToString(u.fullId,v.id),f);(0,m.isThenable)(S)&&o.push(S)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const S=new m.Barrier;return S.open(),S}u.expand=2,this.pushExpandStateUpdate(u);const f=u.resolveBarrier=new m.Barrier,o=S=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),u.actual!==this.root&&(u.actual.error=S.stack||S.message||String(S))};let v;try{v=this._resolveHandler(u.actual===this.root?void 0:u.actual)}catch(S){o(S)}return(0,m.isThenable)(v)?v.catch(o).then(()=>{f.open(),this.updateExpandability(u)}):(f.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.fullId.toString(),expand:u.expand}])}removeItem(u){const f=this.tree.get(u);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,u]);const o=[f];for(;o.length;){const v=o.pop();if(!!v){(0,R.getPrivateApiFor)(v.actual).listener=void 0;for(const S of v.actual.tags)this.decrementTagRefs(S.id);this.tree.delete(v.fullId.toString());for(const S of v.actual.children)o.push(this.tree.get(T.TestId.joinToString(v.fullId,S.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=n}),define(me[224],ge([0,1,4,183]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(L.IEnvironmentService)}),define(me[225],ge([0,1,26,3,8]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class k{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=k;class R{constructor(n){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let A of n.activationEvents)A==="onUri"&&(A=`onUri:${m.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(A)||this._activationMap.set(A,[]),this._activationMap.get(A).push(n)}}keepOnly(n){const A=new Set;n.forEach(u=>A.add(m.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>A.has(m.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,A){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const u=R._findLoopingExtensions(this._extensionDescriptions);if(A=A.concat(u.map(f=>f.identifier)),A.length>0){const f=new Set;A.forEach(o=>f.add(m.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!f.has(m.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new k(u)}static _findLoopingExtensions(n){const A=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,P){this.addNode(S),this.addNode(P),this._arcs.has(S)?this._arcs.get(S).push(P):this._arcs.set(S,[P])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,P){const E=A.getArcs(S);for(let a=0;a<E.length;a++)if(!P.has(E[a]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let S of n){const P=m.ExtensionIdentifier.toKey(S.identifier);if(u.set(P,S),S.extensionDependencies)for(let E of S.extensionDependencies){const a=m.ExtensionIdentifier.toKey(E);A.addArc(P,a)}}let f=new Set;A.getNodes().filter(S=>A.getArcs(S).length===0).forEach(S=>f.add(S));let o=A.getNodes().filter(S=>!f.has(S)),v;do{v=!1;for(let S=0;S<o.length;S++){const P=o[S];A.hasOnlyGoodArcs(P,f)&&(o.splice(S,1),S--,f.add(P),v=!0)}}while(v);return o.map(S=>u.get(S))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const A=this._activationMap.get(n);return A?A.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const A=this._extensionsMap.get(m.ExtensionIdentifier.toKey(n));return A||void 0}}e.ExtensionDescriptionRegistry=R;var C;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(C||(C={}));function D(T,n){const A=T.isBuiltin?0:T.isUnderDevelopment?2:1,u=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(A!==u)return A-u;const f=I.posix.basename(T.extensionLocation.path),o=I.posix.basename(n.extensionLocation.path);return f<o?-1:f>o?1:0}}),define(me[226],ge([0,1,23]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function k(C){const D=m.VSBuffer.alloc(1);switch(C){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=k;function R(C,D){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=R}),define(me[36],ge([0,1,3,2,4,26,185]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new k.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var C;(function(E){E[E.None=0]="None",E[E.LocalProcess=1]="LocalProcess",E[E.LocalWebWorker=2]="LocalWebWorker",E[E.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class D{constructor(a){this.dependency=a}}e.MissingExtensionDependency=D;var T;(function(E){E[E.LocalProcess=0]="LocalProcess",E[E.LocalWebWorker=1]="LocalWebWorker",E[E.Remote=2]="Remote"})(T=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(a,l,p,t){this.codeLoadingTime=a,this.activateCallTime=l,this.activateResolvedTime=p,this.activationReason=t}}e.ActivationTimes=n;class A{constructor(a,l){this.description=a,this.value=l}}e.ExtensionPointContribution=A,e.ExtensionHostLogFileName="exthost";var u;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(u=e.ActivationKind||(e.ActivationKind={}));function f(E){E.enableProposedApi||o(E)}e.checkProposedApiEnabled=f;function o(E){throw new Error(`[${E.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.throwProposedApiError=o;function v(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation}}e.toExtension=v;function S(E,a){return{identifier:new k.ExtensionIdentifier(E.identifier.id),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!a,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid}}e.toExtensionDescription=S;class P{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(a){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,l){return Promise.resolve()}_onWillActivateExtension(a){}_onDidActivateExtension(a,l,p,t,s){}_onDidActivateExtensionError(a,l){}_onExtensionRuntimeError(a,l){}_onExtensionHostExit(a){}}e.NullExtensionService=P}),define(me[227],ge([0,1,26,36,12]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const k=Promise.resolve(void 0);class R{constructor(o,v,S,P){this.startup=o,this.codeLoadingTime=v,this.activateCallTime=S,this.activateResolvedTime=P}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class C{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,v){return o===-1||v===-1?-1:v-o}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class D{constructor(o,v,S,P,E,a){this.activationFailed=o,this.activationFailedError=v,this.activationTimes=S,this.module=P,this.exports=E,this.subscriptions=a}}e.ActivatedExtension=D;class T extends D{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class n extends D{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class A extends D{constructor(o){super(!0,o,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=A;let u=class{constructor(o,v,S,P,E){this._logService=E,this._registry=o,this._resolvedExtensionsSet=new Set,v.forEach(a=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,S.forEach(a=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(a),a)),this._host=P,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(o){const v=m.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(v)}getActivatedExtension(o){const v=m.ExtensionIdentifier.toKey(o),S=this._activatedExtensions.get(v);if(!S)throw new Error("Extension `"+o.value+"` is not known or not activated");return S}activateByEvent(o,v){if(this._alreadyActivatedEvents[o])return k;const S=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(S.map(P=>({id:P.identifier,reason:{startup:v,extensionId:P.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,v){const S=this._registry.getExtensionDescription(o);if(!S)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:S.identifier,reason:v}])}_handleActivateRequest(o,v,S){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(o.id))){v[m.ExtensionIdentifier.toKey(o.id)]=o;return}const P=this._registry.getExtensionDescription(o.id);if(!P){const l=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,l,new L.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(o.id),new A(l));return}const E=typeof P.extensionDependencies=="undefined"?[]:P.extensionDependencies;let a=!0;for(let l=0,p=E.length;l<p;l++){const t=E[l];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const s=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const c=P.displayName||P.identifier.value,d=this._registry.getExtensionDescription(t),b=d&&d.displayName||t,y=new Error(`Cannot activate the '${c}' extension because its dependency '${b}' failed to activate`);y.detail=s.activationFailedError,this._host.onExtensionActivationError(P.identifier,y,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(P.identifier),new A(y));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){a=!1,v[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:o.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){a=!1,v[m.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:o.reason};continue}const i=P.displayName||P.identifier.value,h=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(P.identifier,h,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(P.identifier),new A(h));return}a?v[m.ExtensionIdentifier.toKey(P.identifier)]=o:S.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(E=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(E.id))),o.length===0))return Promise.resolve(void 0);const v=Object.create(null),S=[];for(let E=0,a=o.length;E<a;E++)this._handleActivateRequest(o[E],v,S);for(let E=0,a=S.length;E<a;E++){const l=m.ExtensionIdentifier.toKey(S[E].id);v[l]&&delete v[l]}const P=Object.keys(v).map(E=>v[E]);return S.length===0?Promise.all(P.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(P).then(E=>this._activateExtensions(S))}_activateExtension(o,v){const S=m.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const P=this._activatingExtensions.get(S);if(P)return P;const E=this._host.actualActivateExtension(o,v).then(void 0,a=>{const l=new Error;return a&&a.name&&(l.name=a.name),a&&a.message?l.message=`Activating extension '${o.value}' failed: ${a.message}.`:l.message=`Activating extension '${o.value}' failed: ${a}.`,a&&a.stack&&(l.stack=a.stack),this._host.onExtensionActivationError(o,l,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(a),new A(a)}).then(a=>{this._activatedExtensions.set(S,a),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,E),E}};u=Ve([We(4,I.ILogService)],u),e.ExtensionsActivator=u}),define(me[228],ge([0,1,12,36,27,10,116]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(T){if(T.logFile.scheme!==k.Schemas.file)throw new Error("Only file-logging supported");super(new R.SpdLogLogger(L.ExtensionHostLogFileName,T.logFile.fsPath,!0,T.logLevel))}$setLevel(T){this.setLevel(T)}};C=Ve([We(0,I.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(me[229],ge([0,1,16]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((k,R)=>{this._actualOk=k,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(k){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=k,this._actual&&this._actualOk(k))}resolveErr(k){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=k,this._actual?this._actualErr(k):(0,m.onUnexpectedError)(k))}then(k,R){return this._ensureActual().then(k,R)}catch(k){return this._ensureActual().then(void 0,k)}finally(k){return this._ensureActual().finally(k)}}e.LazyPromise=L}),define(me[66],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(T,n){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=n,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const L=[];function I(D){const T=new m(!0,D);return L[T.nid]=T,T}e.createMainContextProxyIdentifier=I;function k(D){const T=new m(!1,D);return L[T.nid]=T,T}e.createExtHostContextProxyIdentifier=k;function R(D){return L[D].sid}e.getStringIdentifierForProxy=R;class C{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=C}),define(me[5],ge([0,1,60,2,66]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var k;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var R;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));var u;(function(a){a.name="$ident";function l(t,s){return Object.defineProperty(t,a.name,{value:s,enumerable:!0}),t}a.mixin=l;function p(t){return t[a.name]}a.of=p})(u=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(l){return l._id=f._n++,l}}e.IdObject=f,f._n=0;var o;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function P(a){if(a&&a.edits)for(const l of a.edits)typeof l.resource=="object"?l.resource=L.URI.revive(l.resource):(l.newUri=L.URI.revive(l.newUri),l.oldUri=L.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,m.revive)(l.metadata));return a}e.reviveWorkspaceEditDto=P;var E;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[90],ge([0,1,5,3,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class k{constructor(C){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,D){return this._proxy.$getPassword(C,D)}store(C,D,T){return this._proxy.$setPassword(C,D,T)}delete(C,D){return this._proxy.$deletePassword(C,D)}}e.ExtHostSecretState=k,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(me[67],ge([0,1,4,12,5,14]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(D,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(I.MainContext.MainThreadTelemetry)}report(D,T,n){const A=this.getUsageKey(D,T);this._reportedUsages.has(A)||(this._reportedUsages.add(A),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:D}))}getUsageKey(D,T){return`${D}-${T.identifier.value}`}};R=Ve([We(0,k.IExtHostRpcService),We(1,L.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(C,D,T){}})}),define(me[230],ge([0,1,3,5,7,26]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,T,n,A={}){const u=k.ExtensionIdentifier.toKey(D.identifier),f=this._inFlightRequests.get(u)||[],o=[...n].sort().join(" ");let v=f.find(S=>S.scopes===o);if(v)return v.result;{const S=this._getSession(D,u,T,n,A);v={scopes:o,result:S},f.push(v),this._inFlightRequests.set(u,f);try{await S}finally{const P=f.findIndex(E=>E.scopes===o);P>-1&&(f.splice(P),this._inFlightRequests.set(u,f))}return S}}async _getSession(D,T,n,A,u={}){await this._proxy.$ensureProvider(n);const f=D.displayName||D.name;return this._proxy.$getSession(n,A,T,f,u)}async removeSession(D,T){const n=this._authenticationProviders.get(D);return n?n.provider.removeSession(T):this._proxy.$removeSession(D,T)}registerAuthenticationProvider(D,T,n,A){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:T,provider:n,options:A??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===D)||this._providers.push({id:D,label:T});const u=n.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(D,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,T,A?.supportsMultipleAccounts??!1),new I.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(D);const f=this._providers.findIndex(o=>o.id===D);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,T){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,T){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,T){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,T){return this._onDidChangeSessions.fire({provider:{id:D,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(me[231],ge([0,1,5,14,15]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let k=class{constructor(C,D){this._extHostDocumentsAndEditors=D,this._proxy=C.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const D=I.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};k=Ve([We(0,L.IExtHostRpcService)],k),e.ExtHostBulkEdits=k}),define(me[232],ge([0,1,5]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(k){const R=k.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(C){return R.$writeText(C)}})}}e.ExtHostClipboard=L}),define(me[44],ge([0,1,13,7,15,25,5,17,12,60,41,51,2,6,4,14,64]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let P=class{constructor(s,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=s.getProxy(R.MainContext.MainThreadCommands),this._logService=r,this.converter=new E(this,i=>{const h=this._apiCommands.get(i);return h?.result===l.Void?h:void 0},r),this._argumentProcessors=[{processArgument(i){return(0,T.revive)(i)}},{processArgument(i){return(0,k.cloneAndChange)(i,function(h){if(n.Range.isIRange(h))return I.Range.to(h);if(A.Position.isIPosition(h))return I.Position.to(h);if(n.Range.isIRange(h.range)&&u.URI.isUri(h.uri))return I.location.to(h);if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const r=this.registerCommand(!1,s.id,async(...i)=>{const h=s.args.map((d,b)=>{if(!d.validate(i[b]))throw new Error(`Invalid argument '${d.name}' when running '${s.id}', received: ${i[b]}`);return d.convert(i[b])}),c=await this.executeCommand(s.internalId,...h);return s.result.convert(c,i,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new L.Disposable(()=>{r.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,r,i,h,c){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:i,thisArg:h,description:c}),s&&this._proxy.$registerCommand(r),new L.Disposable(()=>{this._commands.delete(r)&&s&&this._proxy.$unregisterCommand(r)})}executeCommand(s,...r){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,r,!0)}async _doExecuteCommand(s,r,i){if(this._commands.has(s))return this._executeContributedCommand(s,r);{const h=(0,k.cloneAndChange)(r,function(c){if(c instanceof L.Position)return I.Position.from(c);if(c instanceof L.Range)return I.Range.from(c);if(c instanceof L.Location)return I.location.from(c);if(L.NotebookRange.isNotebookRange(c))return I.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(s,h,i);return(0,T.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(s,r,!1);throw c}}}async _executeContributedCommand(s,r){const i=this._commands.get(s);if(!i)throw new Error("Unknown command");let{callback:h,thisArg:c,description:d}=i;if(d)for(let b=0;b<d.args.length;b++)try{(0,m.validateConstraint)(r[b],d.args[b].constraint)}catch(y){throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${d.args[b].name}' - ${d.args[b].description}`)}try{return await h.apply(c,r)}catch(b){if(s===this.converter.delegatingCommandId){const y=this.converter.getActualCommand(...r);y&&(s=y.command)}throw this._logService.error(b,s),new Error(`Running the contributed command: '${s}' failed.`)}}$executeContributedCommand(s,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(r=r.map(i=>this._argumentProcessors.reduce((h,c)=>c.processArgument(h),i)),this._executeContributedCommand(s,r)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),this._proxy.$getCommands().then(r=>(s&&(r=r.filter(i=>i[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[r,i]of this._commands){let{description:h}=i;h&&(s[r]=h)}return Promise.resolve(s)}};P=Ve([We(0,v.IExtHostRpcService),We(1,D.ILogService)],P),e.ExtHostCommands=P,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class E{constructor(s,r,i){this._commands=s,this._lookupApiCommand=r,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,r){if(!s)return;const i={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return i;const h=this._lookupApiCommand(s.command);if(h)i.id=h.internalId,i.arguments=h.args.map((c,d)=>c.convert(s.arguments&&s.arguments[d]));else if((0,C.isNonEmptyArray)(s.arguments)){const c=++this._cachIdPool;this._cache.set(c,s),r.add((0,f.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),i.$ident=c,i.id=this.delegatingCommandId,i.arguments=[c],this._logService.trace("CommandsConverter#CREATE",s.command,c)}return i}fromInternal(s){const r=R.ObjectIdentifier.of(s);return typeof r=="number"?this._cache.get(r):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const r=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=E;class a{constructor(s,r,i,h){this.name=s,this.description=r,this.validate=i,this.convert=h}optional(){return new a(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,r){return new a(s??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",t=>u.URI.isUri(t),t=>t),a.Position=new a("position","A position in a text document",t=>L.Position.isPosition(t),I.Position.from),a.Range=new a("range","A range in a text document",t=>L.Range.isRange(t),I.Range.from),a.Selection=new a("selection","A selection in a text document",t=>L.Selection.isSelection(t),I.Selection.from),a.Number=new a("number","",t=>typeof t=="number",t=>t),a.String=new a("string","",t=>typeof t=="string",t=>t),a.CallHierarchyItem=new a("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,I.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,I.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",t=>t instanceof S.TestItemImpl,I.TestItem.from);class l{constructor(s,r){this.description=s,this.convert=r}}e.ApiCommandResult=l,l.Void=new l("no result",t=>t);class p{constructor(s,r,i,h,c){this.id=s,this.internalId=r,this.description=i,this.args=h,this.result=c}}e.ApiCommand=p}),define(me[233],ge([0,1,15,7,83,44,17,111]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new k.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(m.DocumentHighlight.to))),new k.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,f)=>{if((0,R.isFalsyOrEmpty)(u))return;class o extends L.SymbolInformation{static to(S){const P=new o(S.name,m.SymbolKind.to(S.kind),S.containerName||"",new L.Location(f[0],m.Range.to(S.range)));return P.detail=S.detail,P.range=P.location.range,P.selectionRange=m.Range.to(S.selectionRange),P.children=S.children?S.children.map(o.to):[],P}}return u.map(o.to)})),new k.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new k.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range,new k.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new k.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,new k.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new k.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new k.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new k.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new k.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new k.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new k.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(m.location.to))),new k.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(m.Hover.to))),new k.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(f=>L.Position.isPosition(f)),u=>u.map(m.Position.from))],new k.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(f=>{let o;for(const v of f.reverse())o=new L.SelectionRange(m.Range.to(v),o);return o}))),new k.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[k.ApiCommandArgument.String.with("query","Search string")],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>{const f=[];if(Array.isArray(u))for(let o of u)f.push(...o[1].map(m.WorkspaceSymbol.to));return f})),new k.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyItem.to))),new k.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyIncomingCall.to))),new k.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyOutgoingCall.to))),new k.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("newName","The new symbol name")],new k.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return m.WorkspaceEdit.to(u)}})),new k.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new k.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(m.DocumentLink.to))),new k.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const f=(0,C.decodeSemanticTokensDto)(u);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const f=(0,C.decodeSemanticTokensDto)(u);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new k.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new k.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,f,o)=>{if(!u)return new L.CompletionList([]);const v=u.suggestions.map(S=>m.CompletionItem.to(S,o));return new L.CompletionList(v,u.incomplete)})),new k.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new k.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return m.SignatureHelp.to(u)})),new k.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new k.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,f,o)=>n(v=>new L.CodeLens(m.Range.to(v.range),v.command&&o.fromInternal(v.command)))(u))),new k.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>L.Range.isRange(u),u=>L.Selection.isSelection(u)?m.Selection.from(u):m.Range.from(u)),k.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new k.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,f,o)=>n(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(v.command)}else{const S=new L.CodeAction(v.title,v.kind?new L.CodeActionKind(v.kind):void 0);return v.edit&&(S.edit=m.WorkspaceEdit.to(v.edit)),v.command&&(S.command=o.fromInternal(v.command)),S.isPreferred=v.isPreferred,S}})(u))),new k.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(f=>new L.ColorInformation(m.Range.to(f.range),m.Color.to(f.color))):[])),new k.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new k.ApiCommandArgument("color","The color to show and insert",u=>u instanceof L.Color,m.Color.from),new k.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:m.Range.from(u.range)}))],new k.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(m.ColorPresentation.to):[])),new k.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of Inlay objects",u=>u.map(m.InlayHint.to))),new k.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new k.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(f=>m.NotebookExclusiveDocumentPattern.to(f))})))),new k.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(m.InlineValue.to))),new k.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)])).optional(),k.ApiCommandArgument.String.with("label","").optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[k.ApiCommandArgument.Uri.with("resource","Resource to open"),k.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)])).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[k.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),k.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),k.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)]).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new k.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[k.ApiCommandArgument.TestItem],k.ApiCommandResult.Void)];class T{static register(f){D.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=T;function n(u){return f=>{if(Array.isArray(f))return f.map(u)}}function A(u){if(!Array.isArray(u))return;const f=[];for(const o of u)I.isLocationLink(o)?f.push(m.DefinitionLink.to(o)):f.push(m.location.to(o));return f}}),define(me[234],ge([0,1,18,58,3,6,2,83,26,15,7,5]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(f,o,v){const S=f.getProxy(A.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const h=this._commentControllers.get(i.handle);return h||i}else if(i&&i.$mid===7){const h=this._commentControllers.get(i.commentControlHandle);if(!h)return i;const c=h.getCommentThread(i.commentThreadHandle);return c||i}else if(i&&i.$mid===8){const h=this._commentControllers.get(i.thread.commentControlHandle);if(!h)return i;const c=h.getCommentThread(i.thread.commentThreadHandle);return c?{thread:c,text:i.text}:i}else if(i&&i.$mid===9){const h=this._commentControllers.get(i.thread.commentControlHandle);if(!h)return i;const c=h.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;let d=i.commentUniqueId,b=c.getCommentByUniqueId(d);return b||i}else if(i&&i.$mid===10){const h=this._commentControllers.get(i.thread.commentControlHandle);if(!h)return i;const c=h.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;let d=i.text,b=i.commentUniqueId,y=c.getCommentByUniqueId(b);return y?(y.body=d,y):i}return i}})}createCommentController(i,h,c){const d=P.handlePool++,b=new a(i,d,h,c);this._commentControllers.set(b.handle,b);const y=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(i.identifier))||[];return y.push(b),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(i.identifier),y),b.value}$createCommentThreadTemplate(i,h,c){const d=this._commentControllers.get(i);!d||d.$createCommentThreadTemplate(h,c)}async $updateCommentThreadTemplate(i,h,c){const d=this._commentControllers.get(i);!d||d.$updateCommentThreadTemplate(h,c)}$deleteCommentThread(i,h){const c=this._commentControllers.get(i);c&&c.$deleteCommentThread(h)}$provideCommentingRanges(i,h,c){const d=this._commentControllers.get(i);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const b=v.getDocument(R.URI.revive(h));return(0,m.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(b,c)).then(y=>y?y.map(g=>T.Range.from(g)):void 0)}$toggleReaction(i,h,c,d,b){const y=this._commentControllers.get(i);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const g=y.getCommentThread(h);if(g){const _=g.getCommentByUniqueId(d.uniqueIdInThread);if(y!==void 0&&_&&y.reactionHandler)return y.reactionHandler(_,t(b))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class E{constructor(i,h,c,d,b,y,g){this._commentControllerHandle=h,this._id=c,this._uri=d,this._range=b,this._comments=y,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputDisposables.value=new k.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),S.$createCommentThread(h,this.handle,this._id,this._uri,T.Range.from(this._range),g),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this._localDisposables.push({dispose:()=>{S.$deleteCommentThread(h,this.handle)}});const _=this;this.value={get uri(){return _.uri},get range(){return _.range},set range(w){_.range=w},get comments(){return _.comments},set comments(w){_.comments=w},get collapsibleState(){return _.collapsibleState},set collapsibleState(w){_.collapsibleState=w},get canReply(){return _.canReply},set canReply(w){_.canReply=w},get contextValue(){return _.contextValue},set contextValue(w){_.contextValue=w},get label(){return _.label},set label(w){_.label=w},dispose:()=>{_.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new k.DisposableStore);const i=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),h={};i("range")&&(h.range=T.Range.from(this._range)),i("label")&&(h.label=this.label),i("contextValue")&&(h.contextValue=this.contextValue),i("comments")&&(h.comments=this._comments.map(c=>l(this,c,this._commentsMap))),i("collapsibleState")&&(h.collapseState=s(this._collapseState)),i("canReply")&&(h.canReply=this.canReply),this.modifications={},S.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,h)}getCommentByUniqueId(i){for(let h of this._commentsMap){let c=h[0],d=h[1];if(i===d)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}E._handlePool=0,Ve([(0,L.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(i,h,c,d){this._extension=i,this._handle=h,this._id=c,this._label=d,this._threads=new Map,S.$registerCommentController(this.handle,c,d);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(y){b.options=y},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(y){b.commentingRangeProvider=y},get reactionHandler(){return b.reactionHandler},set reactionHandler(y){b.reactionHandler=y},createCommentThread(y,g,_){return b.createCommentThread(y,g,_).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{S.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,S.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,S.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,h,c,d){if(typeof i=="string"){const b=new E(this.id,this.handle,i,h,c,d,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new E(this.id,this.handle,void 0,i,h,c,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,h){const c=new E(this.id,this.handle,void 0,R.URI.revive(i),T.Range.to(h),[],this._extension.identifier);return c.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(i,h){let c=this._threads.get(i);c&&(c.range=T.Range.to(h))}$deleteCommentThread(i){let h=this._threads.get(i);h&&h.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function l(r,i,h){let c=h.get(i);c||(c=++r.commentHandle,h.set(i,c));const d=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:c,body:T.MarkdownString.from(i.body),userName:i.author.name,userIconPath:d,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>p(b)):void 0}}function p(r){return{label:r.label,iconPath:r.iconPath?T.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?R.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case n.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=u}),define(me[131],ge([0,1,2,5,7,4,14,12,17,9,8]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let A=class wn{constructor(f,o){this._logService=o,this._provider=new Map,this._proxy=f.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,o){const v=wn._handlePool++;this._provider.set(v,{provider:f,extensionId:o}),this._proxy.$registerDecorationProvider(v,o.value);const S=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(v,null);return}let E=(0,D.asArray)(P);if(E.length<=wn._maxEventSize){this._proxy.$onDidChange(v,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,E.length);const a=E.map(t=>({uri:t,rank:(0,T.count)(t.path,"/")})),l=(0,D.groupBy)(a,(t,s)=>t.rank-s.rank||(0,T.compare)(t.uri.path,s.uri.path));let p=[];e:for(let t of l){let s;for(let r of t){let i=(0,n.dirname)(r.uri.path);if(s!==i&&(s=i,p.push(r.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(v,p)});return new I.Disposable(()=>{S?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(f,o,v){if(!this._provider.has(f))return Object.create(null);const S=Object.create(null),{provider:P,extensionId:E}=this._provider.get(f);return await Promise.all(o.map(async a=>{try{const{uri:l,id:p}=a,t=await Promise.resolve(P.provideFileDecoration(m.URI.revive(l),v));if(!t)return;try{I.FileDecoration.validate(t),S[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${E.value}': ${s}`)}}catch(l){this._logService.error(l)}})),S}};A._handlePool=0,A._maxEventSize=250,A=Ve([We(0,R.IExtHostRpcService),We(1,C.ILogService)],A),e.ExtHostDecorations=A,e.IExtHostDecorations=(0,k.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[235],ge([0,1,163,117,2,5,7,15,3,12,24,52]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";var u,f,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(E,a,l,p,t,s){this._name=E,this._owner=a,this._maxDiagnosticsPerFile=l,u.set(this,void 0),f.set(this,void 0),o.set(this,void 0),this._isDisposed=!1,nt(this,o,new n.ResourceMap(r=>p.getComparisonKey(r)),"f"),nt(this,u,t,"f"),nt(this,f,s,"f")}dispose(){this._isDisposed||(Oe(this,f,"f").fire([...Oe(this,o,"f").keys()]),Oe(this,u,"f")&&Oe(this,u,"f").$clear(this._owner),Oe(this,o,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(E,a){if(!E){this.clear();return}this._checkDisposed();let l=[];if(I.URI.isUri(E)){if(!a){this.delete(E);return}Oe(this,o,"f").set(E,a.slice()),l=[E]}else if(Array.isArray(E)){l=[];let t;E=[...E].sort(v._compareIndexedTuplesByUri);for(const s of E){const[r,i]=s;if((!t||r.toString()!==t.toString())&&(t&&Oe(this,o,"f").get(t).length===0&&Oe(this,o,"f").delete(t),t=r,l.push(r),Oe(this,o,"f").set(r,[])),i){const h=Oe(this,o,"f").get(r);h&&h.push(...i)}else{const h=Oe(this,o,"f").get(r);h&&(h.length=0)}}}if(Oe(this,f,"f").fire(l),!Oe(this,u,"f"))return;const p=[];for(let t of l){let s=[];const r=Oe(this,o,"f").get(t);if(r)if(r.length>this._maxDiagnosticsPerFile){s=[];const i=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(let c of r)if(c.severity===i[h]&&s.push(C.Diagnostic.from(c))===this._maxDiagnosticsPerFile)break e;s.push({severity:L.MarkerSeverity.Info,message:(0,m.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=r.map(i=>C.Diagnostic.from(i));p.push([t,s])}Oe(this,u,"f").$changeMany(this._owner,p)}delete(E){this._checkDisposed(),Oe(this,f,"f").fire([E]),Oe(this,o,"f").delete(E),Oe(this,u,"f")&&Oe(this,u,"f").$changeMany(this._owner,[[E,void 0]])}clear(){this._checkDisposed(),Oe(this,f,"f").fire([...Oe(this,o,"f").keys()]),Oe(this,o,"f").clear(),Oe(this,u,"f")&&Oe(this,u,"f").$clear(this._owner)}forEach(E,a){this._checkDisposed();for(let l of Oe(this,o,"f").keys())E.apply(a,[l,this.get(l),this])}get(E){this._checkDisposed();const a=Oe(this,o,"f").get(E);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(E){return this._checkDisposed(),Array.isArray(Oe(this,o,"f").get(E))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(E,a){return E[0].toString()<a[0].toString()?-1:E[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=v,u=new WeakMap,f=new WeakMap,o=new WeakMap;let S=class Yt{constructor(E,a,l){this._logService=a,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:p=>p.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,Yt._mapper),this._proxy=E.getProxy(k.MainContext.MainThreadDiagnostics)}static _mapper(E){const a=new n.ResourceMap;for(const l of E)a.set(l,l);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(E,a){const{_collections:l,_proxy:p,_onDidChangeDiagnostics:t,_logService:s,_fileSystemInfoService:r}=this,i=new class{$changeMany(d,b){p.$changeMany(d,b),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",E.value,d,b.length===0?"CLEARING":b)}$clear(d){p.$clear(d),s.trace("[DiagnosticCollection] remove all (extension, owner)",E.value,d)}dispose(){p.dispose()}};let h;if(!a)a="_generated_diagnostic_collection_name_#"+Yt._idPool++,h=a;else if(!l.has(a))h=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do h=a+Yt._idPool++;while(l.has(h))}return new class extends v{constructor(){super(a,h,Yt._maxDiagnosticsPerFile,r.extUri,i,t);l.set(h,this)}dispose(){super.dispose(),l.delete(h)}}}getDiagnostics(E){if(E)return this._getDiagnostics(E);{const a=new Map,l=[];for(const p of this._collections.values())p.forEach((t,s)=>{let r=a.get(t.toString());typeof r=="undefined"&&(r=l.length,a.set(t.toString(),r),l.push([t,[]])),l[r][1]=l[r][1].concat(...s)});return l}}_getDiagnostics(E){let a=[];for(let l of this._collections.values())l.has(E)&&(a=a.concat(l.get(E)));return a}$acceptMarkersChange(E){if(!this._mirrorCollection){const a="_generated_mirror",l=new v(a,a,Yt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,l),this._mirrorCollection=l}for(const[a,l]of E)this._mirrorCollection.set(I.URI.revive(a),l.map(C.Diagnostic.to))}};S._idPool=0,S._maxDiagnosticsPerFile=1e3,S=Ve([We(1,T.ILogService),We(2,A.IExtHostFileSystemInfo)],S),e.ExtHostDiagnostics=S}),define(me[236],ge([0,1,2,5]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(R){this._proxy=R.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(C=>C?C.map(D=>m.URI.revive(D)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(C=>C?m.URI.revive(C):void 0)}}e.ExtHostDialogs=I}),define(me[237],ge([0,1,16,2,7,5,10,21,9]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(A,u,f){this._documentsAndEditors=u,this._logService=f,this._documentContentProviders=new Map,this._proxy=A.getProxy(k.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(A,u){if(Object.keys(R.Schemas).indexOf(A)>=0)throw new Error(`scheme '${A}' already registered`);const f=T._handlePool++;this._documentContentProviders.set(f,u),this._proxy.$registerTextContentProvider(f,A);let o;return typeof u.onDidChange=="function"&&(o=u.onDidChange(v=>{if(v.scheme!==A){this._logService.warn(`Provider for scheme '${A}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(f,v).then(S=>{if(!S&&typeof S!="string")return;const P=this._documentsAndEditors.getDocument(v);if(!P)return;const E=(0,D.splitLines)(S);if(!P.equalLines(E))return this._proxy.$onVirtualDocumentChange(v,S)},m.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(A,u){const f=this._documentContentProviders.get(A);return f?Promise.resolve(f.provideTextDocumentContent(L.URI.revive(u),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(me[238],ge([0,1,3,6,2,5,123,15,13,25,7]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class A{constructor(f,o){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(k.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const S of v)this._onDidRemoveDocument.fire(S.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const S of v)this._onDidAddDocument.fire(S.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const o=this._documentsAndEditors.getDocument(f);if(o)return o}getDocument(f){const o=this.getDocumentData(f);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return o.document}ensureDocumentData(f){const o=this._documentsAndEditors.getDocument(f);if(o)return Promise.resolve(o);let v=this._documentLoader.get(f.toString());return v||(v=this._proxy.$tryOpenDocument(f).then(S=>{this._documentLoader.delete(f.toString());const P=I.URI.revive(S);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(P))},S=>(this._documentLoader.delete(f.toString()),Promise.reject(S))),this._documentLoader.set(f.toString(),v)),v}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(o=>I.URI.revive(o))}$acceptModelModeChanged(f,o){const v=I.URI.revive(f),S=this._documentsAndEditors.getDocument(v);if(!S)throw new Error("unknown document");this._onDidRemoveDocument.fire(S.document),S._acceptLanguageId(o),this._onDidAddDocument.fire(S.document)}$acceptModelSaved(f){const o=I.URI.revive(f),v=this._documentsAndEditors.getDocument(o);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(f,o){const v=I.URI.revive(f),S=this._documentsAndEditors.getDocument(v);if(!S)throw new Error("unknown document");S._acceptIsDirty(o),this._onDidChangeDocument.fire({document:S.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,o,v){const S=I.URI.revive(f),P=this._documentsAndEditors.getDocument(S);if(!P)throw new Error("unknown document");P._acceptIsDirty(v),P.onEvents(o);let E;o.isUndoing?E=n.TextDocumentChangeReason.Undo:o.isRedoing&&(E=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:P.document,contentChanges:o.changes.map(a=>({range:C.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:E}))}setWordDefinitionFor(f,o){(0,R.setWordDefinitionFor)(f,o)}}e.ExtHostDocuments=A}),define(me[45],ge([0,1,56,3,6,2,4,5,123,14,130,15,12,24,10,94,139]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(l,p){this._extHostRpc=l,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const p=[],t=[],s=[];if(l.removedDocuments)for(const r of l.removedDocuments){const i=k.URI.revive(r),h=this._documents.get(i);h?.unref()&&(this._documents.delete(i),p.push(h.value))}if(l.addedDocuments)for(const r of l.addedDocuments){const i=k.URI.revive(r.uri);let h=this._documents.get(i);if(h&&i.scheme!==o.Schemas.vscodeNotebookCell&&i.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);h||(h=new P(new D.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(i,h),t.push(h.value)),h.ref()}if(l.removedEditors)for(const r of l.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&s.push(i)}if(l.addedEditors)for(const r of l.addedEditors){const i=k.URI.revive(r.documentUri);m.ok(this._documents.has(i),`document '${i}' does not exist`),m.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const h=this._documents.get(i).value,c=new n.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>h.document),r.selections.map(A.Selection.to),r.options,r.visibleRanges.map(d=>A.Range.to(d)),typeof r.editorPosition=="number"?A.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,c)}l.newActiveEditor!==void 0&&(m.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,I.dispose)(p),(0,I.dispose)(s),l.removedDocuments&&this._onDidRemoveDocuments.fire(p),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return l?p:p?.value}allEditors(){return[...this._editors.values()]}};E=Ve([We(0,T.IExtHostRpcService),We(1,u.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[239],ge([0,1,2,5,6,7,15,147,9,23]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const o=this._schemes.indexOf(f);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),o=[];let v,S,P=14,E=14;for(const a of f){let l=v?(0,D.commonPrefixLength)(v,a):0;for(l===0?S=1:S=E;l<a.length;l++)l+1===a.length?(P=E,E=9):E+=1,o.push([S,a.toUpperCase().charCodeAt(l),E]),o.push([S,a.toLowerCase().charCodeAt(l),E]),S=E;v=a,E=P}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new C.StateMachine(o)}}provideDocumentLinks(f){this._initStateMachine();const o=[],v=C.LinkComputer.computeLinks({getLineContent(S){return f.lineAt(S-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const S of v){const P=R.DocumentLink.to(S);P.target&&o.push(P)}return o}}class A{constructor(f,o){this._extHostLanguageFeatures=o,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,o,v,S={}){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(P,v);let E=2;S.isCaseSensitive&&(E+=1024),S.isReadonly&&(E+=2048),typeof v.copy=="function"&&(E+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(P,o,E).catch(l=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${o}`),console.error(l)});const a=v.onDidChangeFile(l=>{const p=[];for(const t of l){let{uri:s,type:r}=t;if(s.scheme!==o)continue;let i;switch(r){case k.FileChangeType.Changed:i=0;break;case k.FileChangeType.Created:i=1;break;case k.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}p.push({resource:s,type:i})}this._proxy.$onFileSystemChange(P,p)});return(0,I.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(f){const{type:o,ctime:v,mtime:S,size:P,permissions:E}=f;return{type:o,ctime:v,mtime:S,size:P,permissions:E}}$stat(f,o){return Promise.resolve(this._getFsProvider(f).stat(m.URI.revive(o))).then(v=>A._asIStat(v))}$readdir(f,o){return Promise.resolve(this._getFsProvider(f).readDirectory(m.URI.revive(o)))}$readFile(f,o){return Promise.resolve(this._getFsProvider(f).readFile(m.URI.revive(o))).then(v=>T.VSBuffer.wrap(v))}$writeFile(f,o,v,S){return Promise.resolve(this._getFsProvider(f).writeFile(m.URI.revive(o),v.buffer,S))}$delete(f,o,v){return Promise.resolve(this._getFsProvider(f).delete(m.URI.revive(o),v))}$rename(f,o,v,S){return Promise.resolve(this._getFsProvider(f).rename(m.URI.revive(o),m.URI.revive(v),S))}$copy(f,o,v,S){const P=this._getFsProvider(f);if(!P.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(P.copy(m.URI.revive(o),m.URI.revive(v),S))}$mkdir(f,o){return Promise.resolve(this._getFsProvider(f).createDirectory(m.URI.revive(o)))}$watch(f,o,v,S){const P=this._getFsProvider(f).watch(m.URI.revive(v),S);this._watches.set(o,P)}$unwatch(f,o){const v=this._watches.get(o);v&&(v.dispose(),this._watches.delete(o))}$open(f,o,v){const S=this._getFsProvider(f);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(m.URI.revive(o),v))}$close(f,o){const v=this._getFsProvider(f);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(o))}$read(f,o,v,S){const P=this._getFsProvider(f);if(!P.read)throw new Error('FileSystemProvider does not implement "read"');const E=T.VSBuffer.alloc(S);return Promise.resolve(P.read(o,v,E.buffer,0,S)).then(a=>E.slice(0,a))}$write(f,o,v,S){const P=this._getFsProvider(f);if(!P.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(P.write(o,v,S.buffer,0,S.byteLength))}_getFsProvider(f){const o=this._fsProvider.get(f);if(!o){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return o}}e.ExtHostFileSystem=A}),define(me[91],ge([0,1,5,42,7,23,4,14,52]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class xt{constructor(A,u){const f=A.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return f.$stat(o).catch(xt._handleError)},readDirectory(o){return f.$readdir(o).catch(xt._handleError)},createDirectory(o){return f.$mkdir(o).catch(xt._handleError)},async readFile(o){return f.$readFile(o).then(v=>v.buffer).catch(xt._handleError)},writeFile(o,v){return f.$writeFile(o,k.VSBuffer.wrap(v)).catch(xt._handleError)},delete(o,v){return f.$delete(o,{recursive:!1,useTrash:!1,...v}).catch(xt._handleError)},rename(o,v,S){return f.$rename(o,v,{overwrite:!1,...S}).catch(xt._handleError)},copy(o,v,S){return f.$copy(o,v,{overwrite:!1,...S}).catch(xt._handleError)},isWritableFileSystem(o){const v=u.getCapabilities(o);if(typeof v=="number")return!(v&2048)}})}static _handleError(A){if(!(A instanceof Error))throw new I.FileSystemError(String(A));if(A.name==="ENOPRO")throw I.FileSystemError.Unavailable(A.message);switch(A.name){case L.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(A.message);case L.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(A.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(A.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(A.message);case L.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(A.message);case L.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(A.message);default:throw new I.FileSystemError(A.message,A.name)}}};T=Ve([We(0,C.IExtHostRpcService),We(1,D.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(me[240],ge([0,1,2,44]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(R,C,D,T){this._extHostNotebooks=C,this._textDocumentsAndEditors=D,this._commands=T;const n=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",A=>!0,A=>A),new L.ApiCommandArgument("resource","Interactive resource Uri",A=>!0,A=>A),new L.ApiCommandArgument("controllerId","Notebook controller Id",A=>!0,A=>A),new L.ApiCommandArgument("title","Interactive editor title",A=>!0,A=>A)],new L.ApiCommandResult("Notebook and input URI",A=>{if(A.notebookEditorId!==void 0){const u=this._extHostNotebooks.getEditorById(A.notebookEditorId);return{notebookUri:m.URI.revive(A.notebookUri),inputUri:m.URI.revive(A.inputUri),notebookEditor:u.apiEditor}}return{notebookUri:m.URI.revive(A.notebookUri),inputUri:m.URI.revive(A.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(R,C,D,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:D,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=I}),define(me[241],ge([0,1,6,5]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(R){this._handlePool=0,this._proxy=R.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,R),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=I}),define(me[242],ge([0,1,2,25,15,7,5,9,41,17,13,144,6,111,76,87,46,16,3]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentSymbols(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideDocumentSymbols(re,ee);if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof k.DocumentSymbol?ae.map(I.DocumentSymbol.from):a._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(V){V=V.slice(0).sort((ae,Y)=>{let oe=ae.location.range.start.compareTo(Y.location.range.start);return oe===0&&(oe=Y.location.range.end.compareTo(ae.location.range.end)),oe});const ee=[],re=[];for(const ae of V){const Y={name:ae.name||"!!MISSING: name!!",kind:I.SymbolKind.from(ae.kind),tags:ae.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:I.Range.from(ae.location.range),selectionRange:I.Range.from(ae.location.range),children:[]};for(;;){if(re.length===0){re.push(Y),ee.push(Y);break}const oe=re[re.length-1];if(D.Range.containsRange(oe.range,Y.range)&&!D.Range.equalsRange(oe.range,Y.range)){oe.children&&oe.children.push(Y),re.push(Y);break}re.pop()}}return ee}}class l{constructor(V,ee,re){this._documents=V,this._commands=ee,this._provider=re,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideCodeLenses(re,ee);if(!ae||ee.isCancellationRequested)return;const Y=this._cache.add(ae),oe=new u.DisposableStore;this._disposables.set(Y,oe);const ve={cacheId:Y,lenses:[]};for(let Me=0;Me<ae.length;Me++)ve.lenses.push({cacheId:[Y,Me],range:I.Range.from(ae[Me].range),command:this._commands.toInternal(ae[Me].command,oe)});return ve}async resolveCodeLens(V,ee){const re=V.cacheId&&this._cache.get(...V.cacheId);if(!re)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?ae=re:ae=await this._provider.resolveCodeLens(re,ee),ae||(ae=re),ee.isCancellationRequested)return;const Y=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!Y)return V.command=this._commands.toInternal(ae.command??l._badCmd,Y),V}releaseCodeLenses(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(je){return Array.isArray(je)?je.map(I.DefinitionLink.from):je?[I.DefinitionLink.from(je)]:[]}class t{constructor(V,ee){this._documents=V,this._provider=ee}async provideDefinition(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideDefinition(ae,Y,re);return p(oe)}}class s{constructor(V,ee){this._documents=V,this._provider=ee}async provideDeclaration(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideDeclaration(ae,Y,re);return p(oe)}}class r{constructor(V,ee){this._documents=V,this._provider=ee}async provideImplementation(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideImplementation(ae,Y,re);return p(oe)}}class i{constructor(V,ee){this._documents=V,this._provider=ee}async provideTypeDefinition(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideTypeDefinition(ae,Y,re);return p(oe)}}class h{constructor(V,ee){this._documents=V,this._provider=ee}async provideHover(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideHover(ae,Y,re);if(!(!oe||(0,T.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(Y)),oe.range||(oe.range=new k.Range(Y,Y)),I.Hover.from(oe)}}class c{constructor(V,ee){this._documents=V,this._provider=ee}async provideEvaluatableExpression(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideEvaluatableExpression(ae,Y,re);if(oe)return I.EvaluatableExpression.from(oe)}}class d{constructor(V,ee){this._documents=V,this._provider=ee}async provideInlineValues(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=await this._provider.provideInlineValues(Y,I.Range.to(ee),I.InlineValueContext.to(re),ae);if(Array.isArray(oe))return oe.map(ve=>I.InlineValue.from(ve))}}class b{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentHighlights(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideDocumentHighlights(ae,Y,re);if(Array.isArray(oe))return oe.map(I.DocumentHighlight.from)}}class y{constructor(V,ee){this._documents=V,this._provider=ee}async provideLinkedEditingRanges(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideLinkedEditingRanges(ae,Y,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,T.coalesce)(oe.ranges.map(I.Range.from)),wordPattern:oe.wordPattern}}}class g{constructor(V,ee){this._documents=V,this._provider=ee}async provideReferences(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Position.to(ee),ve=await this._provider.provideReferences(Y,oe,re,ae);if(Array.isArray(ve))return ve.map(I.location.from)}}class _{constructor(V,ee,re,ae,Y,oe,ve){this._documents=V,this._commands=ee,this._diagnostics=re,this._provider=ae,this._logService=Y,this._extension=oe,this._apiDeprecation=ve,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=A.Selection.isISelection(ee)?I.Selection.to(ee):I.Range.to(ee),ve=[];for(const Z of this._diagnostics.getDiagnostics(V))if(oe.intersection(Z.range)&&ve.push(Z)>_._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:re.only?new k.CodeActionKind(re.only):void 0,triggerKind:I.CodeActionTriggerKind.to(re.trigger)},qe=await this._provider.provideCodeActions(Y,oe,Me,ae);if(!(0,T.isNonEmptyArray)(qe)||ae.isCancellationRequested)return;const Ke=this._cache.add(qe),Se=new u.DisposableStore;this._disposables.set(Ke,Se);const tt=[];for(let Z=0;Z<qe.length;Z++){const te=qe[Z];!te||(_._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,Se)})):(Me.only&&(te.kind?Me.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ke,Z],title:te.title,command:te.command&&this._commands.toInternal(te.command,Se),diagnostics:te.diagnostics&&te.diagnostics.map(I.Diagnostic.from),edit:te.edit&&I.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:te.disabled?.reason})))}return{cacheId:Ke,actions:tt}}async resolveCodeAction(V,ee){const[re,ae]=V,Y=this._cache.get(re,ae);if(!Y||_._isCommand(Y)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(Y,ee)??Y;return oe?.edit?I.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}_._maxCodeActionsPerFile=1e3;class w{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentFormattingEdits(V,ee,re){const ae=this._documents.getDocument(V),Y=await this._provider.provideDocumentFormattingEdits(ae,ee,re);if(Array.isArray(Y))return Y.map(I.TextEdit.from)}}class F{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentRangeFormattingEdits(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Range.to(ee),ve=await this._provider.provideDocumentRangeFormattingEdits(Y,oe,re,ae);if(Array.isArray(ve))return ve.map(I.TextEdit.from)}}class O{constructor(V,ee){this._documents=V,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,ee,re,ae,Y){const oe=this._documents.getDocument(V),ve=I.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(oe,ve,re,ae,Y);if(Array.isArray(Me))return Me.map(I.TextEdit.from)}}class G{constructor(V,ee){this._provider=V,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(V,ee){const re=R.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(V,ee);if((0,T.isNonEmptyArray)(ae))for(const Y of ae){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const oe=R.IdObject.mixin(I.WorkspaceSymbol.from(Y));this._symbolCache.set(oe._id,Y),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(V,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const re=this._symbolCache.get(V._id);if(re){const ae=await this._provider.resolveWorkspaceSymbol(re,ee);return ae&&(0,L.mixin)(V,I.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(V){const ee=this._resultCache.get(V);if(ee){for(let[re,ae]=ee;re<=ae;re++)this._symbolCache.delete(re);this._resultCache.delete(V)}}}class K{constructor(V,ee,re){this._documents=V,this._provider=ee,this._logService=re}static supportsResolving(V){return typeof V.prepareRename=="function"}async provideRenameEdits(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Position.to(ee);try{const ve=await this._provider.provideRenameEdits(Y,oe,re,ae);return ve?I.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=K._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(V,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(V),Y=I.Position.to(ee);try{const oe=await this._provider.prepareRename(ae,Y,re);let ve,Me;if(k.Range.isRange(oe)?(ve=oe,Me=ae.getText(oe)):(0,n.isObject)(oe)&&(ve=oe.range,Me=oe.placeholder),!ve||!Me)return;if(ve.start.line>Y.line||ve.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ve),text:Me}}catch(oe){const ve=K._asMessage(oe);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class U{constructor(V,ee){this.resultId=V,this.tokens=ee}}class W{constructor(V,ee){this._documents=V,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(V,ee,re){const ae=this._documents.getDocument(V),Y=ee!==0?this._previousResults.get(ee):null;let oe=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,Y.resultId,re):await this._provider.provideDocumentSemanticTokens(ae,re);return Y&&this._previousResults.delete(ee),oe?(oe=W._fixProvidedSemanticTokens(oe),this._send(W._convertToEdits(Y,oe),oe)):null}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return W._isSemanticTokens(V)?W._isCorrectSemanticTokens(V)?V:new k.SemanticTokens(new Uint32Array(V.data),V.resultId):W._isSemanticTokensEdits(V)?W._isCorrectSemanticTokensEdits(V)?V:new k.SemanticTokensEdits(V.edits.map(ee=>new k.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const ee of V.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,ee){if(!W._isSemanticTokens(ee)||!V||!V.tokens)return ee;const re=V.tokens,ae=re.length,Y=ee.data,oe=Y.length;let ve=0;const Me=Math.min(ae,oe);for(;ve<Me&&re[ve]===Y[ve];)ve++;if(ve===ae&&ve===oe)return new k.SemanticTokensEdits([],ee.resultId);let qe=0;const Ke=Me-ve;for(;qe<Ke&&re[ae-qe-1]===Y[oe-qe-1];)qe++;return new k.SemanticTokensEdits([{start:ve,deleteCount:ae-ve-qe,data:Y.subarray(ve,oe-qe)}],ee.resultId)}_send(V,ee){if(W._isSemanticTokens(V)){const re=this._nextResultId++;return this._previousResults.set(re,new U(V.resultId,V.data)),(0,f.encodeSemanticTokensDto)({id:re,type:"full",data:V.data})}if(W._isSemanticTokensEdits(V)){const re=this._nextResultId++;return W._isSemanticTokens(ee)?this._previousResults.set(re,new U(ee.resultId,ee.data)):this._previousResults.set(re,new U(V.resultId)),(0,f.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(V.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class M{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentRangeSemanticTokens(V,ee,re){const ae=this._documents.getDocument(V),Y=await this._provider.provideDocumentRangeSemanticTokens(ae,I.Range.to(ee),re);return Y?this._send(Y):null}_send(V){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=M;class x{constructor(V,ee,re,ae,Y){this._documents=V,this._commands=ee,this._provider=re,this._apiDeprecation=ae,this._extension=Y,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Position.to(ee),ve=Y.getWordRangeAtPosition(oe)||new k.Range(oe,oe),Me=ve.with({end:oe}),qe=new S.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Y,oe,ae,I.CompletionContext.to(re));if(!Ke||ae.isCancellationRequested)return;const Se=Array.isArray(Ke)?new k.CompletionList(Ke):Ke,tt=x.supportsResolving(this._provider)?this._cache.add(Se.items):this._cache.add([]),Z=new u.DisposableStore;this._disposables.set(tt,Z);const te=[],pe={x:tt,b:te,a:{replace:I.Range.from(ve),insert:I.Range.from(Me)},c:Se.isIncomplete||void 0,d:qe.elapsed()};for(let xe=0;xe<Se.items.length;xe++){const Je=Se.items[xe],rt=this._convertCompletionItem(Je,[tt,xe],Me,ve);te.push(rt)}return pe}async resolveCompletionItem(V,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...V);if(!re)return;const ae=await this._provider.resolveCompletionItem(re,ee);if(!!ae)return this._convertCompletionItem(ae,V)}releaseCompletionItems(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,ee,re,ae){const Y=this._disposables.get(ee[0]);if(!Y)throw Error("DisposableStore is missing...");const oe={x:ee,a:V.label,b:V.kind!==void 0?I.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(I.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(V.command,Y)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=V.textEdit.newText):typeof V.insertText=="string"?oe.h=V.insertText:V.insertText instanceof k.SnippetString&&(oe.h=V.insertText.value,oe.i|=4);let ve;return V.textEdit?ve=V.textEdit.range:V.range&&(ve=V.range),k.Range.isRange(ve)?oe.j=I.Range.from(ve):ve&&(!re?.isEqual(ve.inserting)||!ae?.isEqual(ve.replacing))&&(oe.j={insert:I.Range.from(ve.inserting),replace:I.Range.from(ve.replacing)}),oe}}class B{constructor(V,ee,re){this._documents=V,this._provider=ee,this._commands=re,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Position.to(ee),ve=await this._provider.provideInlineCompletionItems(Y,oe,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:I.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:re.triggerKind},ae);if(!ve||ae.isCancellationRequested)return;const Me=(0,n.isArray)(ve)?{items:ve}:ve,qe=this._cache.add(Me.items);let Ke;return{pid:qe,items:Me.items.map((Se,tt)=>{let Z;return Se.command&&(Ke||(Ke=new u.DisposableStore,this._disposables.set(qe,Ke)),Z=this._commands.toInternal(Se.command,Ke)),{text:Se.text,range:Se.range?I.Range.from(Se.range):void 0,command:Z,idx:tt}})}}disposeCompletions(V){this._cache.delete(V);const ee=this._disposables.get(V);ee&&ee.clear(),this._disposables.delete(V)}handleDidShowCompletionItem(V,ee){const re=this._cache.get(V,ee);re&&N.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class N{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(V){let ee=N.map.get(V);return ee||(ee=new N,N.map.set(V,ee)),ee}fireOnDidShowCompletionItem(V){this._onDidShowCompletionItemEmitter.fire(V)}}e.InlineCompletionController=N,N.map=new WeakMap;class z{constructor(V,ee){this._documents=V,this._provider=ee,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Position.to(ee),ve=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Y,oe,ae,ve);if(Me){const qe=this._cache.add([Me]);return{...I.SignatureHelp.from(Me),id:qe}}}reviveContext(V){let ee;if(V.activeSignatureHelp){const re=I.SignatureHelp.to(V.activeSignatureHelp),ae=this._cache.get(V.activeSignatureHelp.id,0);ae?(ee=ae,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...V,activeSignatureHelp:ee}}releaseSignatureHelp(V){this._cache.delete(V)}}class H{constructor(V,ee){this._documents=V,this._provider=ee}async provideInlayHints(V,ee,re){const ae=this._documents.getDocument(V),Y=await this._provider.provideInlayHints(ae,I.Range.to(ee),re);return Y?{hints:Y.map(I.InlayHint.from)}:void 0}}class Q{constructor(V,ee){this._documents=V,this._provider=ee,this._cache=new v.Cache("DocumentLink")}async provideLinks(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(ae)||ae.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(Q._validateLink).map(I.DocumentLink.from)};{const Y=this._cache.add(ae),oe={links:[],id:Y};for(let ve=0;ve<ae.length;ve++){if(!Q._validateLink(ae[ve]))continue;const Me=I.DocumentLink.from(ae[ve]);Me.cacheId=[Y,ve],oe.links.push(Me)}return oe}}}static _validateLink(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...V);if(!re)return;const ae=await this._provider.resolveDocumentLink(re,ee);if(!(!ae||!Q._validateLink(ae)))return I.DocumentLink.from(ae)}releaseLinks(V){this._cache.delete(V)}}class X{constructor(V,ee){this._documents=V,this._provider=ee}async provideColors(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideDocumentColors(re,ee);return Array.isArray(ae)?ae.map(oe=>({color:I.Color.from(oe.color),range:I.Range.from(oe.range)})):[]}async provideColorPresentations(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Range.to(ee.range),oe=I.Color.to(ee.color),ve=await this._provider.provideColorPresentations(oe,{document:ae,range:Y},re);if(!!Array.isArray(ve))return ve.map(I.ColorPresentation.from)}}class fe{constructor(V,ee){this._documents=V,this._provider=ee}async provideFoldingRanges(V,ee,re){const ae=this._documents.getDocument(V),Y=await this._provider.provideFoldingRanges(ae,ee,re);if(!!Array.isArray(Y))return Y.map(I.FoldingRange.from)}}class _e{constructor(V,ee,re){this._documents=V,this._provider=ee,this._logService=re}async provideSelectionRanges(V,ee,re){const ae=this._documents.getDocument(V),Y=ee.map(I.Position.to),oe=await this._provider.provideSelectionRanges(ae,Y,re);if(!(0,T.isNonEmptyArray)(oe))return[];if(oe.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<Y.length;Me++){const qe=[];ve.push(qe);let Ke=Y[Me],Se=oe[Me];for(;;){if(!Se.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(I.SelectionRange.from(Se)),!Se.parent)break;Ke=Se.range,Se=Se.parent}}return ve}}class ye{constructor(V,ee){this._documents=V,this._provider=ee,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.prepareCallHierarchy(ae,Y,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideCallsTo(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(ae,re);if(!!Y)return Y.map(oe=>({from:this._cacheAndConvertItem(V,oe.from),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}async provideCallsFrom(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(ae,re);if(!!Y)return Y.map(oe=>({to:this._cacheAndConvertItem(V,oe.to),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,ee){const re=this._cache.get(V),ae=I.CallHierarchyItem.from(ee,V,re.size.toString(36));return re.set(ae._itemId,ee),ae}_itemFromCache(V,ee){return this._cache.get(V)?.get(ee)}}class Re{constructor(V,ee){this._documents=V,this._provider=ee,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.prepareTypeHierarchy(ae,Y,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideSupertypes(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(ae,re);if(!!Y)return Y.map(oe=>this._cacheAndConvertItem(V,oe))}async provideSubtypes(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(ae,re);if(!!Y)return Y.map(oe=>this._cacheAndConvertItem(V,oe))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,ee){const re=this._cache.get(V),ae=I.TypeHierarchyItem.from(ee,V,re.size.toString(36));return re.set(ae._itemId,ee),ae}_itemFromCache(V,ee){return this._cache.get(V)?.get(ee)}}class $e{constructor(V,ee){this.adapter=V,this.extension=ee}}class Be{constructor(V,ee,re,ae,Y,oe,ve){this._adapter=new Map,this._uriTransformer=ee,this._proxy=V.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ae,this._diagnostics=Y,this._logService=oe,this._apiDeprecation=ve}_transformDocumentSelector(V){return(0,T.coalesce)((0,T.asArray)(V).map(ee=>this._doTransformDocumentSelector(ee)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:I.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new k.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return Be._handlePool++}_withAdapter(V,ee,re,ae,Y=!1){const oe=this._adapter.get(V);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof ee){let ve;oe.extension&&(ve=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(oe.adapter,oe.extension),qe=oe.extension;return qe&&Promise.resolve(Me).then(()=>this._logService.trace(`[${qe.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Ke=>{Y&&Ke instanceof P.CancellationError||(this._logService.error(`[${qe.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,ee){const re=this._nextHandle();return this._adapter.set(re,new $e(V,ee)),re}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,ee,re,ae){const Y=this._addNewAdapter(new a(this._documents,re),V),oe=ae&&ae.label||Be._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(ee),oe),this._createDisposable(Y)}$provideDocumentSymbols(V,ee,re){return this._withAdapter(V,a,ae=>ae.provideDocumentSymbols(m.URI.revive(ee),re),void 0)}registerCodeLensProvider(V,ee,re){const ae=this._nextHandle(),Y=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new $e(new l(this._documents,this._commands.converter,re),V)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(ee),Y);let oe=this._createDisposable(ae);if(Y!==void 0){const ve=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Y));oe=k.Disposable.from(oe,ve)}return oe}$provideCodeLenses(V,ee,re){return this._withAdapter(V,l,ae=>ae.provideCodeLenses(m.URI.revive(ee),re),void 0)}$resolveCodeLens(V,ee,re){return this._withAdapter(V,l,ae=>ae.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(V,ee){this._withAdapter(V,l,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(V,ee,re){const ae=this._addNewAdapter(new t(this._documents,re),V);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDefinition(V,ee,re,ae){return this._withAdapter(V,t,Y=>Y.provideDefinition(m.URI.revive(ee),re,ae),[])}registerDeclarationProvider(V,ee,re){const ae=this._addNewAdapter(new s(this._documents,re),V);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDeclaration(V,ee,re,ae){return this._withAdapter(V,s,Y=>Y.provideDeclaration(m.URI.revive(ee),re,ae),[])}registerImplementationProvider(V,ee,re){const ae=this._addNewAdapter(new r(this._documents,re),V);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideImplementation(V,ee,re,ae){return this._withAdapter(V,r,Y=>Y.provideImplementation(m.URI.revive(ee),re,ae),[])}registerTypeDefinitionProvider(V,ee,re){const ae=this._addNewAdapter(new i(this._documents,re),V);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideTypeDefinition(V,ee,re,ae){return this._withAdapter(V,i,Y=>Y.provideTypeDefinition(m.URI.revive(ee),re,ae),[])}registerHoverProvider(V,ee,re,ae){const Y=this._addNewAdapter(new h(this._documents,re),V);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(ee)),this._createDisposable(Y)}$provideHover(V,ee,re,ae){return this._withAdapter(V,h,Y=>Y.provideHover(m.URI.revive(ee),re,ae),void 0)}registerEvaluatableExpressionProvider(V,ee,re,ae){const Y=this._addNewAdapter(new c(this._documents,re),V);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(ee)),this._createDisposable(Y)}$provideEvaluatableExpression(V,ee,re,ae){return this._withAdapter(V,c,Y=>Y.provideEvaluatableExpression(m.URI.revive(ee),re,ae),void 0)}registerInlineValuesProvider(V,ee,re,ae){const Y=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new d(this._documents,re),V);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(ee),Y);let ve=this._createDisposable(oe);if(Y!==void 0){const Me=re.onDidChangeInlineValues(qe=>this._proxy.$emitInlineValuesEvent(Y));ve=k.Disposable.from(ve,Me)}return ve}$provideInlineValues(V,ee,re,ae,Y){return this._withAdapter(V,d,oe=>oe.provideInlineValues(m.URI.revive(ee),re,ae,Y),void 0)}registerDocumentHighlightProvider(V,ee,re){const ae=this._addNewAdapter(new b(this._documents,re),V);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDocumentHighlights(V,ee,re,ae){return this._withAdapter(V,b,Y=>Y.provideDocumentHighlights(m.URI.revive(ee),re,ae),void 0)}registerLinkedEditingRangeProvider(V,ee,re){const ae=this._addNewAdapter(new y(this._documents,re),V);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideLinkedEditingRanges(V,ee,re,ae){return this._withAdapter(V,y,async Y=>{const oe=await Y.provideLinkedEditingRanges(m.URI.revive(ee),re,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Be._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(V,ee,re){const ae=this._addNewAdapter(new g(this._documents,re),V);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideReferences(V,ee,re,ae,Y){return this._withAdapter(V,g,oe=>oe.provideReferences(m.URI.revive(ee),re,ae,Y),void 0)}registerCodeActionProvider(V,ee,re,ae){const Y=new u.DisposableStore,oe=this._addNewAdapter(new _(this._documents,this._commands.converter,this._diagnostics,re,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(ee),{providedKinds:ae?.providedCodeActionKinds?.map(ve=>ve.value),documentation:ae?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,Y)}))},Be._extLabel(V),Boolean(re.resolveCodeAction)),Y.add(this._createDisposable(oe)),Y}$provideCodeActions(V,ee,re,ae,Y){return this._withAdapter(V,_,oe=>oe.provideCodeActions(m.URI.revive(ee),re,ae,Y),void 0)}$resolveCodeAction(V,ee,re){return this._withAdapter(V,_,ae=>ae.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(V,ee){this._withAdapter(V,_,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(V,ee,re){const ae=this._addNewAdapter(new w(this._documents,re),V);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(ee),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(V,ee,re,ae){return this._withAdapter(V,w,Y=>Y.provideDocumentFormattingEdits(m.URI.revive(ee),re,ae),void 0)}registerDocumentRangeFormattingEditProvider(V,ee,re){const ae=this._addNewAdapter(new F(this._documents,re),V);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(ee),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(V,ee,re,ae,Y){return this._withAdapter(V,F,oe=>oe.provideDocumentRangeFormattingEdits(m.URI.revive(ee),re,ae,Y),void 0)}registerOnTypeFormattingEditProvider(V,ee,re,ae){const Y=this._addNewAdapter(new O(this._documents,re),V);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(ee),ae,V.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(V,ee,re,ae,Y,oe){return this._withAdapter(V,O,ve=>ve.provideOnTypeFormattingEdits(m.URI.revive(ee),re,ae,Y,oe),void 0)}registerWorkspaceSymbolProvider(V,ee){const re=this._addNewAdapter(new G(ee,this._logService),V);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(V,ee,re){return this._withAdapter(V,G,ae=>ae.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(V,ee,re){return this._withAdapter(V,G,ae=>ae.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(V,ee){this._withAdapter(V,G,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(V,ee,re){const ae=this._addNewAdapter(new K(this._documents,re,this._logService),V);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(ee),K.supportsResolving(re)),this._createDisposable(ae)}$provideRenameEdits(V,ee,re,ae,Y){return this._withAdapter(V,K,oe=>oe.provideRenameEdits(m.URI.revive(ee),re,ae,Y),void 0)}$resolveRenameLocation(V,ee,re,ae){return this._withAdapter(V,K,Y=>Y.resolveRenameLocation(m.URI.revive(ee),re,ae),void 0)}registerDocumentSemanticTokensProvider(V,ee,re,ae){const Y=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new $e(new W(this._documents,re),V)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(ee),ae,oe);let ve=this._createDisposable(Y);if(oe){const Me=re.onDidChangeSemanticTokens(qe=>this._proxy.$emitDocumentSemanticTokensEvent(oe));ve=k.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(V,ee,re,ae){return this._withAdapter(V,W,Y=>Y.provideDocumentSemanticTokens(m.URI.revive(ee),re,ae),null,!0)}$releaseDocumentSemanticTokens(V,ee){this._withAdapter(V,W,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(V,ee,re,ae){const Y=this._addNewAdapter(new M(this._documents,re),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(ee),ae),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(V,ee,re,ae){return this._withAdapter(V,M,Y=>Y.provideDocumentRangeSemanticTokens(m.URI.revive(ee),re,ae),null,!0)}registerCompletionItemProvider(V,ee,re,ae){const Y=this._addNewAdapter(new x(this._documents,this._commands.converter,re,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(ee),ae,x.supportsResolving(re),`${V.identifier.value}(${ae.join("")})`),this._createDisposable(Y)}$provideCompletionItems(V,ee,re,ae,Y){return this._withAdapter(V,x,oe=>oe.provideCompletionItems(m.URI.revive(ee),re,ae,Y),void 0)}$resolveCompletionItem(V,ee,re){return this._withAdapter(V,x,ae=>ae.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(V,ee){this._withAdapter(V,x,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(V,ee,re){const ae=this._addNewAdapter(new B(this._documents,re,this._commands.converter),V);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideInlineCompletions(V,ee,re,ae,Y){return this._withAdapter(V,B,oe=>oe.provideInlineCompletions(m.URI.revive(ee),re,ae,Y),void 0)}$handleInlineCompletionDidShow(V,ee,re){this._withAdapter(V,B,async ae=>{ae.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(V,ee){this._withAdapter(V,B,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(V,ee,re,ae){const Y=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new z(this._documents,re),V);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(ee),Y),this._createDisposable(oe)}$provideSignatureHelp(V,ee,re,ae,Y){return this._withAdapter(V,z,oe=>oe.provideSignatureHelp(m.URI.revive(ee),re,ae,Y),void 0)}$releaseSignatureHelp(V,ee){this._withAdapter(V,z,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(V,ee,re){const ae=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new H(this._documents,re),V);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(ee),ae);let oe=this._createDisposable(Y);if(ae!==void 0){const ve=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ae));oe=k.Disposable.from(oe,ve)}return oe}$provideInlayHints(V,ee,re,ae){return this._withAdapter(V,H,Y=>Y.provideInlayHints(m.URI.revive(ee),re,ae),void 0)}registerDocumentLinkProvider(V,ee,re){const ae=this._addNewAdapter(new Q(this._documents,re),V);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(V,ee,re){return this._withAdapter(V,Q,ae=>ae.provideLinks(m.URI.revive(ee),re),void 0)}$resolveDocumentLink(V,ee,re){return this._withAdapter(V,Q,ae=>ae.resolveLink(ee,re),void 0)}$releaseDocumentLinks(V,ee){this._withAdapter(V,Q,re=>re.releaseLinks(ee),void 0)}registerColorProvider(V,ee,re){const ae=this._addNewAdapter(new X(this._documents,re),V);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDocumentColors(V,ee,re){return this._withAdapter(V,X,ae=>ae.provideColors(m.URI.revive(ee),re),[])}$provideColorPresentations(V,ee,re,ae){return this._withAdapter(V,X,Y=>Y.provideColorPresentations(m.URI.revive(ee),re,ae),void 0)}registerFoldingRangeProvider(V,ee,re){const ae=this._nextHandle(),Y=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new $e(new fe(this._documents,re),V)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(ee),Y);let oe=this._createDisposable(ae);if(Y!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));oe=k.Disposable.from(oe,ve)}return oe}$provideFoldingRanges(V,ee,re,ae){return this._withAdapter(V,fe,Y=>Y.provideFoldingRanges(m.URI.revive(ee),re,ae),void 0)}registerSelectionRangeProvider(V,ee,re){const ae=this._addNewAdapter(new _e(this._documents,re,this._logService),V);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideSelectionRanges(V,ee,re,ae){return this._withAdapter(V,_e,Y=>Y.provideSelectionRanges(m.URI.revive(ee),re,ae),[])}registerCallHierarchyProvider(V,ee,re){const ae=this._addNewAdapter(new ye(this._documents,re),V);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$prepareCallHierarchy(V,ee,re,ae){return this._withAdapter(V,ye,Y=>Promise.resolve(Y.prepareSession(m.URI.revive(ee),re,ae)),void 0)}$provideCallHierarchyIncomingCalls(V,ee,re,ae){return this._withAdapter(V,ye,Y=>Y.provideCallsTo(ee,re,ae),void 0)}$provideCallHierarchyOutgoingCalls(V,ee,re,ae){return this._withAdapter(V,ye,Y=>Y.provideCallsFrom(ee,re,ae),void 0)}$releaseCallHierarchy(V,ee){this._withAdapter(V,ye,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(V,ee,re){const ae=this._addNewAdapter(new Re(this._documents,re),V);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$prepareTypeHierarchy(V,ee,re,ae){return this._withAdapter(V,Re,Y=>Promise.resolve(Y.prepareSession(m.URI.revive(ee),re,ae)),void 0)}$provideTypeHierarchySupertypes(V,ee,re,ae){return this._withAdapter(V,Re,Y=>Y.provideSupertypes(ee,re,ae),void 0)}$provideTypeHierarchySubtypes(V,ee,re,ae){return this._withAdapter(V,Re,Y=>Y.provideSubtypes(ee,re,ae),void 0)}$releaseTypeHierarchy(V,ee){this._withAdapter(V,Re,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,C.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:Be._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:Be._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Be._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Be._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:Be._serializeRegExp(V.beforeText),afterText:V.afterText?Be._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?Be._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(Be._serializeOnEnterRule)}setLanguageConfiguration(V,ee,re){let{wordPattern:ae}=re;if(ae&&(0,C.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(ee,ae):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const Y=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Be._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Be._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Be._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,ee,oe),this._createDisposable(Y)}$setWordDefinitions(V){for(const ee of V)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=Be,Be._handlePool=0}),define(me[243],ge([0,1,5,15,7,49,18,6]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(n,A,u){this._documents=A,this._commands=u,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=n.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(n){this._languageIds=n}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(n,A){await this._proxy.$changeLanguage(n,A);const u=this._documents.getDocumentData(n);if(!u)throw new Error(`document '${n.toString}' NOT found`);return u.document}async tokenAtPosition(n,A){const u=n.version,f=L.Position.from(A),o=await this._proxy.$tokensAtPosition(n.uri,f),v={type:I.StandardTokenType.Other,range:n.getWordRangeAtPosition(A)??new I.Range(A.line,A.character,A.line,A.character)};if(!o)return v;const S={range:L.Range.to(o.range),type:L.TokenType.to(o.type)};return!S.range.contains(A)||u!==n.version?v:S}createLanguageStatusItem(n,A,u){const f=this._handlePool++,o=this._proxy,v=this._ids,S=`${n.identifier.value}/${A}`;if(v.has(S))throw new Error(`LanguageStatusItem with id '${A}' ALREADY exists`);v.add(S);const P={selector:u,id:A,name:n.displayName??n.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let E,a=new C.DisposableStore;const l=()=>{E?.dispose(),E=(0,R.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(f,{id:S,name:P.name??n.displayName??n.name,source:n.displayName??n.name,selector:P.selector,label:P.text,detail:P.detail??"",severity:P.severity===I.LanguageStatusSeverity.Error?k.default.Error:P.severity===I.LanguageStatusSeverity.Warning?k.default.Warning:k.default.Info,command:P.command&&this._commands.toInternal(P.command,a),accessibilityInfo:P.accessibilityInformation})},0)},p={dispose(){a.dispose(),E?.dispose(),o.$removeLanguageStatus(f),v.delete(S)},get id(){return P.id},get name(){return P.name},set name(t){P.name=t,l()},get selector(){return P.selector},set selector(t){P.selector=t,l()},get text(){return P.text},set text(t){P.text=t,l()},get detail(){return P.detail},set detail(t){P.detail=t,l()},get severity(){return P.severity},set severity(t){P.severity=t,l()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(t){P.accessibilityInformation=t,l()},get command(){return P.command},set command(t){P.command=t,l()}};return l(),p}}e.ExtHostLanguages=D}),define(me[244],ge([0,1,5,12,36]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function k(C){return C&&C.title}let R=class{constructor(D,T){this._logService=T,this._proxy=D.getProxy(m.MainContext.MainThreadMessageService)}showMessage(D,T,n,A,u){const f={extension:D};let o;typeof A=="string"||k(A)?o=[A,...u]:(f.modal=A?.modal,f.useCustom=A?.useCustom,f.detail=A?.detail,o=u),f.useCustom&&(0,I.checkProposedApiEnabled)(D);const v=[];for(let S=0;S<o.length;S++){const P=o[S];if(typeof P=="string")v.push({title:P,handle:S,isCloseAffordance:!1});else if(typeof P=="object"){let{title:E,isCloseAffordance:a}=P;v.push({title:E,isCloseAffordance:!!a,handle:S})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(T,n,f,v).then(S=>{if(typeof S=="number")return o[S]})}};R=Ve([We(1,L.ILogService)],R),e.ExtHostMessageService=R}),define(me[245],ge([0,1,23,3,48,6,24,9,13,2,87,5,15,7,66,220,129]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(a,l,p,t,s){this._textDocumentsAndEditors=p,this._textDocuments=t,this._extensionStoragePaths=s,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,h=r.cell.handle,d=this._documents.get(i)?.getCell(h);if(d)return d.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const l=this._editors.get(a);if(!l)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(a){for(const[l,p]of this._editors)if(p.apiEditor===a)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,l){const p=this._documents.get(a);if(!p&&!l)throw new Error(`NO notebook document for '${a}'`);return p}_getProviderData(a){const l=this._notebookContentProviders.get(a);if(!l)throw new Error(`NO provider for '${a}'`);return l}registerNotebookContentProvider(a,l,p,t,s){if((0,C.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);this._notebookContentProviders.set(l,{extension:a,provider:p});let r;return p.onDidChangeNotebookContentOptions&&(r=p.onDidChangeNotebookContentOptions(()=>{const i=u.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(l,i)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},l,u.NotebookDocumentContentOptions.from(t),P._convertNotebookRegistrationData(a,s)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(a,l){if(!l)return;const p=l.filenamePattern.map(t=>u.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(l.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:l.displayName,filenamePattern:p,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,l,p){const t=P._notebookStatusBarItemProviderHandlePool++,s=typeof p.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,s,l);let r;return s!==void 0&&(r=p.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(s))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,s),r&&r.dispose()})}async createNotebookDocument(a){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&u.NotebookData.from(a.content)});return T.URI.revive(l)}async openNotebookDocument(a){const l=this._documents.get(a);if(l)return l.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(a),t=this._documents.get(T.URI.revive(p));return(0,D.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(a,l){T.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let p;typeof l=="object"?p={position:u.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(u.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:p={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,p),s=t&&this._editors.get(t)?.apiEditor;if(s)return s;throw t?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,l,p,t){const s=this._notebookStatusBarItemProviders.get(a),r=T.URI.revive(l),i=this._documents.get(r);if(!i||!s)return;const h=i.getCellFromIndex(p);if(!h)return;const c=await s.provideCellStatusBarItems(h.apiCell,t);if(!c)return;const d=new k.DisposableStore,b=this._statusBarCache.add([d]),g=(Array.isArray(c)?c:[c]).map(_=>u.NotebookStatusBarItem.from(_,this._commandsConverter,d));return{cacheId:b,items:g}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,l,p,t,s){if((0,C.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,p),this._notebookProxy.$registerNotebookSerializer(r,{id:a.identifier,location:a.extensionLocation},l,u.NotebookDocumentContentOptions.from(t),P._convertNotebookRegistrationData(a,s)),(0,k.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(a,l,p){const t=this._notebookSerializer.get(a);if(!t)throw new Error("NO serializer found");const s=await t.deserializeNotebook(l.buffer,p);return new o.SerializableObjectWithBuffers(u.NotebookData.from(s))}async $notebookToData(a,l,p){const t=this._notebookSerializer.get(a);if(!t)throw new Error("NO serializer found");const s=await t.serializeNotebook(u.NotebookData.to(l.value),p);return m.VSBuffer.wrap(s)}async $openNotebook(a,l,p,t,s){const{provider:r}=this._getProviderData(a),i=await r.openNotebook(T.URI.revive(l),{backupId:p,untitledDocumentData:t?.buffer},s);return new o.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(u.NotebookCellData.from)})}async $saveNotebook(a,l,p){const t=this.getNotebookDocument(T.URI.revive(l)),{provider:s}=this._getProviderData(a);return await s.saveNotebook(t.apiNotebook,p),!0}async $saveNotebookAs(a,l,p,t){const s=this.getNotebookDocument(T.URI.revive(l)),{provider:r}=this._getProviderData(a);return await r.saveNotebookAs(T.URI.revive(p),s.apiNotebook,t),!0}async $backupNotebook(a,l,p){const t=this.getNotebookDocument(T.URI.revive(l)),s=this._getProviderData(a),r=this._extensionStoragePaths.workspaceValue(s.extension)??this._extensionStoragePaths.globalValue(s.extension),i=String((0,I.hash)([t.uri.toString(),this._backupIdPool++])),h=T.URI.joinPath(r,i),c=await s.provider.backupNotebook(t.apiNotebook,{destination:h},p);return t.updateBackup(c),c.id}_createExtHostEditor(a,l,p){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const t=new S.ExtHostNotebookEditor(l,this._notebookEditorsProxy,a,p.visibleRanges.map(u.NotebookRange.to),p.selections.map(u.NotebookRange.to),typeof p.viewColumn=="number"?u.ViewColumn.to(p.viewColumn):void 0);this._editors.set(l,t)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const p of a.value.removedDocuments){const t=T.URI.revive(p),s=this._documents.get(t);s&&(s.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(s.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===t.toString()&&this._editors.delete(r.id)}if(a.value.addedDocuments){const p=[];for(const t of a.value.addedDocuments){const s=T.URI.revive(t.uri);if(this._documents.has(s))throw new Error(`adding EXISTING notebook ${s} `);const r=this,i=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(h){r._onDidChangeNotebookCells.fire(h)},emitCellOutputsChange(h){r._onDidChangeCellOutputs.fire(h)},emitCellMetadataChange(h){r._onDidChangeCellMetadata.fire(h)},emitCellExecutionStateChange(h){r._onDidChangeCellExecutionState.fire(h)}},s,t);p.push(...t.cells.map(h=>v.ExtHostCell.asModelAddData(i.apiNotebook,h))),this._documents.get(s)?.dispose(),this._documents.set(s,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(a.value.addedEditors)for(const p of a.value.addedEditors){if(this._editors.has(p.id))return;const t=T.URI.revive(p.documentUri),s=this._documents.get(t);s&&this._createExtHostEditor(s,p.id,p)}const l=[];if(a.value.removedEditors)for(const p of a.value.removedEditors){const t=this._editors.get(p);t&&(this._editors.delete(p),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),l.push(t))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const p=new Set;this._visibleNotebookEditors.forEach(t=>p.add(t.id));for(const t of this._editors.values()){const s=p.has(t.id);t._acceptVisibility(s)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(me[246],ge([0,1,3,76,12,5,14,15]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(A,u){const f=D._Keys.nextId();A.$registerNotebookEditorDecorationType(f,C.NotebookDecorationRenderOptions.from(u)),this.value={key:f,dispose(){A.$removeNotebookEditorDecorationType(f)}}}}D._Keys=new L.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(A,u,f){this._logService=A,this._extHostRpc=u,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(A){return new D(this._extHostRpc.getProxy(k.MainContext.MainThreadNotebookEditors),A).value}$acceptEditorPropertiesChanged(A,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,u);const f=this._notebooksAndEditors.getEditorById(A);u.visibleRanges&&f._acceptVisibleRanges(u.visibleRanges.ranges.map(C.NotebookRange.to)),u.selections&&f._acceptSelections(u.selections.selections.map(C.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const u in A)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(C.ViewColumn.to(A[u]))}};T=Ve([We(0,I.ILogService),We(1,R.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(me[247],ge([0,1,17,18,21,3,6,24,2,26,12,5,15,7,88,213,36,66]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let E=class{constructor(s,r,i,h){this._initData=r,this._extHostNotebook=i,this._logService=h,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=s.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(s,r,i,h,c,d){for(let N of this._kernelData.values())if(N.controller.id===r&&T.ExtensionIdentifier.equals(s.identifier,N.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const b=this._handlePool++,y=this;this._logService.trace(`NotebookController[${b}], CREATED by ${s.identifier.value}, ${r}`);const g=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${s.identifier}'`);let _=!1;const w=new R.DisposableStore,F=new k.Emitter,O=new k.Emitter,G={id:`${s.identifier.value}/${r}`,notebookType:i,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:h||s.identifier.value,preloads:d?d.map(u.NotebookRendererScript.from):[]};let K=c??g,U;this._proxy.$addKernel(b,G).catch(N=>{console.log(N),_=!0});let W=0;const M=()=>{if(_)return;const N=++W;Promise.resolve().then(()=>{N===W&&this._proxy.$updateKernel(b,G)})},x=new C.ResourceMap,B={get id(){return r},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return G.label},set label(N){G.label=N??s.displayName??s.name,M()},get detail(){return G.detail??""},set detail(N){G.detail=N,M()},get description(){return G.description??""},set description(N){G.description=N,M()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(N){G.supportedLanguages=N,M()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(N){G.supportsExecutionOrder=N,M()},get rendererScripts(){return G.preloads?G.preloads.map(u.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(N){K=N??g},get interruptHandler(){return U},set interruptHandler(N){U=N,G.supportsInterrupt=Boolean(N),M()},createNotebookCellExecution(N){if(_)throw new Error("notebook controller is DISPOSED");if(!x.has(N.notebook.uri))throw y._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(z=>z.toString())),new Error(`notebook controller is NOT associated to notebook: ${N.notebook.uri.toString()}`);return y._createNotebookCellExecution(N)},dispose:()=>{_||(this._logService.trace(`NotebookController[${b}], DISPOSED`),_=!0,this._kernelData.delete(b),w.dispose(),F.dispose(),O.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(N,z){y._proxy.$updateNotebookPriority(b,N.uri,z)},onDidReceiveMessage:O.event,postMessage(N,z){return(0,S.checkProposedApiEnabled)(s),y._proxy.$postMessage(b,z&&y._extHostNotebook.getIdByEditor(z),N)},asWebviewUri(N){return(0,S.checkProposedApiEnabled)(s),(0,o.asWebviewUri)(N,y._initData.remote)}};return this._kernelData.set(b,{extensionId:s.identifier,controller:B,onDidReceiveMessage:O,onDidChangeSelection:F,associatedNotebooks:x}),B}$acceptNotebookAssociation(s,r,i){const h=this._kernelData.get(s);if(h){const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));i?h.associatedNotebooks.set(c.uri,!0):h.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,c.uri.toString(),i),h.onDidChangeSelection.fire({selected:i,notebook:c.apiNotebook})}}async $executeCells(s,r,i){const h=this._kernelData.get(s);if(!h)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r)),d=[];for(let b of i){const y=c.getCell(b);y&&d.push(y.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,c.uri.toString(),d.length),await h.controller.executeHandler.call(h.controller,d,c.apiNotebook,h.controller)}catch(b){this._logService.error(`NotebookController[${s}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(s,r,i){const h=this._kernelData.get(s);if(!h)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,c.apiNotebook);else for(let d of i){const b=c.getCell(d);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,r,i){const h=this._kernelData.get(s);if(!h)return;const c=this._extHostNotebook.getEditorById(r);h.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:i}))}_createNotebookCellExecution(s){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const h=new l(i.notebook,i,this._proxy);this._activeExecutions.set(i.uri,h);const c=h.onDidChangeState(()=>{h.state===a.Resolved&&(h.dispose(),c.dispose(),this._activeExecutions.delete(i.uri))});return h.asApiObject()}};E=Ve([We(3,n.ILogService)],E),e.ExtHostNotebookKernels=E;var a;(function(t){t[t.Init=0]="Init",t[t.Started=1]="Started",t[t.Resolved=2]="Resolved"})(a||(a={}));class l extends R.Disposable{constructor(s,r,i){super();this._document=s,this._cell=r,this._proxy=i,this._handle=l.HANDLE++,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new p(10,h=>this.update(h)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const r=Array.isArray(s)?s:[s];return this._proxy.$updateExecutions(new P.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let r=this._cell;if(s&&(r=this._document.getCellFromApiCell(s)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(s){return s.map(r=>{const i=f.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return i===r.items?u.NotebookCellOutput.from(r):u.NotebookCellOutput.from({items:i,id:r.id,metadata:r.metadata})})}async updateOutputs(s,r,i){const h=this.cellIndexToHandle(r),c=this.validateAndConvertOutputs((0,m.asArray)(s));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:h,append:i,outputs:c})}async updateOutputItems(s,r,i){return s=f.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(s),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:s.map(u.NotebookCellOutputItem.from),outputId:r.id,append:i})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(i){s._executionOrder=i,s.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,executionOrder:s._executionOrder}])},start(i){if(s._state===a.Resolved||s._state===a.Started)throw new Error("Cannot call start again");s._state=a.Started,s._onDidChangeState.fire(),s.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,runStartTime:i})},end(i,h){if(s._state===a.Resolved)throw new Error("Cannot call resolve twice");s._state=a.Resolved,s._onDidChangeState.fire(),s.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:s._handle,runEndTime:h,lastRunSuccess:i}),s._collector.flush(),s._proxy.$removeExecution(s._handle)},clearOutput(i){return s.verifyStateForOutput(),s.updateOutputs([],i,!1)},appendOutput(i,h){return s.verifyStateForOutput(),s.updateOutputs(i,h,!0)},replaceOutput(i,h){return s.verifyStateForOutput(),s.updateOutputs(i,h,!1)},appendOutputItems(i,h){return s.verifyStateForOutput(),s.updateOutputItems(i,h,!0)},replaceOutputItems(i,h){return s.verifyStateForOutput(),s.updateOutputItems(i,h,!1)}})}}l.HANDLE=0;class p{constructor(s,r){this.delay=s,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>s.complete())}}}),define(me[248],ge([0,1,3,5,129]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(C,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,D,T){const n=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(D)?.fire({editor:n.apiEditor,message:T})}createRendererMessaging(C,D){if(!C.contributes?.notebookRenderer?.some(u=>u.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const T=!!C.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(u,f,o)=>{const v=T?u:S=>{const P={};n.set(P,S.editor),u({editor:P,message:S.message})};return this.getOrCreateEmitterFor(D).event(v,f,o)},postMessage:(u,f)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(u)&&([u,f]=[f,u]);const o=T?f:n.get(f),v=o&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(o);return this.proxy.$postMessage(v?.id,D,u)}}}getOrCreateEmitterFor(C){let D=this._rendererMessageEmitters.get(C);return D||(D=new m.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,D),D)}}e.ExtHostNotebookRenderers=k}),define(me[68],ge([0,1,5,3,6,23,4,14]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends I.Disposable{constructor(o,v,S,P,E){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=o,this._proxy=E,this._id=E.$register(this.name,v,S,P),this._disposed=!1,this._offset=0}get name(){return this._name}append(o){this.validate(),this._offset+=o?k.VSBuffer.fromString(o).byteLength:0}update(){this._id.then(o=>this._proxy.$update(o))}appendLine(o){this.validate(),this.append(o+`
`)}clear(){this.validate();const o=this._offset;this._id.then(v=>this._proxy.$clear(v,o))}show(o,v){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof o=="boolean"?o:v)))}hide(){this.validate(),this._id.then(o=>this._proxy.$close(o))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(o=>this._proxy.$dispose(o)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class T extends D{constructor(o,v,S){super(o,!1,void 0,v,S)}append(o){super.append(o),this._id.then(v=>this._proxy.$append(v,o)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class n extends D{constructor(o,v,S){super(o,!0,v,void 0,S)}append(o){throw new Error("Not supported")}}class A{constructor(o,v){this.name=o,this._channel=v}append(o){this._channel.then(v=>v.append(o))}appendLine(o){this._channel.then(v=>v.appendLine(o))}clear(){this._channel.then(o=>o.clear())}show(o,v){this._channel.then(S=>S.show(o,v))}hide(){this._channel.then(o=>o.hide())}dispose(){this._channel.then(o=>o.dispose())}}e.LazyOutputChannel=A;let u=class{constructor(o){this._proxy=o.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(o){}createOutputChannel(o,v){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");return new T(o,v.identifier.value,this._proxy)}createOutputChannelFromLogFile(o,v){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if(!v)throw new Error("illegal argument `file`. must not be falsy");return new n(o,v,this._proxy)}};u=Ve([We(0,C.IExtHostRpcService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(me[249],ge([0,1,18,21,3,6,5,2,7,16,17,49,63]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(o,v,S){const P=o.getProxy(R.MainContext.MainThreadQuickOpen);class E{constructor(c,d){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=d}showQuickPick(c,d,b,y=L.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(c),_=++this._instances,w=P.$show(_,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},y),F={},O=w.then(()=>F);return Promise.race([O,g]).then(G=>{if(G!==F)return g.then(K=>{const U=[];for(let W=0;W<K.length;W++){const M=K[W];let x,B,N,z,H;typeof M=="string"?x=M:(x=M.label,B=M.description,N=M.detail,z=M.picked,H=M.alwaysShow),U.push({label:x,description:B,handle:W,detail:N,picked:z,alwaysShow:H})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{b.onDidSelectItem(K[W])}),P.$setItems(_,U),w.then(W=>{if(typeof W=="number")return K[W];if(Array.isArray(W))return W.map(M=>K[M])})})}).then(void 0,G=>{if(!(0,T.isPromiseCanceledError)(G))return P.$setError(_,G),Promise.reject(G)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,d=L.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,P.$input(c,typeof this._validateInput=="function",d).then(void 0,b=>{if(!(0,T.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(c){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,d=L.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!b)return;const y=await this._workspace.getWorkspaceFolders2();if(!!y)return y.find(g=>g.uri.toString()===b.uri.toString())}createQuickPick(c,d){const b=new r(c,d,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(c){const d=new i(c,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(c,d){const b=this._sessions.get(c);b&&b._fireDidChangeValue(d)}$onDidAccept(c){const d=this._sessions.get(c);d&&d._fireDidAccept()}$onDidChangeActive(c,d){const b=this._sessions.get(c);b instanceof r&&b._fireDidChangeActive(d)}$onDidChangeSelection(c,d){const b=this._sessions.get(c);b instanceof r&&b._fireDidChangeSelection(d)}$onDidTriggerButton(c,d){const b=this._sessions.get(c);b&&b._fireDidTriggerButton(d)}$onDidTriggerItemButton(c,d,b){const y=this._sessions.get(c);y instanceof r&&y._fireDidTriggerItemButton(d,b)}$onDidHide(c){const d=this._sessions.get(c);d&&d._fireDidHide()}}class a{constructor(c,d){this._extensionId=c,this._onDidDispose=d,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((d,b)=>{const y=d===D.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(y,d)}),this.update({buttons:c.map((d,b)=>({...s(d),tooltip:d.tooltip,handle:d===D.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const d=this._handlesToButtons.get(c);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,k.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),P.$dispose(this._id))}update(c){if(!this._disposed){for(const d of Object.keys(c)){const b=c[d];this._pendingUpdate[d]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){P.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function l(h){if(h instanceof D.ThemeIcon)return{id:h.id};const c=t(h),d=p(h);return{dark:typeof c=="string"?C.URI.file(c):c,light:typeof d=="string"?C.URI.file(d):d}}function p(h){return typeof h=="object"&&"light"in h?h.light:h}function t(h){return typeof h=="object"&&"dark"in h?h.dark:h}function s(h){const c=l(h.iconPath);let d,b;return"id"in c?b=u.ThemeIcon.asClassName(c):d=c,{iconPath:d,iconClass:b}}class r extends a{constructor(c,d,b){super(c,b);this.enableProposedApi=d,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((d,b)=>{this._handlesToItems.set(b,d),this._itemsToHandles.set(d,b)}),this.update({items:c.map((d,b)=>({label:d.label,description:d.description,handle:b,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons&&this.enableProposedApi?d.buttons.map((y,g)=>({...s(y),tooltip:y.tooltip,handle:g})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(c){const d=(0,n.coalesce)(c.map(b=>this._handlesToItems.get(b)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(c){const d=(0,n.coalesce)(c.map(b=>this._handlesToItems.get(b)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(c,d){const b=this._handlesToItems.get(c);if(!b||!b.buttons||!b.buttons.length)return;const y=b.buttons[d];y&&this._onDidTriggerItemButtonEmitter.fire({button:y,item:b})}}class i extends a{constructor(c,d){super(c,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?A.default.Error:A.default.Ignore})}}return new E(v,S)}e.createExtHostQuickOpen=f}),define(me[250],ge([0,1,2,3,58,6,18,5,17,100,12,26,36,63,15]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(c){if(c)return typeof c.iconPath=="string"?m.URI.file(c.iconPath):m.URI.isUri(c.iconPath)||f.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function S(c,d){if(!c.iconPath&&!d.iconPath)return 0;if(c.iconPath){if(!d.iconPath)return 1}else return-1;const b=typeof c.iconPath=="string"?c.iconPath:m.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,y=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,T.comparePaths)(b,y)}function P(c,d){let b=0;if(c.strikeThrough!==d.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==d.faded)return c.faded?1:-1;if(c.tooltip!==d.tooltip)return(c.tooltip||"").localeCompare(d.tooltip||"");if(b=S(c,d),b!==0)return b;if(c.light&&d.light)b=S(c.light,d.light);else{if(c.light)return 1;if(d.light)return-1}if(b!==0)return b;if(c.dark&&d.dark)b=S(c.dark,d.dark);else{if(c.dark)return 1;if(d.dark)return-1}return b}function E(c,d){if(c.command!==d.command)return c.command<d.command?-1:1;if(c.title!==d.title)return c.title<d.title?-1:1;if(c.tooltip!==d.tooltip){if(c.tooltip!==void 0&&d.tooltip!==void 0)return c.tooltip<d.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(c.arguments===d.arguments)return 0;if(c.arguments)if(d.arguments){if(c.arguments.length!==d.arguments.length)return c.arguments.length-d.arguments.length}else return 1;else return-1;for(let b=0;b<c.arguments.length;b++){const y=c.arguments[b],g=d.arguments[b];if(y!==g)return y<g?-1:1}return 0}function a(c,d){let b=(0,T.comparePaths)(c.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(b!==0)return b;if(c.command&&d.command)b=E(c.command,d.command);else{if(c.command)return 1;if(d.command)return-1}if(b!==0)return b;if(c.decorations&&d.decorations)b=P(c.decorations,d.decorations);else{if(c.decorations)return 1;if(d.decorations)return-1}return b}function l(c,d){for(let b=0;b<c.length;b++)if(c[b]!==d[b])return!1;return!0}function p(c,d){return c.command===d.command&&c.title===d.title&&c.tooltip===d.tooltip&&(c.arguments&&d.arguments?l(c.arguments,d.arguments):c.arguments===d.arguments)}function t(c,d){return(0,D.equals)(c,d,p)}class s{constructor(d,b,y){this._extension=d,this._proxy=b,this._sourceControlHandle=y,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,u.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,u.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,u.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,b){(0,u.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,b)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=s;class r{constructor(d,b,y,g,_){this._proxy=d,this._commands=b,this._sourceControlHandle=y,this._id=g,this._label=_,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,b){const y=this._resourceStatesCommandsMap.get(d);return y?(0,R.asPromise)(()=>this._commands.executeCommand(y.command,...y.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(a),y=(0,D.sortedDiff)(this._resourceSnapshot,d,a).map(w=>{const F=w.toInsert.map(O=>{const G=this._resourceHandlePool++;this._resourceStatesMap.set(G,O);const K=O.resourceUri;let U;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const fe=new k.DisposableStore;U=this._commands.converter.toInternal(O.command,fe),this._resourceStatesDisposablesMap.set(G,fe)}else this._resourceStatesCommandsMap.set(G,O.command);const W=v(O.decorations),M=O.decorations&&v(O.decorations.light)||W,x=O.decorations&&v(O.decorations.dark)||W,B=[M,x],N=O.decorations&&O.decorations.tooltip||"",z=O.decorations&&!!O.decorations.strikeThrough,H=O.decorations&&!!O.decorations.faded,Q=O.contextValue||"";return{rawResource:[G,K,B,N,z,H,Q,U],handle:G}});return{start:w.start,deleteCount:w.deleteCount,toInsert:F}}),g=y.map(({start:w,deleteCount:F,toInsert:O})=>[w,F,O.map(G=>G.rawResource)]),_=y.reverse();for(const{start:w,deleteCount:F,toInsert:O}of _){const G=O.map(U=>U.handle),K=this._handlesSnapshot.splice(w,F,...G);for(const U of K)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=d,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(d,b,y,g,_,w){this._proxy=b,this._commands=y,this._id=g,this._label=_,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new k.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new s(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,g,_,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new k.DisposableStore,this._acceptInputCommand=d;const b=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&t(this._statusBarCommands,d))return;this._statusBarDisposables.value=new k.DisposableStore,this._statusBarCommands=d;const b=(d||[]).map(y=>this._commands.converter.toInternal(y,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(d,b){const y=new r(this._proxy,this._commands,this.handle,d,b),g=L.Event.once(y.onDidDispose)(()=>this.createdResourceGroups.delete(y));return this.createdResourceGroups.set(y,g),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const d=[],b=[];for(const[y,g]of this.createdResourceGroups){g.dispose();const _=y.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(y),this.eventuallyUpdateResourceStates()});L.Event.once(y.onDidDispose)(()=>{this.updatedResourceGroups.delete(y),_.dispose(),this._groups.delete(y.handle),this._proxy.$unregisterGroup(this.handle,y.handle)}),d.push([y.handle,y.id,y.label,y.features]);const w=y._takeResourceStateSnapshot();w.length>0&&b.push([y.handle,w]),this._groups.set(y.handle,y)}this._proxy.$registerGroups(this.handle,d,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(b=>{const y=b._takeResourceStateSnapshot();y.length!==0&&d.push([b.handle,y])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([(0,I.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([(0,I.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let h=class xn{constructor(d,b,y){this._commands=b,this.logService=y,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=d.getProxy(C.MainContext.MainThreadSCM),this._telemetry=d.getProxy(C.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===3){const _=this._sourceControls.get(g.sourceControlHandle);if(!_)return g;const w=_.getResourceGroup(g.groupHandle);return w?w.getResourceState(g.handle):g}else if(g&&g.$mid===4){const _=this._sourceControls.get(g.sourceControlHandle);return _?_.getResourceGroup(g.groupHandle):g}else if(g&&g.$mid===5){const _=this._sourceControls.get(g.handle);return _||g}return g}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,b,y,g){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,b,y,g),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const _=xn._handlePool++,w=new i(d,this._proxy,this._commands,b,y,g);this._sourceControls.set(_,w);const F=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(d.identifier))||[];return F.push(w),this._sourceControlsByExtension.set(A.ExtensionIdentifier.toKey(d.identifier),F),w}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const b=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(d.identifier)),y=b&&b[b.length-1];return y&&y.inputBox}$provideOriginalResource(d,b,y){const g=m.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,g.toString());const _=this._sourceControls.get(d);return!_||!_.quickDiffProvider||!_.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>_.quickDiffProvider.provideOriginalResource(g,y)).then(w=>w||null)}$onInputBoxValueChange(d,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const y=this._sourceControls.get(d);return y&&y.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(d,b,y,g){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,b,y);const _=this._sourceControls.get(d);if(!_)return Promise.resolve(void 0);const w=_.getResourceGroup(b);return w?w.$executeResourceCommand(y,g):Promise.resolve(void 0)}$validateInput(d,b,y){this.logService.trace("ExtHostSCM#$validateInput",d);const g=this._sourceControls.get(d);return!g||!g.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>g.inputBox.validateInput(b,y)).then(_=>{if(!_)return Promise.resolve(void 0);const w=o.MarkdownString.fromStrict(_.message);return w?Promise.resolve([w,_.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};h._handlePool=0,h=Ve([We(2,n.ILogService)],h),e.ExtHostSCM=h});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[251],ge([0,1,7,5,166,6,15]),function(J,e,m,L,I,k,R){"use strict";var C,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(f,o,v,S,P=m.StatusBarAlignment.Left,E){C.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new k.DisposableStore,nt(this,C,f,"f"),nt(this,D,o,"f"),this._entryId=T.ID_GEN++,this._extension=v,this._id=S,this._alignment=P,this._priority=E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!T.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,D,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,D,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let o;this._name?o=this._name:o=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=T.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,C,"f").$setEntry(this._entryId,f,o,this._text,S,this._command?.internal,v,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=T,C=new WeakMap,D=new WeakMap,T.ID_GEN=0,T.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const o={message:f};return this._messages.unshift(o),this._update(),new m.Disposable(()=>{const v=this._messages.indexOf(o);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(f,o){this._proxy=f.getProxy(L.MainContext.MainThreadStatusBar),this._commands=o,this._statusMessage=new n(this)}createStatusBarEntry(f,o,v,S){return new T(this._proxy,this._commands,f,o,v,S)}setStatusBarMessage(f,o){const v=this._statusMessage.setMessage(f);let S;return typeof o=="number"?S=setTimeout(()=>v.dispose(),o):typeof o!="undefined"&&o.then(()=>v.dispose(),()=>v.dispose()),new m.Disposable(()=>{v.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=A}),define(me[92],ge([0,1,5,3,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class k{constructor(C){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,D){this._proxy.$registerExtensionStorageKeysToSync(C,D)}getValue(C,D,T){return this._proxy.$getValue(C,D).then(n=>n||T)}setValue(C,D,T){return this._proxy.$setValue(C,D,T)}$acceptValue(C,D,T){this._onDidChangeStorage.fire({shared:C,key:D,value:T})}}e.ExtHostStorage=k,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(me[69],ge([0,1,4,27,12,91,2]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let C=class{constructor(T,n,A){this._logService=n,this._extHostFileSystem=A,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(T){return R.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,n=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(A){this._logService.error("[ExtHostStorage]",A);return}}workspaceValue(T){if(this._value)return R.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return R.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=Ve([We(0,L.IExtHostInitDataService),We(1,I.ILogService),We(2,k.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(me[33],ge([0,1,3,5,4,2,14,6,7,167,16,215,21,32,195,196,63,13]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class E{constructor(c,d,b,y){this._proxy=c,this._id=d,this._creationOptions=b,this._name=y,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(_=>this._pidPromiseComplete=_);const g=this;this.value={get name(){return g._name||""},get processId(){return g._pidPromise},get creationOptions(){return g._creationOptions},get exitStatus(){return g._exitStatus},get state(){return g._state},sendText(_,w=!0){g._checkDisposed(),g._proxy.$sendText(g._id,_,w)},show(_){g._checkDisposed(),g._proxy.$show(g._id,_)},hide(){g._checkDisposed(),g._proxy.$hide(g._id)},dispose(){g._disposed||(g._disposed=!0,g._proxy.$dispose(g._id))},get dimensions(){if(!(g._cols===void 0||g._rows===void 0))return{columns:g._cols,rows:g._rows}}}}async create(c,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,P.withNullAsUndefined)(c.shellPath),shellArgs:(0,P.withNullAsUndefined)(c.shellArgs),cwd:(0,P.withNullAsUndefined)(c.cwd),env:(0,P.withNullAsUndefined)(c.env),icon:(0,P.withNullAsUndefined)(r(c.iconPath)),color:S.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,P.withNullAsUndefined)(c.message),strictEnv:(0,P.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,P.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,P.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,P.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(c.location,d?.resolvedExtHostIdentifier,d?.location)})}async createExtensionTerminal(c,d,b,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:S.ThemeColor.isThemeColor(y)?y.id:void 0,location:this._serializeParentTerminal(c,d)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,d,b){return typeof c=="object"&&"parentTerminal"in c?d?{parentTerminal:d}:void 0:(b&&(c=b),c)}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,d){return c===this._cols&&d===this._rows||c===0||d===0?!1:(this._cols=c,this._rows=d,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=E;class a{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput&&this._pty.handleInput(c)}resize(c,d){this._pty.setDimensions&&this._pty.setDimensions({columns:c,rows:d})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose&&this._pty.onDidClose((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d&&{cols:d.columns,rows:d.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(d=>this._onProcessTitleChanged.fire(d)),this._pty.open(c||void 0),this._pty.setDimensions&&c&&this._pty.setDimensions(c),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=a;let l=1,p=class extends C.Disposable{constructor(c,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new v.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[b,y]of this._terminalProcesses)y.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,d){const b=new E(this._proxy,(0,f.generateUuid)(),c,c.name),y=new a(c.pty);return b.createExtensionTerminal(this._resolveLocation(c.location),d?.resolvedExtHostIdentifier,r(c.iconPath),i(c.color)).then(g=>{const _=this._setupExtHostProcessListeners(g,y);this._terminalProcessDisposables[g]=_}),this._terminals.push(b),b.value}_resolveLocation(c){return typeof c=="object"&&"viewColumn"in c&&c.viewColumn!==void 0?{viewColumn:c.viewColumn,preserveFocus:c.preserveFocus}:typeof c=="object"&&"parentTerminal"in c?void 0:(c===o.TerminalLocation.Editor||c===o.TerminalLocation.Panel,c)}attachPtyToTerminal(c,d){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const y=new a(d),g=this._setupExtHostProcessListeners(c,y);this._terminalProcessDisposables[c]=g}async $acceptActiveTerminalChanged(c){const d=this._activeTerminal;if(c===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(c);b&&(this._activeTerminal=b,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,d){const b=this._getTerminalById(c);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:d})}async $acceptTerminalDimensions(c,d,b){const y=this._getTerminalById(c);y&&y.setDimensions(d,b)&&this._onDidChangeTerminalDimensions.fire({terminal:y.value,dimensions:y.value.dimensions})}async $acceptTerminalMaximumDimensions(c,d,b){this._terminalProcesses.get(c)?.resize(d,b)}async $acceptTerminalTitleChange(c,d){const b=this._getTerminalById(c);b&&(b.name=d)}async $acceptTerminalClosed(c,d){const b=this._getTerminalObjectIndexById(this._terminals,c);if(b!==null){const y=this._terminals.splice(b,1)[0];y.setExitCode(d),this._onDidCloseTerminal.fire(y.value)}}$acceptTerminalOpened(c,d,b,y){if(d){const w=this._getTerminalObjectIndexById(this._terminals,d);if(w!==null){this._terminals[w]._id=c,this._onDidOpenTerminal.fire(this.terminals[w]),this._terminals[w].isOpen=!0;return}}const g={name:y.name,shellPath:y.executable,shellArgs:y.args,cwd:typeof y.cwd=="string"?y.cwd:k.URI.revive(y.cwd),env:y.env,hideFromUser:y.hideFromUser},_=new E(this._proxy,c,g,b);this._terminals.push(_),this._onDidOpenTerminal.fire(_.value),_.isOpen=!0}async $acceptTerminalProcessId(c,d){const b=this._getTerminalById(c);b&&b._setProcessId(d)}async $startExtensionTerminal(c,d){const b=this._getTerminalById(c);if(!b)return{message:(0,T.localize)(0,null,c)};b.isOpen||await new Promise(g=>{const _=this.onDidOpenTerminal(async w=>{w===b.value&&(_.dispose(),g())})});const y=this._terminalProcesses.get(c);y?y.startSendingEvents(d):this._extensionTerminalAwaitingStart[c]={initialDimensions:d}}_setupExtHostProcessListeners(c,d){const b=new C.DisposableStore;b.add(d.onProcessReady(g=>this._proxy.$sendProcessReady(c,g.pid,g.cwd))),b.add(d.onProcessTitleChanged(g=>this._proxy.$sendProcessTitle(c,g))),this._bufferer.startBuffering(c,d.onProcessData),b.add(d.onProcessExit(g=>this._onProcessExit(c,g))),d.onProcessOverrideDimensions&&b.add(d.onProcessOverrideDimensions(g=>this._proxy.$sendOverrideDimensions(c,g))),this._terminalProcesses.set(c,d);const y=this._extensionTerminalAwaitingStart[c];return y&&d instanceof a&&(d.startSendingEvents(y.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),b}$acceptProcessAckDataEvent(c,d){this._terminalProcesses.get(c)?.acknowledgeDataEvent(d)}$acceptProcessInput(c,d){this._terminalProcesses.get(c)?.input(d)}$acceptTerminalInteraction(c){const d=this._getTerminalById(c);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(c,d,b){try{this._terminalProcesses.get(c)?.resize(d,b)}catch(y){if(y.code!=="EPIPE"&&y.code!=="ERR_IPC_CHANNEL_CLOSED")throw y}}$acceptProcessShutdown(c,d){this._terminalProcesses.get(c)?.shutdown(d)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(d=>this._proxy.$sendProcessInitialCwd(c,d))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(d=>this._proxy.$sendProcessCwd(c,d))}$acceptProcessRequestLatency(c){return c}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,d,b){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,b),this._proxy.$registerProfileProvider(d,c.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(c,d){const b=new u.CancellationTokenSource().token,y=await this._profileProviders.get(c)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(!y||!("options"in y))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in y.options){this.createExtensionTerminal(y.options,d);return}this.createTerminalFromOptions(y.options,d)}}async $provideLinks(c,d){const b=this._getTerminalById(c);if(!b)return[];this._terminalLinkCache.delete(c);const y=this._terminalLinkCancellationSource.get(c);y&&y.dispose(!0);const g=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,g);const _=[],w={terminal:b.value,line:d},F=[];for(const K of this._linkProviders)F.push(new Promise(async U=>{g.token.onCancellationRequested(()=>U({provider:K,links:[]}));const W=await K.provideTerminalLinks(w,g.token)||[];g.token.isCancellationRequested||U({provider:K,links:W})}));const O=await Promise.all(F);if(g.token.isCancellationRequested)return[];const G=new Map;for(const K of O)K&&K.links.length>0&&_.push(...K.links.map(U=>{const W={id:l++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return G.set(W.id,{provider:K.provider,link:U}),W}));return this._terminalLinkCache.set(c,G),_}$activateLink(c,d){const b=this._terminalLinkCache.get(c)?.get(d);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(c,d){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const b=this._terminalProcessDisposables[c];b&&(b.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,d)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,d){const b=this._getTerminalObjectIndexById(c,d);return b!==null?c[b]:null}_getTerminalObjectIndexById(c,d){let b=null;return c.some((y,g)=>y._id===d?(b=g,!0):!1),b}getEnvironmentVariableCollection(c){let d=this._environmentVariableCollections.get(c.identifier.value);return d||(d=new t,this._setEnvironmentVariableCollection(c.identifier.value,d)),d}_syncEnvironmentVariableCollection(c,d){const b=(0,A.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(c,d.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(c){c.forEach(d=>{const b=d[0],y=new t(d[1]);this._setEnvironmentVariableCollection(b,y)})}$acceptDefaultProfile(c,d){this._defaultProfile=c,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(c,d){this._environmentVariableCollections.set(c,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,d)})}};p=Ve([We(1,R.IExtHostRpcService)],p),e.BaseExtHostTerminalService=p;class t{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,d){this._setIfDiffers(c,{value:d,type:D.EnvironmentVariableMutatorType.Replace})}append(c,d){this._setIfDiffers(c,{value:d,type:D.EnvironmentVariableMutatorType.Append})}prepend(c,d){this._setIfDiffers(c,{value:d,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,d){const b=this.map.get(c);(!b||b.value!==d.value||b.type!==d.type)&&(this.map.set(c,d),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,d){this.map.forEach((b,y)=>c.call(d,y,b,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=t;let s=class extends p{constructor(c){super(!1,c)}createTerminal(c,d,b){throw new n.NotSupportedError}createTerminalFromOptions(c,d){throw new n.NotSupportedError}};s=Ve([We(0,R.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function r(h){if(!(!h||typeof h=="string"))return"id"in h?{id:h.id,color:h.color}:h}function i(h){return S.ThemeColor.isThemeColor(h)?h:void 0}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[252],ge([0,1,17,23,21,3,75,48,6,25,13,32,5,14,64,15,7,223,127,89]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E,a){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(w,F){this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=w.getProxy(u.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new s(this.proxy),F.registerArgumentProcessor({processArgument:O=>O?.$mid===13?v.TestItem.toItemFromContext(O):O})}createTestController(w,F){if(this.controllers.has(w))throw new Error(`Attempt to insert a duplicate controller with ID "${w}"`);const O=new D.DisposableStore,G=O.add(new P.SingleUseTestCollection(w));G.root.label=F;const K=new Map,U=this.proxy,W={items:G.root.children,get label(){return F},set label(x){F=x,G.root.label=x,U.$updateControllerLabel(w,F)},get id(){return w},createRunProfile:(x,B,N,z,H)=>{let Q=(0,C.hash)(x);for(;K.has(Q);)Q++;const X=new y(this.proxy,w,Q,x,B,N,z,H);return K.set(Q,X),X},createTestItem(x,B,N){return new o.TestItemImpl(w,x,B,N)},createTestRun:(x,B,N=!0)=>this.runTracker.createTestRun(w,G,x,B,N),set resolveHandler(x){G.resolveHandler=x},get resolveHandler(){return G.resolveHandler},dispose:()=>{O.dispose()}};W.createRunConfiguration=W.createRunProfile,U.$registerTestController(w,F),O.add((0,D.toDisposable)(()=>U.$unregisterTestController(w)));const M={controller:W,collection:G,profiles:K};return this.controllers.set(w,M),O.add((0,D.toDisposable)(()=>this.controllers.delete(w))),O.add(G.onDidGenerateDiff(x=>U.$publishDiff(w,x))),W}createTestObserver(){return this.observer.checkout()}async runTests(w,F=I.CancellationToken.None){const O=r(w);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const G=this.controllers.get(O.controllerId);if(!G)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:w.include?.map(K=>K.id)??[G.collection.root.id],profileGroup:g[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:w.exclude?.map(K=>K.id)},F)}$provideFileCoverage(w,F,O){return(0,m.mapFind)(this.runTracker.trackers,K=>K.id===w?K.getCoverage(F):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(w,F,O,G){return(0,m.mapFind)(this.runTracker.trackers,U=>U.id===w?U.getCoverage(F):void 0)?.resolveFileCoverage(O,G)??Promise.resolve([])}$configureRunProfile(w,F){this.controllers.get(w)?.profiles.get(F)?.configureHandler?.()}$publishTestResults(w){this.results=Object.freeze(w.map(F=>(0,T.deepFreeze)(v.TestResults.to(F))).concat(this.results).sort((F,O)=>O.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(w,F){const O=this.controllers.get(a.TestId.fromString(w).controllerId)?.collection;O&&(await O.expand(w,F<0?Infinity:F),O.flushDiff())}$acceptDiff(w){this.observer.applyDiff(w)}async $runControllerTests(w,F){const O=this.controllers.get(w.controllerId);if(!O)return;const{collection:G,profiles:K}=O,U=K.get(w.profileId);if(!U)return;const W=w.testIds.map(N=>G.tree.get(N)).filter(n.isDefined),M=w.excludeExtIds.map(N=>O.collection.tree.get(N)).filter(n.isDefined).filter(N=>W.some(z=>z.fullId.compare(N.fullId)===2));if(!W.length)return;const x=new S.TestRunRequest(W.some(N=>N.actual instanceof o.TestItemRootImpl)?void 0:W.map(N=>N.actual),M.map(N=>N.actual),U),B=this.runTracker.prepareForMainThreadTestRun(x,i.fromInternal(w,O.collection),F);try{await U.runHandler(x,F)}finally{B.isRunning&&!F.isCancellationRequested&&await k.Event.toPromise(B.onEnd),B.dispose()}}$cancelExtensionTestRun(w){w===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(w)}};p=Ve([We(0,f.IExtHostRpcService)],p),e.ExtHostTesting=p;class t extends D.Disposable{constructor(w,F,O){super();this.dto=w,this.proxy=F,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:G}of this.tasks.values())G.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(w){return this.tasks.get(w)?.coverage}createRun(w){const F=this.dto.id,O=this.dto.controllerId,G=(0,A.generateUuid)(),K=new h(this.proxy,F,G),U=B=>(N,...z)=>{if(M){console.warn(`Setting the state of test "${N.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(N)||(this.ensureTestIsKnown(N),B(N,...z))},W=(B,N)=>{const z=N instanceof Array?N.map(v.TestMessage.from):[v.TestMessage.from(N)];if(B.uri&&B.range){const H={range:v.Range.from(B.range),uri:B.uri};for(const Q of z)Q.location=Q.location||H}this.proxy.$appendTestMessagesInRun(F,G,a.TestId.fromExtHostTestItem(B,O).toString(),z)};let M=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:w,get coverageProvider(){return K.coverageProvider},set coverageProvider(B){K.coverageProvider=B},enqueued:U(B=>{this.proxy.$updateTestStateInRun(F,G,a.TestId.fromExtHostTestItem(B,O).toString(),1)}),skipped:U(B=>{this.proxy.$updateTestStateInRun(F,G,a.TestId.fromExtHostTestItem(B,O).toString(),5)}),started:U(B=>{this.proxy.$updateTestStateInRun(F,G,a.TestId.fromExtHostTestItem(B,O).toString(),2)}),errored:U((B,N,z)=>{W(B,N),this.proxy.$updateTestStateInRun(F,G,a.TestId.fromExtHostTestItem(B,O).toString(),6,z)}),failed:U((B,N,z)=>{W(B,N),this.proxy.$updateTestStateInRun(F,G,a.TestId.fromExtHostTestItem(B,O).toString(),4,z)}),passed:U((B,N)=>{this.proxy.$updateTestStateInRun(F,G,a.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString(),3,N)}),appendOutput:(B,N,z)=>{M||(z&&(this.dto.isIncluded(z)?this.ensureTestIsKnown(z):z=void 0),this.proxy.$appendOutputToRun(F,G,L.VSBuffer.fromString(B),N&&v.location.from(N),z&&a.TestId.fromExtHostTestItem(z,O).toString()))},end:()=>{M||(M=!0,this.proxy.$finishedTestRunTask(F,G),this.tasks.delete(G),this.isRunning||this.dispose())}};return this.tasks.set(G,{run:x,coverage:K}),this.proxy.$startedTestRunTask(F,{id:G,name:w,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(w){if(!(w instanceof o.TestItemImpl))throw new o.InvalidTestItemError(w.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(w,this.dto.controllerId).toString()))return;const F=[],O=this.dto.colllection.root;for(;;){const G=v.TestItem.from(w);if(F.unshift(G),this.sharedTestIds.has(G.extId)||(this.sharedTestIds.add(G.extId),w===O))break;w=w.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class s{constructor(w){this.proxy=w,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(w,F,O){return this.getTracker(w,F,O)}cancelRunById(w){for(const F of this.tracked.values())if(F.id===w){F.dispose();return}}cancelAllRuns(){for(const w of this.tracked.values())w.dispose()}createTestRun(w,F,O,G,K){const U=this.tracked.get(O);if(U)return U.createRun(G);const W=i.fromPublic(w,F,O,K),M=r(O);this.proxy.$startedExtensionTestRun({controllerId:w,profile:M&&{group:g[M.kind],id:M.profileId},exclude:O.exclude?.map(B=>B.id)??[],id:W.id,include:O.include?.map(B=>B.id)??[F.root.id],persist:K});const x=this.getTracker(O,W);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),x.createRun(G)}getTracker(w,F,O){const G=new t(F,this.proxy,O);return this.tracked.set(w,G),G.onEnd(()=>this.tracked.delete(w)),G}}e.TestRunCoordinator=s;const r=_=>{if(!!_.profile){if(!(_.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return _.profile}};class i{constructor(w,F,O,G,K,U){this.controllerId=w,this.id=F,this.isPersisted=K,this.colllection=U,this.includePrefix=O.map(W=>W+"\0"),this.excludePrefix=G.map(W=>W+"\0")}static fromPublic(w,F,O,G){return new i(w,(0,A.generateUuid)(),O.include?.map(K=>a.TestId.fromExtHostTestItem(K,w).toString())??[w],O.exclude?.map(K=>a.TestId.fromExtHostTestItem(K,w).toString())??[],G,F)}static fromInternal(w,F){return new i(w.controllerId,w.runId,w.testIds,w.excludeExtIds,!0,F)}isIncluded(w){const F=a.TestId.fromExtHostTestItem(w,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(F===O||F.startsWith(O))return!1;for(const O of this.includePrefix)if(F===O||F.startsWith(O))return!0;return!1}}e.TestRunDto=i;class h{constructor(w,F,O){this.proxy=w,this.runId=F,this.taskId=O}set coverageProvider(w){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!w||(this._coverageProvider=w,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(w){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(w))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(w,F){const O=await this.fileCoverage;let G=O?.[w];return!this._coverageProvider||!O||!G?[]:(G.detailedCoverage||(G=O[w]=await this._coverageProvider.resolveFileCoverage?.(G,F)??G),G.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class c extends E.IncrementalChangeCollector{constructor(w){super();this.emitter=w,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(w){this.added.add(w)}update(w){Object.assign(w.revived,v.TestItem.toPlain(w.item)),this.added.has(w)||this.updated.add(w)}remove(w){if(this.added.has(w)){this.added.delete(w);return}if(this.updated.delete(w),w.parent&&this.alreadyRemoved.has(w.parent)){this.alreadyRemoved.add(w.item.extId);return}this.removed.add(w)}getChangeEvent(){const{added:w,updated:F,removed:O}=this;return{get added(){return[...w].map(G=>G.revived)},get updated(){return[...F].map(G=>G.revived)},get removed(){return[...O].map(G=>G.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(w){return this.items.get(w)}getMirroredTestDataByReference(w){return this.items.get(w.id)}createItem(w,F){return{...w,revived:v.TestItem.toPlain(w.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=d;class b{constructor(w){this.proxy=w}checkout(){this.current||(this.current=this.createObserverData());const w=this.current;return w.observers++,{onDidChangeTest:w.tests.onDidChangeTests,get tests(){return[...w.tests.rootTests].map(F=>F.revived)},dispose:(0,R.once)(()=>{--w.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(w){return this.current?.tests.getMirroredTestDataByReference(w)}applyDiff(w){this.current?.tests.apply(w)}createObserverData(){const w=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:w}}}class y{constructor(w,F,O,G,K,U,W=!1,M=void 0){this.controllerId=F,this.profileId=O,this._label=G,this.kind=K,this.runHandler=U,this._isDefault=W,this._tag=M,l.set(this,void 0),nt(this,l,w,"f");const x=g[K];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,l,"f").$publishTestRunProfile({profileId:O,controllerId:F,tag:M?v.TestTag.namespace(this.controllerId,M.id):null,label:G,group:x,isDefault:W,hasConfigurationHandler:!1})}get label(){return this._label}set label(w){w!==this._label&&(this._label=w,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:w}))}get isDefault(){return this._isDefault}set isDefault(w){w!==this._isDefault&&(this._isDefault=w,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:w}))}get tag(){return this._tag}set tag(w){w?.id!==this._tag?.id&&(this._tag=w,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:w?v.TestTag.namespace(this.controllerId,w.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(w){w!==this._configureHandler&&(this._configureHandler=w,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!w}))}dispose(){Oe(this,l,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=y,l=new WeakMap;const g={[S.TestRunProfileKind.Coverage]:8,[S.TestRunProfileKind.Debug]:4,[S.TestRunProfileKind.Run]:2}}),define(me[253],ge([0,1,3,17,5,130,15,7]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(n,A){this._extHostDocumentsAndEditors=A,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const A=this._extHostDocumentsAndEditors.allEditors();return n?A:A.map(u=>u.value)}async showTextDocument(n,A,u){let f;typeof A=="number"?f={position:R.ViewColumn.from(A),preserveFocus:u}:typeof A=="object"?f={position:R.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selection:typeof A.selection=="object"?R.Range.from(A.selection):void 0,pinned:typeof A.preview=="boolean"?!A.preview:void 0}:f={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(n.uri,f),v=o&&this._extHostDocumentsAndEditors.getEditor(o);if(v)return v.value;throw o?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,A){return new k.TextEditorDecorationType(this._proxy,n,A).value}$acceptEditorPropertiesChanged(n,A){const u=this._extHostDocumentsAndEditors.getEditor(n);if(!u)throw new Error("unknown text editor");if(A.options&&u._acceptOptions(A.options),A.selections){const f=A.selections.selections.map(R.Selection.to);u._acceptSelections(f)}if(A.visibleRanges){const f=L.coalesce(A.visibleRanges.map(R.Range.to));u._acceptVisibleRanges(f)}if(A.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...A.options,lineNumbers:R.TextEditorLineNumbersStyle.to(A.options.lineNumbers)}}),A.selections){const f=C.TextEditorSelectionChangeKind.fromValue(A.selections.source),o=A.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:o,kind:f})}if(A.visibleRanges){const f=L.coalesce(A.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:f})}}$acceptEditorPositionData(n){for(const A in n){const u=this._extHostDocumentsAndEditors.getEditor(A);if(!u)throw new Error("Unknown text editor");const f=R.ViewColumn.to(n[A]);u.value.viewColumn!==f&&(u._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:f}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=D}),define(me[254],ge([0,1,2,4,5,6,7]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class C{constructor(n,A){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(I.MainContext.MainThreadTimeline),A.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===11){const f=u.uri===void 0?void 0:m.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(D(f))?.get(u.handle)}return u}})}async $getTimeline(n,A,u,f,o){return this._providers.get(n)?.provideTimeline(m.URI.revive(A),u,f,o)}registerTimelineProvider(n,A,u,f){const o=new k.DisposableStore,v=this.convertTimelineItem(A.id,f,o).bind(this);let S;A.onDidChange&&(S=A.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:A.id}),this));const P=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...A,scheme:n,onDidChange:void 0,async provideTimeline(E,a,l,p){p?.resetCache&&(o.clear(),P.get(A.id)?.clear());const t=await A.provideTimeline(E,a,l);if(t==null)return;const s=v(E,p);return{...t,source:A.id,items:t.items.map(s)}},dispose(){for(const E of P.values())E.get(A.id)?.clear();S?.dispose(),o.dispose()}})}convertTimelineItem(n,A,u){return(f,o)=>{let v;if(o?.cacheResults){let S=this._itemsBySourceAndUriMap.get(n);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(n,S));const P=D(f);v=S.get(P),v===void 0&&(v=new Map,S.set(P,v))}return S=>{const{iconPath:P,...E}=S,a=`${n}|${S.id??S.timestamp}`;v?.set(a,S);let l,p,t;return S.iconPath&&(P instanceof R.ThemeIcon?t={id:P.id,color:P.color}:m.URI.isUri(P)?(l=P,p=P):{light:l,dark:p}=P),{...E,id:E.id??void 0,handle:a,source:n,command:S.command?A.toInternal(S.command,u):void 0,icon:l,iconDark:p,themeIcon:t,accessibilityInformation:S.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,k.toDisposable)(()=>{for(const u of this._itemsBySourceAndUriMap.values())u.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=C;function D(T){return T?.toString()}}),define(me[255],ge([0,1,6,10,2,5]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(D){this._openers=new Map,this._proxy=D.getProxy(k.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,T,n,A){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const u=A.schemes.find(f=>!R.supportedSchemes.has(f));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,n),this._proxy.$registerUriOpener(T,A.schemes,D,A.label),(0,m.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(D,T,n){const A=this._openers.get(D);if(!A)throw new Error(`Unknown opener with id: ${D}`);const u=I.URI.revive(T);return A.canOpenExternalUri(u,n)}async $openUri(D,T,n){const A=this._openers.get(D);if(!A)throw new Error(`Unknown opener id: '${D}'`);return A.openExternalUri(I.URI.revive(T.resolvedUri),{sourceUri:I.URI.revive(T.sourceUri)},n)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[256],ge([0,1,5,2,6,16,26]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(T,n){if(this.handles.has(R.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const A=C.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(T)),this.handlers.set(A,n),this._proxy.$registerUriHandler(A,T),(0,I.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(T)),this.handlers.delete(A),this._proxy.$unregisterUriHandler(A)})}$handleExternalUri(T,n){const A=this.handlers.get(T);if(!A)return Promise.resolve(void 0);try{A.handleUri(L.URI.revive(n))}catch(u){(0,k.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(T){return L.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=C,C.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[70],ge([0,1,3,2,179,205,88,5]),function(J,e,m,L,I,k,R,C){"use strict";var D,T,n,A,u,f,o,v,S,P,E,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(d,b,y,g,_,w,F){D.set(this,void 0),T.set(this,void 0),n.set(this,void 0),A.set(this,void 0),u.set(this,void 0),f.set(this,void 0),o.set(this,""),v.set(this,void 0),S.set(this,!1),P.set(this,!1),E.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new m.Emitter),this._onDidDispose=Oe(this,a,"f").event,nt(this,D,d,"f"),nt(this,T,b,"f"),nt(this,v,y,"f"),nt(this,A,g,"f"),nt(this,u,_,"f"),nt(this,f,w,"f"),nt(this,E,p(w),"f"),nt(this,n,F,"f")}dispose(){nt(this,S,!0,"f"),Oe(this,a,"f").fire(),Oe(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return nt(this,P,!0,"f"),(0,R.asWebviewUri)(d,Oe(this,A,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,o,"f")}set html(d){this.assertNotDisposed(),Oe(this,o,"f")!==d&&(nt(this,o,d,"f"),!Oe(this,P,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(nt(this,P,!0,"f"),Oe(this,n,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,T,"f").$setHtml(Oe(this,D,"f"),d))}get options(){return this.assertNotDisposed(),Oe(this,v,"f")}set options(d){this.assertNotDisposed(),Oe(this,T,"f").$setOptions(Oe(this,D,"f"),r(Oe(this,f,"f"),Oe(this,u,"f"),d)),nt(this,v,d,"f")}async postMessage(d){if(Oe(this,S,"f"))return!1;const b=(0,k.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Oe(this,E,"f")});return Oe(this,T,"f").$postMessage(Oe(this,D,"f"),b.message,...b.buffers)}assertNotDisposed(){if(Oe(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=l,D=new WeakMap,T=new WeakMap,n=new WeakMap,A=new WeakMap,u=new WeakMap,f=new WeakMap,o=new WeakMap,v=new WeakMap,S=new WeakMap,P=new WeakMap,E=new WeakMap,a=new WeakMap;function p(c){try{const d=(0,I.normalizeVersion)((0,I.parseVersion)(c.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(d,b,y,g,_){this.initData=b,this.workspace=y,this._logService=g,this._deprecationService=_,this._webviews=new Map,this._webviewProxy=d.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(d,b,...y){const g=this.getWebview(d);if(g){const{message:_}=(0,k.deserializeWebviewMessage)(b,y);g._onMessageEmitter.fire(_)}}$onMissingCsp(d,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,b,y){const g=new l(d,this._webviewProxy,i(b),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(d,g),g._onDidDispose(()=>{this._webviews.delete(d)}),g}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=t;function s(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=s;function r(c,d,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||h(c,d)}}e.serializeWebviewOptions=r;function i(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(d=>L.URI.from(d))}}e.reviveOptions=i;function h(c,d){return[...(d?.getWorkspaceFolders()||[]).map(b=>b.uri),c.extensionLocation]}}),define(me[257],ge([0,1,21,48,6,10,22,2,15,70,87,5,7]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class o{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,r){const i=this.key(t,s.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const h=new f(s,r);return this._documents.set(i,h),h}delete(t,s){const r=this.key(t,s.uri);this._documents.delete(r)}key(t,s){return`${t}@@@${s}`}}var v;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(v||(v={}));class S{constructor(){this._providers=new Map}addTextProvider(t,s,r){return this.add(0,t,s,r)}addCustomProvider(t,s,r){return this.add(1,t,s,r)}get(t){return this._providers.get(t)}add(t,s,r,i){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:r,provider:i}),new u.Disposable(()=>this._providers.delete(s))}}class P{constructor(t,s,r,i,h){this._extHostDocuments=s,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=h,this._editorProviders=new S,this._documents=new o,this._proxy=t.getProxy(A.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,r,i){const h=new I.DisposableStore;return E(r)?(h.add(this._editorProviders.addTextProvider(s,t,r)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(t),s,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(t))):(h.add(this._editorProviders.addCustomProvider(s,t,r)),this.supportEditing(r)&&h.add(r.onDidChangeCustomDocument(c=>{const d=this.getCustomDocumentEntry(s,c.document.uri);if(a(c)){const b=d.addEdit(c);this._proxy.$onDidEdit(c.document.uri,s,b,c.label)}else this._proxy.$onContentChange(c.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(t),s,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(t))),u.Disposable.from(h,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,r,i,h){const c=this._editorProviders.get(s);if(!c)throw new Error(`No provider found for '${s}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${s}'`);const d=C.URI.revive(t),b=await c.provider.openCustomDocument(d,{backupId:r,untitledDocumentData:i?.buffer},h);let y;return this.supportEditing(c.provider)&&this._extensionStoragePaths&&(y=this._extensionStoragePaths.workspaceValue(c.extension)??this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(s,b,y),{editable:this.supportEditing(c.provider)}}async $disposeCustomDocument(t,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${s}'`);const i=C.URI.revive(t),{document:h}=this.getCustomDocumentEntry(s,i);this._documents.delete(s,h),h.dispose()}async $resolveWebviewEditor(t,s,r,i,h,c){const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);const b=D.ViewColumn.to(h),y=this._extHostWebview.createNewWebview(s,i.webviewOptions,d.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(s,r,i.title,b,i.panelOptions,y),_=C.URI.revive(t);switch(d.type){case 1:{const{document:w}=this.getCustomDocumentEntry(r,_);return d.provider.resolveCustomEditor(w,g,c)}case 0:{const w=this._extHostDocuments.getDocument(_);return d.provider.resolveCustomTextEditor(w,g,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,r){this.getCustomDocumentEntry(s,t).disposeEdits(r)}async $onMoveCustomEditor(t,s,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const h=this._extHostWebviewPanels.getWebviewPanel(t);if(!h)throw new Error("No webview found");const c=C.URI.revive(s),d=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(d,h,m.CancellationToken.None)}async $undo(t,s,r,i){return this.getCustomDocumentEntry(s,t).undo(r,i)}async $redo(t,s,r,i){return this.getCustomDocumentEntry(s,t).redo(r,i)}async $revert(t,s,r){const i=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(t,s,r){const i=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(t,s,r,i){const h=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(h.document,C.URI.revive(r),i)}async $backup(t,s,r){const i=this.getCustomDocumentEntry(s,t),c=await this.getCustomEditorProvider(s).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(c),c.id}getCustomDocumentEntry(t,s){const r=this._documents.get(t,C.URI.revive(s));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function E(p){return typeof p.resolveCustomTextEditor=="function"}function a(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function l(p){const t=p.scheme===k.Schemas.file||p.scheme===k.Schemas.untitled?p.fsPath:p.toString();return(0,L.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[258],ge([0,1,3,6,2,32,15,70,5,7]),function(J,e,m,L,I,k,R,C,D,T){"use strict";var n,A,u,f,o,v,S,P,E,a,l,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends L.Disposable{constructor(c,d,b,y,g,_,w){super();n.set(this,void 0),A.set(this,void 0),u.set(this,void 0),f.set(this,void 0),o.set(this,void 0),v.set(this,void 0),S.set(this,void 0),P.set(this,void 0),E.set(this,!0),a.set(this,!0),l.set(this,!1),p.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,p,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,nt(this,n,c,"f"),nt(this,A,d,"f"),nt(this,u,b,"f"),nt(this,o,_,"f"),nt(this,P,g,"f"),nt(this,v,y,"f"),nt(this,f,w,"f")}dispose(){Oe(this,l,"f")||(nt(this,l,!0,"f"),Oe(this,p,"f").fire(),Oe(this,A,"f").$disposeWebview(Oe(this,n,"f")),Oe(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,f,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,u,"f")}get title(){return this.assertNotDisposed(),Oe(this,v,"f")}set title(c){this.assertNotDisposed(),Oe(this,v,"f")!==c&&(nt(this,v,c,"f"),Oe(this,A,"f").$setTitle(Oe(this,n,"f"),c))}get iconPath(){return this.assertNotDisposed(),Oe(this,S,"f")}set iconPath(c){this.assertNotDisposed(),Oe(this,S,"f")!==c&&(nt(this,S,c,"f"),Oe(this,A,"f").$setIconPath(Oe(this,n,"f"),I.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Oe(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,P,"f")=="number"&&Oe(this,P,"f")<0))return Oe(this,P,"f")}get active(){return this.assertNotDisposed(),Oe(this,a,"f")}get visible(){return this.assertNotDisposed(),Oe(this,E,"f")}_updateViewState(c){Oe(this,l,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(nt(this,a,c.active,"f"),nt(this,E,c.visible,"f"),nt(this,P,c.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(c,d){this.assertNotDisposed(),Oe(this,A,"f").$reveal(Oe(this,n,"f"),{viewColumn:c?R.ViewColumn.from(c):void 0,preserveFocus:!!d})}assertNotDisposed(){if(Oe(this,l,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,A=new WeakMap,u=new WeakMap,f=new WeakMap,o=new WeakMap,v=new WeakMap,S=new WeakMap,P=new WeakMap,E=new WeakMap,a=new WeakMap,l=new WeakMap,p=new WeakMap,t=new WeakMap;class r{constructor(c,d,b){this.webviews=d,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,k.generateUuid)()}createWebviewPanel(c,d,b,y,g={}){const _=typeof y=="object"?y.viewColumn:y,w={viewColumn:R.ViewColumn.from(_),preserveFocus:typeof y=="object"&&!!y.preserveFocus},F=(0,C.shouldSerializeBuffersForPostMessage)(c),O=r.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(c),O,d,{title:b,panelOptions:i(g),webviewOptions:(0,C.serializeWebviewOptions)(c,this.workspace,g),serializeBuffersForPostMessage:F},w);const G=this.webviews.createNewWebview(O,g,c);return this.createNewWebviewPanel(O,d,b,_,g,G)}$onDidChangeWebviewPanelViewStates(c){const d=Object.keys(c);d.sort((b,y)=>{const g=c[b],_=c[y];return g.active?1:_.active?-1:+g.visible-+_.visible});for(const b of d){const y=this.getWebviewPanel(b);if(!y)continue;const g=c[b];y._updateViewState({active:g.active,visible:g.visible,viewColumn:R.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,d,b){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:b,extension:c}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(c)}),new T.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(c,d,b,y){const g=this._serializers.get(d);if(!g)throw new Error(`No serializer found for '${d}'`);const{serializer:_,extension:w}=g,F=this.webviews.createNewWebview(c,b.webviewOptions,w),O=this.createNewWebviewPanel(c,d,b.title,y,b.panelOptions,F);await _.deserializeWebviewPanel(O,b.state)}createNewWebviewPanel(c,d,b,y,g,_){const w=new s(c,this._proxy,d,b,y,g,_);return this._webviewPanels.set(c,w),w}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=r;function i(h){return{enableFindWidget:h.enableFindWidget,retainContextWhenHidden:h.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[259],ge([0,1,3,6,70,5,7]),function(J,e,m,L,I,k,R){"use strict";var C,D,T,n,A,u,f,o,v,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends L.Disposable{constructor(l,p,t,s,r,i){super();C.set(this,void 0),D.set(this,void 0),T.set(this,void 0),n.set(this,void 0),A.set(this,!1),u.set(this,void 0),f.set(this,void 0),o.set(this,void 0),v.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Oe(this,v,"f").event,S.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,S,"f").event,nt(this,T,t,"f"),nt(this,f,s,"f"),nt(this,C,l,"f"),nt(this,D,p,"f"),nt(this,n,r,"f"),nt(this,u,i,"f")}dispose(){Oe(this,A,"f")||(nt(this,A,!0,"f"),Oe(this,S,"f").fire(),Oe(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,f,"f")}set title(l){this.assertNotDisposed(),Oe(this,f,"f")!==l&&(nt(this,f,l,"f"),Oe(this,D,"f").$setWebviewViewTitle(Oe(this,C,"f"),l))}get description(){return this.assertNotDisposed(),Oe(this,o,"f")}set description(l){this.assertNotDisposed(),Oe(this,o,"f")!==l&&(nt(this,o,l,"f"),Oe(this,D,"f").$setWebviewViewDescription(Oe(this,C,"f"),l))}get visible(){return Oe(this,u,"f")}get webview(){return Oe(this,n,"f")}get viewType(){return Oe(this,T,"f")}_setVisible(l){l===Oe(this,u,"f")||Oe(this,A,"f")||(nt(this,u,l,"f"),Oe(this,v,"f").fire())}show(l){this.assertNotDisposed(),Oe(this,D,"f").$show(Oe(this,C,"f"),!!l)}assertNotDisposed(){if(Oe(this,A,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,D=new WeakMap,T=new WeakMap,n=new WeakMap,A=new WeakMap,u=new WeakMap,f=new WeakMap,o=new WeakMap,v=new WeakMap,S=new WeakMap;class E{constructor(l,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(k.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,p,t,s){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(l),p,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(l,p,t,s,r){const i=this._viewProviders.get(p);if(!i)throw new Error(`No view provider found for '${p}'`);const{provider:h,extension:c}=i,d=this._extHostWebview.createNewWebview(l,{},c),b=new P(l,this._proxy,p,t,d,!0);this._webviewViews.set(l,b),await h.resolveWebviewView(b,{state:s},r)}async $onDidChangeWebviewViewVisibility(l,p){this.getWebviewView(l)._setVisible(p)}async $disposeWebviewView(l){const p=this.getWebviewView(l);this._webviewViews.delete(l),p.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const p=this._webviewViews.get(l);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=E}),define(me[132],ge([0,1,3,5,2,10,9,4,14]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class $n{constructor(A){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=A.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(A){A!==this._state.focused&&(this._state={...this._state,focused:A},this._onDidChangeWindowState.fire(this._state))}openUri(A,u){let f;if(typeof A=="string"){f=A;try{A=I.URI.parse(A)}catch(o){return Promise.reject(`Invalid uri - '${A}'`)}}return(0,R.isFalsyOrWhitespace)(A.scheme)?Promise.reject("Invalid scheme - cannot be empty"):A.scheme===k.Schemas.command?Promise.reject(`Invalid scheme '${A.scheme}'`):this._proxy.$openUri(A,f,u)}async asExternalUri(A,u){if((0,R.isFalsyOrWhitespace)(A.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(A,u);return I.URI.from(f)}};T.InitialState={focused:!0},T=Ve([We(0,D.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(me[260],ge([0,1,8,80,32,44,6,5,2,14]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends R.Disposable{constructor(u,f){super();const o=u.getProxy(C.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async v=>{const S=D.URI.file((0,m.join)((0,L.tmpdir)(),(0,I.generateUuid)()));return await o.$download(v,S),S})}};n=Ve([We(0,T.IExtHostRpcService),We(1,k.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(me[261],ge([0,1,2,8,151,28,68,27,14,6,12,116,42]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class f{constructor(P,E,a){this.name=P,this.file=E,this.appender=a}static async create(P,E){const a=await(0,A.createRotatingLogger)(P,E,30*u.ByteSize.MB,1);return a.clearFormatters(),new f(P,E,a)}append(P){this.appender.critical(P)}flush(){this.appender.flush()}}class o extends R.AbstractExtHostOutputChannel{constructor(P,E,a,l){super(P,!1,m.URI.file(E.file),a,l);this._appender=E}append(P){super.append(P),this._appender.append(P),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(P,E){this._appender.flush(),super.show(P,E)}clear(){this._appender.flush(),super.clear()}}let v=class extends R.ExtHostOutputService{constructor(P,E,a){super(P);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new T.MutableDisposable,this._logsLocation=a.logsLocation}$setVisibleChannel(P){if(P){const E=this._channels.get(P);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(P,E){if(P=P.trim(),!P)throw new Error("illegal argument `name`. must not be falsy");const a=this._doCreateOutChannel(P,E);return a.then(l=>l._id.then(p=>this._channels.set(p,l))),new R.LazyOutputChannel(P,a)}async _doCreateOutChannel(P,E){try{const a=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await k.SymlinkSupport.existsDirectory(a)||await k.Promises.mkdir(a,{recursive:!0});const p=`${this._namePool++}-${P.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=m.URI.file((0,L.join)(a,`${p}.log`)),s=await f.create(p,t.fsPath);return new o(P,s,E.identifier.value,this._proxy)}catch(a){return this.logService.error(a),new R.ExtHostPushOutputChannel(P,E.identifier.value,this._proxy)}}};v=Ve([We(0,D.IExtHostRpcService),We(1,n.ILogService),We(2,C.IExtHostInitDataService)],v),e.ExtHostOutputService2=v}),define(me[262],ge([0,1,50,293,2,69,6,10,18]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends k.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(p){const t=await super._getWorkspaceStorageURI(p);if(t.scheme!==C.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const s=t.fsPath;let r=0;do{let i;r===0?i=s:i=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${r}`:`${s}-${r}`,await n(i);const h=L.join(i,"vscode.lock"),c=await o(this._logService,h,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),I.URI.file(i);r++}while(r<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function n(l){try{await m.promises.stat(l);return}catch{}try{await m.promises.mkdir(l,{recursive:!0})}catch{}}const A=1e3,u=10*60*1e3;class f extends R.Disposable{constructor(p,t){super();this.logService=p,this.filename=t,this._timer=this._register(new D.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await v(p,t);(!s||s.pid!==process.pid)&&(p.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await m.promises.utimes(t,new Date,new Date)}catch(r){p.error(r),p.info(`Lock '${t}': Could not update mtime.`)}},A)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(p){}}async setWillRelease(p){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${p} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+p};await m.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function o(l,p,t){try{const r={pid:process.pid,willReleaseAt:0};await m.promises.writeFile(p,JSON.stringify(r),{flag:"wx"})}catch(r){l.error(r)}const s=await v(l,p);return!s||s.pid!==process.pid?t?(l.info(`Lock '${p}': Could not acquire lock, giving up.`),null):(l.info(`Lock '${p}': Could not acquire lock, checking if the file is stale.`),E(l,p)):(l.info(`Lock '${p}': Lock acquired.`),new f(l,p))}async function v(l,p){let t;try{t=await m.promises.readFile(p)}catch(s){return l.error(s),null}try{return JSON.parse(String(t))}catch(s){return l.error(s),null}}async function S(l,p){let t;try{t=await m.promises.stat(p)}catch(s){return l.error(s),0}return t.mtime.getTime()}function P(l){try{return process.kill(l,0),!0}catch(p){return!1}}async function E(l,p){const t=await v(l,p);if(!t)return l.info(`Lock '${p}': Could not read pid of lock holder.`),a(l,p);if(t.willReleaseAt){let c=t.willReleaseAt-Date.now();if(c<5e3){for(c>0?l.info(`Lock '${p}': The lockfile is scheduled to be released in ${c} ms.`):l.info(`Lock '${p}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,D.timeout)(Math.min(100,c)),await S(l,p)===0)return a(l,p);c=t.willReleaseAt-Date.now()}return a(l,p)}}if(!P(t.pid))return l.info(`Lock '${p}': The pid ${t.pid} appears to be gone.`),a(l,p);const s=await S(l,p),r=Date.now()-s;if(r<=u)return l.info(`Lock '${p}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;l.info(`Lock '${p}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const i=await S(l,p),h=Date.now()-i;return h<=u?(l.info(`Lock '${p}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(l.info(`Lock '${p}': The lock looks stale even after waiting for 2s.`),a(l,p))}async function a(l,p){l.info(`Lock '${p}': Deleting a stale lock.`);try{await m.promises.unlink(p)}catch(t){}return o(l,p,!0)}}),define(me[263],ge([0,1,32,14,33]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let k=class extends I.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,D,T){return this.createTerminalFromOptions({name:C,shellPath:D,shellArgs:T})}createTerminalFromOptions(C,D){const T=new I.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),C,C.name);return this._terminals.push(T),T.create(C,this._serializeParentTerminal(C,D)),T.value}_serializeParentTerminal(C,D){if(D=D||{},C.location&&typeof C.location=="object"&&"parentTerminal"in C.location){const T=C.location.parentTerminal;if(T){const n=this._terminals.find(A=>A.value===T);n&&(D.resolvedExtHostIdentifier=n._id)}}else C.location&&typeof C.location!="object"?D.location=C.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}};k=Ve([We(0,L.IExtHostRpcService)],k),e.ExtHostTerminalService=k}),define(me[264],ge([0,1,5,14,6,27,2,39,22,28,7,11,53,3,193,77,12]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class P{constructor(d,b,y){this.remoteAddress=d,this.localAddress=b,this._dispose=y,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function E(c){const d=c.trim().split(`
`),b=[];return d.forEach(g=>{const _=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(g);_&&_.length>=3&&b.push({pid:parseInt(_[1],10),socket:parseInt(_[2],10)})}),b.reduce((g,_)=>(g[_.socket]=_,g),{})}e.getSockets=E;function a(...c){const d=[].concat(...c.map(p));return[...new Map(d.filter(b=>b.st==="0A").map(b=>{const y=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:l(y[0]),port:parseInt(y[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=a;function l(c){let d="";if(c.length===8)for(let b=c.length-2;b>=0;b-=2)d+=parseInt(c.substr(b,2),16),b!==0&&(d+=".");else for(let b=c.length-4;b>=0;b-=4)d+=parseInt(c.substr(b,4),16).toString(16),b!==0&&(d+=":");return d}e.parseIpAddress=l;function p(c){const d=c.trim().split(`
`),b=d.shift().trim().split(/\s+/).filter(g=>g!=="rx_queue"&&g!=="tm->when");return d.map(g=>g.trim().split(/\s+/).reduce((_,w,F)=>(_[b[F]||F]=w,_),{}))}e.loadConnectionTable=p;function t(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function s(c){const d=c.trim().split(`
`),b=[];return d.forEach(y=>{const g=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(y);g&&g.length>=4&&b.push({pid:parseInt(g[1],10),ppid:parseInt(g[2]),cmd:g[3]})}),b}e.getRootProcesses=s;async function r(c,d,b){const y=b.reduce((_,w)=>(_[w.pid]=w,_),{}),g=[];return c.forEach(({socket:_,ip:w,port:F})=>{const O=d[_]?d[_].pid:void 0,G=O?y[O]?.cmd:void 0;O&&G&&!t(G)&&g.push({host:w,port:F,detail:G,pid:O})}),g}e.findPorts=r;function i(c,d,b){const y=new Map,g=s(d);for(const _ of c){const w=b.get(_.port);if(w){y.set(_.port,w);continue}const F=g.find(O=>O.cmd.includes(`${_.port}`));if(F){let O=F,G;do G=g.find(K=>K.ppid===O.pid),G&&(O=G);while(G);y.set(_.port,{host:_.ip,port:_.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else y.set(_.port,{host:_.ip,port:_.port,ppid:Number.MAX_VALUE})}return y}e.tryFindRootPorts=i;let h=class extends I.Disposable{constructor(d,b,y){super();this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(m.MainContext.MainThreadTunnelService),A.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${b.remoteAddress.host}:${b.remoteAddress.port}.`);const y=await this._proxy.$openTunnel(b,d.displayName);if(y){const g=new P(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(g),g}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,b){const y=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(y,{selector:d,provider:b}),this._proxy.$registerPortsAttributesProvider(d,y),new n.Disposable(()=>{this._portAttributesProviders.delete(y),this._proxy.$unregisterPortsAttributesProvider(y)})}async $providePortAttributes(d,b,y,g,_){const w=[];for(const O of d){const G=this._portAttributesProviders.get(O);if(!G)return[];w.push(...await Promise.all(b.map(async K=>G.provider.providePortAttributes(K,y,g,_))))}const F=w.filter(O=>!!O);return F.length>0?F.map(O=>({autoForwardAction:O.autoForwardAction,port:O.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;let b=new v.MovingAverage,y;for(;this._candidateFindingEnabled;){const g=new Date().getTime(),_=(await this.findCandidatePorts()).filter(F=>(0,o.isLocalhost)(F.host)||(0,o.isAllInterfaces)(F.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${_.map(F=>F.port).join(", ")}`);const w=new Date().getTime()-g;b.update(w),(!y||JSON.stringify(y)!==JSON.stringify(_))&&(y=_,await this._proxy.$onFoundNewCandidates(y)),await new Promise(F=>setTimeout(()=>F(),this.calculateDelay(b.value)))}}async setTunnelExtensionFunctions(d){return d?(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory&&(this._forwardPortProvider=d.tunnelFactory,this._proxy.$setTunnelProvider(d.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,I.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,b){if(this._extensionTunnels.has(d.host)){const y=this._extensionTunnels.get(d.host);y.has(d.port)&&(b&&y.get(d.port).disposeListener.dispose(),await y.get(d.port).tunnel.dispose(),y.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const y=this._forwardPortProvider(d,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),y!==void 0){const g=await y;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const _=this._register(g.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(g.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:g,disposeListener:_}),u.TunnelDto.fromApiTunnel(g)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(y){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const b=await Promise.all(d.map(g=>this._showCandidatePort(g.host,g.port,g.detail??""))),y=d.filter((g,_)=>b[_]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(g=>g.port).join(", ")} to ${y.map(g=>g.port).join(", ")}`),y}async findCandidatePorts(){let d="",b="";try{d=await T.Promises.readFile("/proc/net/tcp","utf8"),b=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch(W){}const y=a(d,b),g=await new Promise(W=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,x,B)=>{W(x)})}),_=E(g),w=await T.Promises.readdir("/proc"),F=[];for(let W of w)try{const M=Number(W),x=D.joinPath(R.URI.file("/proc"),W);if((await T.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(M)){const N=await T.Promises.readlink(D.joinPath(x,"cwd").fsPath),z=await T.Promises.readFile(D.joinPath(x,"cmdline").fsPath,"utf8");F.push({pid:M,cwd:N,cmd:z})}}catch(M){}const O=[],G=y.filter(W=>{const M=_[W.socket];return M||O.push(W),M}),K=r(G,_,F);let U;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const W=await new Promise(M=>{(0,C.exec)("ps -F -A -l | grep root",(x,B,N)=>{M(B)})});this._foundRootPorts=i(O,W,this._foundRootPorts),U=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.join(", ")}`)}return K.then(W=>U?W.concat(U):W)}};h=Ve([We(0,L.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,S.ILogService)],h),e.ExtHostTunnelService=h}),define(me[265],ge([0,1,18,23,21,16,3,6,103,229,66]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function u(g,_){try{return JSON.stringify(g,_)}catch(w){return"null"}}const f="$$ref$$",o={[f]:-1};class v{constructor(_,w){this.jsonString=_,this.referencedBuffers=w}}function S(g,_=null,w=!1){const F=[];return{jsonString:(w?u:JSON.stringify)(g,(G,K)=>{if(typeof K=="undefined")return o;if(typeof K=="object"){if(K instanceof L.VSBuffer){const U=F.push(K)-1;return{[f]:U}}if(_)return _(G,K)}return K}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=S;function P(g,_,w){return JSON.parse(g,(F,O)=>{if(O){const G=O[f];if(typeof G=="number")return _[G];if(w&&O.$mid===1)return w.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=P;function E(g,_){return JSON.stringify(g,_)}function a(g){return g?(_,w)=>w&&w.$mid===1?g.transformOutgoing(w):w:null}var l;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},s=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends C.Disposable{constructor(_,w=null,F=null){super();this[A]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=_,this._logger=w,this._uriTransformer=F,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,G=n.ProxyIdentifier.count;O<G;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(_=>{this._pendingRPCReplies[_].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(_){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(_){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(_){this._responsiveState!==_&&(this._responsiveState=_,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(_){return this._uriTransformer?(0,D.transformIncomingURIs)(_,this._uriTransformer):_}getProxy(_){const{nid:w,sid:F}=_;return this._proxies[w]||(this._proxies[w]=this._createProxy(w,F)),this._proxies[w]}_createProxy(_,w){let F={get:(O,G)=>(typeof G=="string"&&!O[G]&&G.charCodeAt(0)===36&&(O[G]=(...K)=>this._remoteCall(_,G,K)),G===r?w:O[G])};return new Proxy(Object.create(null),F)}set(_,w){return this._locals[_.nid]=w,w}assertRegistered(_){for(let w=0,F=_.length;w<F;w++){const O=_[w];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(_){if(this._isDisposed)return;const w=_.byteLength,F=h.read(_,0),O=F.readUInt8(),G=F.readUInt32();switch(O){case 1:case 2:{let{rpcId:K,method:U,args:W}=d.deserializeRequestJSONArgs(F);this._uriTransformer&&(W=(0,D.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(w,G,K,U,W,O===2);break}case 3:case 4:{let{rpcId:K,method:U,args:W}=d.deserializeRequestMixedArgs(F);this._uriTransformer&&(W=(0,D.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(w,G,K,U,W,O===4);break}case 5:{this._logger&&this._logger.logIncoming(w,G,0,"ack"),this._onDidReceiveAcknowledge(G);break}case 6:{this._receiveCancel(w,G);break}case 7:{this._receiveReply(w,G,void 0);break}case 9:{let K=d.deserializeReplyOKJSON(F);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReply(w,G,K);break}case 10:{const K=d.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(w,G,K);break}case 8:{let K=d.deserializeReplyOKVSBuffer(F);this._receiveReply(w,G,K);break}case 11:{let K=d.deserializeReplyErrError(F);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReplyErr(w,G,K);break}case 12:{this._receiveReplyErr(w,G,void 0);break}default:console.error("received unexpected message"),console.error(_)}}_receiveRequest(_,w,F,O,G,K){this._logger&&this._logger.logIncoming(_,w,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(F)}.${O}(`,G);const U=String(w);let W,M;if(K){const B=new I.CancellationTokenSource;G.push(B.token),W=this._invokeHandler(F,O,G),M=()=>B.cancel()}else W=this._invokeHandler(F,O,G),M=t;this._cancelInvokedHandlers[U]=M;const x=d.serializeAcknowledged(w);this._logger&&this._logger.logOutgoing(x.byteLength,w,1,"ack"),this._protocol.send(x),W.then(B=>{delete this._cancelInvokedHandlers[U];const N=d.serializeReplyOK(w,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(N.byteLength,w,1,"reply:",B),this._protocol.send(N)},B=>{delete this._cancelInvokedHandlers[U];const N=d.serializeReplyErr(w,B);this._logger&&this._logger.logOutgoing(N.byteLength,w,1,"replyErr:",B),this._protocol.send(N)})}_receiveCancel(_,w){this._logger&&this._logger.logIncoming(_,w,1,"receiveCancel");const F=String(w);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(_,w,F){this._logger&&this._logger.logIncoming(_,w,0,"receiveReply:",F);const O=String(w);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const G=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],G.resolveOk(F)}_receiveReplyErr(_,w,F){this._logger&&this._logger.logIncoming(_,w,0,"receiveReplyErr:",F);const O=String(w);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const G=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let K;F&&(F.$isError?(K=new Error,K.name=F.name,K.message=F.message,K.stack=F.stack):K=F),G.resolveErr(K)}_invokeHandler(_,w,F){try{return Promise.resolve(this._doInvokeHandler(_,w,F))}catch(O){return Promise.reject(O)}}_doInvokeHandler(_,w,F){const O=this._locals[_];if(!O)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(_));let G=O[w];if(typeof G!="function")throw new Error("Unknown method "+w+" on actor "+(0,n.getStringIdentifierForProxy)(_));return G.apply(O,F)}_remoteCall(_,w,F){if(this._isDisposed)return Promise.reject(k.canceled());let O=null;if(F.length>0&&I.CancellationToken.isCancellationToken(F[F.length-1])&&(O=F.pop()),O&&O.isCancellationRequested)return Promise.reject(k.canceled());const G=d.serializeRequestArguments(F,this._uriReplacer),K=++this._lastMessageId,U=String(K),W=new T.LazyPromise;O&&O.onCancellationRequested(()=>{const x=d.serializeCancel(K);this._logger&&this._logger.logOutgoing(x.byteLength,K,0,"cancel"),this._protocol.send(d.serializeCancel(K))}),this._pendingRPCReplies[U]=W,this._onWillSendRequest(K);const M=d.serializeRequest(K,_,w,G,!!O);return this._logger&&this._logger.logOutgoing(M.byteLength,K,0,`request: ${(0,n.getStringIdentifierForProxy)(_)}.${w}(`,F),this._protocol.send(M),W}}e.RPCProtocol=i,A=s,i.UNRESPONSIVE_TIME=3*1e3;class h{constructor(_,w){this._buff=_,this._offset=w}static alloc(_,w,F){let O=new h(L.VSBuffer.alloc(F+1+4),0);return O.writeUInt8(_),O.writeUInt32(w),O}static read(_,w){return new h(_,w)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(_){this._buff.writeUInt8(_,this._offset),this._offset+=1}readUInt8(){const _=this._buff.readUInt8(this._offset);return this._offset+=1,_}writeUInt32(_){this._buff.writeUInt32BE(_,this._offset),this._offset+=4}readUInt32(){const _=this._buff.readUInt32BE(this._offset);return this._offset+=4,_}static sizeShortString(_){return 1+_.byteLength}writeShortString(_){this._buff.writeUInt8(_.byteLength,this._offset),this._offset+=1,this._buff.set(_,this._offset),this._offset+=_.byteLength}readShortString(){const _=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+_).toString();return this._offset+=_,F}static sizeLongString(_){return 4+_.byteLength}writeLongString(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}readLongString(){const _=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+_).toString();return this._offset+=_,F}writeBuffer(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}static sizeVSBuffer(_){return 4+_.byteLength}writeVSBuffer(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}readVSBuffer(){const _=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+_);return this._offset+=_,w}static sizeMixedArray(_){let w=0;w+=1;for(let F=0,O=_.length;F<O;F++){const G=_[F];switch(w+=1,G.type){case 1:w+=this.sizeLongString(G.value);break;case 2:w+=this.sizeVSBuffer(G.value);break;case 3:w+=this.sizeUInt8(),w+=this.sizeLongString(G.value);for(let K=0;K<G.buffers.length;++K)w+=this.sizeVSBuffer(G.buffers[K]);break;case 4:break}}return w}writeMixedArray(_){this._buff.writeUInt8(_.length,this._offset),this._offset+=1;for(let w=0,F=_.length;w<F;w++){const O=_[w];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt8(O.buffers.length),this.writeLongString(O.value);for(let G=0;G<O.buffers.length;++G)this.writeBuffer(O.buffers[G]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const _=this._buff.readUInt8(this._offset);this._offset+=1;let w=new Array(_);for(let F=0;F<_;F++)switch(this.readUInt8()){case 1:w[F]=this.readLongString();break;case 2:w[F]=this.readVSBuffer();break;case 3:const G=this.readUInt8(),K=this.readLongString(),U=[];for(let W=0;W<G;++W)U.push(this.readVSBuffer());w[F]=new n.SerializableObjectWithBuffers(P(K,U,null));break;case 4:w[F]=void 0;break}return w}}var c;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(c||(c={}));class d{static _useMixedArgSerialization(_){for(let w=0,F=_.length;w<F;w++)if(_[w]instanceof L.VSBuffer||_[w]instanceof n.SerializableObjectWithBuffers||typeof _[w]=="undefined")return!0;return!1}static serializeRequestArguments(_,w){if(this._useMixedArgSerialization(_)){const F=[];for(let O=0,G=_.length;O<G;O++){const K=_[O];if(K instanceof L.VSBuffer)F[O]={type:2,value:K};else if(typeof K=="undefined")F[O]={type:4};else if(K instanceof n.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:W}=S(K.value,w);F[O]={type:3,value:L.VSBuffer.fromString(U),buffers:W}}else F[O]={type:1,value:L.VSBuffer.fromString(E(K,w))}}return{type:1,args:F}}return{type:0,args:E(_,w)}}static serializeRequest(_,w,F,O,G){switch(O.type){case 0:return this._requestJSONArgs(_,w,F,O.args,G);case 1:return this._requestMixedArgs(_,w,F,O.args,G)}}static _requestJSONArgs(_,w,F,O,G){const K=L.VSBuffer.fromString(F),U=L.VSBuffer.fromString(O);let W=0;W+=h.sizeUInt8(),W+=h.sizeShortString(K),W+=h.sizeLongString(U);let M=h.alloc(G?2:1,_,W);return M.writeUInt8(w),M.writeShortString(K),M.writeLongString(U),M.buffer}static deserializeRequestJSONArgs(_){const w=_.readUInt8(),F=_.readShortString(),O=_.readLongString();return{rpcId:w,method:F,args:JSON.parse(O)}}static _requestMixedArgs(_,w,F,O,G){const K=L.VSBuffer.fromString(F);let U=0;U+=h.sizeUInt8(),U+=h.sizeShortString(K),U+=h.sizeMixedArray(O);let W=h.alloc(G?4:3,_,U);return W.writeUInt8(w),W.writeShortString(K),W.writeMixedArray(O),W.buffer}static deserializeRequestMixedArgs(_){const w=_.readUInt8(),F=_.readShortString(),O=_.readMixedArray(),G=new Array(O.length);for(let K=0,U=O.length;K<U;K++){const W=O[K];typeof W=="string"?G[K]=JSON.parse(W):G[K]=W}return{rpcId:w,method:F,args:G}}static serializeAcknowledged(_){return h.alloc(5,_,0).buffer}static serializeCancel(_){return h.alloc(6,_,0).buffer}static serializeReplyOK(_,w,F){if(typeof w=="undefined")return this._serializeReplyOKEmpty(_);if(w instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(_,w);if(w instanceof n.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:G}=S(w.value,F,!0);return this._serializeReplyOKJSONWithBuffers(_,O,G)}else return this._serializeReplyOKJSON(_,u(w,F))}static _serializeReplyOKEmpty(_){return h.alloc(7,_,0).buffer}static _serializeReplyOKVSBuffer(_,w){let F=0;F+=h.sizeVSBuffer(w);let O=h.alloc(8,_,F);return O.writeVSBuffer(w),O.buffer}static deserializeReplyOKVSBuffer(_){return _.readVSBuffer()}static _serializeReplyOKJSON(_,w){const F=L.VSBuffer.fromString(w);let O=0;O+=h.sizeLongString(F);let G=h.alloc(9,_,O);return G.writeLongString(F),G.buffer}static _serializeReplyOKJSONWithBuffers(_,w,F){const O=L.VSBuffer.fromString(w);let G=0;G+=h.sizeUInt8(),G+=h.sizeLongString(O);for(const U of F)G+=h.sizeVSBuffer(U);let K=h.alloc(10,_,G);K.writeUInt8(F.length),K.writeLongString(O);for(const U of F)K.writeBuffer(U);return K.buffer}static deserializeReplyOKJSON(_){const w=_.readLongString();return JSON.parse(w)}static deserializeReplyOKJSONWithBuffers(_,w){const F=_.readUInt8(),O=_.readLongString(),G=[];for(let K=0;K<F;++K)G.push(_.readVSBuffer());return new n.SerializableObjectWithBuffers(P(O,G,w))}static serializeReplyErr(_,w){return w?this._serializeReplyErrEror(_,w):this._serializeReplyErrEmpty(_)}static _serializeReplyErrEror(_,w){const F=L.VSBuffer.fromString(u(k.transformErrorForSerialization(w),null));let O=0;O+=h.sizeLongString(F);let G=h.alloc(11,_,O);return G.writeLongString(F),G.buffer}static deserializeReplyErrError(_){const w=_.readLongString();return JSON.parse(w)}static _serializeReplyErrEmpty(_){return h.alloc(12,_,0).buffer}}var b;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var y;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(y||(y={}))}),define(me[266],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(me[267],ge([0,1,10,8,11,2,4,86,43,224,266]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let A=class Wn{constructor(f,o,v,S){this.localUserHome=f,this.remoteAgentService=o,this.environmentService=v,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||I.OS)(),this.resolveUserHome=(async()=>{const P=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=P?.userHome||f})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,o){if(f.remoteAuthority)return m.Schemas.vscodeRemote;const v=(0,C.getVirtualWorkspaceScheme)(o.getWorkspace());if(v)return v;const S=o.getWorkspace().folders[0];if(S)return S.uri.scheme;const P=o.getWorkspace().configuration;return P?P.scheme:m.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?L.win32:L.posix)}async fileURI(f){let o="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const S=f.indexOf("/",2);S===-1?(o=f.substring(2),f="/"):(o=f.substring(2,S),f=f.substring(S)||"/")}return k.URI.from({scheme:m.Schemas.file,authority:o,path:f,query:"",fragment:""})}};A=Ve([We(1,n.IRemoteAgentService),We(2,T.IWorkbenchEnvironmentService),We(3,D.IWorkspaceContextService)],A),e.AbstractPathService=A}),define(me[71],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(R,C){this.line=R,this.character=C}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,C){return new m(0,0)}with(R){return new m(0,0)}}e.Position=m;class L{constructor(R,C,D,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(R,C),this.end=new m(D,T)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.Range=L;var I;(function(k){k[k.Information=1]="Information",k[k.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,17,30,25,29,9,4,8,16,71,13]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const u="\u27EA ",f=" characters skipped \u27EB",o=(u.length+f.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var v;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(v=e.SearchProviderType||(e.SearchProviderType={}));var S;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(S=e.QueryType||(e.QueryType={}));function P(x){return!!x.preview}e.resultIsMatch=P;function E(x){return!!x.resource}e.isFileMatch=E;function a(x){return!!x.message}e.isProgressMessage=a;var l;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=p;class t{constructor(B,N,z){this.ranges=N;const H=Array.isArray(N)?N:[N];if(z&&z.matchLines===1&&s(H)){B=(0,R.getNLines)(B,z.matchLines);let Q="",X=0,fe=0;const _e=Math.floor(z.charsPerLine/5),ye=[];for(const Re of H){const $e=Math.max(Re.startColumn-_e,0),Be=Re.startColumn+z.charsPerLine;if($e>fe+_e+o){const je=u+($e-fe)+f;Q+=je+B.slice($e,Be),X+=$e-(fe+je.length)}else Q+=B.slice(fe,Be);ye.push(new i(0,Re.startColumn-X,Re.endColumn-X)),fe=Be}this.preview={text:Q,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const Q=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:B,matches:(0,m.mapArrayOrNot)(N,X=>new r(X.startLineNumber-Q,X.startColumn,X.endLineNumber-Q,X.endColumn))}}}}e.TextSearchMatch=t;function s(x){const B=x[0].startLineNumber;for(const N of x)if(N.startLineNumber!==B||N.endLineNumber!==B)return!1;return!0}class r{constructor(B,N,z,H){this.startLineNumber=B,this.startColumn=N,this.endLineNumber=z,this.endColumn=H}}e.SearchRange=r;class i extends r{constructor(B,N,z){super(B,N,B,z)}}e.OneLineRange=i;var h;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(h=e.SearchSortOrder||(e.SearchSortOrder={}));function c(x,B=!0){const N=x&&x.files&&x.files.exclude,z=B&&x&&x.search&&x.search.exclude;if(!N&&!z)return;if(!N||!z)return N||z;let H=Object.create(null);return H=I.mixin(H,I.deepClone(N)),H=I.mixin(H,I.deepClone(z),!0),H}e.getExcludes=c;function d(x,B){return x.excludePattern&&L.match(x.excludePattern,B)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&L.match(x.includePattern,B)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(N=>{const z=N.folder.fsPath;if(k.isEqualOrParent(B,z)){const H=D.relative(z,B);return!N.includePattern||!!L.match(N.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var b;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(B,N){super(B);this.code=N}}e.SearchError=y;function g(x){const B=x.message;if((0,T.isPromiseCanceledError)(x))return new y(B,b.canceled);try{const N=JSON.parse(B);return new y(N.message,N.code)}catch(N){return new y(B,b.other)}}e.deserializeSearchError=g;function _(x){const B={message:x.message,code:x.code};return new Error(JSON.stringify(B))}e.serializeSearchError=_;function w(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=w;function F(x){return x.type==="success"}e.isSerializedSearchSuccess=F;function O(x){return!!x.path}e.isSerializedFileMatch=O;function G(x,B){const N=x.searchPath?x.searchPath:x.relativePath;return(0,R.fuzzyContains)(N,B)}e.isFilePatternMatch=G;class K{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function U(x,B){const N={...x||{},...B||{}};return Object.keys(N).filter(z=>{const H=N[z];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=U;class W{constructor(B,N){this._parsedIncludeExpression=null,this._excludeExpression={...B.excludePattern||{},...N.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let z=B.includePattern;N.includePattern&&(z?z={...z,...N.includePattern}:z=N.includePattern),z&&(this._parsedIncludeExpression=L.parse(z))}includedInQuerySync(B,N,z){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,N,z)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,N,z))}includedInQuery(B,N,z){const H=this._parsedExcludeExpression(B,N,z),Q=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(B,N,z):!0;return(0,A.isPromise)(H)?H.then(X=>X?!1:Q()):Q()}hasSiblingExcludeClauses(){return M(this._excludeExpression)}}e.QueryGlobTester=W;function M(x){for(const B in x)if(typeof x[B]!="boolean")return!0;return!1}}),define(me[37],ge([0,1,17,18,21,3,24,10,77,22,9,13,2,169,4,12,189,43,52,27,14,7,31,5]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E,a,l,p,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(_,w,F){return new T.ExtUri(O=>d(O,F)).isEqual(_,w)}function i(_,w,F){return r(_.uri,w.uri,F)?0:(0,n.compare)(_.uri.toString(),w.uri.toString())}function h(_,w,F){return _.index!==w.index?_.index<w.index?-1:1:r(_.uri,w.uri,F)?(0,n.compare)(_.name,w.name):(0,n.compare)(_.uri.toString(),w.uri.toString())}function c(_,w,F,O){const G=_.slice(0).sort((U,W)=>F(U,W,O)),K=w.slice(0).sort((U,W)=>F(U,W,O));return(0,m.delta)(G,K,(U,W)=>F(U,W,O))}function d(_,w){const F=w.getCapabilities(_.scheme);return!(F&&F&1024)}class b extends P.Workspace{constructor(w,F,O,G,K,U){super(w,O.map(W=>new P.WorkspaceFolder(W)),G,U);this._name=F,this._isUntitled=K,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(U),O.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(w,F,O,G){if(!w)return{workspace:null,added:[],removed:[]};const{id:K,name:U,folders:W,configuration:M,isUntitled:x}=w,B=[],N=F;F?W.forEach((X,fe)=>{const _e=u.URI.revive(X.uri),ye=b._findFolder(O||F,_e,G);ye?(ye.name=X.name,ye.index=X.index,B.push(ye)):B.push({uri:_e,name:X.name,index:fe})}):B.push(...W.map(({uri:X,name:fe,index:_e})=>({uri:u.URI.revive(X),name:fe,index:_e}))),B.sort((X,fe)=>X.index<fe.index?-1:1);const z=new b(K,U,B,M?u.URI.revive(M):null,!!x,X=>d(X,G)),{added:H,removed:Q}=c(N?N.workspaceFolders:[],z.workspaceFolders,i,G);return{workspace:z,added:H,removed:Q}}static _findFolder(w,F,O){for(let G=0;G<w.folders.length;G++){const K=w.workspaceFolders[G];if(r(K.uri,F,O))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(w,F){return F&&this._structure.get(w)&&(w=(0,T.dirname)(w)),this._structure.findSubstr(w)}resolveWorkspaceFolder(w){return this._structure.get(w)}}let y=class{constructor(w,F,O,G){this._onDidChangeWorkspace=new k.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new k.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=G,this._extHostFileSystemInfo=O,this._requestIdProvider=new D.Counter,this._barrier=new L.Barrier,this._proxy=w.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=w.getProxy(s.MainContext.MainThreadMessageService);const K=F.workspace;this._confirmedWorkspace=K?new b(K.id,K.name,[],K.configuration?u.URI.revive(K.configuration):null,!!K.isUntitled,U=>d(U,O)):void 0}$initializeWorkspace(w,F){this._trusted=F,this.$acceptWorkspaceData(w),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:C.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(w,F,O,...G){const K=[];if(Array.isArray(G)&&G.forEach(B=>{u.URI.isUri(B.uri)&&!K.some(N=>r(N.uri,B.uri,this._extHostFileSystemInfo))&&K.push({uri:B.uri,name:B.name||(0,T.basenameOrAuthority)(B.uri)})}),this._unconfirmedWorkspace||[F,O].some(B=>typeof B!="number"||B<0)||O===0&&K.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+O>U.length)return!1;const W=U.slice(0);W.splice(F,O,...K.map(B=>({uri:B.uri,name:B.name||(0,T.basenameOrAuthority)(B.uri),index:void 0})));for(let B=0;B<W.length;B++){const N=W[B];if(W.some((z,H)=>H!==B&&r(N.uri,z.uri,this._extHostFileSystemInfo)))return!1}W.forEach((B,N)=>B.index=N);const{added:M,removed:x}=c(U,W,h,this._extHostFileSystemInfo);if(M.length===0&&x.length===0)return!1;if(this._proxy){const B=w.displayName||w.name;this._proxy.$updateWorkspaceFolders(B,F,O,K).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,f.localize)(0,null,B,N.toString()),{extension:w},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(w,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(w,F)}async getWorkspaceFolder2(w,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(w,F)}async resolveWorkspaceFolder(w){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(w)}getPath(){if(!this._actualWorkspace)return;const{folders:w}=this._actualWorkspace;if(w.length!==0)return w[0].uri.fsPath}getRelativePath(w,F){let O,G="";if(typeof w=="string"?(O=u.URI.file(w),G=w):typeof w!="undefined"&&(O=w,G=w.fsPath),!O)return G;const K=this.getWorkspaceFolder(O,!0);if(!K)return G;typeof F=="undefined"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let U=(0,T.relativePath)(K.uri,O);return F&&K.name&&(U=`${K.name}/${U}`),U}trySetWorkspaceFolders(w){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:w,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(w){const{workspace:F,added:O,removed:G}=b.toExtHostWorkspace(w,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:G}))}findFiles(w,F,O,G,K=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let U;if(F===null?U=!1:F&&(typeof F=="string"?U=F:U=F.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:M}=g(w);return this._proxy.$startFileSearch((0,A.withUndefinedAsNull)(W),(0,A.withUndefinedAsNull)(M),(0,A.withUndefinedAsNull)(U),(0,A.withUndefinedAsNull)(O),K).then(x=>Array.isArray(x)?x.map(B=>u.URI.revive(B)):[])}async findTextInFiles(w,F,O,G,K=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),W=typeof F.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:M,folder:x}=g(F.include),B=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,N={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:W,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:M,excludePattern:B},z=!1;if(this._activeSearchCallbacks[U]=H=>{if(z)return;const Q=u.URI.revive(H.resource);H.results.forEach(X=>{(0,t.resultIsMatch)(X)?O({uri:Q,preview:{text:X.preview.text,matches:(0,m.mapArrayOrNot)(X.preview.matches,fe=>new p.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:(0,m.mapArrayOrNot)(X.ranges,fe=>new p.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):O({uri:Q,text:X.text,lineNumber:X.lineNumber})})},K.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(w,(0,A.withUndefinedAsNull)(x),N,U,K);return delete this._activeSearchCallbacks[U],H||{}}catch(H){throw delete this._activeSearchCallbacks[U],H}}$handleTextSearchResult(w,F){this._activeSearchCallbacks[F]&&this._activeSearchCallbacks[F](w)}saveAll(w){return this._proxy.$saveAll(w)}resolveProxy(w){return this._proxy.$resolveProxy(w)}get trusted(){return this._trusted}requestWorkspaceTrust(w){return this._proxy.$requestWorkspaceTrust(w)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=Ve([We(0,l.IExtHostRpcService),We(1,a.IExtHostInitDataService),We(2,E.IExtHostFileSystemInfo),We(3,v.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function g(_){let w,F;return _&&(typeof _=="string"?w=_:(w=_.pattern,F=_.baseFolder||u.URI.file(_.base))),{includePattern:w,folder:F}}}),define(me[38],ge([0,1,25,3,37,5,7,192,85,13,18,4,14,12,2]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(s,r){if(r){const i=r.split(".");let h=s;for(let c=0;h&&c<i.length;c++)h=h[i[c]];return h}}function S(s){return s instanceof o.URI}function P(s){return s&&s.uri instanceof o.URI&&s.languageId&&typeof s.languageId=="string"}function E(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function a(s){return s&&s.uri instanceof o.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function l(s){if(S(s))return{resource:s};if(P(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(E(s))return{overrideIdentifier:s.languageId};if(a(s))return{resource:s.uri};if(s===null)return{resource:null}}let p=class{constructor(r,i,h){this._proxy=r.getProxy(k.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=h,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(h=>h.$acceptConfigurationChanged(r,i))}};p=Ve([We(0,u.IExtHostRpcService),We(1,I.IExtHostWorkspace),We(2,f.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(r,i,h,c){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=c,this._extHostWorkspace=i,this._configuration=C.Configuration.parse(h),this._configurationScopes=this._toMap(h.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const h={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,h))}getConfiguration(r,i,h){const c=l(i)||{},d=this._toReadonlyValue(r?v(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,c,h?.identifier);function b(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const y={has(g){return typeof v(d,g)!="undefined"},get:(g,_)=>{this._validateConfigurationAccess(r?`${r}.${g}`:g,c,h?.identifier);let w=v(d,g);if(typeof w=="undefined")w=_;else{let F;const O=(G,K)=>{let U;const W=()=>{F=F||(0,m.deepClone)(d),U=U||v(F,K)};return(0,T.isObject)(G)?new Proxy(G,{get:(M,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return W(),()=>U;if(F)return U=U||v(F,K),U[x];const B=M[x];return typeof x=="string"?O(B,`${K}.${x}`):B},set:(M,x,B)=>(W(),U&&(U[x]=B),!0),deleteProperty:(M,x)=>(W(),U&&delete U[x],!0),defineProperty:(M,x,B)=>(W(),U&&Object.defineProperty(U,x,B),!0)}):G};w=O(w,g)}return w},update:(g,_,w,F)=>{g=r?`${r}.${g}`:g;const O=b(w);return _!==void 0?this._proxy.$updateConfigurationOption(O,g,_,c,F):this._proxy.$removeConfigurationOption(O,g,c,F)},inspect:g=>{g=r?`${r}.${g}`:g;const _=(0,m.deepClone)(this._configuration.inspect(g,c,this._extHostWorkspace.workspace));if(_)return{key:g,defaultValue:_.default?.value,globalValue:_.user?.value,workspaceValue:_.workspace?.value,workspaceFolderValue:_.workspaceFolder?.value,defaultLanguageValue:_.default?.override,globalLanguageValue:_.user?.override,workspaceLanguageValue:_.workspace?.override,workspaceFolderLanguageValue:_.workspaceFolder?.override,languageIds:_.overrideIdentifiers}}};return typeof d=="object"&&(0,m.mixin)(y,d,!1),Object.freeze(y)}_toReadonlyValue(r){const i=h=>(0,T.isObject)(h)?new Proxy(h,{get:(c,d)=>i(c[d]),set:(c,d,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(c,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(c,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):h;return i(r)}_validateConfigurationAccess(r,i,h){const c=D.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),d=h?`[${h.value}] `:"";if(c===4){typeof i?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){i?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const h=new C.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,d)=>h.affectsConfiguration(c,l(d))})}_toMap(r){return r.reduce((i,h)=>(i.set(h[0],h[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,A.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[72],ge([0,1,2,18,3,5,7,37,45,38,21,33,14,27,4,10,11,12,67,214,16]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E,a,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(K){function U(M){if(M!=null)return M}K.from=U;function W(M){if(M!=null)return M}K.to=W})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(K){function U(M){if(M!=null)return M}K.from=U;function W(M){if(M!=null)return M}K.to=W})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(K){function U(M){if(M!=null)return M}K.from=U;function W(M){if(M!=null)return M}K.to=W})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(K){function U(x){if(x){const B=x;return B&&!!B.process}else return!1}K.is=U;function W(x){if(x==null)return;const B={process:x.process,args:x.args};return x.options&&(B.options=r.from(x.options)),B}K.from=W;function M(x){if(x!=null)return new R.ProcessExecution(x.process,x.args,x.options)}K.to=M})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var h;(function(K){function U(M){if(M!=null)return M}K.from=U;function W(M){if(M!=null)return M}K.to=W})(h=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(K){function U(x){if(x){const B=x;return B&&(!!B.commandLine||!!B.command)}else return!1}K.is=U;function W(x){if(x==null)return;const B={};return x.commandLine!==void 0?B.commandLine=x.commandLine:(B.command=x.command,B.args=x.args),x.options&&(B.options=h.from(x.options)),B}K.from=W;function M(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new R.ShellExecution(x.commandLine,x.options):new R.ShellExecution(x.command,x.args?x.args:[],x.options)}K.to=M})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var d;(function(K){function U(x){if(x){let B=x;return B&&B.customExecution==="customExecution"}else return!1}K.is=U;function W(x){return{customExecution:"customExecution"}}K.from=W;function M(x,B){return B.get(x)}K.to=M})(d=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(K){function U(W,M){let x;return W.scope!==void 0&&typeof W.scope!="number"?x=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===R.TaskScope.Workspace&&M&&M.workspaceFile?x=M.workspaceFile:x=a.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:x}}K.from=U})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var y;(function(K){function U(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}K.from=U})(y=e.TaskGroupDTO||(e.TaskGroupDTO={}));var g;(function(K){function U(x,B){if(x==null)return[];const N=[];for(let z of x){const H=W(z,B);H&&N.push(H)}return N}K.fromMany=U;function W(x,B){if(x==null)return;let N;x.execution instanceof R.ProcessExecution?N=i.from(x.execution):x.execution instanceof R.ShellExecution?N=c.from(x.execution):x.execution&&x.execution instanceof R.CustomExecution&&(N=d.from(x.execution));const z=t.from(x.definition);let H;return x.scope?typeof x.scope=="number"?H=x.scope:H=x.scope.uri:H=R.TaskScope.Workspace,!z||!H?void 0:{_id:x._id,definition:z,name:x.name,source:{extensionId:B.identifier.value,label:x.source,scope:H},execution:N,isBackground:x.isBackground,group:y.from(x.group),presentationOptions:s.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}K.from=W;async function M(x,B,N){if(x==null)return;let z;i.is(x.execution)?z=i.to(x.execution):c.is(x.execution)?z=c.to(x.execution):d.is(x.execution)&&(z=d.to(x._id,N));const H=t.to(x.definition);let Q;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?Q=x.source.scope:Q=await B.resolveWorkspaceFolder(m.URI.revive(x.source.scope)):Q=R.TaskScope.Workspace),!H||!Q)return;const X=new R.Task(H,Q,x.name,x.source.label,z,x.problemMatchers);return x.isBackground!==void 0&&(X.isBackground=x.isBackground),x.group!==void 0&&(X.group=R.TaskGroup.from(x.group._id),X.group&&(X.group=new R.TaskGroup(X.group.id,X.group.label),x.group.isDefault&&(X.group.isDefault=x.group.isDefault))),x.presentationOptions&&(X.presentationOptions=s.to(x.presentationOptions)),x._id&&(X._id=x._id),x.detail&&(X.detail=x.detail),X}K.to=M})(g=e.TaskDTO||(e.TaskDTO={}));var _;(function(K){function U(M){return M}K.from=U;function W(M){if(!!M)return Object.assign(Object.create(null),M)}K.to=W})(_=e.TaskFilterDTO||(e.TaskFilterDTO={}));class w{constructor(U,W,M){this._id=W,this._task=M,p.set(this,void 0),nt(this,p,U,"f")}get task(){return this._task}terminate(){Oe(this,p,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}p=new WeakMap;var F;(function(K){function U(W){return{id:W._id,task:void 0}}K.from=U})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor(U,W,M,x,B,N,z,H){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=U.getProxy(k.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=x,this._configurationService=B,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=z,this._deprecationService=H,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,W,M){if(!M)return new R.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:W,provider:M,extension:U}),this._proxy.$registerTaskProvider(x,W),new R.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(U,W){this._proxy.$registerTaskSystem(U,W)}fetchTasks(U){return this._proxy.$fetchTasks(_.from(U)).then(async W=>{const M=[];for(let x of W){const B=await g.to(x,this._workspaceProvider,this._providedCustomExecutions2);B&&M.push(B)}return M})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(W=>U.push(W)),U}terminateTask(U){if(!(U instanceof w))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,W,M){const x=this._providedCustomExecutions2.get(U.id);if(x){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,x),this._terminalService.attachPtyToTerminal(W,await x.callback(M))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const W=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const W=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:W,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const W=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:U.exitCode})}$provideTasks(U,W){const M=this._handlers.get(U);if(!M)return Promise.reject(new Error("no handler found"));const x=[],B=(0,L.asPromise)(()=>M.provider.provideTasks(n.CancellationToken.None)).then(N=>this.provideTasksInternal(W,x,M,N));return new Promise(N=>{B.then(z=>{Promise.all(x).then(()=>{N(z)})})})}async $resolveTask(U,W){const M=this._handlers.get(U);if(!M)return Promise.reject(new Error("no handler found"));if(W.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${M.type}].`);const x=await g.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const B=await M.provider.resolveTask(x,n.CancellationToken.None);if(!B)return;this.checkDeprecation(B,M);const N=g.from(B,M.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(N.execution)&&await this.addCustomExecution(N,B,!0),await this.resolveTaskInternal(N)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,W,M){const x=await this._proxy.$createTaskId(U);!M&&!this._providedCustomExecutions2.has(x)&&this._notProvidedCustomExecutions.add(x),this._providedCustomExecutions2.set(x,W.execution)}async getTaskExecution(U,W){if(typeof U=="string"){const B=this._taskExecutionPromises.get(U);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let M=this._taskExecutionPromises.get(U.id);if(M)return M;const x=new Promise(async(B,N)=>{const z=W||await g.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);z?B(new w(this,U.id,z)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,x),x.then(B=>(this._taskExecutions.set(U.id,B),B),B=>Promise.reject(B))}checkDeprecation(U,W){U._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let M=this._notProvidedCustomExecutions.values(),x=M.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=M.next()}};O=Ve([We(0,u.IExtHostRpcService),We(1,f.IExtHostInitDataService),We(2,C.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,A.IExtHostTerminalService),We(6,P.ILogService),We(7,E.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let G=class extends O{constructor(U,W,M,x,B,N,z,H){super(U,W,M,x,B,N,z,H);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(U,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const M=g.from(W,U);if(M===void 0)throw new Error("Task is not valid");if(d.is(M.execution))await this.addCustomExecution(M,W,!1);else throw new l.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),W);return this._proxy.$executeTask(M).catch(B=>{throw new Error(B)}),x}provideTasksInternal(U,W,M,x){const B=[];if(x)for(let N of x){this.checkDeprecation(N,M),(!N.definition||!U[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const z=g.from(N,M.extension);z&&d.is(z.execution)?(B.push(z),W.push(this.addCustomExecution(z,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:M.extension}}async resolveTaskInternal(U){if(d.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,W,M){}};G=Ve([We(0,u.IExtHostRpcService),We(1,f.IExtHostInitDataService),We(2,C.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,A.IExtHostTerminalService),We(6,P.ILogService),We(7,E.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(me[268],ge([0,1,17,57,30,79,24,10,8,22,9,13,2,145,175,120,43,128,267,31]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(b,y,g,_){this.configurationService=b,this.workspaceContextService=y,this.editorGroupsService=g,this.pathService=_}text(b,y,g={}){b=this.getContentPattern(b,g);const _=this.configurationService.getValue(),w=y&&y.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(y?.map(S.toWorkspaceFolder),g),type:2,contentPattern:b,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:_.search.usePCRE2||w||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles}}getContentPattern(b,y){const g=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const _={...b,wordSeparators:g.editor.wordSeparators};return this.isCaseSensitive(b,y)&&(_.isCaseSensitive=!0),this.isMultiline(b)&&(_.isMultiline=!0),_}file(b,y={}){return{...this.commonQuery(b,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(b,y){return b?(b=Array.isArray(b)?b.map(i):i(b),y?this.parseSearchPaths(b):{pattern:t(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],y={}){const g=this.handleIncludeExclude(y.includePattern,y.expandPatterns),_=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),w=b.length>1,F=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,y,_)):b.map(K=>this.getFolderQueryForRoot(K,y,_,w))).filter(K=>!!K),O={_reason:y._reason,folderQueries:F,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:_.pattern,includePattern:g.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const U=m.coalesce(m.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(x=>x.resource)))).filter(M=>(0,a.pathIncludedInQuery)(O,M.fsPath)),W=this.commonQueryFromFileList(U);return{...O,...W}}const G=y.extraFileResources&&y.extraFileResources.filter(K=>(0,a.pathIncludedInQuery)(O,K.fsPath));return O.extraFileResources=G&&G.length?G:void 0,O}commonQueryFromFileList(b){const y=[],g=new R.ResourceMap,_={};let w=!1;return b.forEach(F=>{if(F.scheme===C.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(F)){const G=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:D.dirname(F.fsPath)});let K=g.get(G);K||(w=!0,K={folder:G,includePattern:{}},y.push(K),g.set(G,K));const U=D.relative(G.fsPath,F.fsPath);(0,A.assertIsDefined)(K.includePattern)[U.replace(/\\/g,"/")]=!0}else F.fsPath&&(w=!0,_[F.fsPath]=!0)}),{folderQueries:y,includePattern:_,usingSearchPaths:!0,excludePattern:w?void 0:{"**/*":!0}}}isCaseSensitive(b,y){if(y.isSmartCase){if(b.isRegExp){if(n.containsUppercaseCharacter(b.pattern,!0))return!0}else if(n.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,f.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const y=W=>D.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),_=(Array.isArray(b)?b:s(b)).map(W=>{const M=this.pathService.resolvedUserHome;return M?(0,k.untildify)(W,M.scheme===C.Schemas.file?M.fsPath:M.path):W}),w=L.groupBy(_,W=>y(W)?"searchPaths":"exprSegments"),F=(w.exprSegments||[]).map(W=>n.rtrim(W,"/")).map(W=>n.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),r(W))),O={},G=this.expandSearchPathPatterns(w.searchPaths||[]);G&&G.length&&(O.searchPaths=G);const K=m.flatten(F),U=t(...K);return U&&(O.pattern=U),O}getExcludesForFolder(b,y){return y.disregardExcludeSettings?void 0:(0,a.getExcludes)(b,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const y=m.flatten(b.map(_=>{let{pathPortion:w,globPortion:F}=p(_);F&&(F=h(F));const O=this.expandOneSearchPath(w);return m.flatten(O.map(G=>this.resolveOneSearchPathPattern(G,F)))})),g=new Map;return y.forEach(_=>{const w=_.searchPath.toString(),F=g.get(w);F?_.pattern&&(F.pattern=F.pattern||{},F.pattern[_.pattern]=!0):g.set(w,{searchPath:_.searchPath,pattern:_.pattern?t(_.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(b){if(D.isAbsolute(b)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==C.Schemas.file?[{searchPath:y[0].uri.with({path:b})}]:[{searchPath:u.URI.file(D.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const _=D.posix.resolve(y.path,b);return[{searchPath:y.with({path:_})}]}const g=h(b);return[{searchPath:y,pattern:g}]}else{if(b==="./"||b===".\\")return[];{const y=b.replace(/^\.[\/\\]/,""),_=this.workspaceContextService.getWorkspace().folders.map(w=>{const F=y.match(new RegExp(`^${n.escapeRegExpCharacters(w.name)}(?:/(.*)|$)`));return F?{match:F,folder:w}:null}).filter(A.isDefined);if(_.length)return _.map(w=>{const F=w.match[1];return{searchPath:w.folder.uri,pattern:F&&h(F)}});{const w=b.match(/\.[\/\\](.+)[\/\\]?/),F=w?w[1]:b,O=o.localize(0,null,F);throw new Error(O)}}}}resolveOneSearchPathPattern(b,y){const g=b.pattern&&y?`${b.pattern}/${y}`:b.pattern||y,_=[{searchPath:b.searchPath,pattern:g}];return g&&!g.endsWith("**")&&_.push({searchPath:b.searchPath,pattern:g+"/**"}),_}getFolderQueryForSearchPath(b,y,g){const _=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(b.searchPath),y,g,!1);return _?{..._,includePattern:b.pattern}:null}getFolderQueryForRoot(b,y,g,_){let w;const F=u.URI.isUri(b)?b:b.uri;if(g.searchPaths){const W=g.searchPaths.filter(M=>(0,T.isEqual)(M.searchPath,F))[0];if(W&&!W.pattern)return null;W&&(w=W.pattern)}const O=this.configurationService.getValue({resource:F}),K={...this.getExcludesForFolder(O,y)||{},...w||{}},U=u.URI.isUri(b)?(0,T.basename)(b):b.name;return{folder:F,folderName:_?U:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!O.search.followSymlinks}}};l=Ve([We(0,v.IConfigurationService),We(1,S.IWorkspaceContextService),We(2,P.IEditorGroupsService),We(3,E.IPathService)],l),e.QueryBuilder=l;function p(d){const b=d.match(/[\*\{\}\(\)\[\]\?]/);if(b){const y=b.index,g=d.substr(0,y).match(/[/|\\][^/\\]*$/);if(g){let _=d.substr(0,g.index);return _.match(/[/\\]/)||(_+="/"),{pathPortion:_,globPortion:d.substr((g.index||0)+1)}}}return{pathPortion:d}}function t(...d){return d.length?d.reduce((b,y)=>(b[y]=!0,b),Object.create(null)):void 0}function s(d){return I.splitGlobAware(d,",").map(b=>b.trim()).filter(b=>!!b.length)}function r(d){return[`**/${d}/**`,`**/${d}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function i(d){return d.replace(/\\/g,"/")}function h(d){return i(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(d,b){d=m.distinct(d,_=>_.toString());const y=[],g=b.getWorkspace();return d&&d.forEach(_=>{let w;if(b.getWorkbenchState()===2)w=(0,T.relativePath)(g.folders[0].uri,_),w&&w!=="."&&(w="./"+w);else{const F=b.getWorkspaceFolder(_);if(F){const O=F.name;if(g.folders.filter(K=>K.name===O).length===1){const K=(0,T.relativePath)(F.uri,_);K===""?w=`./${F.name}`:w=`./${F.name}/${K}`}else w=_.fsPath}}w&&y.push(w)}),y}e.resolveResourcesForSearchIncludes=c}),define(me[269],ge([0,1,22,2,21,16,4,268,31,43]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function A(v,S){const P=S.activationEvents;if(!P)return Promise.resolve(void 0);const E=[],a=[];for(const i of P)if(/^workspaceContains:/.test(i)){const h=i.substr("workspaceContains:".length);h.indexOf("*")>=0||h.indexOf("?")>=0||v.forceUsingSearch?a.push(h):E.push(h)}if(E.length===0&&a.length===0)return Promise.resolve(void 0);let l;const p=new Promise((i,h)=>{l=i}),t=i=>l({activationEvent:i}),s=Promise.all(E.map(i=>u(v,i,t))).then(()=>{}),r=f(v,S.identifier,a,t);return Promise.all([s,r]).then(()=>{l(void 0)}),p}e.checkActivateWorkspaceContainsExtension=A;async function u(v,S,P){for(const E of v.folders)if(await v.exists(m.joinPath(L.URI.revive(E),S))){P(`workspaceContains:${S}`);return}}async function f(v,S,P,E){if(P.length===0)return Promise.resolve(void 0);const a=new I.CancellationTokenSource,l=v.checkExists(v.folders,P,a.token),p=setTimeout(async()=>{a.cancel(),E(`workspaceContainsTimeout:${P.join(",")}`)},n);let t=!1;try{t=await l}catch(s){k.isPromiseCanceledError(s)||k.onUnexpectedError(s)}a.dispose(),clearTimeout(p),t&&E(`workspaceContains:${P.join(",")}`)}function o(v,S,P,E){const a=v.get(R.IInstantiationService),l=v.get(D.ISearchService),t=a.createInstance(C.QueryBuilder).file(S.map(s=>(0,T.toWorkspaceFolder)(L.URI.revive(s))),{_reason:"checkExists",includePattern:P,exists:!0});return l.fileSearch(t,E).then(s=>!!s.limitHit,s=>k.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=o});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[40],ge([0,1,164,8,73,22,18,6,24,2,12,5,38,227,92,37,36,225,16,26,23,200,7,121,4,27,69,14,84,53,33,3,269,90,202]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E,a,l,p,t,s,r,i,h,c,d,b,y,g,_,w,F){"use strict";var O,G,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let U=class Hn extends C.Disposable{constructor(B,N,z,H,Q,X,fe,_e,ye,Re){super();this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=N,this._extHostContext=z,this._initData=fe,this._extHostWorkspace=H,this._extHostConfiguration=Q,this._logService=X,this._extHostTunnelService=ye,this._extHostTerminalService=Re,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(A.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(A.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(A.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new w.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=B.createChild(new d.ServiceCollection([o.IExtHostStorage,this._storage],[w.IExtHostSecretState,this._secretState]));const $e=new Set;this._initData.hostExtensions.forEach(Be=>$e.add(a.ExtensionIdentifier.toKey(Be))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Be,je,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Be,E.transformErrorForSerialization(je),V)},actualActivateExtension:async(Be,je)=>{if($e.has(a.ExtensionIdentifier.toKey(Be)))return await this._mainThreadExtensionsProxy.$activateExtension(Be,je),new f.HostExtension;const V=this._registry.getExtensionDescription(Be);return this._activateExtension(V,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(B){E.onUnexpectedError(B)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let B=[];try{B=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(N){}await Promise.all(B)}isActivated(B){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(B):!1}_activateByEvent(B,N){return this._activator.activateByEvent(B,N)}_activateById(B,N){return this._activator.activateById(B,N)}activateByIdWithErrors(B,N){return this._activateById(B,N).then(()=>{const z=this._activator.getActivatedExtension(B);if(z.activationFailed)return Promise.reject(z.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(B=>this._registry)}getExtensionExports(B){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(B).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const B=D.TernarySearchTree.forPaths(),N=this._registry.getAllExtensionDescriptions().map(z=>{if(!!this._getEntryPoint(z))return this._hostUtils.realpath(z.extensionLocation.fsPath).then(H=>B.set(T.URI.file(H).fsPath,z))});this._extensionPathIndex=Promise.all(N).then(()=>B)}return this._extensionPathIndex}_deactivate(B){let N=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(B))return N;const z=this._activator.getActivatedExtension(B);if(!z)return N;try{typeof z.module.deactivate=="function"&&(N=Promise.resolve(z.module.deactivate()).then(void 0,H=>(this._logService.error(H),Promise.resolve(void 0))))}catch(H){this._logService.error(H)}try{(0,C.dispose)(z.subscriptions)}catch(H){this._logService.error(H)}return N}async _activateExtension(B,N){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier),this._doActivateExtension(B,N).then(z=>{const H=z.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(B.identifier,H.codeLoadingTime,H.activateCallTime,H.activateResolvedTime,N),this._logExtensionActivationTimes(B,N,"success",H),z},z=>{throw this._logExtensionActivationTimes(B,N,"failure"),z})}_logExtensionActivationTimes(B,N,z,H){const Q=W(B,N);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...H||{},outcome:z})}_doActivateExtension(B,N){const z=W(B,N);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",z);const H=this._getEntryPoint(B);if(!H)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${B.identifier.value} ${JSON.stringify(N)}`),this._logService.flush();const Q=new f.ExtensionActivationTimesBuilder(N.startup);return Promise.all([this._loadCommonJSModule(B.identifier,(0,k.joinPath)(B.extensionLocation,H),Q),this._loadExtensionContext(B)]).then(X=>(I.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),Hn._callActivate(this._logService,B.identifier,X[0],X[1],Q))).then(X=>(I.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),X))}_loadExtensionContext(B){const N=new p.ExtensionGlobalMemento(B,this._storage),z=new p.ExtensionMemento(B.identifier.value,!1,this._storage),H=new F.ExtensionSecrets(B,this._secretState),Q=B.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,X=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([N.whenReady,z.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let _e;return Object.freeze({globalState:N,workspaceState:z,secrets:H,subscriptions:[],get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(ye){return L.join(B.extensionLocation.fsPath,ye)},get storagePath(){return fe._storagePath.workspaceValue(B)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(B).fsPath},get logPath(){return L.join(fe._initData.logsLocation.fsPath,B.identifier.value)},get logUri(){return T.URI.joinPath(fe._initData.logsLocation,B.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(B)},get globalStorageUri(){return fe._storagePath.globalValue(B)},get extensionMode(){return Q},get extension(){return _e===void 0&&(_e=new M(fe,B.identifier,B,X)),_e},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(B),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(B)}})})}static _callActivate(B,N,z,H,Q){return z=z||{activate:void 0,deactivate:void 0},this._callActivateOptional(B,N,z,H,Q).then(X=>new f.ActivatedExtension(!1,null,Q.build(),z,X,H.subscriptions))}static _callActivateOptional(B,N,z,H,Q){if(typeof z.activate=="function")try{Q.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${N.value}`);const X=typeof global=="object"?global:self,fe=z.activate.apply(X,[H]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(fe).then(_e=>(Q.activateResolveStop(),_e))}catch(X){return Promise.reject(X)}else return Promise.resolve(z)}_activateOneStartupFinished(B,N){this._activateById(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:N}).then(void 0,z=>{this._logService.error(z)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const B of this._registry.getAllExtensionDescriptions())if(B.activationEvents)for(const N of B.activationEvents)N==="onStartupFinished"&&this._activateOneStartupFinished(B,N)}_handleEagerExtensions(){const B=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const N=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],z=this._handleWorkspaceContainsEagerExtensions(N),H=Promise.all([B,z]).then(()=>{});return Promise.race([H,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),H}_handleWorkspaceContainsEagerExtensions(B){return B.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(N=>this._handleWorkspaceContainsEagerExtension(B,N))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(B,N){if(this.isActivated(N.identifier))return;const z=!this._initData.remote.isRemote&&!!this._initData.remote.authority,H={folders:B.map(X=>X.uri),forceUsingSearch:z,exists:X=>this._hostUtils.exists(X.fsPath),checkExists:(X,fe,_e)=>this._mainThreadWorkspaceProxy.$checkExists(X,fe,_e)},Q=await(0,_.checkActivateWorkspaceContainsExtension)(H,N);if(!!Q)return this._activateById(N.identifier,{startup:!0,extensionId:N.identifier,activationEvent:Q.activationEvent}).then(void 0,X=>this._logService.error(X))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(B){throw console.error(B),B}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:N}=this._initData.environment;if(!B||!N)throw new Error(m.localize(0,null));const z=await this._loadCommonJSModule(null,N,new f.ExtensionActivationTimesBuilder(!1));if(!z||typeof z.run!="function")throw new Error(m.localize(1,null,N.toString()));return new Promise((H,Q)=>{const X=(ye,Re)=>{ye?Q(ye):H(typeof Re=="number"&&Re>0?1:0)},fe=(0,k.originalFSPath)(N),_e=z.run(fe,X);_e&&_e.then&&_e.then(()=>{H(0)}).catch(ye=>{Q(ye.toString())})})}async $extensionTestsExit(B){this._logService.info(`extension host terminating: test runner requested exit with code ${B}`),this._logService.info(`exiting with code ${B}`),this._logService.flush(),this._hostUtils.exit(B)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(B,N){return this._resolvers[B]=N,(0,C.toDisposable)(()=>{delete this._resolvers[B]})}async _activateAndGetResolver(B){const N=B.indexOf("+");if(N===-1)throw new Error("Not an authority that can be resolved!");const z=B.substr(0,N);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${z}`,!1),{authorityPrefix:z,resolver:this._resolvers[z]}}async $resolveAuthority(B,N){const{authorityPrefix:z,resolver:H}=await this._activateAndGetResolver(B);if(!H)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${z}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(H)),I.mark(`code/extHost/willResolveAuthority/${z}`);const Q=await H.resolve(B,{resolveAttempt:N});I.mark(`code/extHost/didResolveAuthorityOK/${z}`);const X={authority:B,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},fe={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:X,options:fe,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(I.mark(`code/extHost/didResolveAuthorityError/${z}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(B,N){const{authorityPrefix:z,resolver:H}=await this._activateAndGetResolver(B);if(!H)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${z}`);const Q=T.URI.revive(N);if(typeof H.getCanonicalURI=="undefined")return Q;const X=await(0,R.asPromise)(()=>H.getCanonicalURI(Q));return X||Q}$startExtensionHost(B){return this._registry.keepOnly(B),this._startExtensionHost()}$activateByEvent(B,N){return N===1?this._activateByEvent(B,!1):this._readyToRunExtensions.wait().then(z=>this._activateByEvent(B,!1))}async $activate(B,N){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(B)?(await this._activateById(B,N),!0):!1}async $deltaExtensions(B,N){B.forEach(H=>H.extensionLocation=T.URI.revive(H.extensionLocation));const z=await this.getExtensionPathIndex();return await Promise.all(N.map(async H=>{const Q=this._registry.getExtensionDescription(H);if(!Q)return;const X=await this._hostUtils.realpath(Q.extensionLocation.fsPath);z.delete(T.URI.file(X).fsPath)})),await Promise.all(B.map(async H=>{const Q=await this._hostUtils.realpath(H.extensionLocation.fsPath);z.set(T.URI.file(Q).fsPath,H)})),this._registry.deltaExtensions(B,N),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){let N=l.VSBuffer.alloc(B),z=Math.random()%256;for(let H=0;H<B;H++)N.writeUInt8(z,H);return N}async $updateRemoteConnectionData(B){this._remoteConnectionData=B,this._onDidChangeRemoteConnectionData.fire()}};U=Ve([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,c.IExtHostRpcService),We(3,v.IExtHostWorkspace),We(4,u.IExtHostConfiguration),We(5,n.ILogService),We(6,i.IExtHostInitDataService),We(7,h.IExtensionStoragePaths),We(8,b.IExtHostTunnelService),We(9,y.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function W(x,B){return{id:x.identifier.value,name:x.name,extensionVersion:x.version,publisherDisplayName:x.publisher,activationEvents:x.activationEvents?x.activationEvents.join(","):null,isBuiltin:x.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class M{constructor(B,N,z,H){O.set(this,void 0),G.set(this,void 0),K.set(this,void 0),nt(this,O,B,"f"),nt(this,G,N,"f"),nt(this,K,z.identifier,"f"),this.id=z.identifier.value,this.extensionUri=z.extensionLocation,this.extensionPath=L.normalize((0,k.originalFSPath)(z.extensionLocation)),this.packageJSON=z,this.extensionKind=H}get isActive(){return Oe(this,O,"f").isActivated(Oe(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,O,"f").getExtensionExports(Oe(this,K,"f"))}activate(){return Oe(this,O,"f").activateByIdWithErrors(Oe(this,K,"f"),{startup:!1,extensionId:Oe(this,G,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,O=new WeakMap,G=new WeakMap,K=new WeakMap}),define(me[55],ge([0,1,8,2,3,18,5,7,124,37,40,45,216,38,210,14,4,13,34,54]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let l=class{constructor(d,b,y,g,_,w){this._workspaceService=b,this._extensionService=y,this._editorsService=g,this._configurationService=_,this._editorTabs=w,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=d.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(O=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,b){const y=d;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let g=`debug:${encodeURIComponent(y.path||"")}`,_="?";return b&&(g+=`${_}session=${encodeURIComponent(b.id)}`,_="&"),g+=`${_}ref=${y.sourceReference}`,L.URI.parse(g)}else{if(y.path)return L.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const b=[];for(const y of d.getAllExtensionDescriptions())if(y.contributes){const g=y.contributes.debuggers;if(g&&g.length>0)for(const _ of g)(0,o.isDebuggerMainContribution)(_)&&b.push(_.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(b=>d.push(b)),d}addBreakpoints(d){this.startBreakpoints();const b=d.filter(_=>{const w=_.id;return this._breakpoints.has(w)?!1:(this._breakpoints.set(w,_),!0)});this.fireBreakpointChanges(b,[],[]);const y=[],g=new Map;for(const _ of b)if(_ instanceof C.SourceBreakpoint){let w=g.get(_.location.uri.toString());w||(w={type:"sourceMulti",uri:_.location.uri,lines:[]},g.set(_.location.uri.toString(),w),y.push(w)),w.lines.push({id:_.id,enabled:_.enabled,condition:_.condition,hitCondition:_.hitCondition,logMessage:_.logMessage,line:_.location.range.start.line,character:_.location.range.start.character})}else _ instanceof C.FunctionBreakpoint&&y.push({type:"function",id:_.id,enabled:_.enabled,hitCondition:_.hitCondition,logMessage:_.logMessage,condition:_.condition,functionName:_.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(d){this.startBreakpoints();const b=d.filter(w=>this._breakpoints.delete(w.id));this.fireBreakpointChanges([],b,[]);const y=b.filter(w=>w instanceof C.SourceBreakpoint).map(w=>w.id),g=b.filter(w=>w instanceof C.FunctionBreakpoint).map(w=>w.id),_=b.filter(w=>w instanceof C.DataBreakpoint).map(w=>w.id);return this._debugServiceProxy.$unregisterBreakpoints(y,g,_)}startDebugging(d,b,y){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,b,{parentSessionID:y.parentSession?y.parentSession.id:void 0,lifecycleManagedByParent:y.lifecycleManagedByParent,repl:y.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact,debugUI:y.debugUI,suppressSaveBeforeStart:y.suppressSaveBeforeStart})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,b,y){if(!b)return new C.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:g,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,y,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,g),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(_=>_.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(d,b,y){if(!y)return new C.Disposable(()=>{});if(!this.definesDebugType(d,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:g,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,g),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(_=>_.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(d,b){if(!b)return new C.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:y,factory:b}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==b)})}async $runInTerminal(d,b){return Promise.resolve(void 0)}async $substituteVariables(d,b){if(!this._variableResolver){const[_,w]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(_||[],this._editorsService,w)}let y;const g=await this.getFolder(d);return g&&(y={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,b)}createDebugAdapter(d,b){if(d.type==="implementation")return new i(d.implementation)}createSignService(){}async $startDASession(d,b){const y=this,g=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const w=this.convertToDto(_),F=this.createDebugAdapter(w,g);if(!F)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const O=F;return this._debugAdapters.set(d,O),this.getDebugAdapterTrackers(g).then(G=>(G&&this._debugAdaptersTrackers.set(d,G),O.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const U=K,W={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(U.arguments.value);W.body={signature:M},O.sendResponse(W)}else throw new Error("no signer")}catch(M){W.success=!1,W.message=M.message,O.sendResponse(W)}}else G&&G.onDidSendMessage&&G.onDidSendMessage(K),K=(0,o.convertToVSCPaths)(K,!0),y._debugServiceProxy.$acceptDAMessage(d,K)}),O.onError(K=>{G&&G.onError&&G.onError(K),this._debugServiceProxy.$acceptDAError(d,K.name,K.message,K.stack)}),O.onExit(K=>{G&&G.onExit&&G.onExit((0,P.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,P.withNullAsUndefined)(K),void 0)}),G&&G.onWillStartSession&&G.onWillStartSession(),O.startSession()))})}$sendDAMessage(d,b){b=(0,o.convertToDAPaths)(b,!1);const y=this._debugAdaptersTrackers.get(d);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(b);const g=this._debugAdapters.get(d);g&&g.sendMessage(b)}$stopDASession(d){const b=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),b&&b.onWillStopSession&&b.onWillStopSession();const y=this._debugAdapters.get(d);return this._debugAdapters.delete(d),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const b=[],y=[],g=[];if(d.added)for(const _ of d.added){const w=_.id;if(w&&!this._breakpoints.has(w)){let F;if(_.type==="function")F=new C.FunctionBreakpoint(_.functionName,_.enabled,_.condition,_.hitCondition,_.logMessage);else if(_.type==="data")F=new C.DataBreakpoint(_.label,_.dataId,_.canPersist,_.enabled,_.hitCondition,_.condition,_.logMessage);else{const O=L.URI.revive(_.uri);F=new C.SourceBreakpoint(new C.Location(O,new C.Position(_.line,_.character)),_.enabled,_.condition,_.hitCondition,_.logMessage)}F._id=w,this._breakpoints.set(w,F),b.push(F)}}if(d.removed)for(const _ of d.removed){const w=this._breakpoints.get(_);w&&(this._breakpoints.delete(_),y.push(w))}if(d.changed){for(const _ of d.changed)if(_.id){const w=this._breakpoints.get(_.id);if(w){if(w instanceof C.FunctionBreakpoint&&_.type==="function"){const F=w;F.enabled=_.enabled,F.condition=_.condition,F.hitCondition=_.hitCondition,F.logMessage=_.logMessage,F.functionName=_.functionName}else if(w instanceof C.SourceBreakpoint&&_.type==="source"){const F=w;F.enabled=_.enabled,F.condition=_.condition,F.hitCondition=_.hitCondition,F.logMessage=_.logMessage,F.location=new C.Location(L.URI.revive(_.uri),new C.Position(_.line,_.character))}g.push(w)}}}this.fireBreakpointChanges(b,y,g)}$provideDebugConfigurations(d,b,y){return(0,k.asPromise)(async()=>{const g=this.getConfigProviderByHandle(d);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const _=await this.getFolder(b);return g.provideDebugConfigurations(_,y)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(d,b,y,g){return(0,k.asPromise)(async()=>{const _=this.getConfigProviderByHandle(d);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const w=await this.getFolder(b);return _.resolveDebugConfiguration(w,y,g)})}$resolveDebugConfigurationWithSubstitutedVariables(d,b,y,g){return(0,k.asPromise)(async()=>{const _=this.getConfigProviderByHandle(d);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const w=await this.getFolder(b);return _.resolveDebugConfigurationWithSubstitutedVariables(w,y,g)})}async $provideDebugAdapter(d,b){const y=this.getAdapterDescriptorFactoryByHandle(d);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(b);return this.getAdapterDescriptor(y,g).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(_)})}async $acceptDebugSessionStarted(d){const b=await this.getSession(d);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(d){const b=await this.getSession(d);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,b){const y=await this.getSession(d);y&&y._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(d,b){const g={session:await this.getSession(d),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(d){if(d instanceof C.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof C.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const b=this._adapterFactories.filter(y=>y.type===d);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(d){const b=this._adapterFactories.filter(y=>y.handle===d);if(b.length>0)return b[0].factory}getConfigProviderByHandle(d){const b=this._configProviders.filter(y=>y.handle===d);if(b.length>0)return b[0].provider}definesDebugType(d,b){if(d.contributes){const y=d.contributes.debuggers;if(y&&y.length>0){for(const g of y)if(g.label&&g.type&&g.type===b)return!0}}return!1}getDebugAdapterTrackers(d){const y=d.configuration.type,g=this._trackerFactories.filter(_=>_.type===y||_.type==="*").map(_=>(0,k.asPromise)(()=>_.factory.createDebugAdapterTracker(d)).then(w=>w,w=>null));return Promise.race([Promise.all(g).then(_=>{const w=_.filter(F=>!!F);if(w.length>0)return new r(w)}),new Promise((_,w)=>{const F=setTimeout(()=>{clearTimeout(F),w(new Error("timeout"))},1e3)})]).catch(_=>{})}async getAdapterDescriptor(d,b){const y=b.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new C.DebugAdapterServer(y));if(d){const _=await this._extensionService.getExtensionRegistry();return(0,k.asPromise)(()=>d.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,_))).then(w=>{if(w)return w})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,g))}daExecutableFromPackage(d,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,b,y){(d.length>0||b.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:b,changed:y}))}async getSession(d){if(d)if(typeof d=="string"){const b=this._debugSessions.get(d);if(b)return b}else{let b=this._debugSessions.get(d.id);if(!b){const y=await this.getFolder(d.folderUri),g=d.parent?this._debugSessions.get(d.parent):void 0;b=new p(this._debugServiceProxy,d.id,d.type,d.name,y,d.configuration,g),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(d){if(d){const b=L.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};l=Ve([We(0,v.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,n.IExtHostExtensionService),We(3,A.IExtHostDocumentsAndEditors),We(4,f.IExtHostConfiguration),We(5,a.IExtHostEditorTabs)],l),e.ExtHostDebugServiceBase=l;class p{constructor(d,b,y,g,_,w,F){this._debugServiceProxy=d,this._id=b,this._type=y,this._name=g,this._workspaceFolder=_,this._configuration=w,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,b)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=p;class t{constructor(d){this.value=Object.freeze({append(b){d.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=t;class s extends u.AbstractVariableResolverService{constructor(d,b,y,g,_){function w(){if(b){const F=b.activeEditor();if(F)return F.document.uri;const O=g.tabs.filter(G=>G.isActive);if(O.length>0){const G=O[0].resource;return G&&(G.primary||G.secondary)?G.primary??G.secondary:O[0].resource}}}super({getFolderUri:F=>{const O=d.filter(G=>G.name===F);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(F,O)=>y.getConfiguration(void 0,F).get(O),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const F=w();if(F)return m.normalize(F.fsPath)},getWorkspaceFolderPathForFile:()=>{if(_){const F=w();if(F){const O=_.getWorkspaceFolder(F);if(O)return m.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(b){const F=b.activeEditor();if(F&&!F.selection.isEmpty)return F.document.getText(F.selection)}},getLineNumber:()=>{if(b){const F=b.activeEditor();if(F)return String(F.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=s;class r{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(b=>b.onError?b.onError(d):void 0)}onExit(d,b){this.trackers.forEach(y=>y.onExit?y.onExit(d,b):void 0)}}class i extends D.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let h=class extends l{constructor(d,b,y,g,_,w){super(d,b,y,g,_,w)}createVariableResolver(d,b,y){return new s(d,b,y,this._editorTabs)}};h=Ve([We(0,v.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,n.IExtHostExtensionService),We(3,A.IExtHostDocumentsAndEditors),We(4,f.IExtHostConfiguration),We(5,a.IExtHostEditorTabs)],h),e.WorkerExtHostDebugService=h}),define(me[270],ge([0,1,73,2,5,38,36,26,14,27,4,40,34,12]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(a,l,p,t,s,r,i){this._apiFactory=a,this._extensionRegistry=l,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,l,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(P,l,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let l of a.nodeModuleName)this._factories.set(l,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(l=>a.alternativeModuleName(l))}};o=Ve([We(2,n.IInstantiationService),We(3,k.IExtHostConfiguration),We(4,A.IExtHostExtensionService),We(5,T.IExtHostInitDataService),We(6,f.ILogService)],o),e.RequireInterceptor=o;class v{constructor(a,l,p,t,s){this._apiFactory=a,this._extensionPaths=l,this._extensionRegistry=p,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,l){const p=this._extensionPaths.findSubstr(l.fsPath);if(p){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,r)=>t+=`	${r} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(a,l){this.nodeModuleName="keytar";const{environment:p}=l,t=a.getProxy(I.MainContext.MainThreadKeytar);if(p.appRoot){let s=p.appRoot.fsPath;u.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,r)=>t.$getPassword(s,r),setPassword:(s,r,i)=>t.$setPassword(s,r,i),deletePassword:(s,r)=>t.$deletePassword(s,r),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(a,l){return this._impl}alternativeModuleName(a){const l=a.length;if(l<=7||!this.alternativeNames)return;const p=l-7;if((a.charAt(p)==="/"||a.charAt(p)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};S=Ve([We(0,D.IExtHostRpcService),We(1,T.IExtHostInitDataService)],S);let P=class{constructor(a,l,p){this._extensionPaths=a,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(I.MainContext.MainThreadTelemetry);const t=p.getProxy(I.MainContext.MainThreadWindow);this._impl=(s,r)=>{const i=L.URI.parse(s);return r?this.callOriginal(s,r):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,s,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,s,{}):this.callOriginal(s,r)}}load(a,l,p){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(a),this._impl}callOriginal(a,l){return this.sendNoForwardTelemetry(),this._original(a,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};P=Ve([We(2,D.IExtHostRpcService)],P)}),define(me[271],ge([0,1,170,11,7,211,37,40,45,38,33,14,55,194,18,212,54]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let P=class extends u.ExtHostDebugServiceBase{constructor(l,p,t,s,r,i,h){super(l,p,t,s,r,h);this._terminalService=i,this._integratedTerminalInstances=new E}createDebugAdapter(l,p){switch(l.type){case"server":return new k.SocketDebugAdapter(l);case"pipeServer":return new k.NamedPipeDebugAdapter(l);case"executable":return new k.ExecutableDebugAdapter(l,p.type)}return super.createDebugAdapter(l,p)}daExecutableFromPackage(l,p){const t=k.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),l.type);if(t)return new I.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new f.SignService}async $runInTerminal(l,p){if(l.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(w=>{this._integratedTerminalInstances.onTerminalClosed(w)}));const t=await this._configurationService.getConfigProvider(),s=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),i=l.title||m.localize(0,null),h=JSON.stringify({shell:s,shellArgs:r});let c=await this._integratedTerminalInstances.checkout(h,i),d,b=!1;if(c)d=l.cwd;else{const w={shellPath:s,shellArgs:r,cwd:l.cwd,name:i,iconPath:new I.ThemeIcon("debug")};b=!0,c=this._terminalService.createTerminalFromOptions(w,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(c,h)}c.show(!0);const y=await c.processId;b?await new Promise(w=>setTimeout(w,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?c.sendText("cls"):s.indexOf("bash")>=0?c.sendText("clear"):L.isWindows?c.sendText("cls"):c.sendText("clear"));const g=(0,v.prepareCommand)(s,l.args,d,l.env);c.sendText(g);const _=this.onDidTerminateDebugSession(w=>{w.id===p&&(this._integratedTerminalInstances.free(c),_.dispose())});return y}else if(l.kind==="external")return(0,v.runInExternalTerminal)(l,await this._configurationService.getConfigProvider());return super.$runInTerminal(l,p)}createVariableResolver(l,p,t){return new u.ExtHostVariableResolverService(l,p,t,this._editorTabs,this._workspaceService)}};P=Ve([We(0,A.IExtHostRpcService),We(1,R.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,D.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,n.IExtHostTerminalService),We(6,S.IExtHostEditorTabs)],P),e.ExtHostDebugService=P;class E{constructor(){this._terminalInstances=new Map}async checkout(l,p){const s=[...this._terminalInstances.entries()].map(([r,i])=>(0,o.createCancelablePromise)(async h=>{if(r.name!==p||i.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await r.processId))return null;const c=Date.now();return i.lastUsedAt+E.minUseDelay>c||h.isCancellationRequested||i.config!==l?null:(i.lastUsedAt=c,r)}));return await(0,o.firstParallel)(s,r=>!!r)}insert(l,p){this._terminalInstances.set(l,{lastUsedAt:Date.now(),config:p})}free(l){const p=this._terminalInstances.get(l);p&&(p.lastUsedAt=-1)}onTerminalClosed(l){this._terminalInstances.delete(l)}}E.minUseDelay=1e3}),define(me[272],ge([0,1,8,2,113,37,55,45,38,43,33,14,27,72,10,12,67,54,22,80]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let l=class extends f.ExtHostTaskBase{constructor(t,s,r,i,h,c,d,b,y){super(t,s,r,i,h,c,d,b);this.workspaceService=r,this.editorTabs=y,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(o.Schemas.file,{scheme:o.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,s){const r=s;if(!s.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const i=f.TaskHandleDTO.from(r,this.workspaceService),h=await this._proxy.$getTaskExecution(i);if(h.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.getTaskExecution(h,s);return this._proxy.$executeTask(i).catch(()=>{}),c}else{const i=f.TaskDTO.from(s,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,s,!1);const h=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),s);return this._proxy.$executeTask(i).catch(()=>{}),h}}provideTasksInternal(t,s,r,i){const h=[];if(i)for(let c of i){this.checkDeprecation(c,r),(!c.definition||!t[c.definition.type])&&this._logService.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const d=f.TaskDTO.from(c,r.extension);d&&(h.push(d),f.CustomExecutionDTO.is(d.execution)&&s.push(this.addCustomExecution(d,c,!0)))}return{tasks:h,extension:r.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const s=await this._configurationService.getConfigProvider();this._variableResolver=new R.ExtHostVariableResolverService(t,this._editorService,s,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let s=t&&t.length>0?t[0]:void 0;if(!s){const r=L.URI.file((0,a.homedir)());s=new T.WorkspaceFolder({uri:r,name:E.basename(r),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,s){const r=L.URI.revive(t),i={process:void 0,variables:Object.create(null)},h=await this._workspaceProvider.resolveWorkspaceFolder(r),c=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.getVariableResolver(c),b=h?{uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(c);for(let y of s.variables)i.variables[y]=await d.resolveAsync(b,y);if(s.process!==void 0){let y;if(s.process.path!==void 0){y=s.process.path.split(m.delimiter);for(let g=0;g<y.length;g++)y[g]=await d.resolveAsync(b,y[g])}i.process=await I.win32.findExecutable(await d.resolveAsync(b,s.process.name),s.process.cwd!==void 0?await d.resolveAsync(b,s.process.cwd):void 0,y)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,s,r){return I.win32.findExecutable(t,s,r)}};l=Ve([We(0,A.IExtHostRpcService),We(1,u.IExtHostInitDataService),We(2,k.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,n.IExtHostTerminalService),We(6,v.ILogService),We(7,S.IExtHostApiDeprecationService),We(8,P.IExtHostEditorTabs)],l),e.ExtHostTask=l}),define(me[273],ge([0,1,18,16,73,6,2,5,265,12,82,84,27,188,14,65,40,33]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(l,p,t,s){this._disposables=new k.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(l,null,s),p=E._transform(p,this._rpcProtocol);const r=new A.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());r.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...p}),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),r.set(v.IURITransformerService,new v.URITransformerService(s)),r.set(S.IHostUtils,t);const i=new f.InstantiationService(r,!0),h=i.invokeFunction(y=>y.get(P.IExtHostTerminalService));this._disposables.add(h),this._logService=i.invokeFunction(y=>y.get(T.ILogService)),I.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=i.invokeFunction(y=>y.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const c=new WeakMap;this._extensionService.getExtensionPathIndex().then(y=>{Error.prepareStackTrace=(g,_)=>{let w="",F,O;for(const G of _)w+=`
	at ${G.toString()}`,O=G.getFileName(),!F&&O&&(F=y.findSubstr(O));return c.set(g,F),`${g.name||"Error"}: ${g.message||""}${w}`}});const d=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(y=>{const g=L.transformErrorForSerialization(y),_=c.get(y);_?d.$onExtensionRuntimeError(_.identifier,g):b.$onUnexpectedError(g)})}terminate(l){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,m.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(l,p){l.extensions.forEach(s=>s.extensionLocation=R.URI.revive(p.transformIncomingURIs(s.extensionLocation))),l.environment.appRoot=R.URI.revive(p.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(s=>R.URI.revive(p.transformIncomingURIs(s)))),l.environment.extensionTestsLocationURI=R.URI.revive(p.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=R.URI.revive(p.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=R.URI.revive(p.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=R.URI.revive(p.transformIncomingURIs(l.logsLocation)),l.logFile=R.URI.revive(p.transformIncomingURIs(l.logFile)),l.workspace=p.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=E}),define(me[274],ge([0,1,8,21,61,30,22,46,31]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(u,f,o){this.config=u,this.provider=f,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&k.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&k.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const f=this.config.folderQueries||[];return new Promise((o,v)=>{const S=P=>{this.resultCount++,u(P)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const E=P.toString(),a=m.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,a)||this.matchFile(S,{base:P,basename:a})}),Promise.all(f.map(P=>this.searchInFolder(P,S))).then(P=>{o({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{v(new Error((0,I.toErrorMessage)(P)))})})}async searchInFolder(u,f){const o=new L.CancellationTokenSource,v=this.getSearchOptionsForFolder(u),S=this.initDirectoryTree(),P=new D.QueryGlobTester(this.config,u),E=!P.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(o),a=C.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,o.token),p=a.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(s=>{const r=m.posix.relative(u.folder.path,s.path);if(E){const i=m.basename(s.path);this.matchFile(f,{base:u.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(S,u.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,P,f),{providerTime:p,postProcessTime:t.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(u){const f=(0,D.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),o=(0,D.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:o,includes:f,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},f,o,v){if(o===this.filePattern){const P=m.basename(this.filePattern);this.matchFile(v,{base:f,relativePath:this.filePattern,basename:P})}function S(P){const E=m.basename(P),a=m.dirname(P);let l=u[a];l||(l=u[a]=[],S(a)),l.push({base:f,relativePath:P,basename:E})}S(o)}matchDirectoryTree({rootEntries:u,pathToEntries:f},o,v){const S=this,P=this.filePattern;function E(a){const l=k.hasSiblingFn(()=>a.map(p=>p.basename));for(let p=0,t=a.length;p<t;p++){const s=a[p],{relativePath:r,basename:i}=s;if(!o.includedInQuerySync(r,i,P!==i?l:void 0))continue;const h=f[r];if(h)E(h);else{if(r===P)continue;S.matchFile(v,s)}if(S.isLimitHit)break}}E(u)}matchFile(u,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(f))}}class n{constructor(){this.sessions=new Map}fileSearch(u,f,o,v){const S=this.getSessionTokenSource(u.cacheKey),P=new T(u,f,S&&S.token);let E=0;const a=l=>{E+=l.length,o(l.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(P,n.BATCH_SIZE,a,v).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:l.stats}}))}clearCache(u){const f=this.getSessionTokenSource(u);f&&f.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new L.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:R.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,f,o,v){v.onCancellationRequested(()=>{u.cancel()});const S=E=>{E&&(P.push(E),f>0&&P.length>=f&&(o(P),P=[]))};let P=[];return u.search(S).then(E=>(P.length&&o(P),E),E=>(P.length&&o(P),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(me[133],ge([0,1,17,21,61,30,10,8,22,13,2,31]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(a,l,p,t){this.query=a,this.provider=l,this.fileUtils=p,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,l){const p=this.query.folderQueries||[],t=new L.CancellationTokenSource;return l.onCancellationRequested(()=>t.cancel()),new Promise((s,r)=>{this.collector=new o(a);let i=!1;const h=(c,d)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(c);S(c)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const y=this.resultSize(c);this.resultCount+=y,(y>0||!S(c))&&this.collector.add(c,d)}};Promise.all(p.map((c,d)=>this.searchInFolder(c,b=>h(b,d),t.token))).then(c=>{t.dispose(),this.collector.flush();const d=c.some(b=>!!b&&!!b.limitHit);s({limitHit:this.isLimitHit||d,messages:(0,m.flatten)(c.map(b=>b?.message?(0,T.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},c=>{t.dispose();const d=(0,I.toErrorMessage)(c);r(new Error(d))})})}resultSize(a){return S(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,l){const p=Array.isArray(a.ranges)?a.ranges:[a.ranges],t=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:p.slice(0,l),preview:{matches:t.slice(0,l),text:a.preview.text},uri:a.uri}}async searchInFolder(a,l,p){const t=new A.QueryGlobTester(this.query,a),s=[],r={report:c=>{if(!this.validateProviderResult(c))return;const d=a.folder.scheme===R.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(c.uri))):void 0,b=D.relativePath(a.folder,c.uri);if(b){const y=t.includedInQuery(b,C.basename(b),d);(0,T.isPromise)(y)?s.push(y.then(g=>{g&&l(c)})):y&&l(c)}}},i=this.getSearchOptionsForFolder(a),h=await this.provider.provideTextSearchResults(f(this.query.contentPattern),i,r,p);return s.length&&await Promise.all(s),h}validateProviderResult(a){if(S(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const l=(0,A.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),p=(0,A.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),t={folder:n.URI.from(a.folder),excludes:p,includes:l,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=u;function f(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class o{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,l=>this.sendItems(l))}add(a,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!D.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(v(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=o;function v(E){return S(E)?{preview:{matches:(0,m.mapArrayOrNot)(E.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:E.preview.text},ranges:(0,m.mapArrayOrNot)(E.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function S(E){return!!E.preview}e.extensionResultIsMatch=S;class P{constructor(a,l){this.maxBatchSize=a,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,l){!a||this.addItemToBatch(a,l)}addItems(a,l){!a||this.addItemsToBatch(a,l)}addItemToBatch(a,l){this.batch.push(a),this.batchSize+=l,this.onUpdate()}addItemsToBatch(a,l){this.batch=this.batch.concat(a),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(me[74],ge([0,1,6,5,4,274,14,65,12,2,133]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let A=class{constructor(v,S,P){this.extHostRpc=v,this._uriTransformer=S,this._logService=P,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new k.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,S){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const P=this._handlePool++;return this._textSearchProvider.set(P,S),this._proxy.$registerTextSearchProvider(P,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(v,S){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const P=this._handlePool++;return this._fileSearchProvider.set(P,S),this._proxy.$registerFileSearchProvider(P,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(v,S,P,E){const a=u(P),l=this._fileSearchProvider.get(v);if(l)return this._fileSearchManager.fileSearch(a,l,p=>{this._proxy.$handleFileMatch(v,S,p.map(t=>t.resource))},E);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,S,P,E){const a=this._textSearchProvider.get(v);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const l=u(P);return this.createTextSearchManager(l,a).search(t=>this._proxy.$handleTextMatch(v,S,t),E)}$enableExtensionHostSearch(){}createTextSearchManager(v,S){return new n.TextSearchManager(v,S,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};A=Ve([We(0,R.IExtHostRpcService),We(1,C.IURITransformerService),We(2,D.ILogService)],A),e.ExtHostSearch=A;function u(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(f),extraFileResources:o.extraFileResources&&o.extraFileResources.map(v=>T.URI.revive(v))}}e.reviveQuery=u;function f(o){return{...o,folder:T.URI.revive(o.folder)}}}),define(me[275],ge([0,1,21,16,3,49,2,114,109,146,81,42,5,233,232,44,234,38,235,236,237,218,238,45,40,239,219,242,243,244,68,221,249,250,251,92,33,253,222,15,7,256,70,132,37,36,57,207,241,86,131,72,55,74,12,65,14,27,245,204,53,67,230,254,203,69,91,259,257,258,231,52,252,255,90,54,122,247,71,248,10,190,246,201,240]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E,a,l,p,t,s,r,i,h,c,d,b,y,g,_,w,F,O,G,K,U,W,M,x,B,N,z,H,Q,X,fe,_e,ye,Re,$e,Be,je,V,ee,re,ae,Y,oe,ve,Me,qe,Ke,Se,tt,Z,te,pe,xe,Je,rt,ft,pt,St,Ct,ue,Ie,Ue,Qe,ze,at,Le,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ke(ne){const de=ne.get(re.IExtHostInitDataService),be=ne.get(Je.IExtHostFileSystemInfo),we=ne.get(tt.IExtHostConsumerFileSystem),Fe=ne.get(r.IExtHostExtensionService),Ge=ne.get(z.IExtHostWorkspace),He=ne.get(Ct.IExtHostTelemetry),Ye=ne.get(P.IExtHostConfiguration),it=ne.get(V.IURITransformerService),le=ne.get(ee.IExtHostRpcService),Ee=ne.get(O.IExtHostStorage),ce=ne.get(Se.IExtensionStoragePaths),q=ne.get(je.ILogService),Ae=ne.get(oe.IExtHostTunnelService),Pe=ne.get(ve.IExtHostApiDeprecationService),Ze=ne.get(N.IExtHostWindow),Xe=ne.get(pt.IExtHostSecretState),ot=ne.get(St.IExtHostEditorTabs);le.set(u.ExtHostContext.ExtHostFileSystemInfo,be),le.set(u.ExtHostContext.ExtHostLogService,q),le.set(u.ExtHostContext.ExtHostWorkspace,Ge),le.set(u.ExtHostContext.ExtHostConfiguration,Ye),le.set(u.ExtHostContext.ExtHostExtensionService,Fe),le.set(u.ExtHostContext.ExtHostStorage,Ee),le.set(u.ExtHostContext.ExtHostTunnelService,Ae),le.set(u.ExtHostContext.ExtHostWindow,Ze),le.set(u.ExtHostContext.ExtHostSecretState,Xe),le.set(u.ExtHostContext.ExtHostTelemetry,He),le.set(u.ExtHostContext.ExtHostEditorTabs,ot);const vt=le.set(u.ExtHostContext.ExtHostDecorations,ne.get(ye.IExtHostDecorations)),Et=le.set(u.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(s.IExtHostDocumentsAndEditors)),lt=le.set(u.ExtHostContext.ExtHostCommands,ne.get(v.IExtHostCommands)),dt=le.set(u.ExtHostContext.ExtHostTerminalService,ne.get(G.IExtHostTerminalService)),mt=le.set(u.ExtHostContext.ExtHostDebugService,ne.get($e.IExtHostDebugService)),Rt=le.set(u.ExtHostContext.ExtHostSearch,ne.get(Be.IExtHostSearch)),yt=le.set(u.ExtHostContext.ExtHostTask,ne.get(Re.IExtHostTask)),Ot=le.set(u.ExtHostContext.ExtHostOutputService,ne.get(y.IExtHostOutputService)),hn=le.set(u.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(le)),It=le.set(u.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(le,Et)),$t=le.set(u.ExtHostContext.ExtHostDocumentContentProviders,new l.ExtHostDocumentContentProvider(le,Et,q)),Zt=le.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(q,It,le.getProxy(u.MainContext.MainThreadBulkEdits))),wt=le.set(u.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(le,lt,Et,It,ce)),Kt=le.set(u.ExtHostContext.ExtHostNotebookDocuments,new Le.ExtHostNotebookDocuments(q,wt)),Vt=le.set(u.ExtHostContext.ExtHostNotebookEditors,new at.ExtHostNotebookEditors(q,le,wt)),en=le.set(u.ExtHostContext.ExtHostNotebookKernels,new ue.ExtHostNotebookKernels(le,de,wt,q)),tn=le.set(u.ExtHostContext.ExtHostNotebookRenderers,new Ue.ExtHostNotebookRenderers(le,wt)),Pt=le.set(u.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(le,Et)),Qt=le.set(u.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(le.getProxy(u.MainContext.MainThreadTreeViews),lt,q)),bn=le.set(u.ExtHostContext.ExtHostEditorInsets,new X.ExtHostEditorInsets(le.getProxy(u.MainContext.MainThreadEditorInsets),Pt,de)),Wt=le.set(u.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(le,q,be)),Ht=le.set(u.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(le,It,lt.converter)),gt=le.set(u.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(le,it,It,lt,Wt,q,Pe)),nn=le.set(u.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(le,gt)),Nt=le.set(u.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(le,q,Et)),Ut=le.set(u.ExtHostContext.ExtHostQuickOpen,(0,_.createExtHostQuickOpen)(le,Ge,lt)),Xt=le.set(u.ExtHostContext.ExtHostSCM,new w.ExtHostSCM(le,lt,q)),En=le.set(u.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(le,lt,It)),fn=le.set(u.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(le.getProxy(u.MainContext.MainThreadProgress))),_n=le.set(u.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(le)),mn=le.set(u.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(le)),rn=le.set(u.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(le)),sn=le.set(u.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(le,lt)),jt=le.set(u.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(le,{remote:de.remote},Ge,q,Pe)),on=le.set(u.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(le,jt,Ge)),Sn=le.set(u.ExtHostContext.ExtHostCustomEditors,new te.ExtHostCustomEditors(le,It,ce,jt,on)),yn=le.set(u.ExtHostContext.ExtHostWebviewViews,new Z.ExtHostWebviewViews(le,jt)),qt=le.set(u.ExtHostContext.ExtHostTesting,new rt.ExtHostTesting(le,lt)),Jt=le.set(u.ExtHostContext.ExtHostUriOpeners,new ft.ExtHostUriOpeners(le));le.set(u.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(le,wt,Et,lt));const Dn=(0,Q.values)(u.ExtHostContext);le.assertRegistered(Dn);const Cn=new xe.ExtHostBulkEdits(le,Et),an=new o.ExtHostClipboard(le),ln=new b.ExtHostMessageService(le,q),zt=new a.ExtHostDialogs(le),Ft=new F.ExtHostStatusBar(le,lt.converter);return f.ExtHostApiCommands.register(lt),function(Ne,Tt,Gt){const bt=function(){let ie=!Ne.isUnderDevelopment;function he(Te){ie||(q.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Te(ct){if(Array.isArray(ct))ct.forEach(Te);else if(typeof ct=="string")he(ct);else{const _t=ct;typeof _t.scheme=="undefined"&&he(ct),!Ne.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,H.throwProposedApiError)(Ne)}return ct}}(),kn={getSession(ie,he,Te){return Te?.forceNewSession&&(0,H.checkProposedApiEnabled)(Ne),rn.getSession(Ne,ie,he,Te)},get onDidChangeSessions(){return rn.onDidChangeSessions},registerAuthenticationProvider(ie,he,Te,ct){return rn.registerAuthenticationProvider(ie,he,Te,ct)}},In={registerCommand(ie,he,Te){return lt.registerCommand(!0,ie,he,Te)},registerTextEditorCommand(ie,he,Te){return lt.registerCommand(!0,ie,(...ct)=>{const _t=Pt.getActiveTextEditor();if(!_t){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}return _t.edit(kt=>{he.apply(Te,[_t,kt,...ct])}).then(kt=>{kt||q.warn("Edits from command "+ie+" were not applied.")},kt=>{q.warn("An error occurred while running command "+ie,kt)})})},registerDiffInformationCommand:(ie,he,Te)=>((0,H.checkProposedApiEnabled)(Ne),lt.registerCommand(!0,ie,async(...ct)=>{const _t=Et.activeEditor(!0);if(!_t){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(_t.id);he.apply(Te,[kt,...ct])})),executeCommand(ie,...he){return lt.executeCommand(ie,...he)},getCommands(ie=!1){return lt.getCommands(ie)}},gn={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return an.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return He.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return He.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,he){return Ze.openUri(ie,{allowTunneling:!!de.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===de.environment.appUriScheme)return hn.createAppUri(ie);try{return await Ze.asExternalUri(ie,{allowTunneling:!!de.remote.authority})}catch(he){if((0,ze.matchesScheme)(ie,Qe.Schemas.http)||(0,ze.matchesScheme)(ie,Qe.Schemas.https))return ie;throw he}},get remoteName(){return(0,_e.getRemoteName)(de.remote.authority)},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=de.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Pn={createTestController(ie,he){return qt.createTestController(ie,he)},createTestObserver(){return(0,H.checkProposedApiEnabled)(Ne),qt.createTestObserver()},runTests(ie){return(0,H.checkProposedApiEnabled)(Ne),qt.runTests(ie)},get onDidChangeTestResults(){return(0,H.checkProposedApiEnabled)(Ne),qt.onResultsChanged},get testResults(){return(0,H.checkProposedApiEnabled)(Ne),qt.results}},An={getExtension(ie){const he=Tt.getExtensionDescription(ie);if(he)return new r.Extension(Fe,Ne.identifier,he,pn)},get all(){return Tt.getAllExtensionDescriptions().map(ie=>new r.Extension(Fe,Ne.identifier,ie,pn))},get onDidChange(){return Tt.onDidChange}},cn={createDiagnosticCollection(ie){return Wt.createDiagnosticCollection(Ne.identifier,ie)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:ie=>Wt.getDiagnostics(ie),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(ie,he){return Ht.changeLanguage(ie.uri,he)},match(ie,he){return(0,n.score)(W.LanguageSelector.from(ie),he.uri,he.languageId,!0)},registerCodeActionsProvider(ie,he,Te){return gt.registerCodeActionProvider(Ne,bt(ie),he,Te)},registerCodeLensProvider(ie,he){return gt.registerCodeLensProvider(Ne,bt(ie),he)},registerDefinitionProvider(ie,he){return gt.registerDefinitionProvider(Ne,bt(ie),he)},registerDeclarationProvider(ie,he){return gt.registerDeclarationProvider(Ne,bt(ie),he)},registerImplementationProvider(ie,he){return gt.registerImplementationProvider(Ne,bt(ie),he)},registerTypeDefinitionProvider(ie,he){return gt.registerTypeDefinitionProvider(Ne,bt(ie),he)},registerHoverProvider(ie,he){return gt.registerHoverProvider(Ne,bt(ie),he,Ne.identifier)},registerEvaluatableExpressionProvider(ie,he){return gt.registerEvaluatableExpressionProvider(Ne,bt(ie),he,Ne.identifier)},registerInlineValuesProvider(ie,he){return gt.registerInlineValuesProvider(Ne,bt(ie),he,Ne.identifier)},registerDocumentHighlightProvider(ie,he){return gt.registerDocumentHighlightProvider(Ne,bt(ie),he)},registerLinkedEditingRangeProvider(ie,he){return gt.registerLinkedEditingRangeProvider(Ne,bt(ie),he)},registerReferenceProvider(ie,he){return gt.registerReferenceProvider(Ne,bt(ie),he)},registerRenameProvider(ie,he){return gt.registerRenameProvider(Ne,bt(ie),he)},registerDocumentSymbolProvider(ie,he,Te){return gt.registerDocumentSymbolProvider(Ne,bt(ie),he,Te)},registerWorkspaceSymbolProvider(ie){return gt.registerWorkspaceSymbolProvider(Ne,ie)},registerDocumentFormattingEditProvider(ie,he){return gt.registerDocumentFormattingEditProvider(Ne,bt(ie),he)},registerDocumentRangeFormattingEditProvider(ie,he){return gt.registerDocumentRangeFormattingEditProvider(Ne,bt(ie),he)},registerOnTypeFormattingEditProvider(ie,he,Te,...ct){return gt.registerOnTypeFormattingEditProvider(Ne,bt(ie),he,[Te].concat(ct))},registerDocumentSemanticTokensProvider(ie,he,Te){return gt.registerDocumentSemanticTokensProvider(Ne,bt(ie),he,Te)},registerDocumentRangeSemanticTokensProvider(ie,he,Te){return gt.registerDocumentRangeSemanticTokensProvider(Ne,bt(ie),he,Te)},registerSignatureHelpProvider(ie,he,Te,...ct){return typeof Te=="object"?gt.registerSignatureHelpProvider(Ne,bt(ie),he,Te):gt.registerSignatureHelpProvider(Ne,bt(ie),he,typeof Te=="undefined"?[]:[Te,...ct])},registerCompletionItemProvider(ie,he,...Te){return gt.registerCompletionItemProvider(Ne,bt(ie),he,Te)},registerInlineCompletionItemProvider(ie,he){return(0,H.checkProposedApiEnabled)(Ne),gt.registerInlineCompletionsProvider(Ne,bt(ie),he)},registerDocumentLinkProvider(ie,he){return gt.registerDocumentLinkProvider(Ne,bt(ie),he)},registerColorProvider(ie,he){return gt.registerColorProvider(Ne,bt(ie),he)},registerFoldingRangeProvider(ie,he){return gt.registerFoldingRangeProvider(Ne,bt(ie),he)},registerSelectionRangeProvider(ie,he){return gt.registerSelectionRangeProvider(Ne,ie,he)},registerCallHierarchyProvider(ie,he){return gt.registerCallHierarchyProvider(Ne,ie,he)},setLanguageConfiguration:(ie,he)=>gt.setLanguageConfiguration(Ne,ie,he),getTokenInformationAtPosition(ie,he){return(0,H.checkProposedApiEnabled)(Ne),Ht.tokenAtPosition(ie,he)},registerInlayHintsProvider(ie,he){return(0,H.checkProposedApiEnabled)(Ne),gt.registerInlayHintsProvider(Ne,ie,he)},registerTypeHierarchyProvider(ie,he){return(0,H.checkProposedApiEnabled)(Ne),gt.registerTypeHierarchyProvider(Ne,ie,he)},createLanguageStatusItem(ie,he){return(0,H.checkProposedApiEnabled)(Ne),Ht.createLanguageStatusItem(Ne,ie,he)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(ie,he,Te){const ct=await(R.URI.isUri(ie)?Promise.resolve(vn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(ct,he,Te)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Ne,ie)},onDidChangeActiveTextEditor(ie,he,Te){return Pt.onDidChangeActiveTextEditor(ie,he,Te)},onDidChangeVisibleTextEditors(ie,he,Te){return Pt.onDidChangeVisibleTextEditors(ie,he,Te)},onDidChangeTextEditorSelection(ie,he,Te){return Pt.onDidChangeTextEditorSelection(ie,he,Te)},onDidChangeTextEditorOptions(ie,he,Te){return Pt.onDidChangeTextEditorOptions(ie,he,Te)},onDidChangeTextEditorVisibleRanges(ie,he,Te){return Pt.onDidChangeTextEditorVisibleRanges(ie,he,Te)},onDidChangeTextEditorViewColumn(ie,he,Te){return Pt.onDidChangeTextEditorViewColumn(ie,he,Te)},onDidCloseTerminal(ie,he,Te){return dt.onDidCloseTerminal(ie,he,Te)},onDidOpenTerminal(ie,he,Te){return dt.onDidOpenTerminal(ie,he,Te)},onDidChangeActiveTerminal(ie,he,Te){return dt.onDidChangeActiveTerminal(ie,he,Te)},onDidChangeTerminalDimensions(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),dt.onDidChangeTerminalDimensions(ie,he,Te)},onDidChangeTerminalState(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),dt.onDidChangeTerminalState(ie,he,Te)},onDidWriteTerminalData(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),dt.onDidWriteTerminalData(ie,he,Te)},get state(){return Ze.state},onDidChangeWindowState(ie,he,Te){return Ze.onDidChangeWindowState(ie,he,Te)},showInformationMessage(ie,...he){return ln.showMessage(Ne,k.default.Info,ie,he[0],he.slice(1))},showWarningMessage(ie,...he){return ln.showMessage(Ne,k.default.Warning,ie,he[0],he.slice(1))},showErrorMessage(ie,...he){return ln.showMessage(Ne,k.default.Error,ie,he[0],he.slice(1))},showQuickPick(ie,he,Te){return Ut.showQuickPick(ie,!!Ne.enableProposedApi,he,Te)},showWorkspaceFolderPick(ie){return Ut.showWorkspaceFolderPick(ie)},showInputBox(ie,he){return Ut.showInput(ie,he)},showOpenDialog(ie){return zt.showOpenDialog(ie)},showSaveDialog(ie){return zt.showSaveDialog(ie)},createStatusBarItem(ie,he,Te){let ct,_t,kt;return typeof ie=="string"?(ct=ie,_t=he,kt=Te):(_t=ie,kt=he),Ft.createStatusBarEntry(Ne,ct,_t,kt)},setStatusBarMessage(ie,he){return Ft.setStatusBarMessage(ie,he)},withScmProgress(ie){return Pe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fn.withProgress(Ne,{location:M.ProgressLocation.SourceControl},(he,Te)=>ie({report(ct){}}))},withProgress(ie,he){return fn.withProgress(Ne,ie,he)},createOutputChannel(ie){return Ot.createOutputChannel(ie,Ne)},createWebviewPanel(ie,he,Te,ct){return on.createWebviewPanel(Ne,ie,he,Te,ct)},createWebviewTextEditorInset(ie,he,Te,ct){return(0,H.checkProposedApiEnabled)(Ne),bn.createWebviewEditorInset(ie,he,Te,ct,Ne)},createTerminal(ie,he,Te){return typeof ie=="object"?("location"in ie&&(0,H.checkProposedApiEnabled)(Ne),"pty"in ie?dt.createExtensionTerminal(ie):dt.createTerminalFromOptions(ie)):dt.createTerminal(ie,he,Te)},registerTerminalLinkProvider(ie){return dt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,he){return dt.registerProfileProvider(Ne,ie,he)},registerTreeDataProvider(ie,he){return Qt.registerTreeDataProvider(ie,he,Ne)},createTreeView(ie,he){return Qt.createTreeView(ie,he,Ne)},registerWebviewPanelSerializer:(ie,he)=>on.registerWebviewPanelSerializer(Ne,ie,he),registerCustomEditorProvider:(ie,he,Te={})=>Sn.registerCustomEditorProvider(Ne,ie,he,Te),registerFileDecorationProvider(ie){return vt.registerFileDecorationProvider(ie,Ne.identifier)},registerUriHandler(ie){return hn.registerUriHandler(Ne.identifier,ie)},createQuickPick(){return Ut.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Ut.createInputBox(Ne.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(ie,he,Te){return mn.onDidChangeActiveColorTheme(ie,he,Te)},registerWebviewViewProvider(ie,he,Te){return yn.registerWebviewViewProvider(Ne,ie,he,Te?.webviewOptions)},get activeNotebookEditor(){return(0,H.checkProposedApiEnabled)(Ne),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),wt.onDidChangeActiveNotebookEditor(ie,he,Te)},get visibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Ne),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Ne),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),Vt.onDidChangeNotebookEditorSelection(ie,he,Te)},onDidChangeNotebookEditorVisibleRanges(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),Vt.onDidChangeNotebookEditorVisibleRanges(ie,he,Te)},showNotebookDocument(ie,he){return(0,H.checkProposedApiEnabled)(Ne),wt.showNotebookDocument(ie,he)},registerExternalUriOpener(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),Jt.registerExternalUriOpener(Ne.identifier,ie,he,Te)},get tabs(){return(0,H.checkProposedApiEnabled)(Ne),ot.tabs},get activeTab(){return(0,H.checkProposedApiEnabled)(Ne),ot.activeTab},get onDidChangeTabs(){return(0,H.checkProposedApiEnabled)(Ne),ot.onDidChangeTabs},get onDidChangeActiveTab(){return(0,H.checkProposedApiEnabled)(Ne),ot.onDidChangeActiveTab},getInlineCompletionItemController(ie){return(0,H.checkProposedApiEnabled)(Ne),c.InlineCompletionController.get(ie)}},vn={get rootPath(){return Pe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ge.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return Ge.getWorkspaceFolder(ie)},get workspaceFolders(){return Ge.getWorkspaceFolders()},get name(){return Ge.name},set name(ie){throw L.readonly()},get workspaceFile(){return Ge.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,he,...Te)=>Ge.updateWorkspaceFolders(Ne,ie,he||0,...Te),onDidChangeWorkspaceFolders:function(ie,he,Te){return Ge.onDidChangeWorkspace(ie,he,Te)},asRelativePath:(ie,he)=>Ge.getRelativePath(ie,he),findFiles:(ie,he,Te,ct)=>Ge.findFiles(W.GlobPattern.from(ie),W.GlobPattern.from(he),Te,Ne.identifier,ct),findTextInFiles:(ie,he,Te,ct)=>{let _t,kt;return typeof he=="object"?(_t=he,kt=Te):(_t={},kt=he,ct=Te),Ge.findTextInFiles(ie,_t||{},kt,Ne.identifier,ct)},saveAll:ie=>Ge.saveAll(ie),applyEdit(ie){return Cn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,he,Te,ct)=>Nt.createFileSystemWatcher(W.GlobPattern.from(ie),he,Te,ct),get textDocuments(){return It.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let he;const Te=ie;if(typeof ie=="string")he=Promise.resolve(R.URI.file(ie));else if(R.URI.isUri(ie))he=Promise.resolve(ie);else if(!Te||typeof Te=="object")he=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ct=>It.ensureDocumentData(ct).then(_t=>_t.document))},onDidOpenTextDocument:(ie,he,Te)=>It.onDidAddDocument(ie,he,Te),onDidCloseTextDocument:(ie,he,Te)=>It.onDidRemoveDocument(ie,he,Te),onDidChangeTextDocument:(ie,he,Te)=>It.onDidChangeDocument(ie,he,Te),onDidSaveTextDocument:(ie,he,Te)=>It.onDidSaveDocument(ie,he,Te),onWillSaveTextDocument:(ie,he,Te)=>Zt.getOnWillSaveTextDocumentEvent(Ne)(ie,he,Te),get notebookDocuments(){return wt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,he){let Te;if(R.URI.isUri(ie))Te=ie,await wt.openNotebookDocument(ie);else if(typeof ie=="string")Te=R.URI.revive(await wt.createNotebookDocument({viewType:ie,content:he}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,he,Te,ct){return wt.registerNotebookSerializer(Ne,ie,he,Te,Ne.enableProposedApi?ct:void 0)},registerNotebookContentProvider:(ie,he,Te,ct)=>((0,H.checkProposedApiEnabled)(Ne),wt.registerNotebookContentProvider(Ne,ie,he,Te,Ne.enableProposedApi?ct:void 0)),onDidChangeConfiguration:(ie,he,Te)=>Gt.onDidChangeConfiguration(ie,he,Te),getConfiguration(ie,he){return he=arguments.length===1?void 0:he,Gt.getConfiguration(ie,he,Ne)},registerTextDocumentContentProvider(ie,he){return $t.registerTextDocumentContentProvider(ie,he)},registerTaskProvider:(ie,he)=>(Pe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Ne,ie,he)),registerFileSystemProvider(ie,he,Te){return nn.registerFileSystemProvider(Ne.identifier,ie,he,Te)},get fs(){return we.value},registerFileSearchProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Ne),Rt.registerFileSearchProvider(ie,he)),registerTextSearchProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Ne),Rt.registerTextSearchProvider(ie,he)),registerRemoteAuthorityResolver:(ie,he)=>((0,H.checkProposedApiEnabled)(Ne),Fe.registerRemoteAuthorityResolver(ie,he)),registerResourceLabelFormatter:ie=>((0,H.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,he,Te)=>Nt.onDidCreateFile(ie,he,Te),onDidDeleteFiles:(ie,he,Te)=>Nt.onDidDeleteFile(ie,he,Te),onDidRenameFiles:(ie,he,Te)=>Nt.onDidRenameFile(ie,he,Te),onWillCreateFiles:(ie,he,Te)=>Nt.getOnWillCreateFileEvent(Ne)(ie,he,Te),onWillDeleteFiles:(ie,he,Te)=>Nt.getOnWillDeleteFileEvent(Ne)(ie,he,Te),onWillRenameFiles:(ie,he,Te)=>Nt.getOnWillRenameFileEvent(Ne)(ie,he,Te),openTunnel:ie=>((0,H.checkProposedApiEnabled)(Ne),Ae.openTunnel(Ne,ie).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,H.checkProposedApiEnabled)(Ne),Ae.getTunnels()},onDidChangeTunnels:(ie,he,Te)=>((0,H.checkProposedApiEnabled)(Ne),Ae.onDidChangeTunnels(ie,he,Te)),registerPortAttributesProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Ne),Ae.registerPortsAttributesProvider(ie,he)),registerTimelineProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Ne),sn.registerTimelineProvider(ie,he,Ne.identifier,lt.converter)),get isTrusted(){return Ge.trusted},requestWorkspaceTrust:ie=>((0,H.checkProposedApiEnabled)(Ne),Ge.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,he,Te)=>Ge.onDidGrantWorkspaceTrust(ie,he,Te)},Rn={get inputBox(){return Pe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Ne)},createSourceControl(ie,he,Te){return Xt.createSourceControl(Ne,ie,he,Te)}},Ln={createCommentController(ie,he){return En.createCommentController(Ne,ie,he)}},Fn={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(ie,he,Te){return mt.onDidStartDebugSession(ie,he,Te)},onDidTerminateDebugSession(ie,he,Te){return mt.onDidTerminateDebugSession(ie,he,Te)},onDidChangeActiveDebugSession(ie,he,Te){return mt.onDidChangeActiveDebugSession(ie,he,Te)},onDidReceiveDebugSessionCustomEvent(ie,he,Te){return mt.onDidReceiveDebugSessionCustomEvent(ie,he,Te)},onDidChangeBreakpoints(ie,he,Te){return mt.onDidChangeBreakpoints(ie,he,Te)},registerDebugConfigurationProvider(ie,he,Te){return mt.registerDebugConfigurationProvider(ie,he,Te||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,he){return mt.registerDebugAdapterDescriptorFactory(Ne,ie,he)},registerDebugAdapterTrackerFactory(ie,he){return mt.registerDebugAdapterTrackerFactory(ie,he)},startDebugging(ie,he,Te){return!Te||typeof Te=="object"&&"configuration"in Te?mt.startDebugging(ie,he,{parentSession:Te}):mt.startDebugging(ie,he,Te||{})},stopDebugging(ie){return mt.stopDebugging(ie)},addBreakpoints(ie){return mt.addBreakpoints(ie)},removeBreakpoints(ie){return mt.removeBreakpoints(ie)},asDebugSourceUri(ie,he){return mt.asDebugSourceUri(ie,he)}},Mn={registerTaskProvider:(ie,he)=>yt.registerTaskProvider(Ne,ie,he),fetchTasks:ie=>yt.fetchTasks(ie),executeTask:ie=>yt.executeTask(Ne,ie),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(ie,he,Te)=>yt.onDidStartTask(ie,he,Te),onDidEndTask:(ie,he,Te)=>yt.onDidEndTask(ie,he,Te),onDidStartTaskProcess:(ie,he,Te)=>yt.onDidStartTaskProcess(ie,he,Te),onDidEndTaskProcess:(ie,he,Te)=>yt.onDidEndTaskProcess(ie,he,Te)},On={createNotebookController(ie,he,Te,ct,_t){return en.createNotebookController(Ne,ie,he,Te,ct,Ne.enableProposedApi?_t:void 0)},registerNotebookCellStatusBarItemProvider:(ie,he)=>wt.registerNotebookCellStatusBarItemProvider(Ne,ie,he),get onDidSaveNotebookDocument(){return(0,H.checkProposedApiEnabled)(Ne),Kt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,H.checkProposedApiEnabled)(Ne),Vt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return tn.createRendererMessaging(Ne,ie)},onDidChangeNotebookDocumentMetadata(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),Kt.onDidChangeNotebookDocumentMetadata(ie,he,Te)},onDidChangeNotebookCells(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),wt.onDidChangeNotebookCells(ie,he,Te)},onDidChangeNotebookCellExecutionState(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),wt.onDidChangeNotebookCellExecutionState(ie,he,Te)},onDidChangeCellOutputs(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),wt.onDidChangeCellOutputs(ie,he,Te)},onDidChangeCellMetadata(ie,he,Te){return(0,H.checkProposedApiEnabled)(Ne),wt.onDidChangeCellMetadata(ie,he,Te)},createConcatTextDocument(ie,he){return(0,H.checkProposedApiEnabled)(Ne),new Ke.ExtHostNotebookConcatDocument(wt,It,ie,he)}};return{version:de.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:An,languages:cn,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:Tn,workspace:vn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:A.FileType,FilePermission:A.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:T.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalLocation:M.TerminalLocation,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:u.UIKind,Uri:R.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:Ie.TextSearchCompleteMessageType,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=ke}),define(me[276],ge([0,1,82,68,37,131,38,44,45,33,72,55,74,92,53,67,132,91,52,90,122,54]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E,a,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,m.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,m.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,m.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,m.registerSingleton)(A.IExtHostDebugService,A.WorkerExtHostDebugService),(0,m.registerSingleton)(k.IExtHostDecorations,k.ExtHostDecorations),(0,m.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,m.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,m.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,m.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,m.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,m.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,m.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,m.registerSingleton)(S.IExtHostWindow,S.ExtHostWindow),(0,m.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,m.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,m.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry),(0,m.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(me[93],ge([0,1,17,12,31,71]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(A){return A.startsWith("**")||A.startsWith("/")?A:`/${A}`}e.anchorGlob=R;function C(A,u,f,o){const v=(0,m.mapArrayOrNot)(f,D),S=new I.TextSearchMatch(u,v,o),P=S.preview.matches;return{ranges:(0,m.mapArrayOrNot)(v,T),uri:A,preview:{text:S.preview.text,matches:(0,m.mapArrayOrNot)(P,T)}}}e.createTextSearchResult=C;function D(A){return new I.SearchRange(A.start.line,A.start.character,A.end.line,A.end.character)}function T(A){return new k.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn)}let n=class{constructor(u,f){this.prefix=u,this.logService=f}appendLine(u){this.logService.debug(`${this.prefix}#search`,u)}};n=Ve([We(1,L.ILogService)],n),e.OutputChannel=n}),define(me[277],ge([0,1,96,23]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===t)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const k=512,R=512,C=512*8,D=512*128;class T{constructor(s){this.iconvLiteDecoder=s}static async create(s){let r;if(s!==e.UTF8)r=(await new Promise((h,c)=>{J(["iconv-lite-umd"],h,c)})).getDecoder(f(s));else{const i=new TextDecoder;r={write(h){return i.decode(h,{stream:!0})},end(){return i.decode()}}}return new T(r)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function n(t,s){const r=s.minBytesRequiredForDetection??s.guessEncoding?C:R;return new Promise((i,h)=>{const c=(0,m.newWriteableStream)(_=>_.join("")),d=[];let b=0,y;const g=async()=>{try{const _=await p({buffer:L.VSBuffer.concat(d),bytesRead:b},s.guessEncoding);_.encoding=await s.overwriteEncoding(_.encoding),y=await T.create(_.encoding);const w=y.write(L.VSBuffer.concat(d).buffer);c.write(w),d.length=0,b=0,i({stream:c,detected:_})}catch(_){h(_)}};(0,m.listenStream)(t,{onData:async _=>{y?c.write(y.write(_.buffer)):(d.push(_),b+=_.byteLength,b>=r&&(t.pause(),await g(),setTimeout(()=>t.resume())))},onError:_=>c.error(_),onEnd:async()=>{y||await g(),c.end(y?.end())}})})}e.toDecodeStream=n;async function A(t,s,r){const h=(await new Promise((b,y)=>{J(["iconv-lite-umd"],b,y)})).getEncoder(f(s),r);let c=!1,d=!1;return{read(){if(d)return null;const b=t.read();if(typeof b!="string"){if(d=!0,!c&&r?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const y=h.end();return y&&y.length>0?(c=!0,L.VSBuffer.wrap(y)):null}return c=!0,L.VSBuffer.wrap(h.write(b))}}}e.toEncodeReadable=A;async function u(t){return(await new Promise((r,i)=>{J(["iconv-lite-umd"],r,i)})).encodingExists(f(t))}e.encodingExists=u;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function o(t,s){if(!t||s<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),i=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const h=t.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&h===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=o;const v=["ascii","utf-16","utf-32"];async function S(t){const s=await new Promise((d,b)=>{J(["jschardet"],d,b)}),r=t.slice(0,D),i=a(r.buffer),h=s.detect(i);if(!h||!h.encoding)return null;const c=h.encoding.toLowerCase();return 0<=v.indexOf(c)?null:E(h.encoding)}const P={ibm866:"cp866",big5:"cp950"};function E(t){const s=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return P[s]||s}function a(t){let s="";for(let r=0;r<t.length;r++)s+=String.fromCharCode(t[r]);return s}function l(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const s=t.match(/windows(\d+)/);return s?"windows-"+s[1]:t}}e.toCanonicalName=l;function p({buffer:t,bytesRead:s},r){let i=o(t,s),h=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let c=!0,d=!0,b=!1;for(let y=0;y<s&&y<k;y++){const g=y%2==1,_=t.readUInt8(y)===0;if(_&&(b=!0),c&&(g&&!_||!g&&_)&&(c=!1),d&&(g&&_||!g&&!_)&&(d=!1),_&&!c&&!d)break}b&&(c?i=e.UTF16le:d?i=e.UTF16be:h=!0)}return r&&!h&&!i&&t?S(t.slice(0,s)).then(c=>({seemsBinary:!1,encoding:c})):{seemsBinary:h,encoding:i}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[134],ge([0,1,277,28,133]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class k extends I.TextSearchManager{constructor(C,D,T=L,n="searchProcess"){super(C,D,{readdir:A=>T.Promises.readdir(A.fsPath),toCanonicalName:A=>(0,m.toCanonicalName)(A)},n)}}e.NativeTextSearchManager=k}),define(me[278],ge([0,1,279,294,295,2,296]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(A,u,f,o,v,S){const P=S.environment.useHostProxy,E=typeof P=="boolean"?P:!S.remote.isRemote,a=(0,R.createProxyResolver)({resolveProxy:p=>A.resolveProxy(p),getHttpProxySetting:()=>u.getConfiguration("http").get("proxy"),log:(p,t,...s)=>{switch(p){case R.LogLevel.Trace:o.trace(t,...s);break;case R.LogLevel.Debug:o.debug(t,...s);break;case R.LogLevel.Info:o.info(t,...s);break;case R.LogLevel.Warning:o.warn(t,...s);break;case R.LogLevel.Error:o.error(t,...s);break;case R.LogLevel.Critical:o.critical(t,...s);break;case R.LogLevel.Off:break;default:r(p,t,s);break}function r(i,h,...c){o.error("Unknown log level",i),o.error(h,...c)}},getLogLevel:()=>o.getLevel(),proxyResolveTelemetry:p=>{v.$publicLog2("resolveProxy",p)},useHostProxy:E,env:process.env}),l=D(u,a);return n(f,l)}e.connectProxyResolver=C;function D(A,u){const f={config:A.getConfiguration("http").get("proxySupport")||"off"};A.onDidChangeConfiguration(v=>{f.config=A.getConfiguration("http").get("proxySupport")||"off"});const o={config:!!A.getConfiguration("http").get("systemCertificates")};return A.onDidChangeConfiguration(v=>{o.config=!!A.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,R.createHttpPatch)(m,u,{config:"off"},o,!0)),on:Object.assign({},m,(0,R.createHttpPatch)(m,u,{config:"on"},o,!0)),override:Object.assign({},m,(0,R.createHttpPatch)(m,u,{config:"override"},o,!0)),onRequest:Object.assign({},m,(0,R.createHttpPatch)(m,u,f,o,!0)),default:Object.assign(m,(0,R.createHttpPatch)(m,u,f,o,!1))},https:{off:Object.assign({},L,(0,R.createHttpPatch)(L,u,{config:"off"},o,!0)),on:Object.assign({},L,(0,R.createHttpPatch)(L,u,{config:"on"},o,!0)),override:Object.assign({},L,(0,R.createHttpPatch)(L,u,{config:"override"},o,!0)),onRequest:Object.assign({},L,(0,R.createHttpPatch)(L,u,f,o,!0)),default:Object.assign(L,(0,R.createHttpPatch)(L,u,f,o,!1))},tls:Object.assign(I,(0,R.createTlsPatch)(I))}}const T=new Map;function n(A,u){return A.getExtensionPathIndex().then(f=>{const o=J.__$__nodeRequire("module"),v=o._load;o._load=function(P,E,a){if(P==="tls")return u.tls;if(P!=="http"&&P!=="https")return v.apply(this,arguments);const l=u[P],p=f.findSubstr(k.URI.file(E.filename).fsPath);let t=T.get(p);if(t||T.set(p,t={}),!t[P]){let s=l.default;p&&p.enableProposedApi&&(s=l[p.proxySupport]||l.onRequest),t[P]={...s}}return t[P]}})}}),define(me[280],ge([0,1,39,8,78,29,11,9,93,281]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=T.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function A(a,l,p,t){const s=u(a,l,p,t),r=l.folder.fsPath;return{cmd:m.spawn(n,s.args,{cwd:r}),rgDiskPath:n,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=A;function u(a,l,p,t){const s=["--files","--hidden","--case-sensitive"];o([l],p,!1).forEach(i=>{const h=(0,D.anchorGlob)(i);if(s.push("-g",h),R.isMacintosh){const c=(0,I.normalizeNFD)(h);c!==h&&s.push("-g",c)}});const r=f([l],t,void 0,!1);return r.globArgs.forEach(i=>{const h=`!${(0,D.anchorGlob)(i)}`;if(s.push("-g",h),R.isMacintosh){const c=(0,I.normalizeNFD)(h);c!==h&&s.push("-g",c)}}),l.disregardIgnoreFiles!==!1?s.push("--no-ignore"):s.push("--no-ignore-parent"),l.ignoreSymlinks||s.push("--follow"),a.exists&&s.push("--quiet"),s.push("--no-config"),l.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function f(a,l,p,t=!0){const s=[];let r={};return a.forEach(i=>{const h=Object.assign({},i.excludePattern||{},l||{}),c=v(h,t?i.folder.fsPath:void 0,p);s.push(...c.globArgs),c.siblingClauses&&(r=Object.assign(r,c.siblingClauses))}),{globArgs:s,siblingClauses:r}}e.foldersToRgExcludeGlobs=f;function o(a,l,p=!0){const t=[];return a.forEach(s=>{const r=Object.assign({},l||{},s.includePattern||{}),i=v(r,p?s.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=o;function v(a,l,p){const t=[],s={};return Object.keys(a).forEach(r=>{if(p&&p.has(r)||!r)return;const i=a[r];r=P(l?S(l,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(E(r))):i&&i.when&&(s[r]=i)}),{globArgs:t,siblingClauses:s}}function S(a,l){return L.isAbsolute(l)?l:L.join(a,l)}e.getAbsoluteGlob=S;function P(a){return a=C.rtrim(a,"\\"),C.rtrim(a,"/")}function E(a){return k.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=E}),define(me[282],ge([0,1,39,50,8,104,17,61,30,78,29,11,46,9,13,28,31,280,101]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(r=>r())});class l{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(h=>{const c=Object.assign({},h.excludePattern||{},this.config.excludePattern||{}),d=h.folder.fsPath;i.folderQueries.map(b=>b.folder.fsPath).filter(b=>b!==d).forEach(b=>{(0,n.isEqualOrParent)(b,d)&&(c[I.relative(d,b)]=!0)}),this.folderExcludePatterns.set(d,new t(c,d))})}cancel(){this.isCanceled=!0}walk(i,h,c,d,b){if(this.fileWalkSW=u.StopWatch.create(!1),this.isCanceled)return b(null,this.isLimitHit);h.forEach(y=>{const g=I.basename(y.fsPath);this.globalExcludePattern&&this.globalExcludePattern(y.fsPath,g)||this.matchFile(c,{relativePath:y.fsPath,searchPath:void 0})}),this.cmdSW=u.StopWatch.create(!1),this.parallel(i,(y,g)=>{this.call(this.cmdTraversal,this,y,c,d,_=>{if(_){const w=(0,C.toErrorMessage)(_);console.error(w),this.errors.push(w),g(_,void 0)}else g(null,void 0)})},(y,g)=>{this.fileWalkSW.stop();const _=y?R.coalesce(y)[0]:null;b(_,this.isLimitHit)})}parallel(i,h,c){const d=new Array(i.length),b=new Array(i.length);let y=!1,g=0;if(i.length===0)return c(null,[]);i.forEach((_,w)=>{h(_,(F,O)=>{if(F?(y=!0,d[w]=null,b[w]=F):(d[w]=O,b[w]=null),++g===i.length)return c(y?b:null,d)})})}call(i,h,...c){try{i.apply(h,c)}catch(d){c[c.length-1](d)}}cmdTraversal(i,h,c,d){const b=i.folder.fsPath,y=A.isMacintosh;let g;const _=()=>g&&g.kill();a.add(_);let w=M=>{a.delete(_),w=()=>{},d(M)},F="";const O=this.initDirectoryTree();let G;const K=(0,P.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);g=K.cmd,G=!Object.keys(K.siblingClauses).length;const U=K.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let W=`${K.rgDiskPath} ${U}
 - cwd: ${K.cwd}`;K.rgArgs.siblingClauses&&(W+=`
 - Sibling clauses: ${JSON.stringify(K.rgArgs.siblingClauses)}`),c({message:W}),this.cmdResultCount=0,this.collectStdout(g,"utf8",c,(M,x,B)=>{if(M){w(M);return}if(this.isLimitHit){w();return}const z=(F+(y?T.normalizeNFC(x||""):x)).split(`
`);if(B){const H=z.length;z[H-1]=z[H-1].trim(),z[H-1]||z.pop()}else F=z.pop()||"";if(z.length&&z[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=z.length,G){for(const H of z)if(this.matchFile(h,{base:b,relativePath:H,searchPath:this.getSearchPath(i,H)}),this.isLimitHit){_();break}(B||this.isLimitHit)&&w();return}this.addDirectoryEntries(i,O,b,z,h),B&&(this.matchDirectoryTree(O,b,h),w())})}spawnFindCmd(i){const h=this.folderExcludePatterns.get(i.folder.fsPath),c=h.getBasenameTerms(),d=h.getPathTerms(),b=["-L","."];if(c.length||d.length){b.push("-not","(","(");for(const y of c)b.push("-name",y),b.push("-o");for(const y of d)b.push("-path",y),b.push("-o");b.pop(),b.push(")","-prune",")")}return b.push("-type","f"),m.spawn("find",b,{cwd:i.folder.fsPath})}readStdout(i,h,c){let d="";this.collectStdout(i,h,()=>{},(b,y,g)=>{if(b){c(b);return}d+=y,g&&c(null,d)})}collectStdout(i,h,c,d){let b=(_,w,F)=>{(_||F)&&(b=()=>{},this.cmdSW&&this.cmdSW.stop()),d(_,w,F)},y=!1;i.stdout?(this.forwardData(i.stdout,h,b),i.stdout.once("data",()=>y=!0)):c({message:"stdout is null"});let g;i.stderr?g=this.collectData(i.stderr):c({message:"stderr is null"}),i.on("error",_=>{b(_)}),i.on("close",_=>{let w;!y&&(w=this.decodeData(g,h))&&s(w)?b(new Error(`command failed with error code ${_}: ${this.decodeData(g,h)}`)):(this.exists&&_===0&&(this.isLimitHit=!0),b(null,"",!0))})}forwardData(i,h,c){const d=new k.StringDecoder(h);return i.on("data",b=>{c(null,d.write(b))}),d}collectData(i){const h=[];return i.on("data",c=>{h.push(c)}),h}decodeData(i,h){const c=new k.StringDecoder(h);return i.map(d=>c.write(d)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:h},c,d,b){d.indexOf(this.filePattern)!==-1&&this.matchFile(b,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const y=g=>{const _=I.basename(g),w=I.dirname(g);let F=h[w];F||(F=h[w]=[],y(w)),F.push({base:c,relativePath:g,basename:_,searchPath:this.getSearchPath(i,g)})};d.forEach(y)}matchDirectoryTree({rootEntries:i,pathToEntries:h},c,d){const b=this,y=this.folderExcludePatterns.get(c),g=this.filePattern;function _(w){b.directoriesWalked++;const F=D.hasSiblingFn(()=>w.map(O=>O.basename));for(let O=0,G=w.length;O<G;O++){const K=w[O],{relativePath:U,basename:W}=K;if(y.test(U,W,g!==W?F:void 0))continue;const M=h[U];if(M)_(M);else{if(b.filesWalked++,U===g)continue;b.matchFile(d,K)}if(b.isLimitHit)break}}_(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,h,c,d,b){const y=i.folder,g=D.hasSiblingFn(()=>c);this.parallel(c,(_,w)=>{if(this.isCanceled||this.isLimitHit)return w(null);const F=h?[h,_].join(I.sep):_;if(this.folderExcludePatterns.get(i.folder.fsPath).test(F,_,this.config.filePattern!==_?g:void 0))return w(null);const O=[y.fsPath,F].join(I.sep);L.lstat(O,(G,K)=>{if(G||this.isCanceled||this.isLimitHit)return w(null);this.statLinkIfNeeded(O,K,(U,W)=>U||this.isCanceled||this.isLimitHit?w(null):W.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(O,K,(M,x)=>M||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?w(null):(this.walkedPaths[x]=!0,v.Promises.readdir(O).then(B=>{if(this.isCanceled||this.isLimitHit)return w(null);this.doWalk(i,F,B,d,N=>w(N||null))},B=>{w(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&o.isNumber(W.size)&&W.size>this.maxFilesize||this.matchFile(d,{base:y.fsPath,relativePath:F,searchPath:this.getSearchPath(i,F)}),w(null,void 0)))})},_=>{const w=_&&R.coalesce(_);return b(w&&w.length>0?w[0]:void 0)})}matchFile(i,h){this.isFileMatch(h)&&(!this.includePattern||this.includePattern(h.relativePath,I.basename(h.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(h))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,h,c){return h.isSymbolicLink()?L.stat(i,c):c(null,h)}realPathIfNeeded(i,h,c){return h.isSymbolicLink()?L.realpath(i,(d,b)=>d?c(d):c(null,b)):c(null,i)}getSearchPath(i,h){return i.folderName?I.join(i.folderName,h):h}}e.FileWalker=l;class p{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new l(i)}search(i,h,c){this.walker.walk(this.folderQueries,this.extraFiles,i,h,(d,b)=>{c(d,{limitHit:b,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(i,h){this.expression=i,this.root=h,this.init(i)}init(i){let h,c;Object.keys(i).filter(d=>i[d]).forEach(d=>{I.isAbsolute(d)?(h=h||D.getEmptyExpression(),h[d]=i[d]):(c=c||D.getEmptyExpression(),c[d]=i[d])}),this.absoluteParsedExpr=h&&D.parse(h,{trimForExclusions:!0}),this.relativeParsedExpr=c&&D.parse(c,{trimForExclusions:!0})}test(i,h,c){return this.relativeParsedExpr&&this.relativeParsedExpr(i,h,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),h,c)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function s(r){const i=r.trim().split(`
`),h=i[0].trim();if(h.startsWith("Error parsing regex"))return h;if(h.startsWith("regex parse error"))return f.uppercaseFirstLetter(i[i.length-1].trim());if(h.startsWith("error parsing glob")||h.startsWith("unsupported encoding"))return h.charAt(0).toUpperCase()+h.substr(1);if(h==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(h.startsWith("Literal "))return h}e.rgErrorMsgForDisplay=s}),define(me[135],ge([0,1,39,297,104,17,57,30,8,9,2,31,71,298,281,93]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=o.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class P{constructor(y){this.outputChannel=y}provideTextSearchResults(y,g,_,w){return this.outputChannel.appendLine(`provideTextSearchResults ${y.pattern}, ${JSON.stringify({...g,folder:g.folder.toString()})}`),new Promise((F,O)=>{w.onCancellationRequested(()=>N());const G=s(y,g),K=g.folder.fsPath,U=G.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.outputChannel.appendLine(`${S} ${U}
 - cwd: ${K}`);let W=m.spawn(S,G,{cwd:K});W.on("error",fe=>{console.error(fe),this.outputChannel.appendLine("Error: "+(fe&&fe.message)),O((0,A.serializeSearchError)(new A.SearchError(fe&&fe.message,A.SearchErrorCode.rgProcessError)))});let M=!1;const x=new l(g.maxResults,K,g.previewOptions);x.on("result",fe=>{M=!0,H="",_.report(fe)});let B=!1;const N=()=>{B=!0,W&&W.kill(),x&&x.cancel()};let z=!1;x.on("hitLimit",()=>{z=!0,N()});let H="";W.stdout.on("data",fe=>{x.handleData(fe),M||(H+=fe)});let Q=!1;W.stdout.once("data",()=>Q=!0);let X="";W.stderr.on("data",fe=>{const _e=fe.toString();this.outputChannel.appendLine(_e),X+=_e}),W.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),H&&this.outputChannel.appendLine(`Got data without result: ${H}`),this.outputChannel.appendLine(""),B)F({limitHit:z});else{x.flush(),W=null;let fe;X&&!Q&&(fe=E(X))?O((0,A.serializeSearchError)(new A.SearchError(fe.message,fe.code))):F({limitHit:z})}})})}}e.RipgrepTextSearchEngine=P;function E(b){const y=b.split(`
`),g=y[0].trim();if(y.some(w=>w.startsWith("regex parse error")))return new A.SearchError(a(y),A.SearchErrorCode.regexParseError);const _=g.match(/grep config error: unknown encoding: (.*)/);if(_)return new A.SearchError(`Unknown encoding: ${_[1]}`,A.SearchErrorCode.unknownEncoding);if(g.startsWith("error parsing glob"))return new A.SearchError(g.charAt(0).toUpperCase()+g.substr(1),A.SearchErrorCode.globParseError);if(g.startsWith("the literal"))return new A.SearchError(g.charAt(0).toUpperCase()+g.substr(1),A.SearchErrorCode.invalidLiteral);if(g.startsWith("PCRE2: error compiling pattern"))return new A.SearchError(g,A.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function a(b){const y=["Regex parse error"],g=b.filter(_=>_.startsWith("PCRE2:"));if(g.length>=1){const _=g[0].replace("PCRE2:","");if(_.indexOf(":")!==-1&&_.split(":").length>=2){const w=_.split(":")[1];y.push(":"+w)}}return y.join("")}e.buildRegexParseError=a;class l extends L.EventEmitter{constructor(y,g,_){super();this.maxResults=y,this.rootFolder=g,this.previewOptions=_,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(y,g){return super.on(y,g),this}handleData(y){if(this.isDone)return;const g=typeof y=="string"?y:this.stringDecoder.write(y);this.handleDecodedData(g)}handleDecodedData(y){let g=y.indexOf(`
`);const _=this.remainder+y;if(g>=0)g+=this.remainder.length;else{this.remainder=_;return}let w=0;for(;g>=0;)this.handleLine(_.substring(w,g).trim()),w=g+1,g=_.indexOf(`
`,w);this.remainder=_.substring(w)}handleLine(y){if(this.isDone||!y)return;let g;try{g=JSON.parse(y)}catch(_){throw new Error(`malformed line from rg: ${y}`)}if(g.type==="match"){const _=p(g.data.path),w=n.URI.file(D.join(this.rootFolder,_)),F=this.createTextSearchMatch(g.data,w);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(g.type==="context"){const _=p(g.data.path),w=n.URI.file(D.join(this.rootFolder,_));this.createTextSearchContext(g.data,w).forEach(O=>this.onResult(O))}}createTextSearchMatch(y,g){const _=y.line_number-1,w=p(y.lines),F=Buffer.from(w);let O=0,G=0,K=_;y.submatches.length===0&&y.submatches.push(w.length?{start:0,end:1,match:{text:w[0]}}:{start:0,end:0,match:{text:""}});const U=(0,k.coalesce)(y.submatches.map((W,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=p(W.match),B=F.slice(O,W.start).toString().length,N=G+B,z=t(x),H=K,Q=z.numLines+H,X=z.numLines>0?z.lastLineLength:z.lastLineLength+N;return O=W.end,G=X,K=Q,new u.Range(H,N,Q,X)}));return(0,v.createTextSearchResult)(g,w,U,this.previewOptions)}createTextSearchContext(y,g){const _=p(y.lines),w=y.line_number;return _.replace(/\r?\n$/,"").split(`
`).map((F,O)=>({text:F,uri:g,lineNumber:w+O}))}onResult(y){this.emit("result",y)}}e.RipgrepParser=l;function p(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const y=/\n/g;let g=0,_=-1,w;for(;w=y.exec(b);)g++,_=w.index;const F=_>=0?b.length-_-1:b.length;return{numLines:g,lastLineLength:F}}function s(b,y){const g=["--hidden"];g.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:_,otherIncludes:w}=(0,R.groupBy)(y.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(w&&w.length){const O=new Set;w.forEach(G=>{O.add(G)}),g.push("-g","!*"),O.forEach(G=>{r(G).map(v.anchorGlob).forEach(K=>{g.push("-g",K)})})}_&&_.length&&_.forEach(O=>{g.push("-g",O)}),y.excludes.map(v.anchorGlob).forEach(O=>g.push("-g",`!${O}`)),y.maxFileSize&&g.push("--max-filesize",y.maxFileSize+""),y.useIgnoreFiles?g.push("--no-ignore-parent"):g.push("--no-ignore"),y.followSymlinks&&g.push("--follow"),y.encoding&&y.encoding!=="utf8"&&g.push("--encoding",y.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,T.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),y.usePCRE2&&g.push("--pcre2"),g.push("--crlf"),b.isRegExp&&(b.pattern=i(b.pattern),g.push("--auto-hybrid-regex"));let F;if(b.isWordMatch){const G=(0,T.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");g.push("--regexp",G)}else if(b.isRegExp){let O=c(b.pattern);O=d(O),g.push("--regexp",O)}else F=b.pattern,g.push("--fixed-strings");return g.push("--no-config"),y.useGlobalIgnoreFiles||g.push("--no-ignore-global"),g.push("--json"),b.isMultiline&&g.push("--multiline"),y.beforeContext&&g.push("--before-context",y.beforeContext+""),y.afterContext&&g.push("--after-context",y.afterContext+""),g.push("--"),F&&g.push(F),g.push("."),g}function r(b){const y=(0,C.splitGlobAware)(b,"/");return y.map((g,_)=>y.slice(0,_+1).join("/"))}e.spreadGlobComponents=r;function i(b){const y=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(y);)b=b.replace(y,"$1\\x{$2}");const g=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(g);)b=b.replace(g,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=i;const h=b=>b.type==="Assertion"&&b.kind==="lookbehind";function c(b){let y;try{y=new f.RegExpParser().parsePattern(b)}catch{return b}let g="",_=0;const w=(G,K,U)=>{g+=b.slice(_,G)+U,_=K},F=[];return new f.RegExpVisitor({onCharacterEnter(G){if(G.raw!=="\\n")return;const K=F[0];if(!K)w(G.start,G.end,"\\r?\\n");else if(!F.some(h))if(K.type==="CharacterClass")if(K.negate){const U=b.slice(K.start+2,G.start)+b.slice(G.end,K.end-1);w(K.start,K.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=b.slice(K.start+1,G.start)+b.slice(G.end,K.end-1);w(K.start,K.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else K.type==="Quantifier"&&w(G.start,G.end,"(?:\\r?\\n)")},onQuantifierEnter(G){F.unshift(G)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(G){F.unshift(G)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(G){F.unshift(G)},onCharacterClassLeave(){F.shift()},onAssertionEnter(G){h(G)&&F.push(G)},onAssertionLeave(G){F[0]===G&&F.shift()}}).visit(y),g+=b.slice(_),g}e.fixRegexNewline=c;function d(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=d}),define(me[283],ge([0,1,21,135,118,10]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(T){this.outputChannel=T,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(T,n,A,u){const f=new L.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===k.Schemas.userData){const o={...n,folder:n.folder.with({scheme:k.Schemas.file})},v=new I.Progress(S=>A.report({...S,uri:S.uri.with({scheme:n.folder.scheme})}));return this.withToken(u,S=>f.provideTextSearchResults(T,o,v,S))}else return this.withToken(u,o=>f.provideTextSearchResults(T,n,A,o))}async withToken(T,n){const A=C(T);this.inProgress.add(A);const u=await n(A.token);return this.inProgress.delete(A),u}dispose(){this.inProgress.forEach(T=>T.cancel())}}e.RipgrepSearchProvider=R;function C(D){const T=new m.CancellationTokenSource;return D.onCancellationRequested(()=>T.cancel()),T}}),define(me[284],ge([0,1,28,135,134]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class k{constructor(D){this.query=D}search(D,T,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const A={appendLine(f){n({message:f})}},u=new I.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(A),m);return new Promise((f,o)=>u.search(v=>{T(v.map(R))},D).then(v=>f({limitHit:v.limitHit,type:"success",stats:v.stats}),o))}}e.TextSearchEngineAdapter=k;function R(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((D,T)=>{if(T.ranges){const n=T;return D+(Array.isArray(n.ranges)?n.ranges.length:1)}else return D+1},0)}}}),define(me[285],ge([0,1,50,299,17,18,16,3,101,8,46,2,42,31,282,284]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(m);class S{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let s;const r=a(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{s=(0,k.createCancelablePromise)(h=>this.doFileSearchWithEngine(o.Engine,r,c=>i.fire(c),h)),s.then(h=>i.fire(h),h=>i.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return i.event}textSearch(t){let s;const r=a(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{s=(0,k.createCancelablePromise)(h=>this.ripgrepTextSearch(r,c=>i.fire(c),h)),s.then(h=>i.fire(h),h=>i.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return i.event}ripgrepTextSearch(t,s,r){return t.maxFileSize=(0,u.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(t).search(r,s,s)}doFileSearch(t,s,r){return this.doFileSearchWithEngine(o.Engine,t,s,r)}doFileSearchWithEngine(t,s,r,i,h=S.BATCH_SIZE){let c=0;const d=y=>{Array.isArray(y)?(c+=y.length,r(y.map(g=>this.rawMatchToSearchItem(g)))):y.relativePath?(c++,r(this.rawMatchToSearchItem(y))):r(y)};if(s.sortByScore){let y=this.trySortedSearchFromCache(s,d,i);if(!y){const g=s.maxResults?Object.assign({},s,{maxResults:null}):s,_=new t(g);y=this.doSortedSearch(_,s,r,d,i)}return new Promise((g,_)=>{y.then(([w,F])=>{const O=F.map(G=>this.rawMatchToSearchItem(G));this.sendProgress(O,r,h),g(w)},_)})}const b=new t(s);return this.doSearch(b,d,h,i).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.processType,fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,T.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,s,r,i,h){const c=new C.Emitter;let d=(0,k.createCancelablePromise)(y=>{let g=[];const _=w=>{Array.isArray(w)?g=w:(i(w),c.fire(w))};return this.doSearch(t,_,-1,y).then(w=>[w,g])}),b;if(s.cacheKey){b=this.getOrCreateCache(s.cacheKey);const y={promise:d,event:c.event,resolved:!1};b.resultsToSearchCache[s.filePattern||""]=y,d.then(()=>{y.resolved=!0},g=>{delete b.resultsToSearchCache[s.filePattern||""]}),d=this.preventCancellation(d)}return d.then(([y,g])=>{const _=b?b.scorerCache:Object.create(null),w=(typeof s.maxResults!="number"||s.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(s,g,_,h).then(F=>{const O=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:O,fromCache:!1,type:this.processType,workspaceFolderCount:s.folderQueries.length,resultCount:F.length},messages:y.messages,limitHit:y.limitHit||typeof s.maxResults=="number"&&g.length>s.maxResults},F]})})}getOrCreateCache(t){const s=this.caches[t];return s||(this.caches[t]=new P)}trySortedSearchFromCache(t,s,r){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const h=this.getResultsFromCache(i,t.filePattern||"",s,r);if(h)return h.then(([c,d,b])=>{const y=n.StopWatch.create(!1);return this.sortResults(t,d,i.scorerCache,r).then(g=>{const _=y.elapsed(),w={fromCache:!0,detailStats:b,type:this.processType,resultCount:d.length,sortingTime:_};return[{type:"success",limitHit:c.limitHit||typeof t.maxResults=="number"&&d.length>t.maxResults,stats:w},g]})})}sortResults(t,s,r,i){const h=(0,D.prepareQuery)(t.filePattern||""),c=(b,y)=>(0,D.compareItemsByFuzzyScore)(b,y,h,!0,E,r),d=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return I.topAsync(s,c,d,1e4,i)}sendProgress(t,s,r){if(r&&r>0)for(let i=0;i<t.length;i+=r)s(t.slice(i,i+r));else s(t)}getResultsFromCache(t,s,r,i){const h=n.StopWatch.create(!1),c=s.indexOf(T.sep)>=0;let d;for(const _ in t.resultsToSearchCache)if(s.startsWith(_)){if(c&&_.indexOf(T.sep)<0&&_!=="")continue;const w=t.resultsToSearchCache[_];d={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!d)return null;const b=h.elapsed(),y=n.StopWatch.create(!1),g=d.event(r);return i&&i.onCancellationRequested(()=>{g.dispose()}),d.promise.then(([_,w])=>{if(i&&i.isCancellationRequested)throw(0,R.canceled)();const F=[],O=(0,D.prepareQuery)(s).normalizedLowercase;for(const G of w)!(0,f.isFilePatternMatch)(G,O)||F.push(G);return[_,F,{cacheWasResolved:d.resolved,cacheLookupTime:b,cacheFilterTime:y.elapsed(),cacheEntryCount:w.length}]})}doSearch(t,s,r,i){return new Promise((h,c)=>{let d=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(b=>{b&&(r?(d.push(b),r>0&&d.length>=r&&(s(d),d=[])):s(b))},b=>{s(b)},(b,y)=>{d.length&&s(d),b?c(b):h(y)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,r){return t.then(s,r)}catch(s){return this.then(void 0,s)}finally(s){return t.finally(s)}}}}e.SearchService=S,S.BATCH_SIZE=512;class P{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(p){return(0,T.basename)(p.relativePath)}getItemDescription(p){return(0,T.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function a(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(l),extraFileResources:p.extraFileResources&&p.extraFileResources.map(t=>A.URI.revive(t))}}function l(p){return{...p,folder:A.URI.revive(p.folder)}}}),define(me[286],ge([0,1,6,10,2,28,12,27,14,74,65,31,285,283,93,134]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends T.ExtHostSearch{constructor(E,a,l,p){super(E,l,p);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new o.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new f.RipgrepSearchProvider(t)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const E=new o.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new f.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(L.Schemas.file,new u.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(E,a){const l=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(E)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(E,a,l,p){const t=(0,T.reviveQuery)(l);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,a,t,p):super.$provideFileSearchResults(E,a,l,p)}doInternalFileSearch(E,a,l,p){const t=s=>{if((0,A.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this._proxy.$handleFileMatch(E,a,s.map(r=>I.URI.file(r.path)));return}s.message&&this._logService.debug("ExtHostSearch",s.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,t,p)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,a){return new v.NativeTextSearchManager(E,a,void 0,"textSearchProvider")}};S=Ve([We(0,D.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,n.IURITransformerService),We(3,R.ILogService)],S),e.NativeExtHostSearch=S}),define(me[136],ge([0,1,300,125,80,23,16,3,6,8,11,32,106,107,301]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(d){this.socket=d,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const b=y=>d(k.VSBuffer.wrap(y));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(d){const b=y=>{d({type:0,hadError:y,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}}end(){this.socket.end()}drain(){return new Promise((d,b)=>{if(this.socket.bufferSize===0){d();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),d()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=v;var S;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var P;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(P||(P={}));class E extends D.Disposable{constructor(d,b,y,g){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=g,b?(this._zlibInflate=o.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",_=>{console.error(_),(0,R.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibInflate.on("data",_=>{this._pendingInflateData.push(_)}),y&&(this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=o.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{console.error(_),(0,R.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibDeflate.on("data",_=>{this._pendingDeflateData.push(_)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(k.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,b){let y=2;d.byteLength<126?y+=0:d.byteLength<2**16?y+=2:y+=8;const g=k.VSBuffer.alloc(y);if(b?g.writeUInt8(194,0):g.writeUInt8(130,0),d.byteLength<126)g.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){g.writeUInt8(126,1);let _=1;g.writeUInt8(d.byteLength>>>8&255,++_),g.writeUInt8(d.byteLength>>>0&255,++_)}else{g.writeUInt8(127,1);let _=1;g.writeUInt8(0,++_),g.writeUInt8(0,++_),g.writeUInt8(0,++_),g.writeUInt8(0,++_),g.writeUInt8(d.byteLength>>>24&255,++_),g.writeUInt8(d.byteLength>>>16&255,++_),g.writeUInt8(d.byteLength>>>8&255,++_),g.writeUInt8(d.byteLength>>>0&255,++_)}this._totalOutgoingWireBytes+=g.byteLength+d.byteLength,this.socket.write(k.VSBuffer.concat([g,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),g=(b.readUInt8(0)&128)>>>7,_=b.readUInt8(1),w=(_&128)>>>7,F=_&127;this._state.state=2,this._state.readLen=2+(w?4:0)+(F===126?2:0)+(F===127?8:0),this._state.fin=g,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),y=b.readUInt8(1),g=(y&128)>>>7;let _=y&127,w=1;_===126?_=b.readUInt8(++w)*2**8+b.readUInt8(++w):_===127&&(_=b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*2**24+b.readUInt8(++w)*2**16+b.readUInt8(++w)*2**8+b.readUInt8(++w));let F=0;g&&(F=b.readUInt8(++w)*2**24+b.readUInt8(++w)*2**16+b.readUInt8(++w)*2**8+b.readUInt8(++w)),this._state.state=3,this._state.readLen=_,this._state.mask=F}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);a(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const y=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=y.length,this._onData.fire(k.VSBuffer.wrap(y))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function a(c,d){if(d===0)return;let b=c.byteLength>>>2;for(let O=0;O<b;O++){const G=c.readUInt32BE(O*4);c.writeUInt32BE(G^d,O*4)}let y=b*4,g=c.byteLength-y;const _=d>>>24&255,w=d>>>16&255,F=d>>>8&255;g>=1&&c.writeUInt8(c.readUInt8(y)^_,y),g>=2&&c.writeUInt8(c.readUInt8(y+1)^w,y+1),g>=3&&c.writeUInt8(c.readUInt8(y+2)^F,y+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function p(){const c=(0,A.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):d=(0,T.join)((0,I.tmpdir)(),`vscode-ipc-${c}.sock`),s(d),d}e.createRandomIPCHandle=p;function t(c,d,b){const y=(0,m.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${b}-${d}-sock`;let g;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?g=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${b}-${d}.sock`):g=(0,T.join)(c,`${b}-${d}.sock`),s(g),g}e.createStaticIPCHandle=t;function s(c){const d=l[n.platform];typeof d=="number"&&c.length>=d&&console.warn(`WARNING: IPC handle "${c}" is longer than ${d} chars, try a shorter --user-data-dir`)}class r extends u.IPCServer{constructor(d){super(r.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const b=C.Event.fromNodeEventEmitter(d,"connection");return C.Event.map(b,y=>({protocol:new f.Protocol(new v(y)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(y,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(c){return new Promise((d,b)=>{const y=(0,L.createServer)();y.on("error",b),y.listen(c,()=>{y.removeListener("error",b),d(new r(y))})})}e.serve=i;function h(c,d){return new Promise((b,y)=>{const g=(0,L.createConnection)(c,()=>{g.removeListener("error",y),b(f.Client.fromSocket(new v(g),d))});g.once("error",y)})}e.connect=h}),define(me[287],ge([0,1,136,279,50,44,2,199,12]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class T{constructor(u,f,o){this._commands=u,this.logService=f,this._ipcHandlePath=o,this._server=L.createServer((v,S)=>this.onRequest(v,S)),this.setup().catch(v=>(f.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch(u){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,f){const o=[];u.setEncoding("utf8"),u.on("data",v=>o.push(v)),u.on("end",()=>{const v=JSON.parse(o.join(""));switch(v.type){case"open":this.open(v,f);break;case"openExternal":this.openExternal(v,f);break;case"status":this.getStatus(v,f);break;case"extensionManagement":this.manageExtensions(v,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${v.type}`,S=>{S&&this.logService.error(S)}),f.end();break}})}open(u,f){let{fileURIs:o,folderURIs:v,forceNewWindow:S,diffMode:P,addMode:E,forceReuseWindow:a,gotoLineMode:l,waitMarkerFilePath:p}=u;const t=[];if(Array.isArray(v))for(const s of v)try{t.push({folderUri:R.URI.parse(s)})}catch(r){}if(Array.isArray(o))for(const s of o)try{(0,C.hasWorkspaceFileExtension)(s)?t.push({workspaceUri:R.URI.parse(s)}):t.push({fileUri:R.URI.parse(s)})}catch(r){}if(t.length){const s=p?R.URI.file(p):void 0,i={forceNewWindow:S,diffMode:P,addMode:E,gotoLineMode:l,forceReuseWindow:a,preferNewWindow:!a&&!s&&!E,waitMarkerFileURI:s};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}f.writeHead(200),f.end()}async openExternal(u,f){for(const o of u.uris){const v=R.URI.parse(o),S=v.scheme==="file"?v:o;await this._commands.executeCommand("_remoteCLI.openExternal",S)}f.writeHead(200),f.end()}async manageExtensions(u,f){try{const o=P=>P?.map(E=>/\.vsix$/i.test(E)?R.URI.parse(E):E),v={list:u.list,install:o(u.install),uninstall:o(u.uninstall),force:u.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);f.writeHead(200),f.write(S)}catch(o){f.writeHead(500),f.write(String(o),v=>{v&&this.logService.error(v)})}f.end()}async getStatus(u,f){try{const o=await this._commands.executeCommand("_remoteCLI.getSystemStatus");f.writeHead(200),f.write(o),f.end()}catch(o){f.writeHead(500),f.write(String(o),v=>{v&&this.logService.error(v)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=T;let n=class extends T{constructor(u,f){super(u,f,(0,m.createRandomIPCHandle)())}};n=Ve([We(0,k.IExtHostCommands),We(1,D.ILogService)],n),e.CLIServer=n}),define(me[288],ge([0,1,73,275,270,5,278,40,260,2,10,7,287,105]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class o extends I.RequireInterceptor{_installInterceptor(){const P=this,E=J.__$__nodeRequire("module"),a=E._load;E._load=function(p,t,s){for(let r of P._alternatives){let i=r(p);if(i){p=i;break}}return P._factories.has(p)?P._factories.get(p).load(p,T.URI.file((0,f.realpathSync)(t.filename)),r=>a.apply(this,[r,t,s])):a.apply(this,arguments)}}}class v extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const P=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(u.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(o,P,this._registry).install(),m.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const l=process.send,p=this._extHostContext.getProxy(k.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?l.apply(process,t):(p.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(P){return P.main}_loadCommonJSModule(P,E,a){if(E.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let l=null;a.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{P&&m.mark(`code/extHost/willLoadExtensionCode/${P.value}`),l=J.__$__nodeRequire(E.fsPath)}catch(p){return Promise.reject(p)}finally{P&&m.mark(`code/extHost/didLoadExtensionCode/${P.value}`),a.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(P){if(!!this._initData.remote.isRemote)for(const E in P){const a=P[E];a===null?delete process.env[E]:process.env[E]=a}}}e.ExtHostExtensionService=v}),define(me[289],ge([0,1,82,261,263,272,271,286,288,228,264,55,40,68,74,72,33,53,12,69,262]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S,P,E,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(u.IExtHostExtensionService,D.ExtHostExtensionService),(0,m.registerSingleton)(E.ILogService,T.ExtHostLogService),(0,m.registerSingleton)(a.IExtensionStoragePaths,l.ExtensionStoragePaths),(0,m.registerSingleton)(A.IExtHostDebugService,R.ExtHostDebugService),(0,m.registerSingleton)(f.IExtHostOutputService,L.ExtHostOutputService2),(0,m.registerSingleton)(o.IExtHostSearch,C.NativeExtHostSearch),(0,m.registerSingleton)(v.IExtHostTask,k.ExtHostTask),(0,m.registerSingleton)(S.IExtHostTerminalService,I.ExtHostTerminalService),(0,m.registerSingleton)(P.IExtHostTunnelService,n.ExtHostTunnelService)}),define(me[290],ge([0,1,125,302,73,16,107,136,191,226,273,23,103,28,105,18,114,276,289]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,o,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const P=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=J.__$__nodeRequire("module"),h=i._load;i._load=function(c){if(c==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return h.apply(this,arguments)}})();const E=process.exit.bind(process);function a(i){process.exit=function(h){if(i)E(h);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)}}let l=function(i){E()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,h)=>{let c=null,d=setTimeout(()=>{l("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const b=108e5,y=3e5,g=new v.RunOnceScheduler(()=>l("renderer disconnected for too long (1)"),b),_=new v.RunOnceScheduler(()=>l("renderer disconnected for too long (2)"),y);process.on("message",(F,O)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){const G=A.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let K;if(F.skipWebSocketFrames)K=new C.NodeSocket(O);else{const U=A.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));K=new C.WebSocketNodeSocket(new C.NodeSocket(O),F.permessageDeflate,U,!1)}c?(g.cancel(),_.cancel(),c.beginAcceptReconnection(K,G),c.endAcceptReconnection()):(clearTimeout(d),c=new R.PersistentProtocol(K,G),c.onDidDispose(()=>l("renderer disconnected")),i(c),c.onSocketClose(()=>{g.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(_.isScheduled())return;g.isScheduled()&&_.schedule()}});const w={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(w)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((h,c)=>{const d=m.createConnection(i,()=>{d.removeListener("error",c),h(new R.PersistentProtocol(new C.NodeSocket(d)))});d.once("error",c),d.on("close",()=>{l("renderer closed the socket")})})}}async function t(){const i=await p();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(h=>{(0,T.isMessageOfType)(h,2)?(this._terminating=!0,l("received terminate message from renderer")):this._onMessage.fire(h)})}send(h){this._terminating||i.send(h)}drain(){return i.drain()}}}function s(i){return new Promise(h=>{const c=i.onMessage(d=>{c.dispose();const b=JSON.parse(d.toString()),y=b.commit,g=D.default.commit;y&&g&&y!==g&&E(55);const _=[];process.on("unhandledRejection",(O,G)=>{_.push(G),setTimeout(()=>{const K=_.indexOf(G);K>=0&&G.catch(U=>{_.splice(K,1),(0,k.isPromiseCanceledError)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),(0,k.onUnexpectedError)(O))})},1e3)}),process.on("rejectionHandled",O=>{const G=_.indexOf(O);G>=0&&_.splice(G,1)}),process.on("uncaughtException",function(O){(0,k.onUnexpectedError)(O)});let w=0;setInterval(function(){try{process.kill(b.parentPid,0),w=0}catch(O){O&&O.code==="EPERM"?(w++,w>=3&&l(`parent process ${b.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):l(`parent process ${b.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let F;try{F=J.__$__nodeRequire("native-watchdog"),F.start(b.parentPid)}catch(O){(0,k.onUnexpectedError)(O)}i.send((0,T.createMessageOfType)(0)),h({protocol:i,initData:b})});i.send((0,T.createMessageOfType)(1))})}async function r(){I.mark("code/extHost/willConnectToRenderer");const i=await t();I.mark("code/extHost/didConnectToRenderer");const h=await s(i);I.mark("code/extHost/didWaitForInitData");const{initData:c}=h;a(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=P.useHostProxy!==void 0?P.useHostProxy!=="false":void 0,c.environment.skipWorkspaceStorageLock=(0,S.boolean)(P.skipWorkspaceStorageLock,!1);const d=new class{exit(_){E(_)}exists(_){return f.Promises.exists(_)}realpath(_){return(0,o.realpath)(_)}};let b=null;if(c.remote.authority&&P.uriTransformerPath)try{const _=J.__$__nodeRequire(P.uriTransformerPath)(c.remote.authority);b=new u.URITransformer(_)}catch(g){console.error(g)}const y=new n.ExtensionHostMain(h.protocol,c,d,b);l=g=>y.terminate(g)}e.startExtensionHostProcess=r}),define(me[303],ge([0,1,290]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/87260247dc7b912db6e6a21a366e6f50dca759ba/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
