/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(ie){for(var e=[],c=0,F=ie.length;c<F;c++)e[c]=we[ie[c]];return e};define(we[40],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function c(F,_){if(!F)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=c}),define(we[51],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const c=Object.prototype.hasOwnProperty;function F(t){const y=[];for(let n in t)c.call(t,n)&&y.push(t[n]);return y}e.values=F;function _(t,y){for(let n in t)if(c.call(t,n)&&y({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=_;function A(t,y){const n=Object.create(null);for(const h of t){const s=y(h);let d=n[s];d||(d=n[s]=[]),d.push(h)}return n}e.groupBy=A;function R(t){const y=Object.create(null);return t&&t.forEach((n,h)=>{y[h]=n}),y}e.fromMap=R;function I(t,y){const n=[],h=[];for(let s of t)y.has(s)||n.push(s);for(let s of y)t.has(s)||h.push(s);return{removed:n,added:h}}e.diffSets=I;function S(t,y){const n=[],h=[];for(let[s,d]of t)y.has(s)||n.push(d);for(let[s,d]of y)t.has(s)||h.push(d);return{removed:n,added:h}}e.diffMaps=S;class P{constructor(){this.map=new Map}add(y,n){let h=this.map.get(y);h||(h=new Set,this.map.set(y,h)),h.add(n)}delete(y,n){const h=this.map.get(y);!h||(h.delete(n),h.size===0&&this.map.delete(y))}forEach(y,n){const h=this.map.get(y);!h||h.forEach(n)}}e.SetMap=P}),define(we[52],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(R){return(I,S,P)=>{let t=null,y=null;if(typeof P.value=="function"?(t="value",y=P.value):typeof P.get=="function"&&(t="get",y=P.get),!y)throw new Error("not supported");P[t]=R(y,S)}}e.createDecorator=c;function F(R,I,S){let P=null,t=null;if(typeof S.value=="function"?(P="value",t=S.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(P="get",t=S.get),!t)throw new Error("not supported");const y=`$memoize$${I}`;S[P]=function(...n){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[y]}}e.memoize=F;function _(R,I,S){return c((P,t)=>{const y=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...h){this[n]||(this[n]=S?S():void 0),clearTimeout(this[y]),I&&(this[n]=I(this[n],...h),h=[this[n]]),this[y]=setTimeout(()=>{P.apply(this,h),this[n]=S?S():void 0},R)}})}e.debounce=_;function A(R,I,S){return c((P,t)=>{const y=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,h=`$throttle$lastRun$${t}`,s=`$throttle$pending$${t}`;return function(...d){if(this[n]||(this[n]=S?S():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),I&&(this[n]=I(this[n],...d)),this[s])return;const v=this[h]+R;v<=Date.now()?(this[h]=Date.now(),P.apply(this,[this[n]]),this[n]=S?S():void 0):(this[s]=!0,this[y]=setTimeout(()=>{this[s]=!1,this[h]=Date.now(),P.apply(this,[this[n]]),this[n]=S?S():void 0},v-Date.now()))}})}e.throttle=A}),define(we[13],be([0,1,16]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F(G,le=0){return G[G.length-(1+le)]}e.tail=F;function _(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}e.tail2=_;function A(G,le,oe=(Ee,Fe)=>Ee===Fe){if(G===le)return!0;if(!G||!le||G.length!==le.length)return!1;for(let Ee=0,Fe=G.length;Ee<Fe;Ee++)if(!oe(G[Ee],le[Ee]))return!1;return!0}e.equals=A;function R(G,le,oe){let Ee=0,Fe=G.length-1;for(;Ee<=Fe;){const Me=(Ee+Fe)/2|0,Ne=oe(G[Me],le);if(Ne<0)Ee=Me+1;else if(Ne>0)Fe=Me-1;else return Me}return-(Ee+1)}e.binarySearch=R;function I(G,le){let oe=0,Ee=G.length;if(Ee===0)return 0;for(;oe<Ee;){const Fe=Math.floor((oe+Ee)/2);le(G[Fe])?Ee=Fe:oe=Fe+1}return oe}e.findFirstInSorted=I;function S(G,le,oe){if(G=G|0,G>=le.length)throw new TypeError("invalid index");let Ee=le[Math.floor(le.length*Math.random())],Fe=[],Me=[],Ne=[];for(let Qe of le){const ze=oe(Qe,Ee);ze<0?Fe.push(Qe):ze>0?Me.push(Qe):Ne.push(Qe)}return G<Fe.length?S(G,Fe,oe):G<Fe.length+Ne.length?Ne[0]:S(G-(Fe.length+Ne.length),Me,oe)}e.quickSelect=S;function P(G,le){const oe=[];let Ee;for(const Fe of G.slice(0).sort(le))!Ee||le(Ee[0],Fe)!==0?(Ee=[Fe],oe.push(Ee)):Ee.push(Fe);return oe}e.groupBy=P;function t(G,le,oe){const Ee=[];function Fe(Qe,ze,qe){if(ze===0&&qe.length===0)return;const B=Ee[Ee.length-1];B&&B.start+B.deleteCount===Qe?(B.deleteCount+=ze,B.toInsert.push(...qe)):Ee.push({start:Qe,deleteCount:ze,toInsert:qe})}let Me=0,Ne=0;for(;;){if(Me===G.length){Fe(Me,0,le.slice(Ne));break}if(Ne===le.length){Fe(Me,G.length-Me,[]);break}const Qe=G[Me],ze=le[Ne],qe=oe(Qe,ze);qe===0?(Me+=1,Ne+=1):qe<0?(Fe(Me,1,[]),Me+=1):qe>0&&(Fe(Me,0,[ze]),Ne+=1)}return Ee}e.sortedDiff=t;function y(G,le,oe){const Ee=t(G,le,oe),Fe=[],Me=[];for(const Ne of Ee)Fe.push(...G.slice(Ne.start,Ne.start+Ne.deleteCount)),Me.push(...Ne.toInsert);return{removed:Fe,added:Me}}e.delta=y;function n(G,le,oe){if(oe===0)return[];const Ee=G.slice(0,oe).sort(le);return s(G,le,Ee,oe,G.length),Ee}e.top=n;function h(G,le,oe,Ee,Fe){return oe===0?Promise.resolve([]):new Promise((Me,Ne)=>{(async()=>{const Qe=G.length,ze=G.slice(0,oe).sort(le);for(let qe=oe,B=Math.min(oe+Ee,Qe);qe<Qe;qe=B,B=Math.min(B+Ee,Qe)){if(qe>oe&&await new Promise(Q=>setTimeout(Q)),Fe&&Fe.isCancellationRequested)throw(0,c.canceled)();s(G,le,ze,qe,B)}return ze})().then(Me,Ne)})}e.topAsync=h;function s(G,le,oe,Ee,Fe){for(const Me=oe.length;Ee<Fe;Ee++){const Ne=G[Ee];if(le(Ne,oe[Me-1])<0){oe.pop();const Qe=I(oe,ze=>le(Ne,ze)<0);oe.splice(Qe,0,Ne)}}}function d(G){return G.filter(le=>!!le)}e.coalesce=d;function v(G){let le=0;for(let oe=0;oe<G.length;oe++)G[oe]&&(G[le]=G[oe],le+=1);G.length=le}e.coalesceInPlace=v;function C(G,le,oe){G.splice(oe,0,G.splice(le,1)[0])}e.move=C;function w(G){return!Array.isArray(G)||G.length===0}e.isFalsyOrEmpty=w;function a(G){return Array.isArray(G)&&G.length>0}e.isNonEmptyArray=a;function p(G,le){if(!le)return G.filter((Ee,Fe)=>G.indexOf(Ee)===Fe);const oe=Object.create(null);return G.filter(Ee=>{const Fe=le(Ee);return oe[Fe]?!1:(oe[Fe]=!0,!0)})}e.distinct=p;function k(G){const le=new Set;return G.filter(oe=>le.has(oe)?!1:(le.add(oe),!0))}e.distinctES6=k;function i(G){const le=Object.create(null);return oe=>{const Ee=G(oe);return le[Ee]?!1:(le[Ee]=!0,!0)}}e.uniqueFilter=i;function l(G,le){for(let oe=G.length-1;oe>=0;oe--){const Ee=G[oe];if(le(Ee))return oe}return-1}e.lastIndex=l;function r(G,le){return G.length>0?G[0]:le}e.firstOrDefault=r;function o(G,le,oe=(Ee,Fe)=>Ee===Fe){let Ee=0;for(let Fe=0,Me=Math.min(G.length,le.length);Fe<Me&&oe(G[Fe],le[Fe]);Fe++)Ee++;return Ee}e.commonPrefixLength=o;function b(G){return[].concat(...G)}e.flatten=b;function f(G,le){let oe=typeof le=="number"?G:0;typeof le=="number"?oe=G:(oe=0,le=G);const Ee=[];if(oe<=le)for(let Fe=oe;Fe<le;Fe++)Ee.push(Fe);else for(let Fe=oe;Fe>le;Fe--)Ee.push(Fe);return Ee}e.range=f;function m(G,le,oe){return G.reduce((Ee,Fe)=>(Ee[le(Fe)]=oe?oe(Fe):Fe,Ee),Object.create(null))}e.index=m;function D(G,le){return G.push(le),()=>T(G,le)}e.insert=D;function T(G,le){const oe=G.indexOf(le);if(oe>-1)return G.splice(oe,1),le}e.remove=T;function g(G,le,oe){const Ee=G.slice(0,le),Fe=G.slice(le);return Ee.concat(oe,Fe)}e.arrayInsert=g;function E(G,le){let oe;if(typeof le=="number"){let Ee=le;oe=()=>{const Fe=Math.sin(Ee++)*179426549;return Fe-Math.floor(Fe)}}else oe=Math.random;for(let Ee=G.length-1;Ee>0;Ee-=1){const Fe=Math.floor(oe()*(Ee+1)),Me=G[Ee];G[Ee]=G[Fe],G[Fe]=Me}}e.shuffle=E;function u(G,le){const oe=G.indexOf(le);oe>-1&&(G.splice(oe,1),G.unshift(le))}e.pushToStart=u;function M(G,le){const oe=G.indexOf(le);oe>-1&&(G.splice(oe,1),G.push(le))}e.pushToEnd=M;function O(G,le){return Array.isArray(G)?G.map(le):le(G)}e.mapArrayOrNot=O;function q(G){return Array.isArray(G)?G:[G]}e.asArray=q;function K(G){return G[Math.floor(Math.random()*G.length)]}e.getRandomElement=K;function $(G,le){for(const oe of G){const Ee=le(oe);if(Ee!==void 0)return Ee}}e.mapFind=$;function W(G,le,oe){const Ee=H(G,le),Fe=G.length,Me=oe.length;G.length=Fe+Me;for(let Ne=Fe-1;Ne>=Ee;Ne--)G[Ne+Me]=G[Ne];for(let Ne=0;Ne<Me;Ne++)G[Ne+Ee]=oe[Ne]}e.insertInto=W;function N(G,le,oe,Ee){const Fe=H(G,le),Me=G.splice(Fe,oe);return W(G,Fe,Ee),Me}e.splice=N;function H(G,le){return le<0?Math.max(le+G.length,0):Math.min(le,G.length)}function V(G,le){let oe=Number.MAX_SAFE_INTEGER,Ee=0;return G.forEach((Fe,Me)=>{const Ne=le(Fe);Ne<oe&&(oe=Ne,Ee=Me)}),Ee}e.minIndex=V;function Y(G,le){let oe=Number.MIN_SAFE_INTEGER,Ee=0;return G.forEach((Fe,Me)=>{const Ne=le(Fe);Ne>oe&&(oe=Ne,Ee=Me)}),Ee}e.maxIndex=Y;class ce{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let oe=this.firstIdx;for(;oe<this.items.length&&le(this.items[oe]);)oe++;const Ee=oe===this.firstIdx?null:this.items.slice(this.firstIdx,oe);return this.firstIdx=oe,Ee}takeFromEndWhile(le){let oe=this.lastIdx;for(;oe>=0&&le(this.items[oe]);)oe--;const Ee=oe===this.lastIdx?null:this.items.slice(oe+1,this.lastIdx+1);return this.lastIdx=oe,Ee}}e.ArrayQueue=ce}),define(we[53],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(we[102],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var F;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function R(i,l=!1){let r=0,o=i.length,b="",f=0,m=16,D=0;function T(K){let $=0,W=0;for(;$<K;){const N=i.charCodeAt(r);if(N>=48&&N<=57)W=W*16+N-48;else if(N>=65&&N<=70)W=W*16+N-65+10;else if(N>=97&&N<=102)W=W*16+N-97+10;else break;r++,$++}return $<K&&(W=-1),W}function g(K){r=K,b="",f=0,m=16,D=0}function E(){const K=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&P(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&P(i.charCodeAt(r)))for(r++;r<i.length&&P(i.charCodeAt(r));)r++;else return D=3,i.substring(K,r);let $=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&P(i.charCodeAt(r))){for(r++;r<i.length&&P(i.charCodeAt(r));)r++;$=r}else D=3;return i.substring(K,$)}function u(){let K="",$=r;for(;;){if(r>=o){K+=i.substring($,r),D=2;break}const W=i.charCodeAt(r);if(W===34){K+=i.substring($,r),r++;break}if(W===92){if(K+=i.substring($,r),r++,r>=o){D=2;break}switch(i.charCodeAt(r++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const H=T(4);H>=0?K+=String.fromCharCode(H):D=4;break;default:D=5}$=r;continue}if(W>=0&&W<=31)if(S(W)){K+=i.substring($,r),D=2;break}else D=6;r++}return K}function M(){if(b="",D=0,f=r,r>=o)return f=o,m=17;let K=i.charCodeAt(r);if(I(K)){do r++,b+=String.fromCharCode(K),K=i.charCodeAt(r);while(I(K));return m=15}if(S(K))return r++,b+=String.fromCharCode(K),K===13&&i.charCodeAt(r)===10&&(r++,b+=`
`),m=14;switch(K){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,b=u(),m=10;case 47:const $=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<o&&!S(i.charCodeAt(r));)r++;return b=i.substring($,r),m=12}if(i.charCodeAt(r+1)===42){r+=2;const W=o-1;let N=!1;for(;r<W;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,N=!0;break}r++}return N||(r++,D=1),b=i.substring($,r),m=13}return b+=String.fromCharCode(K),r++,m=16;case 45:if(b+=String.fromCharCode(K),r++,r===o||!P(i.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=E(),m=11;default:for(;r<o&&O(K);)r++,K=i.charCodeAt(r);if(f!==r){switch(b=i.substring(f,r),b){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return b+=String.fromCharCode(K),r++,m=16}}function O(K){if(I(K)||S(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let K;do K=M();while(K>=12&&K<=15);return K}return{setPosition:g,getPosition:()=>r,scan:l?q:M,getToken:()=>m,getTokenValue:()=>b,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>D}}e.createScanner=R;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function y(i,l){const r=[],o=new Object;let b;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function D(T,g,E,u){f.value=T,f.offset=g,f.length=E,f.type=u,f.colonOffset=void 0,b=f}try{a(i,{onObjectBegin:(T,g)=>{if(l<=T)throw o;b=void 0,m=l>T,r.push("")},onObjectProperty:(T,g,E)=>{if(l<g||(D(T,g,E,"property"),r[r.length-1]=T,l<=g+E))throw o},onObjectEnd:(T,g)=>{if(l<=T)throw o;b=void 0,r.pop()},onArrayBegin:(T,g)=>{if(l<=T)throw o;b=void 0,r.push(0)},onArrayEnd:(T,g)=>{if(l<=T)throw o;b=void 0,r.pop()},onLiteralValue:(T,g,E)=>{if(l<g||(D(T,g,E,k(T)),l<=g+E))throw o},onSeparator:(T,g,E)=>{if(l<=g)throw o;if(T===":"&&b&&b.type==="property")b.colonOffset=g,m=!1,b=void 0;else if(T===","){const u=r[r.length-1];typeof u=="number"?r[r.length-1]=u+1:(m=!0,r[r.length-1]=""),b=void 0}}})}catch(T){if(T!==o)throw T}return{path:r,previousNode:b,isAtPropertyKey:m,matches:T=>{let g=0;for(let E=0;g<T.length&&E<r.length;E++)if(T[g]===r[E]||T[g]==="*")g++;else if(T[g]!=="**")return!1;return g===T.length}}}e.getLocation=y;function n(i,l=[],r=A.DEFAULT){let o=null,b=[];const f=[];function m(T){Array.isArray(b)?b.push(T):o!==null&&(b[o]=T)}return a(i,{onObjectBegin:()=>{const T={};m(T),f.push(b),b=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{b=f.pop()},onArrayBegin:()=>{const T=[];m(T),f.push(b),b=T,o=null},onArrayEnd:()=>{b=f.pop()},onLiteralValue:m,onError:(T,g,E)=>{l.push({error:T,offset:g,length:E})}},r),b[0]}e.parse=n;function h(i,l=[],r=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(T){o.type==="property"&&(o.length=T-o.offset,o=o.parent)}function f(T){return o.children.push(T),T}a(i,{onObjectBegin:T=>{o=f({type:"object",offset:T,length:-1,parent:o,children:[]})},onObjectProperty:(T,g,E)=>{o=f({type:"property",offset:g,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:T,offset:g,length:E,parent:o})},onObjectEnd:(T,g)=>{o.length=T+g-o.offset,o=o.parent,b(T+g)},onArrayBegin:(T,g)=>{o=f({type:"array",offset:T,length:-1,parent:o,children:[]})},onArrayEnd:(T,g)=>{o.length=T+g-o.offset,o=o.parent,b(T+g)},onLiteralValue:(T,g,E)=>{f({type:k(T),offset:g,length:E,parent:o,value:T}),b(g+E)},onSeparator:(T,g,E)=>{o.type==="property"&&(T===":"?o.colonOffset=g:T===","&&b(g))},onError:(T,g,E)=>{l.push({error:T,offset:g,length:E})}},r);const D=o.children[0];return D&&delete D.parent,D}e.parseTree=h;function s(i,l){if(!i)return;let r=i;for(let o of l)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let b=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===o){r=f.children[1],b=!0;break}if(!b)return}else{const b=o;if(r.type!=="array"||b<0||!Array.isArray(r.children)||b>=r.children.length)return;r=r.children[b]}return r}e.findNodeAtLocation=s;function d(i){if(!i.parent||!i.parent.children)return[];const l=d(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;l.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&l.push(r)}return l}e.getNodePath=d;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":const l=Object.create(null);for(let r of i.children){const o=r.children[1];o&&(l[r.children[0].value]=v(o))}return l;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function C(i,l,r=!1){return l>=i.offset&&l<i.offset+i.length||r&&l===i.offset+i.length}e.contains=C;function w(i,l,r=!1){if(C(i,l,r)){const o=i.children;if(Array.isArray(o))for(let b=0;b<o.length&&o[b].offset<=l;b++){const f=w(o[b],l,r);if(f)return f}return i}}e.findNodeAtOffset=w;function a(i,l,r=A.DEFAULT){const o=R(i,!1);function b(oe){return oe?()=>oe(o.getTokenOffset(),o.getTokenLength()):()=>!0}function f(oe){return oe?Ee=>oe(Ee,o.getTokenOffset(),o.getTokenLength()):()=>!0}const m=b(l.onObjectBegin),D=f(l.onObjectProperty),T=b(l.onObjectEnd),g=b(l.onArrayBegin),E=b(l.onArrayEnd),u=f(l.onLiteralValue),M=f(l.onSeparator),O=b(l.onComment),q=f(l.onError),K=r&&r.disallowComments,$=r&&r.allowTrailingComma;function W(){for(;;){const oe=o.scan();switch(o.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:K||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(oe){case 12:case 13:K?N(10):O();break;case 16:N(1);break;case 15:case 14:break;default:return oe}}}function N(oe,Ee=[],Fe=[]){if(q(oe),Ee.length+Fe.length>0){let Me=o.getToken();for(;Me!==17;){if(Ee.indexOf(Me)!==-1){W();break}else if(Fe.indexOf(Me)!==-1)break;Me=W()}}}function H(oe){const Ee=o.getTokenValue();return oe?u(Ee):D(Ee),W(),!0}function V(){switch(o.getToken()){case 11:let oe=0;try{oe=JSON.parse(o.getTokenValue()),typeof oe!="number"&&(N(2),oe=0)}catch(Ee){N(2)}u(oe);break;case 7:u(null);break;case 8:u(!0);break;case 9:u(!1);break;default:return!1}return W(),!0}function Y(){return o.getToken()!==10?(N(3,[],[2,5]),!1):(H(!1),o.getToken()===6?(M(":"),W(),le()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function ce(){m(),W();let oe=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(oe||N(4,[],[]),M(","),W(),o.getToken()===2&&$)break}else oe&&N(6,[],[]);Y()||N(4,[],[2,5]),oe=!0}return T(),o.getToken()!==2?N(7,[2],[]):W(),!0}function G(){g(),W();let oe=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(oe||N(4,[],[]),M(","),W(),o.getToken()===4&&$)break}else oe&&N(6,[],[]);le()||N(4,[],[4,5]),oe=!0}return E(),o.getToken()!==4?N(8,[4],[]):W(),!0}function le(){switch(o.getToken()){case 3:return G();case 1:return ce();case 10:return H(!0);default:return V()}}return W(),o.getToken()===17?r.allowEmptyContent?!0:(N(4,[],[]),!1):le()?(o.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=a;function p(i,l){let r=R(i),o=[],b,f=0,m;do switch(m=r.getPosition(),b=r.scan(),b){case 12:case 13:case 17:f!==m&&o.push(i.substring(f,m)),l!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,l)),f=r.getPosition();break}while(b!==17);return o.join("")}e.stripComments=p;function k(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(we[103],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(_){this.executor=_,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(_){this._error=_}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(_){return new c(()=>_(this.getValue()))}}e.Lazy=c}),function(ie,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ie=typeof globalThis!="undefined"?globalThis:ie||self,ie.marked=e())}(this,function(){"use strict";function ie(Pe,ye){for(var De=0;De<ye.length;De++){var Z=ye[De];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(Pe,Z.key,Z)}}function e(Pe,ye,De){return ye&&ie(Pe.prototype,ye),De&&ie(Pe,De),Pe}function c(Pe,ye){if(!!Pe){if(typeof Pe=="string")return F(Pe,ye);var De=Object.prototype.toString.call(Pe).slice(8,-1);if(De==="Object"&&Pe.constructor&&(De=Pe.constructor.name),De==="Map"||De==="Set")return Array.from(Pe);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return F(Pe,ye)}}function F(Pe,ye){(ye==null||ye>Pe.length)&&(ye=Pe.length);for(var De=0,Z=new Array(ye);De<ye;De++)Z[De]=Pe[De];return Z}function _(Pe,ye){var De=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(De)return(De=De.call(Pe)).next.bind(De);if(Array.isArray(Pe)||(De=c(Pe))||ye&&Pe&&typeof Pe.length=="number"){De&&(Pe=De);var Z=0;return function(){return Z>=Pe.length?{done:!0}:{done:!1,value:Pe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Pe){A.exports.defaults=Pe}A.exports={defaults:R(),getDefaults:R,changeDefaults:I};var S=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(ye){return n[ye]};function s(Pe,ye){if(ye){if(S.test(Pe))return Pe.replace(P,h)}else if(t.test(Pe))return Pe.replace(y,h);return Pe}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Pe){return Pe.replace(d,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var C=/(^|[^\[])\^/g;function w(Pe,ye){Pe=Pe.source||Pe,ye=ye||"";var De={replace:function(ue,ge){return ge=ge.source||ge,ge=ge.replace(C,"$1"),Pe=Pe.replace(ue,ge),De},getRegex:function(){return new RegExp(Pe,ye)}};return De}var a=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function k(Pe,ye,De){if(Pe){var Z;try{Z=decodeURIComponent(v(De)).replace(a,"").toLowerCase()}catch(ue){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ye&&!p.test(De)&&(De=b(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(ue){return null}return De}var i={},l=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(Pe,ye){i[" "+Pe]||(l.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=T(Pe,"/",!0)),Pe=i[" "+Pe];var De=Pe.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Pe.replace(r,"$1")+ye:ye.charAt(0)==="/"?De?ye:Pe.replace(o,"$1")+ye:Pe+ye}var f={exec:function(){}};function m(Pe){for(var ye=1,De,Z;ye<arguments.length;ye++){De=arguments[ye];for(Z in De)Object.prototype.hasOwnProperty.call(De,Z)&&(Pe[Z]=De[Z])}return Pe}function D(Pe,ye){var De=Pe.replace(/\|/g,function(ge,me,Ie){for(var Be=!1,Le=me;--Le>=0&&Ie[Le]==="\\";)Be=!Be;return Be?"|":" |"}),Z=De.split(/ \|/),ue=0;if(Z[0].trim()||Z.shift(),Z[Z.length-1].trim()||Z.pop(),Z.length>ye)Z.splice(ye);else for(;Z.length<ye;)Z.push("");for(;ue<Z.length;ue++)Z[ue]=Z[ue].trim().replace(/\\\|/g,"|");return Z}function T(Pe,ye,De){var Z=Pe.length;if(Z===0)return"";for(var ue=0;ue<Z;){var ge=Pe.charAt(Z-ue-1);if(ge===ye&&!De)ue++;else if(ge!==ye&&De)ue++;else break}return Pe.substr(0,Z-ue)}function g(Pe,ye){if(Pe.indexOf(ye[1])===-1)return-1;for(var De=Pe.length,Z=0,ue=0;ue<De;ue++)if(Pe[ue]==="\\")ue++;else if(Pe[ue]===ye[0])Z++;else if(Pe[ue]===ye[1]&&(Z--,Z<0))return ue;return-1}function E(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function u(Pe,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Pe),ye>>=1,Pe+=Pe;return De+Pe}var M={escape:s,unescape:v,edit:w,cleanUrl:k,resolveUrl:b,noopTest:f,merge:m,splitCells:D,rtrim:T,findClosingBracket:g,checkSanitizeDeprecation:E,repeatString:u},O=A.exports.defaults,q=M.rtrim,K=M.splitCells,$=M.escape,W=M.findClosingBracket;function N(Pe,ye,De,Z){var ue=ye.href,ge=ye.title?$(ye.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");return Pe[0].charAt(0)!=="!"?(Z.state.inLink=!0,{type:"link",raw:De,href:ue,title:ge,text:me,tokens:Z.inlineTokens(me,[])}):{type:"image",raw:De,href:ue,title:ge,text:$(me)}}function H(Pe,ye){var De=Pe.match(/^(\s+)(?:```)/);if(De===null)return ye;var Z=De[1];return ye.split(`
`).map(function(ue){var ge=ue.match(/^\s+/);if(ge===null)return ue;var me=ge[0];return me.length>=Z.length?ue.slice(Z.length):ue}).join(`
`)}var V=function(){function Pe(De){this.options=De||O}var ye=Pe.prototype;return ye.space=function(Z){var ue=this.rules.block.newline.exec(Z);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(Z){var ue=this.rules.block.code.exec(Z);if(ue){var ge=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:q(ge,`
`)}}},ye.fences=function(Z){var ue=this.rules.block.fences.exec(Z);if(ue){var ge=ue[0],me=H(ge,ue[3]||"");return{type:"code",raw:ge,lang:ue[2]?ue[2].trim():ue[2],text:me}}},ye.heading=function(Z){var ue=this.rules.block.heading.exec(Z);if(ue){var ge=ue[2].trim();if(/#$/.test(ge)){var me=q(ge,"#");(this.options.pedantic||!me||/ $/.test(me))&&(ge=me.trim())}var Ie={type:"heading",raw:ue[0],depth:ue[1].length,text:ge,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},ye.hr=function(Z){var ue=this.rules.block.hr.exec(Z);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(Z){var ue=this.rules.block.blockquote.exec(Z);if(ue){var ge=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(Z){var ue=this.rules.block.list.exec(Z);if(ue){var ge,me,Ie,Be,Le,je,Xe,ne,pe,re,U=ue[1].trim(),Ce=U.length>1,Se={type:"list",raw:"",ordered:Ce,start:Ce?+U.slice(0,-1):"",loose:!1,items:[]};U=Ce?"\\d{1,9}\\"+U.slice(-1):"\\"+U,this.options.pedantic&&(U=Ce?U:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+U+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");Z&&!(this.rules.block.hr.test(Z)||!(ue=Ge.exec(Z)));){pe=ue[2].split(`
`),this.options.pedantic?(Be=2,re=pe[0].trimLeft()):(Be=ue[2].search(/[^ ]/),Be=ue[1].length+(Be>4?1:Be),re=pe[0].slice(Be-ue[1].length)),je=!1,ge=ue[0],!pe[0]&&/^ *$/.test(pe[1])&&(ge=ue[1]+pe.slice(0,2).join(`
`)+`
`,Se.loose=!0,pe=[]);var We=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<pe.length;Le++){if(ne=pe[Le],this.options.pedantic&&(ne=ne.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),We.test(ne)){ge=ue[1]+pe.slice(0,Le).join(`
`)+`
`;break}if(!je){ne.trim()||(je=!0),ne.search(/[^ ]/)>=Be?re+=`
`+ne.slice(Be):re+=`
`+ne;continue}if(ne.search(/[^ ]/)>=Be||!ne.trim()){re+=`
`+ne.slice(Be);continue}else{ge=ue[1]+pe.slice(0,Le).join(`
`)+`
`;break}}Se.loose||(Xe?Se.loose=!0:/\n *\n *$/.test(ge)&&(Xe=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(re),me&&(Ie=me[0]!=="[ ] ",re=re.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:ge,task:!!me,checked:Ie,loose:!1,text:re}),Se.raw+=ge,Z=Z.slice(ge.length)}Se.items[Se.items.length-1].raw=ge.trimRight(),Se.items[Se.items.length-1].text=re.trimRight(),Se.raw=Se.raw.trimRight();var it=Se.items.length;for(Le=0;Le<it;Le++)this.lexer.state.top=!1,Se.items[Le].tokens=this.lexer.blockTokens(Se.items[Le].text,[]),Se.items[Le].tokens.some(function(mt){return mt.type==="space"})&&(Se.loose=!0,Se.items[Le].loose=!0);return Se}},ye.html=function(Z){var ue=this.rules.block.html.exec(Z);if(ue){var ge={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(ue[0]):$(ue[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(Z){var ue=this.rules.block.def.exec(Z);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var ge=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(Z){var ue=this.rules.block.table.exec(Z);if(ue){var ge={type:"table",header:K(ue[1]).map(function(Xe){return{text:Xe}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=ue[0];var me=ge.align.length,Ie,Be,Le,je;for(Ie=0;Ie<me;Ie++)/^ *-+: *$/.test(ge.align[Ie])?ge.align[Ie]="right":/^ *:-+: *$/.test(ge.align[Ie])?ge.align[Ie]="center":/^ *:-+ *$/.test(ge.align[Ie])?ge.align[Ie]="left":ge.align[Ie]=null;for(me=ge.rows.length,Ie=0;Ie<me;Ie++)ge.rows[Ie]=K(ge.rows[Ie],ge.header.length).map(function(Xe){return{text:Xe}});for(me=ge.header.length,Be=0;Be<me;Be++)ge.header[Be].tokens=[],this.lexer.inlineTokens(ge.header[Be].text,ge.header[Be].tokens);for(me=ge.rows.length,Be=0;Be<me;Be++)for(je=ge.rows[Be],Le=0;Le<je.length;Le++)je[Le].tokens=[],this.lexer.inlineTokens(je[Le].text,je[Le].tokens);return ge}}},ye.lheading=function(Z){var ue=this.rules.block.lheading.exec(Z);if(ue){var ge={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(Z){var ue=this.rules.block.paragraph.exec(Z);if(ue){var ge={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(Z){var ue=this.rules.block.text.exec(Z);if(ue){var ge={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(Z){var ue=this.rules.inline.escape.exec(Z);if(ue)return{type:"escape",raw:ue[0],text:$(ue[1])}},ye.tag=function(Z){var ue=this.rules.inline.tag.exec(Z);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):$(ue[0]):ue[0]}},ye.link=function(Z){var ue=this.rules.inline.link.exec(Z);if(ue){var ge=ue[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var me=q(ge.slice(0,-1),"\\");if((ge.length-me.length)%2==0)return}else{var Ie=W(ue[2],"()");if(Ie>-1){var Be=ue[0].indexOf("!")===0?5:4,Le=Be+ue[1].length+Ie;ue[2]=ue[2].substring(0,Ie),ue[0]=ue[0].substring(0,Le).trim(),ue[3]=""}}var je=ue[2],Xe="";if(this.options.pedantic){var ne=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);ne&&(je=ne[1],Xe=ne[3])}else Xe=ue[3]?ue[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(ge)?je=je.slice(1):je=je.slice(1,-1)),N(ue,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(Z,ue){var ge;if((ge=this.rules.inline.reflink.exec(Z))||(ge=this.rules.inline.nolink.exec(Z))){var me=(ge[2]||ge[1]).replace(/\s+/g," ");if(me=ue[me.toLowerCase()],!me||!me.href){var Ie=ge[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return N(ge,me,ge[0],this.lexer)}},ye.emStrong=function(Z,ue,ge){ge===void 0&&(ge="");var me=this.rules.inline.emStrong.lDelim.exec(Z);if(!!me&&!(me[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=me[1]||me[2]||"";if(!Ie||Ie&&(ge===""||this.rules.inline.punctuation.exec(ge))){var Be=me[0].length-1,Le,je,Xe=Be,ne=0,pe=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ue=ue.slice(-1*Z.length+Be);(me=pe.exec(ue))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(je=Le.length,me[3]||me[4]){Xe+=je;continue}else if((me[5]||me[6])&&Be%3&&!((Be+je)%3)){ne+=je;continue}if(Xe-=je,!(Xe>0)){if(je=Math.min(je,je+Xe+ne),Math.min(Be,je)%2){var re=Z.slice(1,Be+me.index+je);return{type:"em",raw:Z.slice(0,Be+me.index+je+1),text:re,tokens:this.lexer.inlineTokens(re,[])}}var U=Z.slice(2,Be+me.index+je-1);return{type:"strong",raw:Z.slice(0,Be+me.index+je+1),text:U,tokens:this.lexer.inlineTokens(U,[])}}}}}},ye.codespan=function(Z){var ue=this.rules.inline.code.exec(Z);if(ue){var ge=ue[2].replace(/\n/g," "),me=/[^ ]/.test(ge),Ie=/^ /.test(ge)&&/ $/.test(ge);return me&&Ie&&(ge=ge.substring(1,ge.length-1)),ge=$(ge,!0),{type:"codespan",raw:ue[0],text:ge}}},ye.br=function(Z){var ue=this.rules.inline.br.exec(Z);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(Z){var ue=this.rules.inline.del.exec(Z);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},ye.autolink=function(Z,ue){var ge=this.rules.inline.autolink.exec(Z);if(ge){var me,Ie;return ge[2]==="@"?(me=$(this.options.mangle?ue(ge[1]):ge[1]),Ie="mailto:"+me):(me=$(ge[1]),Ie=me),{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.url=function(Z,ue){var ge;if(ge=this.rules.inline.url.exec(Z)){var me,Ie;if(ge[2]==="@")me=$(this.options.mangle?ue(ge[0]):ge[0]),Ie="mailto:"+me;else{var Be;do Be=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(Be!==ge[0]);me=$(ge[0]),ge[1]==="www."?Ie="http://"+me:Ie=me}return{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.inlineText=function(Z,ue){var ge=this.rules.inline.text.exec(Z);if(ge){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):$(ge[0]):ge[0]:me=$(this.options.smartypants?ue(ge[0]):ge[0]),{type:"text",raw:ge[0],text:me}}},Pe}(),Y=M.noopTest,ce=M.edit,G=M.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:Y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=ce(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=ce(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=ce(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=ce(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=ce(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=ce(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=G({},le),le.gfm=G({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=ce(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=G({},le.normal,{html:ce(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Y,paragraph:ce(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=ce(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=ce(le._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=ce(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=ce(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=ce(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=ce(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=ce(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=ce(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=ce(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=ce(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=G({},oe),oe.pedantic=G({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ce(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:ce(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=G({},oe.normal,{escape:ce(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=ce(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=G({},oe.gfm,{br:ce(oe.br).replace("{2,}","*").getRegex(),text:ce(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Ee={block:le,inline:oe},Fe=V,Me=A.exports.defaults,Ne=Ee.block,Qe=Ee.inline,ze=M.repeatString;function qe(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(Pe){var ye="",De,Z,ue=Pe.length;for(De=0;De<ue;De++)Z=Pe.charCodeAt(De),Math.random()>.5&&(Z="x"+Z.toString(16)),ye+="&#"+Z+";";return ye}var Q=function(){function Pe(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Me,this.options.tokenizer=this.options.tokenizer||new Fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:Ne.normal,inline:Qe.normal};this.options.pedantic?(Z.block=Ne.pedantic,Z.inline=Qe.pedantic):this.options.gfm&&(Z.block=Ne.gfm,this.options.breaks?Z.inline=Qe.breaks:Z.inline=Qe.gfm),this.tokenizer.rules=Z}Pe.lex=function(Z,ue){var ge=new Pe(ue);return ge.lex(Z)},Pe.lexInline=function(Z,ue){var ge=new Pe(ue);return ge.inlineTokens(Z)};var ye=Pe.prototype;return ye.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(Z,ue){var ge=this;ue===void 0&&(ue=[]),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var me,Ie,Be,Le;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Xe){return(me=Xe.call({lexer:ge},Z,ue))?(Z=Z.substring(me.raw.length),ue.push(me),!0):!1}))){if(me=this.tokenizer.space(Z)){Z=Z.substring(me.raw.length),me.type&&ue.push(me);continue}if(me=this.tokenizer.code(Z)){Z=Z.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me);continue}if(me=this.tokenizer.fences(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.heading(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.hr(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.blockquote(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.list(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.html(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.def(Z)){Z=Z.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.lheading(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Xe=Infinity,ne=Z.slice(1),pe=void 0;ge.options.extensions.startBlock.forEach(function(re){pe=re.call({lexer:this},ne),typeof pe=="number"&&pe>=0&&(Xe=Math.min(Xe,pe))}),Xe<Infinity&&Xe>=0&&(Be=Z.substring(0,Xe+1))}(),this.state.top&&(me=this.tokenizer.paragraph(Be))){Ie=ue[ue.length-1],Le&&Ie.type==="paragraph"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me),Le=Be.length!==Z.length,Z=Z.substring(me.raw.length);continue}if(me=this.tokenizer.text(Z)){Z=Z.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me);continue}if(Z){var je="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return this.state.top=!0,ue},ye.inline=function(Z,ue){this.inlineQueue.push({src:Z,tokens:ue})},ye.inlineTokens=function(Z,ue){var ge=this;ue===void 0&&(ue=[]);var me,Ie,Be,Le=Z,je,Xe,ne;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)pe.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,je.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Xe||(ne=""),Xe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(U){return(me=U.call({lexer:ge},Z,ue))?(Z=Z.substring(me.raw.length),ue.push(me),!0):!1}))){if(me=this.tokenizer.escape(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.tag(Z)){Z=Z.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(me=this.tokenizer.link(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(me=this.tokenizer.emStrong(Z,Le,ne)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.codespan(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.br(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.del(Z)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.autolink(Z,B)){Z=Z.substring(me.raw.length),ue.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(Z,B))){Z=Z.substring(me.raw.length),ue.push(me);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var U=Infinity,Ce=Z.slice(1),Se=void 0;ge.options.extensions.startInline.forEach(function(Ge){Se=Ge.call({lexer:this},Ce),typeof Se=="number"&&Se>=0&&(U=Math.min(U,Se))}),U<Infinity&&U>=0&&(Be=Z.substring(0,U+1))}(),me=this.tokenizer.inlineText(Be,qe)){Z=Z.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(ne=me.raw.slice(-1)),Xe=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(Z){var re="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return ue},e(Pe,null,[{key:"rules",get:function(){return{block:Ne,inline:Qe}}}]),Pe}(),ee=A.exports.defaults,ae=M.cleanUrl,j=M.escape,se=function(){function Pe(De){this.options=De||ee}var ye=Pe.prototype;return ye.code=function(Z,ue,ge){var me=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(Z,me);Ie!=null&&Ie!==Z&&(ge=!0,Z=Ie)}return Z=Z.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+j(me,!0)+'">'+(ge?Z:j(Z,!0))+`</code></pre>
`:"<pre><code>"+(ge?Z:j(Z,!0))+`</code></pre>
`},ye.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ye.html=function(Z){return Z},ye.heading=function(Z,ue,ge,me){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+me.slug(ge)+'">'+Z+"</h"+ue+`>
`:"<h"+ue+">"+Z+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(Z,ue,ge){var me=ue?"ol":"ul",Ie=ue&&ge!==1?' start="'+ge+'"':"";return"<"+me+Ie+`>
`+Z+"</"+me+`>
`},ye.listitem=function(Z){return"<li>"+Z+`</li>
`},ye.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(Z){return"<p>"+Z+`</p>
`},ye.table=function(Z,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ue+`</table>
`},ye.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ye.tablecell=function(Z,ue){var ge=ue.header?"th":"td",me=ue.align?"<"+ge+' align="'+ue.align+'">':"<"+ge+">";return me+Z+"</"+ge+`>
`},ye.strong=function(Z){return"<strong>"+Z+"</strong>"},ye.em=function(Z){return"<em>"+Z+"</em>"},ye.codespan=function(Z){return"<code>"+Z+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(Z){return"<del>"+Z+"</del>"},ye.link=function(Z,ue,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var me='<a href="'+j(Z)+'"';return ue&&(me+=' title="'+ue+'"'),me+=">"+ge+"</a>",me},ye.image=function(Z,ue,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var me='<img src="'+Z+'" alt="'+ge+'"';return ue&&(me+=' title="'+ue+'"'),me+=this.options.xhtml?"/>":">",me},ye.text=function(Z){return Z},Pe}(),fe=function(){function Pe(){}var ye=Pe.prototype;return ye.strong=function(Z){return Z},ye.em=function(Z){return Z},ye.codespan=function(Z){return Z},ye.del=function(Z){return Z},ye.html=function(Z){return Z},ye.text=function(Z){return Z},ye.link=function(Z,ue,ge){return""+ge},ye.image=function(Z,ue,ge){return""+ge},ye.br=function(){return""},Pe}(),Ae=function(){function Pe(){this.seen={}}var ye=Pe.prototype;return ye.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(Z,ue){var ge=Z,me=0;if(this.seen.hasOwnProperty(ge)){me=this.seen[Z];do me++,ge=Z+"-"+me;while(this.seen.hasOwnProperty(ge))}return ue||(this.seen[Z]=me,this.seen[ge]=0),ge},ye.slug=function(Z,ue){ue===void 0&&(ue={});var ge=this.serialize(Z);return this.getNextSafeSlug(ge,ue.dryrun)},Pe}(),xe=se,$e=fe,ve=Ae,Ze=A.exports.defaults,z=M.unescape,J=function(){function Pe(De){this.options=De||Ze,this.options.renderer=this.options.renderer||new xe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $e,this.slugger=new ve}Pe.parse=function(Z,ue){var ge=new Pe(ue);return ge.parse(Z)},Pe.parseInline=function(Z,ue){var ge=new Pe(ue);return ge.parseInline(Z)};var ye=Pe.prototype;return ye.parse=function(Z,ue){ue===void 0&&(ue=!0);var ge="",me,Ie,Be,Le,je,Xe,ne,pe,re,U,Ce,Se,Ge,We,it,mt,vt,nt,ot,lt=Z.length;for(me=0;me<lt;me++){if(U=Z[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(ot=this.options.extensions.renderers[U.type].call({parser:this},U),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(U.type))){ge+=ot||"";continue}switch(U.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(U.tokens),U.depth,z(this.parseInline(U.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(U.text,U.lang,U.escaped);continue}case"table":{for(pe="",ne="",Le=U.header.length,Ie=0;Ie<Le;Ie++)ne+=this.renderer.tablecell(this.parseInline(U.header[Ie].tokens),{header:!0,align:U.align[Ie]});for(pe+=this.renderer.tablerow(ne),re="",Le=U.rows.length,Ie=0;Ie<Le;Ie++){for(Xe=U.rows[Ie],ne="",je=Xe.length,Be=0;Be<je;Be++)ne+=this.renderer.tablecell(this.parseInline(Xe[Be].tokens),{header:!1,align:U.align[Be]});re+=this.renderer.tablerow(ne)}ge+=this.renderer.table(pe,re);continue}case"blockquote":{re=this.parse(U.tokens),ge+=this.renderer.blockquote(re);continue}case"list":{for(Ce=U.ordered,Se=U.start,Ge=U.loose,Le=U.items.length,re="",Ie=0;Ie<Le;Ie++)it=U.items[Ie],mt=it.checked,vt=it.task,We="",it.task&&(nt=this.renderer.checkbox(mt),Ge?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=nt+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=nt+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:nt}):We+=nt),We+=this.parse(it.tokens,Ge),re+=this.renderer.listitem(We,vt,mt);ge+=this.renderer.list(re,Ce,Se);continue}case"html":{ge+=this.renderer.html(U.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(U.tokens));continue}case"text":{for(re=U.tokens?this.parseInline(U.tokens):U.text;me+1<lt&&Z[me+1].type==="text";)U=Z[++me],re+=`
`+(U.tokens?this.parseInline(U.tokens):U.text);ge+=ue?this.renderer.paragraph(re):re;continue}default:{var Rt='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(Rt);return}else throw new Error(Rt)}}}return ge},ye.parseInline=function(Z,ue){ue=ue||this.renderer;var ge="",me,Ie,Be,Le=Z.length;for(me=0;me<Le;me++){if(Ie=Z[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Be=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){ge+=Be||"";continue}switch(Ie.type){case"escape":{ge+=ue.text(Ie.text);break}case"html":{ge+=ue.html(Ie.text);break}case"link":{ge+=ue.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ue));break}case"image":{ge+=ue.image(Ie.href,Ie.title,Ie.text);break}case"strong":{ge+=ue.strong(this.parseInline(Ie.tokens,ue));break}case"em":{ge+=ue.em(this.parseInline(Ie.tokens,ue));break}case"codespan":{ge+=ue.codespan(Ie.text);break}case"br":{ge+=ue.br();break}case"del":{ge+=ue.del(this.parseInline(Ie.tokens,ue));break}case"text":{ge+=ue.text(Ie.text);break}default:{var je='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return ge},Pe}(),he=Q,Oe=J,Ve=V,tt=se,ut=fe,ht=Ae,St=M.merge,Pt=M.checkSanitizeDeprecation,dt=M.escape,bt=A.exports.getDefaults,ft=A.exports.changeDefaults,Et=A.exports.defaults;function Ye(Pe,ye,De){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=St({},Ye.defaults,ye||{}),Pt(ye),De){var Z=ye.highlight,ue;try{ue=he.lex(Pe,ye)}catch(Be){return De(Be)}var ge=function(Le){var je;if(!Le)try{ye.walkTokens&&Ye.walkTokens(ue,ye.walkTokens),je=Oe.parse(ue,ye)}catch(Xe){Le=Xe}return ye.highlight=Z,Le?De(Le):De(null,je)};if(!Z||Z.length<3||(delete ye.highlight,!ue.length))return ge();var me=0;Ye.walkTokens(ue,function(Be){Be.type==="code"&&(me++,setTimeout(function(){Z(Be.text,Be.lang,function(Le,je){if(Le)return ge(Le);je!=null&&je!==Be.text&&(Be.text=je,Be.escaped=!0),me--,me===0&&ge()})},0))}),me===0&&ge();return}try{var Ie=he.lex(Pe,ye);return ye.walkTokens&&Ye.walkTokens(Ie,ye.walkTokens),Oe.parse(Ie,ye)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(Be.message+"",!0)+"</pre>";throw Be}}Ye.options=Ye.setOptions=function(Pe){return St(Ye.defaults,Pe),ft(Ye.defaults),Ye},Ye.getDefaults=bt,Ye.defaults=Et,Ye.use=function(){for(var Pe=this,ye=arguments.length,De=new Array(ye),Z=0;Z<ye;Z++)De[Z]=arguments[Z];var ue=St.apply(void 0,[{}].concat(De)),ge=Ye.defaults.extensions||{renderers:{},childTokens:{}},me;De.forEach(function(Ie){if(Ie.extensions&&(me=!0,Ie.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var je=ge.renderers?ge.renderers[Le.name]:null;je?ge.renderers[Le.name]=function(){for(var Xe=arguments.length,ne=new Array(Xe),pe=0;pe<Xe;pe++)ne[pe]=arguments[pe];var re=Le.renderer.apply(this,ne);return re===!1&&(re=je.apply(this,ne)),re}:ge.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Le.level]?ge[Le.level].unshift(Le.tokenizer):ge[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?ge.startBlock?ge.startBlock.push(Le.start):ge.startBlock=[Le.start]:Le.level==="inline"&&(ge.startInline?ge.startInline.push(Le.start):ge.startInline=[Le.start]))}Le.childTokens&&(ge.childTokens[Le.name]=Le.childTokens)})),Ie.renderer&&function(){var Le=Ye.defaults.renderer||new tt,je=function(pe){var re=Le[pe];Le[pe]=function(){for(var U=arguments.length,Ce=new Array(U),Se=0;Se<U;Se++)Ce[Se]=arguments[Se];var Ge=Ie.renderer[pe].apply(Le,Ce);return Ge===!1&&(Ge=re.apply(Le,Ce)),Ge}};for(var Xe in Ie.renderer)je(Xe);ue.renderer=Le}(),Ie.tokenizer&&function(){var Le=Ye.defaults.tokenizer||new Ve,je=function(pe){var re=Le[pe];Le[pe]=function(){for(var U=arguments.length,Ce=new Array(U),Se=0;Se<U;Se++)Ce[Se]=arguments[Se];var Ge=Ie.tokenizer[pe].apply(Le,Ce);return Ge===!1&&(Ge=re.apply(Le,Ce)),Ge}};for(var Xe in Ie.tokenizer)je(Xe);ue.tokenizer=Le}(),Ie.walkTokens){var Be=Ye.defaults.walkTokens;ue.walkTokens=function(Le){Ie.walkTokens.call(Pe,Le),Be&&Be(Le)}}me&&(ue.extensions=ge),Ye.setOptions(ue)})},Ye.walkTokens=function(Pe,ye){for(var De=function(){var me=ue.value;switch(ye(me),me.type){case"table":{for(var Ie=_(me.header),Be;!(Be=Ie()).done;){var Le=Be.value;Ye.walkTokens(Le.tokens,ye)}for(var je=_(me.rows),Xe;!(Xe=je()).done;)for(var ne=Xe.value,pe=_(ne),re;!(re=pe()).done;){var U=re.value;Ye.walkTokens(U.tokens,ye)}break}case"list":{Ye.walkTokens(me.items,ye);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[me.type]?Ye.defaults.extensions.childTokens[me.type].forEach(function(Ce){Ye.walkTokens(me[Ce],ye)}):me.tokens&&Ye.walkTokens(me.tokens,ye)}},Z=_(Pe),ue;!(ue=Z()).done;)De()},Ye.parseInline=function(Pe,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ye=St({},Ye.defaults,ye||{}),Pt(ye);try{var De=he.lexInline(Pe,ye);return ye.walkTokens&&Ye.walkTokens(De,ye.walkTokens),Oe.parseInline(De,ye)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(Z.message+"",!0)+"</pre>";throw Z}},Ye.Parser=Oe,Ye.parser=Oe.parse,Ye.Renderer=tt,Ye.TextRenderer=ut,Ye.Lexer=he,Ye.lexer=he.lex,Ye.Tokenizer=Ve,Ye.Slugger=ht,Ye.parse=Ye;var Ct=Ye;return Ct}),define(we[75],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(R,I,S){return Math.min(Math.max(R,I),S)}e.clamp=c;function F(R,I){return(I+R%I)%I}e.rot=F;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class A{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function ie(_){const A=[];typeof _=="number"&&A.push("code/timeOrigin",_);function R(S){A.push(S,Date.now())}function I(){const S=[];for(let P=0;P<A.length;P+=2)S.push({name:A[P],startTime:A[P+1]});return S}return{mark:R,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(_+R.startTime)});return A}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function c(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=c(F))}(),define(we[34],be([0,1,3]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new c.Emitter}add(y){const n=this._icons.get(y.id);n?y.description?n.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const _=new F;e.iconRegistry=_;function A(t,y){return new I(t,y)}e.registerCodicon=A;function R(t){return t?t.replace(/\$\((.*?)\)/g,(y,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=R;class I{constructor(y,n,h){this.id=y,this.definition=n,this.description=h,_.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=I;function S(t,y){const n=["codicon","codicon-"+t];return y&&n.push("codicon-modifier-"+y),n}e.getClassNamesArray=S;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(d){if(d instanceof I)return["codicon","codicon-"+d.id];const v=y.exec(d.id);if(!v)return n(I.error);let[,C,w]=v;const a=["codicon","codicon-"+C];return w&&a.push("codicon-modifier-"+w.substr(1)),a}t.asClassNameArray=n;function h(d){return n(d).join(" ")}t.asClassName=h;function s(d){return"."+n(d).join(".")}t.asCSSSelector=s})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(I=e.Codicon||(e.Codicon={}))}),define(we[104],be([0,1,16,6]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(a){const p=a;return p?[p.on,p.pause,p.resume,p.destroy].every(k=>typeof k=="function"):!1}e.isReadableStream=_;function A(a){const p=a;return p?_(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=A;function R(a,p){return new I(a,p)}e.newWriteableStream=R;class I{constructor(p,k){this.reducer=p,this.options=k,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(k=>this.pendingWritePromises.push(k))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(k=>k(p))}emitError(p){this.listeners.error.length===0?(0,c.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(k=>k(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,k){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(k),this.resume();break;case"end":this.listeners.end.push(k),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(k),this.state.flowing&&this.flowErrors();break}}removeListener(p,k){if(this.state.destroyed)return;let i;switch(p){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const l=i.indexOf(k);l>=0&&i.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const k=[...this.pendingWritePromises];this.pendingWritePromises.length=0,k.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(a,p){const k=[];let i;for(;(i=a.read())!==null;)k.push(i);return p(k)}e.consumeReadable=S;function P(a,p,k){const i=[];let l;for(;(l=a.read())!==null&&i.length<k;)i.push(l);return l===null&&i.length>0?p(i):{read:()=>{if(i.length>0)return i.shift();if(typeof l!="undefined"){const r=l;return l=void 0,r}return a.read()}}}e.peekReadable=P;function t(a,p){return new Promise((k,i)=>{const l=[];y(a,{onData:r=>{p&&l.push(r)},onError:r=>{p?i(r):k(void 0)},onEnd:()=>{k(p?p(l):void 0)}})})}e.consumeStream=t;function y(a,p){a.on("error",k=>p.onError(k)),a.on("end",()=>p.onEnd()),a.on("data",k=>p.onData(k))}e.listenStream=y;function n(a,p){return new Promise((k,i)=>{const l=new F.DisposableStore,r=[],o=m=>{if(r.push(m),r.length>p)return l.dispose(),a.pause(),k({stream:a,buffer:r,ended:!1})},b=m=>i(m),f=()=>k({stream:a,buffer:r,ended:!0});l.add((0,F.toDisposable)(()=>a.removeListener("error",b))),a.on("error",b),l.add((0,F.toDisposable)(()=>a.removeListener("end",f))),a.on("end",f),l.add((0,F.toDisposable)(()=>a.removeListener("data",o))),a.on("data",o)})}e.peekStream=n;function h(a,p){const k=R(p);return k.end(a),k}e.toStream=h;function s(){const a=R(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=s;function d(a){let p=!1;return{read:()=>p?null:(p=!0,a)}}e.toReadable=d;function v(a,p,k){const i=R(k);return y(a,{onData:l=>i.write(p.data(l)),onError:l=>i.error(p.error?p.error(l):l),onEnd:()=>i.end()}),i}e.transform=v;function C(a,p,k){let i=!1;return{read:()=>{const l=p.read();return i?l:(i=!0,l!==null?k([a,l]):a)}}}e.prefixedReadable=C;function w(a,p,k){let i=!1;const l=R(k);return y(p,{onData:r=>i?l.write(r):(i=!0,l.write(k([a,r]))),onError:r=>l.error(r),onEnd:()=>{i||(i=!0,l.write(a)),l.end()}}),l}e.prefixedStream=w}),define(we[23],be([0,1,104]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let _,A;class R{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return F?new R(Buffer.allocUnsafe(o)):new R(new Uint8Array(o))}static wrap(o){return F&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new R(o)}static fromString(o,b){return!(b?.dontUseNodeBuffer||!1)&&F?new R(Buffer.from(o)):(_||(_=new TextEncoder),new R(_.encode(o)))}static concat(o,b){if(typeof b=="undefined"){b=0;for(let D=0,T=o.length;D<T;D++)b+=o[D].byteLength}const f=R.alloc(b);let m=0;for(let D=0,T=o.length;D<T;D++){const g=o[D];f.set(g,m),m+=g.byteLength}return f}toString(){return F?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(o,b){return new R(this.buffer.subarray(o,b))}set(o,b){o instanceof R?this.buffer.set(o.buffer,b):this.buffer.set(o,b)}readUInt32BE(o){return P(this.buffer,o)}writeUInt32BE(o,b){t(this.buffer,o,b)}readUInt32LE(o){return y(this.buffer,o)}writeUInt32LE(o,b){n(this.buffer,o,b)}readUInt8(o){return h(this.buffer,o)}writeUInt8(o,b){s(this.buffer,o,b)}}e.VSBuffer=R;function I(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0}e.readUInt16LE=I;function S(r,o,b){r[b+0]=o&255,o=o>>>8,r[b+1]=o&255}e.writeUInt16LE=S;function P(r,o){return r[o]*2**24+r[o+1]*2**16+r[o+2]*2**8+r[o+3]}e.readUInt32BE=P;function t(r,o,b){r[b+3]=o,o=o>>>8,r[b+2]=o,o=o>>>8,r[b+1]=o,o=o>>>8,r[b]=o}e.writeUInt32BE=t;function y(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0|r[o+2]<<16>>>0|r[o+3]<<24>>>0}e.readUInt32LE=y;function n(r,o,b){r[b+0]=o&255,o=o>>>8,r[b+1]=o&255,o=o>>>8,r[b+2]=o&255,o=o>>>8,r[b+3]=o&255}e.writeUInt32LE=n;function h(r,o){return r[o]}e.readUInt8=h;function s(r,o,b){r[b]=o}e.writeUInt8=s;function d(r){return c.consumeReadable(r,o=>R.concat(o))}e.readableToBuffer=d;function v(r){return c.toReadable(r)}e.bufferToReadable=v;function C(r){return c.consumeStream(r,o=>R.concat(o))}e.streamToBuffer=C;async function w(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await C(r.stream)])}e.bufferedStreamToBuffer=w;function a(r){return c.toStream(r,o=>R.concat(o))}e.bufferToStream=a;function p(r){return c.transform(r,{data:o=>typeof o=="string"?R.fromString(o):R.wrap(o)},o=>R.concat(o))}e.streamToBufferReadableStream=p;function k(r){return c.newWriteableStream(o=>R.concat(o),r)}e.newWriteableBufferStream=k;function i(r,o){return c.prefixedReadable(r,o,b=>R.concat(b))}e.prefixedBufferReadable=i;function l(r,o){return c.prefixedStream(r,o,b=>R.concat(b))}e.prefixedBufferStream=l}),define(we[35],be([0,1,9]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(F||(F={})),function(_){const A="error",R="warning",I="warn",S="info",P="ignore";function t(n){return n?c.equalsIgnoreCase(A,n)?_.Error:c.equalsIgnoreCase(R,n)||c.equalsIgnoreCase(I,n)?_.Warning:c.equalsIgnoreCase(S,n)?_.Info:_.Ignore:_.Ignore}_.fromValue=t;function y(n){switch(n){case _.Error:return A;case _.Warning:return R;case _.Info:return S;default:return P}}_.toString=y}(F||(F={})),e.default=F}),define(we[41],be([0,1,17,26,9,10]),function(ie,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function I(r){return r.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=I;function S(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function P(r,o=c.posix.sep){if(!r)return"";const b=r.length,f=r.charCodeAt(0);if(R(f)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let D=3;const T=D;for(;D<b&&!R(r.charCodeAt(D));D++);if(T!==D&&!R(r.charCodeAt(D+1))){for(D+=1;D<b;D++)if(R(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,o)}}return o}else if(C(f)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<b;m++)if(R(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=P;function t(r){if(!F.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let b=2;const f=b;for(;b<r.length&&(o=r.charCodeAt(b),o!==92);b++);return!(f===b||(o=r.charCodeAt(b+1),isNaN(o)||o===92))}e.isUNC=t;const y=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(r,o=F.isWindows){const b=o?y:n;return!(!r||r.length===0||/^\s+$/.test(r)||(b.lastIndex=0,b.test(r))||o&&h.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=s;function d(r,o,b){const f=r===o;return!b||f?f:!r||!o?!1:(0,_.equalsIgnoreCase)(r,o)}e.isEqual=d;function v(r,o,b,f=c.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(b){if(!(0,_.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let D=o.length;return o.charAt(o.length-1)===f&&D--,r.charAt(D)===f}return o.charAt(o.length-1)!==f&&(o+=f),r.indexOf(o)===0}e.isEqualOrParent=v;function C(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=C;function w(r,o){return F.isWindows&&r.endsWith(":")&&(r+=c.sep),(0,c.isAbsolute)(r)||(r=(0,c.join)(o,r)),r=(0,c.normalize)(r),F.isWindows?(r=(0,_.rtrim)(r,c.sep),r.endsWith(":")&&(r+=c.sep)):(r=(0,_.rtrim)(r,c.sep),r||(r=c.sep)),r}e.sanitizeFilePath=w;function a(r){const o=(0,c.normalize)(r);return F.isWindows?r.length>3?!1:p(o)&&(r.length===2||o.charCodeAt(2)===92):o===c.posix.sep}e.isRootOrDriveLetter=a;function p(r){return F.isWindows?C(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function k(r){return p(r)?r[0]:void 0}e.getDriveLetter=k;function i(r,o,b){return o.length>r.length?-1:r===o?0:(b&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=i;function l(r){const o=r.split(":");let b,f,m;if(o.forEach(D=>{const T=Number(D);(0,A.isNumber)(T)?f===void 0?f=T:m===void 0&&(m=T):b=b?[b,D].join(":"):D}),!b)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:b,line:f!==void 0?f:void 0,column:m!==void 0?m:f!==void 0?1:void 0}}e.parseLineAndColumnAware=l}),define(we[22],be([0,1,10]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const v=Array.isArray(d)?[]:{};return Object.keys(d).forEach(C=>{d[C]&&typeof d[C]=="object"?v[C]=F(d[C]):v[C]=d[C]}),v}e.deepClone=F;function _(d){if(!d||typeof d!="object")return d;const v=[d];for(;v.length>0;){const C=v.shift();Object.freeze(C);for(const w in C)if(A.call(C,w)){const a=C[w];typeof a=="object"&&!Object.isFrozen(a)&&v.push(a)}}return d}e.deepFreeze=_;const A=Object.prototype.hasOwnProperty;function R(d,v){return I(d,v,new Set)}e.cloneAndChange=R;function I(d,v,C){if((0,c.isUndefinedOrNull)(d))return d;const w=v(d);if(typeof w!="undefined")return w;if((0,c.isArray)(d)){const a=[];for(const p of d)a.push(I(p,v,C));return a}if((0,c.isObject)(d)){if(C.has(d))throw new Error("Cannot clone recursive data-structure");C.add(d);const a={};for(let p in d)A.call(d,p)&&(a[p]=I(d[p],v,C));return C.delete(d),a}return d}function S(d,v,C=!0){return(0,c.isObject)(d)?((0,c.isObject)(v)&&Object.keys(v).forEach(w=>{w in d?C&&((0,c.isObject)(d[w])&&(0,c.isObject)(v[w])?S(d[w],v[w],C):d[w]=v[w]):d[w]=v[w]}),d):v}e.mixin=S;function P(d,v){if(d===v)return!0;if(d==null||v===null||v===void 0||typeof d!=typeof v||typeof d!="object"||Array.isArray(d)!==Array.isArray(v))return!1;let C,w;if(Array.isArray(d)){if(d.length!==v.length)return!1;for(C=0;C<d.length;C++)if(!P(d[C],v[C]))return!1}else{const a=[];for(w in d)a.push(w);a.sort();const p=[];for(w in v)p.push(w);if(p.sort(),!P(a,p))return!1;for(C=0;C<a.length;C++)if(!P(d[a[C]],v[a[C]]))return!1}return!0}e.equals=P;function t(d){const v=new Set;return JSON.stringify(d,(C,w)=>{if((0,c.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=t;function y(d,v,C){const w=v(d);return typeof w=="undefined"?C:w}e.getOrDefault=y;function n(d,v){const C=Object.create(null);return!d||!v||Object.keys(v).forEach(a=>{const p=d[a],k=v[a];P(p,k)||(C[a]=k)}),C}e.distinct=n;function h(d,v){const C=v.toLowerCase(),w=Object.keys(d).find(a=>a.toLowerCase()===C);return w?d[w]:d[v]}e.getCaseInsensitive=h;function s(d,v){const C=Object.create(null);for(const w of Object.keys(d))v(w,d[w])&&(C[w]=d[w]);return C}e.filter=s});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[20],be([0,1,13,9,2]),function(ie,e,c,F,_){"use strict";var A,R,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(l,r,o){let b=l.get(r);return b===void 0&&(b=o,l.set(r,b)),b}e.getOrSet=S;function P(l){const r=[];return l.forEach((o,b)=>{r.push(`${b} => ${o}`)}),`Map(${l.size}) {${r.join(", ")}}`}e.mapToString=P;function t(l){const r=[];return l.forEach(o=>{r.push(o)}),`Set(${l.size}) {${r.join(", ")}}`}e.setToString=t;class y{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const o=r.charCodeAt(0),b=this._value.charCodeAt(this._pos);return o-b}value(){return this._value[this._pos]}}e.StringIterator=y;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,F.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class h{constructor(r=!0,o=!0){this._splitOnBackslash=r,this._caseSensitive=o}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,F.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var s;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(s||(s={}));class d{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,F.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class C{constructor(r){this._iter=r}static forUris(r=()=>!1){return new C(new d(r))}static forPaths(){return new C(new h)}static forStrings(){return new C(new y)}static forConfigKeys(){return new C(new n)}clear(){this._root=void 0}set(r,o){const b=this._iter.reset(r);let f;for(this._root||(this._root=new v,this._root.segment=b.value()),f=this._root;;){const D=b.cmp(f.segment);if(D>0)f.left||(f.left=new v,f.left.segment=b.value()),f=f.left;else if(D<0)f.right||(f.right=new v,f.right.segment=b.value()),f=f.right;else if(b.hasNext())b.next(),f.mid||(f.mid=new v,f.mid.segment=b.value()),f=f.mid;else break}const m=f.value;return f.value=o,f.key=r,m}fill(r,o){const b=o.slice(0);(0,c.shuffle)(b);for(let f of b)this.set(f,r)}get(r){return this._getNode(r)?.value}_getNode(r){const o=this._iter.reset(r);let b=this._root;for(;b;){const f=o.cmp(b.segment);if(f>0)b=b.left;else if(f<0)b=b.right;else if(o.hasNext())o.next(),b=b.mid;else break}return b}has(r){const o=this._getNode(r);return!(o?.value===void 0&&o?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,o){const b=this._iter.reset(r),f=[];let m=this._root;for(;m;){const D=b.cmp(m.segment);if(D>0)f.push([1,m]),m=m.left;else if(D<0)f.push([-1,m]),m=m.right;else if(b.hasNext())b.next(),f.push([0,m]),m=m.mid;else{for(o?(m.left=void 0,m.mid=void 0,m.right=void 0):m.value=void 0;f.length>0&&m.isEmpty();){let[T,g]=f.pop();switch(T){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}m=g}break}}}findSubstr(r){const o=this._iter.reset(r);let b=this._root,f;for(;b;){const m=o.cmp(b.segment);if(m>0)b=b.left;else if(m<0)b=b.right;else if(o.hasNext())o.next(),f=b.value||f,b=b.mid;else break}return b&&b.value||f}findSuperstr(r){const o=this._iter.reset(r);let b=this._root;for(;b;){const f=o.cmp(b.segment);if(f>0)b=b.left;else if(f<0)b=b.right;else if(o.hasNext())o.next(),b=b.mid;else return b.mid?this._entries(b.mid):void 0}}forEach(r){for(const[o,b]of this)r(b,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const o=[r];for(;o.length>0;){const b=o.pop();b&&(b.value&&(yield[b.key,b.value]),b.left&&o.push(b.left),b.mid&&o.push(b.mid),b.right&&o.push(b.right))}}}e.TernarySearchTree=C;class w{constructor(r,o){this[A]="ResourceMap",r instanceof w?(this.map=new Map(r.map),this.toKey=o??w.defaultToKey):(this.map=new Map,this.toKey=r??w.defaultToKey)}set(r,o){return this.map.set(this.toKey(r),o),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,o){typeof o!="undefined"&&(r=r.bind(o));for(let[b,f]of this.map)r(f,_.URI.parse(b),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield _.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[_.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[_.URI.parse(r[0]),r[1]]}}e.ResourceMap=w,w.defaultToKey=l=>l.toString();var a;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class p{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,o=0){const b=this._map.get(r);if(!!b)return o!==0&&this.touch(b,o),b.value}set(r,o,b=0){let f=this._map.get(r);if(f)f.value=o,b!==0&&this.touch(f,b);else{switch(f={key:r,value:o,next:void 0,previous:void 0},b){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(r,f),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this._map.get(r);if(!!o)return this._map.delete(r),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,o){const b=this._state;let f=this._head;for(;f;){if(o?r.bind(o)(f.value,f.key,this):r(f.value,f.key,this),this._state!==b)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,o=this._state;let b=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(b){const m={value:b.key,done:!1};return b=b.next,m}else return{value:void 0,done:!0}}};return f}values(){const r=this,o=this._state;let b=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(b){const m={value:b.value,done:!1};return b=b.next,m}else return{value:void 0,done:!0}}};return f}entries(){const r=this,o=this._state;let b=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(b){const m={value:[b.key,b.value],done:!1};return b=b.next,m}else return{value:void 0,done:!0}}};return f}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this._head,b=this.size;for(;o&&b>r;)this._map.delete(o.key),o=o.next,b--;this._head=o,this._size=b,o&&(o.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const o=r.next,b=r.previous;if(!o||!b)throw new Error("Invalid list");o.previous=b,b.next=o}r.next=void 0,r.previous=void 0,this._state++}touch(r,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this._head)return;const b=r.next,f=r.previous;r===this._tail?(f.next=void 0,this._tail=f):(b.previous=f,f.next=b),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(o===2){if(r===this._tail)return;const b=r.next,f=r.previous;r===this._head?(b.previous=void 0,this._head=b):(b.previous=f,f.next=b),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((o,b)=>{r.push([b,o])}),r}fromJSON(r){this.clear();for(const[o,b]of r)this.set(o,b)}}e.LinkedMap=p;class k extends p{constructor(r,o=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=k;class i{constructor(r){I.set(this,void 0),Je(this,I,r,"f")}get size(){return Te(this,I,"f").size}forEach(r,o){Te(this,I,"f").forEach(r,o)}get(r){return Te(this,I,"f").get(r)}has(r){return Te(this,I,"f").has(r)}entries(){return Te(this,I,"f").entries()}keys(){return Te(this,I,"f").keys()}values(){return Te(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Te(this,I,"f").entries()}}e.ReadonlyMapView=i}),define(we[105],be([0,1,20,9]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...j){return function(se,fe){for(let Ae=0,xe=j.length;Ae<xe;Ae++){const $e=j[Ae](se,fe);if($e)return $e}return null}}e.or=_,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(j,se,fe){if(!fe||fe.length<se.length)return null;let Ae;return j?Ae=F.startsWithIgnoreCase(fe,se):Ae=fe.indexOf(se)===0,Ae?se.length>0?[{start:0,end:se.length}]:[]:null}function R(j,se){const fe=se.toLowerCase().indexOf(j.toLowerCase());return fe===-1?null:[{start:fe,end:fe+j.length}]}e.matchesContiguousSubString=R;function I(j,se){return S(j.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=I;function S(j,se,fe,Ae){if(fe===j.length)return[];if(Ae===se.length)return null;if(j[fe]===se[Ae]){let xe=null;return(xe=S(j,se,fe+1,Ae+1))?C({start:Ae,end:Ae+1},xe):null}return S(j,se,fe,Ae+1)}function P(j){return 97<=j&&j<=122}function t(j){return 65<=j&&j<=90}e.isUpper=t;function y(j){return 48<=j&&j<=57}function n(j){return j===32||j===9||j===10||j===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(j=>h.add(j.charCodeAt(0)));function s(j){return n(j)||h.has(j)}function d(j,se){return j===se||s(j)&&s(se)}function v(j){return P(j)||t(j)||y(j)}function C(j,se){return se.length===0?se=[j]:j.end===se[0].start?se[0].start=j.start:se.unshift(j),se}function w(j,se){for(let fe=se;fe<j.length;fe++){const Ae=j.charCodeAt(fe);if(t(Ae)||y(Ae)||fe>0&&!v(j.charCodeAt(fe-1)))return fe}return j.length}function a(j,se,fe,Ae){if(fe===j.length)return[];if(Ae===se.length)return null;if(j[fe]!==se[Ae].toLowerCase())return null;{let xe=null,$e=Ae+1;for(xe=a(j,se,fe+1,Ae+1);!xe&&($e=w(se,$e))<se.length;)xe=a(j,se,fe+1,$e),$e++;return xe===null?null:C({start:Ae,end:Ae+1},xe)}}function p(j){let se=0,fe=0,Ae=0,xe=0,$e=0;for(let he=0;he<j.length;he++)$e=j.charCodeAt(he),t($e)&&se++,P($e)&&fe++,v($e)&&Ae++,y($e)&&xe++;const ve=se/j.length,Ze=fe/j.length,z=Ae/j.length,J=xe/j.length;return{upperPercent:ve,lowerPercent:Ze,alphaPercent:z,numericPercent:J}}function k(j){const{upperPercent:se,lowerPercent:fe}=j;return fe===0&&se>.6}function i(j){const{upperPercent:se,lowerPercent:fe,alphaPercent:Ae,numericPercent:xe}=j;return fe>.2&&se<.8&&Ae>.6&&xe<.2}function l(j){let se=0,fe=0,Ae=0,xe=0;for(let $e=0;$e<j.length;$e++)Ae=j.charCodeAt($e),t(Ae)&&se++,P(Ae)&&fe++,n(Ae)&&xe++;return(se===0||fe===0)&&xe===0?j.length<=30:se<=5}function r(j,se){if(!se||(se=se.trim(),se.length===0)||!l(j)||se.length>60)return null;const fe=p(se);if(!i(fe)){if(!k(fe))return null;se=se.toLowerCase()}let Ae=null,xe=0;for(j=j.toLowerCase();xe<se.length&&(Ae=a(j,se,0,xe))===null;)xe=w(se,xe+1);return Ae}e.matchesCamelCase=r;function o(j,se,fe=!1){if(!se||se.length===0)return null;let Ae=null,xe=0;for(j=j.toLowerCase(),se=se.toLowerCase();xe<se.length&&(Ae=b(j,se,0,xe,fe))===null;)xe=f(se,xe+1);return Ae}e.matchesWords=o;function b(j,se,fe,Ae,xe){if(fe===j.length)return[];if(Ae===se.length)return null;if(d(j.charCodeAt(fe),se.charCodeAt(Ae))){let $e=null,ve=Ae+1;if($e=b(j,se,fe+1,Ae+1,xe),!xe)for(;!$e&&(ve=f(se,ve))<se.length;)$e=b(j,se,fe+1,ve,xe),ve++;return $e===null?null:C({start:Ae,end:Ae+1},$e)}else return null}function f(j,se){for(let fe=se;fe<j.length;fe++)if(s(j.charCodeAt(fe))||fe>0&&s(j.charCodeAt(fe-1)))return fe;return j.length}const m=_(e.matchesPrefix,r,R),D=_(e.matchesPrefix,r,I),T=new c.LRUCache(1e4);function g(j,se,fe=!1){if(typeof j!="string"||typeof se!="string")return null;let Ae=T.get(j);Ae||(Ae=new RegExp(F.convertSimple2RegExpPattern(j),"i"),T.set(j,Ae));const xe=Ae.exec(se);return xe?[{start:xe.index,end:xe.index+xe[0].length}]:fe?D(j,se):m(j,se)}e.matchesFuzzy=g;function E(j,se){const fe=Qe(j,j.toLowerCase(),0,se,se.toLowerCase(),0,!0);return fe?M(fe):null}e.matchesFuzzy2=E;function u(j,se,fe,Ae,xe,$e){const ve=Math.min(13,j.length);for(;fe<ve;fe++){const Ze=Qe(j,se,fe,Ae,xe,$e,!1);if(Ze)return Ze}return[0,$e]}e.anyScore=u;function M(j){if(typeof j=="undefined")return[];const se=[],fe=j[1];for(let Ae=j.length-1;Ae>1;Ae--){const xe=j[Ae]+fe,$e=se[se.length-1];$e&&$e.end===xe?$e.end=xe+1:se.push({start:xe,end:xe+1})}return se}e.createMatches=M;const O=128;function q(){const j=[],se=[];for(let fe=0;fe<=O;fe++)se[fe]=0;for(let fe=0;fe<=O;fe++)j.push(se.slice(0));return j}function K(j){const se=[];for(let fe=0;fe<=j;fe++)se[fe]=0;return se}const $=K(2*O),W=K(2*O),N=q(),H=q(),V=q(),Y=!1;function ce(j,se,fe,Ae,xe){function $e(Ze,z,J=" "){for(;Ze.length<z;)Ze=J+Ze;return Ze}let ve=` |   |${Ae.split("").map(Ze=>$e(Ze,3)).join("|")}
`;for(let Ze=0;Ze<=fe;Ze++)Ze===0?ve+=" |":ve+=`${se[Ze-1]}|`,ve+=j[Ze].slice(0,xe+1).map(z=>$e(z.toString(),3)).join("|")+`
`;return ve}function G(j,se,fe,Ae){j=j.substr(se),fe=fe.substr(Ae),console.log(ce(H,j,j.length,fe,fe.length)),console.log(ce(V,j,j.length,fe,fe.length)),console.log(ce(N,j,j.length,fe,fe.length))}function le(j,se){if(se<0||se>=j.length)return!1;const fe=j.codePointAt(se);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(fe)}}function oe(j,se){if(se<0||se>=j.length)return!1;switch(j.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function Ee(j,se,fe){return se[j]!==fe[j]}function Fe(j,se,fe,Ae,xe,$e,ve=!1){for(;se<fe&&xe<$e;)j[se]===Ae[xe]&&(ve&&($[se]=xe),se+=1),xe+=1;return se===fe}e.isPatternInWord=Fe;var Me;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var Ne;(function(j){j.Default=[-100,0];function se(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}j.isDefault=se})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function Qe(j,se,fe,Ae,xe,$e,ve){const Ze=j.length>O?O:j.length,z=Ae.length>O?O:Ae.length;if(fe>=Ze||$e>=z||Ze-fe>z-$e||!Fe(se,fe,Ze,xe,$e,z,!0))return;ze(Ze,z,fe,$e,se,xe);let J=1,he=1,Oe=fe,Ve=$e;const tt=[!1];for(J=1,Oe=fe;Oe<Ze;J++,Oe++){const dt=$[Oe],bt=W[Oe],ft=Oe+1<Ze?W[Oe+1]:z;for(he=dt-$e+1,Ve=dt;Ve<ft;he++,Ve++){let Et=Number.MIN_SAFE_INTEGER,Ye=!1;Ve<=bt&&(Et=qe(j,se,Oe,fe,Ae,xe,Ve,z,$e,N[J-1][he-1]===0,tt));let Ct=0;Et!==Number.MAX_SAFE_INTEGER&&(Ye=!0,Ct=Et+H[J-1][he-1]);const Pe=Ve>dt,ye=Pe?H[J][he-1]+(N[J][he-1]>0?-5:0):0,De=Ve>dt+1&&N[J][he-1]>0,Z=De?H[J][he-2]+(N[J][he-2]>0?-5:0):0;if(De&&(!Pe||Z>=ye)&&(!Ye||Z>=Ct))H[J][he]=Z,V[J][he]=3,N[J][he]=0;else if(Pe&&(!Ye||ye>=Ct))H[J][he]=ye,V[J][he]=2,N[J][he]=0;else if(Ye)H[J][he]=Ct,V[J][he]=1,N[J][he]=N[J-1][he-1]+1;else throw new Error("not possible")}}if(Y&&G(j,fe,Ae,$e),!tt[0]&&!ve)return;J--,he--;const ut=[H[J][he],$e];let ht=0,St=0;for(;J>=1;){let dt=he;do{const bt=V[J][dt];if(bt===3)dt=dt-2;else if(bt===2)dt=dt-1;else break}while(dt>=1);ht>1&&se[fe+J-1]===xe[$e+he-1]&&!Ee(dt+$e-1,Ae,xe)&&ht+1>N[J][dt]&&(dt=he),dt===he?ht++:ht=1,St||(St=dt),J--,he=dt-1,ut.push(he)}z===Ze&&(ut[0]+=2);const Pt=St-Ze;return ut[0]-=Pt,ut}e.fuzzyScore=Qe;function ze(j,se,fe,Ae,xe,$e){let ve=j-1,Ze=se-1;for(;ve>=fe&&Ze>=Ae;)xe[ve]===$e[Ze]&&(W[ve]=Ze,ve--),Ze--}function qe(j,se,fe,Ae,xe,$e,ve,Ze,z,J,he){if(se[fe]!==$e[ve])return Number.MIN_SAFE_INTEGER;let Oe=1,Ve=!1;return ve===fe-Ae?Oe=j[fe]===xe[ve]?7:5:Ee(ve,xe,$e)&&(ve===0||!Ee(ve-1,xe,$e))?(Oe=j[fe]===xe[ve]?7:5,Ve=!0):le($e,ve)&&(ve===0||!le($e,ve-1))?Oe=5:(le($e,ve-1)||oe($e,ve-1))&&(Oe=5,Ve=!0),Oe>1&&fe===Ae&&(he[0]=!0),Ve||(Ve=Ee(ve,xe,$e)||le($e,ve-1)||oe($e,ve-1)),fe===Ae?ve>z&&(Oe-=Ve?3:5):J?Oe+=Ve?2:0:Oe+=Ve?0:1,ve+1===Ze&&(Oe-=Ve?3:5),Oe}function B(j,se,fe,Ae,xe,$e,ve){return ee(j,se,fe,Ae,xe,$e,!0,ve)}e.fuzzyScoreGracefulAggressive=B;function Q(j,se,fe,Ae,xe,$e,ve){return ee(j,se,fe,Ae,xe,$e,!1,ve)}e.fuzzyScoreGraceful=Q;function ee(j,se,fe,Ae,xe,$e,ve,Ze){let z=Qe(j,se,fe,Ae,xe,$e,Ze);if(z&&!ve)return z;if(j.length>=3){const J=Math.min(7,j.length-1);for(let he=fe+1;he<J;he++){const Oe=ae(j,he);if(Oe){const Ve=Qe(Oe,Oe.toLowerCase(),fe,Ae,xe,$e,Ze);Ve&&(Ve[0]-=3,(!z||Ve[0]>z[0])&&(z=Ve))}}}return z}function ae(j,se){if(se+1>=j.length)return;const fe=j[se],Ae=j[se+1];if(fe!==Ae)return j.slice(0,se)+Ae+fe+j.slice(se+2)}}),define(we[106],be([0,1,34,105,9]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${A.source}`,"g");function I(d){return d.replace(R,(v,C)=>C?v:`\\${v}`)}e.escapeIcons=I;const S=new RegExp(`\\\\${A.source}`,"g");function P(d){return d.replace(S,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=P;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function y(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(t,(v,C,w,a)=>w?v:C||a||"")}e.stripIcons=y;function n(d){const v=d.indexOf(e.iconStartMarker);return v===-1?{text:d}:h(d,v)}e.parseLabelWithIcons=n;function h(d,v){const C=[];let w="";function a(f){if(f){w+=f;for(const m of f)C.push(i)}}let p=-1,k="",i=0,l,r,o=v;const b=d.length;for(a(d.substr(0,v));o<b;)l=d[o],r=d[o+1],l===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(p=o,a(k),k=e.iconStartMarker,o++):l===")"&&p!==-1?(i+=o-p+1,p=-1,k=""):p!==-1?/^[a-z0-9\-]$/i.test(l)?k+=l:(a(k),p=-1,k=""):a(l),o++;return a(k),{text:w,iconOffsets:C}}function s(d,v,C=!1){const{text:w,iconOffsets:a}=v;if(!a||a.length===0)return(0,F.matchesFuzzy)(d,w,C);const p=(0,_.ltrim)(w," "),k=w.length-p.length,i=(0,F.matchesFuzzy)(d,p,C);if(i)for(const l of i){const r=a[l.start+k]+k;l.start+=r,l.end+=r}return i}e.matchesFuzzyIconAware=s}),define(we[76],be([0,1,16,106]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var _;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(_=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(h="",s=!1){if(this.value=h,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(h,s=0){return this.value+=P(this.supportThemeIcons?(0,F.escapeIcons)(h):h).replace(/([ \t]+)/g,(d,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,s){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=A;function R(n){return I(n)?!n.value:Array.isArray(n)?n.every(R):!0}e.isEmptyMarkdownString=R;function I(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function S(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=S;function P(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function y(n){const h=[],s=n.split("|").map(v=>v.trim());n=s[0];const d=s[1];if(d){const v=/height=(\d+)/.exec(d),C=/width=(\d+)/.exec(d),w=v?v[1]:"",a=C?C[1]:"",p=isFinite(parseInt(a)),k=isFinite(parseInt(w));p&&h.push(`width="${a}"`),k&&h.push(`height="${w}"`)}return{href:n,dimensions:h}}e.parseHrefAndDimensions=y}),define(we[54],be([0,1,23,9,2]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,S)}e.stringify=A;function R(t){let y=JSON.parse(t);return y=P(y),y}e.parse=R;var I;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function S(t,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,F.regExpFlags)(y)}:y}function P(t,y=0){if(!t||y>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return _.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof c.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=P(t[n],y+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=P(t[n],y+1))}return t}e.revive=P}),define(we[11],be([0,1,26,2]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var _;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp"})(_=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,P,t){this._hosts[S]=P,this._ports[S]=t}setConnectionToken(S,P){this._connectionTokens[S]=P}rewrite(S){if(this._delegate)return this._delegate(S);const P=S.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const y=this._ports[P],n=this._connectionTokens[P];let h=`path=${encodeURIComponent(S.path)}`;return typeof n=="string"&&(h+=`&tkn=${encodeURIComponent(n)}`),F.URI.from({scheme:c.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${t}:${y}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new A;class R{asBrowserUri(S,P){const t=this.toUri(S,P);return t.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===_.file&&(c.isNative||typeof c.globals.importScripts=="function"&&c.globals.origin===`${_.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?t.with({scheme:_.vscodeFileResource,authority:t.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(S,P){const t=this.toUri(S,P);return t.scheme===_.vscodeFileResource?t.with({scheme:_.file,authority:t.authority!==R.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(S,P){return F.URI.isUri(S)?S:F.URI.parse(P.toUrl(S))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(we[24],be([0,1,41,11,17,26,9,2]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(h){return(0,I.uriToFsPath)(h,!0)}e.originalFSPath=S;class P{constructor(s){this._ignorePathCasing=s}compare(s,d,v=!1){return s===d?0:(0,R.compare)(this.getComparisonKey(s,v),this.getComparisonKey(d,v))}isEqual(s,d,v=!1){return s===d?!0:!s||!d?!1:this.getComparisonKey(s,v)===this.getComparisonKey(d,v)}getComparisonKey(s,d=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,d,v=!1){if(s.scheme===d.scheme){if(s.scheme===F.Schemas.file)return c.isEqualOrParent(S(s),S(d),this._ignorePathCasing(s))&&s.query===d.query&&(v||s.fragment===d.fragment);if((0,e.isEqualAuthority)(s.authority,d.authority))return c.isEqualOrParent(s.path,d.path,this._ignorePathCasing(s),"/")&&s.query===d.query&&(v||s.fragment===d.fragment)}return!1}joinPath(s,...d){return I.URI.joinPath(s,...d)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return _.posix.basename(s.path)}extname(s){return _.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let d;return s.scheme===F.Schemas.file?d=I.URI.file(_.dirname(S(s))).path:(d=_.posix.dirname(s.path),s.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),d="/")),s.with({path:d})}normalizePath(s){if(!s.path.length)return s;let d;return s.scheme===F.Schemas.file?d=I.URI.file(_.normalize(S(s))).path:d=_.posix.normalize(s.path),s.with({path:d})}relativePath(s,d){if(s.scheme!==d.scheme||!(0,e.isEqualAuthority)(s.authority,d.authority))return;if(s.scheme===F.Schemas.file){const w=_.relative(S(s),S(d));return A.isWindows?c.toSlashes(w):w}let v=s.path||"/",C=d.path||"/";if(this._ignorePathCasing(s)){let w=0;for(const a=Math.min(v.length,C.length);w<a&&!(v.charCodeAt(w)!==C.charCodeAt(w)&&v.charAt(w).toLowerCase()!==C.charAt(w).toLowerCase());w++);v=C.substr(0,w)+v.substr(w)}return _.posix.relative(v,C)}resolvePath(s,d){if(s.scheme===F.Schemas.file){const v=I.URI.file(_.resolve(S(s),d));return s.with({authority:v.authority,path:v.path})}return d=c.toPosixPath(d),s.with({path:_.posix.resolve(s.path,d)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,d){return s===d||(0,R.equalsIgnoreCase)(s,d)}hasTrailingPathSeparator(s,d=_.sep){if(s.scheme===F.Schemas.file){const v=S(s);return v.length>c.getRoot(v).length&&v[v.length-1]===d}else{const v=s.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,d=_.sep){return(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,d=_.sep){let v=!1;if(s.scheme===F.Schemas.file){const C=S(s);v=C!==void 0&&C.length===c.getRoot(C).length&&C[C.length-1]===d}else{d="/";const C=s.path;v=C.length===1&&C.charCodeAt(C.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path+"/"}):s}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(h=>h.scheme===F.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new P(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(h,s){const d=[];for(let v=0;v<h.length;v++){const C=s(h[v]);h.some((w,a)=>a===v?!1:(0,e.isEqualOrParent)(C,s(w)))||d.push(h[v])}return d}e.distinctParents=t;var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function s(d){const v=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(a=>{const[p,k]=a.split(":");p&&k&&v.set(p,k)});const w=d.path.substring(0,d.path.indexOf(";"));return w&&v.set(h.META_DATA_MIME,w),v}h.parseMetaData=s})(y=e.DataUri||(e.DataUri={}));function n(h,s,d){if(s){let v=h.path;return v&&v[0]!==_.posix.sep&&(v=_.posix.sep+v),h.with({scheme:d,authority:s,path:v})}return h.with({scheme:d})}e.toLocalResource=n}),define(we[14],be([0,1,21,16,3,6,24]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(W){return!!W&&typeof W.then=="function"}e.isThenable=I;function S(W){const N=new c.CancellationTokenSource,H=W(N.token),V=new Promise((Y,ce)=>{const G=N.token.onCancellationRequested(()=>{G.dispose(),N.dispose(),ce((0,F.canceled)())});Promise.resolve(H).then(le=>{G.dispose(),N.dispose(),Y(le)},le=>{G.dispose(),N.dispose(),ce(le)})});return new class{cancel(){N.cancel()}then(Y,ce){return V.then(Y,ce)}catch(Y){return this.then(void 0,Y)}finally(Y){return V.finally(Y)}}}e.createCancelablePromise=S;function P(W,N,H){return Promise.race([W,new Promise(V=>N.onCancellationRequested(()=>V(H)))])}e.raceCancellation=P;async function t(W){let N=-1;const H=W.map((Y,ce)=>Y.then(G=>(N=ce,G))),V=await Promise.race(H);return W.forEach((Y,ce)=>{ce!==N&&Y.cancel()}),V}e.raceCancellablePromises=t;function y(W,N,H){let V;const Y=setTimeout(()=>{V?.(void 0),H?.()},N);return Promise.race([W.finally(()=>clearTimeout(Y)),new Promise(ce=>V=ce)])}e.raceTimeout=y;function n(W){return new Promise((N,H)=>{const V=W();I(V)?V.then(N,H):N(V)})}e.asPromise=n;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(H,H).then(V)})}return new Promise((H,V)=>{this.queuedPromise.then(H,V)})}return this.activePromise=N(),new Promise((H,V)=>{this.activePromise.then(Y=>{this.activePromise=null,H(Y)},Y=>{this.activePromise=null,V(Y)})})}}e.Throttler=h;class s{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=s;class d{constructor(){this.promiseMap=new Map}queue(N,H){const Y=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(N)===Y&&this.promiseMap.delete(N)});return this.promiseMap.set(N,Y),Y}}e.SequencerByKey=d;class v{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,H=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,Y)=>{this.doResolve=V,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=v;class C{constructor(N){this.delayer=new v(N),this.throttler=new h}trigger(N,H){return this.delayer.trigger(()=>this.throttler.queue(N),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=C;class w{constructor(){this._isOpen=!1,this._promise=new Promise((N,H)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;class a extends w{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function p(W,N){return N?new Promise((H,V)=>{const Y=setTimeout(()=>{ce.dispose(),H()},W),ce=N.onCancellationRequested(()=>{clearTimeout(Y),ce.dispose(),V((0,F.canceled)())})}):S(H=>p(W,H))}e.timeout=p;function k(W,N=0){const H=setTimeout(W,N);return(0,A.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=k;function i(W){const N=[];let H=0;const V=W.length;function Y(){return H<V?W[H++]():null}function ce(G){G!=null&&N.push(G);const le=Y();return le?le.then(ce):Promise.resolve(N)}return Promise.resolve(null).then(ce)}e.sequence=i;function l(W,N=V=>!!V,H=null){let V=0;const Y=W.length,ce=()=>{if(V>=Y)return Promise.resolve(H);const G=W[V++];return Promise.resolve(G()).then(oe=>N(oe)?Promise.resolve(oe):ce())};return ce()}e.first=l;function r(W,N=V=>!!V,H=null){if(W.length===0)return Promise.resolve(H);let V=W.length;const Y=()=>{V=-1;for(const ce of W)ce.cancel?.()};return new Promise((ce,G)=>{for(const le of W)le.then(oe=>{--V>=0&&N(oe)?(Y(),ce(oe)):V===0&&ce(H)}).catch(oe=>{--V>=0&&(Y(),G(oe))})})}e.firstParallel=r;class o{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new _.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((H,V)=>{this.outstandingPromises.push({factory:N,c:H,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const H=N.factory();H.then(N.c,N.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class b extends o{constructor(){super(1)}}e.Queue=b;class f{constructor(){this.queues=new Map}queueFor(N,H=R.extUri){const V=H.getComparisonKey(N);let Y=this.queues.get(V);return Y||(Y=new b,_.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(V)}),this.queues.set(V,Y)),Y}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=f;class m{constructor(N,H){this._token=-1,typeof N=="function"&&typeof H=="number"&&this.setIfNotSet(N,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},H)}setIfNotSet(N,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},H))}}e.TimeoutTimer=m;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,H){this.cancel(),this._token=setInterval(()=>{N()},H)}}e.IntervalTimer=D;class T{constructor(N,H){this.timeoutToken=-1,this.runner=N,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class g extends T{constructor(N,H){super(N,H);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=g;class E extends A.Disposable{constructor(N,H,V,Y){super();this.maxWorkChunkSize=N,this.maxPendingWork=H,this.throttleDelay=V,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.maxPendingWork)return!1}else if(this.pending+N.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=E,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const H=setTimeout(()=>N(W));let V=!1;return{dispose(){V||(V=!0,clearTimeout(H))}}}}else e.runWhenIdle=(W,N)=>{const H=requestIdleCallback(W,typeof N=="number"?{timeout:N}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(H))}}}}();class u{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=u;async function M(W,N,H){let V;for(let Y=0;Y<H;Y++)try{return await W()}catch(ce){V=ce,await p(N)}throw V}e.retry=M;class O{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,H,V){return this._pending={taskId:N,cancel:()=>V?.(),promise:H},H.then(()=>this.donePending(N),()=>this.donePending(N)),H}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let H,V;const Y=new Promise((ce,G)=>{H=ce,V=G});this._next={run:N,promise:Y,promiseResolve:H,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=O;class q{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,H)=>{this.completeCallback=N,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(H=>{this.completeCallback(N),this.resolved=!0,H()})}error(N){return new Promise(H=>{this.errorCallback(N),this.rejected=!0,H()})}cancel(){new Promise(N=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=K;var $;(function(W){async function N(H){let V;const Y=await Promise.all(H.map(ce=>ce.then(G=>G,G=>{V||(V=G)})));if(typeof V!="undefined")throw V;return Y}W.settled=N})($=e.Promises||(e.Promises={}))}),define(we[107],be([0,1,14,17]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new c.IdleValue(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),A=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(T,g,E=!1){const u=T||"",M=g||"",O=_.value.collator.compare(u,M);return _.value.collatorIsNumeric&&O===0&&u!==M?u<M?-1:1:O}e.compareFileNames=I;function S(T,g){const E=A.value.collator;return T=T||"",g=g||"",k(E,T,g)}e.compareFileNamesDefault=S;function P(T,g){const E=A.value.collator;return T=T||"",g=g||"",o(T,g)||k(E,T,g)}e.compareFileNamesUpper=P;function t(T,g){const E=A.value.collator;return T=T||"",g=g||"",r(T,g)||k(E,T,g)}e.compareFileNamesLower=t;function y(T,g){return T=T||"",g=g||"",T===g?0:T<g?-1:1}e.compareFileNamesUnicode=y;function n(T,g,E=!1){E||(T=T&&T.toLowerCase(),g=g&&g.toLowerCase());const[u,M]=a(T),[O,q]=a(g);return u!==O?u<O?-1:1:M===q?0:M<q?-1:1}e.noIntlCompareFileNames=n;function h(T,g){const[E,u]=a(T),[M,O]=a(g);let q=_.value.collator.compare(u,O);if(q===0){if(_.value.collatorIsNumeric&&u!==O)return u<O?-1:1;if(q=_.value.collator.compare(E,M),_.value.collatorIsNumeric&&q===0&&E!==M)return E<M?-1:1}return q}e.compareFileExtensions=h;function s(T,g){T=T||"",g=g||"";const E=p(T),u=p(g),M=A.value.collator,O=R.value.collator;return k(O,E,u)||k(M,T,g)}e.compareFileExtensionsDefault=s;function d(T,g){T=T||"",g=g||"";const E=p(T),u=p(g),M=A.value.collator,O=R.value.collator;return k(O,E,u)||o(T,g)||k(M,T,g)}e.compareFileExtensionsUpper=d;function v(T,g){T=T||"",g=g||"";const E=p(T),u=p(g),M=A.value.collator,O=R.value.collator;return k(O,E,u)||r(T,g)||k(M,T,g)}e.compareFileExtensionsLower=v;function C(T,g){T=T||"",g=g||"";const E=p(T).toLowerCase(),u=p(g).toLowerCase();return E!==u?E<u?-1:1:T!==g?T<g?-1:1:0}e.compareFileExtensionsUnicode=C;const w=/^(.*?)(\.([^.]*))?$/;function a(T,g=!1){const E=T?w.exec(T):[];let u=[E&&E[1]||"",E&&E[3]||""];return g&&(!u[0]&&u[1]||u[0]&&u[0].charAt(0)===".")&&(u=[u[0]+"."+u[1],""]),u}function p(T){const g=T?w.exec(T):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function k(T,g,E){let u=T.compare(g,E);return u!==0?u:g.length!==E.length?g.length<E.length?-1:1:0}function i(T){const g=T.charAt(0);return g.toLocaleUpperCase()!==g}function l(T){const g=T.charAt(0);return g.toLocaleLowerCase()!==g}function r(T,g){return i(T)&&l(g)?-1:l(T)&&i(g)?1:0}function o(T,g){return l(T)&&i(g)?-1:i(T)&&l(g)?1:0}function b(T,g,E=!1){return E||(T=T&&T.toLowerCase(),g=g&&g.toLowerCase()),T===g?0:T<g?-1:1}function f(T,g,E=!1){const u=T.split(F.sep),M=g.split(F.sep),O=u.length-1,q=M.length-1;let K,$;for(let W=0;;W++){if(K=O===W,$=q===W,K&&$)return I(u[W],M[W],E);if(K)return-1;if($)return 1;const N=b(u[W],M[W],E);if(N!==0)return N}}e.comparePaths=f;function m(T,g,E){const u=T.toLowerCase(),M=g.toLowerCase(),O=D(T,g,E);if(O)return O;const q=u.endsWith(E),K=M.endsWith(E);if(q!==K)return q?-1:1;const $=I(u,M);return $!==0?$:u.localeCompare(M)}e.compareAnything=m;function D(T,g,E){const u=T.toLowerCase(),M=g.toLowerCase(),O=u.startsWith(E),q=M.startsWith(E);if(O!==q)return O?-1:1;if(O&&q){if(u.length<M.length)return-1;if(u.length>M.length)return 1}return 0}e.compareByPrefix=D}),define(we[27],be([0,1,14,41,20,17,9]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const S="**",P="/",t="[/\\\\]",y="[^/\\\\]",n=/\//g;function h(Y){switch(Y){case 0:return"";case 1:return`${y}*?`;default:return`(?:${t}|${y}+${t}|${t}${y}+)*?`}}function s(Y,ce){if(!Y)return[];const G=[];let le=!1,oe=!1,Ee="";for(const Fe of Y){switch(Fe){case ce:if(!le&&!oe){G.push(Ee),Ee="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}Ee+=Fe}return Ee&&G.push(Ee),G}e.splitGlobAware=s;function d(Y){if(!Y)return"";let ce="";const G=s(Y,P);if(G.every(le=>le===S))ce=".*";else{let le=!1;G.forEach((oe,Ee)=>{if(oe===S){le||(ce+=h(2),le=!0);return}let Fe=!1,Me="",Ne=!1,Qe="";for(const ze of oe){if(ze!=="}"&&Fe){Me+=ze;continue}if(Ne&&(ze!=="]"||!Qe)){let qe;ze==="-"?qe=ze:(ze==="^"||ze==="!")&&!Qe?qe="^":ze===P?qe="":qe=R.escapeRegExpCharacters(ze),Qe+=qe;continue}switch(ze){case"{":Fe=!0;continue;case"[":Ne=!0;continue;case"}":ce+=`(?:${s(Me,",").map(Q=>d(Q)).join("|")})`,Fe=!1,Me="";break;case"]":ce+="["+Qe+"]",Ne=!1,Qe="";break;case"?":ce+=y;continue;case"*":ce+=h(1);continue;default:ce+=R.escapeRegExpCharacters(ze)}}Ee<G.length-1&&(G[Ee+1]!==S||Ee+2<G.length)&&(ce+=t),le=!1})}return ce}const v=/^\*\*\/\*\.[\w\.-]+$/,C=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new _.LRUCache(1e4),l=function(){return!1},r=function(){return null};function o(Y,ce){if(!Y)return r;let G;typeof Y!="string"?G=Y.pattern:G=Y,G=G.trim();const le=`${G}_${!!ce.trimForExclusions}`;let oe=i.get(le);if(oe)return b(oe,Y);let Ee;if(v.test(G)){const Fe=G.substr(4);oe=function(Me,Ne){return typeof Me=="string"&&Me.endsWith(Fe)?G:null}}else(Ee=C.exec(f(G,ce)))?oe=m(Ee[1],G):(ce.trimForExclusions?a:w).test(G)?oe=D(G,ce):(Ee=p.exec(f(G,ce)))?oe=T(Ee[1].substr(1),G,!0):(Ee=k.exec(f(G,ce)))?oe=T(Ee[1],G,!1):oe=g(G);return i.set(le,oe),b(oe,Y)}function b(Y,ce){return typeof ce=="string"?Y:function(G,le){return F.isEqualOrParent(G,ce.base)?Y(A.relative(ce.base,G),le):null}}function f(Y,ce){return ce.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function m(Y,ce){const G=`/${Y}`,le=`\\${Y}`,oe=function(Fe,Me){return typeof Fe!="string"?null:Me?Me===Y?ce:null:Fe===Y||Fe.endsWith(G)||Fe.endsWith(le)?ce:null},Ee=[Y];return oe.basenames=Ee,oe.patterns=[ce],oe.allBasenames=Ee,oe}function D(Y,ce){const G=V(Y.slice(1,-1).split(",").map(Me=>o(Me,ce)).filter(Me=>Me!==r),Y),le=G.length;if(!le)return r;if(le===1)return G[0];const oe=function(Me,Ne){for(let Qe=0,ze=G.length;Qe<ze;Qe++)if(G[Qe](Me,Ne))return Y;return null},Ee=G.find(Me=>!!Me.allBasenames);Ee&&(oe.allBasenames=Ee.allBasenames);const Fe=G.reduce((Me,Ne)=>Ne.allPaths?Me.concat(Ne.allPaths):Me,[]);return Fe.length&&(oe.allPaths=Fe),oe}function T(Y,ce,G){const le=A.sep===A.posix.sep,oe=le?Y:Y.replace(n,A.sep),Ee=A.sep+oe,Fe=A.posix.sep+Y,Me=G?function(Ne,Qe){return typeof Ne=="string"&&(Ne===oe||Ne.endsWith(Ee)||!le&&(Ne===Y||Ne.endsWith(Fe)))?ce:null}:function(Ne,Qe){return typeof Ne=="string"&&(Ne===oe||!le&&Ne===Y)?ce:null};return Me.allPaths=[(G?"*/":"./")+Y],Me}function g(Y){try{const ce=new RegExp(`^${d(Y)}$`);return function(G){return ce.lastIndex=0,typeof G=="string"&&ce.test(G)?Y:null}}catch(ce){return r}}function E(Y,ce,G){return!Y||typeof ce!="string"?!1:u(Y)(ce,void 0,G)}e.match=E;function u(Y,ce={}){if(!Y)return l;if(typeof Y=="string"||K(Y)){const G=o(Y,ce);if(G===r)return l;const le=function(oe,Ee){return!!G(oe,Ee)};return G.allBasenames&&(le.allBasenames=G.allBasenames),G.allPaths&&(le.allPaths=G.allPaths),le}return N(Y,ce)}e.parse=u;function M(Y){if(!Y)return;let ce;return G=>(ce||(ce=(Y()||Promise.resolve([])).then(le=>le?q(le):{})),ce.then(le=>!!le[G]))}e.hasSiblingPromiseFn=M;function O(Y){if(!Y)return;let ce;return G=>{if(!ce){const le=Y();ce=le?q(le):{}}return!!ce[G]}}e.hasSiblingFn=O;function q(Y){const ce={};for(const G of Y)ce[G]=!0;return ce}function K(Y){const ce=Y;return ce&&typeof ce.base=="string"&&typeof ce.pattern=="string"}e.isRelativePattern=K;function $(Y){return Y.allBasenames||[]}e.getBasenameTerms=$;function W(Y){return Y.allPaths||[]}e.getPathTerms=W;function N(Y,ce){const G=V(Object.getOwnPropertyNames(Y).map(Me=>H(Me,Y[Me],ce)).filter(Me=>Me!==r)),le=G.length;if(!le)return r;if(!G.some(Me=>!!Me.requiresSiblings)){if(le===1)return G[0];const Me=function(ze,qe){for(let B=0,Q=G.length;B<Q;B++){const ee=G[B](ze,qe);if(ee)return ee}return null},Ne=G.find(ze=>!!ze.allBasenames);Ne&&(Me.allBasenames=Ne.allBasenames);const Qe=G.reduce((ze,qe)=>qe.allPaths?ze.concat(qe.allPaths):ze,[]);return Qe.length&&(Me.allPaths=Qe),Me}const oe=function(Me,Ne,Qe){let ze;for(let qe=0,B=G.length;qe<B;qe++){const Q=G[qe];Q.requiresSiblings&&Qe&&(Ne||(Ne=A.basename(Me)),ze||(ze=Ne.substr(0,Ne.length-A.extname(Me).length)));const ee=Q(Me,Ne,ze,Qe);if(ee)return ee}return null},Ee=G.find(Me=>!!Me.allBasenames);Ee&&(oe.allBasenames=Ee.allBasenames);const Fe=G.reduce((Me,Ne)=>Ne.allPaths?Me.concat(Ne.allPaths):Me,[]);return Fe.length&&(oe.allPaths=Fe),oe}function H(Y,ce,G){if(ce===!1)return r;const le=o(Y,G);if(le===r)return r;if(typeof ce=="boolean")return le;if(ce){const oe=ce.when;if(typeof oe=="string"){const Ee=(Fe,Me,Ne,Qe)=>{if(!Qe||!le(Fe,Me))return null;const ze=oe.replace("$(basename)",Ne),qe=Qe(ze);return(0,c.isThenable)(qe)?qe.then(B=>B?Y:null):qe?Y:null};return Ee.requiresSiblings=!0,Ee}}return le}function V(Y,ce){const G=Y.filter(Me=>!!Me.basenames);if(G.length<2)return Y;const le=G.reduce((Me,Ne)=>{const Qe=Ne.basenames;return Qe?Me.concat(Qe):Me},[]);let oe;if(ce){oe=[];for(let Me=0,Ne=le.length;Me<Ne;Me++)oe.push(ce)}else oe=G.reduce((Me,Ne)=>{const Qe=Ne.patterns;return Qe?Me.concat(Qe):Me},[]);const Ee=function(Me,Ne){if(typeof Me!="string")return null;if(!Ne){let ze;for(ze=Me.length;ze>0;ze--){const qe=Me.charCodeAt(ze-1);if(qe===47||qe===92)break}Ne=Me.substr(ze)}const Qe=le.indexOf(Ne);return Qe!==-1?oe[Qe]:null};Ee.basenames=le,Ee.patterns=oe,Ee.allBasenames=le;const Fe=Y.filter(Me=>!Me.basenames);return Fe.push(Ee),Fe}}),define(we[77],be([0,1,41,11,17,26,24,9,2]),function(ie,e,c,F,_,A,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(o,b,f){if(typeof o=="string"&&(o=S.URI.file(o)),f){const D=f.getWorkspaceFolder(o);if(D){const T=f.getWorkspace().folders.length>1;let g;if((0,R.isEqual)(D.uri,o)?g="":g=(0,R.relativePath)(D.uri,o),T){const E=D.name?D.name:(0,R.basename)(D.uri);g=g?E+" \u2022 "+g:E}return g}}if(o.scheme!==F.Schemas.file&&o.scheme!==F.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(o.fsPath))return(0,_.normalize)(y(o.fsPath));let m=(0,_.normalize)(o.fsPath);return!A.isWindows&&b?.userHome&&(m=h(m,b.userHome.fsPath)),m}e.getPathLabel=P;function t(o){if(!o)return;typeof o=="string"&&(o=S.URI.file(o));const b=(0,R.basename)(o)||(o.scheme===F.Schemas.file?o.fsPath:o.path);return A.isWindows&&(0,c.isRootOrDriveLetter)(b)?y(b):b}e.getBaseLabel=t;function y(o){return(0,c.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=y;let n=Object.create(null);function h(o,b){if(A.isWindows||!o||!b)return o;let f=n.original===b?n.normalized:void 0;return f||(f=`${(0,I.rtrim)(b,_.posix.sep)}${_.posix.sep}`,n={original:b,normalized:f}),(A.isLinux?o.startsWith(f):(0,I.startsWithIgnoreCase)(o,f))&&(o=`~/${o.substr(f.length)}`),o}e.tildify=h;function s(o,b){return o.replace(/^~($|\/|\\)/,`${b}$1`)}e.untildify=s;const d="\u2026",v="\\\\",C="~";function w(o,b=_.sep){const f=new Array(o.length);let m=!1;for(let D=0;D<o.length;D++){let T=o[D];if(T===""){f[D]=`.${b}`;continue}if(!T){f[D]=T;continue}m=!0;let g="";T.indexOf(v)===0?(g=T.substr(0,T.indexOf(v)+v.length),T=T.substr(T.indexOf(v)+v.length)):T.indexOf(b)===0?(g=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length)):T.indexOf(C)===0&&(g=T.substr(0,T.indexOf(C)+C.length),T=T.substr(T.indexOf(C)+C.length));const E=T.split(b);for(let u=1;m&&u<=E.length;u++)for(let M=E.length-u;m&&M>=0;M--){m=!1;let O=E.slice(M,M+u).join(b);for(let q=0;!m&&q<o.length;q++)if(q!==D&&o[q]&&o[q].indexOf(O)>-1){const K=M+u===E.length,$=M>0&&o[q].indexOf(b)>-1?b+O:O,W=o[q].endsWith($);m=!K||W}if(!m){let q="";(E[0].endsWith(":")||g!=="")&&(M===1&&(M=0,u++,O=E[0]+b+O),M>0&&(q=E[0]+b),q=g+q),M>0&&(q=q+d+b),q=q+O,M+u<E.length&&(q=q+b+d),f[D]=q}}m&&(f[D]=T)}return f}e.shorten=w;var a;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function p(o,b=Object.create(null)){const f=[];let m=!1,D="";for(const T of o)if(T==="$"||m&&T==="{")D&&f.push({value:D,type:a.TEXT}),D="",m=!0;else if(T==="}"&&m){const g=b[D];if(typeof g=="string")g.length&&f.push({value:g,type:a.VARIABLE});else if(g){const E=f[f.length-1];(!E||E.type!==a.SEPARATOR)&&f.push({value:g.label,type:a.SEPARATOR})}D="",m=!1}else D+=T;return D&&!m&&f.push({value:D,type:a.TEXT}),f.filter((T,g)=>{if(T.type===a.SEPARATOR){const E=f[g-1],u=f[g+1];return[E,u].every(M=>M&&(M.type===a.VARIABLE||M.type===a.TEXT)&&M.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=p;function k(o,b){return A.isMacintosh||b?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):o.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=k;function i(o,b){return A.isMacintosh||b?o.replace(/\(&&\w\)|&&/g,""):A.isWindows?o.replace(/&&|&/g,f=>f==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function l(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=l;function r(o){const b=o.indexOf("/")!==-1?_.posix:_.win32,f=b.basename(o),m=b.dirname(o);return f.length?{name:f,parentPath:m}:{name:m,parentPath:""}}e.splitName=r}),define(we[78],be([0,1,27,11,17,24,9]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var I;(function(o){o.text="text/plain",o.binary="application/octet-stream",o.unknown="application/unknown",o.markdown="text/markdown"})(I=e.Mimes||(e.Mimes={}));let S=[],P=[],t=[];function y(o,b=!1){const f=n(o);S.push(f),f.userConfigured?t.push(f):P.push(f),b&&!f.userConfigured&&S.forEach(m=>{m.mime===f.mime||m.userConfigured||(f.extension&&m.extension===f.extension&&console.warn(`Overwriting extension <<${f.extension}>> to now point to mime <<${f.mime}>>`),f.filename&&m.filename===f.filename&&console.warn(`Overwriting filename <<${f.filename}>> to now point to mime <<${f.mime}>>`),f.filepattern&&m.filepattern===f.filepattern&&console.warn(`Overwriting filepattern <<${f.filepattern}>> to now point to mime <<${f.mime}>>`),f.firstline&&m.firstline===f.firstline&&console.warn(`Overwriting firstline <<${f.firstline}>> to now point to mime <<${f.mime}>>`))})}e.registerTextMime=y;function n(o){return{id:o.id,mime:o.mime,filename:o.filename,extension:o.extension,filepattern:o.filepattern,firstline:o.firstline,userConfigured:o.userConfigured,filenameLowercase:o.filename?o.filename.toLowerCase():void 0,extensionLowercase:o.extension?o.extension.toLowerCase():void 0,filepatternLowercase:o.filepattern?(0,c.parse)(o.filepattern.toLowerCase()):void 0,filepatternOnPath:o.filepattern?o.filepattern.indexOf(_.posix.sep)>=0:!1}}function h(o){o?(S=S.filter(b=>!b.userConfigured),t=[]):(S=[],P=[],t=[])}e.clearTextMimes=h;function s(o,b){let f;if(o)switch(o.scheme){case F.Schemas.file:f=o.fsPath;break;case F.Schemas.data:f=A.DataUri.parseMetaData(o).get(A.DataUri.META_DATA_LABEL);break;default:f=o.path}if(!f)return[I.unknown];f=f.toLowerCase();const m=(0,_.basename)(f),D=d(f,m,t);if(D)return[D,I.text];const T=d(f,m,P);if(T)return[T,I.text];if(b){const g=v(b);if(g)return[g,I.text]}return[I.unknown]}e.guessMimeTypes=s;function d(o,b,f){let m=null,D=null,T=null;for(let g=f.length-1;g>=0;g--){const E=f[g];if(b===E.filenameLowercase){m=E;break}if(E.filepattern&&(!D||E.filepattern.length>D.filepattern.length)){const u=E.filepatternOnPath?o:b;E.filepatternLowercase?.(u)&&(D=E)}E.extension&&(!T||E.extension.length>T.extension.length)&&b.endsWith(E.extensionLowercase)&&(T=E)}return m?m.mime:D?D.mime:T?T.mime:null}function v(o){if((0,R.startsWithUTF8BOM)(o)&&(o=o.substr(1)),o.length>0)for(let b=S.length-1;b>=0;b--){const f=S[b];if(!f.firstline)continue;const m=o.match(f.firstline);if(m&&m.length>0)return f.mime}return null}function C(o){return o?typeof o=="string"?o===I.binary||o===I.text||o===I.unknown:o.length===1&&C(o[0]):!0}e.isUnspecific=C;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function p(o){const b=(0,_.extname)(o),f=w[b.toLowerCase()];return f!==void 0?f:k(o)}e.getMediaOrTextMime=p;function k(o){const b=(0,_.extname)(o);return a[b.toLowerCase()]}e.getMediaMime=k;function i(o){for(const b in a)if(a[b]===o)return b}e.getExtensionForMimeType=i;const l=/^(.+)\/(.+?)(;.+)?$/;function r(o,b){const f=l.exec(o);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:b?void 0:o}e.normalizeMimeType=r}),define(we[108],be([0,1,2]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(t){return t.toJSON()}class _{constructor(y){this._uriTransformer=y}transformIncoming(y){const n=this._uriTransformer.transformIncoming(y);return n===y?y:F(c.URI.from(n))}transformOutgoing(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:F(c.URI.from(n))}transformOutgoingURI(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:c.URI.from(n)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,y,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof c.URI)return y.transformOutgoing(t);for(let h in t)if(Object.hasOwnProperty.call(t,h)){const s=A(t[h],y,n+1);s!==null&&(t[h]=s)}}return null}function R(t,y){const n=A(t,y,0);return n===null?t:n}e.transformOutgoingURIs=R;function I(t,y,n,h){if(!t||h>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?c.URI.revive(y.transformIncoming(t)):y.transformIncoming(t);for(let s in t)if(Object.hasOwnProperty.call(t,s)){const d=I(t[s],y,n,h+1);d!==null&&(t[s]=d)}}return null}function S(t,y){const n=I(t,y,!1,0);return n===null?t:n}e.transformIncomingURIs=S;function P(t,y){const n=I(t,y,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=P}),define(we[36],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(S){return c.test(S)}e.isUUID=F;const _=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(S){for(let P=0;P<S.length;P++)S[P]=Math.floor(Math.random()*256);return S};function I(){R(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let S=0,P="";return P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P+="-",P+=A[_[S++]],P+=A[_[S++]],P+="-",P+=A[_[S++]],P+=A[_[S++]],P+="-",P+=A[_[S++]],P+=A[_[S++]],P+="-",P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P}e.generateUuid=I}),define(we[109],be([0,1,226]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class _ extends c.CharacterClassifier{constructor(I){super(0);for(let S=0,P=I.length;S<P;S++)this.set(I.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=_;function A(R){let I={};return S=>(I.hasOwnProperty(S)||(I[S]=R(S)),I[S])}e.getMapForWordSeparators=A(R=>new _(R))}),define(we[79],be([0,1,22]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var F;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(F=e.OverviewRulerLane||(e.OverviewRulerLane={}));var _;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(_=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var I;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(I=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class P{constructor(v,C){this._findMatchBrand=void 0,this.range=v,this.matches=C}}e.FindMatch=P;var t;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var y;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right",d[d.None=2]="None"})(y=e.PositionAffinity||(e.PositionAffinity={}));var n;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(n=e.ModelConstants||(e.ModelConstants={}));class h{constructor(v,C,w,a,p,k){this.identifier=v,this.range=C,this.text=w,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=p,this._isTracked=k}}e.ValidAnnotatedEditOperation=h;class s{constructor(v,C,w){this.reverseEdits=v,this.changes=C,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=s}),define(we[110],be([0,1,9,109,111,42,79]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class S{constructor(a,p,k,i){this.searchString=a,this.isRegex=p,this.matchCase=k,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=P(this.searchString):a=this.searchString.indexOf(`
`)>=0;let p=null;try{p=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(i){return null}if(!p)return null;let k=!this.isRegex&&!a;return k&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(k=this.matchCase),new t(p,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,k?this.searchString:null)}}e.SearchParams=S;function P(w){if(!w||w.length===0)return!1;for(let a=0,p=w.length;a<p;a++)if(w.charCodeAt(a)===92){if(a++,a>=p)break;const i=w.charCodeAt(a);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(a,p,k){this.regex=a,this.wordSeparators=p,this.simpleSearch=k}}e.SearchData=t;function y(w,a,p){if(!p)return new R.FindMatch(w,null);let k=[];for(let i=0,l=a.length;i<l;i++)k[i]=a[i];return new R.FindMatch(w,k)}e.createFindMatch=y;class n{constructor(a){let p=[],k=0;for(let i=0,l=a.length;i<l;i++)a.charCodeAt(i)===10&&(p[k++]=i);this._lineFeedsOffsets=p}findLineFeedCountBeforeOffset(a){const p=this._lineFeedsOffsets;let k=0,i=p.length-1;if(i===-1||a<=p[0])return 0;for(;k<i;){const l=k+((i-k)/2>>0);p[l]>=a?i=l-1:p[l+1]>=a?(k=l,i=l):k=l+1}return k+1}}class h{static findMatches(a,p,k,i,l){const r=p.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(a,k,new C(r.wordSeparators,r.regex),i,l):this._doFindMatchesLineByLine(a,k,r,i,l):[]}static _getMultilineMatchRange(a,p,k,i,l,r){let o,b=0;i?(b=i.findLineFeedCountBeforeOffset(l),o=p+l+b):o=p+l;let f;if(i){let g=i.findLineFeedCountBeforeOffset(l+r.length)-b;f=o+r.length+g}else f=o+r.length;const m=a.getPositionAt(o),D=a.getPositionAt(f);return new A.Range(m.lineNumber,m.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(a,p,k,i,l){const r=a.getOffsetAt(p.getStartPosition()),o=a.getValueInRange(p,1),b=a.getEOL()===`\r
`?new n(o):null,f=[];let m=0,D;for(k.reset(0);D=k.next(o);)if(f[m++]=y(this._getMultilineMatchRange(a,r,o,b,D.index,D[0]),D,i),m>=l)return f;return f}static _doFindMatchesLineByLine(a,p,k,i,l){const r=[];let o=0;if(p.startLineNumber===p.endLineNumber){const f=a.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return o=this._findMatchesInLine(k,f,p.startLineNumber,p.startColumn-1,o,r,i,l),r}const b=a.getLineContent(p.startLineNumber).substring(p.startColumn-1);o=this._findMatchesInLine(k,b,p.startLineNumber,p.startColumn-1,o,r,i,l);for(let f=p.startLineNumber+1;f<p.endLineNumber&&o<l;f++)o=this._findMatchesInLine(k,a.getLineContent(f),f,0,o,r,i,l);if(o<l){const f=a.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);o=this._findMatchesInLine(k,f,p.endLineNumber,0,o,r,i,l)}return r}static _findMatchesInLine(a,p,k,i,l,r,o,b){const f=a.wordSeparators;if(!o&&a.simpleSearch){const T=a.simpleSearch,g=T.length,E=p.length;let u=-g;for(;(u=p.indexOf(T,u+g))!==-1;)if((!f||v(f,p,E,u,g))&&(r[l++]=new R.FindMatch(new A.Range(k,u+1+i,k,u+1+g+i),null),l>=b))return l;return l}const m=new C(a.wordSeparators,a.regex);let D;m.reset(0);do if(D=m.next(p),D&&(r[l++]=y(new A.Range(k,D.index+1+i,k,D.index+1+D[0].length+i),D,o),l>=b))return l;while(D);return l}static findNextMatch(a,p,k,i){const l=p.parseSearchRequest();if(!l)return null;const r=new C(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindNextMatchMultiline(a,k,r,i):this._doFindNextMatchLineByLine(a,k,r,i)}static _doFindNextMatchMultiline(a,p,k,i){const l=new _.Position(p.lineNumber,1),r=a.getOffsetAt(l),o=a.getLineCount(),b=a.getValueInRange(new A.Range(l.lineNumber,l.column,o,a.getLineMaxColumn(o)),1),f=a.getEOL()===`\r
`?new n(b):null;k.reset(p.column-1);let m=k.next(b);return m?y(this._getMultilineMatchRange(a,r,b,f,m.index,m[0]),m,i):p.lineNumber!==1||p.column!==1?this._doFindNextMatchMultiline(a,new _.Position(1,1),k,i):null}static _doFindNextMatchLineByLine(a,p,k,i){const l=a.getLineCount(),r=p.lineNumber,o=a.getLineContent(r),b=this._findFirstMatchInLine(k,o,r,p.column,i);if(b)return b;for(let f=1;f<=l;f++){const m=(r+f-1)%l,D=a.getLineContent(m+1),T=this._findFirstMatchInLine(k,D,m+1,1,i);if(T)return T}return null}static _findFirstMatchInLine(a,p,k,i,l){a.reset(i-1);const r=a.next(p);return r?y(new A.Range(k,r.index+1,k,r.index+1+r[0].length),r,l):null}static findPreviousMatch(a,p,k,i){const l=p.parseSearchRequest();if(!l)return null;const r=new C(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindPreviousMatchMultiline(a,k,r,i):this._doFindPreviousMatchLineByLine(a,k,r,i)}static _doFindPreviousMatchMultiline(a,p,k,i){const l=this._doFindMatchesMultiline(a,new A.Range(1,1,p.lineNumber,p.column),k,i,10*I);if(l.length>0)return l[l.length-1];const r=a.getLineCount();return p.lineNumber!==r||p.column!==a.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(a,new _.Position(r,a.getLineMaxColumn(r)),k,i):null}static _doFindPreviousMatchLineByLine(a,p,k,i){const l=a.getLineCount(),r=p.lineNumber,o=a.getLineContent(r).substring(0,p.column-1),b=this._findLastMatchInLine(k,o,r,i);if(b)return b;for(let f=1;f<=l;f++){const m=(l+r-f-1)%l,D=a.getLineContent(m+1),T=this._findLastMatchInLine(k,D,m+1,i);if(T)return T}return null}static _findLastMatchInLine(a,p,k,i){let l=null,r;for(a.reset(0);r=a.next(p);)l=y(new A.Range(k,r.index+1,k,r.index+1+r[0].length),r,i);return l}}e.TextModelSearch=h;function s(w,a,p,k,i){if(k===0)return!0;const l=a.charCodeAt(k-1);if(w.get(l)!==0||l===13||l===10)return!0;if(i>0){const r=a.charCodeAt(k);if(w.get(r)!==0)return!0}return!1}function d(w,a,p,k,i){if(k+i===p)return!0;const l=a.charCodeAt(k+i);if(w.get(l)!==0||l===13||l===10)return!0;if(i>0){const r=a.charCodeAt(k+i-1);if(w.get(r)!==0)return!0}return!1}function v(w,a,p,k,i){return s(w,a,p,k,i)&&d(w,a,p,k,i)}e.isValidMatch=v;class C{constructor(a,p){this._wordSeparators=a,this._searchRegex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const p=a.length;let k;do{if(this._prevMatchStartIndex+this._prevMatchLength===p||(k=this._searchRegex.exec(a),!k))return null;const i=k.index,l=k[0].length;if(i===this._prevMatchStartIndex&&l===this._prevMatchLength){if(l===0){c.getNextCodePoint(a,p,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=l,!this._wordSeparators||v(this._wordSeparators,a,p,i,l))return k}while(k);return null}}e.Searcher=C}),define(we[112],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class F{constructor(I){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let S=0,P=I.notIn.length;S<P;S++)switch(I.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=F;class _{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of I)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=_;function A(R,I,S){R.has(I)?R.get(I).push(S):R.set(I,[S])}}),define(we[55],be([0,1,27,17]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function _(A,R,I,S){if(Array.isArray(A)){let P=0;for(const t of A){const y=_(t,R,I,S);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof A=="string")return S?A==="*"?5:A===I?10:0:0;if(A){const{language:P,pattern:t,scheme:y,hasAccessToAllModels:n}=A;if(!S&&!n)return 0;let h=0;if(y)if(y===R.scheme)h=10;else if(y==="*")h=5;else return 0;if(P)if(P===I)h=10;else if(P==="*")h=Math.max(h,5);else return 0;if(t){let s;if(typeof t=="string"?s=t:s={...t,base:(0,F.normalize)(t.base)},s===R.fsPath||(0,c.match)(s,R.fsPath))h=10;else return 0}return h}else return 0}}e.score=_}),define(we[113],be([0,1,3,6]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class _{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,I){return this._map.set(R,I),this.fire([R]),(0,F.toDisposable)(()=>{this._map.get(R)===I&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,I){let S=null,P=!1;return this._promises.set(R,I.then(t=>{this._promises.delete(R),!(P||!t)&&(S=this.register(R,t))})),(0,F.toDisposable)(()=>{P=!0,S&&S.dispose()})}getPromise(R){const I=this.get(R);if(I)return Promise.resolve(I);const S=this._promises.get(R);return S?S.then(P=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=_}),define(we[80],be([0,1,23,26]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(_||(_={}));function A(y){for(let n=0,h=y.length;n<h;n+=4){const s=y[n+0],d=y[n+1],v=y[n+2],C=y[n+3];y[n+0]=C,y[n+1]=v,y[n+2]=d,y[n+3]=s}}function R(y){const n=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return F.isLittleEndian()||A(n),c.VSBuffer.wrap(n)}function I(y){const n=y.buffer;if(F.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const h=new Uint8Array(n.byteLength);return h.set(n),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function S(y){const n=new Uint32Array(P(y));let h=0;if(n[h++]=y.id,y.type==="full")n[h++]=1,n[h++]=y.data.length,n.set(y.data,h),h+=y.data.length;else{n[h++]=2,n[h++]=y.deltas.length;for(const s of y.deltas)n[h++]=s.start,n[h++]=s.deleteCount,s.data?(n[h++]=s.data.length,n.set(s.data,h),h+=s.data.length):n[h++]=0}return R(n)}e.encodeSemanticTokensDto=S;function P(y){let n=0;if(n+=1+1,y.type==="full")n+=1+y.data.length;else{n+=1,n+=(1+1+1)*y.deltas.length;for(const h of y.deltas)h.data&&(n+=h.data.length)}return n}function t(y){const n=I(y);let h=0;const s=n[h++];if(n[h++]===1){const w=n[h++],a=n.subarray(h,h+w);return h+=w,{id:s,type:"full",data:a}}const v=n[h++];let C=[];for(let w=0;w<v;w++){const a=n[h++],p=n[h++],k=n[h++];let i;k>0&&(i=n.subarray(h,h+k),h+=k),C[w]={start:a,deleteCount:p,data:i}}return{id:s,type:"delta",deltas:C}}e.decodeSemanticTokensDto=t}),define(we[114],be([18,19]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(we[56],be([0,1,13,10,114]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(P,t){return t&&(P.stack||P.stacktrace)?_.localize(0,null,I(P),R(P.stack)||R(P.stacktrace)):I(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function I(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?_.localize(1,null,P.message):P.message||_.localize(2,null)}function S(P=null,t=!1){if(!P)return _.localize(3,null);if(Array.isArray(P)){const y=c.coalesce(P),n=S(y[0],t);return y.length>1?_.localize(4,null,n,y.length):n}if(F.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return A(y.error,t);if(y.exception)return A(y.exception,t)}return P.stack?A(P,t):P.message?P.message:_.localize(5,null)}e.toErrorMessage=S}),define(we[115],be([18,19]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(we[116],be([0,1,115,26,117]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=R;class I{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,he){this._values[J]=he}}e.ValidatedEditorOptions=I;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class P{constructor(J,he,Oe,Ve){this.id=J,this.name=he,this.defaultValue=Oe,this.schema=Ve}compute(J,he,Oe){return Oe}}class t{constructor(J,he=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=he}validate(J){return this.defaultValue}}class y{constructor(J,he,Oe,Ve){this.id=J,this.name=he,this.defaultValue=Oe,this.schema=Ve}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,he,Oe){return Oe}}function n(z,J){return typeof z=="undefined"?J:z==="false"?!1:Boolean(z)}e.boolean=n;class h extends y{constructor(J,he,Oe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Oe),super(J,he,Oe,Ve)}validate(J){return n(J,this.defaultValue)}}class s extends y{constructor(J,he,Oe,Ve,tt,ut=void 0){typeof ut!="undefined"&&(ut.type="integer",ut.default=Oe,ut.minimum=Ve,ut.maximum=tt),super(J,he,Oe,ut),this.minimum=Ve,this.maximum=tt}static clampedInt(J,he,Oe,Ve){if(typeof J=="undefined")return he;let tt=parseInt(J,10);return isNaN(tt)?he:(tt=Math.max(Oe,tt),tt=Math.min(Ve,tt),tt|0)}validate(J){return s.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class d extends y{constructor(J,he,Oe,Ve,tt){typeof tt!="undefined"&&(tt.type="number",tt.default=Oe),super(J,he,Oe,tt),this.validationFn=Ve}static clamp(J,he,Oe){return J<he?he:J>Oe?Oe:J}static float(J,he){if(typeof J=="number")return J;if(typeof J=="undefined")return he;const Oe=parseFloat(J);return isNaN(Oe)?he:Oe}validate(J){return this.validationFn(d.float(J,this.defaultValue))}}class v extends y{static string(J,he){return typeof J!="string"?he:J}constructor(J,he,Oe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Oe),super(J,he,Oe,Ve)}validate(J){return v.string(J,this.defaultValue)}}function C(z,J,he){return typeof z!="string"||he.indexOf(z)===-1?J:z}e.stringSet=C;class w extends y{constructor(J,he,Oe,Ve,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.enum=Ve,tt.default=Oe),super(J,he,Oe,tt),this._allowedValues=Ve}validate(J){return C(J,this.defaultValue,this._allowedValues)}}class a extends P{constructor(J,he,Oe,Ve,tt,ut,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=tt,ht.default=Ve),super(J,he,Oe,ht),this._allowedValues=tt,this._convert=ut}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function p(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class k extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",description:c.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,he,Oe){return Oe===0?J.accessibilitySupport:Oe}}class i extends P{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:c.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{insertSpace:n(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function b(z){switch(z){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function f(z){switch(z){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class m extends t{constructor(){super(127,[65,32])}compute(J,he,Oe){const Ve=["monaco-editor"];return he.get(32)&&Ve.push(he.get(32)),J.extraEditorClassName&&Ve.push(J.extraEditorClassName),he.get(65)==="default"?Ve.push("mouse-default"):he.get(65)==="copy"&&Ve.push("mouse-copy"),he.get(100)&&Ve.push("showUnused"),he.get(125)&&Ve.push("showDeprecated"),Ve.join(" ")}}class D extends h{constructor(){super(31,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(J,he,Oe){return Oe&&J.emptySelectionClipboard}}class T extends P{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:c.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:c.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{cursorMoveOnType:n(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":C(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":C(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(he.loop,this.defaultValue.loop)}}}class g extends P{constructor(){super(43,"fontLigatures",g.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?g.OFF:J==="true"?g.ON:J:Boolean(J)?g.ON:g.OFF}}e.EditorFontLigatures=g,g.OFF='"liga" off, "calt" off',g.ON='"liga" on, "calt" on';class E extends t{constructor(){super(42)}compute(J,he,Oe){return J.fontInfo}}class u extends y{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(J){let he=d.float(J,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(he,6,100)}compute(J,he,Oe){return J.fontInfo.fontSize}}class M extends P{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:M.MINIMUM_VALUE,maximum:M.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:M.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(s.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,M.MINIMUM_VALUE,M.MAXIMUM_VALUE))}}M.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],M.MINIMUM_VALUE=1,M.MAXIMUM_VALUE=1e3;class O extends P{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Oe,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Oe,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Oe,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Oe,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Oe,description:c.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{multiple:C(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??C(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??C(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??C(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??C(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??C(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class q extends P{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:c.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),delay:s.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:n(he.sticky,this.defaultValue.sticky)}}}var K;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class $ extends t{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(J,he,Oe){return $.computeLayout(he,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const he=J.height/J.lineHeight,Oe=J.scrollBeyondLastLine?he-1:0,Ve=(J.viewLineCount+Oe)/(J.pixelRatio*J.height),tt=Math.floor(J.viewLineCount/Ve);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Oe,desiredRatio:Ve,minimapLineCount:tt}}static _computeMinimapLayout(J,he){const Oe=J.outerWidth,Ve=J.outerHeight,tt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const ut=he.stableMinimapLayoutInput,ht=ut&&J.outerHeight===ut.outerHeight&&J.lineHeight===ut.lineHeight&&J.typicalHalfwidthCharacterWidth===ut.typicalHalfwidthCharacterWidth&&J.pixelRatio===ut.pixelRatio&&J.scrollBeyondLastLine===ut.scrollBeyondLastLine&&J.minimap.enabled===ut.minimap.enabled&&J.minimap.side===ut.minimap.side&&J.minimap.size===ut.minimap.size&&J.minimap.showSlider===ut.minimap.showSlider&&J.minimap.renderCharacters===ut.minimap.renderCharacters&&J.minimap.maxColumn===ut.minimap.maxColumn&&J.minimap.scale===ut.minimap.scale&&J.verticalScrollbarWidth===ut.verticalScrollbarWidth&&J.isViewportWrapping===ut.isViewportWrapping,St=J.lineHeight,Pt=J.typicalHalfwidthCharacterWidth,dt=J.scrollBeyondLastLine,bt=J.minimap.renderCharacters;let ft=tt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Et=J.minimap.maxColumn,Ye=J.minimap.size,Ct=J.minimap.side,Pe=J.verticalScrollbarWidth,ye=J.viewLineCount,De=J.remainingWidth,Z=J.isViewportWrapping,ue=bt?2:3;let ge=Math.floor(tt*Ve);const me=ge/tt;let Ie=!1,Be=!1,Le=ue*ft,je=ft/tt,Xe=1;if(Ye==="fill"||Ye==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:We,desiredRatio:it,minimapLineCount:mt}=$.computeContainedMinimapLineCount({viewLineCount:ye,scrollBeyondLastLine:dt,height:Ve,lineHeight:St,pixelRatio:tt});if(ye/mt>1)Ie=!0,Be=!0,ft=1,Le=1,je=ft/tt;else{let nt=!1,ot=ft+1;if(Ye==="fit"){const lt=Math.ceil((ye+We)*Le);Z&&ht&&De<=he.stableFitRemainingWidth?(nt=!0,ot=he.stableFitMaxMinimapScale):nt=lt>ge}if(Ye==="fill"||nt){Ie=!0;const lt=ft;Le=Math.min(St*tt,Math.max(1,Math.floor(1/it))),Z&&ht&&De<=he.stableFitRemainingWidth&&(ot=he.stableFitMaxMinimapScale),ft=Math.min(ot,Math.max(1,Math.floor(Le/ue))),ft>lt&&(Xe=Math.min(2,ft/lt)),je=ft/tt/Xe,ge=Math.ceil(Math.max(Ge,ye+We)*Le),Z?(he.stableMinimapLayoutInput=J,he.stableFitRemainingWidth=De,he.stableFitMaxMinimapScale=ft):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const ne=Math.floor(Et*je),pe=Math.min(ne,Math.max(0,Math.floor((De-Pe-2)*je/(Pt+je)))+e.MINIMAP_GUTTER_WIDTH);let re=Math.floor(tt*pe);const U=re/tt;re=Math.floor(re*Xe);const Ce=bt?1:2,Se=Ct==="left"?0:Oe-pe-Pe;return{renderMinimap:Ce,minimapLeft:Se,minimapWidth:pe,minimapHeightIsEditorHeight:Ie,minimapIsSampling:Be,minimapScale:ft,minimapLineHeight:Le,minimapCanvasInnerWidth:re,minimapCanvasInnerHeight:ge,minimapCanvasOuterWidth:U,minimapCanvasOuterHeight:me}}static computeLayout(J,he){const Oe=he.outerWidth|0,Ve=he.outerHeight|0,tt=he.lineHeight|0,ut=he.lineNumbersDigitCount|0,ht=he.typicalHalfwidthCharacterWidth,St=he.maxDigitWidth,Pt=he.pixelRatio,dt=he.viewLineCount,bt=J.get(122),ft=bt==="inherit"?J.get(121):bt,Et=ft==="inherit"?J.get(117):ft,Ye=J.get(120),Ct=J.get(2),Pe=he.isDominatedByLongLines,ye=J.get(48),De=J.get(59).renderType!==0,Z=J.get(60),ue=J.get(94),ge=J.get(64),me=J.get(92),Ie=me.verticalScrollbarSize,Be=me.verticalHasArrows,Le=me.arrowSize,je=me.horizontalScrollbarSize,Xe=J.get(57),ne=J.get(36);let pe;if(typeof Xe=="string"&&/^\d+(\.\d+)?ch$/.test(Xe)){const Ot=parseFloat(Xe.substr(0,Xe.length-2));pe=s.clampedInt(Ot*ht,0,0,1e3)}else pe=s.clampedInt(Xe,0,0,1e3);ne&&(pe+=16);let re=0;if(De){const Ot=Math.max(ut,Z);re=Math.round(Ot*St)}let U=0;ye&&(U=tt);let Ce=0,Se=Ce+U,Ge=Se+re,We=Ge+pe;const it=Oe-U-re-pe;let mt=!1,vt=!1,nt=-1;Ct!==2&&(ft==="inherit"&&Pe?(mt=!0,vt=!0):Et==="on"||Et==="bounded"?vt=!0:Et==="wordWrapColumn"&&(nt=Ye));const ot=$._computeMinimapLayout({outerWidth:Oe,outerHeight:Ve,lineHeight:tt,typicalHalfwidthCharacterWidth:ht,pixelRatio:Pt,scrollBeyondLastLine:ue,minimap:ge,verticalScrollbarWidth:Ie,viewLineCount:dt,remainingWidth:it,isViewportWrapping:vt},he.memory||new S);ot.renderMinimap!==0&&ot.minimapLeft===0&&(Ce+=ot.minimapWidth,Se+=ot.minimapWidth,Ge+=ot.minimapWidth,We+=ot.minimapWidth);const lt=it-ot.minimapWidth,Rt=Math.max(1,Math.floor((lt-Ie-2)/ht)),_t=Be?Le:0;return vt&&(nt=Math.max(1,Rt),Et==="bounded"&&(nt=Math.min(nt,Ye))),{width:Oe,height:Ve,glyphMarginLeft:Ce,glyphMarginWidth:U,lineNumbersLeft:Se,lineNumbersWidth:re,decorationsLeft:Ge,decorationsWidth:pe,contentLeft:We,contentWidth:lt,minimap:ot,viewportColumn:Rt,isWordWrapMinified:mt,isViewportWrapping:vt,wrappingColumn:nt,verticalScrollbarWidth:Ie,horizontalScrollbarHeight:je,overviewRuler:{top:_t,width:Ie,height:Ve-2*_t,right:0}}}}e.EditorLayoutInfoComputer=$;class W extends P{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:c.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class N extends P{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:c.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:c.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(he.fontFamily,this.defaultValue.fontFamily)}}}class H extends d{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>d.clamp(J,0,150),{markdownDescription:c.localize(46,null)})}compute(J,he,Oe){return J.fontInfo.lineHeight}}class V extends P{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:c.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(48,null),c.localize(49,null),c.localize(50,null)],default:J.size,description:c.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:c.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:c.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:c.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:c.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),size:C(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:C(he.side,this.defaultValue.side,["right","left"]),showSlider:C(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(he.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(he.scale,1,1,3),maxColumn:s.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(z){return z==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ce extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{top:s.clampedInt(he.top,0,0,1e3),bottom:s.clampedInt(he.bottom,0,0,1e3)}}}class G extends P{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:c.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),cycle:n(he.cycle,this.defaultValue.cycle)}}}class le extends t{constructor(){super(128)}compute(J,he,Oe){return J.pixelRatio}}class oe extends P{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:c.localize(61,null)},comments:{type:"boolean",default:J.comments,description:c.localize(62,null)},other:{type:"boolean",default:J.other,description:c.localize(63,null)}}}],default:J,description:c.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const he=J,Oe={other:n(he.other,this.defaultValue.other),comments:n(he.comments,this.defaultValue.comments),strings:n(he.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var Ee;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(Ee=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(65,null),c.localize(66,null),c.localize(67,null),c.localize(68,null)],default:"on",description:c.localize(69,null)})}validate(J){let he=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(he=4,Oe=J):J==="interval"?he=3:J==="relative"?he=2:J==="on"?he=1:he=0),{renderType:he,renderFn:Oe}}}function Me(z){const J=z.get(87);return J==="editable"?z.get(80):J!=="on"}e.filterValidationDecorations=Me;class Ne extends P{constructor(){const J=[],he={type:"number",description:c.localize(70,null)};super(91,"rulers",J,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:c.localize(71,null),format:"color-hex"}}}]},default:J,description:c.localize(72,null)})}validate(J){if(Array.isArray(J)){let he=[];for(let Oe of J)if(typeof Oe=="number")he.push({column:s.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const Ve=Oe;he.push({column:s.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return he.sort((Oe,Ve)=>Oe.column-Ve.column),he}return this.defaultValue}}function Qe(z,J){if(typeof z!="string")return J;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends P{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(73,null),c.localize(74,null),c.localize(75,null)],default:"auto",description:c.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(77,null),c.localize(78,null),c.localize(79,null)],default:"auto",description:c.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:c.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:c.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:c.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J,Oe=s.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=s.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(he.vertical,this.defaultValue.vertical),horizontal:Qe(he.horizontal,this.defaultValue.horizontal),useShadows:n(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:s.clampedInt(he.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:s.clampedInt(he.verticalSliderSize,Ve,0,1e3),scrollByPage:n(he.scrollByPage,this.defaultValue.scrollByPage)}}}class qe extends P{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:c.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[c.localize(85,null),c.localize(86,null),c.localize(87,null)],default:J.mode,description:c.localize(88,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),mode:C(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class B extends P{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:c.localize(89,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class Q extends P{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(90,null),c.localize(91,null)],default:J.insertMode,description:c.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:c.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:c.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:c.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:c.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:c.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:c.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:c.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[c.localize(100,null),c.localize(101,null),c.localize(102,null)],default:J.previewMode,description:c.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:c.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(135,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{insertMode:C(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(he.showIcons,this.defaultValue.showIcons),showStatusBar:n(he.showStatusBar,this.defaultValue.showStatusBar),preview:n(he.preview,this.defaultValue.preview),previewMode:C(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(he.showMethods,this.defaultValue.showMethods),showFunctions:n(he.showFunctions,this.defaultValue.showFunctions),showConstructors:n(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(he.showDeprecated,this.defaultValue.showDeprecated),showFields:n(he.showFields,this.defaultValue.showFields),showVariables:n(he.showVariables,this.defaultValue.showVariables),showClasses:n(he.showClasses,this.defaultValue.showClasses),showStructs:n(he.showStructs,this.defaultValue.showStructs),showInterfaces:n(he.showInterfaces,this.defaultValue.showInterfaces),showModules:n(he.showModules,this.defaultValue.showModules),showProperties:n(he.showProperties,this.defaultValue.showProperties),showEvents:n(he.showEvents,this.defaultValue.showEvents),showOperators:n(he.showOperators,this.defaultValue.showOperators),showUnits:n(he.showUnits,this.defaultValue.showUnits),showValues:n(he.showValues,this.defaultValue.showValues),showConstants:n(he.showConstants,this.defaultValue.showConstants),showEnums:n(he.showEnums,this.defaultValue.showEnums),showEnumMembers:n(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(he.showKeywords,this.defaultValue.showKeywords),showWords:n(he.showWords,this.defaultValue.showWords),showColors:n(he.showColors,this.defaultValue.showColors),showFiles:n(he.showFiles,this.defaultValue.showFiles),showReferences:n(he.showReferences,this.defaultValue.showReferences),showFolders:n(he.showFolders,this.defaultValue.showFolders),showTypeParameters:n(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(he.showSnippets,this.defaultValue.showSnippets),showUsers:n(he.showUsers,this.defaultValue.showUsers),showIssues:n(he.showIssues,this.defaultValue.showIssues)}}}class ee extends P{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(136,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends t{constructor(){super(129,[80])}compute(J,he,Oe){return he.get(80)?!0:J.tabFocusMode}}var j;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(j=e.WrappingIndent||(e.WrappingIndent={}));function se(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class fe extends t{constructor(){super(131,[130])}compute(J,he,Oe){const Ve=he.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const Ae="Consolas, 'Courier New', monospace",xe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?xe:F.isLinux?$e:Ae,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ve(z){return e.editorOptionsRegistry[z.id]=z,z}var Ze;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.bracketPairColorization=12]="bracketPairColorization",z[z.codeLens=13]="codeLens",z[z.codeLensFontFamily=14]="codeLensFontFamily",z[z.codeLensFontSize=15]="codeLensFontSize",z[z.colorDecorators=16]="colorDecorators",z[z.columnSelection=17]="columnSelection",z[z.comments=18]="comments",z[z.contextmenu=19]="contextmenu",z[z.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",z[z.cursorBlinking=21]="cursorBlinking",z[z.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",z[z.cursorStyle=23]="cursorStyle",z[z.cursorSurroundingLines=24]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",z[z.cursorWidth=26]="cursorWidth",z[z.disableLayerHinting=27]="disableLayerHinting",z[z.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",z[z.domReadOnly=29]="domReadOnly",z[z.dragAndDrop=30]="dragAndDrop",z[z.emptySelectionClipboard=31]="emptySelectionClipboard",z[z.extraEditorClassName=32]="extraEditorClassName",z[z.fastScrollSensitivity=33]="fastScrollSensitivity",z[z.find=34]="find",z[z.fixedOverflowWidgets=35]="fixedOverflowWidgets",z[z.folding=36]="folding",z[z.foldingStrategy=37]="foldingStrategy",z[z.foldingHighlight=38]="foldingHighlight",z[z.foldingImportsByDefault=39]="foldingImportsByDefault",z[z.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=41]="fontFamily",z[z.fontInfo=42]="fontInfo",z[z.fontLigatures=43]="fontLigatures",z[z.fontSize=44]="fontSize",z[z.fontWeight=45]="fontWeight",z[z.formatOnPaste=46]="formatOnPaste",z[z.formatOnType=47]="formatOnType",z[z.glyphMargin=48]="glyphMargin",z[z.gotoLocation=49]="gotoLocation",z[z.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",z[z.hover=52]="hover",z[z.inDiffEditor=53]="inDiffEditor",z[z.inlineSuggest=54]="inlineSuggest",z[z.letterSpacing=55]="letterSpacing",z[z.lightbulb=56]="lightbulb",z[z.lineDecorationsWidth=57]="lineDecorationsWidth",z[z.lineHeight=58]="lineHeight",z[z.lineNumbers=59]="lineNumbers",z[z.lineNumbersMinChars=60]="lineNumbersMinChars",z[z.linkedEditing=61]="linkedEditing",z[z.links=62]="links",z[z.matchBrackets=63]="matchBrackets",z[z.minimap=64]="minimap",z[z.mouseStyle=65]="mouseStyle",z[z.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=67]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",z[z.multiCursorModifier=69]="multiCursorModifier",z[z.multiCursorPaste=70]="multiCursorPaste",z[z.occurrencesHighlight=71]="occurrencesHighlight",z[z.overviewRulerBorder=72]="overviewRulerBorder",z[z.overviewRulerLanes=73]="overviewRulerLanes",z[z.padding=74]="padding",z[z.parameterHints=75]="parameterHints",z[z.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",z[z.quickSuggestions=78]="quickSuggestions",z[z.quickSuggestionsDelay=79]="quickSuggestionsDelay",z[z.readOnly=80]="readOnly",z[z.renameOnType=81]="renameOnType",z[z.renderControlCharacters=82]="renderControlCharacters",z[z.renderIndentGuides=83]="renderIndentGuides",z[z.renderFinalNewline=84]="renderFinalNewline",z[z.renderLineHighlight=85]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=87]="renderValidationDecorations",z[z.renderWhitespace=88]="renderWhitespace",z[z.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",z[z.roundedSelection=90]="roundedSelection",z[z.rulers=91]="rulers",z[z.scrollbar=92]="scrollbar",z[z.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=94]="scrollBeyondLastLine",z[z.scrollPredominantAxis=95]="scrollPredominantAxis",z[z.selectionClipboard=96]="selectionClipboard",z[z.selectionHighlight=97]="selectionHighlight",z[z.selectOnLineNumbers=98]="selectOnLineNumbers",z[z.showFoldingControls=99]="showFoldingControls",z[z.showUnused=100]="showUnused",z[z.snippetSuggestions=101]="snippetSuggestions",z[z.smartSelect=102]="smartSelect",z[z.smoothScrolling=103]="smoothScrolling",z[z.stickyTabStops=104]="stickyTabStops",z[z.stopRenderingLineAfter=105]="stopRenderingLineAfter",z[z.suggest=106]="suggest",z[z.suggestFontSize=107]="suggestFontSize",z[z.suggestLineHeight=108]="suggestLineHeight",z[z.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",z[z.suggestSelection=110]="suggestSelection",z[z.tabCompletion=111]="tabCompletion",z[z.tabIndex=112]="tabIndex",z[z.unusualLineTerminators=113]="unusualLineTerminators",z[z.useShadowDOM=114]="useShadowDOM",z[z.useTabStops=115]="useTabStops",z[z.wordSeparators=116]="wordSeparators",z[z.wordWrap=117]="wordWrap",z[z.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=120]="wordWrapColumn",z[z.wordWrapOverride1=121]="wordWrapOverride1",z[z.wordWrapOverride2=122]="wordWrapOverride2",z[z.wrappingIndent=123]="wrappingIndent",z[z.wrappingStrategy=124]="wrappingStrategy",z[z.showDeprecated=125]="showDeprecated",z[z.inlayHints=126]="inlayHints",z[z.editorClassName=127]="editorClassName",z[z.pixelRatio=128]="pixelRatio",z[z.tabFocusMode=129]="tabFocusMode",z[z.layoutInfo=130]="layoutInfo",z[z.wrappingInfo=131]="wrappingInfo"})(Ze=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(137,null)})),acceptSuggestionOnEnter:ve(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(138,null),""],markdownDescription:c.localize(139,null)})),accessibilitySupport:ve(new k),accessibilityPageSize:ve(new s(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(140,null)})),ariaLabel:ve(new v(4,"ariaLabel",c.localize(141,null))),autoClosingBrackets:ve(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(142,null),c.localize(143,null),""],description:c.localize(144,null)})),autoClosingDelete:ve(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(145,null),""],description:c.localize(146,null)})),autoClosingOvertype:ve(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(147,null),""],description:c.localize(148,null)})),autoClosingQuotes:ve(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(149,null),c.localize(150,null),""],description:c.localize(151,null)})),autoIndent:ve(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[c.localize(152,null),c.localize(153,null),c.localize(154,null),c.localize(155,null),c.localize(156,null)],description:c.localize(157,null)})),automaticLayout:ve(new h(10,"automaticLayout",!1)),autoSurround:ve(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(158,null),c.localize(159,null),c.localize(160,null),""],description:c.localize(161,null)})),bracketPairColorization:ve(new B),stickyTabStops:ve(new h(104,"stickyTabStops",!1,{description:c.localize(162,null)})),codeLens:ve(new h(13,"codeLens",!0,{description:c.localize(163,null)})),codeLensFontFamily:ve(new v(14,"codeLensFontFamily","",{description:c.localize(164,null)})),codeLensFontSize:ve(new s(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(165,null)})),colorDecorators:ve(new h(16,"colorDecorators",!0,{description:c.localize(166,null)})),columnSelection:ve(new h(17,"columnSelection",!1,{description:c.localize(167,null)})),comments:ve(new i),contextmenu:ve(new h(19,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new h(20,"copyWithSyntaxHighlighting",!0,{description:c.localize(168,null)})),cursorBlinking:ve(new a(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:c.localize(169,null)})),cursorSmoothCaretAnimation:ve(new h(22,"cursorSmoothCaretAnimation",!1,{description:c.localize(170,null)})),cursorStyle:ve(new a(23,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:c.localize(171,null)})),cursorSurroundingLines:ve(new s(24,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(172,null)})),cursorSurroundingLinesStyle:ve(new w(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(173,null),c.localize(174,null)],description:c.localize(175,null)})),cursorWidth:ve(new s(26,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(176,null)})),disableLayerHinting:ve(new h(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new h(28,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new h(29,"domReadOnly",!1)),dragAndDrop:ve(new h(30,"dragAndDrop",!0,{description:c.localize(177,null)})),emptySelectionClipboard:ve(new D),extraEditorClassName:ve(new v(32,"extraEditorClassName","")),fastScrollSensitivity:ve(new d(33,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:c.localize(178,null)})),find:ve(new T),fixedOverflowWidgets:ve(new h(35,"fixedOverflowWidgets",!1)),folding:ve(new h(36,"folding",!0,{description:c.localize(179,null)})),foldingStrategy:ve(new w(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(180,null),c.localize(181,null)],description:c.localize(182,null)})),foldingHighlight:ve(new h(38,"foldingHighlight",!0,{description:c.localize(183,null)})),foldingImportsByDefault:ve(new h(39,"foldingImportsByDefault",!1,{description:c.localize(184,null)})),unfoldOnClickAfterEndOfLine:ve(new h(40,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(185,null)})),fontFamily:ve(new v(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(186,null)})),fontInfo:ve(new E),fontLigatures2:ve(new g),fontSize:ve(new u),fontWeight:ve(new M),formatOnPaste:ve(new h(46,"formatOnPaste",!1,{description:c.localize(187,null)})),formatOnType:ve(new h(47,"formatOnType",!1,{description:c.localize(188,null)})),glyphMargin:ve(new h(48,"glyphMargin",!0,{description:c.localize(189,null)})),gotoLocation:ve(new O),hideCursorInOverviewRuler:ve(new h(50,"hideCursorInOverviewRuler",!1,{description:c.localize(190,null)})),highlightActiveIndentGuide:ve(new h(51,"highlightActiveIndentGuide",!0,{description:c.localize(191,null)})),hover:ve(new q),inDiffEditor:ve(new h(53,"inDiffEditor",!1)),letterSpacing:ve(new d(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>d.clamp(z,-5,20),{description:c.localize(192,null)})),lightbulb:ve(new W),lineDecorationsWidth:ve(new y(57,"lineDecorationsWidth",10)),lineHeight:ve(new H),lineNumbers:ve(new Fe),lineNumbersMinChars:ve(new s(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new h(61,"linkedEditing",!1,{description:c.localize(193,null)})),links:ve(new h(62,"links",!0,{description:c.localize(194,null)})),matchBrackets:ve(new w(63,"matchBrackets","always",["always","near","never"],{description:c.localize(195,null)})),minimap:ve(new V),mouseStyle:ve(new w(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new d(66,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:c.localize(196,null)})),mouseWheelZoom:ve(new h(67,"mouseWheelZoom",!1,{markdownDescription:c.localize(197,null)})),multiCursorMergeOverlapping:ve(new h(68,"multiCursorMergeOverlapping",!0,{description:c.localize(198,null)})),multiCursorModifier:ve(new a(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[c.localize(199,null),c.localize(200,null)],markdownDescription:c.localize(201,null)})),multiCursorPaste:ve(new w(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(202,null),c.localize(203,null)],markdownDescription:c.localize(204,null)})),occurrencesHighlight:ve(new h(71,"occurrencesHighlight",!0,{description:c.localize(205,null)})),overviewRulerBorder:ve(new h(72,"overviewRulerBorder",!0,{description:c.localize(206,null)})),overviewRulerLanes:ve(new s(73,"overviewRulerLanes",3,0,3)),padding:ve(new ce),parameterHints:ve(new G),peekWidgetDefaultFocus:ve(new w(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(207,null),c.localize(208,null)],description:c.localize(209,null)})),definitionLinkOpensInPeek:ve(new h(77,"definitionLinkOpensInPeek",!1,{description:c.localize(210,null)})),quickSuggestions:ve(new oe),quickSuggestionsDelay:ve(new s(79,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(211,null)})),readOnly:ve(new h(80,"readOnly",!1)),renameOnType:ve(new h(81,"renameOnType",!1,{description:c.localize(212,null),markdownDeprecationMessage:c.localize(213,null)})),renderControlCharacters:ve(new h(82,"renderControlCharacters",!1,{description:c.localize(214,null)})),renderIndentGuides:ve(new h(83,"renderIndentGuides",!0,{description:c.localize(215,null)})),renderFinalNewline:ve(new h(84,"renderFinalNewline",!0,{description:c.localize(216,null)})),renderLineHighlight:ve(new w(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(217,null)],description:c.localize(218,null)})),renderLineHighlightOnlyWhenFocus:ve(new h(86,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(219,null)})),renderValidationDecorations:ve(new w(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new w(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(220,null),c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),revealHorizontalRightPadding:ve(new s(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new h(90,"roundedSelection",!0,{description:c.localize(224,null)})),rulers:ve(new Ne),scrollbar:ve(new ze),scrollBeyondLastColumn:ve(new s(93,"scrollBeyondLastColumn",5,0,1073741824,{description:c.localize(225,null)})),scrollBeyondLastLine:ve(new h(94,"scrollBeyondLastLine",!0,{description:c.localize(226,null)})),scrollPredominantAxis:ve(new h(95,"scrollPredominantAxis",!0,{description:c.localize(227,null)})),selectionClipboard:ve(new h(96,"selectionClipboard",!0,{description:c.localize(228,null),included:F.isLinux})),selectionHighlight:ve(new h(97,"selectionHighlight",!0,{description:c.localize(229,null)})),selectOnLineNumbers:ve(new h(98,"selectOnLineNumbers",!0)),showFoldingControls:ve(new w(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[c.localize(230,null),c.localize(231,null)],description:c.localize(232,null)})),showUnused:ve(new h(100,"showUnused",!0,{description:c.localize(233,null)})),showDeprecated:ve(new h(125,"showDeprecated",!0,{description:c.localize(234,null)})),inlayHints:ve(new N),snippetSuggestions:ve(new w(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),smartSelect:ve(new ee),smoothScrolling:ve(new h(103,"smoothScrolling",!1,{description:c.localize(240,null)})),stopRenderingLineAfter:ve(new s(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new Q),inlineSuggest:ve(new qe),suggestFontSize:ve(new s(107,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(241,null)})),suggestLineHeight:ve(new s(108,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(242,null)})),suggestOnTriggerCharacters:ve(new h(109,"suggestOnTriggerCharacters",!0,{description:c.localize(243,null)})),suggestSelection:ve(new w(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(244,null),c.localize(245,null),c.localize(246,null)],description:c.localize(247,null)})),tabCompletion:ve(new w(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(248,null),c.localize(249,null),c.localize(250,null)],description:c.localize(251,null)})),tabIndex:ve(new s(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new w(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(252,null),c.localize(253,null),c.localize(254,null)],description:c.localize(255,null)})),useShadowDOM:ve(new h(114,"useShadowDOM",!0)),useTabStops:ve(new h(115,"useTabStops",!0,{description:c.localize(256,null)})),wordSeparators:ve(new v(116,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:c.localize(257,null)})),wordWrap:ve(new w(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(258,null),c.localize(259,null),c.localize(260,null),c.localize(261,null)],description:c.localize(262,null)})),wordWrapBreakAfterCharacters:ve(new v(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new v(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new s(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(263,null)})),wordWrapOverride1:ve(new w(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new w(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new a(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],se,{enumDescriptions:[c.localize(264,null),c.localize(265,null),c.localize(266,null),c.localize(267,null)],description:c.localize(268,null)})),wrappingStrategy:ve(new w(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),editorClassName:ve(new m),pixelRatio:ve(new le),tabFocusMode:ve(new ae),layoutInfo:ve(new $),wrappingInfo:ve(new fe)}}),define(we[118],be([18,19]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[119],be([18,19]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[120],be([18,19]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(we[121],be([18,19]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(we[122],be([18,19]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(we[123],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[124],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[125],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(we[126],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[127],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[128],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[129],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[130],be([18,19]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(we[131],be([18,19]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(we[132],be([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[133],be([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[134],be([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[135],be([18,19]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[136],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var c;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(c=e.EditorActivation||(e.EditorActivation={}));var F;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var _;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[137],be([0,1,119]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||F.test(n)}e.isValidVersionStr=A;function R(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=n.match(F);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=R;function I(n){if(!n)return null;let h=n.majorBase,s=n.majorMustEqual,d=n.minorBase,v=n.minorMustEqual,C=n.patchBase,w=n.patchMustEqual;n.hasCaret&&(h===0||(v=!1),w=!1);let a=0;if(n.preRelease){const p=_.exec(n.preRelease);if(p){const[,k,i,l]=p;a=Date.UTC(Number(k),Number(i)-1,Number(l))}}return{majorBase:h,majorMustEqual:s,minorBase:d,minorMustEqual:v,patchBase:C,patchMustEqual:w,isMinimum:n.hasGreaterEquals,notBefore:a}}e.normalizeVersion=I;function S(n,h,s){let d;typeof n=="string"?d=I(R(n)):d=n;let v;h instanceof Date?v=h.getTime():typeof h=="string"&&(v=new Date(h).getTime());let C;if(typeof s=="string"?C=I(R(s)):C=s,!d||!C)return!1;let w=d.majorBase,a=d.minorBase,p=d.patchBase,k=C.majorBase,i=C.minorBase,l=C.patchBase,r=C.notBefore,o=C.majorMustEqual,b=C.minorMustEqual,f=C.patchMustEqual;return C.isMinimum?w>k?!0:w<k?!1:a>i?!0:a<i||v&&v<r?!1:p>=l:(w===1&&k===0&&(!o||!b||!f)&&(k=1,i=0,l=0,o=!0,b=!1,f=!1),w<k?!1:w>k?!o:a<i?!1:a>i?!b:p<l?!1:p>l?!f:!(v&&v<r))}e.isValidVersion=S;function P(n,h,s,d){return s.isBuiltin||typeof s.main=="undefined"?!0:y(n,h,s.engines.vscode,d)}e.isValidExtensionVersion=P;function t(n,h,s){return n==="*"||y(h,s,n)}e.isEngineValid=t;function y(n,h,s,d=[]){let v=I(R(s));if(!v)return d.push(c.localize(0,null,s)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return d.push(c.localize(1,null,s)),!1}else if(!v.majorMustEqual)return d.push(c.localize(2,null,s)),!1;return S(n,h,v)?!0:(d.push(c.localize(3,null,n,s)),!1)}}),define(we[81],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(_,A=[],R=!1){this.ctor=_,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=c}),define(we[57],be([0,1,81]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function _(R,I,S){I instanceof c.SyncDescriptor||(I=new c.SyncDescriptor(I,[],S)),F.push([R,I])}e.registerSingleton=_;function A(){return F}e.getSingletonServiceDescriptors=A}),define(we[138],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=c;class F{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let R of this._nodes.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const I=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(R);I.outgoing.set(this._hashFn(R),S),S.incoming.set(this._hashFn(A),I)}removeNode(A){const R=this._hashFn(A);this._nodes.delete(R);for(let I of this._nodes.values())I.outgoing.delete(R),I.incoming.delete(R)}lookupOrInsertNode(A){const R=this._hashFn(A);let I=this._nodes.get(R);return I||(I=new c(A),this._nodes.set(R,I)),I}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[R,I]of this._nodes)A.push(`${R}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,R]of this._nodes){const I=new Set([A]),S=this._findCycle(R,I);if(S)return S}}_findCycle(A,R){for(let[I,S]of A.outgoing){if(R.has(I))return[...R,I].join(" -> ");R.add(I);const P=this._findCycle(S,R);if(P)return P;R.delete(I)}}}e.Graph=F}),define(we[4],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function S(P){return P[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=S})(c=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function F(I,S,P,t){S[c.DI_TARGET]===S?S[c.DI_DEPENDENCIES].push({id:I,index:P,optional:t}):(S[c.DI_DEPENDENCIES]=[{id:I,index:P,optional:t}],S[c.DI_TARGET]=S)}function _(I){if(c.serviceIds.has(I))return c.serviceIds.get(I);const S=function(P,t,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(S,P,y,!1)};return S.toString=()=>I,c.serviceIds.set(I,S),S}e.createDecorator=_;function A(I){return I}e.refineServiceDecorator=A;function R(I){return function(S,P,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(I,S,t,!0)}}e.optional=R}),define(we[139],be([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,c.createDecorator)("modelService");function F(_){return!_.isTooLargeForSyncing()&&!_.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(we[140],be([0,1,3,58,6,20,75,55,139]),function(ie,e,c,F,_,A,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(P):!!d.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new c.Emitter}get onDidChange(){return this._onDidChange.event}register(v,C){let w={selector:v,provider:C,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,_.toDisposable)(()=>{if(w){let a=this._entries.indexOf(w);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const C=[];for(let w of this._entries)w._score>0&&C.push(w.provider);return C}ordered(v){const C=[];return this._orderedForEach(v,w=>C.push(w.provider)),C}orderedGroups(v){const C=[];let w,a;return this._orderedForEach(v,p=>{w&&a===p._score?w.push(p.provider):(a=p._score,w=[p.provider],C.push(w))}),C}_orderedForEach(v,C){if(!!v){this._updateScores(v);for(const w of this._entries)w._score>0&&C(w)}}_updateScores(v){let C={uri:v.uri.toString(),language:v.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===C.language&&this._lastCandidate.uri===C.uri)){this._lastCandidate=C;for(let w of this._entries)if(w._score=(0,I.score)(w.selector,v.uri,v.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(v)),P(w.selector)&&w._score>0){for(let a of this._entries)a._score=0;w._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(v,C){return v._score<C._score?1:v._score>C._score?-1:v._time<C._time?1:v._time>C._time?-1:0}}e.LanguageFeatureRegistry=t;const y=new WeakMap;let n=0;function h(d){let v=y.get(d);return v===void 0&&(v=++n,y.set(d,v)),v}class s{constructor(v,C,w=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=C,this.max=w,this._cache=new A.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((C,w)=>(0,F.doHash)(h(w),C),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const C=this._key(v),w=this._cache.get(C);return this._clamp(w?.value)}update(v,C){const w=this._key(v);let a=this._cache.get(w);return a||(a=new R.MovingAverage,this._cache.set(w,a)),a.update(C),this.get(v)}}e.LanguageFeatureRequestDelays=s}),define(we[59],be([0,1,2,42,140,113,34]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class S{constructor(E,u){this.language=E,this.id=u}}e.LanguageIdentifier=S;var P;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var t;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var y;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(y=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let u=this.getForeground(E),M="mtk"+u,O=this.getFontStyle(E);return O&1&&(M+=" mtki"),O&2&&(M+=" mtkb"),O&4&&(M+=" mtku"),M}static getInlineStyleFromMetadata(E,u){const M=this.getForeground(E),O=this.getFontStyle(E);let q=`color: ${u[M]};`;return O&1&&(q+="font-style: italic;"),O&2&&(q+="font-weight: bold;"),O&4&&(q+="text-decoration: underline;"),q}}e.TokenMetadata=h;var s;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(E){const u=g[E];let M=u&&R.iconRegistry.get(u);return M||(console.info("No codicon found for CompletionItemKind "+E),M=R.Codicon.symbolProperty),M.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(E,u){let M=g[E];return typeof M=="undefined"&&!u&&(M=9),M}}();var d;(function(g){g[g.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var C;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var k;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(k=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(g){return g&&c.URI.isUri(g.uri)&&F.Range.isIRange(g.range)&&(F.Range.isIRange(g.originSelectionRange)||F.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=i;var l;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(l=e.SymbolKind||(e.SymbolKind={}));var r;(function(g){g[g.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var o;(function(g){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const u=new Map;u.set(0,"file"),u.set(1,"module"),u.set(2,"namespace"),u.set(3,"package"),u.set(4,"class"),u.set(5,"method"),u.set(6,"property"),u.set(7,"field"),u.set(8,"constructor"),u.set(9,"enum"),u.set(10,"interface"),u.set(11,"function"),u.set(12,"variable"),u.set(13,"constant"),u.set(14,"string"),u.set(15,"number"),u.set(16,"boolean"),u.set(17,"array"),u.set(18,"object"),u.set(19,"key"),u.set(20,"null"),u.set(21,"enum-member"),u.set(22,"struct"),u.set(23,"event"),u.set(24,"operator"),u.set(25,"type-parameter");function M(K){return E.get(K)}g.fromString=M;function O(K){return u.get(K)}g.toString=O;function q(K,$){const W=u.get(K);let N=W&&R.iconRegistry.get("symbol-"+W);return N||(console.info("No codicon found for SymbolKind "+K),N=R.Codicon.symbolProperty),`${$?"inline":"block"} ${N.classNames}`}g.toCssClassName=q})(o=e.SymbolKinds||(e.SymbolKinds={}));class b{constructor(E){this.value=E}}e.FoldingRangeKind=b,b.Comment=new b("comment"),b.Imports=new b("imports"),b.Region=new b("region");var f;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(f=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var D;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(D=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new _.LanguageFeatureRegistry,e.RenameProviderRegistry=new _.LanguageFeatureRegistry,e.CompletionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new _.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new _.LanguageFeatureRegistry,e.HoverProviderRegistry=new _.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new _.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new _.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new _.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new _.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new _.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.LinkProviderRegistry=new _.LanguageFeatureRegistry,e.ColorProviderRegistry=new _.LanguageFeatureRegistry,e.SelectionRangeRegistry=new _.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var T;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(T=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[43],be([0,1,26,9,4]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=c.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",c.isMacintosh),R.set("isLinux",c.isLinux),R.set("isWindows",c.isWindows),R.set("isWeb",c.isWeb),R.set("isMacNative",c.isMacintosh&&!c.isWeb),R.set("isEdge",A.indexOf("Edg/")>=0),R.set("isFirefox",A.indexOf("Firefox")>=0),R.set("isChrome",A.indexOf("Chrome")>=0),R.set("isSafari",A.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var S;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return y.INSTANCE}static true(){return n.INSTANCE}static has(u){return h.create(u)}static equals(u,M){return s.create(u,M)}static notEquals(u,M){return C.create(u,M)}static regex(u,M){return l.create(u,M)}static in(u,M){return d.create(u,M)}static not(u){return w.create(u)}static and(...u){return o.create(u,null)}static or(...u){return b.create(u,null,!0)}static greater(u,M){return a.create(u,M)}static less(u,M){return k.create(u,M)}static deserialize(u,M=!1){if(!!u)return this._deserializeOrExpression(u,M)}static _deserializeOrExpression(u,M){let O=u.split("||");return b.create(O.map(q=>this._deserializeAndExpression(q,M)),null,!0)}static _deserializeAndExpression(u,M){let O=u.split("&&");return o.create(O.map(q=>this._deserializeOne(q,M)),null)}static _deserializeOne(u,M){if(u=u.trim(),u.indexOf("!=")>=0){let O=u.split("!=");return C.create(O[0].trim(),this._deserializeValue(O[1],M))}if(u.indexOf("==")>=0){let O=u.split("==");return s.create(O[0].trim(),this._deserializeValue(O[1],M))}if(u.indexOf("=~")>=0){let O=u.split("=~");return l.create(O[0].trim(),this._deserializeRegexValue(O[1],M))}if(u.indexOf(" in ")>=0){let O=u.split(" in ");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const O=u.split(">=");return p.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const O=u.split(">");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const O=u.split("<=");return i.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const O=u.split("<");return k.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(u)?w.create(u.substr(1).trim()):h.create(u)}static _deserializeValue(u,M){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let O=/^'([^']*)'$/.exec(u);return O?O[1].trim():u}static _deserializeRegexValue(u,M){if((0,F.isFalsyOrWhitespace)(u)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=u.indexOf("/"),q=u.lastIndexOf("/");if(O===q||O<0){if(M)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let K=u.slice(O+1,q),$=u[q+1]==="i"?"i":"";try{return new RegExp(K,$)}catch(W){if(M)throw new Error(`bad regexp-value '${u}', parse error: ${W}`);return console.warn(`bad regexp-value '${u}', parse error: ${W}`),null}}}e.ContextKeyExpr=P;function t(E,u){return E.cmp(u)}class y{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class n{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class h{constructor(u,M){this.key=u,this.negated=M,this.type=2}static create(u,M=null){const O=R.get(u);return typeof O=="boolean"?O?n.INSTANCE:y.INSTANCE:new h(u,M)}cmp(u){return u.type!==this.type?this.type-u.type:m(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class s{constructor(u,M,O){this.key=u,this.value=M,this.negated=O,this.type=4}static create(u,M,O=null){if(typeof M=="boolean")return M?h.create(u,O):w.create(u,O);const q=R.get(u);return typeof q=="boolean"?M===(q?"true":"false")?n.INSTANCE:y.INSTANCE:new s(u,M,O)}cmp(u){return u.type!==this.type?this.type-u.type:D(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=s;class d{constructor(u,M){this.key=u,this.valueKey=M,this.type=10,this.negated=null}static create(u,M){return new d(u,M)}cmp(u){return u.type!==this.type?this.type-u.type:D(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}evaluate(u){const M=u.getValue(this.valueKey),O=u.getValue(this.key);return Array.isArray(M)?M.indexOf(O)>=0:typeof O=="string"&&typeof M=="object"&&M!==null?I.call(M,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=d;class v{constructor(u){this._actual=u,this.type=11}static create(u){return new v(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new v(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class C{constructor(u,M,O){this.key=u,this.value=M,this.negated=O,this.type=5}static create(u,M,O=null){if(typeof M=="boolean")return M?w.create(u,O):h.create(u,O);const q=R.get(u);return typeof q=="boolean"?M===(q?"true":"false")?y.INSTANCE:n.INSTANCE:new C(u,M,O)}cmp(u){return u.type!==this.type?this.type-u.type:D(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=C;class w{constructor(u,M){this.key=u,this.negated=M,this.type=3}static create(u,M=null){const O=R.get(u);return typeof O=="boolean"?O?y.INSTANCE:n.INSTANCE:new w(u,M)}cmp(u){return u.type!==this.type?this.type-u.type:m(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=w;class a{constructor(u,M,O){this.key=u,this.value=M,this.negated=O,this.type=12}static create(u,M,O=null){return new a(u,M,O)}cmp(u){return u.type!==this.type?this.type-u.type:D(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class p{constructor(u,M,O){this.key=u,this.value=M,this.negated=O,this.type=13}static create(u,M,O=null){return new p(u,M,O)}cmp(u){return u.type!==this.type?this.type-u.type:D(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=p;class k{constructor(u,M,O){this.key=u,this.value=M,this.negated=O,this.type=14}static create(u,M,O=null){return new k(u,M,O)}cmp(u){return u.type!==this.type?this.type-u.type:D(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=k;class i{constructor(u,M,O){this.key=u,this.value=M,this.negated=O,this.type=15}static create(u,M,O=null){return new i(u,M,O)}cmp(u){return u.type!==this.type?this.type-u.type:D(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class l{constructor(u,M){this.key=u,this.regexp=M,this.type=7,this.negated=null}static create(u,M){return new l(u,M)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const M=this.regexp?this.regexp.source:"",O=u.regexp?u.regexp.source:"";return M<O?-1:M>O?1:0}equals(u){if(u.type===this.type){const M=this.regexp?this.regexp.source:"",O=u.regexp?u.regexp.source:"";return this.key===u.key&&M===O}return!1}evaluate(u){let M=u.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=l;class r{constructor(u){this._actual=u,this.type=8}static create(u){return new r(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new r(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class o{constructor(u,M){this.expr=u,this.negated=M,this.type=6}static create(u,M){return o._normalizeArr(u,M)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let M=0,O=this.expr.length;M<O;M++){const q=t(this.expr[M],u.expr[M]);if(q!==0)return q}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let M=0,O=this.expr.length;M<O;M++)if(!this.expr[M].equals(u.expr[M]))return!1;return!0}return!1}evaluate(u){for(let M=0,O=this.expr.length;M<O;M++)if(!this.expr[M].evaluate(u))return!1;return!0}static _normalizeArr(u,M){const O=[];let q=!1;for(const K of u)if(!!K){if(K.type===1){q=!0;continue}if(K.type===0)return y.INSTANCE;if(K.type===6){O.push(...K.expr);continue}O.push(K)}if(O.length===0&&q)return n.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(t);for(let K=1;K<O.length;K++)O[K-1].equals(O[K])&&(O.splice(K,1),K--);if(O.length===1)return O[0];for(;O.length>1;){const K=O[O.length-1];if(K.type!==9)break;O.pop();const $=O.pop(),W=O.length===0,N=b.create(K.expr.map(H=>o.create([H,$],null)),null,W);N&&(O.push(N),O.sort(t))}return O.length===1?O[0]:new o(O,M)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let M of this.expr)u.push(...M.keys());return u}map(u){return new o(this.expr.map(M=>M.map(u)),null)}negate(){if(!this.negated){const u=[];for(let M of this.expr)u.push(M.negate());this.negated=b.create(u,this,!0)}return this.negated}}class b{constructor(u,M){this.expr=u,this.negated=M,this.type=9}static create(u,M,O){return b._normalizeArr(u,M,O)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let M=0,O=this.expr.length;M<O;M++){const q=t(this.expr[M],u.expr[M]);if(q!==0)return q}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let M=0,O=this.expr.length;M<O;M++)if(!this.expr[M].equals(u.expr[M]))return!1;return!0}return!1}evaluate(u){for(let M=0,O=this.expr.length;M<O;M++)if(this.expr[M].evaluate(u))return!0;return!1}static _normalizeArr(u,M,O){let q=[],K=!1;if(u){for(let $=0,W=u.length;$<W;$++){const N=u[$];if(!!N){if(N.type===0){K=!0;continue}if(N.type===1)return n.INSTANCE;if(N.type===9){q=q.concat(N.expr);continue}q.push(N)}}if(q.length===0&&K)return y.INSTANCE;q.sort(t)}if(q.length!==0){if(q.length===1)return q[0];for(let $=1;$<q.length;$++)q[$-1].equals(q[$])&&(q.splice($,1),$--);if(q.length===1)return q[0];if(O){for(let $=0;$<q.length;$++)for(let W=$+1;W<q.length;W++)T(q[$],q[W])&&(q.splice(W,1),W--);if(q.length===1)return q[0]}return new b(q,M)}}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let M of this.expr)u.push(...M.keys());return u}map(u){return new b(this.expr.map(M=>M.map(u)),null)}negate(){if(!this.negated){let u=[];for(let M of this.expr)u.push(M.negate());for(;u.length>1;){const M=u.shift(),O=u.shift(),q=[];for(const $ of g(M))for(const W of g(O))q.push(o.create([$,W],null));const K=u.length===0;u.unshift(b.create(q,null,K))}this.negated=u[0]}return this.negated}}class f extends h{constructor(u,M,O){super(u,null);this._defaultValue=M,typeof O=="object"?f._info.push({...O,key:u}):O!==!0&&f._info.push({key:u,description:O,type:M!=null?typeof M:void 0})}static all(){return f._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(u){return s.create(this.key,u)}notEqualsTo(u){return C.create(this.key,u)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(E,u){return E<u?-1:E>u?1:0}function D(E,u,M,O){return E<M?-1:E>M?1:u<O?-1:u>O?1:0}function T(E,u){if(u.type===6&&E.type!==9&&E.type!==6){for(const q of u.expr)if(E.equals(q))return!0}const M=E.negate(),O=g(M).concat(g(u));O.sort(t);for(let q=0;q<O.length;q++){const $=O[q].negate();for(let W=q+1;W<O.length;W++){const N=O[W];if($.equals(N))return!0}}return!1}e.implies=T;function g(E){return E.type===9?E.expr:[E]}}),define(we[141],be([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(we[25],be([0,1,9,4]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=_;function A(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class I{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,n){if(typeof y=="undefined"||y===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof y=="string"||typeof n=="string"){let h=typeof y=="string"?y:y.value,s=typeof n=="string"?n:n.value;return c.equalsIgnoreCase(h,s)}return y._lower===n._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=I;function S(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function P(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[142],be([0,1,9,25]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(s,d){return s.uuid&&d.uuid?s.uuid===d.uuid:s.id===d.id?!0:(0,c.compareIgnoreCase)(s.id,d.id)===0}e.areSameExtensions=_;class A{constructor(d,v){this.version=v,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof A?_(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=A;function R(s,d){return`${s}.${d}`}e.getExtensionId=R;function I(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function S(s,d){return I(R(s,d))}e.getGalleryExtensionId=S;function P(s,d){const v=[],C=w=>{for(const a of v)if(a.some(p=>_(d(p),d(w))))return a;return null};for(const w of s){const a=C(w);a?a.push(w):v.push([w])}return v}e.groupByExtension=P;function t(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function y(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function n(s){const d=new Set;for(const v of s)v.malicious&&d.add(v.id.id);return d}e.getMaliciousExtensionsSet=n;function h(s,d){const v=[],C=d.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const w=C.shift();if(w&&v.every(a=>!_(a.identifier,{id:w}))){const a=s.filter(p=>_(p.identifier,{id:w}));a.length===1&&(v.push(a[0]),C.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=h}),define(we[60],be([0,1,20,17,9,10,2,120,4]),function(ie,e,c,F,_,A,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function P($){return $.create===!0}e.isFileOpenForWriteOptions=P;var t;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var y;(function($){$[$.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var n;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h($){return!!($.capabilities&2)}e.hasReadWriteCapability=h;function s($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=s;function d($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function v($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=v;var C;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(W,N){super(W);this.code=N}}e.FileSystemProviderError=w;function a($,W){const N=new w($.toString(),W);return k(N,W),N}e.createFileSystemProviderError=a;function p($){return $||a((0,I.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=p;function k($,W){return $.name=W?`${W} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=k;function i($){if(!$)return C.Unknown;if($ instanceof w)return $.code;const W=/^(.+) \(FileSystemError\)$/.exec($.name);if(!W)return C.Unknown;switch(W[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=i;function l($){if($ instanceof D)return $.fileOperationResult;switch(i($)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var r;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class o{constructor(W,N,H){this.resource=W,this.operation=N,this.target=H}isOperation(W){return this.operation===W}}e.FileOperationEvent=o;var b;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(b=e.FileChangeType||(e.FileChangeType={}));class f{constructor(W,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const H of W)switch(H.type){case 1:this.added||(this.added=c.TernarySearchTree.forUris(()=>N)),this.added.set(H.resource,H);break;case 0:this.updated||(this.updated=c.TernarySearchTree.forUris(()=>N)),this.updated.set(H.resource,H);break;case 2:this.deleted||(this.deleted=c.TernarySearchTree.forUris(()=>N)),this.deleted.set(H.resource,H);break}}contains(W,...N){return this.doContains(W,{includeChildren:!1},...N)}affects(W,...N){return this.doContains(W,{includeChildren:!0},...N)}doContains(W,N,...H){if(!W)return!1;const V=H.length>0;return!!((!V||H.includes(1))&&(this.added?.get(W)||N.includeChildren&&this.added?.findSuperstr(W))||(!V||H.includes(0))&&(this.updated?.get(W)||N.includeChildren&&this.updated?.findSuperstr(W))||(!V||H.includes(2))&&(this.deleted?.findSubstr(W)||N.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function m($,W,N){return!$||!W||$===W||W.length>$.length?!1:(W.charAt(W.length-1)!==F.sep&&(W+=F.sep),N?(0,_.startsWithIgnoreCase)($,W):$.indexOf(W)===0)}e.isParent=m;class D extends Error{constructor(W,N,H){super(W);this.fileOperationResult=N,this.options=H}}e.FileOperationError=D;class T extends D{constructor(W,N,H){super(W,2,H);this.stat=N}}e.NotModifiedSinceFileOperationError=T;var g;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var E;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(E=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function u($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=u;async function M($,W){if(!W.canHandleResource(R.URI.from({scheme:$.scheme})))return new Promise(N=>{const H=W.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===$.scheme&&V.added&&(H.dispose(),N())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(W){return(0,A.isNumber)(W)||(W=0),W<O.KB?(0,I.localize)(1,null,W.toFixed(0)):W<O.MB?(0,I.localize)(2,null,(W/O.KB).toFixed(2)):W<O.GB?(0,I.localize)(3,null,(W/O.MB).toFixed(2)):W<O.TB?(0,I.localize)(4,null,(W/O.GB).toFixed(2)):(0,I.localize)(5,null,(W/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var q;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function K($){return{maxFileSize:$===0?300*O.MB:16*O.GB,maxHeapSize:$===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=K}),define(we[61],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(..._){this._entries=new Map;for(let[A,R]of _)this.set(A,R)}set(_,A){const R=this._entries.get(_);return this._entries.set(_,A),R}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=c}),define(we[143],be([0,1,14,16,81,138,4,61]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class P extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class t{constructor(s=new I.ServiceCollection,d=!1,v){this._activeInstantiations=new Set,this._services=s,this._strict=d,this._parent=v,this._services.set(R.IInstantiationService,this)}createChild(s){return new t(s,this._strict,this)}invokeFunction(s,...d){let v=n.traceInvocation(s),C=!1;try{return s({get:(a,p)=>{if(C)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const k=this._getOrCreateServiceInstance(a,v);if(!k&&p!==R.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return k}},...d)}finally{C=!0,v.stop()}}createInstance(s,...d){let v,C;return s instanceof _.SyncDescriptor?(v=n.traceCreation(s.ctor),C=this._createInstance(s.ctor,s.staticArguments.concat(d),v)):(v=n.traceCreation(s),C=this._createInstance(s,d,v)),v.stop(),C}_createInstance(s,d=[],v){let C=R._util.getServiceDependencies(s).sort((p,k)=>p.index-k.index),w=[];for(const p of C){let k=this._getOrCreateServiceInstance(p.id,v);if(!k&&this._strict&&!p.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${p.id}.`);w.push(k)}let a=C.length>0?C[0].index:d.length;if(d.length!==a){console.warn(`[createInstance] First service dependency of ${s.name} at position ${a+1} conflicts with ${d.length} static arguments`);let p=a-d.length;p>0?d=d.concat(new Array(p)):d=d.slice(0,a)}return new s(...[...d,...w])}_setServiceInstance(s,d){if(this._services.get(s)instanceof _.SyncDescriptor)this._services.set(s,d);else if(this._parent)this._parent._setServiceInstance(s,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let d=this._services.get(s);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):d}_getOrCreateServiceInstance(s,d){let v=this._getServiceInstanceOrDescriptor(s);return v instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,v,d.branch(s,!0)):(d.branch(s,!1),v)}_safeCreateAndCacheServiceInstance(s,d,v){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,d,v)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,d,v){const C=new A.Graph(p=>p.id.toString());let w=0;const a=[{id:s,desc:d,_trace:v}];for(;a.length;){const p=a.pop();if(C.lookupOrInsertNode(p),w++>1e3)throw new P(C);for(let k of R._util.getServiceDependencies(p.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(k.id);if(!i&&!k.optional&&console.warn(`[createInstance] ${s} depends on ${k.id} which is NOT registered.`),i instanceof _.SyncDescriptor){const l={id:k.id,desc:i,_trace:p._trace.branch(k.id,!0)};C.insertEdge(p,l),a.push(l)}}}for(;;){const p=C.roots();if(p.length===0){if(!C.isEmpty())throw new P(C);break}for(const{data:k}of p){if(this._getServiceInstanceOrDescriptor(k.id)instanceof _.SyncDescriptor){const l=this._createServiceInstanceWithOwner(k.id,k.desc.ctor,k.desc.staticArguments,k.desc.supportsDelayedInstantiation,k._trace);this._setServiceInstance(k.id,l)}C.removeNode(k)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,d,v=[],C,w){if(this._services.get(s)instanceof _.SyncDescriptor)return this._createServiceInstance(d,v,C,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,d,v,C,w);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(s,d=[],v,C){if(v){const w=new c.IdleValue(()=>this._createInstance(s,d,C));return new Proxy(Object.create(null),{get(a,p){if(p in a)return a[p];let k=w.value,i=k[p];return typeof i!="function"||(i=i.bind(k),a[p]=i),i},set(a,p,k){return w.value[p]=k,!0}})}else return this._createInstance(s,d,C)}}e.InstantiationService=t;var y;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(y||(y={}));class n{constructor(s,d){this.type=s,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return S?new n(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(s){return S?new n(0,s.name):n._None}branch(s,d){let v=new n(2,s.toString());return this._dep.push([s,d,v]),v}stop(){let s=Date.now()-this._start;n._totals+=s;let d=!1;function v(w,a){let p=[],k=new Array(w+1).join("	");for(const[i,l,r]of a._dep)if(l&&r){d=!0,p.push(`${k}CREATES -> ${i}`);let o=v(w+1,r);o&&p.push(o)}else p.push(`${k}uses -> ${i}`);return p.join(`
`)}let C=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(s>2||d)&&console.log(C.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(we[15],be([0,1,56,3,6,26,4]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function I(){return new Date().toISOString()}var S;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class P extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class t extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...l){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([i,...l]))}debug(i,...l){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([i,...l]))}info(i,...l){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([i,...l]))}warn(i,...l){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([i,...l]))}error(i,...l){if(this.checkLogLevel(S.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(S.Error,this.format(r))}else this.log(S.Error,this.format([i,...l]))}critical(i,...l){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([i,...l]))}flush(){}format(i){let l="";for(let r=0;r<i.length;r++){let o=i[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(b){}l+=(r>0?" ":"")+o}return l}}e.AbstractMessageLogger=t;class y extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...l){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...l):console.log(`[main ${I()}]`,i,...l))}debug(i,...l){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...l):console.log(`[main ${I()}]`,i,...l))}info(i,...l){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...l):console.log(`[main ${I()}]`,i,...l))}warn(i,...l){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,i,...l):console.warn(`[main ${I()}]`,i,...l))}error(i,...l){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,i,...l):console.error(`[main ${I()}]`,i,...l))}critical(i,...l){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,i,...l):console.error(`[main ${I()}]`,i,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class n extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...l){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",i,...l)}debug(i,...l){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...l)}info(i,...l){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",i,...l)}warn(i,...l){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",i,...l)}error(i,...l){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",i,...l)}critical(i,...l){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...l)}dispose(){}flush(){}}e.ConsoleLogger=n;class h extends P{constructor(i,l=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(l)}trace(i,...l){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(i),...l])}debug(i,...l){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(i),...l])}info(i,...l){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(i),...l])}warn(i,...l){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(i),...l])}error(i,...l){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(i),...l])}critical(i,...l){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(i),...l])}extractMessage(i){return typeof i=="string"?i:(0,c.toErrorMessage)(i,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class s extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const l of this.logServices)l.setLevel(i);super.setLevel(i)}trace(i,...l){for(const r of this.logServices)r.trace(i,...l)}debug(i,...l){for(const r of this.logServices)r.debug(i,...l)}info(i,...l){for(const r of this.logServices)r.info(i,...l)}warn(i,...l){for(const r of this.logServices)r.warn(i,...l)}error(i,...l){for(const r of this.logServices)r.error(i,...l)}critical(i,...l){for(const r of this.logServices)r.critical(i,...l)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=s;class d extends _.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...l){this.logger.trace(i,...l)}debug(i,...l){this.logger.debug(i,...l)}info(i,...l){this.logger.info(i,...l)}warn(i,...l){this.logger.warn(i,...l)}error(i,...l){this.logger.error(i,...l)}critical(i,...l){this.logger.critical(i,...l)}flush(){this.logger.flush()}}e.LogService=d;class v extends _.Disposable{constructor(i,l){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(l(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,l){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,l?.always?S.Trace:this.logLevel,l),this.loggers.set(i.toString(),r),l?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class C{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(i){}getLevel(){return S.Info}trace(i,...l){}debug(i,...l){}info(i,...l){}warn(i,...l){}error(i,...l){}critical(i,...l){}dispose(){}flush(){}}e.NullLogService=C;function w(k){if(k.verbose)return S.Trace;if(typeof k.logLevel=="string"){const i=a(k.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function a(k){switch(k){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=a;function p(k){switch(k){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=p}),define(we[82],be([0,1,35,121,4]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var R;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function P(s,d){return d-s}S.compare=P;const t=Object.create(null);t[S.Error]=(0,F.localize)(0,null),t[S.Warning]=(0,F.localize)(1,null),t[S.Info]=(0,F.localize)(2,null);function y(s){return t[s]||""}S.toString=y;function n(s){switch(s){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=n;function h(s){switch(s){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=h}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(S){const P="";function t(n){return y(n,!0)}S.makeKey=t;function y(n,h){let s=[P];return n.source?s.push(n.source.replace("\xA6","\\\xA6")):s.push(P),n.code?typeof n.code=="string"?s.push(n.code.replace("\xA6","\\\xA6")):s.push(n.code.value.replace("\xA6","\\\xA6")):s.push(P),n.severity!==void 0&&n.severity!==null?s.push(R.toString(n.severity)):s.push(P),n.message&&h?s.push(n.message.replace("\xA6","\\\xA6")):s.push(P),n.startLineNumber!==void 0&&n.startLineNumber!==null?s.push(n.startLineNumber.toString()):s.push(P),n.startColumn!==void 0&&n.startColumn!==null?s.push(n.startColumn.toString()):s.push(P),n.endLineNumber!==void 0&&n.endLineNumber!==null?s.push(n.endLineNumber.toString()):s.push(P),n.endColumn!==void 0&&n.endColumn!==null?s.push(n.endColumn.toString()):s.push(P),s.push(P),s.join("\xA6")}S.makeKeyOptionalMessage=y})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(we[144],be([0,1,3,35,4]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,_.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=I;class S{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=S}),define(we[145],be([0,1,6,9,2,4]),function(ie,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(I){return{resolved:I,dispose(){}}}});function R(I,S){return _.URI.isUri(I)?(0,F.equalsIgnoreCase)(I.scheme,S):(0,F.startsWithIgnoreCase)(I,S+":")}e.matchesScheme=R});var Ue=this&&this.__decorate||function(ie,e,c,F){var _=arguments.length,A=_<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,c):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,c,F);else for(var I=ie.length-1;I>=0;I--)(R=ie[I])&&(A=(_<3?R(A):_>3?R(e,c,A):R(e,c))||A);return _>3&&A&&Object.defineProperty(e,c,A),A},He=this&&this.__param||function(ie,e){return function(c,F){e(c,F,ie)}};define(we[146],be([0,1,14,21,6,4]),function(ie,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var R;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let S=class extends _.Disposable{constructor(y,n){super();this.deferred=new c.DeferredPromise,n.withProgress(y,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};S=Ue([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class P extends _.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(y){this.stop();const n=++this.currentOperationId,h=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:h.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(we[28],be([0,1,40,10]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(R,I){c.ok(F.isString(R)),c.ok(F.isObject(I)),c.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,I)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new _}),define(we[83],be([0,1,3,28]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,P){this.schemasById[_(S)]=P,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new A;F.Registry.add(e.Extensions.JSONContribution,R)}),define(we[62],be([0,1,3,10,118,83,28]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=R.Registry.as(A.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new c.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new c.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,a=!0){this.registerConfigurations([w],a)}registerConfigurations(w,a=!0){const p=[];w.forEach(k=>{p.push(...this.validateAndRegisterProperties(k,a,k.extensionInfo)),this.configurationContributors.push(k),this.registerJSONConfiguration(k)}),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(w){const a=[],p=k=>{if(k.properties)for(const i in k.properties)a.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,k.properties[i]);k.allOf&&k.allOf.forEach(i=>p(i))};for(const k of w){p(k);const i=this.configurationContributors.indexOf(k);i!==-1&&this.configurationContributors.splice(i,1)}P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(w){const a=[],p=[];for(const k of w)for(const i in k)if(a.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...k[i]};const l={type:"object",default:this.defaultValues[i],description:_.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};p.push(n(i)),this.configurationProperties[i]=l,this.defaultLanguageConfigurationOverridesNode.properties[i]=l}else{this.defaultValues[i]=k[i];const l=this.configurationProperties[i];l&&(this.updatePropertyDefaultValue(i,l),this.updateSchema(i,l))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(w){const a=[];for(const p of w)for(const k in p)if(a.push(k),delete this.defaultValues[k],e.OVERRIDE_PROPERTY_PATTERN.test(k))delete this.configurationProperties[k],delete this.defaultLanguageConfigurationOverridesNode.properties[k];else{const i=this.configurationProperties[k];i&&(this.updatePropertyDefaultValue(k,i),this.updateSchema(k,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const a of w)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,a=!0,p,k=3){k=F.isUndefinedOrNull(w.scope)?k:w.scope;let i=[],l=w.properties;if(l)for(let o in l){if(a&&d(o)){delete l[o];continue}const b=l[o];if(this.updatePropertyDefaultValue(o,b),e.OVERRIDE_PROPERTY_PATTERN.test(o)?b.scope=void 0:(b.scope=F.isUndefinedOrNull(b.scope)?k:b.scope,b.restricted=F.isUndefinedOrNull(b.restricted)?!!p?.restrictedConfigurations?.includes(o):b.restricted),l[o].hasOwnProperty("included")&&!l[o].included){this.excludedConfigurationProperties[o]=l[o],delete l[o];continue}else this.configurationProperties[o]=l[o];!l[o].deprecationMessage&&l[o].markdownDeprecationMessage&&(l[o].deprecationMessage=l[o].markdownDeprecationMessage),i.push(o)}let r=w.allOf;if(r)for(let o of r)i.push(...this.validateAndRegisterProperties(o,a,p,k));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const a=p=>{let k=p.properties;if(k)for(const l in k)this.updateSchema(l,k[l]);let i=p.allOf;i&&i.forEach(a)};a(w)}updateSchema(w,a){switch(e.allSettings.properties[w]=a,a.scope){case 1:e.applicationSettings.properties[w]=a;break;case 2:e.machineSettings.properties[w]=a;break;case 6:e.machineOverridableSettings.properties[w]=a;break;case 3:e.windowSettings.properties[w]=a;break;case 4:e.resourceSettings.properties[w]=a;break;case 5:e.resourceSettings.properties[w]=a,this.resourceLanguageSettingsSchema.properties[w]=a;break}}removeFromSchema(w,a){switch(delete e.allSettings.properties[w],a.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const a=`[${w}]`,p={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,p),e.allSettings.properties[a]=p,e.applicationSettings.properties[a]=p,e.machineSettings.properties[a]=p,e.machineOverridableSettings.properties[a]=p,e.windowSettings.properties[a]=p,e.resourceSettings.properties[a]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,a){let p=this.defaultValues[w];F.isUndefined(p)&&(p=a.default),F.isUndefined(p)&&(p=h(a.type)),a.default=p}}const y="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(y);function n(C){return C.substring(1,C.length-1)}e.overrideIdentifierFromKey=n;function h(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const s=new t;R.Registry.add(e.Extensions.Configuration,s);function d(C){return C.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(C)?_.localize(5,null,C):s.getConfigurationProperties()[C]!==void 0?_.localize(6,null,C):null:_.localize(4,null)}e.validateProperty=d;function v(){const C=[],w=s.getConfigurationProperties();for(const a of Object.keys(w))C.push([a,w[a].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=v}),define(we[84],be([0,1,22,10,2,62,4,28]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function S(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof _.URI)}e.isConfigurationOverrides=S;var P;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function y(l,r){const o=r?l?r.keys.filter(E=>l.keys.indexOf(E)===-1):[...r.keys]:[],b=l?r?l.keys.filter(E=>r.keys.indexOf(E)===-1):[...l.keys]:[],f=[];if(r&&l){for(const E of l.keys)if(r.keys.indexOf(E)!==-1){const u=C(l.contents,E),M=C(r.contents,E);c.equals(u,M)||f.push(E)}}const m=[],D=E=>{const u={};for(const M of E)for(const O of M.identifiers)u[k(O)]=M;return u},T=r?D(r.overrides):{},g=l?D(l.overrides):{};if(Object.keys(T).length)for(const E of o){const u=T[E];u&&m.push([(0,A.overrideIdentifierFromKey)(E),u.keys])}if(Object.keys(g).length)for(const E of b){const u=g[E];u&&m.push([(0,A.overrideIdentifierFromKey)(E),u.keys])}if(Object.keys(T).length&&Object.keys(g).length)for(const E of f){const u=g[E],M=T[E];if(u&&M){const O=y({contents:u.contents,keys:u.keys,overrides:[]},{contents:M.contents,keys:M.keys,overrides:[]});m.push([(0,A.overrideIdentifierFromKey)(E),[...O.added,...O.removed,...O.updated]])}}return{added:o,removed:b,updated:f,overrides:m}}e.compare=y;function n(l,r){const o=[];for(const b of Object.keys(l))if(A.OVERRIDE_PROPERTY_PATTERN.test(b)){const f={};for(const m in l[b])f[m]=l[b][m];o.push({identifiers:[(0,A.overrideIdentifierFromKey)(b).trim()],keys:Object.keys(f),contents:h(f,r)})}return o}e.toOverrides=n;function h(l,r){const o=Object.create(null);for(let b in l)s(o,b,l[b],r);return o}e.toValuesTree=h;function s(l,r,o,b){const f=r.split("."),m=f.pop();let D=l;for(let T=0;T<f.length;T++){let g=f[T],E=D[g];switch(typeof E){case"undefined":E=D[g]=Object.create(null);break;case"object":break;default:b(`Ignoring ${r} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify(E)}`);return}D=E}if(typeof D=="object"&&D!==null)try{D[m]=o}catch(T){b(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(D)}`)}else b(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=s;function d(l,r){const o=r.split(".");v(l,o)}e.removeFromValueTree=d;function v(l,r){const o=r.shift();if(r.length===0){delete l[o];return}if(Object.keys(l).indexOf(o)!==-1){const b=l[o];typeof b=="object"&&!Array.isArray(b)&&(v(b,r),Object.keys(b).length===0&&delete l[o])}}function C(l,r,o){function b(D,T){let g=D;for(const E of T){if(typeof g!="object"||g===null)return;g=g[E]}return g}const f=r.split("."),m=b(l,f);return typeof m=="undefined"?o:m}e.getConfigurationValue=C;function w(l,r,o){Object.keys(r).forEach(b=>{b!=="__proto__"&&(b in l?F.isObject(l[b])&&F.isObject(r[b])?w(l[b],r[b],o):o&&(l[b]=r[b]):l[b]=r[b])})}e.merge=w;function a(){const l=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(l)}e.getConfigurationKeys=a;function p(){const l=Object.create(null),r=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let o in r){let b=r[o].default;s(l,o,b,f=>console.error(`Conflict in default settings: ${f}`))}return l}e.getDefaultValues=p;function k(l){return`[${l}]`}e.keyFromOverrideIdentifier=k;function i(l,r,o){const b=l.inspect(r),f=l.inspect(o);return typeof b.userValue!="undefined"||typeof b.workspaceValue!="undefined"||typeof b.workspaceFolderValue!="undefined"?b.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:b.defaultValue}e.getMigratedSettingValue=i}),define(we[147],be([0,1,13,3,102,6,20,22,10,2,84,62,28]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(i={},l=[],r=[]){this._contents=i,this._keys=l,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,l){const r=this.getContentsForOverrideIdentifer(l);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const l of this.overrides)if(l.identifiers.indexOf(i)!==-1)return l.keys;return[]}override(i){const l=this.getContentsForOverrideIdentifer(i);if(!l||typeof l!="object"||!Object.keys(l).length)return this;let r={};for(const o of c.distinct([...Object.keys(this.contents),...Object.keys(l)])){let b=this.contents[o],f=l[o];f&&(typeof b=="object"&&typeof f=="object"?(b=I.deepClone(b),this.mergeContents(b,f)):b=f),r[o]=b}return new h(r,this.keys,this.overrides)}merge(...i){const l=I.deepClone(this.contents),r=I.deepClone(this.overrides),o=[...this.keys];for(const b of i){this.mergeContents(l,b.contents);for(const f of b.overrides){const[m]=r.filter(D=>c.equals(D.identifiers,f.identifiers));m?this.mergeContents(m.contents,f.contents):r.push(I.deepClone(f))}for(const f of b.keys)o.indexOf(f)===-1&&o.push(f)}return new h(l,o,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,l){for(const r of Object.keys(l)){if(r in i&&S.isObject(i[r])&&S.isObject(l[r])){this.mergeContents(i[r],l[r]);continue}i[r]=I.deepClone(l[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const l of this.overrides)if(l.identifiers.indexOf(i)!==-1)return l.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,l){this.addKey(i),(0,t.addToValueTree)(this.contents,i,l,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let l=this.keys.length;for(let r=0;r<l;r++)i.indexOf(this.keys[r])===0&&(l=r);this.keys.splice(l,1,i)}removeKey(i){let l=this.keys.indexOf(i);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=h;class s extends h{constructor(){const i=(0,t.getDefaultValues)(),l=(0,t.getConfigurationKeys)(),r=[];for(const o of Object.keys(i))y.OVERRIDE_PROPERTY_PATTERN.test(o)&&r.push({identifiers:[(0,y.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(i[o]),contents:(0,t.toValuesTree)(i[o],b=>console.error(`Conflict in default settings file: ${b}`))});super(i,l,r)}}e.DefaultConfigurationModel=s;class d{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,l){if(!S.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,l)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,l){this._raw=i;const{contents:r,keys:o,overrides:b,restricted:f}=this.doParseRaw(i,l);this._configurationModel=new h(r,o,b),this._restrictedConfigurations=f||[]}doParseContent(i){let l={},r=null,o=[],b=[],f=[];function m(T){Array.isArray(o)?o.push(T):r!==null&&(o[r]=T)}let D={onObjectBegin:()=>{let T={};m(T),b.push(o),o=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{o=b.pop()},onArrayBegin:()=>{let T=[];m(T),b.push(o),o=T,r=null},onArrayEnd:()=>{o=b.pop()},onLiteralValue:m,onError:(T,g,E)=>{f.push({error:T,offset:g,length:E})}};if(i)try{_.visit(i,D),l=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return l}doParseRaw(i,l){const r=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,r,!0,l);i=o.raw;const b=(0,t.toValuesTree)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),f=Object.keys(i),m=(0,t.toOverrides)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:b,keys:f,overrides:m,restricted:o.restricted}}filter(i,l,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const b={},f=[];for(let m in i)if(y.OVERRIDE_PROPERTY_PATTERN.test(m)&&r){const D=this.filter(i[m],l,!1,o);b[m]=D.raw,f.push(...D.restricted)}else{const D=l[m],T=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&f.push(m),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&(o.skipRestricted&&D?.restricted||(b[m]=i[m]))}return{raw:b,restricted:f}}}e.ConfigurationModelParser=d;class v extends A.Disposable{constructor(i,l,r,o){super();this.userSettingsResource=i,this.scopes=l,this.fileService=o,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,b=>b.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class C{constructor(i,l,r=new h,o=new h,b=new R.ResourceMap,f=new h,m=new R.ResourceMap,D=!0){this._defaultConfiguration=i,this._localUserConfiguration=l,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=b,this._memoryConfiguration=f,this._memoryConfigurationByResource=m,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(i,l,r){return this.getConsolidateConfigurationModel(l,r).getValue(i)}updateValue(i,l,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new h,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,l===void 0?o.removeValue(i):o.setValue(i,l),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,l,r){const o=this.getConsolidateConfigurationModel(l,r),b=this.getFolderConfigurationModelForResource(l.resource,r),f=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,m=l.overrideIdentifier?this._defaultConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),D=l.overrideIdentifier?this.userConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),T=l.overrideIdentifier?this.localUserConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),g=l.overrideIdentifier?this.remoteUserConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),E=r?l.overrideIdentifier?this._workspaceConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,u=b?l.overrideIdentifier?b.freeze().override(l.overrideIdentifier).getValue(i):b.freeze().getValue(i):void 0,M=l.overrideIdentifier?f.override(l.overrideIdentifier).getValue(i):f.getValue(i),O=o.getValue(i),q=c.distinct(c.flatten(o.overrides.map(K=>K.identifiers))).filter(K=>o.getOverrideValue(i,K)!==void 0);return{defaultValue:m,userValue:D,userLocalValue:T,userRemoteValue:g,workspaceValue:E,workspaceFolderValue:u,memoryValue:M,value:O,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,workspace:E!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,workspaceFolder:u!==void 0?{value:b?.freeze().getValue(i),override:l.overrideIdentifier?b?.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:f.getValue(i),override:l.overrideIdentifier?f.getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(i){const l=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,l){this._folderConfigurations.set(i,l),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,l){const r=l.filter(o=>y.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const b=(0,y.overrideIdentifierFromKey)(o),f=this._defaultConfiguration.getKeysForOverrideIdentifier(b),m=i.getKeysForOverrideIdentifier(b),D=[...m.filter(T=>f.indexOf(T)===-1),...f.filter(T=>m.indexOf(T)===-1),...f.filter(T=>!I.equals(this._defaultConfiguration.override(b).getValue(T),i.override(b).getValue(T)))];return[b,D]});return this.updateDefaultConfiguration(i),{keys:l,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:l,updated:r,removed:o,overrides:b}=(0,t.compare)(this.localUserConfiguration,i),f=[...l,...r,...o];return f.length&&this.updateLocalUserConfiguration(i),{keys:f,overrides:b}}compareAndUpdateRemoteUserConfiguration(i){const{added:l,updated:r,removed:o,overrides:b}=(0,t.compare)(this.remoteUserConfiguration,i);let f=[...l,...r,...o];return f.length&&this.updateRemoteUserConfiguration(i),{keys:f,overrides:b}}compareAndUpdateWorkspaceConfiguration(i){const{added:l,updated:r,removed:o,overrides:b}=(0,t.compare)(this.workspaceConfiguration,i);let f=[...l,...r,...o];return f.length&&this.updateWorkspaceConfiguration(i),{keys:f,overrides:b}}compareAndUpdateFolderConfiguration(i,l){const r=this.folderConfigurations.get(i),{added:o,updated:b,removed:f,overrides:m}=(0,t.compare)(r,l);let D=[...o,...b,...f];return(D.length||!r)&&this.updateFolderConfiguration(i,l),{keys:D,overrides:m}}compareAndDeleteFolderConfiguration(i){const l=this.folderConfigurations.get(i);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:b,overrides:f}=(0,t.compare)(l,void 0);return{keys:[...r,...o,...b],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,l){let r=this.getConsolidatedConfigurationModelForResource(i,l);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},l){let r=this.getWorkspaceConsolidatedConfiguration();if(l&&i){const o=l.getFolder(i);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const b=this._memoryConfigurationByResource.get(i);b&&(r=r.merge(b))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let l=this._foldersConsolidatedConfigurations.get(i);if(!l){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(l=r.merge(o),this._freeze&&(l=l.freeze()),this._foldersConsolidatedConfigurations.set(i,l)):l=r}return l}getFolderConfigurationModelForResource(i,l){if(l&&i){const r=l.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,l)=>{const{contents:r,overrides:o,keys:b}=this._folderConfigurations.get(l);return i.push([l,{contents:r,overrides:o,keys:b}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(l=>i.add(l)),this.userConfiguration.freeze().keys.forEach(l=>i.add(l)),this._workspaceConfiguration.freeze().keys.forEach(l=>i.add(l)),this._folderConfigurations.forEach(l=>l.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>l.add(o))),[...l.values()]}static parse(i){const l=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),b=i.folders.reduce((f,m)=>(f.set(P.URI.revive(m[0]),this.parseConfigurationModel(m[1])),f),new R.ResourceMap);return new C(l,r,new h,o,b,new h,new R.ResourceMap,!1)}static parseConfigurationModel(i){return new h(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=C;function w(...k){if(k.length===0)return{keys:[],overrides:[]};if(k.length===1)return k[0];const i=new Set,l=new Map;for(const o of k)o.keys.forEach(b=>i.add(b)),o.overrides.forEach(([b,f])=>{const m=(0,R.getOrSet)(l,b,new Set);f.forEach(D=>m.add(D))});const r=[];return l.forEach((o,b)=>r.push([b,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=w;class a{constructor(i,l,r,o){this.change=i,this.previous=l,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const b=new Set;i.keys.forEach(m=>b.add(m)),i.overrides.forEach(([,m])=>m.forEach(D=>b.add(D))),this.affectedKeys=[...b.values()];const f=new h;this.affectedKeys.forEach(m=>f.setValue(m,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,l){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(l){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,l,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,l,this.currentWorkspace);return!I.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(i,l){let r=(0,t.toValuesTree)({[l]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(i=i[o],!i)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=a;class p extends a{constructor(i,l,r,o){super({keys:i.allKeys(),overrides:[]},void 0,i,l);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=p}),define(we[85],be([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var F;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(R,I=F.Unknown,S){super(R);this._message=R,this._code=I,this._detail=S,this.isHandled=I===F.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(R){return R instanceof _&&R._code===F.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof _&&R._code===F.NoResolverFound}static isHandled(R){return R instanceof _&&R.isHandled}}e.RemoteAuthorityResolverError=_}),define(we[86],be([0,1,11]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(P){return P.scheme===c.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=F;function _(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=_;function A(P){return P.scheme!==c.Schemas.file&&P.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=A;function R(P){if(P.folders.length)return P.folders.every(t=>A(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&A(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=R;function I(P){return R(P)?.scheme}e.getVirtualWorkspaceScheme=I;function S(P){return R(P)!==void 0}e.isVirtualWorkspace=S}),define(we[148],be([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var F;(function(s){s.Shell="terminal.integrated.shell.",s.ShellArgs="terminal.integrated.shellArgs.",s.DefaultProfile="terminal.integrated.defaultProfile.",s.Profiles="terminal.integrated.profiles."})(F=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var _;(function(s){s.ShellLinux="terminal.integrated.shell.linux",s.ShellMacOs="terminal.integrated.shell.osx",s.ShellWindows="terminal.integrated.shell.windows",s.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",s.AutomationShellLinux="terminal.integrated.automationShell.linux",s.AutomationShellMacOs="terminal.integrated.automationShell.osx",s.AutomationShellWindows="terminal.integrated.automationShell.windows",s.ShellArgsLinux="terminal.integrated.shellArgs.linux",s.ShellArgsMacOs="terminal.integrated.shellArgs.osx",s.ShellArgsWindows="terminal.integrated.shellArgs.windows",s.ProfilesWindows="terminal.integrated.profiles.windows",s.ProfilesMacOs="terminal.integrated.profiles.osx",s.ProfilesLinux="terminal.integrated.profiles.linux",s.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",s.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",s.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",s.UseWslProfiles="terminal.integrated.useWslProfiles",s.TabsEnabled="terminal.integrated.tabs.enabled",s.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",s.TabsHideCondition="terminal.integrated.tabs.hideCondition",s.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",s.TabsShowActions="terminal.integrated.tabs.showActions",s.TabsLocation="terminal.integrated.tabs.location",s.TabsFocusMode="terminal.integrated.tabs.focusMode",s.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",s.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",s.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",s.CopyOnSelection="terminal.integrated.copyOnSelection",s.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",s.FontFamily="terminal.integrated.fontFamily",s.FontSize="terminal.integrated.fontSize",s.LetterSpacing="terminal.integrated.letterSpacing",s.LineHeight="terminal.integrated.lineHeight",s.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",s.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",s.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",s.BellDuration="terminal.integrated.bellDuration",s.FontWeight="terminal.integrated.fontWeight",s.FontWeightBold="terminal.integrated.fontWeightBold",s.CursorBlinking="terminal.integrated.cursorBlinking",s.CursorStyle="terminal.integrated.cursorStyle",s.CursorWidth="terminal.integrated.cursorWidth",s.Scrollback="terminal.integrated.scrollback",s.DetectLocale="terminal.integrated.detectLocale",s.DefaultLocation="terminal.integrated.defaultLocation",s.GpuAcceleration="terminal.integrated.gpuAcceleration",s.RightClickBehavior="terminal.integrated.rightClickBehavior",s.Cwd="terminal.integrated.cwd",s.ConfirmOnExit="terminal.integrated.confirmOnExit",s.ConfirmOnKill="terminal.integrated.confirmOnKill",s.EnableBell="terminal.integrated.enableBell",s.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",s.AllowChords="terminal.integrated.allowChords",s.AllowMnemonics="terminal.integrated.allowMnemonics",s.EnvMacOs="terminal.integrated.env.osx",s.EnvLinux="terminal.integrated.env.linux",s.EnvWindows="terminal.integrated.env.windows",s.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",s.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",s.ShowExitAlert="terminal.integrated.showExitAlert",s.SplitCwd="terminal.integrated.splitCwd",s.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",s.WordSeparators="terminal.integrated.wordSeparators",s.TitleMode="terminal.integrated.titleMode",s.EnableFileLinks="terminal.integrated.enableFileLinks",s.UnicodeVersion="terminal.integrated.unicodeVersion",s.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",s.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",s.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",s.LocalEchoStyle="terminal.integrated.localEchoStyle",s.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",s.CustomGlyphs="terminal.integrated.customGlyphs",s.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",s.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",s.InheritEnv="terminal.integrated.inheritEnv",s.ShowLinkHover="terminal.integrated.showLinkHover"})(_=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(s){s.CommandPrompt="cmd",s.PowerShell="pwsh",s.Wsl="wsl",s.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var R;(function(s){s[s.Api=0]="Api",s[s.Process=1]="Process",s[s.Sequence=2]="Sequence"})(R=e.TitleEventSource||(e.TitleEventSource={}));var I;(function(s){s.LocalPty="localPty",s.PtyHost="ptyHost",s.Log="log",s.Heartbeat="heartbeat"})(I=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,c.createDecorator)("ptyService");var S;(function(s){s[s.BeatInterval=5e3]="BeatInterval",s[s.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",s[s.SecondWaitMultiplier=1]="SecondWaitMultiplier",s[s.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(s){s[s.Panel=1]="Panel",s[s.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var t;(function(s){s.TerminalView="view",s.Editor="editor"})(t=e.TerminalLocationString||(e.TerminalLocationString={}));var y;(function(s){s[s.GraceTime=6e4]="GraceTime",s[s.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var n;(function(s){s[s.HighWatermarkChars=1e5]="HighWatermarkChars",s[s.LowWatermarkChars=5e3]="LowWatermarkChars",s[s.CharCountAckSize=5e3]="CharCountAckSize"})(n=e.FlowControlConstants||(e.FlowControlConstants={}));var h;(function(s){s.GitBash="Git Bash",s.Pwsh="PowerShell"})(h=e.ProfileSource||(e.ProfileSource={}))}),define(we[149],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,A,R=5){let I;return I=A(S=>{const P=typeof S=="string"?S:S.data;let t=this._terminalBufferMap.get(_);if(t){t.data.push(P);return}const y=setTimeout(()=>this.flushBuffer(_),R);t={data:[P],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(_),I.dispose()}},this._terminalBufferMap.set(_,t)}),I}stopBuffering(_){const A=this._terminalBufferMap.get(_);A&&A.dispose()}flushBuffer(_){const A=this._terminalBufferMap.get(_);A&&(this._terminalBufferMap.delete(_),this._callback(_,A.data.join("")))}}e.TerminalDataBufferer=c}),define(we[150],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var c;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(c=e.ColorScheme||(e.ColorScheme={}))}),define(we[44],be([0,1,34,3,6,4,28,150]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(v){function C(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=C})(S=e.ThemeColor||(e.ThemeColor={}));function P(v){return{id:v}}e.themeColorFromId=P;var t;(function(v){function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color=="undefined"||S.isThemeColor(l.color))}v.isThemeIcon=C;const w=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function a(l){const r=w.exec(l);if(!r)return;let[,o]=r;return{id:o}}v.fromString=a;function p(l,r){let o=l.id;const b=o.lastIndexOf("~");return b!==-1&&(o=o.substring(0,b)),r&&(o=`${o}~${r}`),{id:o}}v.modify=p;function k(l,r){return l.id===r.id&&l.color?.id===r.color?.id}v.isEqual=k;function i(l,r){return{id:l.id,color:r?P(r):void 0}}v.asThemeIcon=i,v.asClassNameArray=c.CSSIcon.asClassNameArray,v.asClassName=c.CSSIcon.asClassName,v.asCSSSelector=c.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function y(v){switch(v){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(C){return this.themingParticipants.push(C),this.onThemingParticipantAddedEmitter.fire(C),(0,_.toDisposable)(()=>{const w=this.themingParticipants.indexOf(C);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new n;R.Registry.add(e.Extensions.ThemingContribution,h);function s(v){return h.onColorThemeChange(v)}e.registerThemingParticipant=s;class d extends _.Disposable{constructor(C){super();this.themeService=C,this.theme=C.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(C){this.theme=C,this.updateStyles()}updateStyles(){}getColor(C,w){let a=this.theme.getColor(C);return a&&w&&(a=w(a,this.theme)),a?a.toString():null}}e.Themable=d}),define(we[151],be([0,1,14,34,3,122,83,28,44]),function(ie,e,c,F,_,A,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${F.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(C,w,a,p){const k=this.iconsById[C];if(k){if(a&&!k.description){k.description=a,this.iconSchema.properties[C].markdownDescription=`${a} $(${C})`;const r=this.iconReferenceSchema.enum.indexOf(C);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=a),this._onDidChange.fire()}return k}let i={id:C,description:a,defaults:w,deprecationMessage:p};this.iconsById[C]=i;let l={$ref:"#/definitions/icons"};return p&&(l.deprecationMessage=p),a&&(l.markdownDescription=`${a}: $(${C})`),this.iconSchema.properties[C]=l,this.iconReferenceSchema.enum.push(C),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:C}}deregisterIcon(C){delete this.iconsById[C],delete this.iconSchema.properties[C];const w=this.iconReferenceSchema.enum.indexOf(C);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(C=>this.iconsById[C])}getIcon(C){return this.iconsById[C]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(C,w){const a=this.iconFontsById[C];if(a)return a;let p={id:C,definition:w};return this.iconFontsById[C]=p,this._onDidChange.fire(),p}deregisterIconFont(C){delete this.iconFontsById[C]}getIconFonts(){return Object.keys(this.iconFontsById).map(C=>this.iconFontsById[C])}getIconFont(C){return this.iconFontsById[C]}toString(){const C=(k,i)=>k.id.localeCompare(i.id),w=k=>{for(;S.ThemeIcon.isThemeIcon(k.defaults);)k=this.iconsById[k.defaults.id];return`codicon codicon-${k?k.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const p=Object.keys(this.iconsById).map(k=>this.iconsById[k]);for(const k of p.filter(i=>!!i.description).sort(C))a.push(`|<i class="${w(k)}"></i>|${k.id}|${S.ThemeIcon.isThemeIcon(k.defaults)?k.defaults.id:k.id}|${k.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const k of p.filter(i=>!S.ThemeIcon.isThemeIcon(i.defaults)).sort(C))a.push(`|<i class="${w(k)}"></i>|${k.id}|`);return a.join(`
`)}}const t=new P;I.Registry.add(e.Extensions.IconContribution,t);function y(v,C,w,a){return t.registerIcon(v,C,w,a)}e.registerIcon=y;function n(){return t}e.getIconRegistry=n;function h(){for(const v of F.iconRegistry.all)t.registerIcon(v.id,v.definition,v.description);F.iconRegistry.onDidRegister(v=>t.registerIcon(v.id,v.definition,v.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let s=I.Registry.as(R.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,t.getIconSchema());const d=new c.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=y("widget-close",F.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=y("goto-previous-location",F.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=y("goto-next-location",F.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=S.ThemeIcon.modify(F.Codicon.sync,"spin")}),define(we[45],be([0,1,20,24,2,4]),function(ie,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var R;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function I(n){const h=n;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=I;function S(n){const h=n;return!!(h&&typeof h=="object"&&_.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=S;class P{constructor(h,s,d,v){this._id=h,this._configuration=d,this._ignorePathCasing=v,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class t{constructor(h,s){this.raw=s,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,F.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function y(n){return new t({uri:n,index:0,name:(0,F.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=y}),define(we[63],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const A=this._idPool++;return this._data.set(A,_),this.logDebugInfo(),A}get(_,A){return this._data.has(_)?this._data.get(_)[A]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(we[37],be([0,1,11,24,4]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(I=>{const S=this._providerInfo.get(I.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(I,S){S===null?this._providerInfo.delete(I):this._providerInfo.set(I,S)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,_.createDecorator)("IExtHostFileSystemInfo")}),define(we[29],be([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(we[152],be([0,1,14]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(R,I,S){this._deferredPromises=new Map,this._id=R,this._shared=I,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const y of P.values())y.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,I){let S=this._value[R];return typeof S=="undefined"&&(S=I),S}update(R,I){this._value[R]=I;let S=this._deferredPromises.get(R);if(S!==void 0)return S.p;const P=new c.DeferredPromise;return this._deferredPromises.set(R,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class _ extends F{constructor(R,I){super(R.identifier.value,!0,I);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=_}),define(we[153],be([0,1,3,2,15]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(I,S){this._logService=I,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new c.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,S,P){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I)).acceptModelChanged(S.value,P)}$acceptDirtyStateChanged(I,S){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I)).acceptDirty(S)}$acceptModelSaved(I){const S=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(I,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,S);const P=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I));P.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};A=Ue([He(0,_.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(we[12],be([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class F{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=F});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[154],be([0,1,25,3]),function(ie,e,c,F){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(I,S){_.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(I.identifier),Je(this,_,S,"f"),Te(this,_,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(I){return Te(this,_,"f").get(this._id,I)}store(I,S){return Te(this,_,"f").store(this._id,I,S)}delete(I){return Te(this,_,"f").delete(this._id,I)}}e.ExtensionSecrets=A,_=new WeakMap}),define(we[87],be([0,1,4,3]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(we[46],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var c;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(c=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,_=(w,a)=>{const p={controllerId:a};return F.set(w,p),p};e.createPrivateApiFor=_;const A=w=>F.get(w);e.getPrivateApiFor=A;const R=(w,a,p,k)=>{let i=p;return{enumerable:!0,configurable:!1,get(){return i},set(l){if(!k(i,l)){const r=i;i=l,w.listener?.({op:3,key:a,value:l,previous:r})}}}},I=(w,a)=>w===a,S={range:(w,a)=>w===a?!0:!w||!a?!1:w.isEqual(a),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(w,a)=>!(w.length!==a.length||w.some(p=>!a.find(k=>p.id===k.id)))},P=Object.keys(S),t=(w,a)=>({range:R(w,"range",void 0,S.range),label:R(w,"label",a,S.label),description:R(w,"description",void 0,S.description),canResolveChildren:R(w,"canResolveChildren",!1,S.canResolveChildren),busy:R(w,"busy",!1,S.busy),error:R(w,"error",void 0,S.error),tags:R(w,"tags",[],S.tags)}),y=(w,a)=>{const p=new Map;for(const k of P)S[k](w[k],a[k])||p.set(k,a[k]);return p};e.diffTestItems=y;class n extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=n;class h extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class s extends Error{constructor(a,p,k){super(`TestItem with ID "${a}" is from controller "${p}" and cannot be added as a child of an item from controller "${k}".`)}}e.MixedTestItemController=s;const d=w=>{const a=(0,e.getPrivateApiFor)(w);let p=new Map;return{get size(){return p.size},forEach(k,i){for(const l of p.values())k.call(i,l,this)},replace(k){const i=new Map,l=new Set(p.keys()),r={op:4,ops:[]};for(const o of k){if(!(o instanceof v))throw new h(o.id);const b=(0,e.getPrivateApiFor)(o).controllerId;if(b!==a.controllerId)throw new s(o.id,b,a.controllerId);if(i.has(o.id))throw new n(o.id);i.set(o.id,o),l.delete(o.id),r.ops.push({op:0,item:o})}for(const o of l.keys())r.ops.push({op:1,id:o});a.listener?.(r),p=i},add(k){if(!(k instanceof v))throw new h(k.id);p.set(k.id,k),a.listener?.({op:0,item:k})},delete(k){p.delete(k)&&a.listener?.({op:1,id:k})},get(k){return p.get(k)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class v{constructor(a,p,k,i){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const l=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof C?void 0:l.parent}},children:{value:d(this),enumerable:!0,writable:!1},...t(l,k)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class C extends v{constructor(a,p){super(a,a,p,void 0)}}e.TestItemRootImpl=C}),define(we[64],be([0,1,4,3,12]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(I){function S(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}I.fromApiTunnel=S;function P(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}I.fromServiceTunnel=P})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let R=class{constructor(S){this.onDidChangeTunnels=new F.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,P){return{dispose:()=>{}}}async $providePortAttributes(S,P,t,y,n){return[]}async $forwardPort(S,P){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ue([He(0,_.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[7],be([0,1,13,16,76,20,78,10,2,36,60,85]),function(ie,e,c,F,_,A,R,I,S,P,t,y){"use strict";var n,h,s,d,v,C,w,a,p,k,i,l,r,o,b,f,m,D,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function E(x){function L(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(L,x),Object.setPrototypeOf(L.prototype,x.prototype),L}let u=v=class{constructor(L){n.set(this,void 0),Je(this,n,L,"f")}static from(...L){let te=L;return new v(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof Te(this,n,"f")=="function"&&(Te(this,n,"f").call(this),Je(this,n,void 0,"f"))}};n=new WeakMap,u=v=Ue([E],u),e.Disposable=u;let M=C=class{constructor(L,te){if(L<0)throw(0,F.illegalArgument)("line must be non-negative");if(te<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ke=L[_e];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ke=L[_e];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(L){if(!L)return!1;if(L instanceof C)return!0;let{line:te,character:_e}=L;return typeof te=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,F.illegalArgument)();let _e;return typeof L=="undefined"?_e=0:typeof L=="number"?_e=L:(_e=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),_e===0&&te===0?this:new C(this.line+_e,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,F.illegalArgument)();let _e;return typeof L=="undefined"?_e=this.line:typeof L=="number"?_e=L:(_e=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),_e===this.line&&te===this.character?this:new C(_e,te)}toJSON(){return{line:this.line,character:this.character}}};M=C=Ue([E],M),e.Position=M;let O=w=class{constructor(L,te,_e,Ke){let et,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new M(L,te),st=new M(_e,Ke)):L instanceof M&&te instanceof M&&(et=L,st=te),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(L){return L instanceof w?!0:L?M.isPosition(L.start)&&M.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof w?this.contains(L._start)&&this.contains(L._end):L instanceof M?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=M.Max(L.start,this._start),_e=M.Min(L.end,this._end);if(!te.isAfter(_e))return new w(te,_e)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=M.Min(L.start,this._start),_e=M.Max(L.end,this.end);return new w(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,F.illegalArgument)();let _e;return L?M.isPosition(L)?_e=L:(_e=L.start||this.start,te=L.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new w(_e,te)}toJSON(){return[this.start,this.end]}};O=w=Ue([E],O),e.Range=O;let q=a=class extends O{constructor(L,te,_e,Ke){let et,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new M(L,te),st=new M(_e,Ke)):L instanceof M&&te instanceof M&&(et=L,st=te),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(L){return L instanceof a?!0:L?O.isRange(L)&&M.isPosition(L.anchor)&&M.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};q=a=Ue([E],q),e.Selection=q;class K{constructor(L,te,_e){if(typeof L!="string"||L.length===0)throw(0,F.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,F.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,F.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=K;class $ extends Error{constructor(L,te=y.RemoteAuthorityResolverErrorCode.Unknown,_e){super(L);this._message=L,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(L,te){return new $(L,y.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new $(L,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var W;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var N;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(N=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let H=p=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof p?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new p(L,te)}static insert(L,te){return p.replace(new O(L,L),te)}static delete(L){return p.replace(L,"")}static setEndOfLine(L){const te=new p(new O(new M(0,0),new M(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!O.isRange(L))throw(0,F.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,F.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,F.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};H=p=Ue([E],H),e.TextEdit=H;var V;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(V=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,_e,Ke){this._edits.push({_type:1,from:L,to:te,options:_e,metadata:Ke})}createFile(L,te,_e){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:_e})}deleteFile(L,te,_e){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(L,te,_e){this._edits.push({_type:3,metadata:_e,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,_e,Ke,et){let st,at,yt=[],At;if(zt.isNotebookRange(te)&&Mt.isNotebookCellDataArray(_e)&&!Mt.isNotebookCellDataArray(Ke)?(st=te.start,at=te.end,yt=_e,At=Ke):typeof te=="number"&&typeof _e=="number"&&Mt.isNotebookCellDataArray(Ke)&&(st=te,at=_e,yt=Ke,At=et),st===void 0||at===void 0)throw new Error("Invalid arguments");(st!==at||yt.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:at-st,cells:yt,metadata:At})}replaceNotebookCellMetadata(L,te,_e,Ke){this._edits.push({_type:3,metadata:Ke,uri:L,edit:{editType:8,index:te,metadata:_e}})}replace(L,te,_e,Ke){this._edits.push({_type:2,uri:L,edit:new H(te,_e),metadata:Ke})}insert(L,te,_e,Ke){this.replace(L,new O(te,te),_e,Ke)}delete(L,te,_e){this.replace(L,te,"",_e)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const _e of te)_e&&this._edits.push({_type:2,uri:L,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ke=this._edits[_e];Ke._type===2&&Ke.uri.toString()===L.toString()&&(this._edits[_e]=void 0)}(0,c.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===L.toString()&&te.push(_e.edit);return te}entries(){const L=new A.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=L.get(te.uri);_e||(_e=[te.uri,[]],L.set(te.uri,_e)),_e[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=Ue([E],Y),e.WorkspaceEdit=Y;let ce=k=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof k?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=k._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const _e=new k;_e._tabstop=this._tabstop,L(_e),this._tabstop=_e._tabstop,L=_e.value}else L=k._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const _e=L.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const _e=new k;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ce=k=Ue([E],ce),e.SnippetString=ce;var G;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(G=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=i=class{constructor(L,te){if(this.uri=L,te)if(te instanceof O)this.range=te;else if(te instanceof M)this.range=new O(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof i?!0:L?O.isRange(L.range)&&S.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=i=Ue([E],oe),e.Location=oe;let Ee=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&S.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};Ee=Ue([E],Ee),e.DiagnosticRelatedInformation=Ee;let Fe=class{constructor(L,te,_e=le.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=_e}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,c.equals)(L.tags,te.tags)&&(0,c.equals)(L.relatedInformation,te.relatedInformation,Ee.isEqual)}};Fe=Ue([E],Fe),e.Diagnostic=Fe;let Me=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};Me=Ue([E],Me),e.Hover=Me;var Ne;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Qe=class{constructor(L,te=Ne.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};Qe=Ue([E],Qe),e.DocumentHighlight=Qe;var ze;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var qe;(function(x){x[x.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let B=l=class{constructor(L,te,_e,Ke,et){this.name=L,this.kind=te,this.containerName=et,typeof _e=="string"&&(this.containerName=_e),Ke instanceof oe?this.location=Ke:_e instanceof O&&(this.location=new oe(Ke,_e)),l.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};B=l=Ue([E],B),e.SymbolInformation=B;let Q=r=class{constructor(L,te,_e,Ke,et){this.name=L,this.detail=te,this.kind=_e,this.range=Ke,this.selectionRange=et,this.children=[],r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(r.validate)}};Q=r=Ue([E],Q),e.DocumentSymbol=Q;var ee;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(L,te){this.title=L,this.kind=te}};ae=Ue([E],ae),e.CodeAction=ae;let j=o=class{constructor(L){this.value=L}append(L){return new o(this.value?this.value+o.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+o.sep)}};j.sep=".",j=o=Ue([E],j),e.CodeActionKind=j,j.Empty=new j(""),j.QuickFix=j.Empty.append("quickfix"),j.Refactor=j.Empty.append("refactor"),j.RefactorExtract=j.Refactor.append("extract"),j.RefactorInline=j.Refactor.append("inline"),j.RefactorRewrite=j.Refactor.append("rewrite"),j.Source=j.Empty.append("source"),j.SourceOrganizeImports=j.Source.append("organizeImports"),j.SourceFixAll=j.Source.append("fixAll");let se=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};se=Ue([E],se),e.SelectionRange=se;class fe{constructor(L,te,_e,Ke,et,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=fe;class Ae{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=Ae;class xe{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=xe;var $e;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ve=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};ve=Ue([E],ve),e.CodeLens=ve;let Ze=b=class{constructor(L,te=!1){h.set(this,void 0),Je(this,h,new _.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof b?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Te(this,h,"f").value}set value(L){Te(this,h,"f").value=L}get isTrusted(){return Te(this,h,"f").isTrusted}set isTrusted(L){Te(this,h,"f").isTrusted=L}get supportThemeIcons(){return Te(this,h,"f").supportThemeIcons}set supportThemeIcons(L){Te(this,h,"f").supportThemeIcons=L}get supportHtml(){return Te(this,h,"f").supportHtml}set supportHtml(L){Te(this,h,"f").supportHtml=L}appendText(L){return Te(this,h,"f").appendText(L),this}appendMarkdown(L){return Te(this,h,"f").appendMarkdown(L),this}appendCodeblock(L,te){return Te(this,h,"f").appendCodeblock(te??"",L),this}};h=new WeakMap,Ze=b=Ue([E],Ze),e.MarkdownString=Ze;let z=class{constructor(L,te){this.label=L,this.documentation=te}};z=Ue([E],z),e.ParameterInformation=z;let J=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};J=Ue([E],J),e.SignatureInformation=J;let he=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};he=Ue([E],he),e.SignatureHelp=he;var Oe;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ve;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Ve=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(L,te,_e){this.text=L,this.position=te,this.kind=_e}};tt=Ue([E],tt),e.InlayHint=tt;var ut;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ht;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(ht=e.CompletionItemKind||(e.CompletionItemKind={}));var St;(function(x){x[x.Deprecated=1]="Deprecated"})(St=e.CompletionItemTag||(e.CompletionItemTag={}));let Pt=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ht[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pt=Ue([E],Pt),e.CompletionItem=Pt;let dt=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};dt=Ue([E],dt),e.CompletionList=dt;let bt=class{constructor(L,te,_e){this.text=L,this.range=te,this.command=_e}};bt=Ue([E],bt),e.InlineSuggestion=bt;let ft=class{constructor(L){this.items=L}};ft=Ue([E],ft),e.InlineSuggestions=ft;var Et;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var Ye;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Ye=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ct;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Ct=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var De;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Z;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(Z=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function L(te){switch(te){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=L}(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(L,te){if(te&&!S.URI.isUri(te))throw(0,F.illegalArgument)("target");if(!O.isRange(L)||L.isEmpty)throw(0,F.illegalArgument)("range");this.range=L,this.target=te}};ge=Ue([E],ge),e.DocumentLink=ge;let me=class{constructor(L,te,_e,Ke){this.red=L,this.green=te,this.blue=_e,this.alpha=Ke}};me=Ue([E],me),e.Color=me;let Ie=class{constructor(L,te){if(te&&!(te instanceof me))throw(0,F.illegalArgument)("color");if(!O.isRange(L)||L.isEmpty)throw(0,F.illegalArgument)("range");this.range=L,this.color=te}};Ie=Ue([E],Ie),e.ColorInformation=Ie;let Be=class{constructor(L){if(!L||typeof L!="string")throw(0,F.illegalArgument)("label");this.label=L}};Be=Ue([E],Be),e.ColorPresentation=Be;var Le;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Le=e.ColorFormat||(e.ColorFormat={}));var je;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Xe{constructor(L,te,_e){if(this.startIndex=L,this.length=te,this.tooltip=_e,typeof L!="number"||L<0)throw(0,F.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,F.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=Xe;var ne;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(L){this.options=L,typeof L!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=pe;var re;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var U;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(U=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=f=class{constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,F.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Ce.Clean=new f("clean","Clean"),Ce.Build=new f("build","Build"),Ce.Rebuild=new f("rebuild","Rebuild"),Ce.Test=new f("test","Test"),Ce=f=Ue([E],Ce),e.TaskGroup=Ce;function Se(x){let L="";for(let te=0;te<x.length;te++)L+=x[te].replace(/,/g,",,")+",";return L}let Ge=class{constructor(L,te,_e){if(typeof L!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,F.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return Se(L)}};Ge=Ue([E],Ge),e.ProcessExecution=Ge;let We=class{constructor(L,te,_e){if(this._args=[],Array.isArray(te)){if(!L)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,F.illegalArgument)("command");this._command=L,this._args=te,this._options=_e}else{if(typeof L!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,F.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return Se(L)}};We=Ue([E],We),e.ShellExecution=We;var it;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(it=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class vt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=vt;let nt=m=class{constructor(L,te,_e,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=L;let at;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=Ke,at=et,this.__deprecated=!0):te===mt.Global||te===mt.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,at=st):(this.target=te,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,at=st),typeof at=="string"?(this._problemMatchers=[at],this._hasDefinedMatchers=!0):Array.isArray(at)?(this._problemMatchers=at,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(m.EmptyType===te||m.ProcessType===te||m.ShellType===te||m.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};nt.ExtensionCallbackType="customExecution",nt.ProcessType="process",nt.ShellType="shell",nt.EmptyType="$empty",nt=m=Ue([E],nt),e.Task=nt;var ot;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ot=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(L,te=Rt.None){this.collapsibleState=te,S.URI.isUri(L)?this.resourceUri=L:this.label=L}};lt=Ue([E],lt),e.TreeItem=lt;var Rt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(Rt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(L,te){this.id=L,this.color=te}};_t=Ue([E],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let Ot=class{constructor(L){this.id=L}};Ot=Ue([E],Ot),e.ThemeColor=Ot;var di;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(di=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(L,te){if(typeof L!="string"&&(!L||!S.URI.isUri(L)&&!S.URI.isUri(L.uri)))throw(0,F.illegalArgument)("base");if(typeof te!="string")throw(0,F.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=S.URI.file(L),this.base=L):S.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=te}};kt=Ue([E],kt),e.RelativePattern=kt;let $t=class{constructor(L,te,_e,Ke){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};$t=Ue([E],$t),e.Breakpoint=$t;let Zt=class extends $t{constructor(L,te,_e,Ke,et){super(te,_e,Ke,et);if(L===null)throw(0,F.illegalArgument)("location");this.location=L}};Zt=Ue([E],Zt),e.SourceBreakpoint=Zt;let gt=class extends $t{constructor(L,te,_e,Ke,et){super(te,_e,Ke,et);this.functionName=L}};gt=Ue([E],gt),e.FunctionBreakpoint=gt;let Kt=class extends $t{constructor(L,te,_e,Ke,et,st,at){super(Ke,et,st,at);if(!te)throw(0,F.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=_e}};Kt=Ue([E],Kt),e.DataBreakpoint=Kt;let Vt=class{constructor(L,te,_e){this.command=L,this.args=te||[],this.options=_e}};Vt=Ue([E],Vt),e.DebugAdapterExecutable=Vt;let ei=class{constructor(L,te){this.port=L,this.host=te}};ei=Ue([E],ei),e.DebugAdapterServer=ei;let ti=class{constructor(L){this.path=L}};ti=Ue([E],ti),e.DebugAdapterNamedPipeServer=ti;let It=class{constructor(L){this.implementation=L}};It=Ue([E],It),e.DebugAdapterInlineImplementation=It;let Qt=class{constructor(L,te){this.range=L,this.expression=te}};Qt=Ue([E],Qt),e.EvaluatableExpression=Qt;var wi;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(L,te){this.range=L,this.text=te}};Wt=Ue([E],Wt),e.InlineValueText=Wt;let Ht=class{constructor(L,te,_e=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=_e}};Ht=Ue([E],Ht),e.InlineValueVariableLookup=Ht;let ct=class{constructor(L,te){this.range=L,this.expression=te}};ct=Ue([E],ct),e.InlineValueEvaluatableExpression=ct;let ii=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};ii=Ue([E],ii),e.InlineValueContext=ii;var Nt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let xt=D=class extends Error{constructor(L,te=t.FileSystemProviderErrorCode.Unknown,_e){super(S.URI.isUri(L)?L.toString(!0):L);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(L){return new D(L,t.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(L){return new D(L,t.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(L){return new D(L,t.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(L){return new D(L,t.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(L){return new D(L,t.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(L){return new D(L,t.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};xt=D=Ue([E],xt),e.FileSystemError=xt;let Yt=class{constructor(L,te,_e){this.start=L,this.end=te,this.kind=_e}};Yt=Ue([E],Yt),e.FoldingRange=Yt;var bi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=fi;function ni(x){return typeof x=="undefined"||(0,I.isStringArray)(x)}class ri{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,_e=L.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,_e=L.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,_e,Ke,et){if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(L,te,_e,Ke,et);if(O.isRange(L)&&typeof te=="string"&&ni(_e))return this._push(L,te,_e);throw(0,F.illegalArgument)()}_push(L,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=L.start.line,et=L.start.character,st=L.end.character-L.start.character,at=this._tokenTypeStrToInt.get(te);let yt=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(At);yt|=1<<Ft>>>0}this._pushEncoded(Ke,et,st,at,yt)}_pushEncoded(L,te,_e,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Ft=0;for(let Lt=0;Lt<yt;Lt++){let Bt=this._data[5*Lt],ui=this._data[5*Lt+1];Bt===0?(Bt=At,ui+=Ft):Bt+=At,this._data[5*Lt]=Bt,this._data[5*Lt+1]=ui,At=Bt,Ft=ui}}let st=L,at=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(at-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=at,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const _e=L.length/5|0;for(let at=0;at<_e;at++)te[at]=at;te.sort((at,yt)=>{const At=L[5*at],Ft=L[5*yt];if(At===Ft){const Lt=L[5*at+1],Bt=L[5*yt+1];return Lt-Bt}return At-Ft});const Ke=new Uint32Array(L.length);let et=0,st=0;for(let at=0;at<_e;at++){const yt=5*te[at],At=L[yt+0],Ft=L[yt+1],Lt=L[yt+2],Bt=L[yt+3],ui=L[yt+4],xi=At-et,qi=xi===0?Ft-st:Ft,ci=5*at;Ke[ci+0]=xi,Ke[ci+1]=qi,Ke[ci+2]=Lt,Ke[ci+3]=Bt,Ke[ci+4]=ui,et=At,st=Ft}return Ke}build(L){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),L):new jt(ri._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=ri;class jt{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=jt;class si{constructor(L,te,_e){this.start=L,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=si;class _i{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=_i;var yi;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var qt;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(qt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new _t("arrow-left")},Jt=Ue([E],Jt),e.QuickInputButtons=Jt;var Si;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(L,te,_e){this.badge=L,this.tooltip=te,this.color=_e}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let oi=class{constructor(L){this.kind=L}};oi=Ue([E],oi),e.ColorTheme=oi;var ai;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(ai=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(L,te){if(L<0)throw(0,F.illegalArgument)("start must be positive");if(te<0)throw(0,F.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof zt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,_e=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(_e=L.end),te===this._start&&_e===this._end?this:new zt(te,_e)}}e.NotebookRange=zt;class Mt{constructor(L,te,_e,Ke,et,st,at){this.kind=L,this.value=te,this.languageId=_e,this.mime=Ke,this.outputs=et??[],this.metadata=st,this.executionSummary=at,Mt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Mt.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Mt;class Re{constructor(L){this.cells=L}}e.NotebookData=Re;class Tt{constructor(L,te){this.data=L,this.mime=te;const _e=(0,R.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(L){return L instanceof Tt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return Tt.json(te,"application/vnd.code.notebook.error")}static stdout(L){return Tt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Tt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new Tt(L,te)}static text(L,te=R.Mimes.text){const _e=Te(Tt,s,"f",d).encode(String(L));return new Tt(_e,te)}static json(L,te="application/json"){const _e=JSON.stringify(L,void 0,"	");return Tt.text(_e,te)}}e.NotebookCellOutputItem=Tt,s=Tt,d={value:new TextEncoder};class Gt{constructor(L,te,_e){this.items=Gt.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,P.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(L){return L instanceof Gt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,I.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const _e=new Set,Ke=new Set;for(let et=0;et<L.length;et++){const st=L[et],at=(0,R.normalizeMimeType)(st.mime);if(!_e.has(at)){_e.add(at);continue}Ke.add(et),te&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ke.size===0?L:L.filter((et,st)=>!Ke.has(st))}}e.NotebookCellOutput=Gt;var pt;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(pt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=gi;var Ii;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(L,te=[]){this.uri=L,this.provides=(0,c.asArray)(te)}}e.NotebookRendererScript=Pi;let li=class{constructor(L,te){this.label=L,this.timestamp=te}};li=Ue([E],li),e.TimelineItem=li;var Ai;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(Ai=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ti;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(Ti=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Ri;class Fi{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let X=class{constructor(L,te,_e){this.include=L,this.exclude=te,this.profile=_e}};X=Ue([E],X),e.TestRunRequest=X;let de=T=class{constructor(L){this.message=L}static diff(L,te,_e){const Ke=new T(L);return Ke.expectedOutput=te,Ke.actualOutput=_e,Ke}};de=T=Ue([E],de),e.TestMessage=de;let ke=class{constructor(L){this.id=L}};ke=Ue([E],ke),e.TestTag=ke;let rt=class{constructor(L,te){this.covered=L,this.total=te}};rt=Ue([E],rt),e.CoveredCount=rt;let wt=g=class{constructor(L,te,_e,Ke){this.uri=L,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=Ke}static fromDetails(L,te){const _e=new rt(0,0),Ke=new rt(0,0),et=new rt(0,0);for(const at of te)if("branches"in at){_e.total+=1,_e.covered+=at.executionCount>0?1:0;for(const yt of at.branches)Ke.total+=1,Ke.covered+=yt.executionCount>0?1:0}else et.total+=1,et.covered+=at.executionCount>0?1:0;const st=new g(L,_e,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return st.detailedCoverage=te,st}};wt=g=Ue([E],wt),e.FileCoverage=wt;let Dt=class{constructor(L,te,_e=[]){this.executionCount=L,this.location=te,this.branches=_e}};Dt=Ue([E],Dt),e.StatementCoverage=Dt;let Oi=class{constructor(L,te){this.executionCount=L,this.location=te}};Oi=Ue([E],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(L,te){this.executionCount=L,this.location=te}};Ni=Ue([E],Ni),e.FunctionCoverage=Ni;var Hi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(L,te,_e,Ke,et,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=st}}e.TypeHierarchyItem=ji}),define(we[88],be([0,1,40,11,9,227,117,7,13]),function(ie,e,c,F,_,A,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(s,d){d?P.set(s,d):P.delete(s)}e.setWordDefinitionFor=t;function y(s){return P.get(s)}e.getWordDefinitionFor=y;class n extends A.MirrorTextModel{constructor(d,v,C,w,a,p,k,i){super(v,C,w,a);this._proxy=d,this._languageId=p,this._isDirty=k,this._notebook=i,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,S.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===F.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(v){return v?d._getTextInRange(v):d.getText()},get eol(){return d._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(v){return d._lineAt(v)},offsetAt(v){return d._offsetAt(v)},positionAt(v){return d._positionAt(v)},validateRange(v){return d._validateRange(v)},validatePosition(v){return d._validatePosition(v)},getWordRangeAtPosition(v,C){return d._getWordRangeAtPosition(v,C)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,c.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,c.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const v=this._validateRange(d);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const C=this._eol,w=v.start.line,a=v.end.line,p=[];p.push(this._lines[w].substring(v.start.character));for(let k=w+1;k<a;k++)p.push(this._lines[k]);return p.push(this._lines[a].substring(0,v.end.character)),p.join(C)}_lineAt(d){let v;if(d instanceof I.Position?v=d.line:typeof d=="number"&&(v=d),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new h(v,this._lines[v],v===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(d),C=this._lines[v.index].length;return new I.Position(v.index,Math.min(v.remainder,C))}_validateRange(d){if(!(d instanceof I.Range))throw new Error("Invalid argument");const v=this._validatePosition(d.start),C=this._validatePosition(d.end);return v===d.start&&C===d.end?d:new I.Range(v.line,v.character,C.line,C.character)}_validatePosition(d){if(!(d instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:v,character:C}=d,w=!1;if(v<0)v=0,C=0,w=!0;else if(v>=this._lines.length)v=this._lines.length-1,C=this._lines[v].length,w=!0;else{const a=this._lines[v].length;C<0?(C=0,w=!0):C>a&&(C=a,w=!0)}return w?new I.Position(v,C):d}_getWordRangeAtPosition(d,v){const C=this._validatePosition(d);if(!v)v=y(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const w=(0,R.getWordAtText)(C.character+1,(0,R.ensureValidWordDefinition)(v),this._lines[C.line],0);if(w)return new I.Range(C.line,w.startColumn-1,C.line,w.endColumn-1)}}e.ExtHostDocumentData=n;class h{constructor(d,v,C){this._line=d,this._text=v,this._isLastLine=C}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(we[155],be([0,1,7,3,228,6,55,20,2,36]),function(ie,e,c,F,_,A,R,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,h,s,d){this._notebook=s,this._selector=d,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(C=>{const w=this._cellUris.get(C.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=C=>{C===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(C=>v(C.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const n=[],h=[];for(const s of this._notebook.getCells())s.kind===c.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),n.push(s.document.getText().length+1),h.push(s.document.lineCount));this._cellLengths=new _.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new _.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(n){if(!n){let w="";for(const a of this._cells)w+=a.document.getText()+`
`;return w=w.slice(0,-1),w}if(n.isEmpty)return"";const h=this.locationAt(n.start),s=this.locationAt(n.end),d=this._cellUris.get(h.uri),v=this._cellUris.get(s.uri);if(d===void 0||v===void 0)return"";if(d===v)return this._cells[d].document.getText(new c.Range(h.range.start,s.range.end));const C=[this._cells[d].document.getText(new c.Range(h.range.start,new c.Position(this._cells[d].document.lineCount,0)))];for(let w=d+1;w<v;w++)C.push(this._cells[w].document.getText());return C.push(this._cells[v].document.getText(new c.Range(new c.Position(0,0),s.range.end))),C.join(`
`)}offsetAt(n){const h=this._cellLines.getIndexOf(n.line),s=this._cellLengths.getPrefixSum(h.index-1),d=this._cells[h.index].document.offsetAt(n.with(h.remainder));return s+d}positionAt(n){if(typeof n=="number"){const s=this._cellLengths.getIndexOf(n),d=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(d)}const h=this._cellUris.get(n.uri);if(h!==void 0){const s=this._cellLines.getPrefixSum(h-1);return new c.Position(s+n.range.start.line,n.range.start.character)}return new c.Position(0,0)}locationAt(n){c.Range.isRange(n)||(n=new c.Range(n,n));const h=this._cellLines.getIndexOf(n.start.line);let s=h;n.isEmpty||(s=this._cellLines.getIndexOf(n.end.line));const d=new c.Position(h.remainder,n.start.character),v=new c.Position(s.remainder,n.end.character),C=new c.Range(d,v),w=this._cells[h.index];return new c.Location(w.document.uri,w.document.validateRange(C))}contains(n){return this._cellUris.has(n)}validateRange(n){const h=this.validatePosition(n.start),s=this.validatePosition(n.end);return n.with(h,s)}validatePosition(n){const h=this._cellLines.getIndexOf(n.line),s=new c.Position(h.remainder,n.character),d=this._cells[h.index].document.validatePosition(s),v=this._cellLines.getPrefixSum(h.index-1);return new c.Position(v+d.line,d.character)}}e.ExtHostNotebookConcatDocument=t}),define(we[156],be([0,1,7,12,3]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(I){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let S=I==="light"?c.ColorThemeKind.Light:I==="dark"?c.ColorThemeKind.Dark:c.ColorThemeKind.HighContrast;this._actual=new c.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Ue([He(0,F.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(we[65],be([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class F{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=F}),define(we[157],be([0,1,23]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(S){let P=this.buffers.indexOf(S);return P<0&&(P=this.buffers.length,this.buffers.push(S)),P}}function _(I,S){if(S.serializeBuffersForPostMessage){const P=new F,t=(h,s)=>{if(s instanceof ArrayBuffer){const d=P.add(s);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(s)){const d=A(s);if(d){const v=P.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:d,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},y=JSON.stringify(I,t),n=P.buffers.map(h=>{const s=new Uint8Array(h);return c.VSBuffer.wrap(s)});return{message:y,buffers:n}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=_;function A(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(I,S){const P=S.map(n=>{const h=new ArrayBuffer(n.byteLength);return new Uint8Array(h).set(n.buffer),h}),t=S.length?(n,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const s=h,{index:d}=s,v=P[d];if(s.view)switch(s.view.type){case 1:return new Int8Array(v,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return h}:void 0;return{message:JSON.parse(I,t),arrayBuffers:P}}e.deserializeWebviewMessage=R}),define(we[158],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var c;(function(F){function _(R){const I={items:new Map};return R.types.forEach((S,P)=>{I.items.set(S,{asString:async()=>R.items[P].asString})}),I}F.toITreeDataTransfer=_;async function A(R){const I={types:[],items:[]},S=Array.from(R.items.entries());for(const P of S)I.types.push(P[0]),I.items.push({asString:await P[1].asString()});return I}F.toTreeDataTransferDTO=A})(c=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[66],be([0,1,11,2]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function _(I,S){return I.scheme===c.Schemas.http||I.scheme===c.Schemas.https?I:(S&&S.authority&&S.isRemote&&I.scheme===c.Schemas.file&&(I=F.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:I.path})),F.URI.from({scheme:c.Schemas.https,authority:`${I.scheme}+${A(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=_;function A(I){return I.replace(/./g,S=>{const P=S.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?S:"-"+P.toString(16).padStart(4,"0")})}function R(I){return I.replace(/-([0-9a-f]{4})/g,(S,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=R}),define(we[159],be([0,1,3,6,66]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(I,S,P){this._proxy=I,this._editors=S,this._initData=P,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const t=S.getVisibleTextEditors();for(const y of this._insets.values())t.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,S,P,t,y){let n;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===I){n=a;break}if(!n)throw new Error("not a visible editor");const h=this,s=this._handlePool++,d=new c.Emitter,v=new c.Emitter,C=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,_.asWebviewUri)(a,h._initData.remote)}get cspSource(){return _.webviewGenericCspSource}set options(a){this._options=a,h._proxy.$setOptions(s,a)}get options(){return this._options}set html(a){this._html=a,h._proxy.$setHtml(s,a)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(a){return h._proxy.$postMessage(s,a)}},w=new class{constructor(){this.editor=I,this.line=S,this.height=P,this.webview=C,this.onDidDispose=v.event}dispose(){h._insets.has(s)&&(h._insets.delete(s),h._proxy.$disposeEditorInset(s),v.fire(),v.dispose(),d.dispose())}};return this._proxy.$createEditorInset(s,n.id,n.value.document.uri,S+1,P,t||{},y.identifier,y.extensionLocation),this._insets.set(s,{editor:I,inset:w,onDidReceiveMessage:d}),w}$onDidDispose(I){const S=this._insets.get(I);S&&S.inset.dispose()}$onDidReceiveMessage(I,S){const P=this._insets.get(I);P&&P.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(we[160],be([0,1,130,10,2,6,4,43,28,13,11]),function(ie,e,c,F,_,A,R,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,c.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,c.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,c.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,c.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,c.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new I.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,c.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,c.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,c.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,c.localize)(10,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,c.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,c.localize)(12,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,c.localize)(13,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,c.localize)(14,null)),e.ActiveEditorGroupLockedContext=new I.RawContextKey("activeEditorGroupLocked",!1,(0,c.localize)(15,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,c.localize)(16,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,c.localize)(17,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,c.localize)(18,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,c.localize)(19,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,c.localize)(20,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,c.localize)(21,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function y(E){if(a(E))return!1;const u=E;return _.URI.isUri(u?.resource)}e.isResourceEditorInput=y;function n(E){if(a(E))return!1;const u=E;return u?.original!==void 0&&u.modified!==void 0}e.isResourceDiffEditorInput=n;function h(E){if(a(E))return!1;const u=E;return u?.primary!==void 0&&u.secondary!==void 0}e.isResourceSideBySideEditorInput=h;function s(E){if(a(E))return!1;const u=E;return u?u.resource===void 0||u.resource.scheme===t.Schemas.untitled||u.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=s;var d;(function(E){E[E.SHORT=0]="SHORT",E[E.MEDIUM=1]="MEDIUM",E[E.LONG=2]="LONG"})(d=e.Verbosity||(e.Verbosity={}));var v;(function(E){E[E.EXPLICIT=1]="EXPLICIT",E[E.AUTO=2]="AUTO",E[E.FOCUS_CHANGE=3]="FOCUS_CHANGE",E[E.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));var C;(function(E){E[E.None=0]="None",E[E.Readonly=2]="Readonly",E[E.Untitled=4]="Untitled",E[E.Singleton=8]="Singleton",E[E.RequiresTrust=16]="RequiresTrust",E[E.CanSplitInGroup=32]="CanSplitInGroup"})(C=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class w extends A.Disposable{}e.AbstractEditorInput=w;function a(E){return E instanceof w}e.isEditorInput=a;function p(E){const u=E;return _.URI.isUri(u?.preferredResource)}function k(E){const u=E;return a(u?.primary)&&a(u?.secondary)}e.isSideBySideEditorInput=k;function i(E){const u=E;return a(u?.modified)&&a(u?.original)}e.isDiffEditorInput=i;function l(E){return a(E?.editor)}e.isEditorInputWithOptions=l;function r(E){const u=E;return l(E)&&u?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function o(E){const u=E;return typeof u?.groupId=="number"&&a(u.editor)}e.isEditorIdentifier=o;var b;(function(E){E[E.PRIMARY=1]="PRIMARY",E[E.SECONDARY=2]="SECONDARY",E[E.BOTH=3]="BOTH"})(b=e.SideBySideEditor||(e.SideBySideEditor={}));class f{getOriginalUri(u,M){if(!u)return;if(M?.supportSideBySide){const{primary:q,secondary:K}=this.getSideEditors(u);if(q&&K){if(M?.supportSideBySide===b.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:M.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:M.filterByScheme})};u=M.supportSideBySide===b.PRIMARY?q:K}}if(n(u)||h(u))return;const O=p(u)?u.preferredResource:u.resource;return!O||!M||!M.filterByScheme?O:this.filterUri(O,M.filterByScheme)}getSideEditors(u){return k(u)||h(u)?{primary:u.primary,secondary:u.secondary}:i(u)||n(u)?{primary:u.modified,secondary:u.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(u,M){if(!u)return;if(M?.supportSideBySide){const{primary:q,secondary:K}=this.getSideEditors(u);if(q&&K){if(M?.supportSideBySide===b.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:M.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:M.filterByScheme})};u=M.supportSideBySide===b.PRIMARY?q:K}}if(n(u)||h(u))return;const O=u.resource;return!O||!M||!M.filterByScheme?O:this.filterUri(O,M.filterByScheme)}filterUri(u,M){if(Array.isArray(M)){if(M.some(O=>u.scheme===O))return u}else if(M===u.scheme)return u}}e.EditorResourceAccessor=new f;var m;(function(E){E[E.LEFT=0]="LEFT",E[E.RIGHT=1]="RIGHT"})(m=e.CloseDirection||(e.CloseDirection={}));class D{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(u){const M=this.instantiationService=u.get(R.IInstantiationService);for(const[O,q]of this.editorSerializerConstructors)this.createEditorSerializer(O,q,M);this.editorSerializerConstructors.clear()}createEditorSerializer(u,M,O){const q=O.createInstance(M);this.editorSerializerInstances.set(u,q)}registerFileEditorFactory(u){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=u}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(u,M){if(this.editorSerializerConstructors.has(u)||this.editorSerializerInstances.has(u))throw new Error(`A editor serializer with type ID '${u}' was already registered.`);return this.instantiationService?this.createEditorSerializer(u,M,this.instantiationService):this.editorSerializerConstructors.set(u,M),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(u),this.editorSerializerInstances.delete(u)})}getEditorSerializer(u){return this.editorSerializerInstances.get(typeof u=="string"?u:u.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new D);async function T(E,u){if(!E||!E.length)return[];const M=await Promise.all(E.map(async O=>{const q=_.URI.revive(O.fileUri);if(!q||(await u.activateProvider(q.scheme),!u.canHandleResource(q)))return;const K=typeof O.exists=="boolean"?O.exists:await u.exists(q);if(!K&&O.openOnlyIfExists)return;const $={selection:K?O.selection:void 0,pinned:!0,override:O.editorOverrideId};let W;return K?W={resource:q,options:$}:W={resource:q,options:$,forceUntitled:!0},W}));return(0,P.coalesce)(M)}e.pathsToEditors=T;var g;(function(E){E[E.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",E[E.SEQUENTIAL=1]="SEQUENTIAL"})(g=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[161],be([0,1,3,43,131,4,6,20,28,13,51,22,34,151]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",n.Codicon.window,(0,_.localize)(0,null));var s;(function(b){b.ViewContainersRegistry="workbench.registry.view.containers",b.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var d;(function(b){b[b.Sidebar=0]="Sidebar",b[b.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function v(b){switch(b){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=v;function C(b){return`viewContainer.${b}.enabled`}e.getEnabledViewContainerContextKey=C;class w extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new c.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new c.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(f,m,D){const T=this.get(f.id);if(T)return T;const g=f;return g.openCommandActionDescriptor=D?.donotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,I.getOrSet)(this.viewContainers,m,[]).push(g),D?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:m}),g}deregisterViewContainer(f){for(const m of this.viewContainers.keys()){const D=this.viewContainers.get(m),T=D?.indexOf(f);if(T!==-1){D?.splice(T,1),D.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:m});return}}}get(f){return this.all.filter(m=>m.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(D=>D?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===f)}}S.Registry.add(s.ViewContainersRegistry,new w);var a;(function(b){b.Open="2_open",b.Debug="4_debug",b.SCM="5_scm",b.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function p(b,f){const m=b.group??a.More,D=f.group??a.More;return m!==D?m.localeCompare(D):(b.order??5)-(f.order??5)}class k extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new c.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new c.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new c.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new c.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(f,m){this.registerViews2([{views:f,viewContainer:m}])}registerViews2(f){f.forEach(({views:m,viewContainer:D})=>this.addViews(m,D)),this._onViewsRegistered.fire(f)}deregisterViews(f,m){const D=this.removeViews(f,m);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:m})}moveViews(f,m){for(const D of this._views.keys())if(D!==m){const T=this.removeViews(f,D);T.length&&(this.addViews(T,m),this._onDidChangeContainer.fire({views:T,from:D,to:m}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const m of this._viewContainers){const D=(this._views.get(m)||[]).filter(T=>T.id===f)[0];if(D)return D}return null}getViewContainer(f){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(T=>T.id===f)[0])return m;return null}registerViewWelcomeContent(f,m){return this._viewWelcomeContents.add(f,m),this._onDidChangeViewWelcomeContent.fire(f),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(f,m),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,m){const D=new Map;for(const[T,g]of m)this._viewWelcomeContents.add(f,g),D.set(T,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(f,g),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),D}getViewWelcomeContent(f){const m=[];return this._viewWelcomeContents.forEach(f,D=>m.push(D)),m.sort(p)}addViews(f,m){let D=this._views.get(m);D||(D=[],this._views.set(m,D),this._viewContainers.push(m));for(const T of f){if(this.getView(T.id)!==null)throw new Error((0,_.localize)(1,null,T.id));D.push(T)}}removeViews(f,m){const D=this._views.get(m);if(!D)return[];const T=[],g=[];for(const E of D)f.includes(E)?T.push(E):g.push(E);return T.length&&(g.length?this._views.set(m,g):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),T}}S.Registry.add(s.ViewsRegistry,new k),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new F.RawContextKey("focusedView","",(0,_.localize)(2,null));function i(b){return`view.${b}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var l;(function(b){b[b.Default=0]="Default",b[b.Expand=1]="Expand"})(l=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(b){b[b.None=0]="None",b[b.Collapsed=1]="Collapsed",b[b.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(f,m){this.resolved=!1,this._hasResolve=!1,(0,y.mixin)(this,f),this._hasResolve=!!m,this.resolve=async D=>{if(m&&!this.resolved){const T=await m(D);T&&(this.tooltip=this.tooltip??T.tooltip,this.command=this.command??T.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(we[162],be([0,1,3,14,132]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,S,P,t){const y={command:I};if(S&&Object.keys(S).length>0&&(y.arguments=S),this.internalSend("request",y),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const h=this.pendingRequests.get(y.seq);if(h){this.pendingRequests.delete(y.seq);const s={type:"response",seq:0,request_seq:y.seq,success:!1,command:I,message:(0,_.localize)(0,null,t,I)};h(s)}},t)}return P&&this.pendingRequests.set(y.seq,P),y.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,S){return I.type!=="event"||S.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,F.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const S=I,P=this.pendingRequests.get(S.request_seq);P&&(this.pendingRequests.delete(S.request_seq),P(S));break}}}internalSend(I,S){S.type=I,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((S,P)=>I.set(P,S)),await(0,F.timeout)(500),I.forEach((S,P)=>{S({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(we[163],be([0,1,9,2,17,22,11]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function S(r,o,b){return r.replace(I,function(f,m){return o&&m.length>0&&m[0]!=="_"?f:b&&b.hasOwnProperty(m)?b[m]:f})}e.formatPII=S;function P(r){const o={};for(const b of Object.keys(r))b.startsWith("!")||(o[b]=r[b]);return o}e.filterExceptionsFromTelemetry=P;function t(r){return r.configuration.request==="attach"&&!y(r)&&(!r.parentSession||t(r.parentSession))}e.isSessionAttach=t;function y(r){let o=r.configuration.type;if(!!o)return o==="vslsShare"&&(o=r.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(o,"extensionhost")||(0,c.equalsIgnoreCase)(o,"pwa-extensionhost")?r:r.parentSession?y(r.parentSession):void 0}e.getExtensionHostDebugSession=y;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function h(r,o,b){let f,m=0,D=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,T=null;for(;T=D.exec(r);){let g=T.index+1,E=g+T[0].length;if(g<=o&&E>=b){f=T[0],m=g;break}}if(f){let g=/\w+/g,E=null;for(;(E=g.exec(f))&&!(E.index+1+m+E[0].length>=b););E&&(f=f.substring(0,g.lastIndex))}return f?{start:m,end:m+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(r){return!!(r&&r.match(s))}e.isUri=d;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(d(r.path))return F.URI.parse(r.path);if((0,_.isAbsolute)(r.path))return F.URI.file(r.path)}return r.path}function C(r){if(typeof r.path=="object"){const o=F.URI.revive(r.path);if(o)return o.scheme===R.Schemas.file?o.fsPath:o.toString()}return r.path}function w(r,o){const b=o?v:C,f=(0,A.deepClone)(r);return p(f,(m,D)=>{m&&D&&(D.path=b(D))}),f}e.convertToDAPaths=w;function a(r,o){const b=o?v:C,f=(0,A.deepClone)(r);return p(f,(m,D)=>{!m&&D&&(D.path=b(D))}),f}e.convertToVSCPaths=a;function p(r,o){switch(r.type){case"event":const b=r;switch(b.event){case"output":o(!1,b.body.source);break;case"loadedSource":o(!1,b.body.source);break;case"breakpoint":o(!1,b.body.breakpoint.source);break;default:break}break;case"request":const f=r;switch(f.command){case"setBreakpoints":o(!0,f.arguments.source);break;case"breakpointLocations":o(!0,f.arguments.source);break;case"source":o(!0,f.arguments.source);break;case"gotoTargets":o(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(D=>o(!1,D));break;default:break}break;case"response":const m=r;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(D=>o(!1,D.source));break;case"loadedSources":m.body.sources.forEach(D=>o(!1,D));break;case"scopes":m.body.scopes.forEach(D=>o(!1,D.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(D=>o(!1,D.source));break;case"setBreakpoints":m.body.breakpoints.forEach(D=>o(!1,D.source));break;default:break}break}}function k(r){return r.filter(o=>!o.presentation?.hidden).sort((o,b)=>o.presentation?b.presentation?o.presentation.group?b.presentation.group?o.presentation.group!==b.presentation.group?o.presentation.group.localeCompare(b.presentation.group):i(o.presentation.order,b.presentation.order):-1:b.presentation.group?1:i(o.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.getVisibleAndSorted=k;function i(r,o){return typeof r!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:r-o}async function l(r,o){const b=r.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorMode});if(b!=="none"&&(await o.saveAll(),b==="allEditorsInActiveGroup")){const f=o.activeEditorPane;f&&await o.save({editor:f.input,groupId:f.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=l}),define(we[89],be([0,1,27,78,11,17,26,43]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(g){g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeLanguage=5]="ChangeLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var v;(function(g){g.scheme=_.Schemas.vscodeNotebookCell;const E=/^ch(\d{7,})/;function u($,W){return $.with({scheme:g.scheme,fragment:`ch${W.toString().padStart(7,"0")}${$.scheme!==_.Schemas.file?$.scheme:""}`})}g.generate=u;function M($){if($.scheme!==g.scheme)return;const W=E.exec($.fragment);return W?{handle:Number(W[1]),notebook:$.with({scheme:$.fragment.substr(W[0].length)||_.Schemas.file,fragment:null})}:void 0}g.parse=M;function O($){if($.scheme!==_.Schemas.vscodeNotebookCellMetadata)return;const W=E.exec($.fragment);return W?{handle:Number(W[1]),notebook:$.with({scheme:$.fragment.substr(W[0].length)||_.Schemas.file,fragment:null})}:void 0}g.parseCellMetadataUri=O;function q($,W,N){return $.with({scheme:N,fragment:`ch${W.toString().padStart(7,"0")}${$.scheme!==_.Schemas.file?$.scheme:""}`})}g.generateCellUri=q;function K($,W){if($.scheme!==W)return;const N=E.exec($.fragment);return N?{handle:Number(N[1]),notebook:$.with({scheme:$.fragment.substr(N[0].length)||_.Schemas.file,fragment:null})}:void 0}g.parseCellUri=K})(v=e.CellUri||(e.CellUri={}));const C=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(g){return C.get(g)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=w;function a(g){return C.get(g)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function p(g){return C.get(g)?.mergeable??!1}e.mimeTypeIsMergeable=p;function k(g,E){return R.isWindows&&(g=g.replace(/\//g,"\\"),E=E.replace(/\//g,"\\")),c.match(g,E)}function i(g,E,u){let M=0;for(let O=0;O<E.length;O++){if(k(E[O],g))return M;M++}for(let O=0;O<u.length;O++){if(k(u[O],g))return M;M++}return M}function l(g,E,u){return g.sort((M,O)=>i(M,E,u)-i(O,E,u))}e.sortMimeTypes=l;function r(g,E,u,M=(O,q)=>O===q){const O=[];function q(W,N,H){if(N===0&&H.length===0)return;const V=O[O.length-1];V&&V.start+V.deleteCount===W?(V.deleteCount+=N,V.toInsert.push(...H)):O.push({start:W,deleteCount:N,toInsert:H})}let K=0,$=0;for(;;){if(K===g.length){q(K,0,E.slice($));break}if($===E.length){q(K,g.length-K,[]);break}const W=g[K],N=E[$];if(M(W,N)){K+=1,$+=1;continue}u(N)?(q(K,1,[]),K+=1):(q(K,0,[N]),$+=1)}return O}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(g){g.default="default",g.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function b(g){const E=g;return!!((typeof E.include=="string"||c.isRelativePattern(E.include))&&(typeof E.exclude=="string"||c.isRelativePattern(E.exclude)))}e.isDocumentExcludePattern=b;function f(g,E,u){if(Array.isArray(g.viewType)&&g.viewType.indexOf(E)>=0||g.viewType===E)return!0;if(g.filenamePattern){let M=b(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,O=b(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(c.match(M,(0,A.basename)(u.fsPath).toLowerCase()))return!(O&&c.match(O,(0,A.basename)(u.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class m{constructor(E){this.textModel=E}getElements(){const E=new Int32Array(this.textModel.cells.length);for(let u=0;u<this.textModel.cells.length;u++)E[u]=this.textModel.cells[u].getHashValue();return E}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var D;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(D=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class T{static create(E){return`${T._prefix}${E}`}static parse(E){if(E.startsWith(T._prefix))return E.substr(T._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=T,T._prefix="notebook/"}),define(we[164],be([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState",_[_.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(we[165],be([0,1,134,4,43]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,c.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,c.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,c.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[166],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=c;function F(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=F}),define(we[90],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var c;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(c=e.TestResultState||(e.TestResultState={}));var F;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(_=e.TestMessageType||(e.TestMessageType={}));var A;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&(y.item=y.item?Object.assign(y.item,n.item):n.item)};e.applyTestItemUpdate=R;var I;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var S;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(n){}update(n){}remove(n,h){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const h=this.createChangeCollector();for(const s of n)switch(s[0]){case 0:{const d=s[1];if(d.parent){if(this.items.has(d.parent)){const v=this.items.get(d.parent);v.children.add(d.item.extId);const C=this.createItem(d,v);this.items.set(d.item.extId,C),h.add(C)}}else{const v=this.createItem(d);this.roots.add(v),this.items.set(d.item.extId,v),h.add(v)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=s[1],v=this.items.get(d.extId);if(!v)break;d.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,d),h.update(v);break}case 2:{const d=this.items.get(s[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d);const v=[[s[1]]];for(;v.length;)for(const C of v.pop()){const w=this.items.get(C);w&&(v.push(w.children),this.items.delete(C),h.remove(w,w!==d),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}h.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(we[67],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(A){A.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class _{constructor(R,I=R.length){if(this.path=R,this.viewEnd=I,R.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,I,S=R.parent){if(R.id===I)return new _([I]);let P=[R.id];for(let t=S;t&&t.id!==I;t=t.parent)P.push(t.id);return P.push(I),new _(P.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new _(R.split("\0"))}static join(R,I){return new _([...R.path,I])}static joinToString(R,I){return R.toString()+"\0"+I}static compare(R,I){return R===I?0:I.startsWith(R+"\0")?2:R.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new _(this.path,R)}compare(R){if(typeof R=="string")return _.compare(this.toString(),R);for(let I=0;I<R.viewEnd&&I<this.viewEnd;I++)if(R.path[I]!==this.path[I])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=_}),define(we[167],be([0,1,17,91,10,22,26,77,135]),function(ie,e,c,F,_,A,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(y,n,h){this._contributedVariables=new Map,this._context=y,this._labelService=n,h&&(this._envVariablesPromise=h.then(s=>this.prepareEnv(s)))}prepareEnv(y){if(R.isWindows){const n=Object.create(null);return Object.keys(y).forEach(h=>{n[h.toLowerCase()]=y[h]}),n}return y}resolveWithEnvironment(y,n,h){return this.recursiveResolve(this.prepareEnv(y),n?n.uri:void 0,h)}async resolveAsync(y,n){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,n)}async resolveAnyBase(y,n,h,s){const d=A.deepClone(n);return R.isWindows&&d.windows?Object.keys(d.windows).forEach(v=>d[v]=d.windows[v]):R.isMacintosh&&d.osx?Object.keys(d.osx).forEach(v=>d[v]=d.osx[v]):R.isLinux&&d.linux&&Object.keys(d.linux).forEach(v=>d[v]=d.linux[v]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,d,h,s)}async resolveAnyAsync(y,n,h){return this.resolveAnyBase(y,n,h)}async resolveAnyMap(y,n,h){const s=new Map;return{newConfig:await this.resolveAnyBase(y,n,h,s),resolvedVariables:s}}resolveWithInteractionReplace(y,n,h,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,n,h,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,n){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,n)}recursiveResolve(y,n,h,s,d){if(_.isString(h))return this.resolveString(y,n,h,s,d);if(_.isArray(h))return h.map(v=>this.recursiveResolve(y,n,v,s,d));if(_.isObject(h)){let v=Object.create(null);return Object.keys(h).forEach(C=>{const w=this.resolveString(y,n,C,s,d);v[w]=this.recursiveResolve(y,n,h[C],s,d)}),v}return h}resolveString(y,n,h,s,d){return h.replace(P.VARIABLE_REGEXP,(C,w)=>{if(w.includes(P.VARIABLE_LHS))return C;let a=this.evaluateSingleVariable(y,C,w,n,s);return d&&d.set(w,a),a!==C&&_.isString(a)&&a.match(P.VARIABLE_REGEXP)&&(a=this.resolveString(y,n,a,s,d)),a})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,n,h,s,d){let v;const C=h.split(":");C.length>1&&(h=C[0],v=C[1]);const w=()=>{const k=this._context.getFilePath();if(k)return k;throw new Error((0,S.localize)(0,null,n))},a=()=>{const k=w();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,S.localize)(1,null,n,c.basename(k)))},p=()=>{if(v){const k=this._context.getFolderUri(v);if(k)return k;throw new Error((0,S.localize)(2,null,n,v))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,n)):new Error((0,S.localize)(4,null,n))};switch(h){case"env":if(v){if(y){const k=y[R.isWindows?v.toLowerCase():v];if(_.isString(k))return k}return""}throw new Error((0,S.localize)(5,null,n));case"config":if(v){const k=this._context.getConfigurationValue(s,v);if(_.isUndefinedOrNull(k))throw new Error((0,S.localize)(6,null,n,v));if(_.isObject(k))throw new Error((0,S.localize)(7,null,n,v));return k}throw new Error((0,S.localize)(8,null,n));case"command":return this.resolveFromMap(n,v,d,"command");case"input":return this.resolveFromMap(n,v,d,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return s||v?(0,I.normalizeDriveLetter)(this.fsPath(p())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(p()));case"lineNumber":const k=this._context.getLineNumber();if(k)return k;throw new Error((0,S.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,S.localize)(10,null,n));case"file":return w();case"fileWorkspaceFolder":return a();case"relativeFile":return s||v?c.relative(this.fsPath(p()),w()):w();case"relativeFileDirname":const l=c.dirname(w());if(s||v){const f=c.relative(this.fsPath(p()),l);return f.length===0?".":f}return l;case"fileDirname":return c.dirname(w());case"fileExtname":return c.extname(w());case"fileBasename":return c.basename(w());case"fileBasenameNoExtension":const r=c.basename(w());return r.slice(0,r.length-c.extname(r).length);case"fileDirnameBasename":return c.basename(c.dirname(w()));case"execPath":const o=this._context.getExecPath();return o||n;case"execInstallFolder":const b=this._context.getAppRoot();return b||n;case"pathSeparator":return c.sep;default:try{const f=v?`${h}:${v}`:h;return this.resolveFromMap(n,f,d,void 0)}catch(f){return n}}}}resolveFromMap(y,n,h,s){if(n&&h){const d=s===void 0?h[n]:h[s+":"+n];if(typeof d=="string")return d;throw new Error((0,S.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[92],be([0,1,4,160]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var _;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var A;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var I;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function P(d){const v=d;return(0,F.isEditorInput)(v?.editor)&&(0,F.isEditorInput)(v?.replacement)}e.isEditorReplacement=P;var t;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.GROUP_LOCKED=2]="GROUP_LOCKED",d[d.EDITOR_OPEN=3]="EDITOR_OPEN",d[d.EDITOR_CLOSE=4]="EDITOR_CLOSE",d[d.EDITOR_MOVE=5]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=7]="EDITOR_LABEL",d[d.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",d[d.EDITOR_PIN=9]="EDITOR_PIN",d[d.EDITOR_STICKY=10]="EDITOR_STICKY",d[d.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(y=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function h(d){const v=d;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=h;function s(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=s}),define(we[168],be([0,1,4,92]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(A){const R=A;return typeof A=="number"||(0,F.isEditorGroup)(R)}e.isPreferredGroup=_}),define(we[8],be([0,1,13,23,76,229,54,22,10,2,42,59,136,82,46,89,67,168,7]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ne){function pe(U){const{selectionStartLineNumber:Ce,selectionStartColumn:Se,positionLineNumber:Ge,positionColumn:We}=U,it=new w.Position(Ce-1,Se-1),mt=new w.Position(Ge-1,We-1);return new w.Selection(it,mt)}ne.to=pe;function re(U){const{anchor:Ce,active:Se}=U;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}ne.from=re})(a=e.Selection||(e.Selection={}));var p;(function(ne){function pe(U){if(!U)return;const{start:Ce,end:Se}=U;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}ne.from=pe;function re(U){if(!U)return;const{startLineNumber:Ce,startColumn:Se,endLineNumber:Ge,endColumn:We}=U;return new w.Range(Ce-1,Se-1,Ge-1,We-1)}ne.to=re})(p=e.Range||(e.Range={}));var k;(function(ne){function pe(re){switch(re){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}ne.to=pe})(k=e.TokenType||(e.TokenType={}));var i;(function(ne){function pe(U){return new w.Position(U.lineNumber-1,U.column-1)}ne.to=pe;function re(U){return{lineNumber:U.line+1,column:U.character+1}}ne.from=re})(i=e.Position||(e.Position={}));var l;(function(ne){function pe(U){switch(U){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}ne.from=pe;function re(U){switch(U){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}ne.to=re})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(ne){function pe(U){let Ce;return U.code&&((0,S.isString)(U.code)||(0,S.isNumber)(U.code)?Ce=String(U.code):Ce={value:String(U.code.value),target:U.code.target}),{...p.from(U.range),message:U.message,source:U.source,code:Ce,severity:b.from(U.severity),relatedInformation:U.relatedInformation&&U.relatedInformation.map(o.from),tags:Array.isArray(U.tags)?(0,c.coalesce)(U.tags.map(l.from)):void 0}}ne.from=pe;function re(U){const Ce=new w.Diagnostic(p.to(U),U.message,b.to(U.severity));return Ce.source=U.source,Ce.code=(0,S.isString)(U.code)?U.code:U.code?.value,Ce.relatedInformation=U.relatedInformation&&U.relatedInformation.map(o.to),Ce.tags=U.tags&&(0,c.coalesce)(U.tags.map(l.to)),Ce}ne.to=re})(r=e.Diagnostic||(e.Diagnostic={}));var o;(function(ne){function pe(U){return{...p.from(U.location.range),message:U.message,resource:U.location.uri}}ne.from=pe;function re(U){return new w.DiagnosticRelatedInformation(new w.Location(U.resource,p.to(U)),U.message)}ne.to=re})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var b;(function(ne){function pe(U){switch(U){case w.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}ne.from=pe;function re(U){switch(U){case h.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ne.to=re})(b=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var f;(function(ne){function pe(U){return typeof U=="number"&&U>=w.ViewColumn.One?U-1:U===w.ViewColumn.Beside?C.SIDE_GROUP:C.ACTIVE_GROUP}ne.from=pe;function re(U){if(typeof U=="number"&&U>=0)return U+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=re})(f=e.ViewColumn||(e.ViewColumn={}));function m(ne){return typeof ne.range!="undefined"}function D(ne){return ne.length===0?!0:!!m(ne[0])}e.isDecorationOptionsArr=D;var T;(function(ne){function pe(We){return We.map(ne.from)}ne.fromMany=pe;function re(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function U(We){let it;if(re(We)){const{language:ot,value:lt}=We;it={value:"```"+ot+`
`+lt+"\n```\n"}}else w.MarkdownString.isMarkdownString(We)?it={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml}:typeof We=="string"?it={value:We}:it={value:""};const mt=Object.create(null);it.uris=mt;const vt=ot=>{try{let lt=P.URI.parse(ot,!0);lt=lt.with({query:Ce(lt.query,mt)}),mt[ot]=lt}catch(lt){}return""},nt=new A.Renderer;return nt.link=vt,nt.image=ot=>vt(_.parseHrefAndDimensions(ot).href),A(it.value,{renderer:nt}),it}ne.from=U;function Ce(We,it){if(!We)return We;let mt;try{mt=(0,R.parse)(We)}catch(nt){}if(!mt)return We;let vt=!1;return mt=(0,I.cloneAndChange)(mt,nt=>{if(P.URI.isUri(nt)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ot]=nt,vt=!0,ot}else return}),vt?JSON.stringify(mt):We}function Se(We){const it=new w.MarkdownString(We.value,We.supportThemeIcons);return it.isTrusted=We.isTrusted,it.supportHtml=We.supportHtml,it}ne.to=Se;function Ge(We){if(!!We)return typeof We=="string"?We:ne.from(We)}ne.fromStrict=Ge})(T=e.MarkdownString||(e.MarkdownString={}));function g(ne){return D(ne)?ne.map(pe=>({range:p.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?T.fromMany(pe.hoverMessage):pe.hoverMessage?T.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):ne.map(pe=>({range:p.from(pe)}))}e.fromRangeOrRangeWithMessage=g;function E(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?P.URI.file(ne):ne}e.pathOrURIToURI=E;var u;(function(ne){function pe(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?E(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}ne.from=pe})(u=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var M;(function(ne){function pe(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?E(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?u.from(re.before):void 0,after:re.after?u.from(re.after):void 0}}ne.from=pe})(M=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(ne){function pe(re){if(typeof re=="undefined")return re;switch(re){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=pe})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(ne){function pe(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?O.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?M.from(re.light):void 0,dark:re.dark?M.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?E(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?u.from(re.before):void 0,after:re.after?u.from(re.after):void 0}}ne.from=pe})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(ne){function pe(U){return{text:U.newText,eol:U.newEol&&he.from(U.newEol),range:p.from(U.range)}}ne.from=pe;function re(U){const Ce=new w.TextEdit(p.to(U.range),U.text);return Ce.newEol=typeof U.eol=="undefined"?void 0:he.to(U.eol),Ce}ne.to=re})(K=e.TextEdit||(e.TextEdit={}));var $;(function(ne){function pe(U,Ce,Se){const Ge={edits:[]};if(U instanceof w.WorkspaceEdit)for(let We of U._allEntries())if(We._type===1)Ge.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const it=Ce?.getDocument(We.uri);Ge.edits.push({_type:2,resource:We.uri,edit:K.from(We.edit),modelVersionId:it?.version,metadata:We.metadata})}else We._type===3?Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Et.from)}});return Ge}ne.from=pe;function re(U){const Ce=new w.WorkspaceEdit;for(const Se of U.edits)Se.edit?Ce.replace(P.URI.revive(Se.resource),p.to(Se.edit.range),Se.edit.text):Ce.renameFile(P.URI.revive(Se.oldUri),P.URI.revive(Se.newUri),Se.options);return Ce}ne.to=re})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(ne){const pe=Object.create(null);pe[w.SymbolKind.File]=0,pe[w.SymbolKind.Module]=1,pe[w.SymbolKind.Namespace]=2,pe[w.SymbolKind.Package]=3,pe[w.SymbolKind.Class]=4,pe[w.SymbolKind.Method]=5,pe[w.SymbolKind.Property]=6,pe[w.SymbolKind.Field]=7,pe[w.SymbolKind.Constructor]=8,pe[w.SymbolKind.Enum]=9,pe[w.SymbolKind.Interface]=10,pe[w.SymbolKind.Function]=11,pe[w.SymbolKind.Variable]=12,pe[w.SymbolKind.Constant]=13,pe[w.SymbolKind.String]=14,pe[w.SymbolKind.Number]=15,pe[w.SymbolKind.Boolean]=16,pe[w.SymbolKind.Array]=17,pe[w.SymbolKind.Object]=18,pe[w.SymbolKind.Key]=19,pe[w.SymbolKind.Null]=20,pe[w.SymbolKind.EnumMember]=21,pe[w.SymbolKind.Struct]=22,pe[w.SymbolKind.Event]=23,pe[w.SymbolKind.Operator]=24,pe[w.SymbolKind.TypeParameter]=25;function re(Ce){return typeof pe[Ce]=="number"?pe[Ce]:6}ne.from=re;function U(Ce){for(const Se in pe)if(pe[Se]===Ce)return Number(Se);return w.SymbolKind.Property}ne.to=U})(W=e.SymbolKind||(e.SymbolKind={}));var N;(function(ne){function pe(U){switch(U){case w.SymbolTag.Deprecated:return 1}}ne.from=pe;function re(U){switch(U){case 1:return w.SymbolTag.Deprecated}}ne.to=re})(N=e.SymbolTag||(e.SymbolTag={}));var H;(function(ne){function pe(U){return{name:U.name,kind:W.from(U.kind),tags:U.tags&&U.tags.map(N.from),containerName:U.containerName,location:le.from(U.location)}}ne.from=pe;function re(U){const Ce=new w.SymbolInformation(U.name,W.to(U.kind),U.containerName,le.to(U.location));return Ce.tags=U.tags&&U.tags.map(N.to),Ce}ne.to=re})(H=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(ne){function pe(U){const Ce={name:U.name||"!!MISSING: name!!",detail:U.detail,range:p.from(U.range),selectionRange:p.from(U.selectionRange),kind:W.from(U.kind),tags:U.tags?.map(N.from)??[]};return U.children&&(Ce.children=U.children.map(pe)),Ce}ne.from=pe;function re(U){const Ce=new w.DocumentSymbol(U.name,U.detail,W.to(U.kind),p.to(U.range),p.to(U.selectionRange));return(0,c.isNonEmptyArray)(U.tags)&&(Ce.tags=U.tags.map(N.to)),U.children&&(Ce.children=U.children.map(re)),Ce}ne.to=re})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(ne){function pe(U){const Ce=new w.CallHierarchyItem(W.to(U.kind),U.name,U.detail||"",P.URI.revive(U.uri),p.to(U.range),p.to(U.selectionRange));return Ce._sessionId=U._sessionId,Ce._itemId=U._itemId,Ce}ne.to=pe;function re(U,Ce,Se){if(Ce=Ce??U._sessionId,Se=Se??U._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,name:U.name,detail:U.detail,kind:W.from(U.kind),uri:U.uri,range:p.from(U.range),selectionRange:p.from(U.selectionRange),tags:U.tags?.map(N.from)}}ne.from=re})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ce;(function(ne){function pe(re){return new w.CallHierarchyIncomingCall(Y.to(re.from),re.fromRanges.map(U=>p.to(U)))}ne.to=pe})(ce=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var G;(function(ne){function pe(re){return new w.CallHierarchyOutgoingCall(Y.to(re.to),re.fromRanges.map(U=>p.to(U)))}ne.to=pe})(G=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var le;(function(ne){function pe(U){return{range:U.range&&p.from(U.range),uri:U.uri}}ne.from=pe;function re(U){return new w.Location(P.URI.revive(U.uri),p.to(U.range))}ne.to=re})(le=e.location||(e.location={}));var oe;(function(ne){function pe(U){const Ce=U,Se=U;return{originSelectionRange:Ce.originSelectionRange?p.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Se.uri,range:p.from(Ce.targetRange?Ce.targetRange:Se.range),targetSelectionRange:Ce.targetSelectionRange?p.from(Ce.targetSelectionRange):void 0}}ne.from=pe;function re(U){return{targetUri:P.URI.revive(U.uri),targetRange:p.to(U.range),targetSelectionRange:U.targetSelectionRange?p.to(U.targetSelectionRange):void 0,originSelectionRange:U.originSelectionRange?p.to(U.originSelectionRange):void 0}}ne.to=re})(oe=e.DefinitionLink||(e.DefinitionLink={}));var Ee;(function(ne){function pe(U){return{range:p.from(U.range),contents:T.fromMany(U.contents)}}ne.from=pe;function re(U){return new w.Hover(U.contents.map(T.to),p.to(U.range))}ne.to=re})(Ee=e.Hover||(e.Hover={}));var Fe;(function(ne){function pe(U){return{range:p.from(U.range),expression:U.expression}}ne.from=pe;function re(U){return new w.EvaluatableExpression(p.to(U.range),U.expression)}ne.to=re})(Fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Me;(function(ne){function pe(U){if(U instanceof w.InlineValueText)return{type:"text",range:p.from(U.range),text:U.text};if(U instanceof w.InlineValueVariableLookup)return{type:"variable",range:p.from(U.range),variableName:U.variableName,caseSensitiveLookup:U.caseSensitiveLookup};if(U instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(U.range),expression:U.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=pe;function re(U){switch(U.type){case"text":return{range:p.to(U.range),text:U.text};case"variable":return{range:p.to(U.range),variableName:U.variableName,caseSensitiveLookup:U.caseSensitiveLookup};case"expression":return{range:p.to(U.range),expression:U.expression}}}ne.to=re})(Me=e.InlineValue||(e.InlineValue={}));var Ne;(function(ne){function pe(U){return{frameId:U.frameId,stoppedLocation:p.from(U.stoppedLocation)}}ne.from=pe;function re(U){return new w.InlineValueContext(U.frameId,p.to(U.stoppedLocation))}ne.to=re})(Ne=e.InlineValueContext||(e.InlineValueContext={}));var Qe;(function(ne){function pe(U){return{range:p.from(U.range),kind:U.kind}}ne.from=pe;function re(U){return new w.DocumentHighlight(p.to(U.range),U.kind)}ne.to=re})(Qe=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(ne){function pe(re){switch(re){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}ne.to=pe})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(ne){function pe(re){return{triggerKind:ze.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}ne.to=pe})(qe=e.CompletionContext||(e.CompletionContext={}));var B;(function(ne){function pe(U){switch(U){case w.CompletionItemTag.Deprecated:return 1}}ne.from=pe;function re(U){switch(U){case 1:return w.CompletionItemTag.Deprecated}}ne.to=re})(B=e.CompletionItemTag||(e.CompletionItemTag={}));var Q;(function(ne){const pe=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function re(Se){return pe.get(Se)??9}ne.from=re;const U=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Ce(Se){return U.get(Se)??w.CompletionItemKind.Property}ne.to=Ce})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ne){function pe(re,U){const Ce=new w.CompletionItem(re.label);return Ce.insertText=re.insertText,Ce.kind=Q.to(re.kind),Ce.tags=re.tags?.map(B.to),Ce.detail=re.detail,Ce.documentation=_.isMarkdownString(re.documentation)?T.to(re.documentation):re.documentation,Ce.sortText=re.sortText,Ce.filterText=re.filterText,Ce.preselect=re.preselect,Ce.commitCharacters=re.commitCharacters,t.Range.isIRange(re.range)?Ce.range=p.to(re.range):typeof re.range=="object"&&(Ce.range={inserting:p.to(re.range.insert),replacing:p.to(re.range.replace)}),Ce.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?Ce.insertText=new w.SnippetString(re.insertText):(Ce.insertText=re.insertText,Ce.textEdit=Ce.range instanceof w.Range?new w.TextEdit(Ce.range,Ce.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(Ce.additionalTextEdits=re.additionalTextEdits.map(Se=>K.to(Se))),Ce.command=U&&re.command?U.fromInternal(re.command):void 0,Ce}ne.to=pe})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ne){function pe(U){return{label:U.label,documentation:U.documentation?T.fromStrict(U.documentation):void 0}}ne.from=pe;function re(U){return{label:U.label,documentation:_.isMarkdownString(U.documentation)?T.to(U.documentation):U.documentation}}ne.to=re})(ae=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(ne){function pe(U){return{label:U.label,documentation:U.documentation?T.fromStrict(U.documentation):void 0,parameters:Array.isArray(U.parameters)?U.parameters.map(ae.from):[],activeParameter:U.activeParameter}}ne.from=pe;function re(U){return{label:U.label,documentation:_.isMarkdownString(U.documentation)?T.to(U.documentation):U.documentation,parameters:Array.isArray(U.parameters)?U.parameters.map(ae.to):[],activeParameter:U.activeParameter}}ne.to=re})(j=e.SignatureInformation||(e.SignatureInformation={}));var se;(function(ne){function pe(U){return{activeSignature:U.activeSignature,activeParameter:U.activeParameter,signatures:Array.isArray(U.signatures)?U.signatures.map(j.from):[]}}ne.from=pe;function re(U){return{activeSignature:U.activeSignature,activeParameter:U.activeParameter,signatures:Array.isArray(U.signatures)?U.signatures.map(j.to):[]}}ne.to=re})(se=e.SignatureHelp||(e.SignatureHelp={}));var fe;(function(ne){function pe(U){return{text:U.text,position:i.from(U.position),kind:Ae.from(U.kind??w.InlayHintKind.Other),whitespaceBefore:U.whitespaceBefore,whitespaceAfter:U.whitespaceAfter}}ne.from=pe;function re(U){const Ce=new w.InlayHint(U.text,i.to(U.position),Ae.to(U.kind));return Ce.whitespaceAfter=U.whitespaceAfter,Ce.whitespaceBefore=U.whitespaceBefore,Ce}ne.to=re})(fe=e.InlayHint||(e.InlayHint={}));var Ae;(function(ne){function pe(U){return U}ne.from=pe;function re(U){return U}ne.to=re})(Ae=e.InlayHintKind||(e.InlayHintKind={}));var xe;(function(ne){function pe(U){return{range:p.from(U.range),url:U.target,tooltip:U.tooltip}}ne.from=pe;function re(U){let Ce;if(U.url)try{Ce=typeof U.url=="string"?P.URI.parse(U.url,!0):P.URI.revive(U.url)}catch(Se){}return new w.DocumentLink(p.to(U.range),Ce)}ne.to=re})(xe=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ne){function pe(U){const Ce=new w.ColorPresentation(U.label);return U.textEdit&&(Ce.textEdit=K.to(U.textEdit)),U.additionalTextEdits&&(Ce.additionalTextEdits=U.additionalTextEdits.map(Se=>K.to(Se))),Ce}ne.to=pe;function re(U){return{label:U.label,textEdit:U.textEdit?K.from(U.textEdit):void 0,additionalTextEdits:U.additionalTextEdits?U.additionalTextEdits.map(Ce=>K.from(Ce)):void 0}}ne.from=re})($e=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(ne){function pe(U){return new w.Color(U[0],U[1],U[2],U[3])}ne.to=pe;function re(U){return[U.red,U.green,U.blue,U.alpha]}ne.from=re})(ve=e.Color||(e.Color={}));var Ze;(function(ne){function pe(U){return{range:p.from(U.range)}}ne.from=pe;function re(U){return new w.SelectionRange(p.to(U.range))}ne.to=re})(Ze=e.SelectionRange||(e.SelectionRange={}));var z;(function(ne){function pe(re){switch(re){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}ne.to=pe})(z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(ne){function pe(U){switch(U){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=pe;function re(U){switch(U){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}ne.to=re})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var he;(function(ne){function pe(U){if(U===w.EndOfLine.CRLF)return 1;if(U===w.EndOfLine.LF)return 0}ne.from=pe;function re(U){if(U===1)return w.EndOfLine.CRLF;if(U===0)return w.EndOfLine.LF}ne.to=re})(he=e.EndOfLine||(e.EndOfLine={}));var Oe;(function(ne){function pe(re){if(typeof re=="object")return re.viewId;switch(re){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=pe})(Oe=e.ProgressLocation||(e.ProgressLocation={}));var Ve;(function(ne){function pe(re){const U={start:re.start+1,end:re.end+1};return re.kind&&(U.kind=tt.from(re.kind)),U}ne.from=pe})(Ve=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ne){function pe(re){if(re)switch(re){case w.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}ne.from=pe})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ut;(function(ne){function pe(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?p.from(re.selection):void 0,override:typeof re.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=pe})(ut=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ht;(function(ne){function pe(U){return U instanceof w.RelativePattern||typeof U=="string"?U:re(U)?new w.RelativePattern(U.base,U.pattern):U}ne.from=pe;function re(U){const Ce=U;return Ce&&typeof Ce.base=="string"&&typeof Ce.pattern=="string"}})(ht=e.GlobPattern||(e.GlobPattern={}));var St;(function(ne){function pe(re){if(re){if(Array.isArray(re))return re.map(pe);if(typeof re=="string")return re;{const U=re;return{language:U.language,scheme:U.scheme,pattern:typeof U.pattern=="undefined"?void 0:ht.from(U.pattern),exclusive:U.exclusive}}}else return}ne.from=pe})(St=e.LanguageSelector||(e.LanguageSelector={}));var Pt;(function(ne){function pe(U){return{start:U.start,end:U.end}}ne.from=pe;function re(U){return new w.NotebookRange(U.start,U.end)}ne.to=re})(Pt=e.NotebookRange||(e.NotebookRange={}));var dt;(function(ne){function pe(U){return{timing:typeof U.runStartTime=="number"&&typeof U.runEndTime=="number"?{startTime:U.runStartTime,endTime:U.runEndTime}:void 0,executionOrder:U.executionOrder,success:U.lastRunSuccess}}ne.to=pe;function re(U){return{lastRunSuccess:U.success,runStartTime:U.timing?.startTime,runEndTime:U.timing?.endTime,executionOrder:U.executionOrder}}ne.from=re})(dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var bt;(function(ne){function pe(U){switch(U){case w.NotebookCellKind.Markup:return d.CellKind.Markup;case w.NotebookCellKind.Code:default:return d.CellKind.Code}}ne.from=pe;function re(U){switch(U){case d.CellKind.Markup:return w.NotebookCellKind.Markup;case d.CellKind.Code:default:return w.NotebookCellKind.Code}}ne.to=re})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ne){function pe(U){const Ce={metadata:U.metadata??Object.create(null),cells:[]};for(let Se of U.cells)w.NotebookCellData.validate(Se),Ce.cells.push(Et.from(Se));return Ce}ne.from=pe;function re(U){const Ce=new w.NotebookData(U.cells.map(Et.to));return(0,S.isEmptyObject)(U.metadata)||(Ce.metadata=U.metadata),Ce}ne.to=re})(ft=e.NotebookData||(e.NotebookData={}));var Et;(function(ne){function pe(U){return{cellKind:bt.from(U.kind),language:U.languageId,mime:U.mime,source:U.value,metadata:U.metadata,internalMetadata:dt.from(U.executionSummary??{}),outputs:U.outputs?U.outputs.map(Ct.from):[]}}ne.from=pe;function re(U){return new w.NotebookCellData(bt.to(U.cellKind),U.source,U.language,U.mime,U.outputs?U.outputs.map(Ct.to):void 0,U.metadata,U.internalMetadata?dt.to(U.internalMetadata):void 0)}ne.to=re})(Et=e.NotebookCellData||(e.NotebookCellData={}));var Ye;(function(ne){function pe(U){return{mime:U.mime,valueBytes:F.VSBuffer.wrap(U.data)}}ne.from=pe;function re(U){return new w.NotebookCellOutputItem(U.valueBytes.buffer,U.mime)}ne.to=re})(Ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(ne){function pe(U){return{outputId:U.id,items:U.items.map(Ye.from),metadata:U.metadata}}ne.from=pe;function re(U){const Ce=U.items.map(Ye.to);return new w.NotebookCellOutput(Ce,U.outputId,U.metadata)}ne.to=re})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(ne){function pe(Se){if(Se!=null){if(Se instanceof w.RelativePattern||typeof Se=="string")return Se;if(Ce(Se))return new w.RelativePattern(Se.base,Se.pattern);if(U(Se))return{include:ht.from(Se.include)||void 0,exclude:ht.from(Se.exclude)||void 0}}}ne.from=pe;function re(Se){return typeof Se=="string"?Se:Ce(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}ne.to=re;function U(Se){const Ge=Se,We=ht.from(Ge.include);if(!(We&&We instanceof w.RelativePattern||typeof We=="string"))return!1;const it=ht.from(Ge.exclude);return!!(it&&it instanceof w.RelativePattern||typeof it=="string")}function Ce(Se){const Ge=Se;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(ne){function pe(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?u.from(re.top):void 0}}ne.from=pe})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var De;(function(ne){function pe(re,U,Ce){const Se=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:U.toInternal(Se,Ce),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}ne.from=pe})(De=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Z;(function(ne){function pe(re){return{transientOutputs:re?.transientOutputs??!1,transientCellMetadata:re?.transientCellMetadata??{},transientDocumentMetadata:re?.transientDocumentMetadata??{}}}ne.from=pe})(Z=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ue;(function(ne){function pe(U){return{uri:U.uri,provides:U.provides}}ne.from=pe;function re(U){return new w.NotebookRendererScript(P.URI.revive(U.uri),U.provides)}ne.to=re})(ue=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(ne){function pe(U){return{message:T.fromStrict(U.message)||"",type:0,expected:U.expectedOutput,actual:U.actualOutput,location:U.location?le.from(U.location):void 0}}ne.from=pe;function re(U){const Ce=new w.TestMessage(typeof U.message=="string"?U.message:T.to(U.message));return Ce.actualOutput=U.actual,Ce.expectedOutput=U.expected,Ce.location=U.location?le.to(U.location):void 0,Ce}ne.to=re})(ge=e.TestMessage||(e.TestMessage={}));var me;(function(ne){let pe;(function(re){re.Delimiter="\0"})(pe||(pe={})),ne.namespace=(re,U)=>re+"\0"+U,ne.denamespace=re=>{const U=re.indexOf("\0");return{ctrlId:re.slice(0,U),tagId:re.slice(U+1)}}})(me=e.TestTag||(e.TestTag={}));var Ie;(function(ne){function pe(Se){const Ge=(0,s.getPrivateApiFor)(Se).controllerId;return{extId:v.TestId.fromExtHostTestItem(Se,Ge).toString(),label:Se.label,uri:Se.uri,tags:Se.tags.map(We=>me.namespace(Ge,We.id)),range:p.from(Se.range)||null,description:Se.description||null,error:Se.error&&T.fromStrict(Se.error)||null}}ne.from=pe;function re(Se){return{id:v.TestId.fromString(Se.extId).localId,label:Se.label,uri:P.URI.revive(Se.uri),tags:(Se.tags||[]).map(Ge=>{const{tagId:We}=me.denamespace(Ge);return new w.TestTag(We)}),range:p.to(Se.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Se.description||void 0}}ne.toPlain=re;function U(Se){const Ge=v.TestId.fromString(Se.extId),We=new s.TestItemImpl(Ge.controllerId,Ge.localId,Se.label,P.URI.revive(Se.uri));return We.range=p.to(Se.range||void 0),We.description=Se.description||void 0,We}function Ce(Se){let Ge;for(const We of Se.tests){const it=U(We.item);(0,s.getPrivateApiFor)(it).parent=Ge,Ge=it}return Ge}ne.toItemFromContext=Ce})(Ie=e.TestItem||(e.TestItem={})),function(ne){function pe(U){return{id:U.id}}ne.from=pe;function re(U){return new w.TestTag(U.id)}ne.to=re}(me=e.TestTag||(e.TestTag={}));var Be;(function(ne){const pe=(U,Ce)=>{const Se={...Ie.toPlain(U.item),parent:void 0,taskStates:U.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(We=>We.type===0).map(ge.to)})),children:U.children.map(Ge=>Ce.get(Ge)).filter(S.isDefined).map(Ge=>pe(Ge,Ce))};for(const Ge of Se.children)Ge.parent=Se;return Se};function re(U){const Ce=[],Se=new Map;for(const Ge of U.items)Se.set(Ge.item.extId,Ge),U.request.targets.some(We=>We.controllerId===Ge.controllerId&&We.testIds.includes(Ge.item.extId))&&Ce.push(Ge);return{completedAt:U.completedAt,results:Ce.map(Ge=>pe(Ge,Se))}}ne.to=re})(Be=e.TestResults||(e.TestResults={}));var Le;(function(ne){function pe(Se){return{covered:Se.covered,total:Se.covered}}function re(Se){return"line"in Se?i.from(Se):p.from(Se)}function U(Se){return"branches"in Se?{count:Se.executionCount,location:re(Se.location),type:1,branches:Se.branches.length?Se.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&re(Ge.location)})):void 0}:{type:0,count:Se.executionCount,location:re(Se.location)}}ne.fromDetailed=U;function Ce(Se){return{uri:Se.uri,statement:pe(Se.statementCoverage),branch:Se.branchCoverage&&pe(Se.branchCoverage),function:Se.functionCoverage&&pe(Se.functionCoverage),details:Se.detailedCoverage?.map(U)}}ne.fromFile=Ce})(Le=e.TestCoverage||(e.TestCoverage={}));var je;(function(ne){function pe(re){switch(re){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}ne.to=pe})(je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Xe;(function(ne){function pe(U){const Ce=new w.TypeHierarchyItem(W.to(U.kind),U.name,U.detail||"",P.URI.revive(U.uri),p.to(U.range),p.to(U.selectionRange));return Ce._sessionId=U._sessionId,Ce._itemId=U._itemId,Ce}ne.to=pe;function re(U,Ce,Se){if(Ce=Ce??U._sessionId,Se=Se??U._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,kind:W.from(U.kind),name:U.name,detail:U.detail??"",uri:U.uri,range:p.from(U.range),selectionRange:p.from(U.selectionRange),tags:U.tags?.map(N.from)}}ne.from=re})(Xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[169],be([0,1,2,16,7,8,230]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(P,t,y,n={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=y,this._thresholds=n,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,y,n)=>{const s={dispose:this._callbacks.push([t,y,P])};return Array.isArray(n)&&n.push(s),s}}async $participateInSave(P,t){const y=c.URI.revive(P);let n=!1;const h=setTimeout(()=>n=!0,this._thresholds.timeout),s=[];try{for(let d of[...this._callbacks]){if(n)break;const v=this._documents.getDocument(y),C=await this._deliverEventAsyncAndBlameBadListeners(d,{document:v,reason:A.TextDocumentSaveReason.to(t)});s.push(C)}}finally{clearTimeout(h)}return s}_deliverEventAsyncAndBlameBadListeners([P,t,y],n){const h=this._badListeners.get(P);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,P,t,n).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const d=this._badListeners.get(P);this._badListeners.set(P,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,y,n){const h=[],s=Date.now(),{document:d,reason:v}=n,{version:C}=d,w=Object.freeze({document:d,reason:v,waitUntil(a){if(Object.isFrozen(h))throw(0,F.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(a))}});try{t.apply(y,[w])}catch(a){return Promise.reject(a)}return Object.freeze(h),new Promise((a,p)=>{const k=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(k),a(i)}).catch(i=>{clearTimeout(k),p(i)})}).then(a=>{const p={edits:[]};for(const k of a)if(Array.isArray(k)&&k.every(i=>i instanceof _.TextEdit))for(const{newText:i,newEol:l,range:r}of k)p.edits.push({_type:2,resource:d.uri,edit:{range:r&&A.Range.from(r),text:i,eol:l&&A.EndOfLine.from(l)}});if(p.edits.length!==0)return C===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(we[68],be([0,1,8,2,3,4]),function(ie,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class R{constructor(){this._onDidChangeTabs=new _.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new _.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(S){let P=-1;this._tabs=S.map((y,n)=>{y.isActive&&(P=n);let h;if(y.resource){const s=y.resource;s.primary||s.secondary?h={primary:F.URI.revive(s.primary),secondary:F.URI.revive(s.secondary)}:h=F.URI.revive(y.resource)}return Object.freeze({label:y.label,viewColumn:c.ViewColumn.to(y.viewColumn),resource:h,editorId:y.editorId,isActive:y.isActive})});const t=this._activeTab;this._activeTab=P===-1?void 0:this._tabs[P],this._activeTab!==t&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=R}),define(we[170],be([0,1,3,27,2,8,7]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(t,y,n,h,s){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,n&&(this._config+=1),h&&(this._config+=2),s&&(this._config+=4);const d=(0,F.parse)(y),v=t(C=>{if(!n)for(let w of C.created){const a=_.URI.revive(w);d(a.fsPath)&&this._onDidCreate.fire(a)}if(!h)for(let w of C.changed){const a=_.URI.revive(w);d(a.fsPath)&&this._onDidChange.fire(a)}if(!s)for(let w of C.deleted){const a=_.URI.revive(w);d(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(t,y,n){this._logService=y,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,y,n,h){return new I(this._onFileSystemEvent.event,t,y,n,h)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,y){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:y.map(n=>({oldUri:_.URI.revive(n.source),newUri:_.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:y.map(n=>_.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:y.map(n=>_.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,y){return(n,h,s)=>{const d=function(C){n.call(h,C)};return d.extension=t,y.event(d,void 0,s)}}async $onWillRunFileOperation(t,y,n,h){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:y.map(s=>({oldUri:_.URI.revive(s.source),newUri:_.URI.revive(s.target)}))},n,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:y.map(s=>_.URI.revive(s.target))},n,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:y.map(s=>_.URI.revive(s.target))},n,h)}}async _fireWillEvent(t,y,n,h){const s=new Set,d=[];if(await t.fireAsync(y,h,async(C,w)=>{const a=Date.now(),p=await Promise.resolve(C);p instanceof R.WorkspaceEdit&&(d.push(p),s.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-a>n&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),h.isCancellationRequested||d.length===0)return;const v={edits:[]};for(let C of d){let{edits:w}=A.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(w)}return{edit:v,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=S}),define(we[171],be([0,1,11,22,2,8,7,89]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(n,h,s,d){this.start=n,this.deletedCount=h,this.deletedItems=s,this.items=d}static asApiEvents(n){return n.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(s=>s.apiCell)}))}}class P{constructor(n,h,s){this.notebook=n,this._extHostDocument=h,this._cellData=s,this.handle=s.handle,this.uri=_.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=s.internalMetadata??{},this._metadata=Object.freeze(s.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(s.internalMetadata??{}))}static asModelAddData(n,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return n._mime},set mime(s){n._mime=s},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,h,s){const d=s.map(A.NotebookCellOutputItem.to),v=this._outputs.find(C=>C.id===n);v&&(h||(v.items.length=0),v.items.push(...d))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=P;class t{constructor(n,h,s,d,v,C){this._proxy=n,this._textDocumentsAndEditors=h,this._textDocuments=s,this._emitter=d,this.uri=v,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=C.viewType,this._metadata=Object.freeze(C.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,C.cells]],!0),this._versionId=C.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===c.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(h){return h=n._validateIndex(h),n._cells[h].apiCell},getCells(h){return(h?n._getCells(h):n._cells).map(d=>d.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,h){this._versionId=n.versionId,this._isDirty=h;for(const s of n.rawEvents)s.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===I.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(s.index,s.metadata):s.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(s.index,s.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let h=n.start|0,s=n.end|0;return h<0&&(h=0),s>this._cells.length&&(s=this._cells.length),n.with({start:h,end:s})}_getCells(n){n=this._validateRange(n);const h=[];for(let s=n.start;s<n.end;s++)h.push(this._cells[s]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,h){if(this._disposed)return;const s=[],d=[],v=[];n.reverse().forEach(C=>{const a=C[2].map(i=>{const l=new P(this,this._textDocumentsAndEditors,i);return h||d.push(P.asModelAddData(this.apiNotebook,i)),l}),p=new S(C[0],C[1],[],a),k=this._cells.splice(C[0],C[1],...a);for(const i of k)v.push(i.uri),p.deletedItems.push(i.apiCell);s.push(p)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:v}),h||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(s)}))}_moveCell(n,h){const s=this._cells.splice(n,1);this._cells.splice(h,0,...s);const d=[new S(n,1,s.map(v=>v.apiCell),[]),new S(h,0,[],s)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(d)}))}_setCellOutputs(n,h){const s=this._cells[n];s.setOutputs(h),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_setCellOutputItems(n,h,s,d){const v=this._cells[n];v.setOutputItems(h,s,d),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(n,h){const s=this._cells[n];s.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(s.uri,h)}_changeCellMime(n,h){const s=this._cells[n];s.apiCell.mime=h}_changeCellMetadata(n,h){const s=this._cells[n],d=s.apiCell.metadata;s.setMetadata(h);const v=s.apiCell.metadata;(0,F.equals)(d,v)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:s.apiCell}))}_changeCellInternalMetadata(n,h){const s=this._cells[n],d=s.internalMetadata;if(s.setInternalMetadata(h),d.runState!==h.runState){const v=h.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:s.apiCell,state:v}))}}getCellFromApiCell(n){return this._cells.find(h=>h.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(h=>h.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(we[93],be([0,1,7,8,16]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:P})}replaceCells(S,P,t){this._throwIfFinalized(),!(S===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:S,count:P-S,cells:t.map(F.NotebookCellData.from)})}}class R{constructor(S,P,t,y,n,h){this.id=S,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=y,this._viewColumn=h}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(P){if(!Array.isArray(P)||!P.every(c.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");S._selections=P,S._trySetSelections(P)},get visibleRanges(){return S._visibleRanges},revealRange(P,t){S._proxy.$tryRevealRange(S.id,F.NotebookRange.from(P),t??c.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(P){const t=new A(this.document.version);return P(t),S._applyEdit(t.finalize())},setDecorations(P,t){return S.setDecorations(P,t)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(F.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let y=0;y<S.cellEdits.length;y++){if(t<0){P.push(S.cellEdits[y]),t++;continue}const h=P[t],s=S.cellEdits[y];if(h.editType===1&&s.editType===1&&h.index===s.index){h.cells.push(...S.cellEdits[y].cells),h.count+=S.cellEdits[y].count;continue}P.push(S.cellEdits[y]),t++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,P)}setDecorations(S,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return P.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(P),S.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(we[172],be([0,1,8,146,125,21,52]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(y){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=y}withProgress(y,n,h){const s=this._handles++,{title:d,location:v,cancellable:C}=n,w={label:(0,_.localize)(0,null,y.displayName||y.name),id:y.identifier.value};return this._proxy.$startProgress(s,{location:c.ProgressLocation.from(v),title:d,source:w,cancellable:C},y),this._withProgress(s,h,!!C)}_withProgress(y,n,h){let s;h&&(s=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(y,s));const d=C=>{this._proxy.$progressEnd(C),this._mapHandleToCancellationSource.delete(C),s&&s.dispose()};let v;try{v=n(new P(this._proxy,y),h&&s?s.token:A.CancellationToken.None)}catch(C){throw d(y),C}return v.then(C=>d(y),C=>d(y)),v}$acceptProgressCanceled(y){const n=this._mapHandleToCancellationSource.get(y);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(y))}}e.ExtHostProgress=I;function S(t,y){return t.message=y.message,typeof y.increment=="number"&&(typeof t.increment=="number"?t.increment+=y.increment:t.increment=y.increment),t}class P extends F.Progress{constructor(y,n){super(h=>this.throttledReport(h));this._proxy=y,this._handle=n}throttledReport(y){this._proxy.$progressReport(this._handle,y)}}Ue([(0,R.throttle)(100,(t,y)=>S(t,y),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(we[94],be([0,1,40,16,53,8,7]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(n,h,s){const d=I._Keys.nextId();n.$registerTextEditorDecorationType(h.identifier,d,A.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:d,dispose(){n.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=I,I._Keys=new _.IdGenerator("TextEditorDecorationType");class S{constructor(n,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,h){this._throwIfFinalized();let s=null;if(n instanceof R.Position)s=new R.Range(n,n);else if(n instanceof R.Range)s=n;else throw new Error("Unrecognized location");this._pushEdit(s,h,!1)}insert(n,h){this._throwIfFinalized(),this._pushEdit(new R.Range(n,n),h,!0)}delete(n){this._throwIfFinalized();let h=null;if(n instanceof R.Range)h=n;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(n,h,s){const d=this._document.validateRange(n);this._collectedEdits.push({range:d,text:h,forceMoveMarkers:s})}setEndOfLine(n){if(this._throwIfFinalized(),n!==R.EndOfLine.LF&&n!==R.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=S;class P{constructor(n,h,s,d){this._proxy=n,this._id=h,this._accept(s),this._logService=d;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(C){v._setTabSize(C)},get insertSpaces(){return v._insertSpaces},set insertSpaces(C){v._setInsertSpaces(C)},get cursorStyle(){return v._cursorStyle},set cursorStyle(C){v._setCursorStyle(C)},get lineNumbers(){return v._lineNumbers},set lineNumbers(C){v._setLineNumbers(C)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const h=Math.floor(n);return h>0?h:null}if(typeof n=="string"){const h=parseInt(n,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(n){const h=this._validateTabSize(n);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const h=this._validateInsertSpaces(n);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const h={};let s=!1;if(typeof n.tabSize!="undefined"){const d=this._validateTabSize(n.tabSize);d==="auto"?(s=!0,h.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,s=!0,h.tabSize=d)}if(typeof n.insertSpaces!="undefined"){const d=this._validateInsertSpaces(n.insertSpaces);d==="auto"?(s=!0,h.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,s=!0,h.insertSpaces=d)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,s=!0,h.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,s=!0,h.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(n){n.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=P;class t{constructor(n,h,s,d,v,C,w,a){this.id=n,this._proxy=h,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new P(this._proxy,this.id,C,s),this._visibleRanges=w,this._viewColumn=a;const p=this;this.value=Object.freeze({get document(){return d.getValue()},set document(k){throw(0,F.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(k){if(!(k instanceof R.Selection))throw(0,F.illegalArgument)("selection");p._selections=[k],p._trySetSelection()},get selections(){return p._selections},set selections(k){if(!Array.isArray(k)||k.some(i=>!(i instanceof R.Selection)))throw(0,F.illegalArgument)("selections");p._selections=k,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(k){throw(0,F.readonly)("visibleRanges")},get options(){return p._options.value},set options(k){p._disposed||p._options.assign(k)},get viewColumn(){return p._viewColumn},set viewColumn(k){throw(0,F.readonly)("viewColumn")},edit(k,i={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new S(d.getValue(),i);return k(l),p._applyEdit(l)},insertSnippet(k,i,l={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=p._selections.map(o=>A.Range.from(o));else if(i instanceof R.Position){const{lineNumber:o,column:b}=A.Position.from(i);r=[{startLineNumber:o,startColumn:b,endLineNumber:o,endColumn:b}]}else if(i instanceof R.Range)r=[A.Range.from(i)];else{r=[];for(const o of i)if(o instanceof R.Range)r.push(A.Range.from(o));else{const{lineNumber:b,column:f}=A.Position.from(o);r.push({startLineNumber:b,startColumn:f,endLineNumber:b,endColumn:f})}}return h.$tryInsertSnippet(n,k.value,r,l)},setDecorations(k,i){const l=i.length===0;l&&!p._hasDecorationsForKey.has(k.key)||(l?p._hasDecorationsForKey.delete(k.key):p._hasDecorationsForKey.add(k.key),p._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return h.$trySetDecorations(n,k.key,A.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let o=0,b=i.length;o<b;o++){const f=i[o];r[4*o]=f.start.line+1,r[4*o+1]=f.start.character+1,r[4*o+2]=f.end.line+1,r[4*o+3]=f.end.character+1}return h.$trySetDecorationsFast(n,k.key,r)}}))},revealRange(k,i){p._runOnProxy(()=>h.$tryRevealRange(n,A.Range.from(k),i||R.TextEditorRevealType.Default))},show(k){h.$tryShowEditor(n,A.ViewColumn.from(k))},hide(){h.$tryHideEditor(n)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,c.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,c.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,c.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,c.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const h=n.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const s=h.edits.map(v=>v.range);s.sort((v,C)=>v.end.line===C.end.line?v.end.character===C.end.character?v.start.line===C.start.line?v.start.character-C.start.character:v.start.line-C.start.line:v.end.character-C.end.character:v.end.line-C.end.line);for(let v=0,C=s.length-1;v<C;v++){const w=s[v].end;if(s[v+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=h.edits.map(v=>({range:A.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,d,{setEndOfLine:typeof h.setEndOfLine=="number"?A.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=t}),define(we[173],be([0,1,128,24,2,3,6,161,14,7,10,13,8,21,158]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(w,a){if((0,t.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let p;return Array.isArray(w.highlights)&&(p=w.highlights.filter(k=>k.length===2&&typeof k[0]=="number"&&typeof k[1]=="number"),p=p.length?p:void 0),{label:w.label,highlights:p}}}class v{constructor(a,p,k){this._proxy=a,this.commands=p,this.logService=k,this.treeViews=new Map;function i(l){return l&&l.$treeViewId&&l.$treeItemHandle}p.registerArgumentProcessor({processArgument:l=>i(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(r=>i(r)?this.convertArgument(r):r):l})}registerTreeDataProvider(a,p,k){const i=this.createTreeView(a,{treeDataProvider:p},k);return{dispose:()=>i.dispose()}}createTreeView(a,p,k){if(!p||!p.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=p.dragAndDropController!==void 0,l=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!p.showCollapseAll,canSelectMany:!!p.canSelectMany,canDragAndDrop:i}),r=this.createExtHostTreeView(a,p,k);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(o){r.message=o},get title(){return r.title},set title(o){r.title=o},get description(){return r.description},set description(o){r.description=o},reveal:(o,b)=>r.reveal(o,b),dispose:async()=>{await l,this.treeViews.delete(a),r.dispose()}}}$getChildren(a,p){const k=this.treeViews.get(a);return k?k.getChildren(p):Promise.reject(new Error((0,c.localize)(0,null,a)))}async $onDrop(a,p,k){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,c.localize)(1,null,a)));const l=s.TreeDataTransferConverter.toITreeDataTransfer(p);if(l.items.has(I.TREE_ITEM_DATA_TRANSFER_TYPE)){const o=JSON.parse(await l.items.get(I.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(b=>i.getExtensionElement(b)).filter(b=>!!b);o.length>0?l.items.set(I.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(o)}):l.items.delete(I.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(l,k)}async $hasResolve(a){const p=this.treeViews.get(a);if(!p)throw new Error((0,c.localize)(2,null,a));return p.hasResolve}$resolve(a,p,k){const i=this.treeViews.get(a);if(!i)throw new Error((0,c.localize)(3,null,a));return i.resolveTreeItem(p,k)}$setExpanded(a,p,k){const i=this.treeViews.get(a);if(!i)throw new Error((0,c.localize)(4,null,a));i.setExpanded(p,k)}$setSelection(a,p){const k=this.treeViews.get(a);if(!k)throw new Error((0,c.localize)(5,null,a));k.setSelection(p)}$setVisible(a,p){const k=this.treeViews.get(a);if(!k)throw new Error((0,c.localize)(6,null,a));k.setVisible(p)}createExtHostTreeView(a,p,k){const i=new C(a,p,this._proxy,this.commands.converter,this.logService,k);return this.treeViews.set(a,i),i}convertArgument(a){const p=this.treeViews.get(a.$treeViewId);return p?p.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=v;class C extends R.Disposable{constructor(a,p,k,i,l,r){super();if(this.viewId=a,this.proxy=k,this.commands=i,this.logService=l,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,r.contributes&&r.contributes.views)for(const f in r.contributes.views)for(const m of r.contributes.views[f])m.id===a&&(this._title=m.name);this.dataProvider=p.treeDataProvider,this.dndController=p.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let o,b;this._register(A.Event.debounce(this._onDidChangeData.event,(f,m)=>(f||(f={message:!1,elements:[]}),m.element!==!1&&(o||(o=new Promise(D=>b=D),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(m.element)?f.elements.push(...m.element):f.elements.push(m.element)),m.message&&(f.message=!0),f),200,!0)(({message:f,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const D=b;return o=null,this.refresh(m).then(()=>D())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,t.isUndefinedOrNull)(a))}async getChildren(a){const p=a?this.getExtensionElement(a):void 0;if(a&&!p)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let k=this.getChildrenNodes(a);return k||(k=await this.fetchChildrenNodes(p)),k?k.map(i=>i.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,p){p=p||{select:!0,focus:!1};const k=(0,t.isUndefinedOrNull)(p.select)?!0:p.select,i=(0,t.isUndefinedOrNull)(p.focus)?!1:p.focus,l=(0,t.isUndefinedOrNull)(p.expand)?!1:p.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:r.map(b=>b.item)},{select:k,focus:i,expand:l})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:k,focus:i,expand:l})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,p){const k=this.getExtensionElement(a);k&&(p?this._onDidExpandElement.fire(Object.freeze({element:k})):this._onDidCollapseElement.fire(Object.freeze({element:k})))}setSelection(a){(0,y.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,p){const k=this.getExtensionElement(p);if(!!k)return(0,S.asPromise)(()=>this.dndController?.onDrop(a,k))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,p){if(!this.dataProvider.resolveTreeItem)return;const k=this.elements.get(a);if(k){const i=this.nodes.get(k);if(i){const l=await this.dataProvider.resolveTreeItem(i.extensionItem,k,p)??i.extensionItem;return i.item.tooltip=this.getTooltip(l.tooltip),i.item.command=this.getCommand(i.disposableStore,l.command),i.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(p=>p?this.resolveUnknownParentChain(p).then(k=>this.resolveTreeNode(p,k[k.length-1]).then(i=>(k.push(i),k))):Promise.resolve([]))}resolveParent(a){const p=this.nodes.get(a);return p?Promise.resolve(p.parent?this.elements.get(p.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,p){const k=this.nodes.get(a);return k?Promise.resolve(k):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(i=>this.createHandle(a,i,p,!0)).then(i=>this.getChildren(p?p.item.handle:void 0).then(()=>{const l=this.getExtensionElement(i);if(l){const r=this.nodes.get(l);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(a){if(a){let p;if(typeof a=="string"){const k=this.getExtensionElement(a);p=k?this.nodes.get(k):void 0}else p=a;return p&&p.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const p=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const k=a?this.nodes.get(a):void 0,i=await this.dataProvider.getChildren(a);if(p.token.isCancellationRequested)return;const l=await Promise.all((0,y.coalesce)(i||[]).map(async r=>{const o=await this.dataProvider.getTreeItem(r);return o&&!p.token.isCancellationRequested?this.createAndRegisterTreeNode(r,o,k):null}));return p.token.isCancellationRequested?void 0:(0,y.coalesce)(l)}finally{p.dispose()}}refresh(a){if(a.some(k=>!k))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const k=this.getHandlesToRefresh(a);if(k.length)return this.refreshHandles(k)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const p=new Set,k=a.map(l=>this.nodes.get(l));for(const l of k)if(l&&!p.has(l.item.handle)){let r=l;for(;r&&r.parent&&k.findIndex(o=>r&&r.parent&&o&&o.item.handle===r.parent.item.handle)===-1;){const o=this.elements.get(r.parent.item.handle);r=o?this.nodes.get(o):void 0}r&&!r.parent&&p.add(l.item.handle)}const i=[];return p.forEach(l=>{const r=this.elements.get(l);if(r){const o=this.nodes.get(r);o&&(!o.parent||!p.has(o.parent.item.handle))&&i.push(l)}}),i}refreshHandles(a){const p={};return Promise.all(a.map(k=>this.refreshNode(k).then(i=>{i&&(p[k]=i.item)}))).then(()=>Object.keys(p).length?this.proxy.$refresh(this.viewId,p):void 0)}refreshNode(a){const p=this.getExtensionElement(a);if(p){const k=this.nodes.get(p);if(k)return this.clearChildren(p),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(i=>{if(i){const l=this.createTreeNode(p,i,k.parent);return this.updateNodeCache(p,l,k,k.parent),k.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,p,k){const i=this.createTreeNode(a,p,k);if(p.id&&this.elements.has(i.item.handle))throw new Error((0,c.localize)(7,null,p.id));return this.addNodeToCache(a,i),this.addNodeToParentCache(i,k),i}getTooltip(a){return P.MarkdownString.isMarkdownString(a)?n.MarkdownString.from(a):a}getCommand(a,p){return p?this.commands.toInternal(p,a):void 0}createTreeNode(a,p,k){const i=new R.DisposableStore,l=this.createHandle(a,p,k),r=this.getLightIconPath(p);return{item:{handle:l,parentHandle:k?k.item.handle:void 0,label:d(p.label,this.extension),description:p.description,resourceUri:p.resourceUri,tooltip:this.getTooltip(p.tooltip),command:this.getCommand(i,p.command),contextValue:p.contextValue,icon:r,iconDark:this.getDarkIconPath(p)||r,themeIcon:this.getThemeIcon(p),collapsibleState:(0,t.isUndefinedOrNull)(p.collapsibleState)?P.TreeItemCollapsibleState.None:p.collapsibleState,accessibilityInformation:p.accessibilityInformation},extensionItem:p,parent:k,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(a){return a.iconPath instanceof P.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:p,label:k,resourceUri:i},l,r){if(p)return`${C.ID_HANDLE_PREFIX}/${p}`;const o=d(k,this.extension),b=l?l.item.handle:C.LABEL_HANDLE_PREFIX;let f=o?o.label:i?(0,F.basename)(i):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const m=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,D=this.getChildrenNodes(l)||[];let T,g=0;do{if(T=`${b}/${g}:${f}`,r||!this.elements.has(T)||m===T)break;g++}while(g<=D.length);return T}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon))return typeof a.iconPath=="string"||_.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return _.URI.isUri(a)?a:_.URI.file(a)}addNodeToCache(a,p){this.elements.set(p.item.handle,a),this.nodes.set(a,p)}updateNodeCache(a,p,k,i){this.elements.delete(p.item.handle),this.nodes.delete(a),p.item.handle!==k.item.handle&&this.elements.delete(k.item.handle),this.addNodeToCache(a,p);const l=this.getChildrenNodes(i)||[],r=l.filter(o=>o.item.handle===k.item.handle)[0];r&&l.splice(l.indexOf(r),1,p)}addNodeToParentCache(a,p){p?(p.children||(p.children=[]),p.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const p=this.nodes.get(a);if(p){if(p.children)for(const k of p.children){const i=this.elements.get(k.item.handle);i&&this.clear(i)}p.children=void 0}}else this.clearAll()}clear(a){const p=this.nodes.get(a);if(p){if(p.children)for(const k of p.children){const i=this.elements.get(k.item.handle);i&&this.clear(i)}this.nodes.delete(a),this.elements.delete(p.item.handle),p.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}C.LABEL_HANDLE_PREFIX="0",C.ID_HANDLE_PREFIX="1"}),define(we[174],be([0,1,14,3,6,10,46,8,90,67]),function(ie,e,c,F,_,A,R,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends _.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const h=this.diff[this.diff.length-1];if(h&&n[0]===1){if(h[0]===1&&h[1].extId===n[1].extId){(0,S.applyTestItemUpdate)(h[1],n[1]);return}if(h[0]===0&&h[1].item.extId===n[1].extId){(0,S.applyTestItemUpdate)(h[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,h){const s=this.tree.get(n);if(!!s){if((s.expandLevels===void 0||h>s.expandLevels)&&(s.expandLevels=h),s.expand===1){const d=this.resolveChildren(s);return d.isOpen()?this.expandChildren(s,h-1):d.wait().then(()=>this.expandChildren(s,h-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,h-1)):this.expandChildren(s,h-1)}}dispose(){for(const n of this.tree.values())(0,R.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,h){switch(h.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(n.fullId,h.id));break;case 0:this.upsertItem(h.item,n);break;case 4:for(const w of h.ops)this.onTestItemEvent(n,w);break;case 3:const{key:s,value:d,previous:v}=h,C=n.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(d,v,C);break;case"range":this.pushDiff([1,{extId:C,item:{range:I.Range.from(d)}}]);break;case"error":this.pushDiff([1,{extId:C,item:{error:I.MarkdownString.fromStrict(d)||null}}]);break;default:this.pushDiff([1,{extId:C,item:{[s]:d??null}}]);break}break;default:(0,A.assertNever)(h)}}upsertItem(n,h){if(!(n instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const s=P.TestId.fromExtHostTestItem(n,this.root.id,h?.actual),d=(0,R.getPrivateApiFor)(n);d.parent&&d.parent!==h?.actual&&d.parent.children.delete(n.id);let v=this.tree.get(s.toString());if(!v){v={fullId:s,actual:n,parent:h?s.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(n,h),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:I.TestItem.from(n)}]),this.connectItemAndChildren(n,v,h);return}if(v.actual===n){this.connectItem(n,v,h);return}const C=v.actual.children,w=v.actual,a=(0,R.diffTestItems)(w,n);(0,R.getPrivateApiFor)(w).listener=void 0,v.actual=n,v.expand=0;for(const[p,k]of a)this.onTestItemEvent(v,{op:3,key:p,value:k,previous:w[p]});this.connectItemAndChildren(n,v,h);for(const p of C)n.children.get(p.id)||this.removeItem(P.TestId.joinToString(s,p.id))}diffTagRefs(n,h,s){const d=new Set(h.map(v=>v.id));for(const v of n)d.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:s,item:{tags:n.map(v=>I.TestTag.namespace(this.controllerId,v.id))}}]),d.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const h=this.tags.get(n.id);h?h.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:I.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const h=this.tags.get(n);h&&!--h.refCount&&(this.tags.delete(n),this.pushDiff([6,I.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,h){(0,R.getPrivateApiFor)(n).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(n,h,s){this.setItemParent(n,s);const d=(0,R.getPrivateApiFor)(n);d.parent=s?.actual,d.listener=v=>this.onTestItemEvent(h,v),this.updateExpandability(h)}connectItemAndChildren(n,h,s){this.connectItem(n,h,s);for(const d of n.children)this.upsertItem(d,h)}updateExpandability(n){let h;this._resolveHandler?n.resolveBarrier?h=n.resolveBarrier.isOpen()?3:2:h=n.actual.canResolveChildren?1:0:h=0,h!==n.expand&&(n.expand=h,this.pushDiff([1,{extId:n.fullId.toString(),expand:h}]),h===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,h){if(h<0)return;const s=[];for(const d of n.actual.children){const v=this.expand(P.TestId.joinToString(n.fullId,d.id),h);(0,c.isThenable)(v)&&s.push(v)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const v=new c.Barrier;return v.open(),v}n.expand=2,this.pushExpandStateUpdate(n);const h=n.resolveBarrier=new c.Barrier,s=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=v.stack||v.message||String(v))};let d;try{d=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(v){s(v)}return(0,c.isThenable)(d)?d.catch(s).then(()=>{h.open(),this.updateExpandability(n)}):(h.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const h=this.tree.get(n);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const s=[h];for(;s.length;){const d=s.pop();if(!!d){(0,R.getPrivateApiFor)(d.actual).listener=void 0;for(const v of d.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(d.fullId.toString());for(const v of d.actual.children)s.push(this.tree.get(P.TestId.joinToString(d.fullId,v.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(we[175],be([0,1,4,141]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(F.IEnvironmentService)}),define(we[176],be([0,1,25,3,17]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class R{constructor(t){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let y of t.activationEvents)y==="onUri"&&(y=`onUri:${c.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(t)}}keepOnly(t){const y=new Set;t.forEach(n=>y.add(c.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>y.has(c.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,y){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=R._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(n.map(h=>h.identifier)),y.length>0){const h=new Set;y.forEach(s=>h.add(c.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!h.has(c.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,C){this.addNode(v),this.addNode(C),this._arcs.has(v)?this._arcs.get(v).push(C):this._arcs.set(v,[C])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,C){const w=y.getArcs(v);for(let a=0;a<w.length;a++)if(!C.has(w[a]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let v of t){const C=c.ExtensionIdentifier.toKey(v.identifier);if(n.set(C,v),v.extensionDependencies)for(let w of v.extensionDependencies){const a=c.ExtensionIdentifier.toKey(w);y.addArc(C,a)}}let h=new Set;y.getNodes().filter(v=>y.getArcs(v).length===0).forEach(v=>h.add(v));let s=y.getNodes().filter(v=>!h.has(v)),d;do{d=!1;for(let v=0;v<s.length;v++){const C=s[v];y.hasOnlyGoodArcs(C,h)&&(s.splice(v,1),v--,h.add(C),d=!0)}}while(d);return s.map(v=>n.get(v))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const y=this._activationMap.get(t);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const y=this._extensionsMap.get(c.ExtensionIdentifier.toKey(t));return y||void 0}}e.ExtensionDescriptionRegistry=R;var I;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(I||(I={}));function S(P,t){const y=P.isBuiltin?0:P.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(y!==n)return y-n;const h=_.posix.basename(P.extensionLocation.path),s=_.posix.basename(t.extensionLocation.path);return h<s?-1:h>s?1:0}}),define(we[177],be([0,1,23]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var _;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(_=e.MessageType||(e.MessageType={}));function A(I){const S=c.VSBuffer.alloc(1);switch(I){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=A;function R(I,S){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=R}),define(we[30],be([0,1,3,2,4,25,142]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");var I;(function(w){w[w.None=0]="None",w[w.LocalProcess=1]="LocalProcess",w[w.LocalWebWorker=2]="LocalWebWorker",w[w.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class S{constructor(a){this.dependency=a}}e.MissingExtensionDependency=S;var P;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(P=e.ExtensionHostKind||(e.ExtensionHostKind={}));class t{constructor(a,p,k,i){this.codeLoadingTime=a,this.activateCallTime=p,this.activateResolvedTime=k,this.activationReason=i}}e.ActivationTimes=t;class y{constructor(a,p){this.description=a,this.value=p}}e.ExtensionPointContribution=y,e.ExtensionHostLogFileName="exthost";var n;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function h(w){w.enableProposedApi||s(w)}e.checkProposedApiEnabled=h;function s(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=s;function d(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=d;function v(w,a){return{identifier:new A.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!a,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=v;class C{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None}activateByEvent(a){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,p){return Promise.resolve()}_onWillActivateExtension(a){}_onDidActivateExtension(a,p,k,i,l){}_onDidActivateExtensionError(a,p){}_onExtensionRuntimeError(a,p){}_onExtensionHostExit(a){}}e.NullExtensionService=C}),define(we[178],be([0,1,25,30,15]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class R{constructor(s,d,v,C){this.startup=s,this.codeLoadingTime=d,this.activateCallTime=v,this.activateResolvedTime=C}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class I{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,d){return s===-1||d===-1?-1:d-s}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class S{constructor(s,d,v,C,w,a){this.activationFailed=s,this.activationFailedError=d,this.activationTimes=v,this.module=C,this.exports=w,this.subscriptions=a}}e.ActivatedExtension=S;class P extends S{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends S{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class y extends S{constructor(s){super(!0,s,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=y;let n=class{constructor(s,d,v,C,w){this._logService=w,this._registry=s,this._resolvedExtensionsSet=new Set,d.forEach(a=>this._resolvedExtensionsSet.add(c.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,v.forEach(a=>this._hostExtensionsMap.set(c.ExtensionIdentifier.toKey(a),a)),this._host=C,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const d=c.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(d)}getActivatedExtension(s){const d=c.ExtensionIdentifier.toKey(s),v=this._activatedExtensions.get(d);if(!v)throw new Error("Extension `"+s.value+"` is not known or not activated");return v}activateByEvent(s,d){if(this._alreadyActivatedEvents[s])return A;const v=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(v.map(C=>({id:C.identifier,reason:{startup:d,extensionId:C.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,d){const v=this._registry.getExtensionDescription(s);if(!v)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:v.identifier,reason:d}])}_handleActivateRequest(s,d,v){if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(s.id))){d[c.ExtensionIdentifier.toKey(s.id)]=s;return}const C=this._registry.getExtensionDescription(s.id);if(!C){const p=new Error(`Cannot activate unknown extension '${s.id.value}'`);this._host.onExtensionActivationError(s.id,p,new F.MissingExtensionDependency(s.id.value)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(s.id),new y(p));return}const w=typeof C.extensionDependencies=="undefined"?[]:C.extensionDependencies;let a=!0;for(let p=0,k=w.length;p<k;p++){const i=w[p];if(this._resolvedExtensionsSet.has(c.ExtensionIdentifier.toKey(i)))continue;const l=this._activatedExtensions.get(c.ExtensionIdentifier.toKey(i));if(l&&!l.activationFailed)continue;if(l&&l.activationFailed){const f=C.displayName||C.identifier.value,m=this._registry.getExtensionDescription(i),D=m&&m.displayName||i,T=new Error(`Cannot activate the '${f}' extension because its dependency '${D}' failed to activate`);T.detail=l.activationFailedError,this._host.onExtensionActivationError(C.identifier,T,null),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(C.identifier),new y(T));return}if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(i))){a=!1,d[c.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(c.ExtensionIdentifier.toKey(i)),reason:s.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){a=!1,d[c.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:s.reason};continue}const o=C.displayName||C.identifier.value,b=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(C.identifier,b,new F.MissingExtensionDependency(i)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(C.identifier),new y(b));return}a?d[c.ExtensionIdentifier.toKey(C.identifier)]=s:v.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(w=>!this._activatedExtensions.has(c.ExtensionIdentifier.toKey(w.id))),s.length===0))return Promise.resolve(void 0);const d=Object.create(null),v=[];for(let w=0,a=s.length;w<a;w++)this._handleActivateRequest(s[w],d,v);for(let w=0,a=v.length;w<a;w++){const p=c.ExtensionIdentifier.toKey(v[w].id);d[p]&&delete d[p]}const C=Object.keys(d).map(w=>d[w]);return v.length===0?Promise.all(C.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(C).then(w=>this._activateExtensions(v))}_activateExtension(s,d){const v=c.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const C=this._activatingExtensions.get(v);if(C)return C;const w=this._host.actualActivateExtension(s,d).then(void 0,a=>{const p=new Error;return a&&a.name&&(p.name=a.name),a&&a.message?p.message=`Activating extension '${s.value}' failed: ${a.message}.`:p.message=`Activating extension '${s.value}' failed: ${a}.`,a&&a.stack&&(p.stack=a.stack),this._host.onExtensionActivationError(s,p,null),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(a),new y(a)}).then(a=>{this._activatedExtensions.set(v,a),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,w),w}};n=Ue([He(4,_.ILogService)],n),e.ExtensionsActivator=n}),define(we[179],be([0,1,16]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,R)=>{this._actualOk=A,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,c.onUnexpectedError)(A))}then(A,R){return this._ensureActual().then(A,R)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=F}),define(we[47],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(P,t){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=t,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const F=[];function _(S){const P=new c(!0,S);return F[P.nid]=P,P}e.createMainContextProxyIdentifier=_;function A(S){const P=new c(!1,S);return F[P.nid]=P,P}e.createExtHostContextProxyIdentifier=A;function R(S){return F[S].sid}e.getStringIdentifierForProxy=R;class I{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=I}),define(we[5],be([0,1,54,2,47]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var R;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(a){a.name="$ident";function p(i,l){return Object.defineProperty(i,a.name,{value:l,enumerable:!0}),i}a.mixin=p;function k(i){return i[a.name]}a.of=k})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(p){return p._id=h._n++,p}}e.IdObject=h,h._n=0;var s;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function C(a){if(a&&a.edits)for(const p of a.edits)typeof p.resource=="object"?p.resource=F.URI.revive(p.resource):(p.newUri=F.URI.revive(p.newUri),p.oldUri=F.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,c.revive)(p.metadata));return a}e.reviveWorkspaceEditDto=C;var w;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,_.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,_.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,_.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,_.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[69],be([0,1,5,3,4]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(I){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,S){return this._proxy.$getPassword(I,S)}store(I,S,P){return this._proxy.$setPassword(I,S,P)}delete(I,S){return this._proxy.$deletePassword(I,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(we[70],be([0,1,4,15,5,12]),function(ie,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(S,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(_.MainContext.MainThreadTelemetry)}report(S,P,t){const y=this.getUsageKey(S,P);this._reportedUsages.has(y)||(this._reportedUsages.add(y),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:S}))}getUsageKey(S,P){return`${S}-${P.identifier.value}`}};R=Ue([He(0,A.IExtHostRpcService),He(1,F.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(I,S,P){}})}),define(we[180],be([0,1,3,5,7,25]),function(ie,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,P,t,y={}){const n=A.ExtensionIdentifier.toKey(S.identifier),h=this._inFlightRequests.get(n)||[],s=[...t].sort().join(" ");let d=h.find(v=>v.scopes===s);if(d)return d.result;{const v=this._getSession(S,n,P,t,y);d={scopes:s,result:v},h.push(d),this._inFlightRequests.set(n,h);try{await v}finally{const C=h.findIndex(w=>w.scopes===s);C>-1&&(h.splice(C),this._inFlightRequests.set(n,h))}return v}}async _getSession(S,P,t,y,n={}){await this._proxy.$ensureProvider(t);const h=S.displayName||S.name;return this._proxy.$getSession(t,y,P,h,n)}async removeSession(S,P){const t=this._authenticationProviders.get(S);return t?t.provider.removeSession(P):this._proxy.$removeSession(S,P)}registerAuthenticationProvider(S,P,t,y){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:P,provider:t,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===S)||this._providers.push({id:S,label:P});const n=t.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(S,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,P,y?.supportsMultipleAccounts??!1),new _.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(S);const h=this._providers.findIndex(s=>s.id===S);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,P){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,P){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,P){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,P){return this._onDidChangeSessions.fire({provider:{id:S,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(we[181],be([0,1,5,12,8]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(I,S){this._extHostDocumentsAndEditors=S,this._proxy=I.getProxy(c.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const S=_.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};A=Ue([He(0,F.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(we[182],be([0,1,5]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(A){const R=A.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(I){return R.$writeText(I)}})}}e.ExtHostClipboard=F}),define(we[48],be([0,1,10,7,8,22,5,13,15,54,42,111,2,6,4,12,46]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let C=class{constructor(l,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=l.getProxy(R.MainContext.MainThreadCommands),this._logService=r,this.converter=new w(this,o=>{const b=this._apiCommands.get(o);return b?.result===p.Void?b:void 0},r),this._argumentProcessors=[{processArgument(o){return(0,P.revive)(o)}},{processArgument(o){return(0,A.cloneAndChange)(o,function(b){if(t.Range.isIRange(b))return _.Range.to(b);if(y.Position.isIPosition(b))return _.Position.to(b);if(t.Range.isIRange(b.range)&&n.URI.isUri(b.uri))return _.location.to(b);if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(l){this._argumentProcessors.push(l)}registerApiCommand(l){const r=this.registerCommand(!1,l.id,async(...o)=>{const b=l.args.map((m,D)=>{if(!m.validate(o[D]))throw new Error(`Invalid argument '${m.name}' when running '${l.id}', received: ${o[D]}`);return m.convert(o[D])}),f=await this.executeCommand(l.internalId,...b);return l.result.convert(f,o,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this._apiCommands.set(l.id,l),new F.Disposable(()=>{r.dispose(),this._apiCommands.delete(l.id)})}registerCommand(l,r,o,b,f){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:o,thisArg:b,description:f}),l&&this._proxy.$registerCommand(r),new F.Disposable(()=>{this._commands.delete(r)&&l&&this._proxy.$unregisterCommand(r)})}executeCommand(l,...r){return this._logService.trace("ExtHostCommands#executeCommand",l),this._doExecuteCommand(l,r,!0)}async _doExecuteCommand(l,r,o){if(this._commands.has(l))return this._executeContributedCommand(l,r);{const b=(0,A.cloneAndChange)(r,function(f){if(f instanceof F.Position)return _.Position.from(f);if(f instanceof F.Range)return _.Range.from(f);if(f instanceof F.Location)return _.location.from(f);if(F.NotebookRange.isNotebookRange(f))return _.NotebookRange.from(f);if(!Array.isArray(f))return f});try{const f=await this._proxy.$executeCommand(l,b,o);return(0,P.revive)(f)}catch(f){if(f instanceof Error&&f.message==="$executeCommand:retry")return this._doExecuteCommand(l,r,!1);throw f}}}async _executeContributedCommand(l,r){const o=this._commands.get(l);if(!o)throw new Error("Unknown command");let{callback:b,thisArg:f,description:m}=o;if(m)for(let D=0;D<m.args.length;D++)try{(0,c.validateConstraint)(r[D],m.args[D].constraint)}catch(T){throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${m.args[D].name}' - ${m.args[D].description}`)}try{return await b.apply(f,r)}catch(D){if(l===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...r);T&&(l=T.command)}throw this._logService.error(D,l),new Error(`Running the contributed command: '${l}' failed.`)}}$executeContributedCommand(l,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",l),this._commands.has(l)?(r=r.map(o=>this._argumentProcessors.reduce((b,f)=>f.processArgument(b),o)),this._executeContributedCommand(l,r)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this._logService.trace("ExtHostCommands#getCommands",l),this._proxy.$getCommands().then(r=>(l&&(r=r.filter(o=>o[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(let[r,o]of this._commands){let{description:b}=o;b&&(l[r]=b)}return Promise.resolve(l)}};C=Ue([He(0,d.IExtHostRpcService),He(1,S.ILogService)],C),e.ExtHostCommands=C,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class w{constructor(l,r,o){this._commands=l,this._lookupApiCommand=r,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(l,r){if(!l)return;const o={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return o;const b=this._lookupApiCommand(l.command);if(b)o.id=b.internalId,o.arguments=b.args.map((f,m)=>f.convert(l.arguments&&l.arguments[m]));else if((0,I.isNonEmptyArray)(l.arguments)){const f=++this._cachIdPool;this._cache.set(f,l),r.add((0,h.toDisposable)(()=>{this._cache.delete(f),this._logService.trace("CommandsConverter#DISPOSE",f)})),o.$ident=f,o.id=this.delegatingCommandId,o.arguments=[f],this._logService.trace("CommandsConverter#CREATE",l.command,f)}return o}fromInternal(l){const r=R.ObjectIdentifier.of(l);return typeof r=="number"?this._cache.get(r):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this._cache.get(l[0])}_executeConvertedCommand(...l){const r=this.getActualCommand(...l);return this._logService.trace("CommandsConverter#EXECUTE",l[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class a{constructor(l,r,o,b){this.name=l,this.description=r,this.validate=o,this.convert=b}optional(){return new a(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,r){return new a(l??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),a.Position=new a("position","A position in a text document",i=>F.Position.isPosition(i),_.Position.from),a.Range=new a("range","A range in a text document",i=>F.Range.isRange(i),_.Range.from),a.Selection=new a("selection","A selection in a text document",i=>F.Selection.isSelection(i),_.Selection.from),a.Number=new a("number","",i=>typeof i=="number",i=>i),a.String=new a("string","",i=>typeof i=="string",i=>i),a.CallHierarchyItem=new a("item","A call hierarchy item",i=>i instanceof F.CallHierarchyItem,_.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",i=>i instanceof F.TypeHierarchyItem,_.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",i=>i instanceof v.TestItemImpl,_.TestItem.from);class p{constructor(l,r){this.description=l,this.convert=r}}e.ApiCommandResult=p,p.Void=new p("no result",i=>i);class k{constructor(l,r,o,b,f){this.id=l,this.internalId=r,this.description=o,this.args=b,this.result=f}}e.ApiCommand=k}),define(we[183],be([0,1,8,7,59,48,13,80]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(c.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,h)=>{if((0,R.isFalsyOrEmpty)(n))return;class s extends F.SymbolInformation{static to(v){const C=new s(v.name,c.SymbolKind.to(v.kind),v.containerName||"",new F.Location(h[0],c.Range.to(v.range)));return C.detail=v.detail,C.range=C.location.range,C.selectionRange=c.Range.to(v.selectionRange),C.children=v.children?v.children.map(s.to):[],C}}return n.map(s.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(c.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(c.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(h=>F.Position.isPosition(h)),n=>n.map(c.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(h=>{let s;for(const d of h.reverse())s=new F.SelectionRange(c.Range.to(d),s);return s}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const h=[];if(Array.isArray(n))for(let s of n)h.push(...s[1].map(c.WorkspaceSymbol.to));return h})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return c.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(c.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,I.decodeSemanticTokensDto)(n);if(h.type==="full")return new F.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,I.decodeSemanticTokensDto)(n);if(h.type==="full")return new F.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,h,s)=>{if(!n)return new F.CompletionList([]);const d=n.suggestions.map(v=>c.CompletionItem.to(v,s));return new F.CompletionList(d,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return c.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,h,s)=>t(d=>new F.CodeLens(c.Range.to(d.range),d.command&&s.fromInternal(d.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>F.Range.isRange(n),n=>F.Selection.isSelection(n)?c.Selection.from(n):c.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,h,s)=>t(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(d.command)}else{const v=new F.CodeAction(d.title,d.kind?new F.CodeActionKind(d.kind):void 0);return d.edit&&(v.edit=c.WorkspaceEdit.to(d.edit)),d.command&&(v.command=s.fromInternal(d.command)),v.isPreferred=d.isPreferred,v}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(h=>new F.ColorInformation(c.Range.to(h.range),c.Color.to(h.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof F.Color,c.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:c.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(c.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(c.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(h=>c.NotebookExclusiveDocumentPattern.to(h))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(c.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class P{static register(h){S.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=P;function t(n){return h=>{if(Array.isArray(h))return h.map(n)}}function y(n){if(!Array.isArray(n))return;const h=[];for(const s of n)_.isLocationLink(s)?h.push(c.DefinitionLink.to(s)):h.push(c.location.to(s));return h}}),define(we[184],be([0,1,14,52,3,6,2,59,25,8,7,5]),function(ie,e,c,F,_,A,R,I,S,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(h,s,d){const v=h.getProxy(y.MainContext.MainThreadComments);class C{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const b=this._commentControllers.get(o.handle);return b||o}else if(o&&o.$mid===7){const b=this._commentControllers.get(o.commentControlHandle);if(!b)return o;const f=b.getCommentThread(o.commentThreadHandle);return f||o}else if(o&&o.$mid===8){const b=this._commentControllers.get(o.thread.commentControlHandle);if(!b)return o;const f=b.getCommentThread(o.thread.commentThreadHandle);return f?{thread:f,text:o.text}:o}else if(o&&o.$mid===9){const b=this._commentControllers.get(o.thread.commentControlHandle);if(!b)return o;const f=b.getCommentThread(o.thread.commentThreadHandle);if(!f)return o;let m=o.commentUniqueId,D=f.getCommentByUniqueId(m);return D||o}else if(o&&o.$mid===10){const b=this._commentControllers.get(o.thread.commentControlHandle);if(!b)return o;const f=b.getCommentThread(o.thread.commentThreadHandle);if(!f)return o;let m=o.text,D=o.commentUniqueId,T=f.getCommentByUniqueId(D);return T?(T.body=m,T):o}return o}})}createCommentController(o,b,f){const m=C.handlePool++,D=new a(o,m,b,f);this._commentControllers.set(D.handle,D);const T=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(o.identifier))||[];return T.push(D),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(o.identifier),T),D.value}$createCommentThreadTemplate(o,b,f){const m=this._commentControllers.get(o);!m||m.$createCommentThreadTemplate(b,f)}async $updateCommentThreadTemplate(o,b,f){const m=this._commentControllers.get(o);!m||m.$updateCommentThreadTemplate(b,f)}$deleteCommentThread(o,b){const f=this._commentControllers.get(o);f&&f.$deleteCommentThread(b)}$provideCommentingRanges(o,b,f){const m=this._commentControllers.get(o);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const D=d.getDocument(R.URI.revive(b));return(0,c.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(D,f)).then(T=>T?T.map(g=>P.Range.from(g)):void 0)}$toggleReaction(o,b,f,m,D){const T=this._commentControllers.get(o);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const g=T.getCommentThread(b);if(g){const E=g.getCommentByUniqueId(m.uniqueIdInThread);if(T!==void 0&&E&&T.reactionHandler)return T.reactionHandler(E,i(D))}return Promise.resolve(void 0)})}dispose(){}}C.handlePool=0;class w{constructor(o,b,f,m,D,T,g){this._commentControllerHandle=b,this._id=f,this._uri=m,this._range=D,this._comments=T,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${o}.${this.handle}`),v.$createCommentThread(b,this.handle,this._id,this._uri,P.Range.from(this._range),g),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(b,this.handle)}});const E=this;this.value={get uri(){return E.uri},get range(){return E.range},set range(u){E.range=u},get comments(){return E.comments},set comments(u){E.comments=u},get collapsibleState(){return E.collapsibleState},set collapsibleState(u){E.collapsibleState=u},get canReply(){return E.canReply},set canReply(u){E.canReply=u},get contextValue(){return E.contextValue},set contextValue(u){E.contextValue=u},get label(){return E.label},set label(u){E.label=u},dispose:()=>{E.dispose()}}}set threadId(o){this._id=o}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(o){o.isEqual(this._range)||(this._range=o,this.modifications.range=o,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(o){this._canReply!==o&&(this._canReply=o,this.modifications.canReply=o,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(o){this._label=o,this.modifications.label=o,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(o){this._contextValue=o,this.modifications.contextValue=o,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(o){this._comments=o,this.modifications.comments=o,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(o){this._collapseState=o,this.modifications.collapsibleState=o,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const o=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),b={};o("range")&&(b.range=P.Range.from(this._range)),o("label")&&(b.label=this.label),o("contextValue")&&(b.contextValue=this.contextValue),o("comments")&&(b.comments=this._comments.map(f=>p(this,f,this._commentsMap))),o("collapsibleState")&&(b.collapseState=l(this._collapseState)),o("canReply")&&(b.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,b)}getCommentByUniqueId(o){for(let b of this._commentsMap){let f=b[0],m=b[1];if(o===m)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(o=>o.dispose())}}w._handlePool=0,Ue([(0,F.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(o,b,f,m){this._extension=o,this._handle=b,this._id=f,this._label=m,this._threads=new Map,v.$registerCommentController(this.handle,f,m);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(T){D.options=T},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(T){D.commentingRangeProvider=T},get reactionHandler(){return D.reactionHandler},set reactionHandler(T){D.reactionHandler=T},createCommentThread(T,g,E){return D.createCommentThread(T,g,E).value},dispose:()=>{D.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(o){this._reactionHandler=o,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this._options}set options(o){this._options=o,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(o,b,f,m){if(typeof o=="string"){const D=new w(this.id,this.handle,o,b,f,m,this._extension.identifier);return this._threads.set(D.handle,D),D}else{const D=new w(this.id,this.handle,void 0,o,b,f,this._extension.identifier);return this._threads.set(D.handle,D),D}}$createCommentThreadTemplate(o,b){const f=new w(this.id,this.handle,void 0,R.URI.revive(o),P.Range.to(b),[],this._extension.identifier);return f.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(o,b){let f=this._threads.get(o);f&&(f.range=P.Range.to(b))}$deleteCommentThread(o){let b=this._threads.get(o);b&&b.dispose(),this._threads.delete(o)}getCommentThread(o){return this._threads.get(o)}dispose(){this._threads.forEach(o=>{o.dispose()}),this._localDisposables.forEach(o=>o.dispose())}}function p(r,o,b){let f=b.get(o);f||(f=++r.commentHandle,b.set(o,f));const m=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:f,body:P.MarkdownString.from(o.body),userName:o.author.name,userIconPath:m,label:o.label,commentReactions:o.reactions?o.reactions.map(D=>k(D)):void 0}}function k(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?R.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function l(r){if(r!==void 0)switch(r){case t.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new C}e.createExtHostComments=n}),define(we[95],be([0,1,2,5,7,4,12,15,13,9,17]),function(ie,e,c,F,_,A,R,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class vi{constructor(h,s){this._logService=s,this._provider=new Map,this._proxy=h.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,s){const d=vi._handlePool++;this._provider.set(d,{provider:h,extensionId:s}),this._proxy.$registerDecorationProvider(d,s.value);const v=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(C=>{if(!C){this._proxy.$onDidChange(d,null);return}let w=(0,S.asArray)(C);if(w.length<=vi._maxEventSize){this._proxy.$onDidChange(d,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,w.length);const a=w.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),p=(0,S.groupBy)(a,(i,l)=>i.rank-l.rank||(0,P.compare)(i.uri.path,l.uri.path));let k=[];e:for(let i of p){let l;for(let r of i){let o=(0,t.dirname)(r.uri.path);if(l!==o&&(l=o,k.push(r.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(d,k)});return new _.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(h,s,d){if(!this._provider.has(h))return Object.create(null);const v=Object.create(null),{provider:C,extensionId:w}=this._provider.get(h);return await Promise.all(s.map(async a=>{try{const{uri:p,id:k}=a,i=await Promise.resolve(C.provideFileDecoration(c.URI.revive(p),d));if(!i)return;try{_.FileDecoration.validate(i),v[k]=[i.propagate,i.tooltip,i.badge,i.color]}catch(l){this._logService.warn(`INVALID decoration from extension '${w.value}': ${l}`)}}catch(p){this._logService.error(p)}})),v}};y._handlePool=0,y._maxEventSize=250,y=Ue([He(0,R.IExtHostRpcService),He(1,I.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[185],be([0,1,123,82,2,5,7,8,3,15,20,37]),function(ie,e,c,F,_,A,R,I,S,P,t,y){"use strict";var n,h,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(w,a,p,k,i,l){this._name=w,this._owner=a,this._maxDiagnosticsPerFile=p,n.set(this,void 0),h.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,Je(this,s,new t.ResourceMap(r=>k.getComparisonKey(r)),"f"),Je(this,n,i,"f"),Je(this,h,l,"f")}dispose(){this._isDisposed||(Te(this,h,"f").fire([...Te(this,s,"f").keys()]),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner),Te(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(w,a){if(!w){this.clear();return}this._checkDisposed();let p=[];if(_.URI.isUri(w)){if(!a){this.delete(w);return}Te(this,s,"f").set(w,a.slice()),p=[w]}else if(Array.isArray(w)){p=[];let i;w=[...w].sort(d._compareIndexedTuplesByUri);for(const l of w){const[r,o]=l;if((!i||r.toString()!==i.toString())&&(i&&Te(this,s,"f").get(i).length===0&&Te(this,s,"f").delete(i),i=r,p.push(r),Te(this,s,"f").set(r,[])),o){const b=Te(this,s,"f").get(r);b&&b.push(...o)}else{const b=Te(this,s,"f").get(r);b&&(b.length=0)}}}if(Te(this,h,"f").fire(p),!Te(this,n,"f"))return;const k=[];for(let i of p){let l=[];const r=Te(this,s,"f").get(i);if(r)if(r.length>this._maxDiagnosticsPerFile){l=[];const o=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let b=0;b<4;b++)for(let f of r)if(f.severity===o[b]&&l.push(I.Diagnostic.from(f))===this._maxDiagnosticsPerFile)break e;l.push({severity:F.MarkerSeverity.Info,message:(0,c.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=r.map(o=>I.Diagnostic.from(o));k.push([i,l])}Te(this,n,"f").$changeMany(this._owner,k)}delete(w){this._checkDisposed(),Te(this,h,"f").fire([w]),Te(this,s,"f").delete(w),Te(this,n,"f")&&Te(this,n,"f").$changeMany(this._owner,[[w,void 0]])}clear(){this._checkDisposed(),Te(this,h,"f").fire([...Te(this,s,"f").keys()]),Te(this,s,"f").clear(),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner)}forEach(w,a){this._checkDisposed();for(let p of Te(this,s,"f").keys())w.apply(a,[p,this.get(p),this])}get(w){this._checkDisposed();const a=Te(this,s,"f").get(w);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(w){return this._checkDisposed(),Array.isArray(Te(this,s,"f").get(w))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(w,a){return w[0].toString()<a[0].toString()?-1:w[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=d,n=new WeakMap,h=new WeakMap,s=new WeakMap;let v=class Xt{constructor(w,a,p){this._logService=a,this._fileSystemInfoService=p,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:k=>k.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Xt._mapper),this._proxy=w.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(w){const a=new t.ResourceMap;for(const p of w)a.set(p,p);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(w,a){const{_collections:p,_proxy:k,_onDidChangeDiagnostics:i,_logService:l,_fileSystemInfoService:r}=this,o=new class{$changeMany(m,D){k.$changeMany(m,D),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,m,D.length===0?"CLEARING":D)}$clear(m){k.$clear(m),l.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,m)}dispose(){k.dispose()}};let b;if(!a)a="_generated_diagnostic_collection_name_#"+Xt._idPool++,b=a;else if(!p.has(a))b=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do b=a+Xt._idPool++;while(p.has(b))}return new class extends d{constructor(){super(a,b,Xt._maxDiagnosticsPerFile,r.extUri,o,i);p.set(b,this)}dispose(){super.dispose(),p.delete(b)}}}getDiagnostics(w){if(w)return this._getDiagnostics(w);{const a=new Map,p=[];for(const k of this._collections.values())k.forEach((i,l)=>{let r=a.get(i.toString());typeof r=="undefined"&&(r=p.length,a.set(i.toString(),r),p.push([i,[]])),p[r][1]=p[r][1].concat(...l)});return p}}_getDiagnostics(w){let a=[];for(let p of this._collections.values())p.has(w)&&(a=a.concat(p.get(w)));return a}$acceptMarkersChange(w){if(!this._mirrorCollection){const a="_generated_mirror",p=new d(a,a,Xt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,p),this._mirrorCollection=p}for(const[a,p]of w)this._mirrorCollection.set(_.URI.revive(a),p.map(I.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=Ue([He(1,P.ILogService),He(2,y.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(we[186],be([0,1,2,5]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(R){this._proxy=R.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(I=>I?I.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(I=>I?c.URI.revive(I):void 0)}}e.ExtHostDialogs=_}),define(we[187],be([0,1,16,2,7,5,11,21,9]),function(ie,e,c,F,_,A,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(y,n,h){this._documentsAndEditors=n,this._logService=h,this._documentContentProviders=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,n){if(Object.keys(R.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const h=P._handlePool++;this._documentContentProviders.set(h,n),this._proxy.$registerTextContentProvider(h,y);let s;return typeof n.onDidChange=="function"&&(s=n.onDidChange(d=>{if(d.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(h,d).then(v=>{if(!v&&typeof v!="string")return;const C=this._documentsAndEditors.getDocument(d);if(!C)return;const w=(0,S.splitLines)(v);if(!C.equalLines(w))return this._proxy.$onVirtualDocumentChange(d,v)},c.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(y,n){const h=this._documentContentProviders.get(y);return h?Promise.resolve(h.provideTextDocumentContent(F.URI.revive(n),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(we[188],be([0,1,3,6,2,5,88,8,10,22,7]),function(ie,e,c,F,_,A,R,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(h,s){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const v of d)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const v of d)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const s=this._documentsAndEditors.getDocument(h);if(s)return s}getDocument(h){const s=this.getDocumentData(h);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return s.document}ensureDocumentData(h){const s=this._documentsAndEditors.getDocument(h);if(s)return Promise.resolve(s);let d=this._documentLoader.get(h.toString());return d||(d=this._proxy.$tryOpenDocument(h).then(v=>{this._documentLoader.delete(h.toString());const C=_.URI.revive(v);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(C))},v=>(this._documentLoader.delete(h.toString()),Promise.reject(v))),this._documentLoader.set(h.toString(),d)),d}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(s=>_.URI.revive(s))}$acceptModelModeChanged(h,s){const d=_.URI.revive(h),v=this._documentsAndEditors.getDocument(d);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(s),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(h){const s=_.URI.revive(h),d=this._documentsAndEditors.getDocument(s);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(h,s){const d=_.URI.revive(h),v=this._documentsAndEditors.getDocument(d);if(!v)throw new Error("unknown document");v._acceptIsDirty(s),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,s,d){const v=_.URI.revive(h),C=this._documentsAndEditors.getDocument(v);if(!C)throw new Error("unknown document");C._acceptIsDirty(d),C.onEvents(s);let w;s.isUndoing?w=t.TextDocumentChangeReason.Undo:s.isRedoing&&(w=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:C.document,contentChanges:s.changes.map(a=>({range:I.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:w}))}setWordDefinitionFor(h,s){(0,R.setWordDefinitionFor)(h,s)}}e.ExtHostDocuments=y}),define(we[49],be([0,1,40,3,6,2,4,5,88,12,94,8,15,20,11,231,103]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class C{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(p,k){this._extHostRpc=p,this._logService=k,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const k=[],i=[],l=[];if(p.removedDocuments)for(const r of p.removedDocuments){const o=A.URI.revive(r),b=this._documents.get(o);b?.unref()&&(this._documents.delete(o),k.push(b.value))}if(p.addedDocuments)for(const r of p.addedDocuments){const o=A.URI.revive(r.uri);let b=this._documents.get(o);if(b&&o.scheme!==s.Schemas.vscodeNotebookCell&&o.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);b||(b=new C(new S.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),o,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(o,b),i.push(b.value)),b.ref()}if(p.removedEditors)for(const r of p.removedEditors){const o=this._editors.get(r);this._editors.delete(r),o&&l.push(o)}if(p.addedEditors)for(const r of p.addedEditors){const o=A.URI.revive(r.documentUri);c.ok(this._documents.has(o),`document '${o}' does not exist`),c.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const b=this._documents.get(o).value,f=new t.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>b.document),r.selections.map(y.Selection.to),r.options,r.visibleRanges.map(m=>y.Range.to(m)),typeof r.editorPosition=="number"?y.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,f)}p.newActiveEditor!==void 0&&(c.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,_.dispose)(k),(0,_.dispose)(l),p.removedDocuments&&this._onDidRemoveDocuments.fire(k),p.addedDocuments&&this._onDidAddDocuments.fire(i),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const k=this._editors.get(this._activeEditorId);return p?k:k?.value}allEditors(){return[...this._editors.values()]}};w=Ue([He(0,P.IExtHostRpcService),He(1,n.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[189],be([0,1,2,5,6,7,8,232,9,23]),function(ie,e,c,F,_,A,R,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const s=this._schemes.indexOf(h);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),s=[];let d,v,C=14,w=14;for(const a of h){let p=d?(0,S.commonPrefixLength)(d,a):0;for(p===0?v=1:v=w;p<a.length;p++)p+1===a.length?(C=w,w=9):w+=1,s.push([v,a.toUpperCase().charCodeAt(p),w]),s.push([v,a.toLowerCase().charCodeAt(p),w]),v=w;d=a,w=C}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new I.StateMachine(s)}}provideDocumentLinks(h){this._initStateMachine();const s=[],d=I.LinkComputer.computeLinks({getLineContent(v){return h.lineAt(v-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const v of d){const C=R.DocumentLink.to(v);C.target&&s.push(C)}return s}}class y{constructor(h,s){this._extHostLanguageFeatures=s,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,s,d,v={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const C=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(C,d);let w=2;v.isCaseSensitive&&(w+=1024),v.isReadonly&&(w+=2048),typeof d.copy=="function"&&(w+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(w+=4),this._proxy.$registerFileSystemProvider(C,s,w).catch(p=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${s}`),console.error(p)});const a=d.onDidChangeFile(p=>{const k=[];for(const i of p){let{uri:l,type:r}=i;if(l.scheme!==s)continue;let o;switch(r){case A.FileChangeType.Changed:o=0;break;case A.FileChangeType.Created:o=1;break;case A.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}k.push({resource:l,type:o})}this._proxy.$onFileSystemChange(C,k)});return(0,_.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(C),this._proxy.$unregisterProvider(C)})}static _asIStat(h){const{type:s,ctime:d,mtime:v,size:C,permissions:w}=h;return{type:s,ctime:d,mtime:v,size:C,permissions:w}}$stat(h,s){return Promise.resolve(this._getFsProvider(h).stat(c.URI.revive(s))).then(d=>y._asIStat(d))}$readdir(h,s){return Promise.resolve(this._getFsProvider(h).readDirectory(c.URI.revive(s)))}$readFile(h,s){return Promise.resolve(this._getFsProvider(h).readFile(c.URI.revive(s))).then(d=>P.VSBuffer.wrap(d))}$writeFile(h,s,d,v){return Promise.resolve(this._getFsProvider(h).writeFile(c.URI.revive(s),d.buffer,v))}$delete(h,s,d){return Promise.resolve(this._getFsProvider(h).delete(c.URI.revive(s),d))}$rename(h,s,d,v){return Promise.resolve(this._getFsProvider(h).rename(c.URI.revive(s),c.URI.revive(d),v))}$copy(h,s,d,v){const C=this._getFsProvider(h);if(!C.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(C.copy(c.URI.revive(s),c.URI.revive(d),v))}$mkdir(h,s){return Promise.resolve(this._getFsProvider(h).createDirectory(c.URI.revive(s)))}$watch(h,s,d,v){const C=this._getFsProvider(h).watch(c.URI.revive(d),v);this._watches.set(s,C)}$unwatch(h,s){const d=this._watches.get(s);d&&(d.dispose(),this._watches.delete(s))}$open(h,s,d){const v=this._getFsProvider(h);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(c.URI.revive(s),d))}$close(h,s){const d=this._getFsProvider(h);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(s))}$read(h,s,d,v){const C=this._getFsProvider(h);if(!C.read)throw new Error('FileSystemProvider does not implement "read"');const w=P.VSBuffer.alloc(v);return Promise.resolve(C.read(s,d,w.buffer,0,v)).then(a=>w.slice(0,a))}$write(h,s,d,v){const C=this._getFsProvider(h);if(!C.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(C.write(s,d,v.buffer,0,v.byteLength))}_getFsProvider(h){const s=this._fsProvider.get(h);if(!s){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return s}}e.ExtHostFileSystem=y}),define(we[71],be([0,1,5,60,7,23,4,12,37]),function(ie,e,c,F,_,A,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(y,n){const h=y.getProxy(c.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return h.$stat(s).catch(Ut._handleError)},readDirectory(s){return h.$readdir(s).catch(Ut._handleError)},createDirectory(s){return h.$mkdir(s).catch(Ut._handleError)},async readFile(s){return h.$readFile(s).then(d=>d.buffer).catch(Ut._handleError)},writeFile(s,d){return h.$writeFile(s,A.VSBuffer.wrap(d)).catch(Ut._handleError)},delete(s,d){return h.$delete(s,{recursive:!1,useTrash:!1,...d}).catch(Ut._handleError)},rename(s,d,v){return h.$rename(s,d,{overwrite:!1,...v}).catch(Ut._handleError)},copy(s,d,v){return h.$copy(s,d,{overwrite:!1,...v}).catch(Ut._handleError)},isWritableFileSystem(s){const d=n.getCapabilities(s);if(typeof d=="number")return!(d&2048)}})}static _handleError(y){if(!(y instanceof Error))throw new _.FileSystemError(String(y));if(y.name==="ENOPRO")throw _.FileSystemError.Unavailable(y.message);switch(y.name){case F.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(y.message);case F.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(y.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(y.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(y.message);case F.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(y.message);case F.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(y.message);default:throw new _.FileSystemError(y.message,y.name)}}};P=Ue([He(0,I.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(we[190],be([0,1,2,48]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(R,I,S,P){this._extHostNotebooks=I,this._textDocumentsAndEditors=S,this._commands=P;const t=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new F.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new F.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new F.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new F.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:c.URI.revive(y.notebookUri),inputUri:c.URI.revive(y.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:c.URI.revive(y.notebookUri),inputUri:c.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(R,I,S,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],modeId:S,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=_}),define(we[191],be([0,1,6,5]),function(ie,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(R){this._handlePool=0,this._proxy=R.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,R),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=_}),define(we[192],be([0,1,2,22,8,7,5,9,42,13,10,233,6,80,53,63,193,16,3]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(B,Q){this._documents=B,this._provider=Q}async provideDocumentSymbols(B,Q){const ee=this._documents.getDocument(B),ae=await this._provider.provideDocumentSymbols(ee,Q);if(!(0,P.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(_.DocumentSymbol.from):a._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((ae,j)=>{let se=ae.location.range.start.compareTo(j.location.range.start);return se===0&&(se=j.location.range.end.compareTo(ae.location.range.end)),se});const Q=[],ee=[];for(const ae of B){const j={name:ae.name||"!!MISSING: name!!",kind:_.SymbolKind.from(ae.kind),tags:ae.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:_.Range.from(ae.location.range),selectionRange:_.Range.from(ae.location.range),children:[]};for(;;){if(ee.length===0){ee.push(j),Q.push(j);break}const se=ee[ee.length-1];if(S.Range.containsRange(se.range,j.range)&&!S.Range.equalsRange(se.range,j.range)){se.children&&se.children.push(j),ee.push(j);break}ee.pop()}}return Q}}class p{constructor(B,Q,ee){this._documents=B,this._commands=Q,this._provider=ee,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,Q){const ee=this._documents.getDocument(B),ae=await this._provider.provideCodeLenses(ee,Q);if(!ae||Q.isCancellationRequested)return;const j=this._cache.add(ae),se=new n.DisposableStore;this._disposables.set(j,se);const fe={cacheId:j,lenses:[]};for(let Ae=0;Ae<ae.length;Ae++)fe.lenses.push({cacheId:[j,Ae],range:_.Range.from(ae[Ae].range),command:this._commands.toInternal(ae[Ae].command,se)});return fe}async resolveCodeLens(B,Q){const ee=B.cacheId&&this._cache.get(...B.cacheId);if(!ee)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?ae=ee:ae=await this._provider.resolveCodeLens(ee,Q),ae||(ae=ee),Q.isCancellationRequested)return;const j=B.cacheId&&this._disposables.get(B.cacheId[0]);if(!!j)return B.command=this._commands.toInternal(ae.command??p._badCmd,j),B}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}p._badCmd={command:"missing",title:"!!MISSING: command!!"};function k(qe){return Array.isArray(qe)?qe.map(_.DefinitionLink.from):qe?[_.DefinitionLink.from(qe)]:[]}class i{constructor(B,Q){this._documents=B,this._provider=Q}async provideDefinition(B,Q,ee){const ae=this._documents.getDocument(B),j=_.Position.to(Q),se=await this._provider.provideDefinition(ae,j,ee);return k(se)}}class l{constructor(B,Q){this._documents=B,this._provider=Q}async provideDeclaration(B,Q,ee){const ae=this._documents.getDocument(B),j=_.Position.to(Q),se=await this._provider.provideDeclaration(ae,j,ee);return k(se)}}class r{constructor(B,Q){this._documents=B,this._provider=Q}async provideImplementation(B,Q,ee){const ae=this._documents.getDocument(B),j=_.Position.to(Q),se=await this._provider.provideImplementation(ae,j,ee);return k(se)}}class o{constructor(B,Q){this._documents=B,this._provider=Q}async provideTypeDefinition(B,Q,ee){const ae=this._documents.getDocument(B),j=_.Position.to(Q),se=await this._provider.provideTypeDefinition(ae,j,ee);return k(se)}}class b{constructor(B,Q){this._documents=B,this._provider=Q}async provideHover(B,Q,ee){const ae=this._documents.getDocument(B),j=_.Position.to(Q),se=await this._provider.provideHover(ae,j,ee);if(!(!se||(0,P.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(j)),se.range||(se.range=new A.Range(j,j)),_.Hover.from(se)}}class f{constructor(B,Q){this._documents=B,this._provider=Q}async provideEvaluatableExpression(B,Q,ee){const ae=this._documents.getDocument(B),j=_.Position.to(Q),se=await this._provider.provideEvaluatableExpression(ae,j,ee);if(se)return _.EvaluatableExpression.from(se)}}class m{constructor(B,Q){this._documents=B,this._provider=Q}async provideInlineValues(B,Q,ee,ae){const j=this._documents.getDocument(B),se=await this._provider.provideInlineValues(j,_.Range.to(Q),_.InlineValueContext.to(ee),ae);if(Array.isArray(se))return se.map(fe=>_.InlineValue.from(fe))}}class D{constructor(B,Q){this._documents=B,this._provider=Q}async provideDocumentHighlights(B,Q,ee){const ae=this._documents.getDocument(B),j=_.Position.to(Q),se=await this._provider.provideDocumentHighlights(ae,j,ee);if(Array.isArray(se))return se.map(_.DocumentHighlight.from)}}class T{constructor(B,Q){this._documents=B,this._provider=Q}async provideLinkedEditingRanges(B,Q,ee){const ae=this._documents.getDocument(B),j=_.Position.to(Q),se=await this._provider.provideLinkedEditingRanges(ae,j,ee);if(se&&Array.isArray(se.ranges))return{ranges:(0,P.coalesce)(se.ranges.map(_.Range.from)),wordPattern:se.wordPattern}}}class g{constructor(B,Q){this._documents=B,this._provider=Q}async provideReferences(B,Q,ee,ae){const j=this._documents.getDocument(B),se=_.Position.to(Q),fe=await this._provider.provideReferences(j,se,ee,ae);if(Array.isArray(fe))return fe.map(_.location.from)}}class E{constructor(B,Q,ee,ae,j,se,fe){this._documents=B,this._commands=Q,this._diagnostics=ee,this._provider=ae,this._logService=j,this._extension=se,this._apiDeprecation=fe,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(B,Q,ee,ae){const j=this._documents.getDocument(B),se=y.Selection.isISelection(Q)?_.Selection.to(Q):_.Range.to(Q),fe=[];for(const z of this._diagnostics.getDiagnostics(B))if(se.intersection(z.range)&&fe.push(z)>E._maxCodeActionsPerFile)break;const Ae={diagnostics:fe,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:_.CodeActionTriggerKind.to(ee.trigger)},xe=await this._provider.provideCodeActions(j,se,Ae,ae);if(!(0,P.isNonEmptyArray)(xe)||ae.isCancellationRequested)return;const $e=this._cache.add(xe),ve=new n.DisposableStore;this._disposables.set($e,ve);const Ze=[];for(let z=0;z<xe.length;z++){const J=xe[z];!J||(E._isCommand(J)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:J.title,command:this._commands.toInternal(J,ve)})):(Ae.only&&(J.kind?Ae.only.contains(J.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${J.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[$e,z],title:J.title,command:J.command&&this._commands.toInternal(J.command,ve),diagnostics:J.diagnostics&&J.diagnostics.map(_.Diagnostic.from),edit:J.edit&&_.WorkspaceEdit.from(J.edit),kind:J.kind&&J.kind.value,isPreferred:J.isPreferred,disabled:J.disabled?.reason})))}return{cacheId:$e,actions:Ze}}async resolveCodeAction(B,Q){const[ee,ae]=B,j=this._cache.get(ee,ae);if(!j||E._isCommand(j)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(j,Q)??j;return se?.edit?_.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}E._maxCodeActionsPerFile=1e3;class u{constructor(B,Q){this._documents=B,this._provider=Q}async provideDocumentFormattingEdits(B,Q,ee){const ae=this._documents.getDocument(B),j=await this._provider.provideDocumentFormattingEdits(ae,Q,ee);if(Array.isArray(j))return j.map(_.TextEdit.from)}}class M{constructor(B,Q){this._documents=B,this._provider=Q}async provideDocumentRangeFormattingEdits(B,Q,ee,ae){const j=this._documents.getDocument(B),se=_.Range.to(Q),fe=await this._provider.provideDocumentRangeFormattingEdits(j,se,ee,ae);if(Array.isArray(fe))return fe.map(_.TextEdit.from)}}class O{constructor(B,Q){this._documents=B,this._provider=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Q,ee,ae,j){const se=this._documents.getDocument(B),fe=_.Position.to(Q),Ae=await this._provider.provideOnTypeFormattingEdits(se,fe,ee,ae,j);if(Array.isArray(Ae))return Ae.map(_.TextEdit.from)}}class q{constructor(B,Q){this._provider=B,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(B,Q){const ee=R.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(B,Q);if((0,P.isNonEmptyArray)(ae))for(const j of ae){if(!j)continue;if(!j.name){this._logService.warn("INVALID SymbolInformation, lacks name",j);continue}const se=R.IdObject.mixin(_.WorkspaceSymbol.from(j));this._symbolCache.set(se._id,j),ee.symbols.push(se)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol(B,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return B;const ee=this._symbolCache.get(B._id);if(ee){const ae=await this._provider.resolveWorkspaceSymbol(ee,Q);return ae&&(0,F.mixin)(B,_.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(B){const Q=this._resultCache.get(B);if(Q){for(let[ee,ae]=Q;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(B)}}}class K{constructor(B,Q,ee){this._documents=B,this._provider=Q,this._logService=ee}static supportsResolving(B){return typeof B.prepareRename=="function"}async provideRenameEdits(B,Q,ee,ae){const j=this._documents.getDocument(B),se=_.Position.to(Q);try{const fe=await this._provider.provideRenameEdits(j,se,ee,ae);return fe?_.WorkspaceEdit.from(fe):void 0}catch(fe){const Ae=K._asMessage(fe);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation(B,Q,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(B),j=_.Position.to(Q);try{const se=await this._provider.prepareRename(ae,j,ee);let fe,Ae;if(A.Range.isRange(se)?(fe=se,Ae=ae.getText(se)):(0,t.isObject)(se)&&(fe=se.range,Ae=se.placeholder),!fe||!Ae)return;if(fe.start.line>j.line||fe.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(fe),text:Ae}}catch(se){const fe=K._asMessage(se);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ${constructor(B,Q){this.resultId=B,this.tokens=Q}}class W{constructor(B,Q){this._documents=B,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,Q,ee){const ae=this._documents.getDocument(B),j=Q!==0?this._previousResults.get(Q):null;let se=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,j.resultId,ee):await this._provider.provideDocumentSemanticTokens(ae,ee);return j&&this._previousResults.delete(Q),se?(se=W._fixProvidedSemanticTokens(se),this._send(W._convertToEdits(j,se),se)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return W._isSemanticTokens(B)?W._isCorrectSemanticTokens(B)?B:new A.SemanticTokens(new Uint32Array(B.data),B.resultId):W._isSemanticTokensEdits(B)?W._isCorrectSemanticTokensEdits(B)?B:new A.SemanticTokensEdits(B.edits.map(Q=>new A.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const Q of B.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,Q){if(!W._isSemanticTokens(Q)||!B||!B.tokens)return Q;const ee=B.tokens,ae=ee.length,j=Q.data,se=j.length;let fe=0;const Ae=Math.min(ae,se);for(;fe<Ae&&ee[fe]===j[fe];)fe++;if(fe===ae&&fe===se)return new A.SemanticTokensEdits([],Q.resultId);let xe=0;const $e=Ae-fe;for(;xe<$e&&ee[ae-xe-1]===j[se-xe-1];)xe++;return new A.SemanticTokensEdits([{start:fe,deleteCount:ae-fe-xe,data:j.subarray(fe,se-xe)}],Q.resultId)}_send(B,Q){if(W._isSemanticTokens(B)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(B.resultId,B.data)),(0,h.encodeSemanticTokensDto)({id:ee,type:"full",data:B.data})}if(W._isSemanticTokensEdits(B)){const ee=this._nextResultId++;return W._isSemanticTokens(Q)?this._previousResults.set(ee,new $(Q.resultId,Q.data)):this._previousResults.set(ee,new $(B.resultId)),(0,h.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(B.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class N{constructor(B,Q){this._documents=B,this._provider=Q}async provideDocumentRangeSemanticTokens(B,Q,ee){const ae=this._documents.getDocument(B),j=await this._provider.provideDocumentRangeSemanticTokens(ae,_.Range.to(Q),ee);return j?this._send(j):null}_send(B){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}e.DocumentRangeSemanticTokensAdapter=N;class H{constructor(B,Q,ee,ae,j){this._documents=B,this._commands=Q,this._provider=ee,this._apiDeprecation=ae,this._extension=j,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}async provideCompletionItems(B,Q,ee,ae){const j=this._documents.getDocument(B),se=_.Position.to(Q),fe=j.getWordRangeAtPosition(se)||new A.Range(se,se),Ae=fe.with({end:se}),xe=new v.StopWatch(!0),$e=await this._provider.provideCompletionItems(j,se,ae,_.CompletionContext.to(ee));if(!$e||ae.isCancellationRequested)return;const ve=Array.isArray($e)?new A.CompletionList($e):$e,Ze=H.supportsResolving(this._provider)?this._cache.add(ve.items):this._cache.add([]),z=new n.DisposableStore;this._disposables.set(Ze,z);const J=[],he={x:Ze,b:J,a:{replace:_.Range.from(fe),insert:_.Range.from(Ae)},c:ve.isIncomplete||void 0,d:xe.elapsed()};for(let Oe=0;Oe<ve.items.length;Oe++){const Ve=ve.items[Oe],tt=this._convertCompletionItem(Ve,[Ze,Oe],Ae,fe);J.push(tt)}return he}async resolveCompletionItem(B,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...B);if(!ee)return;const ae=await this._provider.resolveCompletionItem(ee,Q);if(!!ae)return this._convertCompletionItem(ae,B)}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,Q,ee,ae){const j=this._disposables.get(Q[0]);if(!j)throw Error("DisposableStore is missing...");const se={x:Q,a:B.label,b:B.kind!==void 0?_.CompletionItemKind.from(B.kind):void 0,n:B.tags&&B.tags.map(_.CompletionItemTag.from),c:B.detail,d:typeof B.documentation=="undefined"?void 0:_.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters,l:B.additionalTextEdits&&B.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal(B.command,j)};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=B.textEdit.newText):typeof B.insertText=="string"?se.h=B.insertText:B.insertText instanceof A.SnippetString&&(se.h=B.insertText.value,se.i|=4);let fe;return B.textEdit?fe=B.textEdit.range:B.range&&(fe=B.range),A.Range.isRange(fe)?se.j=_.Range.from(fe):fe&&(!ee?.isEqual(fe.inserting)||!ae?.isEqual(fe.replacing))&&(se.j={insert:_.Range.from(fe.inserting),replace:_.Range.from(fe.replacing)}),se}}class V{constructor(B,Q,ee){this._documents=B,this._provider=Q,this._commands=ee,this._cache=new d.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(B,Q,ee,ae){const j=this._documents.getDocument(B),se=_.Position.to(Q),fe=await this._provider.provideInlineCompletionItems(j,se,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:_.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},ae);if(!fe||ae.isCancellationRequested)return;const Ae=(0,t.isArray)(fe)?{items:fe}:fe,xe=this._cache.add(Ae.items);let $e;return{pid:xe,items:Ae.items.map((ve,Ze)=>{let z;return ve.command&&($e||($e=new n.DisposableStore,this._disposables.set(xe,$e)),z=this._commands.toInternal(ve.command,$e)),{text:ve.text,range:ve.range?_.Range.from(ve.range):void 0,command:z,idx:Ze}})}}disposeCompletions(B){this._cache.delete(B);const Q=this._disposables.get(B);Q&&Q.clear(),this._disposables.delete(B)}handleDidShowCompletionItem(B,Q){const ee=this._cache.get(B,Q);ee&&Y.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class Y{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(B){let Q=Y.map.get(B);return Q||(Q=new Y,Y.map.set(B,Q)),Q}fireOnDidShowCompletionItem(B){this._onDidShowCompletionItemEmitter.fire(B)}}e.InlineCompletionController=Y,Y.map=new WeakMap;class ce{constructor(B,Q){this._documents=B,this._provider=Q,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(B,Q,ee,ae){const j=this._documents.getDocument(B),se=_.Position.to(Q),fe=this.reviveContext(ee),Ae=await this._provider.provideSignatureHelp(j,se,ae,fe);if(Ae){const xe=this._cache.add([Ae]);return{..._.SignatureHelp.from(Ae),id:xe}}}reviveContext(B){let Q;if(B.activeSignatureHelp){const ee=_.SignatureHelp.to(B.activeSignatureHelp),ae=this._cache.get(B.activeSignatureHelp.id,0);ae?(Q=ae,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...B,activeSignatureHelp:Q}}releaseSignatureHelp(B){this._cache.delete(B)}}class G{constructor(B,Q){this._documents=B,this._provider=Q}async provideInlayHints(B,Q,ee){const ae=this._documents.getDocument(B),j=await this._provider.provideInlayHints(ae,_.Range.to(Q),ee);return j?{hints:j.map(_.InlayHint.from)}:void 0}}class le{constructor(B,Q){this._documents=B,this._provider=Q,this._cache=new d.Cache("DocumentLink")}async provideLinks(B,Q){const ee=this._documents.getDocument(B),ae=await this._provider.provideDocumentLinks(ee,Q);if(!(!Array.isArray(ae)||ae.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(_.DocumentLink.from)};{const j=this._cache.add(ae),se={links:[],id:j};for(let fe=0;fe<ae.length;fe++){if(!le._validateLink(ae[fe]))continue;const Ae=_.DocumentLink.from(ae[fe]);Ae.cacheId=[j,fe],se.links.push(Ae)}return se}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...B);if(!ee)return;const ae=await this._provider.resolveDocumentLink(ee,Q);if(!(!ae||!le._validateLink(ae)))return _.DocumentLink.from(ae)}releaseLinks(B){this._cache.delete(B)}}class oe{constructor(B,Q){this._documents=B,this._provider=Q}async provideColors(B,Q){const ee=this._documents.getDocument(B),ae=await this._provider.provideDocumentColors(ee,Q);return Array.isArray(ae)?ae.map(se=>({color:_.Color.from(se.color),range:_.Range.from(se.range)})):[]}async provideColorPresentations(B,Q,ee){const ae=this._documents.getDocument(B),j=_.Range.to(Q.range),se=_.Color.to(Q.color),fe=await this._provider.provideColorPresentations(se,{document:ae,range:j},ee);if(!!Array.isArray(fe))return fe.map(_.ColorPresentation.from)}}class Ee{constructor(B,Q){this._documents=B,this._provider=Q}async provideFoldingRanges(B,Q,ee){const ae=this._documents.getDocument(B),j=await this._provider.provideFoldingRanges(ae,Q,ee);if(!!Array.isArray(j))return j.map(_.FoldingRange.from)}}class Fe{constructor(B,Q,ee){this._documents=B,this._provider=Q,this._logService=ee}async provideSelectionRanges(B,Q,ee){const ae=this._documents.getDocument(B),j=Q.map(_.Position.to),se=await this._provider.provideSelectionRanges(ae,j,ee);if(!(0,P.isNonEmptyArray)(se))return[];if(se.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Ae=0;Ae<j.length;Ae++){const xe=[];fe.push(xe);let $e=j[Ae],ve=se[Ae];for(;;){if(!ve.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(_.SelectionRange.from(ve)),!ve.parent)break;$e=ve.range,ve=ve.parent}}return fe}}class Me{constructor(B,Q){this._documents=B,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(B,Q,ee){const ae=this._documents.getDocument(B),j=_.Position.to(Q),se=await this._provider.prepareCallHierarchy(ae,j,ee);if(!se)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,se)]}async provideCallsTo(B,Q,ee){const ae=this._itemFromCache(B,Q);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!j)return j.map(se=>({from:this._cacheAndConvertItem(B,se.from),fromRanges:se.fromRanges.map(fe=>_.Range.from(fe))}))}async provideCallsFrom(B,Q,ee){const ae=this._itemFromCache(B,Q);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!j)return j.map(se=>({to:this._cacheAndConvertItem(B,se.to),fromRanges:se.fromRanges.map(fe=>_.Range.from(fe))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,Q){const ee=this._cache.get(B),ae=_.CallHierarchyItem.from(Q,B,ee.size.toString(36));return ee.set(ae._itemId,Q),ae}_itemFromCache(B,Q){return this._cache.get(B)?.get(Q)}}class Ne{constructor(B,Q){this._documents=B,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(B,Q,ee){const ae=this._documents.getDocument(B),j=_.Position.to(Q),se=await this._provider.prepareTypeHierarchy(ae,j,ee);if(!se)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,se)]}async provideSupertypes(B,Q,ee){const ae=this._itemFromCache(B,Q);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(ae,ee);if(!!j)return j.map(se=>this._cacheAndConvertItem(B,se))}async provideSubtypes(B,Q,ee){const ae=this._itemFromCache(B,Q);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(ae,ee);if(!!j)return j.map(se=>this._cacheAndConvertItem(B,se))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,Q){const ee=this._cache.get(B),ae=_.TypeHierarchyItem.from(Q,B,ee.size.toString(36));return ee.set(ae._itemId,Q),ae}_itemFromCache(B,Q){return this._cache.get(B)?.get(Q)}}class Qe{constructor(B,Q){this.adapter=B,this.extension=Q}}class ze{constructor(B,Q,ee,ae,j,se,fe){this._adapter=new Map,this._uriTransformer=Q,this._proxy=B.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=j,this._logService=se,this._apiDeprecation=fe}_transformDocumentSelector(B){return(0,P.coalesce)((0,P.asArray)(B).map(Q=>this._doTransformDocumentSelector(Q)))}_doTransformDocumentSelector(B){if(typeof B=="string")return{$serialized:!0,language:B};if(B)return{$serialized:!0,language:B.language,scheme:this._transformScheme(B.scheme),pattern:typeof B.pattern=="undefined"?void 0:_.GlobPattern.from(B.pattern),exclusive:B.exclusive}}_transformScheme(B){return this._uriTransformer&&typeof B=="string"?this._uriTransformer.transformOutgoingScheme(B):B}_createDisposable(B){return new A.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return ze._handlePool++}_withAdapter(B,Q,ee,ae,j=!1){const se=this._adapter.get(B);if(!se)return Promise.resolve(ae);if(se.adapter instanceof Q){let fe;se.extension&&(fe=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Ae=ee(se.adapter,se.extension),xe=se.extension;return xe&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-fe}ms`),$e=>{j&&$e instanceof C.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error($e))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(B,Q){const ee=this._nextHandle();return this._adapter.set(ee,new Qe(B,Q)),ee}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Q,ee,ae){const j=this._addNewAdapter(new a(this._documents,ee),B),se=ae&&ae.label||ze._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(Q),se),this._createDisposable(j)}$provideDocumentSymbols(B,Q,ee){return this._withAdapter(B,a,ae=>ae.provideDocumentSymbols(c.URI.revive(Q),ee),void 0)}registerCodeLensProvider(B,Q,ee){const ae=this._nextHandle(),j=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new p(this._documents,this._commands.converter,ee),B)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Q),j);let se=this._createDisposable(ae);if(j!==void 0){const fe=ee.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(j));se=A.Disposable.from(se,fe)}return se}$provideCodeLenses(B,Q,ee){return this._withAdapter(B,p,ae=>ae.provideCodeLenses(c.URI.revive(Q),ee),void 0)}$resolveCodeLens(B,Q,ee){return this._withAdapter(B,p,ae=>ae.resolveCodeLens(Q,ee),void 0)}$releaseCodeLenses(B,Q){this._withAdapter(B,p,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(B,Q,ee){const ae=this._addNewAdapter(new i(this._documents,ee),B);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDefinition(B,Q,ee,ae){return this._withAdapter(B,i,j=>j.provideDefinition(c.URI.revive(Q),ee,ae),[])}registerDeclarationProvider(B,Q,ee){const ae=this._addNewAdapter(new l(this._documents,ee),B);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDeclaration(B,Q,ee,ae){return this._withAdapter(B,l,j=>j.provideDeclaration(c.URI.revive(Q),ee,ae),[])}registerImplementationProvider(B,Q,ee){const ae=this._addNewAdapter(new r(this._documents,ee),B);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideImplementation(B,Q,ee,ae){return this._withAdapter(B,r,j=>j.provideImplementation(c.URI.revive(Q),ee,ae),[])}registerTypeDefinitionProvider(B,Q,ee){const ae=this._addNewAdapter(new o(this._documents,ee),B);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideTypeDefinition(B,Q,ee,ae){return this._withAdapter(B,o,j=>j.provideTypeDefinition(c.URI.revive(Q),ee,ae),[])}registerHoverProvider(B,Q,ee,ae){const j=this._addNewAdapter(new b(this._documents,ee),B);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(Q)),this._createDisposable(j)}$provideHover(B,Q,ee,ae){return this._withAdapter(B,b,j=>j.provideHover(c.URI.revive(Q),ee,ae),void 0)}registerEvaluatableExpressionProvider(B,Q,ee,ae){const j=this._addNewAdapter(new f(this._documents,ee),B);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(Q)),this._createDisposable(j)}$provideEvaluatableExpression(B,Q,ee,ae){return this._withAdapter(B,f,j=>j.provideEvaluatableExpression(c.URI.revive(Q),ee,ae),void 0)}registerInlineValuesProvider(B,Q,ee,ae){const j=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new m(this._documents,ee),B);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(Q),j);let fe=this._createDisposable(se);if(j!==void 0){const Ae=ee.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(j));fe=A.Disposable.from(fe,Ae)}return fe}$provideInlineValues(B,Q,ee,ae,j){return this._withAdapter(B,m,se=>se.provideInlineValues(c.URI.revive(Q),ee,ae,j),void 0)}registerDocumentHighlightProvider(B,Q,ee){const ae=this._addNewAdapter(new D(this._documents,ee),B);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentHighlights(B,Q,ee,ae){return this._withAdapter(B,D,j=>j.provideDocumentHighlights(c.URI.revive(Q),ee,ae),void 0)}registerLinkedEditingRangeProvider(B,Q,ee){const ae=this._addNewAdapter(new T(this._documents,ee),B);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideLinkedEditingRanges(B,Q,ee,ae){return this._withAdapter(B,T,async j=>{const se=await j.provideLinkedEditingRanges(c.URI.revive(Q),ee,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?ze._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(B,Q,ee){const ae=this._addNewAdapter(new g(this._documents,ee),B);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideReferences(B,Q,ee,ae,j){return this._withAdapter(B,g,se=>se.provideReferences(c.URI.revive(Q),ee,ae,j),void 0)}registerCodeActionProvider(B,Q,ee,ae){const j=new n.DisposableStore,se=this._addNewAdapter(new E(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(Q),{providedKinds:ae?.providedCodeActionKinds?.map(fe=>fe.value),documentation:ae?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,j)}))},ze._extLabel(B),Boolean(ee.resolveCodeAction)),j.add(this._createDisposable(se)),j}$provideCodeActions(B,Q,ee,ae,j){return this._withAdapter(B,E,se=>se.provideCodeActions(c.URI.revive(Q),ee,ae,j),void 0)}$resolveCodeAction(B,Q,ee){return this._withAdapter(B,E,ae=>ae.resolveCodeAction(Q,ee),void 0)}$releaseCodeActions(B,Q){this._withAdapter(B,E,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(B,Q,ee){const ae=this._addNewAdapter(new u(this._documents,ee),B);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Q),B.identifier,B.displayName||B.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(B,Q,ee,ae){return this._withAdapter(B,u,j=>j.provideDocumentFormattingEdits(c.URI.revive(Q),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(B,Q,ee){const ae=this._addNewAdapter(new M(this._documents,ee),B);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Q),B.identifier,B.displayName||B.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(B,Q,ee,ae,j){return this._withAdapter(B,M,se=>se.provideDocumentRangeFormattingEdits(c.URI.revive(Q),ee,ae,j),void 0)}registerOnTypeFormattingEditProvider(B,Q,ee,ae){const j=this._addNewAdapter(new O(this._documents,ee),B);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(Q),ae,B.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits(B,Q,ee,ae,j,se){return this._withAdapter(B,O,fe=>fe.provideOnTypeFormattingEdits(c.URI.revive(Q),ee,ae,j,se),void 0)}registerWorkspaceSymbolProvider(B,Q){const ee=this._addNewAdapter(new q(Q,this._logService),B);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(B,Q,ee){return this._withAdapter(B,q,ae=>ae.provideWorkspaceSymbols(Q,ee),{symbols:[]})}$resolveWorkspaceSymbol(B,Q,ee){return this._withAdapter(B,q,ae=>ae.resolveWorkspaceSymbol(Q,ee),void 0)}$releaseWorkspaceSymbols(B,Q){this._withAdapter(B,q,ee=>ee.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(B,Q,ee){const ae=this._addNewAdapter(new K(this._documents,ee,this._logService),B);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Q),K.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(B,Q,ee,ae,j){return this._withAdapter(B,K,se=>se.provideRenameEdits(c.URI.revive(Q),ee,ae,j),void 0)}$resolveRenameLocation(B,Q,ee,ae){return this._withAdapter(B,K,j=>j.resolveRenameLocation(c.URI.revive(Q),ee,ae),void 0)}registerDocumentSemanticTokensProvider(B,Q,ee,ae){const j=this._nextHandle(),se=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(j,new Qe(new W(this._documents,ee),B)),this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(Q),ae,se);let fe=this._createDisposable(j);if(se){const Ae=ee.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(se));fe=A.Disposable.from(fe,Ae)}return fe}$provideDocumentSemanticTokens(B,Q,ee,ae){return this._withAdapter(B,W,j=>j.provideDocumentSemanticTokens(c.URI.revive(Q),ee,ae),null,!0)}$releaseDocumentSemanticTokens(B,Q){this._withAdapter(B,W,ee=>ee.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(B,Q,ee,ae){const j=this._addNewAdapter(new N(this._documents,ee),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(Q),ae),this._createDisposable(j)}$provideDocumentRangeSemanticTokens(B,Q,ee,ae){return this._withAdapter(B,N,j=>j.provideDocumentRangeSemanticTokens(c.URI.revive(Q),ee,ae),null,!0)}registerCompletionItemProvider(B,Q,ee,ae){const j=this._addNewAdapter(new H(this._documents,this._commands.converter,ee,this._apiDeprecation,B),B);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(Q),ae,H.supportsResolving(ee),`${B.identifier.value}(${ae.join("")})`),this._createDisposable(j)}$provideCompletionItems(B,Q,ee,ae,j){return this._withAdapter(B,H,se=>se.provideCompletionItems(c.URI.revive(Q),ee,ae,j),void 0)}$resolveCompletionItem(B,Q,ee){return this._withAdapter(B,H,ae=>ae.resolveCompletionItem(Q,ee),void 0)}$releaseCompletionItems(B,Q){this._withAdapter(B,H,ee=>ee.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(B,Q,ee){const ae=this._addNewAdapter(new V(this._documents,ee,this._commands.converter),B);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideInlineCompletions(B,Q,ee,ae,j){return this._withAdapter(B,V,se=>se.provideInlineCompletions(c.URI.revive(Q),ee,ae,j),void 0)}$handleInlineCompletionDidShow(B,Q,ee){this._withAdapter(B,V,async ae=>{ae.handleDidShowCompletionItem(Q,ee)},void 0)}$freeInlineCompletionsList(B,Q){this._withAdapter(B,V,async ee=>{ee.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider(B,Q,ee,ae){const j=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new ce(this._documents,ee),B);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(Q),j),this._createDisposable(se)}$provideSignatureHelp(B,Q,ee,ae,j){return this._withAdapter(B,ce,se=>se.provideSignatureHelp(c.URI.revive(Q),ee,ae,j),void 0)}$releaseSignatureHelp(B,Q){this._withAdapter(B,ce,ee=>ee.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(B,Q,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new G(this._documents,ee),B);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(Q),ae);let se=this._createDisposable(j);if(ae!==void 0){const fe=ee.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(ae));se=A.Disposable.from(se,fe)}return se}$provideInlayHints(B,Q,ee,ae){return this._withAdapter(B,G,j=>j.provideInlayHints(c.URI.revive(Q),ee,ae),void 0)}registerDocumentLinkProvider(B,Q,ee){const ae=this._addNewAdapter(new le(this._documents,ee),B);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Q),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(B,Q,ee){return this._withAdapter(B,le,ae=>ae.provideLinks(c.URI.revive(Q),ee),void 0)}$resolveDocumentLink(B,Q,ee){return this._withAdapter(B,le,ae=>ae.resolveLink(Q,ee),void 0)}$releaseDocumentLinks(B,Q){this._withAdapter(B,le,ee=>ee.releaseLinks(Q),void 0)}registerColorProvider(B,Q,ee){const ae=this._addNewAdapter(new oe(this._documents,ee),B);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentColors(B,Q,ee){return this._withAdapter(B,oe,ae=>ae.provideColors(c.URI.revive(Q),ee),[])}$provideColorPresentations(B,Q,ee,ae){return this._withAdapter(B,oe,j=>j.provideColorPresentations(c.URI.revive(Q),ee,ae),void 0)}registerFoldingRangeProvider(B,Q,ee){const ae=this._nextHandle(),j=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new Ee(this._documents,ee),B)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Q),j);let se=this._createDisposable(ae);if(j!==void 0){const fe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));se=A.Disposable.from(se,fe)}return se}$provideFoldingRanges(B,Q,ee,ae){return this._withAdapter(B,Ee,j=>j.provideFoldingRanges(c.URI.revive(Q),ee,ae),void 0)}registerSelectionRangeProvider(B,Q,ee){const ae=this._addNewAdapter(new Fe(this._documents,ee,this._logService),B);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideSelectionRanges(B,Q,ee,ae){return this._withAdapter(B,Fe,j=>j.provideSelectionRanges(c.URI.revive(Q),ee,ae),[])}registerCallHierarchyProvider(B,Q,ee){const ae=this._addNewAdapter(new Me(this._documents,ee),B);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareCallHierarchy(B,Q,ee,ae){return this._withAdapter(B,Me,j=>Promise.resolve(j.prepareSession(c.URI.revive(Q),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(B,Q,ee,ae){return this._withAdapter(B,Me,j=>j.provideCallsTo(Q,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(B,Q,ee,ae){return this._withAdapter(B,Me,j=>j.provideCallsFrom(Q,ee,ae),void 0)}$releaseCallHierarchy(B,Q){this._withAdapter(B,Me,ee=>Promise.resolve(ee.releaseSession(Q)),void 0)}registerTypeHierarchyProvider(B,Q,ee){const ae=this._addNewAdapter(new Ne(this._documents,ee),B);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareTypeHierarchy(B,Q,ee,ae){return this._withAdapter(B,Ne,j=>Promise.resolve(j.prepareSession(c.URI.revive(Q),ee,ae)),void 0)}$provideTypeHierarchySupertypes(B,Q,ee,ae){return this._withAdapter(B,Ne,j=>j.provideSupertypes(Q,ee,ae),void 0)}$provideTypeHierarchySubtypes(B,Q,ee,ae){return this._withAdapter(B,Ne,j=>j.provideSubtypes(Q,ee,ae),void 0)}$releaseTypeHierarchy(B,Q){this._withAdapter(B,Ne,ee=>Promise.resolve(ee.releaseSession(Q)),void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:(0,I.regExpFlags)(B)}}static _serializeIndentationRule(B){return{decreaseIndentPattern:ze._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?ze._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?ze._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:ze._serializeRegExp(B.beforeText),afterText:B.afterText?ze._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?ze._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(ze._serializeOnEnterRule)}setLanguageConfiguration(B,Q,ee){let{wordPattern:ae}=ee;if(ae&&(0,I.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Q,ae):this._documents.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const j=this._nextHandle(),se={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ze._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ze._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ze._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,Q,se),this._createDisposable(j)}$setWordDefinitions(B){for(const Q of B)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(we[194],be([0,1,5,8,7,35,14,6]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(t,y,n){this._documents=y,this._commands=n,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,y){await this._proxy.$changeLanguage(t,y);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,y){const n=t.version,h=F.Position.from(y),s=await this._proxy.$tokensAtPosition(t.uri,h),d={type:_.StandardTokenType.Other,range:t.getWordRangeAtPosition(y)??new _.Range(y.line,y.character,y.line,y.character)};if(!s)return d;const v={range:F.Range.to(s.range),type:F.TokenType.to(s.type)};return!v.range.contains(y)||n!==t.version?d:v}createLanguageStatusItem(t,y,n){const h=this._handlePool++,s=this._proxy,d=this._ids,v=`${t.identifier.value}/${y}`;if(d.has(v))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);d.add(v);const C={selector:n,id:y,name:t.displayName??t.name,severity:_.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let w,a=new I.DisposableStore;const p=()=>{w?.dispose(),w=(0,R.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(h,{id:v,name:C.name??t.displayName??t.name,source:t.displayName??t.name,selector:C.selector,label:C.text,detail:C.detail??"",severity:C.severity===_.LanguageStatusSeverity.Error?A.default.Error:C.severity===_.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:C.command&&this._commands.toInternal(C.command,a),accessibilityInfo:C.accessibilityInformation})},0)},k={dispose(){a.dispose(),w?.dispose(),s.$removeLanguageStatus(h),d.delete(v)},get id(){return C.id},get name(){return C.name},set name(i){C.name=i,p()},get selector(){return C.selector},set selector(i){C.selector=i,p()},get text(){return C.text},set text(i){C.text=i,p()},get detail(){return C.detail},set detail(i){C.detail=i,p()},get severity(){return C.severity},set severity(i){C.severity=i,p()},get accessibilityInformation(){return C.accessibilityInformation},set accessibilityInformation(i){C.accessibilityInformation=i,p()},get command(){return C.command},set command(i){C.command=i,p()}};return p(),k}}e.ExtHostLanguages=S}),define(we[195],be([0,1,5,15,30]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(I){return I&&I.title}let R=class{constructor(S,P){this._logService=P,this._proxy=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,P,t,y,n){const h={extension:S};let s;typeof y=="string"||A(y)?s=[y,...n]:(h.modal=y?.modal,h.useCustom=y?.useCustom,h.detail=y?.detail,s=n),h.useCustom&&(0,_.checkProposedApiEnabled)(S);const d=[];for(let v=0;v<s.length;v++){const C=s[v];if(typeof C=="string")d.push({title:C,handle:v,isCloseAffordance:!1});else if(typeof C=="object"){let{title:w,isCloseAffordance:a}=C;d.push({title:w,isCloseAffordance:!!a,handle:v})}else this._logService.warn("Invalid message item:",C)}return this._proxy.$showMessage(P,t,h,d).then(v=>{if(typeof v=="number")return s[v]})}};R=Ue([He(1,F.ILogService)],R),e.ExtHostMessageService=R}),define(we[196],be([0,1,23,3,58,6,20,9,10,2,63,5,8,7,47,171,93]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class C{constructor(a,p,k,i,l){this._textDocumentsAndEditors=k,this._textDocuments=i,this._extensionStoragePaths=l,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const o=r.notebookEditor?.notebookUri,b=r.cell.handle,m=this._documents.get(o)?.getCell(b);if(m)return m.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const p=this._editors.get(a);if(!p)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(a){for(const[p,k]of this._editors)if(k.apiEditor===a)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,p){const k=this._documents.get(a);if(!k&&!p)throw new Error(`NO notebook document for '${a}'`);return k}_getProviderData(a){const p=this._notebookContentProviders.get(a);if(!p)throw new Error(`NO provider for '${a}'`);return p}registerNotebookContentProvider(a,p,k,i,l){if((0,I.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:a,provider:k});let r;return k.onDidChangeNotebookContentOptions&&(r=k.onDidChangeNotebookContentOptions(()=>{const o=n.NotebookDocumentContentOptions.from(k.options);this._notebookProxy.$updateNotebookProviderOptions(p,o)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},p,n.NotebookDocumentContentOptions.from(i),C._convertNotebookRegistrationData(a,l)),new h.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}static _convertNotebookRegistrationData(a,p){if(!p)return;const k=p.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(p.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:p.displayName,filenamePattern:k,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,p,k){const i=C._notebookStatusBarItemProviderHandlePool++,l=typeof k.onDidChangeCellStatusBarItems=="function"?C._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,k),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,l,p);let r;return l!==void 0&&(r=k.onDidChangeCellStatusBarItems(o=>this._notebookProxy.$emitCellStatusBarEvent(l))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,l),r&&r.dispose()})}async createNotebookDocument(a){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&n.NotebookData.from(a.content)});return P.URI.revive(p)}async openNotebookDocument(a){const p=this._documents.get(a);if(p)return p.apiNotebook;const k=await this._notebookDocumentsProxy.$tryOpenNotebook(a),i=this._documents.get(P.URI.revive(k));return(0,S.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(a,p){P.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let k;typeof p=="object"?k={position:n.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(n.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:k={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,k),l=i&&this._editors.get(i)?.apiEditor;if(l)return l;throw i?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,p,k,i){const l=this._notebookStatusBarItemProviders.get(a),r=P.URI.revive(p),o=this._documents.get(r);if(!o||!l)return;const b=o.getCellFromIndex(k);if(!b)return;const f=await l.provideCellStatusBarItems(b.apiCell,i);if(!f)return;const m=new A.DisposableStore,D=this._statusBarCache.add([m]),g=(Array.isArray(f)?f:[f]).map(E=>n.NotebookStatusBarItem.from(E,this._commandsConverter,m));return{cacheId:D,items:g}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,p,k,i,l){if((0,I.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,k),this._notebookProxy.$registerNotebookSerializer(r,{id:a.identifier,location:a.extensionLocation},p,n.NotebookDocumentContentOptions.from(i),C._convertNotebookRegistrationData(a,l)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(a,p,k){const i=this._notebookSerializer.get(a);if(!i)throw new Error("NO serializer found");const l=await i.deserializeNotebook(p.buffer,k);return new s.SerializableObjectWithBuffers(n.NotebookData.from(l))}async $notebookToData(a,p,k){const i=this._notebookSerializer.get(a);if(!i)throw new Error("NO serializer found");const l=await i.serializeNotebook(n.NotebookData.to(p.value),k);return c.VSBuffer.wrap(l)}async $openNotebook(a,p,k,i,l){const{provider:r}=this._getProviderData(a),o=await r.openNotebook(P.URI.revive(p),{backupId:k,untitledDocumentData:i?.buffer},l);return new s.SerializableObjectWithBuffers({metadata:o.metadata??Object.create(null),cells:o.cells.map(n.NotebookCellData.from)})}async $saveNotebook(a,p,k){const i=this.getNotebookDocument(P.URI.revive(p)),{provider:l}=this._getProviderData(a);return await l.saveNotebook(i.apiNotebook,k),!0}async $saveNotebookAs(a,p,k,i){const l=this.getNotebookDocument(P.URI.revive(p)),{provider:r}=this._getProviderData(a);return await r.saveNotebookAs(P.URI.revive(k),l.apiNotebook,i),!0}async $backupNotebook(a,p,k){const i=this.getNotebookDocument(P.URI.revive(p)),l=this._getProviderData(a),r=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension),o=String((0,_.hash)([i.uri.toString(),this._backupIdPool++])),b=P.URI.joinPath(r,o),f=await l.provider.backupNotebook(i.apiNotebook,{destination:b},k);return i.updateBackup(f),f.id}_createExtHostEditor(a,p,k){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const i=new v.ExtHostNotebookEditor(p,this._notebookEditorsProxy,a,k.visibleRanges.map(n.NotebookRange.to),k.selections.map(n.NotebookRange.to),typeof k.viewColumn=="number"?n.ViewColumn.to(k.viewColumn):void 0);this._editors.set(p,i)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const k of a.value.removedDocuments){const i=P.URI.revive(k),l=this._documents.get(i);l&&(l.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:l.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(l.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(a.value.addedDocuments){const k=[];for(const i of a.value.addedDocuments){const l=P.URI.revive(i.uri);if(this._documents.has(l))throw new Error(`adding EXISTING notebook ${l} `);const r=this,o=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(b){r._onDidChangeNotebookCells.fire(b)},emitCellOutputsChange(b){r._onDidChangeCellOutputs.fire(b)},emitCellMetadataChange(b){r._onDidChangeCellMetadata.fire(b)},emitCellExecutionStateChange(b){r._onDidChangeCellExecutionState.fire(b)}},l,i);k.push(...i.cells.map(b=>d.ExtHostCell.asModelAddData(o.apiNotebook,b))),this._documents.get(l)?.dispose(),this._documents.set(l,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(a.value.addedEditors)for(const k of a.value.addedEditors){if(this._editors.has(k.id))return;const i=P.URI.revive(k.documentUri),l=this._documents.get(i);l&&this._createExtHostEditor(l,k.id,k)}const p=[];if(a.value.removedEditors)for(const k of a.value.removedEditors){const i=this._editors.get(k);i&&(this._editors.delete(k),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),p.push(i))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const k=new Set;this._visibleNotebookEditors.forEach(i=>k.add(i.id));for(const i of this._editors.values()){const l=k.has(i.id);i._acceptVisibility(l)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=C,C._notebookStatusBarItemProviderHandlePool=0}),define(we[197],be([0,1,3,53,15,5,12,8]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(y,n){const h=S._Keys.nextId();y.$registerNotebookEditorDecorationType(h,I.NotebookDecorationRenderOptions.from(n)),this.value={key:h,dispose(){y.$removeNotebookEditorDecorationType(h)}}}}S._Keys=new F.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(y,n,h){this._logService=y,this._extHostRpc=n,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new S(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,n);const h=this._notebooksAndEditors.getEditorById(y);n.visibleRanges&&h._acceptVisibleRanges(n.visibleRanges.ranges.map(I.NotebookRange.to)),n.selections&&h._acceptSelections(n.selections.selections.map(I.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const n in y)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(I.ViewColumn.to(y[n]))}};P=Ue([He(0,_.ILogService),He(1,R.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(we[198],be([0,1,13,14,21,3,6,20,2,25,15,5,8,7,66,164,30,47]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(l,r,o,b){this._initData=r,this._extHostNotebook=o,this._logService=b,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=l.getProxy(y.MainContext.MainThreadNotebookKernels)}createNotebookController(l,r,o,b,f,m){for(let Y of this._kernelData.values())if(Y.controller.id===r&&P.ExtensionIdentifier.equals(l.identifier,Y.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const D=this._handlePool++,T=this;this._logService.trace(`NotebookController[${D}], CREATED by ${l.identifier.value}, ${r}`);const g=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${l.identifier}'`);let E=!1;const u=new R.DisposableStore,M=new A.Emitter,O=new A.Emitter,q={id:`${l.identifier.value}/${r}`,notebookType:o,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:b||l.identifier.value,preloads:m?m.map(n.NotebookRendererScript.from):[]};let K=f??g,$;this._proxy.$addKernel(D,q).catch(Y=>{console.log(Y),E=!0});let W=0;const N=()=>{if(E)return;const Y=++W;Promise.resolve().then(()=>{Y===W&&this._proxy.$updateKernel(D,q)})},H=new I.ResourceMap,V={get id(){return r},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return q.label},set label(Y){q.label=Y??l.displayName??l.name,N()},get detail(){return q.detail??""},set detail(Y){q.detail=Y,N()},get description(){return q.description??""},set description(Y){q.description=Y,N()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(Y){q.supportedLanguages=Y,N()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){q.supportsExecutionOrder=Y,N()},get rendererScripts(){return q.preloads?q.preloads.map(n.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(Y){K=Y??g},get interruptHandler(){return $},set interruptHandler(Y){$=Y,q.supportsInterrupt=Boolean(Y),N()},createNotebookCellExecution(Y){if(E)throw new Error("notebook controller is DISPOSED");if(!H.has(Y.notebook.uri))throw T._logService.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return T._createNotebookCellExecution(Y)},dispose:()=>{E||(this._logService.trace(`NotebookController[${D}], DISPOSED`),E=!0,this._kernelData.delete(D),u.dispose(),M.dispose(),O.dispose(),this._proxy.$removeKernel(D))},updateNotebookAffinity(Y,ce){T._proxy.$updateNotebookPriority(D,Y.uri,ce)},onDidReceiveMessage:O.event,postMessage(Y,ce){return(0,v.checkProposedApiEnabled)(l),T._proxy.$postMessage(D,ce&&T._extHostNotebook.getIdByEditor(ce),Y)},asWebviewUri(Y){return(0,v.checkProposedApiEnabled)(l),(0,s.asWebviewUri)(Y,T._initData.remote)}};return this._kernelData.set(D,{extensionId:l.identifier,controller:V,onDidReceiveMessage:O,onDidChangeSelection:M,associatedNotebooks:H}),V}$acceptNotebookAssociation(l,r,o){const b=this._kernelData.get(l);if(b){const f=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));o?b.associatedNotebooks.set(f.uri,!0):b.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${l}] ASSOCIATE notebook`,f.uri.toString(),o),b.onDidChangeSelection.fire({selected:o,notebook:f.apiNotebook})}}async $executeCells(l,r,o){const b=this._kernelData.get(l);if(!b)return;const f=this._extHostNotebook.getNotebookDocument(S.URI.revive(r)),m=[];for(let D of o){const T=f.getCell(D);T&&m.push(T.apiCell)}try{this._logService.trace(`NotebookController[${l}] EXECUTE cells`,f.uri.toString(),m.length),await b.controller.executeHandler.call(b.controller,m,f.apiNotebook,b.controller)}catch(D){this._logService.error(`NotebookController[${l}] execute cells FAILED`,D),console.error(D)}}async $cancelCells(l,r,o){const b=this._kernelData.get(l);if(!b)return;const f=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));if(b.controller.interruptHandler)await b.controller.interruptHandler.call(b.controller,f.apiNotebook);else for(let m of o){const D=f.getCell(m);D&&this._activeExecutions.get(D.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,r,o){const b=this._kernelData.get(l);if(!b)return;const f=this._extHostNotebook.getEditorById(r);b.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:o}))}_createNotebookCellExecution(l){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const b=new p(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,b);const f=b.onDidChangeState(()=>{b.state===a.Resolved&&(b.dispose(),f.dispose(),this._activeExecutions.delete(o.uri))});return b.asApiObject()}};w=Ue([He(3,t.ILogService)],w),e.ExtHostNotebookKernels=w;var a;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(a||(a={}));class p extends R.Disposable{constructor(l,r,o){super();this._document=l,this._cell=r,this._proxy=o,this._handle=p.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new k(10,b=>this.update(b)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(l){await this._collector.addItem(l)}async update(l){const r=Array.isArray(l)?l:[l];return this._proxy.$updateExecutions(new C.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(l){let r=this._cell;if(l&&(r=this._document.getCellFromApiCell(l)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(l){return l.map(r=>{const o=h.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return o===r.items?n.NotebookCellOutput.from(r):n.NotebookCellOutput.from({items:o,id:r.id,metadata:r.metadata})})}async updateOutputs(l,r,o){const b=this.cellIndexToHandle(r),f=this.validateAndConvertOutputs((0,c.asArray)(l));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:b,append:o,outputs:f})}async updateOutputItems(l,r,o){return l=h.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(l),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:l.map(n.NotebookCellOutputItem.from),outputId:r.id,append:o})}asApiObject(){const l=this;return Object.freeze({get token(){return l._tokenSource.token},get cell(){return l._cell.apiCell},get executionOrder(){return l._executionOrder},set executionOrder(o){l._executionOrder=o,l.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionHandle:l._handle,executionOrder:l._executionOrder}])},start(o){if(l._state===a.Resolved||l._state===a.Started)throw new Error("Cannot call start again");l._state=a.Started,l._onDidChangeState.fire(),l.update({editType:d.CellExecutionUpdateType.ExecutionState,executionHandle:l._handle,runStartTime:o})},end(o,b){if(l._state===a.Resolved)throw new Error("Cannot call resolve twice");l._state=a.Resolved,l._onDidChangeState.fire(),l.updateSoon({editType:d.CellExecutionUpdateType.Complete,executionHandle:l._handle,runEndTime:b,lastRunSuccess:o}),l._collector.flush(),l._proxy.$removeExecution(l._handle)},clearOutput(o){return l.verifyStateForOutput(),l.updateOutputs([],o,!1)},appendOutput(o,b){return l.verifyStateForOutput(),l.updateOutputs(o,b,!0)},replaceOutput(o,b){return l.verifyStateForOutput(),l.updateOutputs(o,b,!1)},appendOutputItems(o,b){return l.verifyStateForOutput(),l.updateOutputItems(o,b,!0)},replaceOutputItems(o,b){return l.verifyStateForOutput(),l.updateOutputItems(o,b,!1)}})}}p.HANDLE=0;class k{constructor(l,r){this.delay=l,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(l){return this.batch.push(l),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const l=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>l.complete())}}}),define(we[199],be([0,1,3,5,93]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(I,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,S,P){const t=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(S)?.fire({editor:t.apiEditor,message:P})}createRendererMessaging(I,S){if(!I.contributes?.notebookRenderer?.some(n=>n.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const P=!!I.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,h,s)=>{const d=P?n:v=>{const C={};t.set(C,v.editor),n({editor:C,message:v.message})};return this.getOrCreateEmitterFor(S).event(d,h,s)},postMessage:(n,h)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,h]=[h,n]);const s=P?h:t.get(h),d=s&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(s);return this.proxy.$postMessage(d?.id,S,n)}}}getOrCreateEmitterFor(I){let S=this._rendererMessageEmitters.get(I);return S||(S=new c.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,S),S)}}e.ExtHostNotebookRenderers=A}),define(we[96],be([0,1,5,3,6,23,4,12]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends _.Disposable{constructor(s,d,v,C,w){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=w,this._id=w.$register(this.name,d,v,C),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?A.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(d=>this._proxy.$clear(d,s))}show(s,d){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof s=="boolean"?s:d)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class P extends S{constructor(s,d,v){super(s,!1,void 0,d,v)}append(s){super.append(s),this._id.then(d=>this._proxy.$append(d,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class t extends S{constructor(s,d,v){super(s,!0,d,void 0,v)}append(s){throw new Error("Not supported")}}class y{constructor(s,d){this.name=s,this._channel=d}append(s){this._channel.then(d=>d.append(s))}appendLine(s){this._channel.then(d=>d.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,d){this._channel.then(v=>v.show(s,d))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=y;let n=class{constructor(s){this._proxy=s.getProxy(c.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s,d){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new P(s,d.identifier.value,this._proxy)}createOutputChannelFromLogFile(s,d){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new t(s,d,this._proxy)}};n=Ue([He(0,I.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(we[200],be([0,1,14,21,3,6,5,2,7,16,13,35,44]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(s,d,v){const C=s.getProxy(R.MainContext.MainThreadQuickOpen);class w{constructor(f,m){this._sessions=new Map,this._instances=0,this._workspace=f,this._commands=m}showQuickPick(f,m,D,T=F.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(f),E=++this._instances,u=C.$show(E,{title:D?.title,placeHolder:D?.placeHolder,matchOnDescription:D?.matchOnDescription,matchOnDetail:D?.matchOnDetail,ignoreFocusLost:D?.ignoreFocusOut,canPickMany:D?.canPickMany},T),M={},O=u.then(()=>M);return Promise.race([O,g]).then(q=>{if(q!==M)return g.then(K=>{const $=[];for(let W=0;W<K.length;W++){const N=K[W];let H,V,Y,ce,G;typeof N=="string"?H=N:(H=N.label,V=N.description,Y=N.detail,ce=N.picked,G=N.alwaysShow),$.push({label:H,description:V,handle:W,detail:Y,picked:ce,alwaysShow:G})}return D&&typeof D.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{D.onDidSelectItem(K[W])}),C.$setItems(E,$),u.then(W=>{if(typeof W=="number")return K[W];if(Array.isArray(W))return W.map(N=>K[N])})})}).then(void 0,q=>{if(!(0,P.isPromiseCanceledError)(q))return C.$setError(E,q),Promise.reject(q)})}$onItemSelected(f){this._onDidSelectItem&&this._onDidSelectItem(f)}showInput(f,m=F.CancellationToken.None){return this._validateInput=f?f.validateInput:void 0,C.$input(f,typeof this._validateInput=="function",m).then(void 0,D=>{if(!(0,P.isPromiseCanceledError)(D))return Promise.reject(D)})}$validateInput(f){return this._validateInput?(0,c.asPromise)(()=>this._validateInput(f)):Promise.resolve(void 0)}async showWorkspaceFolderPick(f,m=F.CancellationToken.None){const D=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!D)return;const T=await this._workspace.getWorkspaceFolders2();if(!!T)return T.find(g=>g.uri.toString()===D.uri.toString())}createQuickPick(f,m){const D=new r(f,m,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}createInputBox(f){const m=new o(f,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(f,m){const D=this._sessions.get(f);D&&D._fireDidChangeValue(m)}$onDidAccept(f){const m=this._sessions.get(f);m&&m._fireDidAccept()}$onDidChangeActive(f,m){const D=this._sessions.get(f);D instanceof r&&D._fireDidChangeActive(m)}$onDidChangeSelection(f,m){const D=this._sessions.get(f);D instanceof r&&D._fireDidChangeSelection(m)}$onDidTriggerButton(f,m){const D=this._sessions.get(f);D&&D._fireDidTriggerButton(m)}$onDidTriggerItemButton(f,m,D){const T=this._sessions.get(f);T instanceof r&&T._fireDidTriggerItemButton(m,D)}$onDidHide(f){const m=this._sessions.get(f);m&&m._fireDidHide()}}class a{constructor(f,m){this._extensionId=f,this._onDidDispose=m,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new _.Emitter,this._onDidChangeValueEmitter=new _.Emitter,this._onDidTriggerButtonEmitter=new _.Emitter,this._onDidHideEmitter=new _.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(f){this._title=f,this.update({title:f})}get step(){return this._steps}set step(f){this._steps=f,this.update({step:f})}get totalSteps(){return this._totalSteps}set totalSteps(f){this._totalSteps=f,this.update({totalSteps:f})}get enabled(){return this._enabled}set enabled(f){this._enabled=f,this.update({enabled:f})}get busy(){return this._busy}set busy(f){this._busy=f,this.update({busy:f})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(f){this._ignoreFocusOut=f,this.update({ignoreFocusOut:f})}get value(){return this._value}set value(f){this._value=f,this.update({value:f})}get placeholder(){return this._placeholder}set placeholder(f){this._placeholder=f,this.update({placeholder:f})}get buttons(){return this._buttons}set buttons(f){this._buttons=f.slice(),this._handlesToButtons.clear(),f.forEach((m,D)=>{const T=m===S.QuickInputButtons.Back?-1:D;this._handlesToButtons.set(T,m)}),this.update({buttons:f.map((m,D)=>({...l(m),tooltip:m.tooltip,handle:m===S.QuickInputButtons.Back?-1:D}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(f){this._value=f,this._onDidChangeValueEmitter.fire(f)}_fireDidTriggerButton(f){const m=this._handlesToButtons.get(f);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),C.$dispose(this._id))}update(f){if(!this._disposed){for(const m of Object.keys(f)){const D=f[m];this._pendingUpdate[m]=D===void 0?null:D}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){C.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function p(b){if(b instanceof S.ThemeIcon)return{id:b.id};const f=i(b),m=k(b);return{dark:typeof f=="string"?I.URI.file(f):f,light:typeof m=="string"?I.URI.file(m):m}}function k(b){return typeof b=="object"&&"light"in b?b.light:b}function i(b){return typeof b=="object"&&"dark"in b?b.dark:b}function l(b){const f=p(b.iconPath);let m,D;return"id"in f?D=n.ThemeIcon.asClassName(f):m=f,{iconPath:m,iconClass:D}}class r extends a{constructor(f,m,D){super(f,D);this.enableProposedApi=m,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new _.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new _.Emitter,this._onDidTriggerItemButtonEmitter=new _.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(f){this._items=f.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),f.forEach((m,D)=>{this._handlesToItems.set(D,m),this._itemsToHandles.set(m,D)}),this.update({items:f.map((m,D)=>({label:m.label,description:m.description,handle:D,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons&&this.enableProposedApi?m.buttons.map((T,g)=>({...l(T),tooltip:T.tooltip,handle:g})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(f){this._canSelectMany=f,this.update({canSelectMany:f})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(f){this._matchOnDescription=f,this.update({matchOnDescription:f})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(f){this._matchOnDetail=f,this.update({matchOnDetail:f})}get sortByLabel(){return this._sortByLabel}set sortByLabel(f){this._sortByLabel=f,this.update({sortByLabel:f})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(f){this._keepScrollPosition=f,this.update({keepScrollPosition:f})}get activeItems(){return this._activeItems}set activeItems(f){this._activeItems=f.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(f){this._selectedItems=f.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(f){const m=(0,t.coalesce)(f.map(D=>this._handlesToItems.get(D)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(f){const m=(0,t.coalesce)(f.map(D=>this._handlesToItems.get(D)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(f,m){const D=this._handlesToItems.get(f);if(!D||!D.buttons||!D.buttons.length)return;const T=D.buttons[m];T&&this._onDidTriggerItemButtonEmitter.fire({button:T,item:D})}}class o extends a{constructor(f,m){super(f,m);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(f){this._password=f,this.update({password:f})}get prompt(){return this._prompt}set prompt(f){this._prompt=f,this.update({prompt:f})}get validationMessage(){return this._validationMessage}set validationMessage(f){this._validationMessage=f,this.update({validationMessage:f,severity:f?y.default.Error:y.default.Ignore})}}return new w(d,v)}e.createExtHostQuickOpen=h}),define(we[201],be([0,1,2,3,52,6,14,5,13,107,15,25,30,44,8]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(f){if(f)return typeof f.iconPath=="string"?c.URI.file(f.iconPath):c.URI.isUri(f.iconPath)||h.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function v(f,m){if(!f.iconPath&&!m.iconPath)return 0;if(f.iconPath){if(!m.iconPath)return 1}else return-1;const D=typeof f.iconPath=="string"?f.iconPath:c.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,T=typeof m.iconPath=="string"?m.iconPath:c.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,P.comparePaths)(D,T)}function C(f,m){let D=0;if(f.strikeThrough!==m.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==m.faded)return f.faded?1:-1;if(f.tooltip!==m.tooltip)return(f.tooltip||"").localeCompare(m.tooltip||"");if(D=v(f,m),D!==0)return D;if(f.light&&m.light)D=v(f.light,m.light);else{if(f.light)return 1;if(m.light)return-1}if(D!==0)return D;if(f.dark&&m.dark)D=v(f.dark,m.dark);else{if(f.dark)return 1;if(m.dark)return-1}return D}function w(f,m){if(f.command!==m.command)return f.command<m.command?-1:1;if(f.title!==m.title)return f.title<m.title?-1:1;if(f.tooltip!==m.tooltip){if(f.tooltip!==void 0&&m.tooltip!==void 0)return f.tooltip<m.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(f.arguments===m.arguments)return 0;if(f.arguments)if(m.arguments){if(f.arguments.length!==m.arguments.length)return f.arguments.length-m.arguments.length}else return 1;else return-1;for(let D=0;D<f.arguments.length;D++){const T=f.arguments[D],g=m.arguments[D];if(T!==g)return T<g?-1:1}return 0}function a(f,m){let D=(0,P.comparePaths)(f.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(D!==0)return D;if(f.command&&m.command)D=w(f.command,m.command);else{if(f.command)return 1;if(m.command)return-1}if(D!==0)return D;if(f.decorations&&m.decorations)D=C(f.decorations,m.decorations);else{if(f.decorations)return 1;if(m.decorations)return-1}return D}function p(f,m){for(let D=0;D<f.length;D++)if(f[D]!==m[D])return!1;return!0}function k(f,m){return f.command===m.command&&f.title===m.title&&f.tooltip===m.tooltip&&(f.arguments&&m.arguments?p(f.arguments,m.arguments):f.arguments===m.arguments)}function i(f,m){return(0,S.equals)(f,m,k)}class l{constructor(m,D,T){this._extension=m,this._proxy=D,this._sourceControlHandle=T,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(m){this._proxy.$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(m){if((0,n.checkProposedApiEnabled)(this._extension),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,m))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(m,D){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,m,D)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=l;class r{constructor(m,D,T,g,E){this._proxy=m,this._commands=D,this._sourceControlHandle=T,this._id=g,this._label=E,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,D){const T=this._resourceStatesCommandsMap.get(m);return T?(0,R.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],D)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(a),T=(0,S.sortedDiff)(this._resourceSnapshot,m,a).map(u=>{const M=u.toInsert.map(O=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,O);const K=O.resourceUri;let $;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const Ee=new A.DisposableStore;$=this._commands.converter.toInternal(O.command,Ee),this._resourceStatesDisposablesMap.set(q,Ee)}else this._resourceStatesCommandsMap.set(q,O.command);const W=d(O.decorations),N=O.decorations&&d(O.decorations.light)||W,H=O.decorations&&d(O.decorations.dark)||W,V=[N,H],Y=O.decorations&&O.decorations.tooltip||"",ce=O.decorations&&!!O.decorations.strikeThrough,G=O.decorations&&!!O.decorations.faded,le=O.contextValue||"";return{rawResource:[q,K,V,Y,ce,G,le,$],handle:q}});return{start:u.start,deleteCount:u.deleteCount,toInsert:M}}),g=T.map(({start:u,deleteCount:M,toInsert:O})=>[u,M,O.map(q=>q.rawResource)]),E=T.reverse();for(const{start:u,deleteCount:M,toInsert:O}of E){const q=O.map($=>$.handle),K=this._handlesSnapshot.splice(u,M,...q);for(const $ of K)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=m,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class o{constructor(m,D,T,g,E,u){this._proxy=D,this._commands=T,this._id=g,this._label=E,this._rootUri=u,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=o._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new l(m,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,g,E,u)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,this._proxy.$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,this._proxy.$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=m;const D=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:D})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&i(this._statusBarCommands,m))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=m;const D=(m||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:D})}get selected(){return this._selected}createResourceGroup(m,D){const T=new r(this._proxy,this._commands,this.handle,m,D),g=F.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,g),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const m=[],D=[];for(const[T,g]of this.createdResourceGroups){g.dispose();const E=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});F.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),E.dispose(),this._groups.delete(T.handle),this._proxy.$unregisterGroup(this.handle,T.handle)}),m.push([T.handle,T.id,T.label,T.features]);const u=T._takeResourceStateSnapshot();u.length>0&&D.push([T.handle,u]),this._groups.set(T.handle,T)}this._proxy.$registerGroups(this.handle,m,D),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(D=>{const T=D._takeResourceStateSnapshot();T.length!==0&&m.push([D.handle,T])}),m.length>0&&this._proxy.$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}o._handlePool=0,Ue([(0,_.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),Ue([(0,_.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let b=class Bi{constructor(m,D,T){this._commands=D,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=m.getProxy(I.MainContext.MainThreadSCM),this._telemetry=m.getProxy(I.MainContext.MainThreadTelemetry),D.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===3){const E=this._sourceControls.get(g.sourceControlHandle);if(!E)return g;const u=E.getResourceGroup(g.groupHandle);return u?u.getResourceState(g.handle):g}else if(g&&g.$mid===4){const E=this._sourceControls.get(g.sourceControlHandle);return E?E.getResourceGroup(g.groupHandle):g}else if(g&&g.$mid===5){const E=this._sourceControls.get(g.handle);return E||g}return g}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,D,T,g){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,D,T,g),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const E=Bi._handlePool++,u=new o(m,this._proxy,this._commands,D,T,g);this._sourceControls.set(E,u);const M=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(m.identifier))||[];return M.push(u),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(m.identifier),M),u}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const D=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(m.identifier)),T=D&&D[D.length-1];return T&&T.inputBox}$provideOriginalResource(m,D,T){const g=c.URI.revive(D);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,g.toString());const E=this._sourceControls.get(m);return!E||!E.quickDiffProvider||!E.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>E.quickDiffProvider.provideOriginalResource(g,T)).then(u=>u||null)}$onInputBoxValueChange(m,D){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const T=this._sourceControls.get(m);return T&&T.inputBox.$onInputBoxValueChange(D),Promise.resolve(void 0)}$executeResourceCommand(m,D,T,g){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,D,T);const E=this._sourceControls.get(m);if(!E)return Promise.resolve(void 0);const u=E.getResourceGroup(D);return u?u.$executeResourceCommand(T,g):Promise.resolve(void 0)}$validateInput(m,D,T){this.logService.trace("ExtHostSCM#$validateInput",m);const g=this._sourceControls.get(m);return!g||!g.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>g.inputBox.validateInput(D,T)).then(E=>{if(!E)return Promise.resolve(void 0);const u=s.MarkdownString.fromStrict(E.message);return u?Promise.resolve([u,E.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};b._handlePool=0,b=Ue([He(2,t.ILogService)],b),e.ExtHostSCM=b});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[202],be([0,1,7,5,126,6,8]),function(ie,e,c,F,_,A,R){"use strict";var I,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(h,s,d,v,C=c.StatusBarAlignment.Left,w){I.set(this,void 0),S.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Je(this,I,h,"f"),Je(this,S,s,"f"),this._entryId=P.ID_GEN++,this._extension=d,this._id=v,this._alignment=C,this._priority=w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!P.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Te(this,S,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Te(this,S,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,I,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let s;this._name?s=this._name:s=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const v=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,I,"f").$setEntry(this._entryId,h,s,this._text,v,this._command?.internal,d,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,I=new WeakMap,S=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const s={message:h};return this._messages.unshift(s),this._update(),new c.Disposable(()=>{const d=this._messages.indexOf(s);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class y{constructor(h,s){this._proxy=h.getProxy(F.MainContext.MainThreadStatusBar),this._commands=s,this._statusMessage=new t(this)}createStatusBarEntry(h,s,d,v){return new P(this._proxy,this._commands,h,s,d,v)}setStatusBarMessage(h,s){const d=this._statusMessage.setMessage(h);let v;return typeof s=="number"?v=setTimeout(()=>d.dispose(),s):typeof s!="undefined"&&s.then(()=>d.dispose(),()=>d.dispose()),new c.Disposable(()=>{d.dispose(),clearTimeout(v)})}}e.ExtHostStatusBar=y}),define(we[72],be([0,1,5,3,4]),function(ie,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(I){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,S){this._proxy.$registerExtensionStorageKeysToSync(I,S)}getValue(I,S,P){return this._proxy.$getValue(I,S).then(t=>t||P)}setValue(I,S,P){return this._proxy.$setValue(I,S,P)}$acceptValue(I,S,P){this._onDidChangeStorage.fire({shared:I,key:S,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(we[73],be([0,1,4,29,15,71,2]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let I=class{constructor(P,t,y){this._logService=t,this._extHostFileSystem=y,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(P){return R.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(P){if(this._value)return R.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return R.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=Ue([He(0,F.IExtHostInitDataService),He(1,_.ILogService),He(2,A.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(we[38],be([0,1,3,5,4,2,12,6,7,127,16,166,21,36,148,149,44,10]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class w{constructor(f,m,D,T){this._proxy=f,this._id=m,this._creationOptions=D,this._name=T,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(E=>this._pidPromiseComplete=E);const g=this;this.value={get name(){return g._name||""},get processId(){return g._pidPromise},get creationOptions(){return g._creationOptions},get exitStatus(){return g._exitStatus},get state(){return g._state},sendText(E,u=!0){g._checkDisposed(),g._proxy.$sendText(g._id,E,u)},show(E){g._checkDisposed(),g._proxy.$show(g._id,E)},hide(){g._checkDisposed(),g._proxy.$hide(g._id)},dispose(){g._disposed||(g._disposed=!0,g._proxy.$dispose(g._id))},get dimensions(){if(!(g._cols===void 0||g._rows===void 0))return{columns:g._cols,rows:g._rows}}}}async create(f,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:(0,C.withNullAsUndefined)(f.shellPath),shellArgs:(0,C.withNullAsUndefined)(f.shellArgs),cwd:(0,C.withNullAsUndefined)(f.cwd),env:(0,C.withNullAsUndefined)(f.env),icon:(0,C.withNullAsUndefined)(r(f.iconPath)),color:v.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:(0,C.withNullAsUndefined)(f.message),strictEnv:(0,C.withNullAsUndefined)(f.strictEnv),hideFromUser:(0,C.withNullAsUndefined)(f.hideFromUser),isFeatureTerminal:(0,C.withNullAsUndefined)(m?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,C.withNullAsUndefined)(m?.useShellEnvironment),location:m?.location||this._serializeParentTerminal(f.location,m?.resolvedExtHostIdentifier,m?.location)})}async createExtensionTerminal(f,m,D,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:D,color:v.ThemeColor.isThemeColor(T)?T.id:void 0,location:this._serializeParentTerminal(f,m)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,m,D){return typeof f=="object"&&"parentTerminal"in f?m?{parentTerminal:m}:void 0:(D&&(f=D),f)}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitCode(f){this._exitStatus=Object.freeze({code:f})}setDimensions(f,m){return f===this._cols&&m===this._rows||f===0||m===0?!1:(this._cols=f,this._rows=m,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(m=>{m!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=w;class a{constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new c.Emitter,this._onProcessTitleChanged=new c.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new c.Emitter,this._onProcessShellTypeChanged=new c.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput&&this._pty.handleInput(f)}resize(f,m){this._pty.setDimensions&&this._pty.setDimensions({columns:f,rows:m})}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(f){this._pty.onDidWrite(m=>this._onProcessData.fire(m)),this._pty.onDidClose&&this._pty.onDidClose((m=void 0)=>{this._onProcessExit.fire(m===void 0?void 0:m)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(m=>this._onProcessOverrideDimensions.fire(m&&{cols:m.columns,rows:m.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(m=>this._onProcessTitleChanged.fire(m)),this._pty.open(f||void 0),this._pty.setDimensions&&f&&this._pty.setDimensions(f),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=a;let p=1,k=class extends I.Disposable{constructor(f,m){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=m.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(f),this._register({dispose:()=>{for(const[D,T]of this._terminalProcesses)T.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,m){const D=new w(this._proxy,(0,h.generateUuid)(),f,f.name),T=new a(f.pty);return D.createExtensionTerminal(this._resolveLocation(f.location),m?.resolvedExtHostIdentifier,r(f.iconPath),o(f.color)).then(g=>{const E=this._setupExtHostProcessListeners(g,T);this._terminalProcessDisposables[g]=E}),this._terminals.push(D),D.value}_resolveLocation(f){return typeof f=="object"&&"viewColumn"in f&&f.viewColumn!==void 0?{viewColumn:f.viewColumn,preserveFocus:f.preserveFocus}:typeof f=="object"&&"parentTerminal"in f?void 0:(f===s.TerminalLocation.Editor||f===s.TerminalLocation.Panel,f)}attachPtyToTerminal(f,m){if(!this._getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const T=new a(m),g=this._setupExtHostProcessListeners(f,T);this._terminalProcessDisposables[f]=g}async $acceptActiveTerminalChanged(f){const m=this._activeTerminal;if(f===null){this._activeTerminal=void 0,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const D=this._getTerminalById(f);D&&(this._activeTerminal=D,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,m){const D=this._getTerminalById(f);D&&this._onDidWriteTerminalData.fire({terminal:D.value,data:m})}async $acceptTerminalDimensions(f,m,D){const T=this._getTerminalById(f);T&&T.setDimensions(m,D)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptTerminalMaximumDimensions(f,m,D){this._terminalProcesses.get(f)?.resize(m,D)}async $acceptTerminalTitleChange(f,m){const D=this._getTerminalById(f);D&&(D.name=m)}async $acceptTerminalClosed(f,m){const D=this._getTerminalObjectIndexById(this._terminals,f);if(D!==null){const T=this._terminals.splice(D,1)[0];T.setExitCode(m),this._onDidCloseTerminal.fire(T.value)}}$acceptTerminalOpened(f,m,D,T){if(m){const u=this._getTerminalObjectIndexById(this._terminals,m);if(u!==null){this._terminals[u]._id=f,this._onDidOpenTerminal.fire(this.terminals[u]),this._terminals[u].isOpen=!0;return}}const g={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:A.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},E=new w(this._proxy,f,g,D);this._terminals.push(E),this._onDidOpenTerminal.fire(E.value),E.isOpen=!0}async $acceptTerminalProcessId(f,m){const D=this._getTerminalById(f);D&&D._setProcessId(m)}async $startExtensionTerminal(f,m){const D=this._getTerminalById(f);if(!D)return{message:(0,P.localize)(0,null,f)};D.isOpen||await new Promise(g=>{const E=this.onDidOpenTerminal(async u=>{u===D.value&&(E.dispose(),g())})});const T=this._terminalProcesses.get(f);T?T.startSendingEvents(m):this._extensionTerminalAwaitingStart[f]={initialDimensions:m}}_setupExtHostProcessListeners(f,m){const D=new I.DisposableStore;D.add(m.onProcessReady(g=>this._proxy.$sendProcessReady(f,g.pid,g.cwd))),D.add(m.onProcessTitleChanged(g=>this._proxy.$sendProcessTitle(f,g))),this._bufferer.startBuffering(f,m.onProcessData),D.add(m.onProcessExit(g=>this._onProcessExit(f,g))),m.onProcessOverrideDimensions&&D.add(m.onProcessOverrideDimensions(g=>this._proxy.$sendOverrideDimensions(f,g))),this._terminalProcesses.set(f,m);const T=this._extensionTerminalAwaitingStart[f];return T&&m instanceof a&&(m.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),D}$acceptProcessAckDataEvent(f,m){this._terminalProcesses.get(f)?.acknowledgeDataEvent(m)}$acceptProcessInput(f,m){this._terminalProcesses.get(f)?.input(m)}$acceptTerminalInteraction(f){const m=this._getTerminalById(f);m?.setInteractedWith()&&this._onDidChangeTerminalState.fire(m.value)}$acceptProcessResize(f,m,D){try{this._terminalProcesses.get(f)?.resize(m,D)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(f,m){this._terminalProcesses.get(f)?.shutdown(m)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(m=>this._proxy.$sendProcessInitialCwd(f,m))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(m=>this._proxy.$sendProcessCwd(f,m))}$acceptProcessRequestLatency(f){return f}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,m,D){if(this._profileProviders.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this._profileProviders.set(m,D),this._proxy.$registerProfileProvider(m,f.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(m),this._proxy.$unregisterProfileProvider(m)})}async $createContributedProfileTerminal(f,m){const D=new n.CancellationTokenSource().token,T=await this._profileProviders.get(f)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,m);return}this.createTerminalFromOptions(T.options,m)}}async $provideLinks(f,m){const D=this._getTerminalById(f);if(!D)return[];this._terminalLinkCache.delete(f);const T=this._terminalLinkCancellationSource.get(f);T&&T.dispose(!0);const g=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,g);const E=[],u={terminal:D.value,line:m},M=[];for(const K of this._linkProviders)M.push(new Promise(async $=>{g.token.onCancellationRequested(()=>$({provider:K,links:[]}));const W=await K.provideTerminalLinks(u,g.token)||[];g.token.isCancellationRequested||$({provider:K,links:W})}));const O=await Promise.all(M);if(g.token.isCancellationRequested)return[];const q=new Map;for(const K of O)K&&K.links.length>0&&E.push(...K.links.map($=>{const W={id:p++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return q.set(W.id,{provider:K.provider,link:$}),W}));return this._terminalLinkCache.set(f,q),E}$activateLink(f,m){const D=this._terminalLinkCache.get(f)?.get(m);!D||D.provider.handleTerminalLink(D.link)}_onProcessExit(f,m){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const D=this._terminalProcessDisposables[f];D&&(D.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,m)}_getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}_getTerminalObjectById(f,m){const D=this._getTerminalObjectIndexById(f,m);return D!==null?f[D]:null}_getTerminalObjectIndexById(f,m){let D=null;return f.some((T,g)=>T._id===m?(D=g,!0):!1),D}getEnvironmentVariableCollection(f){let m=this._environmentVariableCollections.get(f.identifier.value);return m||(m=new i,this._setEnvironmentVariableCollection(f.identifier.value,m)),m}_syncEnvironmentVariableCollection(f,m){const D=(0,y.serializeEnvironmentVariableCollection)(m.map);this._proxy.$setEnvironmentVariableCollection(f,m.persistent,D.length===0?void 0:D)}$initEnvironmentVariableCollections(f){f.forEach(m=>{const D=m[0],T=new i(m[1]);this._setEnvironmentVariableCollection(D,T)})}$acceptDefaultProfile(f,m){this._defaultProfile=f,this._defaultAutomationProfile=m}_setEnvironmentVariableCollection(f,m){this._environmentVariableCollections.set(f,m),m.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,m)})}};k=Ue([He(1,R.IExtHostRpcService)],k),e.BaseExtHostTerminalService=k;class i{constructor(f){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(f)}get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(f,m){this._setIfDiffers(f,{value:m,type:S.EnvironmentVariableMutatorType.Replace})}append(f,m){this._setIfDiffers(f,{value:m,type:S.EnvironmentVariableMutatorType.Append})}prepend(f,m){this._setIfDiffers(f,{value:m,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(f,m){const D=this.map.get(f);(!D||D.value!==m.value||D.type!==m.type)&&(this.map.set(f,m),this._onDidChangeCollection.fire())}get(f){return this.map.get(f)}forEach(f,m){this.map.forEach((D,T)=>f.call(m,T,D,this))}delete(f){this.map.delete(f),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let l=class extends k{constructor(f){super(!1,f)}createTerminal(f,m,D){throw new t.NotSupportedError}createTerminalFromOptions(f,m){throw new t.NotSupportedError}};l=Ue([He(0,R.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l;function r(b){if(!(!b||typeof b=="string"))return"id"in b?{id:b.id,color:b.color}:b}function o(b){return v.ThemeColor.isThemeColor(b)?b:void 0}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[203],be([0,1,13,23,21,3,234,58,6,22,10,36,5,12,46,8,7,174,90,67]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C,w,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let k=class{constructor(u,M){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=u.getProxy(n.MainContext.MainThreadTesting),this.observer=new D(this.proxy),this.runTracker=new l(this.proxy),M.registerArgumentProcessor({processArgument:O=>O?.$mid===13?d.TestItem.toItemFromContext(O):O})}createTestController(u,M){if(this.controllers.has(u))throw new Error(`Attempt to insert a duplicate controller with ID "${u}"`);const O=new S.DisposableStore,q=O.add(new C.SingleUseTestCollection(u));q.root.label=M;const K=new Map,$=this.proxy,W={items:q.root.children,get label(){return M},set label(H){M=H,q.root.label=H,$.$updateControllerLabel(u,M)},get id(){return u},createRunProfile:(H,V,Y,ce,G)=>{let le=(0,I.hash)(H);for(;K.has(le);)le++;const oe=new T(this.proxy,u,le,H,V,Y,ce,G);return K.set(le,oe),oe},createTestItem(H,V,Y){return new s.TestItemImpl(u,H,V,Y)},createTestRun:(H,V,Y=!0)=>this.runTracker.createTestRun(u,q,H,V,Y),set resolveHandler(H){q.resolveHandler=H},get resolveHandler(){return q.resolveHandler},dispose:()=>{O.dispose()}};W.createRunConfiguration=W.createRunProfile,$.$registerTestController(u,M),O.add((0,S.toDisposable)(()=>$.$unregisterTestController(u)));const N={controller:W,collection:q,profiles:K};return this.controllers.set(u,N),O.add((0,S.toDisposable)(()=>this.controllers.delete(u))),O.add(q.onDidGenerateDiff(H=>$.$publishDiff(u,H))),W}createTestObserver(){return this.observer.checkout()}async runTests(u,M=_.CancellationToken.None){const O=r(u);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.controllers.get(O.controllerId);if(!q)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:u.include?.map(K=>K.id)??[q.collection.root.id],profileGroup:g[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:u.exclude?.map(K=>K.id)},M)}$provideFileCoverage(u,M,O){return(0,c.mapFind)(this.runTracker.trackers,K=>K.id===u?K.getCoverage(M):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(u,M,O,q){return(0,c.mapFind)(this.runTracker.trackers,$=>$.id===u?$.getCoverage(M):void 0)?.resolveFileCoverage(O,q)??Promise.resolve([])}$configureRunProfile(u,M){this.controllers.get(u)?.profiles.get(M)?.configureHandler?.()}$publishTestResults(u){this.results=Object.freeze(u.map(M=>(0,P.deepFreeze)(d.TestResults.to(M))).concat(this.results).sort((M,O)=>O.completedAt-M.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(u,M){const O=this.controllers.get(a.TestId.fromString(u).controllerId)?.collection;O&&(await O.expand(u,M<0?Infinity:M),O.flushDiff())}$acceptDiff(u){this.observer.applyDiff(u)}async $runControllerTests(u,M){const O=this.controllers.get(u.controllerId);if(!O)return;const{collection:q,profiles:K}=O,$=K.get(u.profileId);if(!$)return;const W=u.testIds.map(Y=>q.tree.get(Y)).filter(t.isDefined),N=u.excludeExtIds.map(Y=>O.collection.tree.get(Y)).filter(t.isDefined).filter(Y=>W.some(ce=>ce.fullId.compare(Y.fullId)===2));if(!W.length)return;const H=new v.TestRunRequest(W.some(Y=>Y.actual instanceof s.TestItemRootImpl)?void 0:W.map(Y=>Y.actual),N.map(Y=>Y.actual),$),V=this.runTracker.prepareForMainThreadTestRun(H,o.fromInternal(u,O.collection),M);try{await $.runHandler(H,M)}finally{V.isRunning&&!M.isCancellationRequested&&await A.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(u){u===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(u)}};k=Ue([He(0,h.IExtHostRpcService)],k),e.ExtHostTesting=k;class i extends S.Disposable{constructor(u,M,O){super();this.dto=u,this.proxy=M,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new _.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:q}of this.tasks.values())q.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(u){return this.tasks.get(u)?.coverage}createRun(u){const M=this.dto.id,O=this.dto.controllerId,q=(0,y.generateUuid)(),K=new b(this.proxy,M,q),$=V=>(Y,...ce)=>{if(N){console.warn(`Setting the state of test "${Y.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Y)||(this.ensureTestIsKnown(Y),V(Y,...ce))},W=(V,Y)=>{const ce=Y instanceof Array?Y.map(d.TestMessage.from):[d.TestMessage.from(Y)];if(V.uri&&V.range){const G={range:d.Range.from(V.range),uri:V.uri};for(const le of ce)le.location=le.location||G}this.proxy.$appendTestMessagesInRun(M,q,a.TestId.fromExtHostTestItem(V,O).toString(),ce)};let N=!1;const H={isPersisted:this.dto.isPersisted,token:this.cts.token,name:u,get coverageProvider(){return K.coverageProvider},set coverageProvider(V){K.coverageProvider=V},enqueued:$(V=>{this.proxy.$updateTestStateInRun(M,q,a.TestId.fromExtHostTestItem(V,O).toString(),1)}),skipped:$(V=>{this.proxy.$updateTestStateInRun(M,q,a.TestId.fromExtHostTestItem(V,O).toString(),5)}),started:$(V=>{this.proxy.$updateTestStateInRun(M,q,a.TestId.fromExtHostTestItem(V,O).toString(),2)}),errored:$((V,Y,ce)=>{W(V,Y),this.proxy.$updateTestStateInRun(M,q,a.TestId.fromExtHostTestItem(V,O).toString(),6,ce)}),failed:$((V,Y,ce)=>{W(V,Y),this.proxy.$updateTestStateInRun(M,q,a.TestId.fromExtHostTestItem(V,O).toString(),4,ce)}),passed:$((V,Y)=>{this.proxy.$updateTestStateInRun(M,q,a.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,Y)}),appendOutput:(V,Y,ce)=>{N||(ce&&(this.dto.isIncluded(ce)?this.ensureTestIsKnown(ce):ce=void 0),this.proxy.$appendOutputToRun(M,q,F.VSBuffer.fromString(V),Y&&d.location.from(Y),ce&&a.TestId.fromExtHostTestItem(ce,O).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(M,q),this.tasks.delete(q),this.isRunning||this.dispose())}};return this.tasks.set(q,{run:H,coverage:K}),this.proxy.$startedTestRunTask(M,{id:q,name:u,running:!0}),H}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(u){if(!(u instanceof s.TestItemImpl))throw new s.InvalidTestItemError(u.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(u,this.dto.controllerId).toString()))return;const M=[],O=this.dto.colllection.root;for(;;){const q=d.TestItem.from(u);if(M.unshift(q),this.sharedTestIds.has(q.extId)||(this.sharedTestIds.add(q.extId),u===O))break;u=u.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,M)}}class l{constructor(u){this.proxy=u,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(u,M,O){return this.getTracker(u,M,O)}cancelRunById(u){for(const M of this.tracked.values())if(M.id===u){M.dispose();return}}cancelAllRuns(){for(const u of this.tracked.values())u.dispose()}createTestRun(u,M,O,q,K){const $=this.tracked.get(O);if($)return $.createRun(q);const W=o.fromPublic(u,M,O,K),N=r(O);this.proxy.$startedExtensionTestRun({controllerId:u,profile:N&&{group:g[N.kind],id:N.profileId},exclude:O.exclude?.map(V=>V.id)??[],id:W.id,include:O.include?.map(V=>V.id)??[M.root.id],persist:K});const H=this.getTracker(O,W);return H.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),H.createRun(q)}getTracker(u,M,O){const q=new i(M,this.proxy,O);return this.tracked.set(u,q),q.onEnd(()=>this.tracked.delete(u)),q}}e.TestRunCoordinator=l;const r=E=>{if(!!E.profile){if(!(E.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return E.profile}};class o{constructor(u,M,O,q,K,$){this.controllerId=u,this.id=M,this.isPersisted=K,this.colllection=$,this.includePrefix=O.map(W=>W+"\0"),this.excludePrefix=q.map(W=>W+"\0")}static fromPublic(u,M,O,q){return new o(u,(0,y.generateUuid)(),O.include?.map(K=>a.TestId.fromExtHostTestItem(K,u).toString())??[u],O.exclude?.map(K=>a.TestId.fromExtHostTestItem(K,u).toString())??[],q,M)}static fromInternal(u,M){return new o(u.controllerId,u.runId,u.testIds,u.excludeExtIds,!0,M)}isIncluded(u){const M=a.TestId.fromExtHostTestItem(u,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(M===O||M.startsWith(O))return!1;for(const O of this.includePrefix)if(M===O||M.startsWith(O))return!0;return!1}}e.TestRunDto=o;class b{constructor(u,M,O){this.proxy=u,this.runId=M,this.taskId=O}set coverageProvider(u){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!u||(this._coverageProvider=u,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(u){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(u))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(M){throw this.fileCoverage=void 0,M}}async resolveFileCoverage(u,M){const O=await this.fileCoverage;let q=O?.[u];return!this._coverageProvider||!O||!q?[]:(q.detailedCoverage||(q=O[u]=await this._coverageProvider.resolveFileCoverage?.(q,M)??q),q.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class f extends w.IncrementalChangeCollector{constructor(u){super();this.emitter=u,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(u){this.added.add(u)}update(u){Object.assign(u.revived,d.TestItem.toPlain(u.item)),this.added.has(u)||this.updated.add(u)}remove(u){if(this.added.has(u)){this.added.delete(u);return}if(this.updated.delete(u),u.parent&&this.alreadyRemoved.has(u.parent)){this.alreadyRemoved.add(u.item.extId);return}this.removed.add(u)}getChangeEvent(){const{added:u,updated:M,removed:O}=this;return{get added(){return[...u].map(q=>q.revived)},get updated(){return[...M].map(q=>q.revived)},get removed(){return[...O].map(q=>q.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(u){return this.items.get(u)}getMirroredTestDataByReference(u){return this.items.get(u.id)}createItem(u,M){return{...u,revived:d.TestItem.toPlain(u.item),depth:M?M.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}e.MirroredTestCollection=m;class D{constructor(u){this.proxy=u}checkout(){this.current||(this.current=this.createObserverData());const u=this.current;return u.observers++,{onDidChangeTest:u.tests.onDidChangeTests,get tests(){return[...u.tests.rootTests].map(M=>M.revived)},dispose:(0,R.once)(()=>{--u.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(u){return this.current?.tests.getMirroredTestDataByReference(u)}applyDiff(u){this.current?.tests.apply(u)}createObserverData(){const u=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:u}}}class T{constructor(u,M,O,q,K,$,W=!1,N=void 0){this.controllerId=M,this.profileId=O,this._label=q,this.kind=K,this.runHandler=$,this._isDefault=W,this._tag=N,p.set(this,void 0),Je(this,p,u,"f");const H=g[K];if(typeof H!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Te(this,p,"f").$publishTestRunProfile({profileId:O,controllerId:M,tag:N?d.TestTag.namespace(this.controllerId,N.id):null,label:q,group:H,isDefault:W,hasConfigurationHandler:!1})}get label(){return this._label}set label(u){u!==this._label&&(this._label=u,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:u}))}get isDefault(){return this._isDefault}set isDefault(u){u!==this._isDefault&&(this._isDefault=u,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:u}))}get tag(){return this._tag}set tag(u){u?.id!==this._tag?.id&&(this._tag=u,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:u?d.TestTag.namespace(this.controllerId,u.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(u){u!==this._configureHandler&&(this._configureHandler=u,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!u}))}dispose(){Te(this,p,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=T,p=new WeakMap;const g={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(we[204],be([0,1,3,13,5,94,8,7]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(t,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new c.Emitter,this._onDidChangeTextEditorOptions=new c.Emitter,this._onDidChangeTextEditorVisibleRanges=new c.Emitter,this._onDidChangeTextEditorViewColumn=new c.Emitter,this._onDidChangeActiveTextEditor=new c.Emitter,this._onDidChangeVisibleTextEditors=new c.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const y=this._extHostDocumentsAndEditors.allEditors();return t?y:y.map(n=>n.value)}async showTextDocument(t,y,n){let h;typeof y=="number"?h={position:R.ViewColumn.from(y),preserveFocus:n}:typeof y=="object"?h={position:R.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?R.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:h={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(t.uri,h),d=s&&this._extHostDocumentsAndEditors.getEditor(s);if(d)return d.value;throw s?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,y){return new A.TextEditorDecorationType(this._proxy,t,y).value}$acceptEditorPropertiesChanged(t,y){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(y.options&&n._acceptOptions(y.options),y.selections){const h=y.selections.selections.map(R.Selection.to);n._acceptSelections(h)}if(y.visibleRanges){const h=F.coalesce(y.visibleRanges.map(R.Range.to));n._acceptVisibleRanges(h)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...y.options,lineNumbers:R.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const h=I.TextEditorSelectionChangeKind.fromValue(y.selections.source),s=y.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:s,kind:h})}if(y.visibleRanges){const h=F.coalesce(y.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:h})}}$acceptEditorPositionData(t){for(const y in t){const n=this._extHostDocumentsAndEditors.getEditor(y);if(!n)throw new Error("Unknown text editor");const h=R.ViewColumn.to(t[y]);n.value.viewColumn!==h&&(n._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:h}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=S}),define(we[205],be([0,1,2,4,5,6,7]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class I{constructor(t,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const h=n.uri===void 0?void 0:c.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(S(h))?.get(n.handle)}return n}})}async $getTimeline(t,y,n,h,s){return this._providers.get(t)?.provideTimeline(c.URI.revive(y),n,h,s)}registerTimelineProvider(t,y,n,h){const s=new A.DisposableStore,d=this.convertTimelineItem(y.id,h,s).bind(this);let v;y.onDidChange&&(v=y.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:y.id}),this));const C=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:t,onDidChange:void 0,async provideTimeline(w,a,p,k){k?.resetCache&&(s.clear(),C.get(y.id)?.clear());const i=await y.provideTimeline(w,a,p);if(i==null)return;const l=d(w,k);return{...i,source:y.id,items:i.items.map(l)}},dispose(){for(const w of C.values())w.get(y.id)?.clear();v?.dispose(),s.dispose()}})}convertTimelineItem(t,y,n){return(h,s)=>{let d;if(s?.cacheResults){let v=this._itemsBySourceAndUriMap.get(t);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(t,v));const C=S(h);d=v.get(C),d===void 0&&(d=new Map,v.set(C,d))}return v=>{const{iconPath:C,...w}=v,a=`${t}|${v.id??v.timestamp}`;d?.set(a,v);let p,k,i;return v.iconPath&&(C instanceof R.ThemeIcon?i={id:C.id,color:C.color}:c.URI.isUri(C)?(p=C,k=C):{light:p,dark:k}=C),{...w,id:w.id??void 0,handle:a,source:t,command:v.command?y.toInternal(v.command,n):void 0,icon:p,iconDark:k,themeIcon:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=I;function S(P){return P?.toString()}}),define(we[206],be([0,1,6,11,2,5]),function(ie,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,P,t,y){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const n=y.schemes.find(h=>!R.supportedSchemes.has(h));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,y.schemes,S,y.label),(0,c.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(S,P,t){const y=this._openers.get(S);if(!y)throw new Error(`Unknown opener with id: ${S}`);const n=_.URI.revive(P);return y.canOpenExternalUri(n,t)}async $openUri(S,P,t){const y=this._openers.get(S);if(!y)throw new Error(`Unknown opener id: '${S}'`);return y.openExternalUri(_.URI.revive(P.resolvedUri),{sourceUri:_.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(we[207],be([0,1,5,2,6,16,25]),function(ie,e,c,F,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(R.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const y=I.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(P)),this.handlers.set(y,t),this._proxy.$registerUriHandler(y,P),(0,_.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(P)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(P,t){const y=this.handlers.get(P);if(!y)return Promise.resolve(void 0);try{y.handleUri(F.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(P){return F.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=I,I.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[50],be([0,1,3,2,137,157,66,5]),function(ie,e,c,F,_,A,R,I){"use strict";var S,P,t,y,n,h,s,d,v,C,w,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class p{constructor(m,D,T,g,E,u,M){S.set(this,void 0),P.set(this,void 0),t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),h.set(this,void 0),s.set(this,""),d.set(this,void 0),v.set(this,!1),C.set(this,!1),w.set(this,!1),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new c.Emitter),this._onDidDispose=Te(this,a,"f").event,Je(this,S,m,"f"),Je(this,P,D,"f"),Je(this,d,T,"f"),Je(this,y,g,"f"),Je(this,n,E,"f"),Je(this,h,u,"f"),Je(this,w,k(u),"f"),Je(this,t,M,"f")}dispose(){Je(this,v,!0,"f"),Te(this,a,"f").fire(),Te(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return Je(this,C,!0,"f"),(0,R.asWebviewUri)(m,Te(this,y,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,s,"f")}set html(m){this.assertNotDisposed(),Te(this,s,"f")!==m&&(Je(this,s,m,"f"),!Te(this,C,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(Je(this,C,!0,"f"),Te(this,t,"f").report("Webview vscode-resource: uris",Te(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,P,"f").$setHtml(Te(this,S,"f"),m))}get options(){return this.assertNotDisposed(),Te(this,d,"f")}set options(m){this.assertNotDisposed(),Te(this,P,"f").$setOptions(Te(this,S,"f"),r(Te(this,h,"f"),Te(this,n,"f"),m)),Je(this,d,m,"f")}async postMessage(m){if(Te(this,v,"f"))return!1;const D=(0,A.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Te(this,w,"f")});return Te(this,P,"f").$postMessage(Te(this,S,"f"),D.message,...D.buffers)}assertNotDisposed(){if(Te(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,S=new WeakMap,P=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,h=new WeakMap,s=new WeakMap,d=new WeakMap,v=new WeakMap,C=new WeakMap,w=new WeakMap,a=new WeakMap;function k(f){try{const m=(0,_.normalizeVersion)((0,_.parseVersion)(f.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=k;class i{constructor(m,D,T,g,E){this.initData=D,this.workspace=T,this._logService=g,this._deprecationService=E,this._webviews=new Map,this._webviewProxy=m.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(m,D,...T){const g=this.getWebview(m);if(g){const{message:E}=(0,A.deserializeWebviewMessage)(D,T);g._onMessageEmitter.fire(E)}}$onMissingCsp(m,D){this._logService.warn(`${D} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,D,T){const g=new p(m,this._webviewProxy,o(D),this.initData,this.workspace,T,this._deprecationService);return this._webviews.set(m,g),g._onDidDispose(()=>{this._webviews.delete(m)}),g}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=i;function l(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=l;function r(f,m,D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,enableForms:D.enableForms,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots||b(f,m)}}e.serializeWebviewOptions=r;function o(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(m=>F.URI.from(m))}}e.reviveOptions=o;function b(f,m){return[...(m?.getWorkspaceFolders()||[]).map(D=>D.uri),f.extensionLocation]}}),define(we[208],be([0,1,21,58,6,11,24,2,8,50,63,5,7]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(i,l){this.document=i,this._storagePath=l,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,l){await this.getEdit(i).undo(),l||this.disposeBackup()}async redo(i,l){await this.getEdit(i).redo(),l||this.disposeBackup()}disposeEdits(i){for(const l of i)this._edits.delete(l)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=p(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const l=this._edits.get(i,0);if(!l)throw new Error("No edit found");return l}}class s{constructor(){this._documents=new Map}get(i,l){return this._documents.get(this.key(i,l))}add(i,l,r){const o=this.key(i,l.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${i} resource:${l.uri}`);const b=new h(l,r);return this._documents.set(o,b),b}delete(i,l){const r=this.key(i,l.uri);this._documents.delete(r)}key(i,l){return`${i}@@@${l}`}}var d;(function(k){k[k.Text=0]="Text",k[k.Custom=1]="Custom"})(d||(d={}));class v{constructor(){this._providers=new Map}addTextProvider(i,l,r){return this.add(0,i,l,r)}addCustomProvider(i,l,r){return this.add(1,i,l,r)}get(i){return this._providers.get(i)}add(i,l,r,o){if(this._providers.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this._providers.set(l,{type:i,extension:r,provider:o}),new n.Disposable(()=>this._providers.delete(l))}}class C{constructor(i,l,r,o,b){this._extHostDocuments=l,this._extensionStoragePaths=r,this._extHostWebview=o,this._extHostWebviewPanels=b,this._editorProviders=new v,this._documents=new s,this._proxy=i.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,l,r,o){const b=new _.DisposableStore;return w(r)?(b.add(this._editorProviders.addTextProvider(l,i,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),l,o.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(b.add(this._editorProviders.addCustomProvider(l,i,r)),this.supportEditing(r)&&b.add(r.onDidChangeCustomDocument(f=>{const m=this.getCustomDocumentEntry(l,f.document.uri);if(a(f)){const D=m.addEdit(f);this._proxy.$onDidEdit(f.document.uri,l,D,f.label)}else this._proxy.$onContentChange(f.document.uri,l)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),l,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(b,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(l)}))}async $createCustomDocument(i,l,r,o,b){const f=this._editorProviders.get(l);if(!f)throw new Error(`No provider found for '${l}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${l}'`);const m=I.URI.revive(i),D=await f.provider.openCustomDocument(m,{backupId:r,untitledDocumentData:o?.buffer},b);let T;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(l,D,T),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(i,l){const r=this._editorProviders.get(l);if(!r)throw new Error(`No provider found for '${l}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${l}'`);const o=I.URI.revive(i),{document:b}=this.getCustomDocumentEntry(l,o);this._documents.delete(l,b),b.dispose()}async $resolveWebviewEditor(i,l,r,o,b,f){const m=this._editorProviders.get(r);if(!m)throw new Error(`No provider found for '${r}'`);const D=S.ViewColumn.to(b),T=this._extHostWebview.createNewWebview(l,o.webviewOptions,m.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(l,r,o.title,D,o.panelOptions,T),E=I.URI.revive(i);switch(m.type){case 1:{const{document:u}=this.getCustomDocumentEntry(r,E);return m.provider.resolveCustomEditor(u,g,f)}case 0:{const u=this._extHostDocuments.getDocument(E);return m.provider.resolveCustomTextEditor(u,g,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,l,r){this.getCustomDocumentEntry(l,i).disposeEdits(r)}async $onMoveCustomEditor(i,l,r){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const b=this._extHostWebviewPanels.getWebviewPanel(i);if(!b)throw new Error("No webview found");const f=I.URI.revive(l),m=this._extHostDocuments.getDocument(f);await o.provider.moveCustomTextEditor(m,b,c.CancellationToken.None)}async $undo(i,l,r,o){return this.getCustomDocumentEntry(l,i).undo(r,o)}async $redo(i,l,r,o){return this.getCustomDocumentEntry(l,i).redo(r,o)}async $revert(i,l,r){const o=this.getCustomDocumentEntry(l,i);await this.getCustomEditorProvider(l).revertCustomDocument(o.document,r),o.disposeBackup()}async $onSave(i,l,r){const o=this.getCustomDocumentEntry(l,i);await this.getCustomEditorProvider(l).saveCustomDocument(o.document,r),o.disposeBackup()}async $onSaveAs(i,l,r,o){const b=this.getCustomDocumentEntry(l,i);return this.getCustomEditorProvider(l).saveCustomDocumentAs(b.document,I.URI.revive(r),o)}async $backup(i,l,r){const o=this.getCustomDocumentEntry(l,i),f=await this.getCustomEditorProvider(l).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},r);return o.updateBackup(f),f.id}getCustomDocumentEntry(i,l){const r=this._documents.get(i,I.URI.revive(l));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=C;function w(k){return typeof k.resolveCustomTextEditor=="function"}function a(k){return typeof k.undo=="function"&&typeof k.redo=="function"}function p(k){const i=k.scheme===A.Schemas.file||k.scheme===A.Schemas.untitled?k.fsPath:k.toString();return(0,F.hash)(i)+""}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[209],be([0,1,3,6,2,36,8,50,5,7]),function(ie,e,c,F,_,A,R,I,S,P){"use strict";var t,y,n,h,s,d,v,C,w,a,p,k,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends F.Disposable{constructor(f,m,D,T,g,E,u){super();t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),h.set(this,void 0),s.set(this,void 0),d.set(this,void 0),v.set(this,void 0),C.set(this,void 0),w.set(this,!0),a.set(this,!0),p.set(this,!1),k.set(this,this._register(new c.Emitter)),this.onDidDispose=Te(this,k,"f").event,i.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Te(this,i,"f").event,Je(this,t,f,"f"),Je(this,y,m,"f"),Je(this,n,D,"f"),Je(this,s,E,"f"),Je(this,C,g,"f"),Je(this,d,T,"f"),Je(this,h,u,"f")}dispose(){Te(this,p,"f")||(Je(this,p,!0,"f"),Te(this,k,"f").fire(),Te(this,y,"f").$disposeWebview(Te(this,t,"f")),Te(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,h,"f")}get viewType(){return this.assertNotDisposed(),Te(this,n,"f")}get title(){return this.assertNotDisposed(),Te(this,d,"f")}set title(f){this.assertNotDisposed(),Te(this,d,"f")!==f&&(Je(this,d,f,"f"),Te(this,y,"f").$setTitle(Te(this,t,"f"),f))}get iconPath(){return this.assertNotDisposed(),Te(this,v,"f")}set iconPath(f){this.assertNotDisposed(),Te(this,v,"f")!==f&&(Je(this,v,f,"f"),Te(this,y,"f").$setIconPath(Te(this,t,"f"),_.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Te(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,C,"f")=="number"&&Te(this,C,"f")<0))return Te(this,C,"f")}get active(){return this.assertNotDisposed(),Te(this,a,"f")}get visible(){return this.assertNotDisposed(),Te(this,w,"f")}_updateViewState(f){Te(this,p,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Je(this,a,f.active,"f"),Je(this,w,f.visible,"f"),Je(this,C,f.viewColumn,"f"),Te(this,i,"f").fire({webviewPanel:this}))}reveal(f,m){this.assertNotDisposed(),Te(this,y,"f").$reveal(Te(this,t,"f"),{viewColumn:f?R.ViewColumn.from(f):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Te(this,p,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,y=new WeakMap,n=new WeakMap,h=new WeakMap,s=new WeakMap,d=new WeakMap,v=new WeakMap,C=new WeakMap,w=new WeakMap,a=new WeakMap,p=new WeakMap,k=new WeakMap,i=new WeakMap;class r{constructor(f,m,D){this.webviews=m,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(f,m,D,T,g={}){const E=typeof T=="object"?T.viewColumn:T,u={viewColumn:R.ViewColumn.from(E),preserveFocus:typeof T=="object"&&!!T.preserveFocus},M=(0,I.shouldSerializeBuffersForPostMessage)(f),O=r.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(f),O,m,{title:D,panelOptions:o(g),webviewOptions:(0,I.serializeWebviewOptions)(f,this.workspace,g),serializeBuffersForPostMessage:M},u);const q=this.webviews.createNewWebview(O,g,f);return this.createNewWebviewPanel(O,m,D,E,g,q)}$onDidChangeWebviewPanelViewStates(f){const m=Object.keys(f);m.sort((D,T)=>{const g=f[D],E=f[T];return g.active?1:E.active?-1:+g.visible-+E.visible});for(const D of m){const T=this.getWebviewPanel(D);if(!T)continue;const g=f[D];T._updateViewState({active:g.active,visible:g.visible,viewColumn:R.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,m,D){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:D,extension:f}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(f)}),new P.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(f,m,D,T){const g=this._serializers.get(m);if(!g)throw new Error(`No serializer found for '${m}'`);const{serializer:E,extension:u}=g,M=this.webviews.createNewWebview(f,D.webviewOptions,u),O=this.createNewWebviewPanel(f,m,D.title,T,D.panelOptions,M);await E.deserializeWebviewPanel(O,D.state)}createNewWebviewPanel(f,m,D,T,g,E){const u=new l(f,this._proxy,m,D,T,g,E);return this._webviewPanels.set(f,u),u}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=r;function o(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[210],be([0,1,3,6,50,5,7]),function(ie,e,c,F,_,A,R){"use strict";var I,S,P,t,y,n,h,s,d,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class C extends F.Disposable{constructor(p,k,i,l,r,o){super();I.set(this,void 0),S.set(this,void 0),P.set(this,void 0),t.set(this,void 0),y.set(this,!1),n.set(this,void 0),h.set(this,void 0),s.set(this,void 0),d.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Te(this,d,"f").event,v.set(this,this._register(new c.Emitter)),this.onDidDispose=Te(this,v,"f").event,Je(this,P,i,"f"),Je(this,h,l,"f"),Je(this,I,p,"f"),Je(this,S,k,"f"),Je(this,t,r,"f"),Je(this,n,o,"f")}dispose(){Te(this,y,"f")||(Je(this,y,!0,"f"),Te(this,v,"f").fire(),Te(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,h,"f")}set title(p){this.assertNotDisposed(),Te(this,h,"f")!==p&&(Je(this,h,p,"f"),Te(this,S,"f").$setWebviewViewTitle(Te(this,I,"f"),p))}get description(){return this.assertNotDisposed(),Te(this,s,"f")}set description(p){this.assertNotDisposed(),Te(this,s,"f")!==p&&(Je(this,s,p,"f"),Te(this,S,"f").$setWebviewViewDescription(Te(this,I,"f"),p))}get visible(){return Te(this,n,"f")}get webview(){return Te(this,t,"f")}get viewType(){return Te(this,P,"f")}_setVisible(p){p===Te(this,n,"f")||Te(this,y,"f")||(Je(this,n,p,"f"),Te(this,d,"f").fire())}show(p){this.assertNotDisposed(),Te(this,S,"f").$show(Te(this,I,"f"),!!p)}assertNotDisposed(){if(Te(this,y,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,S=new WeakMap,P=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,h=new WeakMap,s=new WeakMap,d=new WeakMap,v=new WeakMap;class w{constructor(p,k){this._extHostWebview=k,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,k,i,l){if(this._viewProviders.has(k))throw new Error(`View provider for '${k}' already registered`);return this._viewProviders.set(k,{provider:i,extension:p}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(p),k,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(k),this._proxy.$unregisterWebviewViewProvider(k)})}async $resolveWebviewView(p,k,i,l,r){const o=this._viewProviders.get(k);if(!o)throw new Error(`No view provider found for '${k}'`);const{provider:b,extension:f}=o,m=this._extHostWebview.createNewWebview(p,{},f),D=new C(p,this._proxy,k,i,m,!0);this._webviewViews.set(p,D),await b.resolveWebviewView(D,{state:l},r)}async $onDidChangeWebviewViewVisibility(p,k){this.getWebviewView(p)._setVisible(k)}async $disposeWebviewView(p){const k=this.getWebviewView(p);this._webviewViews.delete(p),k.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const k=this._webviewViews.get(p);if(!k)throw new Error("No webview found");return k}}e.ExtHostWebviewViews=w}),define(we[97],be([0,1,3,5,2,11,9,4,12]),function(ie,e,c,F,_,A,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Ui{constructor(y){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=y.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,n){let h;if(typeof y=="string"){h=y;try{y=_.URI.parse(y)}catch(s){return Promise.reject(`Invalid uri - '${y}'`)}}return(0,R.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,h,n)}async asExternalUri(y,n){if((0,R.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(y,n);return _.URI.from(h)}};P.InitialState={focused:!0},P=Ue([He(0,S.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(we[211],be([0,1,15,5,29,12]),function(ie,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends c.AbstractLogger{constructor(S,P){super();this._proxy=S.getProxy(F.MainContext.MainThreadLog),this._logFile=P.logFile.toJSON(),this.setLevel(P.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...P){this.getLevel()<=c.LogLevel.Trace&&this._proxy.$log(this._logFile,c.LogLevel.Trace,Array.from(arguments))}debug(S,...P){this.getLevel()<=c.LogLevel.Debug&&this._proxy.$log(this._logFile,c.LogLevel.Debug,Array.from(arguments))}info(S,...P){this.getLevel()<=c.LogLevel.Info&&this._proxy.$log(this._logFile,c.LogLevel.Info,Array.from(arguments))}warn(S,...P){this.getLevel()<=c.LogLevel.Warning&&this._proxy.$log(this._logFile,c.LogLevel.Warning,Array.from(arguments))}error(S,...P){this.getLevel()<=c.LogLevel.Error&&this._proxy.$log(this._logFile,c.LogLevel.Error,Array.from(arguments))}critical(S,...P){this.getLevel()<=c.LogLevel.Critical&&this._proxy.$log(this._logFile,c.LogLevel.Critical,Array.from(arguments))}flush(){}};R=Ue([He(0,A.IExtHostRpcService),He(1,_.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(we[212],be([0,1,14,23,21,16,3,6,108,179,47]),function(ie,e,c,F,_,A,R,I,S,P,t){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(g,E){try{return JSON.stringify(g,E)}catch(u){return"null"}}const h="$$ref$$",s={[h]:-1};class d{constructor(E,u){this.jsonString=E,this.referencedBuffers=u}}function v(g,E=null,u=!1){const M=[];return{jsonString:(u?n:JSON.stringify)(g,(q,K)=>{if(typeof K=="undefined")return s;if(typeof K=="object"){if(K instanceof F.VSBuffer){const $=M.push(K)-1;return{[h]:$}}if(E)return E(q,K)}return K}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=v;function C(g,E,u){return JSON.parse(g,(M,O)=>{if(O){const q=O[h];if(typeof q=="number")return E[q];if(u&&O.$mid===1)return u.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=C;function w(g,E){return JSON.stringify(g,E)}function a(g){return g?(E,u)=>u&&u.$mid===1?g.transformOutgoing(u):u:null}var p;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var k;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(k=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},l=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class o extends I.Disposable{constructor(E,u=null,M=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=E,this._logger=u,this._uriTransformer=M,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,q=t.ProxyIdentifier.count;O<q;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(E=>{this._pendingRPCReplies[E].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(E){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(E){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(E){this._responsiveState!==E&&(this._responsiveState=E,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(E){return this._uriTransformer?(0,S.transformIncomingURIs)(E,this._uriTransformer):E}getProxy(E){const{nid:u,sid:M}=E;return this._proxies[u]||(this._proxies[u]=this._createProxy(u,M)),this._proxies[u]}_createProxy(E,u){let M={get:(O,q)=>(typeof q=="string"&&!O[q]&&q.charCodeAt(0)===36&&(O[q]=(...K)=>this._remoteCall(E,q,K)),q===r?u:O[q])};return new Proxy(Object.create(null),M)}set(E,u){return this._locals[E.nid]=u,u}assertRegistered(E){for(let u=0,M=E.length;u<M;u++){const O=E[u];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(E){if(this._isDisposed)return;const u=E.byteLength,M=b.read(E,0),O=M.readUInt8(),q=M.readUInt32();switch(O){case 1:case 2:{let{rpcId:K,method:$,args:W}=m.deserializeRequestJSONArgs(M);this._uriTransformer&&(W=(0,S.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(u,q,K,$,W,O===2);break}case 3:case 4:{let{rpcId:K,method:$,args:W}=m.deserializeRequestMixedArgs(M);this._uriTransformer&&(W=(0,S.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(u,q,K,$,W,O===4);break}case 5:{this._logger&&this._logger.logIncoming(u,q,0,"ack"),this._onDidReceiveAcknowledge(q);break}case 6:{this._receiveCancel(u,q);break}case 7:{this._receiveReply(u,q,void 0);break}case 9:{let K=m.deserializeReplyOKJSON(M);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReply(u,q,K);break}case 10:{const K=m.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(u,q,K);break}case 8:{let K=m.deserializeReplyOKVSBuffer(M);this._receiveReply(u,q,K);break}case 11:{let K=m.deserializeReplyErrError(M);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReplyErr(u,q,K);break}case 12:{this._receiveReplyErr(u,q,void 0);break}default:console.error("received unexpected message"),console.error(E)}}_receiveRequest(E,u,M,O,q,K){this._logger&&this._logger.logIncoming(E,u,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(M)}.${O}(`,q);const $=String(u);let W,N;if(K){const V=new _.CancellationTokenSource;q.push(V.token),W=this._invokeHandler(M,O,q),N=()=>V.cancel()}else W=this._invokeHandler(M,O,q),N=i;this._cancelInvokedHandlers[$]=N;const H=m.serializeAcknowledged(u);this._logger&&this._logger.logOutgoing(H.byteLength,u,1,"ack"),this._protocol.send(H),W.then(V=>{delete this._cancelInvokedHandlers[$];const Y=m.serializeReplyOK(u,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(Y.byteLength,u,1,"reply:",V),this._protocol.send(Y)},V=>{delete this._cancelInvokedHandlers[$];const Y=m.serializeReplyErr(u,V);this._logger&&this._logger.logOutgoing(Y.byteLength,u,1,"replyErr:",V),this._protocol.send(Y)})}_receiveCancel(E,u){this._logger&&this._logger.logIncoming(E,u,1,"receiveCancel");const M=String(u);this._cancelInvokedHandlers[M]&&this._cancelInvokedHandlers[M]()}_receiveReply(E,u,M){this._logger&&this._logger.logIncoming(E,u,0,"receiveReply:",M);const O=String(u);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const q=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],q.resolveOk(M)}_receiveReplyErr(E,u,M){this._logger&&this._logger.logIncoming(E,u,0,"receiveReplyErr:",M);const O=String(u);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const q=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let K;M&&(M.$isError?(K=new Error,K.name=M.name,K.message=M.message,K.stack=M.stack):K=M),q.resolveErr(K)}_invokeHandler(E,u,M){try{return Promise.resolve(this._doInvokeHandler(E,u,M))}catch(O){return Promise.reject(O)}}_doInvokeHandler(E,u,M){const O=this._locals[E];if(!O)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(E));let q=O[u];if(typeof q!="function")throw new Error("Unknown method "+u+" on actor "+(0,t.getStringIdentifierForProxy)(E));return q.apply(O,M)}_remoteCall(E,u,M){if(this._isDisposed)return Promise.reject(A.canceled());let O=null;if(M.length>0&&_.CancellationToken.isCancellationToken(M[M.length-1])&&(O=M.pop()),O&&O.isCancellationRequested)return Promise.reject(A.canceled());const q=m.serializeRequestArguments(M,this._uriReplacer),K=++this._lastMessageId,$=String(K),W=new P.LazyPromise;O&&O.onCancellationRequested(()=>{const H=m.serializeCancel(K);this._logger&&this._logger.logOutgoing(H.byteLength,K,0,"cancel"),this._protocol.send(m.serializeCancel(K))}),this._pendingRPCReplies[$]=W,this._onWillSendRequest(K);const N=m.serializeRequest(K,E,u,q,!!O);return this._logger&&this._logger.logOutgoing(N.byteLength,K,0,`request: ${(0,t.getStringIdentifierForProxy)(E)}.${u}(`,M),this._protocol.send(N),W}}e.RPCProtocol=o,y=l,o.UNRESPONSIVE_TIME=3*1e3;class b{constructor(E,u){this._buff=E,this._offset=u}static alloc(E,u,M){let O=new b(F.VSBuffer.alloc(M+1+4),0);return O.writeUInt8(E),O.writeUInt32(u),O}static read(E,u){return new b(E,u)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(E){this._buff.writeUInt8(E,this._offset),this._offset+=1}readUInt8(){const E=this._buff.readUInt8(this._offset);return this._offset+=1,E}writeUInt32(E){this._buff.writeUInt32BE(E,this._offset),this._offset+=4}readUInt32(){const E=this._buff.readUInt32BE(this._offset);return this._offset+=4,E}static sizeShortString(E){return 1+E.byteLength}writeShortString(E){this._buff.writeUInt8(E.byteLength,this._offset),this._offset+=1,this._buff.set(E,this._offset),this._offset+=E.byteLength}readShortString(){const E=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+E).toString();return this._offset+=E,M}static sizeLongString(E){return 4+E.byteLength}writeLongString(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}readLongString(){const E=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+E).toString();return this._offset+=E,M}writeBuffer(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}static sizeVSBuffer(E){return 4+E.byteLength}writeVSBuffer(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}readVSBuffer(){const E=this._buff.readUInt32BE(this._offset);this._offset+=4;const u=this._buff.slice(this._offset,this._offset+E);return this._offset+=E,u}static sizeMixedArray(E){let u=0;u+=1;for(let M=0,O=E.length;M<O;M++){const q=E[M];switch(u+=1,q.type){case 1:u+=this.sizeLongString(q.value);break;case 2:u+=this.sizeVSBuffer(q.value);break;case 3:u+=this.sizeUInt8(),u+=this.sizeLongString(q.value);for(let K=0;K<q.buffers.length;++K)u+=this.sizeVSBuffer(q.buffers[K]);break;case 4:break}}return u}writeMixedArray(E){this._buff.writeUInt8(E.length,this._offset),this._offset+=1;for(let u=0,M=E.length;u<M;u++){const O=E[u];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt8(O.buffers.length),this.writeLongString(O.value);for(let q=0;q<O.buffers.length;++q)this.writeBuffer(O.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const E=this._buff.readUInt8(this._offset);this._offset+=1;let u=new Array(E);for(let M=0;M<E;M++)switch(this.readUInt8()){case 1:u[M]=this.readLongString();break;case 2:u[M]=this.readVSBuffer();break;case 3:const q=this.readUInt8(),K=this.readLongString(),$=[];for(let W=0;W<q;++W)$.push(this.readVSBuffer());u[M]=new t.SerializableObjectWithBuffers(C(K,$,null));break;case 4:u[M]=void 0;break}return u}}var f;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(f||(f={}));class m{static _useMixedArgSerialization(E){for(let u=0,M=E.length;u<M;u++)if(E[u]instanceof F.VSBuffer||E[u]instanceof t.SerializableObjectWithBuffers||typeof E[u]=="undefined")return!0;return!1}static serializeRequestArguments(E,u){if(this._useMixedArgSerialization(E)){const M=[];for(let O=0,q=E.length;O<q;O++){const K=E[O];if(K instanceof F.VSBuffer)M[O]={type:2,value:K};else if(typeof K=="undefined")M[O]={type:4};else if(K instanceof t.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:W}=v(K.value,u);M[O]={type:3,value:F.VSBuffer.fromString($),buffers:W}}else M[O]={type:1,value:F.VSBuffer.fromString(w(K,u))}}return{type:1,args:M}}return{type:0,args:w(E,u)}}static serializeRequest(E,u,M,O,q){switch(O.type){case 0:return this._requestJSONArgs(E,u,M,O.args,q);case 1:return this._requestMixedArgs(E,u,M,O.args,q)}}static _requestJSONArgs(E,u,M,O,q){const K=F.VSBuffer.fromString(M),$=F.VSBuffer.fromString(O);let W=0;W+=b.sizeUInt8(),W+=b.sizeShortString(K),W+=b.sizeLongString($);let N=b.alloc(q?2:1,E,W);return N.writeUInt8(u),N.writeShortString(K),N.writeLongString($),N.buffer}static deserializeRequestJSONArgs(E){const u=E.readUInt8(),M=E.readShortString(),O=E.readLongString();return{rpcId:u,method:M,args:JSON.parse(O)}}static _requestMixedArgs(E,u,M,O,q){const K=F.VSBuffer.fromString(M);let $=0;$+=b.sizeUInt8(),$+=b.sizeShortString(K),$+=b.sizeMixedArray(O);let W=b.alloc(q?4:3,E,$);return W.writeUInt8(u),W.writeShortString(K),W.writeMixedArray(O),W.buffer}static deserializeRequestMixedArgs(E){const u=E.readUInt8(),M=E.readShortString(),O=E.readMixedArray(),q=new Array(O.length);for(let K=0,$=O.length;K<$;K++){const W=O[K];typeof W=="string"?q[K]=JSON.parse(W):q[K]=W}return{rpcId:u,method:M,args:q}}static serializeAcknowledged(E){return b.alloc(5,E,0).buffer}static serializeCancel(E){return b.alloc(6,E,0).buffer}static serializeReplyOK(E,u,M){if(typeof u=="undefined")return this._serializeReplyOKEmpty(E);if(u instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(E,u);if(u instanceof t.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:q}=v(u.value,M,!0);return this._serializeReplyOKJSONWithBuffers(E,O,q)}else return this._serializeReplyOKJSON(E,n(u,M))}static _serializeReplyOKEmpty(E){return b.alloc(7,E,0).buffer}static _serializeReplyOKVSBuffer(E,u){let M=0;M+=b.sizeVSBuffer(u);let O=b.alloc(8,E,M);return O.writeVSBuffer(u),O.buffer}static deserializeReplyOKVSBuffer(E){return E.readVSBuffer()}static _serializeReplyOKJSON(E,u){const M=F.VSBuffer.fromString(u);let O=0;O+=b.sizeLongString(M);let q=b.alloc(9,E,O);return q.writeLongString(M),q.buffer}static _serializeReplyOKJSONWithBuffers(E,u,M){const O=F.VSBuffer.fromString(u);let q=0;q+=b.sizeUInt8(),q+=b.sizeLongString(O);for(const $ of M)q+=b.sizeVSBuffer($);let K=b.alloc(10,E,q);K.writeUInt8(M.length),K.writeLongString(O);for(const $ of M)K.writeBuffer($);return K.buffer}static deserializeReplyOKJSON(E){const u=E.readLongString();return JSON.parse(u)}static deserializeReplyOKJSONWithBuffers(E,u){const M=E.readUInt8(),O=E.readLongString(),q=[];for(let K=0;K<M;++K)q.push(E.readVSBuffer());return new t.SerializableObjectWithBuffers(C(O,q,u))}static serializeReplyErr(E,u){return u?this._serializeReplyErrEror(E,u):this._serializeReplyErrEmpty(E)}static _serializeReplyErrEror(E,u){const M=F.VSBuffer.fromString(n(A.transformErrorForSerialization(u),null));let O=0;O+=b.sizeLongString(M);let q=b.alloc(11,E,O);return q.writeLongString(M),q.buffer}static deserializeReplyErrError(E){const u=E.readLongString();return JSON.parse(u)}static _serializeReplyErrEmpty(E){return b.alloc(12,E,0).buffer}}var D;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(D||(D={}));var T;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(T||(T={}))}),define(we[213],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const c=function(A){const R=I=>{self.removeEventListener("message",R);const S=I.data;Object.defineProperties(self,{postMessage:{value(P,t){S.postMessage(P,t)}},onmessage:{get(){return S.onmessage},set(P){S.onmessage=P}}}),S.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",R)}.toString();class F extends EventTarget{constructor(A,R,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${c})('${R}'))`,P=new Blob([S],{type:"application/javascript"}),t=URL.createObjectURL(P),y=new MessageChannel,n=t,h={type:"_newWorker",id:n,port:y.port2,url:t,options:I};A(h,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:n};y.port1.postMessage(s),URL.revokeObjectURL(t),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(s){y.port1.onmessage=s}},onmessageerror:{get(){return y.port1.onmessageerror},set(s){y.port1.onmessageerror=s}}}),y.port1.addEventListener("messageerror",s=>{const d=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(d)}),y.port1.addEventListener("message",s=>{const d=new MessageEvent("message",{data:s.data});this.dispatchEvent(d)}),y.port1.start()}}e.NestedWorker=F}),define(we[214],be([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(we[215],be([0,1,11,17,26,2,4,86,45,175,214]),function(ie,e,c,F,_,A,R,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let y=class $i{constructor(h,s,d,v){this.localUserHome=h,this.remoteAgentService=s,this.environmentService=d,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||_.OS)(),this.resolveUserHome=(async()=>{const C=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=C?.userHome||h})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,s){if(h.remoteAuthority)return c.Schemas.vscodeRemote;const d=(0,I.getVirtualWorkspaceScheme)(s.getWorkspace());if(d)return d;const v=s.getWorkspace().folders[0];if(v)return v.uri.scheme;const C=s.getWorkspace().configuration;return C?C.scheme:c.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?F.win32:F.posix)}async fileURI(h){let s="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const v=h.indexOf("/",2);v===-1?(s=h.substring(2),h="/"):(s=h.substring(2,v),h=h.substring(v)||"/")}return A.URI.from({scheme:c.Schemas.file,authority:s,path:h,query:"",fragment:""})}};y=Ue([He(1,t.IRemoteAgentService),He(2,P.IWorkbenchEnvironmentService),He(3,S.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(we[98],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(R,I){this.line=R,this.character=I}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,I){return new c(0,0)}with(R){return new c(0,0)}}e.Position=c;class F{constructor(R,I,S,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(R,I),this.end=new c(S,P)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.Range=F;var _;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[39],be([0,1,13,27,22,41,9,4,17,16,98,10]),function(ie,e,c,F,_,A,R,I,S,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",h=" characters skipped \u27EB",s=(n.length+h.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var d;(function(H){H[H.file=0]="file",H[H.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(H){H[H.File=1]="File",H[H.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function C(H){return!!H.preview}e.resultIsMatch=C;function w(H){return!!H.resource}e.isFileMatch=w;function a(H){return!!H.message}e.isProgressMessage=a;var p;(function(H){H[H.Normal=0]="Normal",H[H.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class k{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=k;class i{constructor(V,Y,ce){this.ranges=Y;const G=Array.isArray(Y)?Y:[Y];if(ce&&ce.matchLines===1&&l(G)){V=(0,R.getNLines)(V,ce.matchLines);let le="",oe=0,Ee=0;const Fe=Math.floor(ce.charsPerLine/5),Me=[];for(const Ne of G){const Qe=Math.max(Ne.startColumn-Fe,0),ze=Ne.startColumn+ce.charsPerLine;if(Qe>Ee+Fe+s){const qe=n+(Qe-Ee)+h;le+=qe+V.slice(Qe,ze),oe+=Qe-(Ee+qe.length)}else le+=V.slice(Ee,ze);Me.push(new o(0,Ne.startColumn-oe,Ne.endColumn-oe)),Ee=ze}this.preview={text:le,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const le=Array.isArray(Y)?Y[0].startLineNumber:Y.startLineNumber;this.preview={text:V,matches:(0,c.mapArrayOrNot)(Y,oe=>new r(oe.startLineNumber-le,oe.startColumn,oe.endLineNumber-le,oe.endColumn))}}}}e.TextSearchMatch=i;function l(H){const V=H[0].startLineNumber;for(const Y of H)if(Y.startLineNumber!==V||Y.endLineNumber!==V)return!1;return!0}class r{constructor(V,Y,ce,G){this.startLineNumber=V,this.startColumn=Y,this.endLineNumber=ce,this.endColumn=G}}e.SearchRange=r;class o extends r{constructor(V,Y,ce){super(V,Y,V,ce)}}e.OneLineRange=o;var b;(function(H){H.Default="default",H.FileNames="fileNames",H.Type="type",H.Modified="modified",H.CountDescending="countDescending",H.CountAscending="countAscending"})(b=e.SearchSortOrder||(e.SearchSortOrder={}));function f(H,V=!0){const Y=H&&H.files&&H.files.exclude,ce=V&&H&&H.search&&H.search.exclude;if(!Y&&!ce)return;if(!Y||!ce)return Y||ce;let G=Object.create(null);return G=_.mixin(G,_.deepClone(Y)),G=_.mixin(G,_.deepClone(ce),!0),G}e.getExcludes=f;function m(H,V){return H.excludePattern&&F.match(H.excludePattern,V)?!1:H.includePattern||H.usingSearchPaths?H.includePattern&&F.match(H.includePattern,V)?!0:H.usingSearchPaths?!!H.folderQueries&&H.folderQueries.some(Y=>{const ce=Y.folder.fsPath;if(A.isEqualOrParent(V,ce)){const G=S.relative(ce,V);return!Y.includePattern||!!F.match(Y.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var D;(function(H){H[H.unknownEncoding=1]="unknownEncoding",H[H.regexParseError=2]="regexParseError",H[H.globParseError=3]="globParseError",H[H.invalidLiteral=4]="invalidLiteral",H[H.rgProcessError=5]="rgProcessError",H[H.other=6]="other",H[H.canceled=7]="canceled"})(D=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(V,Y){super(V);this.code=Y}}e.SearchError=T;function g(H){const V=H.message;if((0,P.isPromiseCanceledError)(H))return new T(V,D.canceled);try{const Y=JSON.parse(V);return new T(Y.message,Y.code)}catch(Y){return new T(V,D.other)}}e.deserializeSearchError=g;function E(H){const V={message:H.message,code:H.code};return new Error(JSON.stringify(V))}e.serializeSearchError=E;function u(H){return H.type==="error"?!0:H.type==="success"}e.isSerializedSearchComplete=u;function M(H){return H.type==="success"}e.isSerializedSearchSuccess=M;function O(H){return!!H.path}e.isSerializedFileMatch=O;function q(H,V){const Y=H.searchPath?H.searchPath:H.relativePath;return(0,R.fuzzyContains)(Y,V)}e.isFilePatternMatch=q;class K{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function $(H,V){const Y={...H||{},...V||{}};return Object.keys(Y).filter(ce=>{const G=Y[ce];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=$;class W{constructor(V,Y){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...Y.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let ce=V.includePattern;Y.includePattern&&(ce?ce={...ce,...Y.includePattern}:ce=Y.includePattern),ce&&(this._parsedIncludeExpression=F.parse(ce))}includedInQuerySync(V,Y,ce){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,Y,ce)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,Y,ce))}includedInQuery(V,Y,ce){const G=this._parsedExcludeExpression(V,Y,ce),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(V,Y,ce):!0;return(0,y.isPromise)(G)?G.then(oe=>oe?!1:le()):le()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=W;function N(H){for(const V in H)if(typeof H[V]!="boolean")return!0;return!1}}),define(we[31],be([0,1,13,14,21,3,20,11,75,24,9,10,2,129,4,15,144,45,37,29,12,7,39,5]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C,w,a,p,k,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(E,u,M){return new P.ExtUri(O=>m(O,M)).isEqual(E,u)}function o(E,u,M){return r(E.uri,u.uri,M)?0:(0,t.compare)(E.uri.toString(),u.uri.toString())}function b(E,u,M){return E.index!==u.index?E.index<u.index?-1:1:r(E.uri,u.uri,M)?(0,t.compare)(E.name,u.name):(0,t.compare)(E.uri.toString(),u.uri.toString())}function f(E,u,M,O){const q=E.slice(0).sort(($,W)=>M($,W,O)),K=u.slice(0).sort(($,W)=>M($,W,O));return(0,c.delta)(q,K,($,W)=>M($,W,O))}function m(E,u){const M=u.getCapabilities(E.scheme);return!(M&&M&1024)}class D extends C.Workspace{constructor(u,M,O,q,K,$){super(u,O.map(W=>new C.WorkspaceFolder(W)),q,$);this._name=M,this._isUntitled=K,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris($),O.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(u,M,O,q){if(!u)return{workspace:null,added:[],removed:[]};const{id:K,name:$,folders:W,configuration:N,isUntitled:H}=u,V=[],Y=M;M?W.forEach((oe,Ee)=>{const Fe=n.URI.revive(oe.uri),Me=D._findFolder(O||M,Fe,q);Me?(Me.name=oe.name,Me.index=oe.index,V.push(Me)):V.push({uri:Fe,name:oe.name,index:Ee})}):V.push(...W.map(({uri:oe,name:Ee,index:Fe})=>({uri:n.URI.revive(oe),name:Ee,index:Fe}))),V.sort((oe,Ee)=>oe.index<Ee.index?-1:1);const ce=new D(K,$,V,N?n.URI.revive(N):null,!!H,oe=>m(oe,q)),{added:G,removed:le}=f(Y?Y.workspaceFolders:[],ce.workspaceFolders,o,q);return{workspace:ce,added:G,removed:le}}static _findFolder(u,M,O){for(let q=0;q<u.folders.length;q++){const K=u.workspaceFolders[q];if(r(K.uri,M,O))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(u,M){return M&&this._structure.get(u)&&(u=(0,P.dirname)(u)),this._structure.findSubstr(u)}resolveWorkspaceFolder(u){return this._structure.get(u)}}let T=class{constructor(u,M,O,q){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=q,this._extHostFileSystemInfo=O,this._requestIdProvider=new S.Counter,this._barrier=new F.Barrier,this._proxy=u.getProxy(l.MainContext.MainThreadWorkspace),this._messageService=u.getProxy(l.MainContext.MainThreadMessageService);const K=M.workspace;this._confirmedWorkspace=K?new D(K.id,K.name,[],K.configuration?n.URI.revive(K.configuration):null,!!K.isUntitled,$=>m($,O)):void 0}$initializeWorkspace(u,M){this._trusted=M,this.$acceptWorkspaceData(u),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:I.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(u,M,O,...q){const K=[];if(Array.isArray(q)&&q.forEach(V=>{n.URI.isUri(V.uri)&&!K.some(Y=>r(Y.uri,V.uri,this._extHostFileSystemInfo))&&K.push({uri:V.uri,name:V.name||(0,P.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[M,O].some(V=>typeof V!="number"||V<0)||O===0&&K.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+O>$.length)return!1;const W=$.slice(0);W.splice(M,O,...K.map(V=>({uri:V.uri,name:V.name||(0,P.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<W.length;V++){const Y=W[V];if(W.some((ce,G)=>G!==V&&r(Y.uri,ce.uri,this._extHostFileSystemInfo)))return!1}W.forEach((V,Y)=>V.index=Y);const{added:N,removed:H}=f($,W,b,this._extHostFileSystemInfo);if(N.length===0&&H.length===0)return!1;if(this._proxy){const V=u.displayName||u.name;this._proxy.$updateWorkspaceFolders(V,M,O,K).then(void 0,Y=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,h.localize)(0,null,V,Y.toString()),{extension:u},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(u,M){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(u,M)}async getWorkspaceFolder2(u,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(u,M)}async resolveWorkspaceFolder(u){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(u)}getPath(){if(!this._actualWorkspace)return;const{folders:u}=this._actualWorkspace;if(u.length!==0)return u[0].uri.fsPath}getRelativePath(u,M){let O,q="";if(typeof u=="string"?(O=n.URI.file(u),q=u):typeof u!="undefined"&&(O=u,q=u.fsPath),!O)return q;const K=this.getWorkspaceFolder(O,!0);if(!K)return q;typeof M=="undefined"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let $=(0,P.relativePath)(K.uri,O);return M&&K.name&&($=`${K.name}/${$}`),$}trySetWorkspaceFolders(u){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:u,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(u){const{workspace:M,added:O,removed:q}=D.toExtHostWorkspace(u,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:q}))}findFiles(u,M,O,q,K=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let $;if(M===null?$=!1:M&&(typeof M=="string"?$=M:$=M.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:N}=g(u);return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(W),(0,y.withUndefinedAsNull)(N),(0,y.withUndefinedAsNull)($),(0,y.withUndefinedAsNull)(O),K).then(H=>Array.isArray(H)?H.map(V=>n.URI.revive(V)):[])}async findTextInFiles(u,M,O,q,K=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),W=typeof M.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:N,folder:H}=g(M.include),V=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,Y={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:W,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:N,excludePattern:V},ce=!1;if(this._activeSearchCallbacks[$]=G=>{if(ce)return;const le=n.URI.revive(G.resource);G.results.forEach(oe=>{(0,i.resultIsMatch)(oe)?O({uri:le,preview:{text:oe.preview.text,matches:(0,c.mapArrayOrNot)(oe.preview.matches,Ee=>new k.Range(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))},ranges:(0,c.mapArrayOrNot)(oe.ranges,Ee=>new k.Range(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))}):O({uri:le,text:oe.text,lineNumber:oe.lineNumber})})},K.isCancellationRequested)return{};try{const G=await this._proxy.$startTextSearch(u,(0,y.withUndefinedAsNull)(H),Y,$,K);return delete this._activeSearchCallbacks[$],G||{}}catch(G){throw delete this._activeSearchCallbacks[$],G}}$handleTextSearchResult(u,M){this._activeSearchCallbacks[M]&&this._activeSearchCallbacks[M](u)}saveAll(u){return this._proxy.$saveAll(u)}resolveProxy(u){return this._proxy.$resolveProxy(u)}get trusted(){return this._trusted}requestWorkspaceTrust(u){return this._proxy.$requestWorkspaceTrust(u)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};T=Ue([He(0,p.IExtHostRpcService),He(1,a.IExtHostInitDataService),He(2,w.IExtHostFileSystemInfo),He(3,d.ILogService)],T),e.ExtHostWorkspace=T,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function g(E){let u,M;return E&&(typeof E=="string"?u=E:(u=E.pattern,M=E.baseFolder||n.URI.file(E.base))),{includePattern:u,folder:M}}}),define(we[32],be([0,1,22,3,31,5,7,147,62,10,14,4,12,15,2]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(l,r){if(r){const o=r.split(".");let b=l;for(let f=0;b&&f<o.length;f++)b=b[o[f]];return b}}function v(l){return l instanceof s.URI}function C(l){return l&&l.uri instanceof s.URI&&l.languageId&&typeof l.languageId=="string"}function w(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function a(l){return l&&l.uri instanceof s.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function p(l){if(v(l))return{resource:l};if(C(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(w(l))return{overrideIdentifier:l.languageId};if(a(l))return{resource:l.uri};if(l===null)return{resource:null}}let k=class{constructor(r,o,b){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=b,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,o){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(r,o))}};k=Ue([He(0,n.IExtHostRpcService),He(1,_.IExtHostWorkspace),He(2,h.ILogService)],k),e.ExtHostConfiguration=k;class i{constructor(r,o,b,f){this._onDidChangeConfiguration=new F.Emitter,this._proxy=r,this._logService=f,this._extHostWorkspace=o,this._configuration=I.Configuration.parse(b),this._configurationScopes=this._toMap(b.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,o){const b={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,b))}getConfiguration(r,o,b){const f=p(o)||{},m=this._toReadonlyValue(r?d(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,f,b?.identifier);function D(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const T={has(g){return typeof d(m,g)!="undefined"},get:(g,E)=>{this._validateConfigurationAccess(r?`${r}.${g}`:g,f,b?.identifier);let u=d(m,g);if(typeof u=="undefined")u=E;else{let M;const O=(q,K)=>{let $;const W=()=>{M=M||(0,c.deepClone)(m),$=$||d(M,K)};return(0,P.isObject)(q)?new Proxy(q,{get:(N,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return W(),()=>$;if(M)return $=$||d(M,K),$[H];const V=N[H];return typeof H=="string"?O(V,`${K}.${H}`):V},set:(N,H,V)=>(W(),$&&($[H]=V),!0),deleteProperty:(N,H)=>(W(),$&&delete $[H],!0),defineProperty:(N,H,V)=>(W(),$&&Object.defineProperty($,H,V),!0)}):q};u=O(u,g)}return u},update:(g,E,u,M)=>{g=r?`${r}.${g}`:g;const O=D(u);return E!==void 0?this._proxy.$updateConfigurationOption(O,g,E,f,M):this._proxy.$removeConfigurationOption(O,g,f,M)},inspect:g=>{g=r?`${r}.${g}`:g;const E=(0,c.deepClone)(this._configuration.inspect(g,f,this._extHostWorkspace.workspace));if(E)return{key:g,defaultValue:E.default?.value,globalValue:E.user?.value,workspaceValue:E.workspace?.value,workspaceFolderValue:E.workspaceFolder?.value,defaultLanguageValue:E.default?.override,globalLanguageValue:E.user?.override,workspaceLanguageValue:E.workspace?.override,workspaceFolderLanguageValue:E.workspaceFolder?.override,languageIds:E.overrideIdentifiers}}};return typeof m=="object"&&(0,c.mixin)(T,m,!1),Object.freeze(T)}_toReadonlyValue(r){const o=b=>(0,P.isObject)(b)?new Proxy(b,{get:(f,m)=>o(f[m]),set:(f,m,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(f,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(f,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return o(r)}_validateConfigurationAccess(r,o,b){const f=S.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),m=b?`[${b.value}] `:"";if(f===4){typeof o?.resource=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){o?.resource&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,o){const b=new I.ConfigurationChangeEvent(r,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,m)=>b.affectsConfiguration(f,p(m))})}_toMap(r){return r.reduce((o,b)=>(o.set(b[0],b[1]),o),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[99],be([0,1,2,14,3,5,7,31,49,32,21,38,12,29,4,11,26,15,70,165,16]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C,w,a,p){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(K){function $(N){if(N!=null)return N}K.from=$;function W(N){if(N!=null)return N}K.to=W})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var l;(function(K){function $(N){if(N!=null)return N}K.from=$;function W(N){if(N!=null)return N}K.to=W})(l=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(K){function $(N){if(N!=null)return N}K.from=$;function W(N){if(N!=null)return N}K.to=W})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(K){function $(H){if(H){const V=H;return V&&!!V.process}else return!1}K.is=$;function W(H){if(H==null)return;const V={process:H.process,args:H.args};return H.options&&(V.options=r.from(H.options)),V}K.from=W;function N(H){if(H!=null)return new R.ProcessExecution(H.process,H.args,H.options)}K.to=N})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var b;(function(K){function $(N){if(N!=null)return N}K.from=$;function W(N){if(N!=null)return N}K.to=W})(b=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(K){function $(H){if(H){const V=H;return V&&(!!V.commandLine||!!V.command)}else return!1}K.is=$;function W(H){if(H==null)return;const V={};return H.commandLine!==void 0?V.commandLine=H.commandLine:(V.command=H.command,V.args=H.args),H.options&&(V.options=b.from(H.options)),V}K.from=W;function N(H){if(!(H==null||H.command===void 0&&H.commandLine===void 0))return H.commandLine?new R.ShellExecution(H.commandLine,H.options):new R.ShellExecution(H.command,H.args?H.args:[],H.options)}K.to=N})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(K){function $(H){if(H){let V=H;return V&&V.customExecution==="customExecution"}else return!1}K.is=$;function W(H){return{customExecution:"customExecution"}}K.from=W;function N(H,V){return V.get(H)}K.to=N})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var D;(function(K){function $(W,N){let H;return W.scope!==void 0&&typeof W.scope!="number"?H=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?H=N.workspaceFile:H=a.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:H}}K.from=$})(D=e.TaskHandleDTO||(e.TaskHandleDTO={}));var T;(function(K){function $(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}K.from=$})(T=e.TaskGroupDTO||(e.TaskGroupDTO={}));var g;(function(K){function $(H,V){if(H==null)return[];const Y=[];for(let ce of H){const G=W(ce,V);G&&Y.push(G)}return Y}K.fromMany=$;function W(H,V){if(H==null)return;let Y;H.execution instanceof R.ProcessExecution?Y=o.from(H.execution):H.execution instanceof R.ShellExecution?Y=f.from(H.execution):H.execution&&H.execution instanceof R.CustomExecution&&(Y=m.from(H.execution));const ce=i.from(H.definition);let G;return H.scope?typeof H.scope=="number"?G=H.scope:G=H.scope.uri:G=R.TaskScope.Workspace,!ce||!G?void 0:{_id:H._id,definition:ce,name:H.name,source:{extensionId:V.identifier.value,label:H.source,scope:G},execution:Y,isBackground:H.isBackground,group:T.from(H.group),presentationOptions:l.from(H.presentationOptions),problemMatchers:H.problemMatchers,hasDefinedMatchers:H.hasDefinedMatchers,runOptions:H.runOptions?H.runOptions:{reevaluateOnRerun:!0},detail:H.detail}}K.from=W;async function N(H,V,Y){if(H==null)return;let ce;o.is(H.execution)?ce=o.to(H.execution):f.is(H.execution)?ce=f.to(H.execution):m.is(H.execution)&&(ce=m.to(H._id,Y));const G=i.to(H.definition);let le;if(H.source&&(H.source.scope!==void 0?typeof H.source.scope=="number"?le=H.source.scope:le=await V.resolveWorkspaceFolder(c.URI.revive(H.source.scope)):le=R.TaskScope.Workspace),!G||!le)return;const oe=new R.Task(G,le,H.name,H.source.label,ce,H.problemMatchers);return H.isBackground!==void 0&&(oe.isBackground=H.isBackground),H.group!==void 0&&(oe.group=R.TaskGroup.from(H.group._id),oe.group&&(oe.group=new R.TaskGroup(oe.group.id,oe.group.label),H.group.isDefault&&(oe.group.isDefault=H.group.isDefault))),H.presentationOptions&&(oe.presentationOptions=l.to(H.presentationOptions)),H._id&&(oe._id=H._id),H.detail&&(oe.detail=H.detail),oe}K.to=N})(g=e.TaskDTO||(e.TaskDTO={}));var E;(function(K){function $(N){return N}K.from=$;function W(N){if(!!N)return Object.assign(Object.create(null),N)}K.to=W})(E=e.TaskFilterDTO||(e.TaskFilterDTO={}));class u{constructor($,W,N){this._id=W,this._task=N,k.set(this,void 0),Je(this,k,$,"f")}get task(){return this._task}terminate(){Te(this,k,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}k=new WeakMap;var M;(function(K){function $(W){return{id:W._id,task:void 0}}K.from=$})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor($,W,N,H,V,Y,ce,G){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=$.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=H,this._configurationService=V,this._terminalService=Y,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ce,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,W,N){if(!N)return new R.Disposable(()=>{});const H=this.nextHandle();return this._handlers.set(H,{type:W,provider:N,extension:$}),this._proxy.$registerTaskProvider(H,W),new R.Disposable(()=>{this._handlers.delete(H),this._proxy.$unregisterTaskProvider(H)})}registerTaskSystem($,W){this._proxy.$registerTaskSystem($,W)}fetchTasks($){return this._proxy.$fetchTasks(E.from($)).then(async W=>{const N=[];for(let H of W){const V=await g.to(H,this._workspaceProvider,this._providedCustomExecutions2);V&&N.push(V)}return N})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(W=>$.push(W)),$}terminateTask($){if(!($ instanceof u))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,W,N){const H=this._providedCustomExecutions2.get($.id);if(H){if(this._activeCustomExecutions2.get($.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set($.id,H),this._terminalService.attachPtyToTerminal(W,await H.callback(N))}this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){const W=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const W=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:W,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const W=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:$.exitCode})}$provideTasks($,W){const N=this._handlers.get($);if(!N)return Promise.reject(new Error("no handler found"));const H=[],V=(0,F.asPromise)(()=>N.provider.provideTasks(t.CancellationToken.None)).then(Y=>this.provideTasksInternal(W,H,N,Y));return new Promise(Y=>{V.then(ce=>{Promise.all(H).then(()=>{Y(ce)})})})}async $resolveTask($,W){const N=this._handlers.get($);if(!N)return Promise.reject(new Error("no handler found"));if(W.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${N.type}].`);const H=await g.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!H)throw new Error("Unexpected: Task cannot be resolved.");const V=await N.provider.resolveTask(H,t.CancellationToken.None);if(!V)return;this.checkDeprecation(V,N);const Y=g.from(V,N.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==H.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(Y.execution)&&await this.addCustomExecution(Y,V,!0),await this.resolveTaskInternal(Y)}nextHandle(){return this._handleCounter++}async addCustomExecution($,W,N){const H=await this._proxy.$createTaskId($);!N&&!this._providedCustomExecutions2.has(H)&&this._notProvidedCustomExecutions.add(H),this._providedCustomExecutions2.set(H,W.execution)}async getTaskExecution($,W){if(typeof $=="string"){const V=this._taskExecutionPromises.get($);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let N=this._taskExecutionPromises.get($.id);if(N)return N;const H=new Promise(async(V,Y)=>{const ce=W||await g.to($.task,this._workspaceProvider,this._providedCustomExecutions2);ce?V(new u(this,$.id,ce)):Y("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set($.id,H),H.then(V=>(this._taskExecutions.set($.id,V),V),V=>Promise.reject(V))}checkDeprecation($,W){$._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));let N=this._notProvidedCustomExecutions.values(),H=N.next();for(;!H.done;)!this._activeCustomExecutions2.has(H.value)&&this._lastStartedTask!==H.value&&(this._providedCustomExecutions2.delete(H.value),this._notProvidedCustomExecutions.delete(H.value)),H=N.next()}};O=Ue([He(0,n.IExtHostRpcService),He(1,h.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,C.ILogService),He(7,w.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let q=class extends O{constructor($,W,N,H,V,Y,ce,G){super($,W,N,H,V,Y,ce,G);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask($,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const N=g.from(W,$);if(N===void 0)throw new Error("Task is not valid");if(m.is(N.execution))await this.addCustomExecution(N,W,!1);else throw new p.NotSupportedError;const H=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),W);return this._proxy.$executeTask(N).catch(V=>{throw new Error(V)}),H}provideTasksInternal($,W,N,H){const V=[];if(H)for(let Y of H){this.checkDeprecation(Y,N),(!Y.definition||!$[Y.definition.type])&&this._logService.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const ce=g.from(Y,N.extension);ce&&m.is(ce.execution)?(V.push(ce),W.push(this.addCustomExecution(ce,Y,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:N.extension}}async resolveTaskInternal($){if(m.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,W,N){}};q=Ue([He(0,n.IExtHostRpcService),He(1,h.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,C.ILogService),He(7,w.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(we[216],be([0,1,13,51,27,77,20,11,17,24,9,10,2,110,133,84,45,92,215,39]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(D,T,g,E){this.configurationService=D,this.workspaceContextService=T,this.editorGroupsService=g,this.pathService=E}text(D,T,g={}){D=this.getContentPattern(D,g);const E=this.configurationService.getValue(),u=T&&T.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(T?.map(v.toWorkspaceFolder),g),type:2,contentPattern:D,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:E.search.usePCRE2||u||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles}}getContentPattern(D,T){const g=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const E={...D,wordSeparators:g.editor.wordSeparators};return this.isCaseSensitive(D,T)&&(E.isCaseSensitive=!0),this.isMultiline(D)&&(E.isMultiline=!0),E}file(D,T={}){return{...this.commonQuery(D,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(D,T){return D?(D=Array.isArray(D)?D.map(o):o(D),T?this.parseSearchPaths(D):{pattern:i(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],T={}){const g=this.handleIncludeExclude(T.includePattern,T.expandPatterns),E=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),u=D.length>1,M=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,T,E)):D.map(K=>this.getFolderQueryForRoot(K,T,E,u))).filter(K=>!!K),O={_reason:T._reason,folderQueries:M,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:E.pattern,includePattern:g.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const $=c.coalesce(c.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(H=>H.resource)))).filter(N=>(0,a.pathIncludedInQuery)(O,N.fsPath)),W=this.commonQueryFromFileList($);return{...O,...W}}const q=T.extraFileResources&&T.extraFileResources.filter(K=>(0,a.pathIncludedInQuery)(O,K.fsPath));return O.extraFileResources=q&&q.length?q:void 0,O}commonQueryFromFileList(D){const T=[],g=new R.ResourceMap,E={};let u=!1;return D.forEach(M=>{if(M.scheme===I.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(M)){const q=this.workspaceContextService.getWorkspaceFolder(M)?.uri??M.with({path:S.dirname(M.fsPath)});let K=g.get(q);K||(u=!0,K={folder:q,includePattern:{}},T.push(K),g.set(q,K));const $=S.relative(q.fsPath,M.fsPath);(0,y.assertIsDefined)(K.includePattern)[$.replace(/\\/g,"/")]=!0}else M.fsPath&&(u=!0,E[M.fsPath]=!0)}),{folderQueries:T,includePattern:E,usingSearchPaths:!0,excludePattern:u?void 0:{"**/*":!0}}}isCaseSensitive(D,T){if(T.isSmartCase){if(D.isRegExp){if(t.containsUppercaseCharacter(D.pattern,!0))return!0}else if(t.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,h.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const T=W=>S.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),E=(Array.isArray(D)?D:l(D)).map(W=>{const N=this.pathService.resolvedUserHome;return N?(0,A.untildify)(W,N.scheme===I.Schemas.file?N.fsPath:N.path):W}),u=F.groupBy(E,W=>T(W)?"searchPaths":"exprSegments"),M=(u.exprSegments||[]).map(W=>t.rtrim(W,"/")).map(W=>t.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),r(W))),O={},q=this.expandSearchPathPatterns(u.searchPaths||[]);q&&q.length&&(O.searchPaths=q);const K=c.flatten(M),$=i(...K);return $&&(O.pattern=$),O}getExcludesForFolder(D,T){return T.disregardExcludeSettings?void 0:(0,a.getExcludes)(D,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const T=c.flatten(D.map(E=>{let{pathPortion:u,globPortion:M}=k(E);M&&(M=b(M));const O=this.expandOneSearchPath(u);return c.flatten(O.map(q=>this.resolveOneSearchPathPattern(q,M)))})),g=new Map;return T.forEach(E=>{const u=E.searchPath.toString(),M=g.get(u);M?E.pattern&&(M.pattern=M.pattern||{},M.pattern[E.pattern]=!0):g.set(u,{searchPath:E.searchPath,pattern:E.pattern?i(E.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(D){if(S.isAbsolute(D)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==I.Schemas.file?[{searchPath:T[0].uri.with({path:D})}]:[{searchPath:n.URI.file(S.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=o(D),D.startsWith("../")||D===".."){const E=S.posix.resolve(T.path,D);return[{searchPath:T.with({path:E})}]}const g=b(D);return[{searchPath:T,pattern:g}]}else{if(D==="./"||D===".\\")return[];{const T=D.replace(/^\.[\/\\]/,""),E=this.workspaceContextService.getWorkspace().folders.map(u=>{const M=T.match(new RegExp(`^${t.escapeRegExpCharacters(u.name)}(?:/(.*)|$)`));return M?{match:M,folder:u}:null}).filter(y.isDefined);if(E.length)return E.map(u=>{const M=u.match[1];return{searchPath:u.folder.uri,pattern:M&&b(M)}});{const u=D.match(/\.[\/\\](.+)[\/\\]?/),M=u?u[1]:D,O=s.localize(0,null,M);throw new Error(O)}}}}resolveOneSearchPathPattern(D,T){const g=D.pattern&&T?`${D.pattern}/${T}`:D.pattern||T,E=[{searchPath:D.searchPath,pattern:g}];return g&&!g.endsWith("**")&&E.push({searchPath:D.searchPath,pattern:g+"/**"}),E}getFolderQueryForSearchPath(D,T,g){const E=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(D.searchPath),T,g,!1);return E?{...E,includePattern:D.pattern}:null}getFolderQueryForRoot(D,T,g,E){let u;const M=n.URI.isUri(D)?D:D.uri;if(g.searchPaths){const W=g.searchPaths.filter(N=>(0,P.isEqual)(N.searchPath,M))[0];if(W&&!W.pattern)return null;W&&(u=W.pattern)}const O=this.configurationService.getValue({resource:M}),K={...this.getExcludesForFolder(O,T)||{},...u||{}},$=n.URI.isUri(D)?(0,P.basename)(D):D.name;return{folder:M,folderName:E?$:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!O.search.followSymlinks}}};p=Ue([He(0,d.IConfigurationService),He(1,v.IWorkspaceContextService),He(2,C.IEditorGroupsService),He(3,w.IPathService)],p),e.QueryBuilder=p;function k(m){const D=m.match(/[\*\{\}\(\)\[\]\?]/);if(D){const T=D.index,g=m.substr(0,T).match(/[/|\\][^/\\]*$/);if(g){let E=m.substr(0,g.index);return E.match(/[/\\]/)||(E+="/"),{pathPortion:E,globPortion:m.substr((g.index||0)+1)}}}return{pathPortion:m}}function i(...m){return m.length?m.reduce((D,T)=>(D[T]=!0,D),Object.create(null)):void 0}function l(m){return _.splitGlobAware(m,",").map(D=>D.trim()).filter(D=>!!D.length)}function r(m){return[`**/${m}/**`,`**/${m}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function o(m){return m.replace(/\\/g,"/")}function b(m){return o(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(m,D){m=c.distinct(m,E=>E.toString());const T=[],g=D.getWorkspace();return m&&m.forEach(E=>{let u;if(D.getWorkbenchState()===2)u=(0,P.relativePath)(g.folders[0].uri,E),u&&u!=="."&&(u="./"+u);else{const M=D.getWorkspaceFolder(E);if(M){const O=M.name;if(g.folders.filter(K=>K.name===O).length===1){const K=(0,P.relativePath)(M.uri,E);K===""?u=`./${M.name}`:u=`./${M.name}/${K}`}else u=E.fsPath}}u&&T.push(u)}),T}e.resolveResourcesForSearchIncludes=f}),define(we[217],be([0,1,24,2,21,16,4,216,39,45]),function(ie,e,c,F,_,A,R,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function y(d,v){const C=v.activationEvents;if(!C)return Promise.resolve(void 0);const w=[],a=[];for(const o of C)if(/^workspaceContains:/.test(o)){const b=o.substr("workspaceContains:".length);b.indexOf("*")>=0||b.indexOf("?")>=0||d.forceUsingSearch?a.push(b):w.push(b)}if(w.length===0&&a.length===0)return Promise.resolve(void 0);let p;const k=new Promise((o,b)=>{p=o}),i=o=>p({activationEvent:o}),l=Promise.all(w.map(o=>n(d,o,i))).then(()=>{}),r=h(d,v.identifier,a,i);return Promise.all([l,r]).then(()=>{p(void 0)}),k}e.checkActivateWorkspaceContainsExtension=y;async function n(d,v,C){for(const w of d.folders)if(await d.exists(c.joinPath(F.URI.revive(w),v))){C(`workspaceContains:${v}`);return}}async function h(d,v,C,w){if(C.length===0)return Promise.resolve(void 0);const a=new _.CancellationTokenSource,p=d.checkExists(d.folders,C,a.token),k=setTimeout(async()=>{a.cancel(),w(`workspaceContainsTimeout:${C.join(",")}`)},t);let i=!1;try{i=await p}catch(l){A.isPromiseCanceledError(l)||A.onUnexpectedError(l)}a.dispose(),clearTimeout(k),i&&w(`workspaceContains:${C.join(",")}`)}function s(d,v,C,w){const a=d.get(R.IInstantiationService),p=d.get(S.ISearchService),i=a.createInstance(I.QueryBuilder).file(v.map(l=>(0,P.toWorkspaceFolder)(F.URI.revive(l))),{_reason:"checkExists",includePattern:C,exists:!0});return p.fileSearch(i,w).then(l=>!!l.limitHit,l=>A.isPromiseCanceledError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=s});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[33],be([0,1,124,17,74,24,14,6,20,2,15,5,32,178,72,31,30,176,16,25,23,152,7,85,4,29,73,12,61,64,38,3,217,69,154]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C,w,a,p,k,i,l,r,o,b,f,m,D,T,g,E,u,M){"use strict";var O,q,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let $=class Wi extends I.Disposable{constructor(V,Y,ce,G,le,oe,Ee,Fe,Me,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=ce,this._initData=Ee,this._extHostWorkspace=G,this._extHostConfiguration=le,this._logService=oe,this._extHostTunnelService=Me,this._extHostTerminalService=Ne,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new C.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new u.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=V.createChild(new m.ServiceCollection([s.IExtHostStorage,this._storage],[u.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(ze=>Qe.add(a.ExtensionIdentifier.toKey(ze))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,qe,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,w.transformErrorForSerialization(qe),B)},actualActivateExtension:async(ze,qe)=>{if(Qe.has(a.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,qe),new h.HostExtension;const B=this._registry.getExtensionDescription(ze);return this._activateExtension(B,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){w.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch(Y){}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,Y){return this._activator.activateByEvent(V,Y)}_activateById(V,Y){return this._activator.activateById(V,Y)}activateByIdWithErrors(V,Y){return this._activateById(V,Y).then(()=>{const ce=this._activator.getActivatedExtension(V);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const V=S.TernarySearchTree.forPaths(),Y=this._registry.getAllExtensionDescriptions().map(ce=>{if(!!this._getEntryPoint(ce))return this._hostUtils.realpath(ce.extensionLocation.fsPath).then(G=>V.set(P.URI.file(G).fsPath,ce))});this._extensionPathIndex=Promise.all(Y).then(()=>V)}return this._extensionPathIndex}_deactivate(V){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return Y;const ce=this._activator.getActivatedExtension(V);if(!ce)return Y;try{typeof ce.module.deactivate=="function"&&(Y=Promise.resolve(ce.module.deactivate()).then(void 0,G=>(this._logService.error(G),Promise.resolve(void 0))))}catch(G){this._logService.error(G)}try{(0,I.dispose)(ce.subscriptions)}catch(G){this._logService.error(G)}return Y}async _activateExtension(V,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,Y).then(ce=>{const G=ce.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,G.codeLoadingTime,G.activateCallTime,G.activateResolvedTime,Y),this._logExtensionActivationTimes(V,Y,"success",G),ce},ce=>{throw this._logExtensionActivationTimes(V,Y,"failure"),ce})}_logExtensionActivationTimes(V,Y,ce,G){const le=W(V,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...G||{},outcome:ce})}_doActivateExtension(V,Y){const ce=W(V,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ce);const G=this._getEntryPoint(V);if(!G)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value} ${JSON.stringify(Y)}`),this._logService.flush();const le=new h.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,A.joinPath)(V.extensionLocation,G),le),this._loadExtensionContext(V)]).then(oe=>(_.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),Wi._callActivate(this._logService,V.identifier,oe[0],oe[1],le))).then(oe=>(_.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),oe))}_loadExtensionContext(V){const Y=new k.ExtensionGlobalMemento(V,this._storage),ce=new k.ExtensionMemento(V.identifier.value,!1,this._storage),G=new M.ExtensionSecrets(V,this._secretState),le=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,oe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([Y.whenReady,ce.whenReady,this._storagePath.whenReady]).then(()=>{const Ee=this;let Fe;return Object.freeze({globalState:Y,workspaceState:ce,secrets:G,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Me){return F.join(V.extensionLocation.fsPath,Me)},get storagePath(){return Ee._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return Ee._storagePath.globalValue(V).fsPath},get logPath(){return F.join(Ee._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return P.URI.joinPath(Ee._initData.logsLocation,V.identifier.value)},get storageUri(){return Ee._storagePath.workspaceValue(V)},get globalStorageUri(){return Ee._storagePath.globalValue(V)},get extensionMode(){return le},get extension(){return Fe===void 0&&(Fe=new N(Ee,V.identifier,V,oe)),Fe},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(V),Ee.extensionRuntime},get environmentVariableCollection(){return Ee._extHostTerminalService.getEnvironmentVariableCollection(V)}})})}static _callActivate(V,Y,ce,G,le){return ce=ce||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,Y,ce,G,le).then(oe=>new h.ActivatedExtension(!1,null,le.build(),ce,oe,G.subscriptions))}static _callActivateOptional(V,Y,ce,G,le){if(typeof ce.activate=="function")try{le.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const oe=typeof global=="object"?global:self,Ee=ce.activate.apply(oe,[G]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(Ee).then(Fe=>(le.activateResolveStop(),Fe))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(ce)}_activateOneStartupFinished(V,Y){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:Y}).then(void 0,ce=>{this._logService.error(ce)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const Y of V.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(V,Y)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ce=this._handleWorkspaceContainsEagerExtensions(Y),G=Promise.all([V,ce]).then(()=>{});return Promise.race([G,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),G}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(V,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,Y){if(this.isActivated(Y.identifier))return;const ce=!this._initData.remote.isRemote&&!!this._initData.remote.authority,G={folders:V.map(oe=>oe.uri),forceUsingSearch:ce,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,Ee,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(oe,Ee,Fe)},le=await(0,E.checkActivateWorkspaceContainsExtension)(G,Y);if(!!le)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:le.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:Y}=this._initData.environment;if(!V||!Y)throw new Error(c.localize(0,null));const ce=await this._loadCommonJSModule(null,Y,new h.ExtensionActivationTimesBuilder(!1));if(!ce||typeof ce.run!="function")throw new Error(c.localize(1,null,Y.toString()));return new Promise((G,le)=>{const oe=(Me,Ne)=>{Me?le(Me):G(typeof Ne=="number"&&Ne>0?1:0)},Ee=(0,A.originalFSPath)(Y),Fe=ce.run(Ee,oe);Fe&&Fe.then&&Fe.then(()=>{G(0)}).catch(Me=>{le(Me.toString())})})}async $extensionTestsExit(V){this._logService.info(`extension host terminating: test runner requested exit with code ${V}`),this._logService.info(`exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(V,Y){return this._resolvers[V]=Y,(0,I.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const Y=V.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const ce=V.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this._resolvers[ce]}}async $resolveAuthority(V,Y){const{authorityPrefix:ce,resolver:G}=await this._activateAndGetResolver(V);if(!G)return{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ce}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(G)),_.mark(`code/extHost/willResolveAuthority/${ce}`);const le=await G.resolve(V,{resolveAttempt:Y});_.mark(`code/extHost/didResolveAuthorityOK/${ce}`);const oe={authority:V,host:le.host,port:le.port,connectionToken:le.connectionToken},Ee={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted};return{type:"ok",value:{authority:oe,options:Ee,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(_.mark(`code/extHost/didResolveAuthorityError/${ce}`),le instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI(V,Y){const{authorityPrefix:ce,resolver:G}=await this._activateAndGetResolver(V);if(!G)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ce}`);const le=P.URI.revive(Y);if(typeof G.getCanonicalURI=="undefined")return le;const oe=await(0,R.asPromise)(()=>G.getCanonicalURI(le));return oe||le}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,Y){return Y===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(ce=>this._activateByEvent(V,!1))}async $activate(V,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,Y),!0):!1}async $deltaExtensions(V,Y){V.forEach(G=>G.extensionLocation=P.URI.revive(G.extensionLocation));const ce=await this.getExtensionPathIndex();return await Promise.all(Y.map(async G=>{const le=this._registry.getExtensionDescription(G);if(!le)return;const oe=await this._hostUtils.realpath(le.extensionLocation.fsPath);ce.delete(P.URI.file(oe).fsPath)})),await Promise.all(V.map(async G=>{const le=await this._hostUtils.realpath(G.extensionLocation.fsPath);ce.set(P.URI.file(le).fsPath,G)})),this._registry.deltaExtensions(V,Y),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let Y=p.VSBuffer.alloc(V),ce=Math.random()%256;for(let G=0;G<V;G++)Y.writeUInt8(ce,G);return Y}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};$=Ue([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,f.IExtHostRpcService),He(3,d.IExtHostWorkspace),He(4,n.IExtHostConfiguration),He(5,t.ILogService),He(6,o.IExtHostInitDataService),He(7,b.IExtensionStoragePaths),He(8,D.IExtHostTunnelService),He(9,T.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function W(H,V){return{id:H.identifier.value,name:H.name,extensionVersion:H.version,publisherDisplayName:H.publisher,activationEvents:H.activationEvents?H.activationEvents.join(","):null,isBuiltin:H.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class N{constructor(V,Y,ce,G){O.set(this,void 0),q.set(this,void 0),K.set(this,void 0),Je(this,O,V,"f"),Je(this,q,Y,"f"),Je(this,K,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=F.normalize((0,A.originalFSPath)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=G}get isActive(){return Te(this,O,"f").isActivated(Te(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,O,"f").getExtensionExports(Te(this,K,"f"))}activate(){return Te(this,O,"f").activateByIdWithErrors(Te(this,K,"f"),{startup:!1,extensionId:Te(this,q,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=N,O=new WeakMap,q=new WeakMap,K=new WeakMap}),define(we[100],be([0,1,17,2,3,14,5,7,162,31,33,49,167,32,163,12,4,10,91,68]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let p=class{constructor(m,D,T,g,E,u){this._workspaceService=D,this._extensionService=T,this._editorsService=g,this._configurationService=E,this._editorTabs=u,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new _.Emitter,this._onDidTerminateDebugSession=new _.Emitter,this._onDidChangeActiveDebugSession=new _.Emitter,this._onDidReceiveDebugSessionCustomEvent=new _.Emitter,this._debugServiceProxy=m.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new _.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(M=>{M.onDidChange(O=>{this.registerAllDebugTypes(M)}),this.registerAllDebugTypes(M)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,D){const T=m;if(typeof T.sourceReference=="number"&&T.sourceReference>0){let g=`debug:${encodeURIComponent(T.path||"")}`,E="?";return D&&(g+=`${E}session=${encodeURIComponent(D.id)}`,E="&"),g+=`${E}ref=${T.sourceReference}`,F.URI.parse(g)}else{if(T.path)return F.URI.file(T.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const D=[];for(const T of m.getAllExtensionDescriptions())if(T.contributes){const g=T.contributes.debuggers;if(g&&g.length>0)for(const E of g)(0,s.isDebuggerMainContribution)(E)&&D.push(E.type)}this._debugServiceProxy.$registerDebugTypes(D)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(D=>m.push(D)),m}addBreakpoints(m){this.startBreakpoints();const D=m.filter(E=>{const u=E.id;return this._breakpoints.has(u)?!1:(this._breakpoints.set(u,E),!0)});this.fireBreakpointChanges(D,[],[]);const T=[],g=new Map;for(const E of D)if(E instanceof I.SourceBreakpoint){let u=g.get(E.location.uri.toString());u||(u={type:"sourceMulti",uri:E.location.uri,lines:[]},g.set(E.location.uri.toString(),u),T.push(u)),u.lines.push({id:E.id,enabled:E.enabled,condition:E.condition,hitCondition:E.hitCondition,logMessage:E.logMessage,line:E.location.range.start.line,character:E.location.range.start.character})}else E instanceof I.FunctionBreakpoint&&T.push({type:"function",id:E.id,enabled:E.enabled,hitCondition:E.hitCondition,logMessage:E.logMessage,condition:E.condition,functionName:E.functionName});return this._debugServiceProxy.$registerBreakpoints(T)}removeBreakpoints(m){this.startBreakpoints();const D=m.filter(u=>this._breakpoints.delete(u.id));this.fireBreakpointChanges([],D,[]);const T=D.filter(u=>u instanceof I.SourceBreakpoint).map(u=>u.id),g=D.filter(u=>u instanceof I.FunctionBreakpoint).map(u=>u.id),E=D.filter(u=>u instanceof I.DataBreakpoint).map(u=>u.id);return this._debugServiceProxy.$unregisterBreakpoints(T,g,E)}startDebugging(m,D,T){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,D,{parentSessionID:T.parentSession?T.parentSession.id:void 0,lifecycleManagedByParent:T.lifecycleManagedByParent,repl:T.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:T.noDebug,compact:T.compact,debugUI:T.debugUI,suppressSaveBeforeStart:T.suppressSaveBeforeStart})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,D,T){if(!D)return new I.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:g,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,T,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,g),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(E=>E.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(m,D,T){if(!T)return new I.Disposable(()=>{});if(!this.definesDebugType(m,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:g,factory:T}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,g),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(E=>E.factory!==T),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(m,D){if(!D)return new I.Disposable(()=>{});const T=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:T,factory:D}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==D)})}async $runInTerminal(m,D){return Promise.resolve(void 0)}async $substituteVariables(m,D){if(!this._variableResolver){const[E,u]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(E||[],this._editorsService,u)}let T;const g=await this.getFolder(m);return g&&(T={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(T,D)}createDebugAdapter(m,D){if(m.type==="implementation")return new o(m.implementation)}createSignService(){}async $startDASession(m,D){const T=this,g=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const u=this.convertToDto(E),M=this.createDebugAdapter(u,g);if(!M)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const O=M;return this._debugAdapters.set(m,O),this.getDebugAdapterTrackers(g).then(q=>(q&&this._debugAdaptersTrackers.set(m,q),O.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const $=K,W={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign($.arguments.value);W.body={signature:N},O.sendResponse(W)}else throw new Error("no signer")}catch(N){W.success=!1,W.message=N.message,O.sendResponse(W)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(K),K=(0,s.convertToVSCPaths)(K,!0),T._debugServiceProxy.$acceptDAMessage(m,K)}),O.onError(K=>{q&&q.onError&&q.onError(K),this._debugServiceProxy.$acceptDAError(m,K.name,K.message,K.stack)}),O.onExit(K=>{q&&q.onExit&&q.onExit((0,C.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,C.withNullAsUndefined)(K),void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),O.startSession()))})}$sendDAMessage(m,D){D=(0,s.convertToDAPaths)(D,!1);const T=this._debugAdaptersTrackers.get(m);T&&T.onWillReceiveMessage&&T.onWillReceiveMessage(D);const g=this._debugAdapters.get(m);g&&g.sendMessage(D)}$stopDASession(m){const D=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),D&&D.onWillStopSession&&D.onWillStopSession();const T=this._debugAdapters.get(m);return this._debugAdapters.delete(m),T?T.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const D=[],T=[],g=[];if(m.added)for(const E of m.added){const u=E.id;if(u&&!this._breakpoints.has(u)){let M;if(E.type==="function")M=new I.FunctionBreakpoint(E.functionName,E.enabled,E.condition,E.hitCondition,E.logMessage);else if(E.type==="data")M=new I.DataBreakpoint(E.label,E.dataId,E.canPersist,E.enabled,E.hitCondition,E.condition,E.logMessage);else{const O=F.URI.revive(E.uri);M=new I.SourceBreakpoint(new I.Location(O,new I.Position(E.line,E.character)),E.enabled,E.condition,E.hitCondition,E.logMessage)}M._id=u,this._breakpoints.set(u,M),D.push(M)}}if(m.removed)for(const E of m.removed){const u=this._breakpoints.get(E);u&&(this._breakpoints.delete(E),T.push(u))}if(m.changed){for(const E of m.changed)if(E.id){const u=this._breakpoints.get(E.id);if(u){if(u instanceof I.FunctionBreakpoint&&E.type==="function"){const M=u;M.enabled=E.enabled,M.condition=E.condition,M.hitCondition=E.hitCondition,M.logMessage=E.logMessage,M.functionName=E.functionName}else if(u instanceof I.SourceBreakpoint&&E.type==="source"){const M=u;M.enabled=E.enabled,M.condition=E.condition,M.hitCondition=E.hitCondition,M.logMessage=E.logMessage,M.location=new I.Location(F.URI.revive(E.uri),new I.Position(E.line,E.character))}g.push(u)}}}this.fireBreakpointChanges(D,T,g)}$provideDebugConfigurations(m,D,T){return(0,A.asPromise)(async()=>{const g=this.getConfigProviderByHandle(m);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const E=await this.getFolder(D);return g.provideDebugConfigurations(E,T)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(m,D,T,g){return(0,A.asPromise)(async()=>{const E=this.getConfigProviderByHandle(m);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.getFolder(D);return E.resolveDebugConfiguration(u,T,g)})}$resolveDebugConfigurationWithSubstitutedVariables(m,D,T,g){return(0,A.asPromise)(async()=>{const E=this.getConfigProviderByHandle(m);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.getFolder(D);return E.resolveDebugConfigurationWithSubstitutedVariables(u,T,g)})}async $provideDebugAdapter(m,D){const T=this.getAdapterDescriptorFactoryByHandle(m);if(!T)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(D);return this.getAdapterDescriptor(T,g).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(E)})}async $acceptDebugSessionStarted(m){const D=await this.getSession(m);this._onDidStartDebugSession.fire(D)}async $acceptDebugSessionTerminated(m){const D=await this.getSession(m);D&&(this._onDidTerminateDebugSession.fire(D),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,D){const T=await this.getSession(m);T&&T._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(m,D){const g={session:await this.getSession(m),event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(m){if(m instanceof I.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof I.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const D=this._adapterFactories.filter(T=>T.type===m);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(m){const D=this._adapterFactories.filter(T=>T.handle===m);if(D.length>0)return D[0].factory}getConfigProviderByHandle(m){const D=this._configProviders.filter(T=>T.handle===m);if(D.length>0)return D[0].provider}definesDebugType(m,D){if(m.contributes){const T=m.contributes.debuggers;if(T&&T.length>0){for(const g of T)if(g.label&&g.type&&g.type===D)return!0}}return!1}getDebugAdapterTrackers(m){const T=m.configuration.type,g=this._trackerFactories.filter(E=>E.type===T||E.type==="*").map(E=>(0,A.asPromise)(()=>E.factory.createDebugAdapterTracker(m)).then(u=>u,u=>null));return Promise.race([Promise.all(g).then(E=>{const u=E.filter(M=>!!M);if(u.length>0)return new r(u)}),new Promise((E,u)=>{const M=setTimeout(()=>{clearTimeout(M),u(new Error("timeout"))},1e3)})]).catch(E=>{})}async getAdapterDescriptor(m,D){const T=D.configuration.debugServer;if(typeof T=="number")return Promise.resolve(new I.DebugAdapterServer(T));if(m){const E=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>m.createDebugAdapterDescriptor(D,this.daExecutableFromPackage(D,E))).then(u=>{if(u)return u})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,g))}daExecutableFromPackage(m,D){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,D,T){(m.length>0||D.length>0||T.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:D,changed:T}))}async getSession(m){if(m)if(typeof m=="string"){const D=this._debugSessions.get(m);if(D)return D}else{let D=this._debugSessions.get(m.id);if(!D){const T=await this.getFolder(m.folderUri),g=m.parent?this._debugSessions.get(m.parent):void 0;D=new k(this._debugServiceProxy,m.id,m.type,m.name,T,m.configuration,g),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(m){if(m){const D=F.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}};p=Ue([He(0,d.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,y.IExtHostDocumentsAndEditors),He(4,h.IExtHostConfiguration),He(5,a.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class k{constructor(m,D,T,g,E,u,M){this._debugServiceProxy=m,this._id=D,this._type=T,this._name=g,this._workspaceFolder=E,this._configuration=u,this._parentSession=M}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,D){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,D)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=k;class i{constructor(m){this.value=Object.freeze({append(D){m.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=i;class l extends n.AbstractVariableResolverService{constructor(m,D,T,g,E){function u(){if(D){const M=D.activeEditor();if(M)return M.document.uri;const O=g.tabs.filter(q=>q.isActive);if(O.length>0){const q=O[0].resource;return q&&(q.primary||q.secondary)?q.primary??q.secondary:O[0].resource}}}super({getFolderUri:M=>{const O=m.filter(q=>q.name===M);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(M,O)=>T.getConfiguration(void 0,M).get(O),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const M=u();if(M)return c.normalize(M.fsPath)},getWorkspaceFolderPathForFile:()=>{if(E){const M=u();if(M){const O=E.getWorkspaceFolder(M);if(O)return c.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(D){const M=D.activeEditor();if(M&&!M.selection.isEmpty)return M.document.getText(M.selection)}},getLineNumber:()=>{if(D){const M=D.activeEditor();if(M)return String(M.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=l;class r{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(D=>D.onError?D.onError(m):void 0)}onExit(m,D){this.trackers.forEach(T=>T.onExit?T.onExit(m,D):void 0)}}class o extends S.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let b=class extends p{constructor(m,D,T,g,E,u){super(m,D,T,g,E,u)}createVariableResolver(m,D,T){return new l(m,D,T,this._editorTabs)}};b=Ue([He(0,d.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,y.IExtHostDocumentsAndEditors),He(4,h.IExtHostConfiguration),He(5,a.IExtHostEditorTabs)],b),e.WorkerExtHostDebugService=b}),define(we[218],be([0,1,74,2,5,32,30,25,12,29,4,33,91,15]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(a,p,k,i,l,r,o){this._apiFactory=a,this._extensionRegistry=p,this._instaService=k,this._extHostConfiguration=i,this._extHostExtensionService=l,this._initData=r,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const p=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,p,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(C,p,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let p of a.nodeModuleName)this._factories.set(p,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(p=>a.alternativeModuleName(p))}};s=Ue([He(2,t.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,y.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,h.ILogService)],s),e.RequireInterceptor=s;class d{constructor(a,p,k,i,l){this._apiFactory=a,this._extensionPaths=p,this._extensionRegistry=k,this._configProvider=i,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,p){const k=this._extensionPaths.findSubstr(p.fsPath);if(k){let i=this._extApiImpl.get(I.ExtensionIdentifier.toKey(k.identifier));return i||(i=this._apiFactory(k,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(k.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((l,r)=>i+=`	${r} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${p.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(a,p){this.nodeModuleName="keytar";const{environment:k}=p,i=a.getProxy(_.MainContext.MainThreadKeytar);if(k.appRoot){let l=k.appRoot.fsPath;n.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${l}/node_modules.asar/keytar`),this.alternativeNames.add(`${l}/node_modules/keytar`)}this._impl={getPassword:(l,r)=>i.$getPassword(l,r),setPassword:(l,r,o)=>i.$setPassword(l,r,o),deletePassword:(l,r)=>i.$deletePassword(l,r),findPassword:l=>i.$findPassword(l),findCredentials(l){return i.$findCredentials(l)}}}load(a,p){return this._impl}alternativeModuleName(a){const p=a.length;if(p<=7||!this.alternativeNames)return;const k=p-7;if((a.charAt(k)==="/"||a.charAt(k)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};v=Ue([He(0,S.IExtHostRpcService),He(1,P.IExtHostInitDataService)],v);let C=class{constructor(a,p,k){this._extensionPaths=a,this._appUriScheme=p,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=k.getProxy(_.MainContext.MainThreadTelemetry);const i=k.getProxy(_.MainContext.MainThreadWindow);this._impl=(l,r)=>{const o=F.URI.parse(l);return r?this.callOriginal(l,r):o.scheme==="http"||o.scheme==="https"?i.$openUri(o,l,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?i.$openUri(o,l,{}):this.callOriginal(l,r)}}load(a,p,k){const i=this._extensionPaths.findSubstr(p.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=k(a),this._impl}callOriginal(a,p){return this.sendNoForwardTelemetry(),this._original(a,p)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};C=Ue([He(2,S.IExtHostRpcService)],C)}),define(we[219],be([0,1,14,16,74,6,2,5,212,15,57,61,29,143,12,65,33,38]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(p,k,i,l){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new S.RPCProtocol(p,null,l),k=w._transform(k,this._rpcProtocol);const r=new y.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...k}),r.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),r.set(d.IURITransformerService,new d.URITransformerService(l)),r.set(v.IHostUtils,i);const o=new h.InstantiationService(r,!0),b=o.invokeFunction(T=>T.get(C.IExtHostTerminalService));this._disposables.add(b),this._logService=o.invokeFunction(T=>T.get(P.ILogService)),_.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",k),this._extensionService=o.invokeFunction(T=>T.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(T=>{Error.prepareStackTrace=(g,E)=>{let u="",M,O;for(const q of E)u+=`
	at ${q.toString()}`,O=q.getFileName(),!M&&O&&(M=T.findSubstr(O));return f.set(g,M),`${g.name||"Error"}: ${g.message||""}${u}`}});const m=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),D=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(T=>{const g=F.transformErrorForSerialization(T),E=f.get(T);E?m.$onExtensionRuntimeError(E.identifier,g):D.$onUnexpectedError(g)})}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const k=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,c.timeout)(4e3),k]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(p,k){p.extensions.forEach(l=>l.extensionLocation=R.URI.revive(k.transformIncomingURIs(l.extensionLocation))),p.environment.appRoot=R.URI.revive(k.transformIncomingURIs(p.environment.appRoot));const i=p.environment.extensionDevelopmentLocationURI;return i&&(p.environment.extensionDevelopmentLocationURI=i.map(l=>R.URI.revive(k.transformIncomingURIs(l)))),p.environment.extensionTestsLocationURI=R.URI.revive(k.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=R.URI.revive(k.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=R.URI.revive(k.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=R.URI.revive(k.transformIncomingURIs(p.logsLocation)),p.logFile=R.URI.revive(k.transformIncomingURIs(p.logFile)),p.workspace=k.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=w}),define(we[220],be([0,1,17,21,56,27,24,193,39]),function(ie,e,c,F,_,A,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(n,h,s){this.config=n,this.provider=h,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const h=this.config.folderQueries||[];return new Promise((s,d)=>{const v=C=>{this.resultCount++,n(C)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(C=>{const w=C.toString(),a=c.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,a)||this.matchFile(v,{base:C,basename:a})}),Promise.all(h.map(C=>this.searchInFolder(C,v))).then(C=>{s({limitHit:this.isLimitHit,stats:C[0]||void 0})},C=>{d(new Error((0,_.toErrorMessage)(C)))})})}async searchInFolder(n,h){const s=new F.CancellationTokenSource,d=this.getSearchOptionsForFolder(n),v=this.initDirectoryTree(),C=new S.QueryGlobTester(this.config,n),w=!C.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(s),a=I.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,s.token),k=a.elapsed(),i=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(l=>{const r=c.posix.relative(n.folder.path,l.path);if(w){const o=c.basename(l.path);this.matchFile(h,{base:n.folder,relativePath:r,basename:o});return}this.addDirectoryEntries(v,n.folder,r,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,C,h),{providerTime:k,postProcessTime:i.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(n){const h=(0,S.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),s=(0,S.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:s,includes:h,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},h,s,d){if(s===this.filePattern){const C=c.basename(this.filePattern);this.matchFile(d,{base:h,relativePath:this.filePattern,basename:C})}function v(C){const w=c.basename(C),a=c.dirname(C);let p=n[a];p||(p=n[a]=[],v(a)),p.push({base:h,relativePath:C,basename:w})}v(s)}matchDirectoryTree({rootEntries:n,pathToEntries:h},s,d){const v=this,C=this.filePattern;function w(a){const p=A.hasSiblingFn(()=>a.map(k=>k.basename));for(let k=0,i=a.length;k<i;k++){const l=a[k],{relativePath:r,basename:o}=l;if(!s.includedInQuerySync(r,o,C!==o?p:void 0))continue;const b=h[r];if(b)w(b);else{if(r===C)continue;v.matchFile(d,l)}if(v.isLimitHit)break}}w(n)}matchFile(n,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(h))}}class t{constructor(){this.sessions=new Map}fileSearch(n,h,s,d){const v=this.getSessionTokenSource(n.cacheKey),C=new P(n,h,v&&v.token);let w=0;const a=p=>{w+=p.length,s(p.map(k=>this.rawMatchToSearchItem(k)))};return this.doSearch(C,t.BATCH_SIZE,a,d).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:p.stats}}))}clearCache(n){const h=this.getSessionTokenSource(n);h&&h.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new F.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:R.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,h,s,d){d.onCancellationRequested(()=>{n.cancel()});const v=w=>{w&&(C.push(w),h>0&&C.length>=h&&(s(C),C=[]))};let C=[];return n.search(v).then(w=>(C.length&&s(C),w),w=>(C.length&&s(C),Promise.reject(w)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(we[221],be([0,1,13,21,56,27,11,17,24,10,2,39]),function(ie,e,c,F,_,A,R,I,S,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(a,p,k,i){this.query=a,this.provider=p,this.fileUtils=k,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,p){const k=this.query.folderQueries||[],i=new F.CancellationTokenSource;return p.onCancellationRequested(()=>i.cancel()),new Promise((l,r)=>{this.collector=new s(a);let o=!1;const b=(f,m)=>{if(!o&&!this.isLimitHit){const D=this.resultSize(f);v(f)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,o=!0,i.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const T=this.resultSize(f);this.resultCount+=T,(T>0||!v(f))&&this.collector.add(f,m)}};Promise.all(k.map((f,m)=>this.searchInFolder(f,D=>b(D,m),i.token))).then(f=>{i.dispose(),this.collector.flush();const m=f.some(D=>!!D&&!!D.limitHit);l({limitHit:this.isLimitHit||m,messages:(0,c.flatten)(f.map(D=>D?.message?(0,P.isArray)(D.message)?D.message:[D.message]:[])),stats:{type:this.processType}})},f=>{i.dispose();const m=(0,_.toErrorMessage)(f);r(new Error(m))})})}resultSize(a){return v(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,p){const k=Array.isArray(a.ranges)?a.ranges:[a.ranges],i=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:k.slice(0,p),preview:{matches:i.slice(0,p),text:a.preview.text},uri:a.uri}}async searchInFolder(a,p,k){const i=new y.QueryGlobTester(this.query,a),l=[],r={report:f=>{if(!this.validateProviderResult(f))return;const m=a.folder.scheme===R.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(f.uri))):void 0,D=S.relativePath(a.folder,f.uri);if(D){const T=i.includedInQuery(D,I.basename(D),m);(0,P.isPromise)(T)?l.push(T.then(g=>{g&&p(f)})):T&&p(f)}}},o=this.getSearchOptionsForFolder(a),b=await this.provider.provideTextSearchResults(h(this.query.contentPattern),o,r,k);return l.length&&await Promise.all(l),b}validateProviderResult(a){if(v(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const p=(0,y.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),k=(0,y.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),i={folder:t.URI.from(a.folder),excludes:k,includes:p,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function h(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class s{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new C(512,p=>this.sendItems(p))}add(a,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!S.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(d(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=s;function d(w){return v(w)?{preview:{matches:(0,c.mapArrayOrNot)(w.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:w.preview.text},ranges:(0,c.mapArrayOrNot)(w.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function v(w){return!!w.preview}e.extensionResultIsMatch=v;class C{constructor(a,p){this.maxBatchSize=a,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,p){!a||this.addItemToBatch(a,p)}addItems(a,p){!a||this.addItemsToBatch(a,p)}addItemToBatch(a,p){this.batch.push(a),this.batchSize+=p,this.onUpdate()}addItemsToBatch(a,p){this.batch=this.batch.concat(a),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<C.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},C.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=C,C.TIMEOUT=4e3,C.START_BATCH_AFTER_COUNT=50}),define(we[101],be([0,1,6,5,4,220,12,65,15,2,221]),function(ie,e,c,F,_,A,R,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let y=class{constructor(d,v,C){this.extHostRpc=d,this._uriTransformer=v,this._logService=C,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,v){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const C=this._handlePool++;return this._textSearchProvider.set(C,v),this._proxy.$registerTextSearchProvider(C,this._transformScheme(d)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(C),this._proxy.$unregisterProvider(C)})}registerFileSearchProvider(d,v){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const C=this._handlePool++;return this._fileSearchProvider.set(C,v),this._proxy.$registerFileSearchProvider(C,this._transformScheme(d)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(C),this._proxy.$unregisterProvider(C)})}$provideFileSearchResults(d,v,C,w){const a=n(C),p=this._fileSearchProvider.get(d);if(p)return this._fileSearchManager.fileSearch(a,p,k=>{this._proxy.$handleFileMatch(d,v,k.map(i=>i.resource))},w);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,v,C,w){const a=this._textSearchProvider.get(d);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const p=n(C);return this.createTextSearchManager(p,a).search(i=>this._proxy.$handleTextMatch(d,v,i),w)}$enableExtensionHostSearch(){}createTextSearchManager(d,v){return new t.TextSearchManager(d,v,{readdir:C=>Promise.resolve([]),toCanonicalName:C=>C},"textSearchProvider")}};y=Ue([He(0,R.IExtHostRpcService),He(1,I.IURITransformerService),He(2,S.ILogService)],y),e.ExtHostSearch=y;function n(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(h),extraFileResources:s.extraFileResources&&s.extraFileResources.map(d=>P.URI.revive(d))}}e.reviveQuery=n;function h(s){return{...s,folder:P.URI.revive(s.folder)}}}),define(we[222],be([0,1,21,16,3,35,2,116,79,112,55,60,5,183,182,48,184,32,185,186,187,169,188,49,33,189,170,192,194,195,96,172,200,201,202,72,38,204,173,8,7,207,50,97,31,30,51,159,191,86,95,99,100,101,15,65,12,29,196,156,64,70,180,205,155,73,71,210,208,209,181,37,203,206,69,68,87,198,98,199,11,145,197,153,190]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C,w,a,p,k,i,l,r,o,b,f,m,D,T,g,E,u,M,O,q,K,$,W,N,H,V,Y,ce,G,le,oe,Ee,Fe,Me,Ne,Qe,ze,qe,B,Q,ee,ae,j,se,fe,Ae,xe,$e,ve,Ze,z,J,he,Oe,Ve,tt,ut,ht,St,Pt,dt,bt,ft,Et,Ye,Ct,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(Z){const ue=Z.get(ee.IExtHostInitDataService),ge=Z.get(Ve.IExtHostFileSystemInfo),me=Z.get(Ze.IExtHostConsumerFileSystem),Ie=Z.get(r.IExtHostExtensionService),Be=Z.get(ce.IExtHostWorkspace),Le=Z.get(Pt.IExtHostTelemetry),je=Z.get(C.IExtHostConfiguration),Xe=Z.get(B.IURITransformerService),ne=Z.get(Q.IExtHostRpcService),pe=Z.get(O.IExtHostStorage),re=Z.get(ve.IExtensionStoragePaths),U=Z.get(qe.ILogService),Ce=Z.get(se.IExtHostTunnelService),Se=Z.get(fe.IExtHostApiDeprecationService),Ge=Z.get(Y.IExtHostWindow),We=Z.get(ht.IExtHostSecretState),it=Z.get(St.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),ne.set(n.ExtHostContext.ExtHostLogService,U),ne.set(n.ExtHostContext.ExtHostWorkspace,Be),ne.set(n.ExtHostContext.ExtHostConfiguration,je),ne.set(n.ExtHostContext.ExtHostExtensionService,Ie),ne.set(n.ExtHostContext.ExtHostStorage,pe),ne.set(n.ExtHostContext.ExtHostTunnelService,Ce),ne.set(n.ExtHostContext.ExtHostWindow,Ge),ne.set(n.ExtHostContext.ExtHostSecretState,We),ne.set(n.ExtHostContext.ExtHostTelemetry,Le),ne.set(n.ExtHostContext.ExtHostEditorTabs,it);const mt=ne.set(n.ExtHostContext.ExtHostDecorations,Z.get(Me.IExtHostDecorations)),vt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,Z.get(l.IExtHostDocumentsAndEditors)),nt=ne.set(n.ExtHostContext.ExtHostCommands,Z.get(d.IExtHostCommands)),ot=ne.set(n.ExtHostContext.ExtHostTerminalService,Z.get(q.IExtHostTerminalService)),lt=ne.set(n.ExtHostContext.ExtHostDebugService,Z.get(Qe.IExtHostDebugService)),Rt=ne.set(n.ExtHostContext.ExtHostSearch,Z.get(ze.IExtHostSearch)),_t=ne.set(n.ExtHostContext.ExtHostTask,Z.get(Ne.IExtHostTask)),Ot=ne.set(n.ExtHostContext.ExtHostOutputService,Z.get(T.IExtHostOutputService)),di=ne.set(n.ExtHostContext.ExtHostUrls,new H.ExtHostUrls(ne)),kt=ne.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ne,vt)),$t=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(ne,vt,U)),Zt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new k.ExtHostDocumentSaveParticipant(U,kt,ne.getProxy(n.MainContext.MainThreadBulkEdits))),gt=ne.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(ne,nt,vt,kt,re)),Kt=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(U,gt)),Vt=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new Ct.ExtHostNotebookEditors(U,ne,gt)),ei=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new dt.ExtHostNotebookKernels(ne,ue,gt,U)),ti=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new ft.ExtHostNotebookRenderers(ne,gt)),It=ne.set(n.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(ne,vt)),Qt=ne.set(n.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),nt,U)),wi=ne.set(n.ExtHostContext.ExtHostEditorInsets,new oe.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),It,ue)),Wt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(ne,U,ge)),Ht=ne.set(n.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(ne,kt,nt.converter)),ct=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(ne,Xe,kt,nt,Wt,U,Se)),ii=ne.set(n.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(ne,ct)),Nt=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new b.ExtHostFileSystemEventService(ne,U,vt)),xt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,E.createExtHostQuickOpen)(ne,Be,nt)),Yt=ne.set(n.ExtHostContext.ExtHostSCM,new u.ExtHostSCM(ne,nt,U)),bi=ne.set(n.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(ne,nt,kt)),hi=ne.set(n.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new Ee.ExtHostLabelService(ne)),fi=ne.set(n.ExtHostContext.ExtHostTheming,new j.ExtHostTheming(ne)),ni=ne.set(n.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication(ne)),ri=ne.set(n.ExtHostContext.ExtHostTimeline,new xe.ExtHostTimeline(ne,nt)),jt=ne.set(n.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(ne,{remote:ue.remote},Be,U,Se)),si=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new he.ExtHostWebviewPanels(ne,jt,Be)),_i=ne.set(n.ExtHostContext.ExtHostCustomEditors,new J.ExtHostCustomEditors(ne,kt,re,jt,si)),yi=ne.set(n.ExtHostContext.ExtHostWebviewViews,new z.ExtHostWebviewViews(ne,jt)),qt=ne.set(n.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(ne,nt)),Jt=ne.set(n.ExtHostContext.ExtHostUriOpeners,new ut.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(ne,gt,vt,nt));const Si=(0,le.values)(n.ExtHostContext);ne.assertRegistered(Si);const Di=new Oe.ExtHostBulkEdits(ne,vt),oi=new s.ExtHostClipboard(ne),ai=new D.ExtHostMessageService(ne,U),zt=new a.ExtHostDialogs(ne),Mt=new M.ExtHostStatusBar(ne,nt.converter);return h.ExtHostApiCommands.register(nt),function(Re,Tt,Gt){const pt=function(){let X=!Re.isUnderDevelopment;function de(ke){X||(U.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(rt){if(Array.isArray(rt))rt.forEach(ke);else if(typeof rt=="string")de(rt);else{const wt=rt;typeof wt.scheme=="undefined"&&de(rt),!Re.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,G.throwProposedApiError)(Re)}return rt}}(),Ci={getSession(X,de,ke){return ke?.forceNewSession&&(0,G.checkProposedApiEnabled)(Re),ni.getSession(Re,X,de,ke)},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(X,de,ke,rt){return ni.registerAuthenticationProvider(X,de,ke,rt)}},ki={registerCommand(X,de,ke){return nt.registerCommand(!0,X,de,ke)},registerTextEditorCommand(X,de,ke){return nt.registerCommand(!0,X,(...rt)=>{const wt=It.getActiveTextEditor();if(!wt){U.warn("Cannot execute "+X+" because there is no active text editor.");return}return wt.edit(Dt=>{de.apply(ke,[wt,Dt,...rt])}).then(Dt=>{Dt||U.warn("Edits from command "+X+" were not applied.")},Dt=>{U.warn("An error occurred while running command "+X,Dt)})})},registerDiffInformationCommand:(X,de,ke)=>((0,G.checkProposedApiEnabled)(Re),nt.registerCommand(!0,X,async(...rt)=>{const wt=vt.activeEditor(!0);if(!wt){U.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await It.getDiffInformation(wt.id);de.apply(ke,[Dt,...rt])})),executeCommand(X,...de){return nt.executeCommand(X,...de)},getCommands(X=!1){return nt.getCommands(X)}},mi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return oi.value},get shell(){return ot.getDefaultShell(!1)},get isTelemetryEnabled(){return Le.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Le.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,de){return Ge.openUri(X,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===ue.environment.appUriScheme)return di.createAppUri(X);try{return await Ge.asExternalUri(X,{allowTunneling:!!ue.remote.authority})}catch(de){if((0,Ye.matchesScheme)(X,Et.Schemas.http)||(0,Ye.matchesScheme)(X,Et.Schemas.https))return X;throw de}},get remoteName(){return(0,Fe.getRemoteName)(ue.remote.authority)},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ue.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Ii={createTestController(X,de){return qt.createTestController(X,de)},createTestObserver(){return(0,G.checkProposedApiEnabled)(Re),qt.createTestObserver()},runTests(X){return(0,G.checkProposedApiEnabled)(Re),qt.runTests(X)},get onDidChangeTestResults(){return(0,G.checkProposedApiEnabled)(Re),qt.onResultsChanged},get testResults(){return(0,G.checkProposedApiEnabled)(Re),qt.results}},Pi={getExtension(X){const de=Tt.getExtensionDescription(X);if(de)return new r.Extension(Ie,Re.identifier,de,gi)},get all(){return Tt.getAllExtensionDescriptions().map(X=>new r.Extension(Ie,Re.identifier,X,gi))},get onDidChange(){return Tt.onDidChange}},li={createDiagnosticCollection(X){return Wt.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:X=>Wt.getDiagnostics(X),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(X,de){return Ht.changeLanguage(X.uri,de)},match(X,de){return(0,t.score)(W.LanguageSelector.from(X),de.uri,de.languageId,!0)},registerCodeActionsProvider(X,de,ke){return ct.registerCodeActionProvider(Re,pt(X),de,ke)},registerCodeLensProvider(X,de){return ct.registerCodeLensProvider(Re,pt(X),de)},registerDefinitionProvider(X,de){return ct.registerDefinitionProvider(Re,pt(X),de)},registerDeclarationProvider(X,de){return ct.registerDeclarationProvider(Re,pt(X),de)},registerImplementationProvider(X,de){return ct.registerImplementationProvider(Re,pt(X),de)},registerTypeDefinitionProvider(X,de){return ct.registerTypeDefinitionProvider(Re,pt(X),de)},registerHoverProvider(X,de){return ct.registerHoverProvider(Re,pt(X),de,Re.identifier)},registerEvaluatableExpressionProvider(X,de){return ct.registerEvaluatableExpressionProvider(Re,pt(X),de,Re.identifier)},registerInlineValuesProvider(X,de){return ct.registerInlineValuesProvider(Re,pt(X),de,Re.identifier)},registerDocumentHighlightProvider(X,de){return ct.registerDocumentHighlightProvider(Re,pt(X),de)},registerLinkedEditingRangeProvider(X,de){return ct.registerLinkedEditingRangeProvider(Re,pt(X),de)},registerReferenceProvider(X,de){return ct.registerReferenceProvider(Re,pt(X),de)},registerRenameProvider(X,de){return ct.registerRenameProvider(Re,pt(X),de)},registerDocumentSymbolProvider(X,de,ke){return ct.registerDocumentSymbolProvider(Re,pt(X),de,ke)},registerWorkspaceSymbolProvider(X){return ct.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,de){return ct.registerDocumentFormattingEditProvider(Re,pt(X),de)},registerDocumentRangeFormattingEditProvider(X,de){return ct.registerDocumentRangeFormattingEditProvider(Re,pt(X),de)},registerOnTypeFormattingEditProvider(X,de,ke,...rt){return ct.registerOnTypeFormattingEditProvider(Re,pt(X),de,[ke].concat(rt))},registerDocumentSemanticTokensProvider(X,de,ke){return ct.registerDocumentSemanticTokensProvider(Re,pt(X),de,ke)},registerDocumentRangeSemanticTokensProvider(X,de,ke){return ct.registerDocumentRangeSemanticTokensProvider(Re,pt(X),de,ke)},registerSignatureHelpProvider(X,de,ke,...rt){return typeof ke=="object"?ct.registerSignatureHelpProvider(Re,pt(X),de,ke):ct.registerSignatureHelpProvider(Re,pt(X),de,typeof ke=="undefined"?[]:[ke,...rt])},registerCompletionItemProvider(X,de,...ke){return ct.registerCompletionItemProvider(Re,pt(X),de,ke)},registerInlineCompletionItemProvider(X,de){return(0,G.checkProposedApiEnabled)(Re),ct.registerInlineCompletionsProvider(Re,pt(X),de)},registerDocumentLinkProvider(X,de){return ct.registerDocumentLinkProvider(Re,pt(X),de)},registerColorProvider(X,de){return ct.registerColorProvider(Re,pt(X),de)},registerFoldingRangeProvider(X,de){return ct.registerFoldingRangeProvider(Re,pt(X),de)},registerSelectionRangeProvider(X,de){return ct.registerSelectionRangeProvider(Re,X,de)},registerCallHierarchyProvider(X,de){return ct.registerCallHierarchyProvider(Re,X,de)},setLanguageConfiguration:(X,de)=>ct.setLanguageConfiguration(Re,X,de),getTokenInformationAtPosition(X,de){return(0,G.checkProposedApiEnabled)(Re),Ht.tokenAtPosition(X,de)},registerInlayHintsProvider(X,de){return(0,G.checkProposedApiEnabled)(Re),ct.registerInlayHintsProvider(Re,X,de)},registerTypeHierarchyProvider(X,de){return(0,G.checkProposedApiEnabled)(Re),ct.registerTypeHierarchyProvider(Re,X,de)},createLanguageStatusItem(X,de){return(0,G.checkProposedApiEnabled)(Re),Ht.createLanguageStatusItem(Re,X,de)}},Ai={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return ot.activeTerminal},get terminals(){return ot.terminals},async showTextDocument(X,de,ke){const rt=await(R.URI.isUri(X)?Promise.resolve(pi.openTextDocument(X)):Promise.resolve(X));return It.showTextDocument(rt,de,ke)},createTextEditorDecorationType(X){return It.createTextEditorDecorationType(Re,X)},onDidChangeActiveTextEditor(X,de,ke){return It.onDidChangeActiveTextEditor(X,de,ke)},onDidChangeVisibleTextEditors(X,de,ke){return It.onDidChangeVisibleTextEditors(X,de,ke)},onDidChangeTextEditorSelection(X,de,ke){return It.onDidChangeTextEditorSelection(X,de,ke)},onDidChangeTextEditorOptions(X,de,ke){return It.onDidChangeTextEditorOptions(X,de,ke)},onDidChangeTextEditorVisibleRanges(X,de,ke){return It.onDidChangeTextEditorVisibleRanges(X,de,ke)},onDidChangeTextEditorViewColumn(X,de,ke){return It.onDidChangeTextEditorViewColumn(X,de,ke)},onDidCloseTerminal(X,de,ke){return ot.onDidCloseTerminal(X,de,ke)},onDidOpenTerminal(X,de,ke){return ot.onDidOpenTerminal(X,de,ke)},onDidChangeActiveTerminal(X,de,ke){return ot.onDidChangeActiveTerminal(X,de,ke)},onDidChangeTerminalDimensions(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),ot.onDidChangeTerminalDimensions(X,de,ke)},onDidChangeTerminalState(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),ot.onDidChangeTerminalState(X,de,ke)},onDidWriteTerminalData(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),ot.onDidWriteTerminalData(X,de,ke)},get state(){return Ge.state},onDidChangeWindowState(X,de,ke){return Ge.onDidChangeWindowState(X,de,ke)},showInformationMessage(X,...de){return ai.showMessage(Re,A.default.Info,X,de[0],de.slice(1))},showWarningMessage(X,...de){return ai.showMessage(Re,A.default.Warning,X,de[0],de.slice(1))},showErrorMessage(X,...de){return ai.showMessage(Re,A.default.Error,X,de[0],de.slice(1))},showQuickPick(X,de,ke){return xt.showQuickPick(X,!!Re.enableProposedApi,de,ke)},showWorkspaceFolderPick(X){return xt.showWorkspaceFolderPick(X)},showInputBox(X,de){return xt.showInput(X,de)},showOpenDialog(X){return zt.showOpenDialog(X)},showSaveDialog(X){return zt.showSaveDialog(X)},createStatusBarItem(X,de,ke){let rt,wt,Dt;return typeof X=="string"?(rt=X,wt=de,Dt=ke):(wt=X,Dt=de),Mt.createStatusBarEntry(Re,rt,wt,Dt)},setStatusBarMessage(X,de){return Mt.setStatusBarMessage(X,de)},withScmProgress(X){return Se.report("window.withScmProgress",Re,"Use 'withProgress' instead."),hi.withProgress(Re,{location:N.ProgressLocation.SourceControl},(de,ke)=>X({report(rt){}}))},withProgress(X,de){return hi.withProgress(Re,X,de)},createOutputChannel(X){return Ot.createOutputChannel(X,Re)},createWebviewPanel(X,de,ke,rt){return si.createWebviewPanel(Re,X,de,ke,rt)},createWebviewTextEditorInset(X,de,ke,rt){return(0,G.checkProposedApiEnabled)(Re),wi.createWebviewEditorInset(X,de,ke,rt,Re)},createTerminal(X,de,ke){return typeof X=="object"?("location"in X&&(0,G.checkProposedApiEnabled)(Re),"pty"in X?ot.createExtensionTerminal(X):ot.createTerminalFromOptions(X)):ot.createTerminal(X,de,ke)},registerTerminalLinkProvider(X){return ot.registerLinkProvider(X)},registerTerminalProfileProvider(X,de){return ot.registerProfileProvider(Re,X,de)},registerTreeDataProvider(X,de){return Qt.registerTreeDataProvider(X,de,Re)},createTreeView(X,de){return Qt.createTreeView(X,de,Re)},registerWebviewPanelSerializer:(X,de)=>si.registerWebviewPanelSerializer(Re,X,de),registerCustomEditorProvider:(X,de,ke={})=>_i.registerCustomEditorProvider(Re,X,de,ke),registerFileDecorationProvider(X){return mt.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return di.registerUriHandler(Re.identifier,X)},createQuickPick(){return xt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return xt.createInputBox(Re.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(X,de,ke){return fi.onDidChangeActiveColorTheme(X,de,ke)},registerWebviewViewProvider(X,de,ke){return yi.registerWebviewViewProvider(Re,X,de,ke?.webviewOptions)},get activeNotebookEditor(){return(0,G.checkProposedApiEnabled)(Re),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),gt.onDidChangeActiveNotebookEditor(X,de,ke)},get visibleNotebookEditors(){return(0,G.checkProposedApiEnabled)(Re),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,G.checkProposedApiEnabled)(Re),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),Vt.onDidChangeNotebookEditorSelection(X,de,ke)},onDidChangeNotebookEditorVisibleRanges(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),Vt.onDidChangeNotebookEditorVisibleRanges(X,de,ke)},showNotebookDocument(X,de){return(0,G.checkProposedApiEnabled)(Re),gt.showNotebookDocument(X,de)},registerExternalUriOpener(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),Jt.registerExternalUriOpener(Re.identifier,X,de,ke)},get tabs(){return(0,G.checkProposedApiEnabled)(Re),it.tabs},get activeTab(){return(0,G.checkProposedApiEnabled)(Re),it.activeTab},get onDidChangeTabs(){return(0,G.checkProposedApiEnabled)(Re),it.onDidChangeTabs},get onDidChangeActiveTab(){return(0,G.checkProposedApiEnabled)(Re),it.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,G.checkProposedApiEnabled)(Re),f.InlineCompletionController.get(X)}},pi={get rootPath(){return Se.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Be.getPath()},set rootPath(X){throw F.readonly()},getWorkspaceFolder(X){return Be.getWorkspaceFolder(X)},get workspaceFolders(){return Be.getWorkspaceFolders()},get name(){return Be.name},set name(X){throw F.readonly()},get workspaceFile(){return Be.workspaceFile},set workspaceFile(X){throw F.readonly()},updateWorkspaceFolders:(X,de,...ke)=>Be.updateWorkspaceFolders(Re,X,de||0,...ke),onDidChangeWorkspaceFolders:function(X,de,ke){return Be.onDidChangeWorkspace(X,de,ke)},asRelativePath:(X,de)=>Be.getRelativePath(X,de),findFiles:(X,de,ke,rt)=>Be.findFiles(W.GlobPattern.from(X),W.GlobPattern.from(de),ke,Re.identifier,rt),findTextInFiles:(X,de,ke,rt)=>{let wt,Dt;return typeof de=="object"?(wt=de,Dt=ke):(wt={},Dt=de,rt=ke),Be.findTextInFiles(X,wt||{},Dt,Re.identifier,rt)},saveAll:X=>Be.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,de,ke,rt)=>Nt.createFileSystemWatcher(W.GlobPattern.from(X),de,ke,rt),get textDocuments(){return kt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw F.readonly()},openTextDocument(X){let de;const ke=X;if(typeof X=="string")de=Promise.resolve(R.URI.file(X));else if(R.URI.isUri(X))de=Promise.resolve(X);else if(!ke||typeof ke=="object")de=kt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>kt.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(X,de,ke)=>kt.onDidAddDocument(X,de,ke),onDidCloseTextDocument:(X,de,ke)=>kt.onDidRemoveDocument(X,de,ke),onDidChangeTextDocument:(X,de,ke)=>kt.onDidChangeDocument(X,de,ke),onDidSaveTextDocument:(X,de,ke)=>kt.onDidSaveDocument(X,de,ke),onWillSaveTextDocument:(X,de,ke)=>Zt.getOnWillSaveTextDocumentEvent(Re)(X,de,ke),get notebookDocuments(){return gt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,de){let ke;if(R.URI.isUri(X))ke=X,await gt.openNotebookDocument(X);else if(typeof X=="string")ke=R.URI.revive(await gt.createNotebookDocument({viewType:X,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(X,de,ke,rt){return gt.registerNotebookSerializer(Re,X,de,ke,Re.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(X,de,ke,rt)=>((0,G.checkProposedApiEnabled)(Re),gt.registerNotebookContentProvider(Re,X,de,ke,Re.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(X,de,ke)=>Gt.onDidChangeConfiguration(X,de,ke),getConfiguration(X,de){return de=arguments.length===1?void 0:de,Gt.getConfiguration(X,de,Re)},registerTextDocumentContentProvider(X,de){return $t.registerTextDocumentContentProvider(X,de)},registerTaskProvider:(X,de)=>(Se.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Re,X,de)),registerFileSystemProvider(X,de,ke){return ii.registerFileSystemProvider(Re.identifier,X,de,ke)},get fs(){return me.value},registerFileSearchProvider:(X,de)=>((0,G.checkProposedApiEnabled)(Re),Rt.registerFileSearchProvider(X,de)),registerTextSearchProvider:(X,de)=>((0,G.checkProposedApiEnabled)(Re),Rt.registerTextSearchProvider(X,de)),registerRemoteAuthorityResolver:(X,de)=>((0,G.checkProposedApiEnabled)(Re),Ie.registerRemoteAuthorityResolver(X,de)),registerResourceLabelFormatter:X=>((0,G.checkProposedApiEnabled)(Re),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,de,ke)=>Nt.onDidCreateFile(X,de,ke),onDidDeleteFiles:(X,de,ke)=>Nt.onDidDeleteFile(X,de,ke),onDidRenameFiles:(X,de,ke)=>Nt.onDidRenameFile(X,de,ke),onWillCreateFiles:(X,de,ke)=>Nt.getOnWillCreateFileEvent(Re)(X,de,ke),onWillDeleteFiles:(X,de,ke)=>Nt.getOnWillDeleteFileEvent(Re)(X,de,ke),onWillRenameFiles:(X,de,ke)=>Nt.getOnWillRenameFileEvent(Re)(X,de,ke),openTunnel:X=>((0,G.checkProposedApiEnabled)(Re),Ce.openTunnel(Re,X).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,G.checkProposedApiEnabled)(Re),Ce.getTunnels()},onDidChangeTunnels:(X,de,ke)=>((0,G.checkProposedApiEnabled)(Re),Ce.onDidChangeTunnels(X,de,ke)),registerPortAttributesProvider:(X,de)=>((0,G.checkProposedApiEnabled)(Re),Ce.registerPortsAttributesProvider(X,de)),registerTimelineProvider:(X,de)=>((0,G.checkProposedApiEnabled)(Re),ri.registerTimelineProvider(X,de,Re.identifier,nt.converter)),get isTrusted(){return Be.trusted},requestWorkspaceTrust:X=>((0,G.checkProposedApiEnabled)(Re),Be.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,de,ke)=>Be.onDidGrantWorkspaceTrust(X,de,ke)},Ti={get inputBox(){return Se.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Re)},createSourceControl(X,de,ke){return Yt.createSourceControl(Re,X,de,ke)}},Ri={createCommentController(X,de){return bi.createCommentController(Re,X,de)}},Fi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(X,de,ke){return lt.onDidStartDebugSession(X,de,ke)},onDidTerminateDebugSession(X,de,ke){return lt.onDidTerminateDebugSession(X,de,ke)},onDidChangeActiveDebugSession(X,de,ke){return lt.onDidChangeActiveDebugSession(X,de,ke)},onDidReceiveDebugSessionCustomEvent(X,de,ke){return lt.onDidReceiveDebugSessionCustomEvent(X,de,ke)},onDidChangeBreakpoints(X,de,ke){return lt.onDidChangeBreakpoints(X,de,ke)},registerDebugConfigurationProvider(X,de,ke){return lt.registerDebugConfigurationProvider(X,de,ke||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,de){return lt.registerDebugAdapterDescriptorFactory(Re,X,de)},registerDebugAdapterTrackerFactory(X,de){return lt.registerDebugAdapterTrackerFactory(X,de)},startDebugging(X,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?lt.startDebugging(X,de,{parentSession:ke}):lt.startDebugging(X,de,ke||{})},stopDebugging(X){return lt.stopDebugging(X)},addBreakpoints(X){return lt.addBreakpoints(X)},removeBreakpoints(X){return lt.removeBreakpoints(X)},asDebugSourceUri(X,de){return lt.asDebugSourceUri(X,de)}},Mi={registerTaskProvider:(X,de)=>_t.registerTaskProvider(Re,X,de),fetchTasks:X=>_t.fetchTasks(X),executeTask:X=>_t.executeTask(Re,X),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(X,de,ke)=>_t.onDidStartTask(X,de,ke),onDidEndTask:(X,de,ke)=>_t.onDidEndTask(X,de,ke),onDidStartTaskProcess:(X,de,ke)=>_t.onDidStartTaskProcess(X,de,ke),onDidEndTaskProcess:(X,de,ke)=>_t.onDidEndTaskProcess(X,de,ke)},Li={createNotebookController(X,de,ke,rt,wt){return ei.createNotebookController(Re,X,de,ke,rt,Re.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(X,de)=>gt.registerNotebookCellStatusBarItemProvider(Re,X,de),get onDidSaveNotebookDocument(){return(0,G.checkProposedApiEnabled)(Re),Kt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,G.checkProposedApiEnabled)(Re),Vt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ti.createRendererMessaging(Re,X)},onDidChangeNotebookDocumentMetadata(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),Kt.onDidChangeNotebookDocumentMetadata(X,de,ke)},onDidChangeNotebookCells(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCells(X,de,ke)},onDidChangeNotebookCellExecutionState(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCellExecutionState(X,de,ke)},onDidChangeCellOutputs(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),gt.onDidChangeCellOutputs(X,de,ke)},onDidChangeCellMetadata(X,de,ke){return(0,G.checkProposedApiEnabled)(Re),gt.onDidChangeCellMetadata(X,de,ke)},createConcatTextDocument(X,de){return(0,G.checkProposedApiEnabled)(Re),new $e.ExtHostNotebookConcatDocument(gt,kt,X,de)}};return{version:ue.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:li,notebooks:Li,scm:Ti,tasks:Mi,tests:Ii,window:Ai,workspace:pi,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:_.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:P.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:n.UIKind,Uri:R.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:bt.TextSearchCompleteMessageType,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(we[223],be([0,1,57,96,31,95,32,48,49,38,99,100,101,72,64,70,97,71,37,69,87,68]),function(ie,e,c,F,_,A,R,I,S,P,t,y,n,h,s,d,v,C,w,a,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService),(0,c.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,c.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,c.registerSingleton)(C.IExtHostConsumerFileSystem,C.ExtHostConsumerFileSystem),(0,c.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,c.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,c.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,c.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,c.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,c.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,c.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,c.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,c.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,c.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,c.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,c.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,c.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,c.registerSingleton)(k.IExtHostEditorTabs,k.ExtHostEditorTabs)}),define(we[224],be([0,1,222,33,218,7,14,5,11]),function(ie,e,c,F,_,A,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(s){const d=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(C,...w)=>{w.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const a=w.slice(0,-1).join(","),p=w.pop().toString();return`(function anonymous(${a}) {
${p}
})`}});function v(...C){return d?self.eval(d.createScript("",...C)):new Function(...C)}s.create=v})(P||(P={}));class t extends _.RequireInterceptor{_installInterceptor(){}getModule(d,v){for(let C of this._alternatives){let w=C(d);if(w){d=w;break}}if(this._factories.has(d))return this._factories.get(d).load(d,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class y extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const d=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);h(d,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(c.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(d){return d.browser}async _loadCommonJSModule(d,v,C){v=v.with({path:n(v.path,".js")}),d&&performance.mark(`code/extHost/willFetchExtensionCode/${d.value}`);const w=await fetch(S.FileAccess.asBrowserUri(v).toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d.value}`),w.status!==200)throw new Error(w.statusText);const a=await w.text(),p=`${v.toString(!0)}#vscode-extension`,k=`${a}
//# sourceURL=${p}`;let i;try{i=P.create(y._ttpExtensionScripts?.createScript("module")??"module",y._ttpExtensionScripts?.createScript("exports")??"exports",y._ttpExtensionScripts?.createScript("require")??"require",y._ttpExtensionScripts?.createScript(k)??k)}catch(b){throw console.error(d?`Loading code for extension ${d.value} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${v.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}const l={},r={exports:l},o=b=>{const f=this._fakeModules.getModule(b,v);if(f===void 0)throw new Error(`Cannot load module '${b}'`);return f};try{return C.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d.value}`),i(r,l,o),r.exports!==l?r.exports:l}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d.value}`),C.codeLoadingStop()}}async $setRemoteEnvironment(d){}async _waitForDebuggerAttachment(d=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+d;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=y,y._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:s=>s});function n(s,d){return s.endsWith(d)?s:s+d}function h(s,d){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(a,p){const k=console[a];console[a]=function(){s.$logExtensionHostMessage({type:"__$console",severity:p,arguments:w(arguments)}),d&&k.apply(console,arguments)}}const C=1e5;function w(a){const p=[],k=[];if(a.length)for(let i=0;i<a.length;i++){if(typeof a[i]=="undefined")a[i]="undefined";else if(a[i]instanceof Error){const l=a[i];l.stack?a[i]=l.stack:a[i]=l.toString()}k.push(a[i])}try{const i=JSON.stringify(k,function(l,r){if(r&&typeof r=="object"){if(p.indexOf(r)!==-1)return"[Circular]";p.push(r)}return r});return i.length>C?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(we[225],be([0,1,57,15,33,73,224,211]),function(ie,e,c,F,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(_.IExtHostExtensionService,R.ExtHostExtensionService),(0,c.registerSingleton)(F.ILogService,I.ExtHostLogService),(0,c.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(we[235],be([0,1,23,3,177,219,213,17,74,11,2,223,225]),function(ie,e,c,F,_,A,R,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const h=fetch.bind(self);if(self.fetch=function(a,p){return a instanceof Request||/^file:/i.test(String(a))&&(a=P.FileAccess.asBrowserUri(t.URI.parse(String(a))).toString(!0)),h(a,p)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,p,k,i,l){return/^file:/i.test(p.toString())&&(p=P.FileAccess.asBrowserUri(t.URI.parse(p.toString())).toString(!0)),super.open(a,p,k??!0,i,l)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const a=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:k=>k}),p=self.Worker;Worker=function(k,i){/^file:/i.test(k.toString())&&(k=P.FileAccess.asBrowserUri(t.URI.parse(k.toString())).toString(!0));const l=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${k}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;i=i||{},i.name=i.name||I.basename(k.toString());const r=new Blob([l],{type:"application/javascript"}),o=URL.createObjectURL(r);return new p(a?a.createScriptURL(o):o,i)}}else self.Worker=class extends R.NestedWorker{constructor(a,p){super(n,a,{name:I.basename(a.toString()),...p})}};const s=new class{exit(a){y()}async exists(a){return!0}async realpath(a){return a}};class d{constructor(){const p=new MessageChannel,k=new F.Emitter;let i=!1;n(p.port2,[p.port2]),p.port1.onmessage=l=>{const{data:r}=l;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const o=c.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,_.isMessageOfType)(o,2)){i=!0,C("received terminate message from renderer");return}k.fire(o)},this.protocol={onMessage:k.event,send:l=>{if(!i){const r=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);p.port1.postMessage(r,[r])}}}}}function v(a){return new Promise(p=>{const k=a.onMessage(i=>{k.dispose();const l=JSON.parse(i.toString());a.send((0,_.createMessageOfType)(0)),p({protocol:a,initData:l})});a.send((0,_.createMessageOfType)(1))})}let C=a=>y();function w(){const a=new d;S.mark("code/extHost/willConnectToRenderer"),v(a.protocol).then(p=>{S.mark("code/extHost/didWaitForInitData");const k=new A.ExtensionHostMain(p.protocol,p.initData,s,null);C=i=>k.terminate(i)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/87260247dc7b912db6e6a21a366e6f50dca759ba/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
